# Annode

The world's first P2P neuromorphic hypergraph data currency using 1schema (a master data protocol) on layer 1.
A global incentivized OSINT knowledge graph built and inspired from data structures used in the field of AGI.

ANNE has been in development since 2006.  Through various iterations (not called ANNE) the essence of ANNE emerged as limited aspects were battle tested in real-world use cases in private and local settings.  With blockchain technology available the potential to pull off ANNE at scale became possible via decentralization with incentives. With these pieces added the vision of ANNE, at-scale, was a realistic potential.

ANNE is not a registered corp or org under any government polity nor connected to or run by one.  ANNE is a project that will remain *actually* decentralized by utilizing the neuromorphic hypergraph's data modelling abilities with Annodes as mini-web servers.  While many projects boast of decentralization their mining pools centralize mining and their data-access for downstream apps often require building traditional L2s (utilizing traditional tech stacks) that create access-choke-points and threats of access centralization.  ANNE does not fall victim to these pitfalls.

Annodes can be queried directly for 1schema structured hypergraph data to power downstream use-cases without a middle-layer.  Any data model can be represented using 1schema thus no data protocol changes are ever needed.  Every class neuron is a potential "protocol".  Neurons inherit parameters and attributes from their parents in the BE DIMENSION.  No new tables are needed to support custom data models.  ANNE is built to change by using ANNE.  Using 1Schema creates new data protocols within the ANNE hypergraph.  Feedback loops are closed and create edges in the hypergraph that look just like the data they are feeding back on.  Powerful results are instantly available without data prep or data labelling as all data in ANNE is conceptualized and ready for use in the same hypergraph.

The two supported database backends are:

- MariaDB: for Main Net and Production Environments
- H2 embedded file database, which should only be used for local and/or test net nodes.

Future plans to build a native linux-OS powered by ANNE data with built-in annode used for advanced AI/AGI use cases will be tackled once ANNE is released.  This will require no protocol changes.

## Thanks
Deep thanks to SIGNUM NETWORK (originally called "Burst") and their open-source code which was the starting point for account-based blockchain functionality.   If SIGNA was a sports car it was stripped down to a battle-tested p2p "blockchain" chassis.  They have great use cases for many unique and powerful features and that technology is available by using SIGNA.  ANNE is focused on ANNE.  With the blockchain acount-based chassis in place; ANNE's neurmorphic hypergrpah  at L1 creates a p2p L1 data currency with a focus on data as a primary thought. Payments in ANNE can be thought of as electro-chemical actions between neurons that fire.  The focus of ANNE is data.  Heavy changes to mining were also done to capture the game-theory behavior that is suitable for the ecosystem and long-term outlook ANNE is aiming to accomplish.

## Network Features

- Neuromorphic hypergraph enforced at L1
- Transactions create relons (edges) in the neuromorphic hypergraph.
- All relons conform to 1schema as semantic indexed triplets using "from", "reln" and "to" in multiple data dimensions.
- Relons can be used to create quick shorthand conceptual edges or to individually supply semantic roles of a neuron used in deeper modelling of more complex language expression. For the sake of communication, "words" will be used here, but in fact, these would all be indexed neuronIDs that reference each the respective neurons for the parts of the relon.

basic relon pattern: FROM->RELN->TO

mrscatman->appreciates->tumeric

or

clumpX-> ROLE_WHO-> mrscatman  
clumpX-> ROLE_ACTION-> released  
clumpX-> ROLE_THEME-> ANNE 
clumpX-> ROLE_WHEN-> 01/23/2023

- All data in ANNE is edge based.  There is no data "in" a neuron.  Meaning is captured and held via the connections between neurons.  While we can say the neuron for "ANNE" is neuron 7777770163980908667, we know this not because of what is "in" that neuron.  There is no data "in" that neuron.  ANNE hypergraph memory operates similar to an interference pattern.  The circuit that is wired from outbound relationships in a particular dimension are what "define" a neuron.   Inbound relationships are informative too.  The data is in the relationships, not the neurons.  This can't be overstated enough.
- To get data in a brain we fire neurons.  What fires together wires together.  To create relons (transactions) you reference existing neurons and relons.
- Queryable annodes for conceptual data ready-to-use in use-case apps with support for AI/AGI processes.
- Every neuron is a data resource.  Every neuron is a potential data oracle.  Every neuron is a potential revenue stream.
- Muliple baked-in annie streams to incentivize.
- HDD mining - ASIC proof / Energy efficient and sustainable mining
- Non-inflationary.   Mining reward and dev fund to sustain development via L1 bounties without VC.
- No ICO/Airdrops/Premine


## Network Specification

- Block time is 2 minutes 
- Max Block size is 375,360 byte (?)
- Minimum transaction size is 184 bytes
- Transactions include mining fee and transaction-specific neuron firing fees paid to owners and sponsors of neurons.
- TPS is 16 (?)
- STPS is up to 5,000 (?)
- Maximum 1,200,000 balance changes per block (?)

## Data Currency

- Maximum Supply: [2,200,000,000,000]
- Lowest unit of measure: ANNIES.  There are 2 decimal plaes in ANNIES.
- Block reward starts at [1,000,000] ANNIES per block.
- Block reward decreased at 1% each lunar cycle (~29.5 days or 21,240 blocks)
- By the end of lunar cycle 73 approximately 50% of the ANNIES will be in circulation. 
- Block reward stablizes at [18,000] ANNIES at cycle 398 until it ends at cycle 691 (~55yrs)
This period of time will allow ample time for the network to adjust and replace the block reward with block mining fees.
- Mining fees are 1 ANNIE per tx for standard ANNE relons utilizing neuron references for from, reln, to.  If a non-ANNE neuron is used
in the TO for referencing a string, blob, url, ipv4/6 addr or any of the non-ANNE TO_TYPES, the mining fee can go up to a max of 4 ANNIES.
- Block reward is split between Miner and the ANNE Dev Fund (ADF).
- Mining reward % increases each cycle starting at 70% of the Block Reward.  (700k ANNIES on block 1)
- Mining reward % caps out at 86.3% on cycle 154 and stays there until the block reward ends.
- ADF reward % decreases each cycle starting at 30% of the block reward.
- ADF reward % bottoms out at 13.7% on cycle 154 and stays there until the block reward ends.

*ANNE DEV FUND coins are earmarked for marketing partnerships, community bounties for code/business development, community projects, founders, and for other external incentives and rewards.  They are to be used as resources.  There use is at the sole discretion of the ANNE DEV FUND with the stated intent of growing the network sans the need for VC, corps, or other external influences that can threaten decentralization or the future success of the project.


## MINING GAME-THEORY

- Pool miners can win any block not ending in 1 or 6.  
- Pool miners are handicapped on "solo blocks" so that they cannot win the block. (unless there are no solo miners mining)
- Solo miners can win any block but are anticipated to be unable to compete with pools.
- All miners are handicapped from winning "more than" 5 of any of the last 10 blocks.
- No new block can be mined before 30 seconds from the first valid submission of the previous block.
This provides a 30 second window for any miner to propogate a better solution than the current best solution accepted by the network.
- There is a MAXIMUM ROLLBACK of 1 block.  If a valid block solution is submitted within 30 seconds of the first
valid block submission for that height, the network will rollback 1 block and accept the better solution.


## Addendum

ANNE's base blockchain functions are account-based and built from SIGNA's code base.  It was stripped down and used with most payment features removed.  ANNE does not compete with SIGNA and recommends SIGNA for crypto p2p payment enabling smart contracts, escrow services, multi-out payments, subscriptions, NFTs and more.   ANNE is a data currency and focuses
on building a neuromorphic incentivized hypergraph.  What Bitcoin and cryptos do for payments, ANNE does for data.

Since SIGNA base code is used for the base blockchain features ANNE inherited:

- Decentralized Peer-to-Peer network with spam protection
- Built in Java - runs anywhere, from a Raspberry Pi to a Phone
- Fast sync with multithreaded CPU or, optionally, an OpenCL GPU
- HTTP API for clients to interact with network

# Installation

## Prerequisites

### Windows

Any recent 64 bit Windows should suffice (a Java 11 is embedded in the windows package).

### Linux and Mac, Java 64-bit 11 (Recommended) or higher

You need Java 64-bit 11 (recommended) or higher installed.
Install the `openjdk-11-jre` package or similar for your distribution.
To check your java version, run `java -version`. You should get an output similar to the following:

```text
openjdk version "11.0.13" 2021-10-19
OpenJDK Runtime Environment (build 11.0.13+8-Ubuntu-0ubuntu1.20.04)
OpenJDK 64-Bit Server VM (build 11.0.13+8-Ubuntu-0ubuntu1.20.04, mixed mode, sharing)
```

The important part is that the Java version starts with `11.` (Java 11)

### MariaDB (Recommended)

[Download and install MariaDB](https://mariadb.com/downloads/mariadb-tx)

The MariaDb installation will ask to setup a password for the root user.
This password can be anything you like. 

Modify these settings in the `node-default.properties` file in the node directory after installing the Signum node:

**TIP: _remove # from first character of each line so it looks like the below_**
```properties
 DB.Url=jdbc:mariadb://localhost:3306/annedb
 DB.Username=anne_user
 DB.Password=pass
```
**Windows Setup**

after you install MariaDB and use a root passowrd of your choice, go to the windows icon and find the "MariaDB XX.XX" folder and within that open the "MySQL Client" option. You should see a command prompt asking for your root password, type the password you created when installing maria and hit enter. You should now see something like MariaDB [(none)]>  if so copy the below including the blank lines and paste it into that command prompt window.  

**TIP: _use the copy icon in github when you mouse over the text, then use the RIGHT mouse button and click in the command prompt window to paste_**
```
create database if not exists annedb;
create user if not exists 'anne_user'@'localhost' identified by 'pass';
grant all privileges on annedb.* to 'anne_user'@'localhost';
flush privileges;

```
You should see 4 "Query OK" responses after pasting, maria is now setup!   If you have already updated your node-default.properties file as shown above you should be able to start your node and begin to syncronize it to the network.


## Set Up

Grab the latest [release](https://github.com/signum-network/signum-node/releases) (or, if you prefer, compile yourself using the instructions below)

In the `conf` directory, copy `node-default.properties` into a new file named `node.properties` and modify this file to suit your needs (See "Configuration" section below)

To run the node, double click on `anne-node.exe` (if on Windows) or run `java -jar anne-node.jar`.
On most systems this will show you a monitoring window and will create a tray icon to show that the Annode is running. To disable this, instead run `java -jar anne-node.jar --headless`.

## Configuration

### Running on mainnet

All default/recommended parameters are defined in code by the Annode but you can overwrite the parameter within the config file to suit your needs.
The default values for the available settings are shown in the `conf/node-default.properties` file as commented out. 

### Configuration Hints

**H2/MariaDB**

By default Signum Node is using H2 (file based) as database. 
If you like to use MariaDB you will need to adjust your `conf/node.properties`:

```properties
#### DATABASE ####
DB.Url=jdbc:mariadb://localhost:3306/annedb
DB.Username=
DB.Password=
```

Please modify the `DB.Url` to your own specifications (port 3306 is the standard port from MariaDB) and also set the `DB.Username` and `DB.Password` according your setup for the created database.

**UPnP-Portforwarding**

By default the UPnP port forwarding is activated. 
If you run the node on a VPS you can deactivate this by setting it to "no".
```properties
## Port for incoming peer to peer networking requests, if enabled.
# P2P.Port = 9115
## Use UPnP-Portforwarding
P2P.UPnP = no
```

## Hardware Requirements

The Annode is not hardware demanding nor it needs a fast internet connection.
The specifications for the hardware is as follows:

-   Minimum : 1 vCPU, 1 GB RAM, 20 GB HD,  Minimum Swapfile 2GB (Linux)
-   Recommended : 2 vCPU, 2 GB RAM, 20 GB HD, Minimum Swapfile 4GB (Linux)

**Tuning options**
//list some annode configs here


# API Documentation

API documentation is provided on every Annode.

You can access it via `<host>:8125/api-doc` (or `<host>:6876/api-doc` for Testnet respectively).

# Developers

Main Developer: [mrscatman](https://github.com/mrscatman). 
Key guidance in legacy code base from SIGNA's main Developer: [jjos2372](https://github.com/jjos2372).  Thanks also to Frank-the-Tank for the various engagements and arrangements.

# Appendix
