import * as THREE from './js/3rdparty/threejs/build/three.module.js';
//import { GUI } from './js/other/dat.gui.module.js';
import { CSS3DRenderer }  from './js/3rdparty/threejs/examples/jsm/renderers/CSS3DRenderer.js';
import {CSS3DObject } from './js/3rdparty/threejs/examples/jsm/renderers/CSS3DRenderer.js';
import CameraControls from './js/other/camera-controls.module.js';
CameraControls.install( { THREE: THREE } );

var DOSINT = {}

ANNE.DOSINT = DOSINT;

DOSINT._DIG = null;

DOSINT.animationID = null;

DOSINT._lookatLbls = [];

DOSINT.white_material = null;
DOSINT.white_material_low_alpha = null;
DOSINT.green_material = null;
DOSINT.yellow_material = null;
DOSINT.yellow_material_low_alpha = null;

DOSINT.tick = 0;
DOSINT.tick_block = 0;  //attempt to auto-correct flag error from unkown gui happenings that interupted tweens (and flag settings)

DOSINT.vol = 32*255/2;

//holds the materials for pos/neg/neu (to resuse)
DOSINT.awarez_mats = null;

DOSINT.bMLOOKOK = true;

DOSINT.b3JSACTIVE = true;
DOSINT.bTRAVELLING = false;
DOSINT.bONETIME = false;

DOSINT.color_array_by_base = [];
DOSINT.color_array_by_base [0x00ff00] = [0x00ffff, 0x00ff44, 0x00ff99, 0x00ffcc, 0x33ff33];
DOSINT.color_array_by_base [0xff0000] = [0x00ffff, 0xff0011, 0xff0022, 0xff1133, 0xfefe00];
DOSINT.color_array_by_base [0xfefe17] = [0x00ffff, 0xeeeeee, 0xeefe17, 0xffff55, 0xfefefe];

DOSINT.cameraHomePosition = new THREE.Vector3();
DOSINT.cameraHomeRotation = new THREE.Vector3();
DOSINT.cameraHomeZoom = .5;

DOSINT.getPosMat = function() { return DOSINT.awarez_mats[9];}
DOSINT.getNegMat = function() { return DOSINT.awarez_mats[10];}
DOSINT.getNeuMat = function() { return DOSINT.awarez_mats[11];}

DOSINT.activateOrbit = function($target) {
    DOSINT.controls = new CameraControls( DOSINT.camera, DOSINT.rendererCSS.domElement );
    DOSINT.controls.maxPolarAngle = 1.5088724652651286;
    DOSINT.controls.minPolarAngle = 0;
    DOSINT.controls.setTarget( $target.x, $target.y, $target.z );
    DOSINT.controls.minDistance = 100;
    DOSINT.controls.maxDistance = 5000;
    DOSINT.controls.minZoom = .3;
    DOSINT.controls.maxZoom = 4.8;
    DOSINT.controls.zoomTo(1.4, false);
    DOSINT.controls.mouseButtons.wheel = CameraControls.ACTION.ZOOM;
    DOSINT.controls.mouseButtons.right = CameraControls.ACTION.TRUCK;
}

DOSINT.preload = function() {
    window.THREE = THREE;
    DOSINT.colors = [0x00ff00, 0xff0000, 0xfefe17];

    DOSINT.awarez_mats = [
        new THREE.MeshBasicMaterial({ color: 0x00ff00, wireframe:true, transparent:true, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, wireframe:true, transparent:true, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true, transparent:true, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0x00ff00, wireframe:true, transparent:true, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, wireframe:true, transparent:true, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true, transparent:true, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0x00ff00, transparent:true, side: THREE.DoubleSide, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, transparent:true, side: THREE.DoubleSide, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, transparent:true, side: THREE.DoubleSide, opacity:.2 }),
        new THREE.MeshBasicMaterial({ color: 0x00ff00, transparent:true, side: THREE.DoubleSide, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xff0000, transparent:true, side: THREE.DoubleSide, opacity:1 }),
        new THREE.MeshBasicMaterial({ color: 0xfefe17, transparent:true, side: THREE.DoubleSide, opacity:1 }),
    ];


    var skyboxGeo = new THREE.BoxGeometry(30000, 30000, 30000);
    const ft = new THREE.TextureLoader().load("./imgs/skybox/redeclipse_ft.png");
    const ft_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: ft, side: THREE.DoubleSide });
    const bk = new THREE.TextureLoader().load("./imgs/skybox/redeclipse_bk.png");
    const bk_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: bk, side: THREE.DoubleSide });
    const up = new THREE.TextureLoader().load("./imgs/skybox/redeclipse_up.png");
    const up_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: up, side: THREE.DoubleSide });
    const downz = new THREE.TextureLoader().load("./imgs/skybox/redeclipse_dn.png");
    const dn_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: downz, side: THREE.DoubleSide });
    const rt = new THREE.TextureLoader().load("./imgs/skybox/redeclipse_rt.png");
    const rt_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: rt, side: THREE.DoubleSide });
    const lf = new THREE.TextureLoader().load("./imgs/skybox/redeclipse_lf.png");
    const lf_mesh = new THREE.MeshBasicMaterial({opacity:.5, map: lf, side: THREE.DoubleSide });
    DOSINT.skyboxMesh = new THREE.Mesh(skyboxGeo, [
        ft_mesh, bk_mesh, up_mesh, dn_mesh, rt_mesh, lf_mesh  
    ]);
}



/**
 * 
 */
DOSINT.init = function($cb=null) {
    //var gui = new GUI({ autoPlace: false, closeOnTop:true, useLocalStorage:true });
    //var container = document.getElementById('dat_gui_container');
    //container.appendChild(gui.domElement);
    //DOSINT.settings = gui.addFolder ('settings');
    //DOSINT.settings.open();
    //var el_close = container.querySelector(".close-button");
    //el_close.addEventListener("click", e=>{
        //gui.open();
        //ANNE.A.hide("dat_gui_container");
    //});
    
    ANNE.CSS3DObject = CSS3DObject;

    var container = document.getElementById( 'container' );
    DOSINT.renderer = new THREE.WebGLRenderer({antialias: true});
    DOSINT.renderer.setPixelRatio( window.devicePixelRatio );
    DOSINT.renderer.setSize( window.innerWidth, window.innerHeight );
    DOSINT.renderer.setClearColor(0x000000); // Set a dark color (black)
    DOSINT.renderer.gammaOutput = true;
    DOSINT.renderer.gammaFactor = 2.2;
    DOSINT.renderer.toneMapping = THREE.ACESFilmicToneMapping;
	DOSINT.renderer.toneMappingExposure = 0.8;  //causes darker tone .. darkness..
    container.appendChild( DOSINT.renderer.domElement );

    DOSINT.scene = new THREE.Scene();
    DOSINT.scene.add(DOSINT.skyboxMesh);

    const ambientLight = new THREE.AmbientLight(0x202020, 0.5); // Color, Intensity
    DOSINT.scene.add(ambientLight);

    var csscontainer = document.getElementById( 'csscontainer' );
    DOSINT.rendererCSS = new CSS3DRenderer();
    //DOSINT.renderer.setPixelRatio( window.devicePixelRatio );
    DOSINT.rendererCSS.setSize( window.innerWidth, window.innerHeight );
    DOSINT.rendererCSS.domElement.style.position = 'absolute';
    DOSINT.rendererCSS.domElement.style.top = 0;
    csscontainer.appendChild( DOSINT.rendererCSS.domElement );
    
    DOSINT.white_material = new THREE.MeshBasicMaterial({ color: 0xffffff, wireframe:true });
    DOSINT.white_material_low_alpha = new THREE.MeshBasicMaterial({ color: 0xffffff, wireframe:true, transparent:true, opacity:.2 });
    DOSINT.yellow_material = new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true });
    DOSINT.yellow_material_low_alpha =  new THREE.MeshBasicMaterial({ color: 0xfefe17, wireframe:true, transparent:true, opacity:.2 });
    DOSINT.green_material = new THREE.MeshBasicMaterial({ color: 0x00ff00, wireframe:true });

    // Set up the camera
    DOSINT.camera = new THREE.PerspectiveCamera(55, window.innerWidth / window.innerHeight, 0.1, 30000);
    DOSINT.camera.zoom=1;
    DOSINT.camera.position.z = 1270;

    DOSINT.cameraHomePosition.copy(DOSINT.camera.position);
    DOSINT.cameraHomeRotation.copy(DOSINT.camera.rotation);
    DOSINT.cameraHomeZoom = DOSINT.camera.zoom;
    
    DOSINT.savedRotation = new THREE.Vector3();
    DOSINT.savedPosition = new THREE.Vector3();
    DOSINT.saveZoom = DOSINT.camera.zoom;
    DOSINT.savedExposure = 1;

    DOSINT.mouseLock = false;
    DOSINT.raycaster = new THREE.Raycaster();
    DOSINT.pointer = new THREE.Vector2();
    DOSINT.mouse = new THREE.Vector2();

    DOSINT._entryTileMeshes = [];

    window.addEventListener( 'resize', e=>{
            DOSINT.camera.aspect = window.innerWidth / window.innerHeight;
            DOSINT.camera.updateProjectionMatrix();
            DOSINT.renderer.setSize( window.innerWidth, window.innerHeight );
            DOSINT.rendererCSS.setSize( window.innerWidth, window.innerHeight );
        }, false );


    window.addEventListener('wheel', $e=>{
        if (DOSINT.b3JSACTIVE==false) return;
        const zoomSpeed = 0.01; 
        const minZoom = .3; 
        const maxZoom = 2.8; 
        const zoomLevel = DOSINT.camera.zoom + ($e.deltaY/10 * -zoomSpeed);
        DOSINT.camera.zoom = Math.max(minZoom, Math.min(maxZoom, zoomLevel));
        DOSINT.camera.updateProjectionMatrix();
    });


    //for mouse over obj events...
    window.addEventListener( 'pointermove', $e=> {

        DOSINT.pointer.x = ( $e.clientX / window.innerWidth ) * 2 - 1;
        DOSINT.pointer.y = - ( $e.clientY / window.innerHeight ) * 2 + 1;
        
        DOSINT.mouse.x = $e.clientX;
        DOSINT.mouse.y = $e.clientY;

        if (DOSINT.bTRAVELLING==true || DOSINT.b3JSACTIVE==false) return;

        //pointer move for mouse look here.
        if (DOSINT.bMLOOKOK==true && DOSINT.mouseLock==true) {
            const movementX = $e.movementX || $e.mozMovementX || $e.webkitMovementX || 0;
            const movementY = $e.movementY || $e.mozMovementY || $e.webkitMovementY || 0;
            DOSINT.camera.rotation.y -= movementX * 0.004;
            DOSINT.camera.rotation.x -= movementY * 0.002;
        }

        //hoverables for lastARING.
        //we could move this handling into the ring..but i dont wan't to.
        if (DOSINT._lastARING!=null && DOSINT._lastARING._hoverableSections.length>0) {

            DOSINT.raycaster.setFromCamera( DOSINT.pointer, DOSINT.camera );
    
            //if mouse is over a hoverable object, change the cursor
            const intersects = DOSINT.raycaster.intersectObjects( DOSINT._lastARING._hoverableSections );
            if (intersects.length>0) {
                //document.body.style.cursor = 'grab';
                var hovObj = intersects[0].object;
    
                if (hovObj.ATYPE==AWAREZ_RINGASBAR) {
                    DOSINT.tick_block=0;
                    hovObj.awarezRing.handleRingAsBarHover(hovObj);
                }
                else if (hovObj.ATYPE==AWAREZ_BUCKET) {
                    hovObj.parent.parent.awarezRing.handleBucketHover(hovObj);
                }
            }
        }
    });


    /**
     * 
     */
    document.addEventListener("mousedown", async $e=>{
        if ($e.button === 2) return; //right click
        if (DOSINT.bTRAVELLING==true || DOSINT.b3JSACTIVE==false) return;

        if (DOSINT._lastARING!=null && DOSINT._lastARING.bDOINGARINGTUNNEL==true) return;

        if ($e.target.parentElement!=undefined) {
            if ($e.target.parentElement.getAttribute("overlay")!=undefined) {
                console.log("skipping event from overlay")
                return;
            }
            if ($e.target.parentElement.parentElement!=undefined 
                && $e.target.parentElement.parentElement.getAttribute("overlay")!=undefined) {
                console.log("skipping event from overlay")
                return;
            }
        }

        if (DOSINT.bMLOOKOK==false) {
            if (DOSINT._lastARING!=null) {
                DOSINT.pointer.x = ( $e.clientX / window.innerWidth ) * 2 - 1;
                DOSINT.pointer.y = - ( $e.clientY / window.innerHeight ) * 2 + 1;
                DOSINT.raycaster.setFromCamera( DOSINT.pointer, DOSINT.camera );
                const intersects = DOSINT.raycaster.intersectObjects( DOSINT._lastARING._hoverableSections );
                if (intersects.length>0) {
                    var hovObj = intersects[0].object;
                    if (hovObj.ATYPE==AWAREZ_BUCKET) {
                        hovObj.parent.parent.awarezRing.makeTunnel(hovObj);
                    }
                }

                //click on nothing while lastARing present,
                //go back to home view.
                else {
                }
                return;
            }
            return;
        }

        //if mouselook is ok (note: we do click+mousemove for mouselook), and the user clicked on a non overlay,
        //do the mouselook (and save rotation to tween back when mouse look done)
        else {
            DOSINT.savedRotation.copy(DOSINT.camera.rotation);
            DOSINT.mouseLock=true;
            DOSINT.pointer.x = ( $e.clientX / window.innerWidth ) * 2 - 1;
            DOSINT.pointer.y = - ( $e.clientY / window.innerHeight ) * 2 + 1;
            DOSINT.raycaster.setFromCamera( DOSINT.pointer, DOSINT.camera );
            const intersects = DOSINT.raycaster.intersectObjects( DOSINT._entryTileMeshes );
            if (intersects.length==0) return;
            var clickObj = intersects[0].object;
            if (clickObj.ATYPE==ENTRY_TILE) {
                clickObj.cb(clickObj);
                //DOSINT.goThroughTile(hovObj);
            }
        }
    });


    /**
     * Must be in mouselock for this to work.
     * Otherwise it will throw us WAY off!  :)
     */
    document.addEventListener("mouseup", $e=>{
        if (DOSINT.bTRAVELLING==true || DOSINT.b3JSACTIVE==false) return;
        
        if (DOSINT._lastARING!=null && DOSINT._lastARING.bDOINGARINGTUNNEL==true) return;
        if (DOSINT.bMLOOKOK==false) return;
        DOSINT.mouseLock=false;

        gsap.to(DOSINT.camera.rotation, {
            x:DOSINT.savedRotation.x,
            y:DOSINT.savedRotation.y,
            z:DOSINT.savedRotation.z,
            ease:"power4.inOut",
            duration: .5,
        });
    });

    //DOSINT.maintrack.play();
    //DOSINT.analyser = new THREE.AudioAnalyser(DOSINT.maintrack, 32);
    DOSINT.animate();

    var camPosA = new THREE.Vector3(-2000, 0, -3800);
    var spawnPosA = new THREE.Vector3(-3000, 0, -3000);
    var camPosB = new THREE.Vector3(2000, 0, -3800)
    var spawnPosB = new THREE.Vector3( 3000, 0, -3000);

    DOSINT.makePlaneClicker("View a DIG", DOSINT.loadExistingDig, "./imgs/annex_yellow_ico.png", camPosA, spawnPosA);
    DOSINT.makePlaneClicker("Start a DIG", DOSINT.loadNewDig, "./imgs/feelz_logo.png", camPosA, spawnPosA);     //aware view?
    //DOSINT.makePlaneClicker("ANNEX What's Hot", DOSINT.whatsHot, "./imgs/annex_red_ico.png", camPosA, spawnPosA);
    //DOSINT.makePlaneClicker("ANNEfolio", DOSINT.annfolio, "./imgs/ico_anne_white.png", camPosA, spawnPosA);  
    //DOSINT.makePlaneClicker("Research & Build", DOSINT.goToExplorer, "./imgs/ANNET.png", new THREE.Vector3(3200, 0, -4600), new THREE.Vector3( 3400, 0, -4400));  
    //DOSINT.makePlaneClicker("ANNEXer Whales", DOSINT.doAnnexerWhales, "./imgs/annex_blue_ico.png", camPosB, spawnPosB);
    //DOSINT.makePlaneClicker("ANNE Wallet", DOSINT.ANNEWallet, "./imgs/anne_yellow_arch_on_black.png", camPosB, spawnPosB);

    //DOSINT.placePlanes2x3x2();

   
    ANNE.A.show("footer_tiles");    //holds go home and camera ico

  

    if($cb!=null) $cb();
}


DOSINT.loadNewDig = function($clickObj) {
    if (DOSINT._DIG!=null) {
        DOSINT._DIG.cleanup();
        DOSINT._DIG = null;
    }

    DOSINT.bMLOOKOK=false;
    //DOSINT._REVELATIAN = new revelatian(DOSINT, DOSINT.scene, DOSINT.camera, DOSINT.rendererCSS, $clickObj.helperObj, DOSINT.bEMULATE_DATA);

    //DOSINT.travelToObj(DOSINT._REVELATIAN.mesh.position, $clickObj.helperObj.camPosition, function() {
       // console.log("travel callback footer tiles show")
        //ANNE.A.show("btn_home_view");
        //ANNE.A.show("revelatian_footer"); 
    //});
}


DOSINT.loadExistingDig = function($clickObj) {
    if (DOSINT._DIG!=null) {
        DOSINT._DIG.cleanup();
        DOSINT._DIG = null;
    }

    DOSINT.bMLOOKOK=false;
    //DOSINT._REVELATIAN = new revelatian(DOSINT, DOSINT.scene, DOSINT.camera, DOSINT.rendererCSS, $clickObj.helperObj, DOSINT.bEMULATE_DATA);

    //DOSINT.travelToObj(DOSINT._REVELATIAN.mesh.position, $clickObj.helperObj.camPosition, function() {
       // console.log("travel callback footer tiles show")
        //ANNE.A.show("btn_home_view");
        //ANNE.A.show("revelatian_footer"); 
    //});
}




/**
 * 
 */
DOSINT.goToExplorer = function($clickObj) {
    if (DOSINT._ANNEfolio!=null) {
        DOSINT._ANNEfolio.cleanup();
        DOSINT._ANNEfolio = null;
    }
    else if (DOSINT._REVELATIAN!=null) {
        DOSINT._REVELATIAN.cleanup();
        DOSINT._REVELATIAN = null;
    }

    DOSINT.bMLOOKOK=false;
        
    DOSINT._REVELATIAN = new revelatian(DOSINT, DOSINT.scene, DOSINT.camera, DOSINT.rendererCSS, $clickObj.helperObj, DOSINT.bEMULATE_DATA);

    DOSINT.travelToObj(DOSINT._REVELATIAN.mesh.position, $clickObj.helperObj.camPosition, function() {
        console.log("travel callback footer tiles show")
        ANNE.A.show("btn_home_view");
        ANNE.A.show("revelatian_footer");
        
    });
}


DOSINT.lastInjectedCleanup = function() {
    ANNE.A.emptySelf("injected_div", true);  //empty and hide
}



/**
 * 
 * @param {*} $nObj 
 */
DOSINT.doANNEfolioView = async($nObj, $helperObj)=> {
    ANNE.A.hide("injected_div");
    ANNE.A.show("id_annefolio_filters");
    console.log("DO THE ANNEFOLIO VIEW");

    if (DOSINT._ANNEfolio!=null) {
        DOSINT._ANNEfolio.cleanup();
        DOSINT._ANNEfolio = null;
    }
    else if (DOSINT._REVELATIAN!=null) {
        DOSINT._REVELATIAN.cleanup();
        DOSINT._REVELATIAN = null;
    }

    //if we come ot our own identity view before we hit the annefolio...
    if ($nObj.nid==ANNE.USER._userNObj.nid && DOSINT.bGETOURSTUFF1TIME==false) {
        await DOSINT.getOurStuffOneTime();
        DOSINT.bGETOURSTUFF1TIME=true;
    }

    ANNE.A.play("inspire_space");

    DOSINT._ANNEfolio = new ANNEfolio(DOSINT, DOSINT.scene, DOSINT.camera, DOSINT.rendererCSS, $nObj, $helperObj, DOSINT.bEMULATE_DATA);
}


/**
 * moves and lerps the rotation of the camera to lookat our object.
 * note: if p1 is moving then this will be wrong!!!
 * We don't pass a ref to the obj, we pass its position.. so if that changes this will not be right.
 */
DOSINT.travelToObj=function($p1, $p2, $callback=null) {
    
    DOSINT.bTRAVELLING = true;

    var backupmlook = false;
    if (DOSINT.bMLOOKOK==true) backupmlook = true;

    DOSINT.bMLOOKOK=false;

    var las = new lookatSmooth(DOSINT.camera, null, $p2);
    las.startLookOnly(1, "none", 0, 1, null);
    var tween = gsap.to(DOSINT.camera.position, {
        x:$p2.x,
        y:$p2.y,
        z:$p2.z,
        ease:"power2.inOut",
        duration: 3,
        onUpdate:function() {
            if (tween.time()>1/3) {
                DOSINT.camera.lookAt($p1);
            }
        },
        onComplete:function() {
            DOSINT.bTRAVELLING = false;
            if (backupmlook==true) {
                DOSINT.bMLOOKOK=true;
            }
            if ($callback!=null) $callback();
        }
    })
}


/**
 * 
 */
DOSINT.travelHome = function() {
    DOSINT.switchViewCleanup();
    ANNE.A.hide("btn_home_view");
    ANNE.A.hide("id_annefolio_filters");
    
    ANNE.A.show("left_holder2");

    const THIS = this;

    //set the camera position and rotation back to home position.
    //(we may need to lerp rotation, look at that later)
    gsap.to(DOSINT.camera.position, {
        y:DOSINT.cameraHomePosition.y,
        x:DOSINT.cameraHomePosition.x,
        z:DOSINT.cameraHomePosition.z,
        duration:1,
        onComplete:function() {
            THIS.camera.updateProjectionMatrix();
        }
      });

    //rotate cam back
    gsap.to(DOSINT.camera.rotation, {
        y:DOSINT.cameraHomeRotation.y,
        x:DOSINT.cameraHomeRotation.x,
        z:DOSINT.cameraHomeRotation.z,
        duration:1,
        onComplete:function() {
            THIS.camera.updateProjectionMatrix();
        }
    });


    //have to zoom it back.
    gsap.to(DOSINT.camera, {
        zoom:DOSINT.cameraHomeZoom,
        duration:1,
        onComplete:function() {
            THIS.camera.updateProjectionMatrix();
            DOSINT.bMLOOKOK=true;
            //console.log("%c"+DOSINT.camera.position, TALK.bgblue);
            //console.log("%c"+DOSINT.camera.zoom, TALK.bgblue);
        }
    });
}


/**
 * 
 */
DOSINT.placePlanes2x3x2 = function() {
    //console.log("placePlanes2x3x2");
    DOSINT.camera.position.z = 2000;
    DOSINT.camera.position.y = 100;
    DOSINT.camera.position.x = -400;
    gsap.to(DOSINT.camera.position, {
        x:0,
        y:0,
        z:1270,
        ease:"power2.in",   
        duration:3
    });

    this.bMLOOKOK=true;
    var pts = [];
    var Z = -200;
    var INCR = 400;
    var Ybump = -433;
    pts.push(new THREE.Vector3(-INCR/2, 2*INCR+Ybump, Z));
    pts.push(new THREE.Vector3(INCR/2, 2*INCR+Ybump, Z));
    pts.push(new THREE.Vector3(-INCR, INCR+Ybump, Z));
    pts.push(new THREE.Vector3(0, INCR+Ybump, Z));
    pts.push(new THREE.Vector3(INCR, INCR+Ybump, Z));
    pts.push(new THREE.Vector3(-INCR/2, 0+Ybump, Z));
    pts.push(new THREE.Vector3(INCR/2, 0+Ybump, Z));
    
    //a speherical ring around 0,0,0
    const super_radius = 3000;
    const radStep = (Math.PI * 2) / pts.length; 

    for (var p=0; p < pts.length; p++) {
        var hp  = new THREE.Vector3(pts[p].x, pts[p].y, pts[p].z);
        DOSINT._entryTileMeshes[p].helperObj.homePosition = hp;
        DOSINT._entryTileMeshes[p].helperObj.radStep=radStep;
        DOSINT._entryTileMeshes[p].radius=super_radius;

        gsap.to(DOSINT._entryTileMeshes[p].position, {
            x:pts[p].x,
            y:pts[p].y,
            z:pts[p].z,
            ease:"power2.in",   
            duration:3
        });
    }
}


/**
 * 
 * @param {*} $title 
 * @param {*} $cb 
 */
DOSINT.makePlaneClicker = function($title, $cb=null, $imgRef="", $camPos, $spawnPos) {
    const planeGeometry = new THREE.PlaneGeometry(333, 333);
    const planeMaterial = new THREE.MeshBasicMaterial({transparent:true, opacity:0, side:THREE.DoubleSide});
    const entryTile = new THREE.Mesh(planeGeometry, planeMaterial);
    entryTile.position.set((Math.random()-.5)*1500, (Math.random()-.5)*1500, -3000);
    entryTile.ATYPE=ENTRY_TILE;
    DOSINT._entryTileMeshes.push(entryTile);

    entryTile.helperObj = {camPosition:$camPos, objSpawnPosition:$spawnPos};

    const elClicker = document.createElement("div");
    elClicker.classList.add("tile");

    if ($imgRef!="") {
        const elImg = document.createElement("img");
        elImg.classList.add("tile-img");
        elImg.setAttribute("width", 180);
        elImg.src = $imgRef;
        elClicker.appendChild(elImg);
    }

    const elClickerTitle = document.createElement("div");
    elClickerTitle.classList.add("tile-title");
    elClickerTitle.innerHTML = $title;
    elClicker.appendChild(elClickerTitle);

    const tileCSSOBJ = new ANNE.CSS3DObject( elClicker );
    tileCSSOBJ.position.set( 0, 0, 0);

    entryTile.add(tileCSSOBJ);
    entryTile.tileCSSOBJ =tileCSSOBJ;
    entryTile.cb = $cb;
    tileCSSOBJ.cb = $cb;

    DOSINT.scene.add(entryTile);
    return entryTile;
}


/**
 * 
 */
DOSINT.animate = function() {
    DOSINT.tick+=1;

    //animate through a tunnel.
    if (DOSINT._lastARING!=null && DOSINT._lastARING.bDOINGARINGTUNNEL==true && DOSINT._lastARING.ATunnel) {
        DOSINT._lastARING.ATunnel.tunnelTravel();
    }
    
    const time = performance.now() * 0.001;
    DOSINT.animationID = requestAnimationFrame(DOSINT.animate);

    DOSINT.renderer.render(DOSINT.scene, DOSINT.camera);
    DOSINT.rendererCSS.render( DOSINT.scene, DOSINT.camera );
}

DOSINT.stopAnimation=function() {
    cancelAnimationFrame(DOSINT.animationID);
    DOSINT.animationID = null;
}
DOSINT.restartAnimation=function() {
    DOSINT.animate();
}



DOSINT.similarity=function($nid1, $nid2) {

}


DOSINT.connect=function($nid1, $nid2) {

}

DOSINT.dateCompareStrs=async($str1, $str2)=>{
    //resolve the date strings.
    //then do date compare.
}

DOSINT.dateCompare=async($nid1, $nid2)=> {
    var dig_dt_comp = new dosint_dig_date_compare($nid1, $nid2);
    await dig_dt_comp.load();
}

