const QT_PERCENT = 0;
const QT_SPECIFIC = 1;

const SRC_FUND = 0;
const SRC_OWNER = 1;

const SP_MIN_PAYMENT = 1_000_000;  //new min, 1m annies (10k annecoin)

class anne_streampay_fund {
    constructor($nObj, $dossier_inst){
        this.nObj = $nObj;
        this.dossier_inst = $dossier_inst;
        this.bVALID = false;
        this.el_params = null;

        this.btn_qt = null;
        this.btn_cycle_frequency = null;
        this.btn_quantity = null;
        this.btn_benefactors = null;
        this.btn_min_start_block = null;
        this.btn_src = null;
        this.btn_keep_min_balance = null;
        this.btn_max_payments = null;
        this.btn_min_streampay_payment = null;

        this.el_funding_msg = ANNE.A.ezEl(this.dossier_inst.el_content, "div", "simple-row", "");
        this.el_recap_msg = ANNE.A.ezEl(this.dossier_inst.el_content, "div", "simple-row text-recap", "");

        ANNE.A.hide(this.dossier_inst.el_upgrade_ghost_relons);

        if (this.nObj.owned_by==USER._userNObj.nid) this._mode = "maker";
        else this._mode="benefactor_view_mode"; //could be NIXED if not a benefactor.

        this.sp_quantity = 0;
        this.sp_qt = null;
        this.sp_frequency = null;   //new min = 10080
        this.sp_benefactors = [];
        this.sp_qv_percent_val = 0;
        this.sp_qv_specific_val = 0;
        this.sp_max_payments = 0;

        this.sp_min_start_block = 0;
        this.sp_qt_var = -1;
        this._min_payment = SP_MIN_PAYMENT;

        this.sp_src = MEM.streampay_src_theFund;
        this.SOURCE_OF_FUNDS = SRC_FUND;

        this.sp_keep_min_balance = 0;

        this.PAYMENT_FEE = 10000;   //new payment fee, 100 coins, to decentivize micro usage
        this.bFROZE = false;
        this.bCOMPLETE = false;

        this.rel_qt = null;
        this.rel_quantity = null;
        this.rel_cycle_frequency = null;
        this.rel_benefactors = null;
        this.rel_min_start_block = null;
        this.rel_src = null;
        this.rel_keep_min_balance = null;
        this.rel_freeze =null;
        this.rel_max_payments = null;
        this.rel_min_streampay_payment = null;
        

        this.setRelVals();
    }

    /**
     * When I recompile the annode we can remove the PARAM makers here.
     * I am making them since they are pre-loaded as part of the streampay class definition yet.
     */
    initASYNC=async()=>{
        this.rel_param_qt = MEMG.getParamRelon(MEM.streampay.outs, MEM.distro_quantity_type.temp_nid);
        this.rel_param_quantity = MEMG.getParamRelon(MEM.streampay.outs, MEM.distro_quantity.temp_nid);
        this.rel_param_benefactors = MEMG.getParamRelon(MEM.streampay.outs, MEM.distro_to_whom.temp_nid);
        this.rel_param_cycle_frequency = MEMG.getParamRelon(MEM.streampay.outs, MEM.block_frequency.temp_nid);
        this.rel_param_min_start_block = MEMG.getParamRelon(MEM.streampay.outs, MEM.min_start_block.temp_nid);
        this.rel_param_src = MEMG.getParamRelon(MEM.streampay.outs, MEM.streampay_src.temp_nid);
        this.rel_param_keep_min_balance = MEMG.getParamRelon(MEM.streampay.outs, MEM.keep_min_balance.temp_nid);
        this.rel_param_max_payments = MEMG.getParamRelon(MEM.streampay.outs, MEM.max_total_payments.temp_nid);
        this.rel_param_min_payment = MEMG.getParamRelon(MEM.streampay.outs, MEM.min_streampay_payment.temp_nid);
    }


    /**
     * 
     */
    recheck = function() {
        this.setRelVals();
        this.makerMode();
    }


    /**
     * Poor man's talk.  Lightweight and fast for the task at hand.
     * @param {*} $fundings 
     * @param {*} $total_in_funds 
     * @param {*} $distros 
     * @param {*} $total_out_funds 
     * @param {*} $aPayouts 
     * @param {*} $anniesHypothetical 
     * @param {*} $payback
     */
    doRecap = function($fundings, $total_in_funds, $distros, $total_out_funds, $aPayouts, $anniesHypothetical=0, $payback=0, $triggers_length=0) {
        ANNE.A.empty(this.el_recap_msg);
        var aS = [];
        var funding_vb = "has been ";
        var bDEAD=false;

        var NOBJ = this.nObj;
        if (this.sp_src==MEM.streampay_src_owner.nid) {
            NOBJ = USER._userNObj;
        }
        
        if (this.nObj.ghost==true) {
            aS.push("<p><b>♼ "+this.nObj.text+" ♼</b> is a ghost neuron and does not yet exist on ANNE.");
        }

        //not a ghost...
        //look for the trigger.  If the trigger doesn't exist then this is dead.

        else if (this.bFROZE==false) {
            var wdBenefactors = ANNE.TALK.pluralizeNounIf2(this.sp_benefactors, "benefactor", "benefactors");
            aS.push("<p><b>♼ "+this.nObj.text+" ♼</b> is not yet frozen/activated and can still have its definition updated.");
            aS.push("  It currently is set to distribute funds to <b>"+this.sp_benefactors.length+"</b> "+wdBenefactors);
            
            var blocks = "<b>"+this.sp_frequency+" blocks</b>";

            if (this.sp_qt==MEM.distro_qt_percent.nid) {
                var basis = "<b>% of total fund</b>"
            }
            else  {
                var basis = "<b>specific amount</b>"
            }
            aS.push(" on a <b>"+basis+"</b> basis every "+blocks+".");

            if (this.sp_min_start_block>0) {
                aS.push("  The fund will not start the stream until a min block of <b>"+this.sp_min_start_block+"</b>.");
            }
        }

        else {
            //LOOK FOR THE TRIGGER TO VERIFY IF THIS IS ACTIVE OR NOT.

            //froze with 0.
            if (this.bCOMPLETE==true) {
                aS.push("<p><b>♼ "+this.nObj.text+" ♼</b> has run its course and there are no more active distributions.");
                funding_vb = "was ";
                bDEAD=true;
            }
            
            //froze language.
            else if (this.bFROZE==true) {
                var wdBenefactors = ANNE.TALK.pluralizeNounIf2(this.sp_benefactors, "benefactor", "benefactors");
                
                if (this.bCOMPLETE==false) {
                    aS.push("<p><b>♼ "+this.nObj.text+" ♼</b> is activate and ");
                    aS.push("currently set to distribute funds to <b>"+this.sp_benefactors.length+"</b> "+wdBenefactors);
                    
                }
                else {
                    aS.push("<p><b>♼ "+this.nObj.text+" ♼</b> is complete and ");
                    aS.push("distributed funds to <b>"+this.sp_benefactors.length+"</b> "+wdBenefactors);
                }
               
                var blocks = "<b>"+this.sp_frequency+" blocks</b>";

                if (this.sp_qt==MEM.distro_qt_percent.nid) {
                    var basis = "<b>% of total fund</b>"
                }
                else  {
                    var basis = "<b>specific amount</b>"
                }
                aS.push(" on a <b>"+basis+"</b> basis every "+blocks+".");

                if (this.sp_min_start_block>0) {
                    if (this.bCOMPLETE==true) {
                        //
                    }
                    else if (this.sp_min_start_block > ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK) {
                        aS.push("  The fund will not start the stream until a min block of <b>"+this.sp_min_start_block+"</b>.");
                    }
                    else {
                        aS.push("  The fund has a min start block that already passed and is now esimated to start at <b>"+ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK_1+"</b>.");
                    }
                }


                //enforce max payments.
                if (this.sp_max_payments>0) {
                    var ppay = 0;
                    for (var p=0; p < $aPayouts.length; p++) {
                        if ($aPayouts[p].projected==true) ppay+=1;
                    }
                    var ender = "are remaining to make.";
                    if (ppay==1) ender = "remains to be made.";
                    else if (ppay==0) ender = " are left to make.  You should only see this message during grace period of the last payment cycle right before it is applied OR your SP was set up in such a way to have O valid payments.";
                    
                    if (this.bCOMPLETE==false) {
                        aS.push("  The fund has max payments (cycles of payout) of <b>"+this.sp_max_payments+"</b> of which "+ppay+" "+ender+".");
                    }
                }
            }
        }

        var bDOINGOWNERFUND = false;
        if (this.SOURCE_OF_FUNDS == SRC_OWNER) {
            bDOINGOWNERFUND = true;
        }
        
        if (bDOINGOWNERFUND==false && $fundings==0) {
            aS.push("  There have been no fundings or distributions.");
        }

        else {
            var actual_fundings = $fundings;
            var actual_total_in_funds = $total_in_funds;
            if ($anniesHypothetical>0) {
                actual_fundings = $fundings-1;
                if ($total_in_funds>0) {
                    actual_total_in_funds = $total_in_funds - $anniesHypothetical;
                }
            }

            var wdfundings = ANNE.TALK.pluralizeNounIf2(actual_fundings, "funding", "fundings");
            var aft = actual_total_in_funds;
            if (aft==undefined || aft==null) aft = 0;
            
            if (bDOINGOWNERFUND==false) {
                aS.push("  There "+funding_vb+actual_fundings+" "+wdfundings+" for a total of "+ANNE.GUI_STUFF.doAnniesToANNE_HTML(actual_total_in_funds)+".");
            }
            else {
                var ownerNOBJ = MEMG.getNeuronByNid(this.nObj.owned_by);
                aS.push("  This is set to payout from the owning identity account <span class='text-sharpgreen-pad'>"+ownerNOBJ.bestNameHTML()+"</span> which has a total of "+ANNE.GUI_STUFF.doAnniesToANNE_HTML(actual_total_in_funds)+".");
            }
            
            if ($distros==0) {
                aS.push("  There have been no distributions yet.");
            }
            else {
                var wdDistros = ANNE.TALK.pluralizeNounIf2($distros, "distribution", "distributions");
                aS.push("  There "+funding_vb+$distros+" "+wdDistros+" for a total of "+ANNE.GUI_STUFF.doAnniesToANNE_HTML($total_out_funds)+".");
            }

            if (this.bCOMPLETE==true) {
                var totalFees = $distros * 700;
                aS.push("  "+ANNE.GUI_STUFF.doAnniesToANNE_HTML(totalFees)+" in total fees were paid to send internal payments.");
            }
            if ($payback!=0) {
                var ownerNOBJ = MEMG.getNeuronByNid(this.nObj.owned_by);
                aS.push("  A final payback payment was made of "+ANNE.GUI_STUFF.doAnniesToANNE_HTML($payback)+" to fund owner <b>"+ownerNOBJ.bestNameHTML()+"</b> to close out the fund.");
            }
        }

        if (bDEAD==true) {
            this.el_recap_msg.innerHTML = aS.join("");
            return;
        }

        var future_distro = 0;
        var cycles_left_map = [];
        var cycles_left = 0;
        var max_height = 0;

        for (var p=0; p < $aPayouts.length; p++) {
            var pObj = $aPayouts[p];
            if (pObj.projected==true) {
                future_distro+=1;
                if (cycles_left_map.indexOf(pObj.height)==-1) {
                    cycles_left_map.push(pObj.height);
                    if (pObj.height > max_height) max_height = pObj.height;
                }
            }
        }

        cycles_left = cycles_left_map.length;

        var wdFDistro = ANNE.TALK.pluralizeNounIf2(future_distro, "distribution", "distributions");
        var wdCycles = ANNE.TALK.pluralizeNounIf2(cycles_left, "cycle", "cycles");
        
        var estimatedEndDate = ANNE.UTILS.estimateTimeByBlocks(max_height-ANNE.HISTORY.getGLKB());

        var ands = [];
        if (this.sp_min_start_block) {
            if (this.sp_min_start_block <= ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK) {
                if (this.rel_freeze==null) {
                    ands.push(" <span class='text-red'>(( note: MIN BLOCK OF <b>"+this.sp_min_start_block+"</b> is IRRELEVANT.. WE'RE BEYOND THAT BLOCK))</span>");
                }
                else ands.push(" and a min start block of <b>"+this.sp_min_start_block+"</b>");
            }
            else {
                ands.push(" and a min start block of <b>"+this.sp_min_start_block+"</b>");
            }
        }
        if (this.sp_max_payments) ands.push(" and <b>"+this.sp_max_payments+"</b> max payment ");
        if (this.sp_keep_min_balance) ands.push(" and keeping a min balance of <b>"+ANNE.GUI_STUFF.doAnniesToANNE_HTML(this.sp_keep_min_balance)+"</b> outside of the payments ")
        
        if (this._min_payment > SP_MIN_PAYMENT) {
            ands.push(" and a min payment of <b>"+ANNE.GUI_STUFF.doAnniesToANNE_HTML(this._min_payment)+"</b> ")
        }

        if ($anniesHypothetical!=0) {
            aS.push("  With the hypothetical funding of "+ANNE.GUI_STUFF.doAnniesToANNE_HTML($anniesHypothetical));
            if (ands) {
                aS = aS.concat(ands);
            }
            aS.push("  there would be a projected <b>&nbsp;"+future_distro+"&nbsp;</b>more "+wdFDistro+" remaining.");// over<b>&nbsp;"+cycles_left+"&nbsp;</b>"+wdCycles+".");
            aS.push("  If those funds are added the final distribution will pushed out to block <b>&nbsp;"+max_height+"&nbsp;</b> which should be around <b>&nbsp;"+estimatedEndDate+"&nbsp;</b>.</p>");
        }

        else {
            aS.push("  There are a projected <b>&nbsp;"+future_distro+"&nbsp;</b> "+wdFDistro+" remaining.");// over <b>&nbsp;"+cycles_left+"&nbsp;</b> payment "+wdCycles+".");
            if (max_height>0) aS.push("  With the present funds");
            if (ands) {
                aS = aS.concat(ands);
            }
            aS.push(" the final distribution will be on block <b>&nbsp;"+max_height+"&nbsp;</b> which should be around <b>&nbsp;"+estimatedEndDate+"&nbsp;</b>.</p>");
        }
        const singleSpaces = aS.join("").replace(/\s{2,}/g, ' ');

        this.el_recap_msg.innerHTML = singleSpaces;
    }
        

    /**
     * anne_streampay_fund
     */
    setRelVals = function() {
        this.rel_qt = MEMG.getHasRelon(this.nObj.outs, MEM.distro_quantity_type.temp_nid);
        this.rel_quantity = MEMG.getHasRelon(this.nObj.outs, MEM.distro_quantity.temp_nid);
        this.rel_cycle_frequency = MEMG.getHasRelon(this.nObj.outs, MEM.block_frequency.temp_nid);
        this.rel_benefactors = MEMG.getHasRelons(this.nObj.outs, MEM.distro_to_whom.temp_nid);
        this.rel_min_start_block = MEMG.getHasRelon(this.nObj.outs, MEM.min_start_block.temp_nid);
        this.rel_src = MEMG.getHasRelon(this.nObj.outs, MEM.streampay_src.temp_nid);
        this.rel_keep_min_balance = MEMG.getHasRelon(this.nObj.outs, MEM.keep_min_balance.temp_nid);
        this.rel_freeze = MEMG.getSysMsgRelon(this.nObj.outs, MEM.CMD_FREEZE.temp_nid);
        if (this.rel_freeze!=null) {
            this.bFROZE=true;

            //rel if froze, but not yet in the neuron.  Do it here (override)
            if (this.nObj.freeze == false) {
                this.dossier_inst.el_doss_body.classList.add("freeze-border");
            }
        }
        this.rel_max_payments = MEMG.getHasRelon(this.nObj.outs, MEM.max_total_payments.temp_nid);
        this.rel_min_streampay_payment = MEMG.getHasRelon(this.nObj.outs, MEM.min_streampay_payment.temp_nid);
        
    }


    /**
     * anne_streampay_fund
     */
    benefactorViewMode = function() {
        if (this.rel_benefactor==null || this.rel_benefactor.to_s!=USER._userNObj.nid) {
            //do pithy msg.
            return;
        }
    }


    /**
     * 
     * @param {*} $src 
     */
    setSOURCE = function($src) {
        this.sp_src = $src;
        if (this.sp_src==MEM.streampay_src_owner.nid) {
            this.SOURCE_OF_FUNDS = SRC_OWNER;
        }
        else {
            this.SOURCE_OF_FUNDS = SRC_FUND;
        }
    }


    /**
     */
    makerMode = function() {
        this.missing = 0;
        this.bVALID = false;
        var idboxID = this.dossier_inst.el_idsbox.id;

        if (this.nObj.owned_by!=USER._userNObj.nid) return;
        if (this.el_params==null) {
            this.el_params = ANNE.A.ezEl(this.dossier_inst.el_content, "div", "simple-row", "");
        }

        if (this.rel_qt==null && this.rel_freeze==null) { 
            if (this.nObj.ghost==false && this.bFROZE==true) return;
            if (this.btn_qt==null) {
                var bREQUIRED=true;
                var msg = "streampay type";
                this.btn_qt = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_qt, msg, bREQUIRED);
                this.btn_qt.setAttribute("prompt", "streampay type");
                var helpermsg = "Streampays payout each streampay cycle based on either <b>a percent of the fund's balance</b> OR <b>a specific amount</b>."; 
                helpermsg = helpermsg+ "  If a payment cycle arrives and funds are no longer available in the fund the payment will be skipped.  "
                helpermsg = helpermsg+ "  The streampay will deactivated.  It will be auto-reactivated if it is funded again.";
                helpermsg = helpermsg+ "  Streampays cost 7 annecoin per cyle payment, per benefactor.  This cost covers the overhead and relons made to document the payment.";
                helpermsg = helpermsg+ "  This goes into the annode operator fund for payment to annode operators.";
                this.btn_qt.setAttribute("helperMsg", helpermsg);  //a bigger helper msg
                this.btn_qt.setAttribute("displayin_id", idboxID);
                this.btn_qt.setAttribute("col1", "tal50");
                this.btn_qt.setAttribute("col2", "tal50");
            }
            this.missing+=1;
        }

        else {
            if (this.btn_qt!=null || this.rel_freeze!=null) ANNE.A.removeSelf(this.btn_qt);

            this.sp_qt = this.rel_qt.to_s;
            
            if (this.rel_qt.to_s==MEM.distro_qt_percent.nid) {
                this.sp_qt_var = QT_PERCENT;
            }
            else if (this.rel_qt.to_s==MEM.distro_qt_specific.nid) {
                this.sp_qt_var = QT_SPECIFIC;
            }

            //open this up after this.rel_qt
            if (this.rel_quantity==null) { 
                if (this.nObj.ghost==false && this.bFROZE==true) return; 
                var bREQUIRED=true;
                
                if (this.btn_quantity==null) {
                    if (this.rel_qt.to_s==MEM.distro_qt_percent.nid)  {
                        msg = "% of fund each cycle";
                        var max_percent=1; 
                        this.btn_quantity = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_quantity, msg, bREQUIRED);
                        this.btn_quantity.setAttribute("maximum", max_percent);  
                        this.btn_quantity.setAttribute("prompt", "The % of the total fund balance to pay out each cycle.");
                        this.btn_quantity.setAttribute("minimum", "0.0001");  //min percent of fund to move.
                        this.btn_quantity.setAttribute("default", "0.0001");
                        this.btn_quantity.setAttribute("displayin_id", idboxID);
                        this.btn_quantity.setAttribute("col1", "tal50");
                        this.btn_quantity.setAttribute("col2", "tal50");
                        this.btn_quantity.setAttribute("nounit", "1");
                        var helpermsg = "The % must be a WHOLE NUMBER greater than 0 and less than or equal 1!"; 
                        this.btn_quantity.setAttribute("helperMsg", helpermsg);  //a bigger helper msg
                    }
                    else if (this.rel_qt.to_s==MEM.distro_qt_specific.nid) {
                        //2.2 billion ANNE COIN, 220B annies.
                        //this is 1/1000th of the entire chain in a single distribution.  (that should be plenty for a cap)
                        //if 1B market cap, then this single distro payment would be 1M usd transfer in a single payment.
                        msg = "specific anne coins each cycle";
                        var max_annies = 220000000000; 
                        this.btn_quantity = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_quantity, msg, bREQUIRED);
                        this.btn_quantity.setAttribute("maximum", max_annies);
                        this.btn_quantity.setAttribute("prompt", "The specific number of annecoin to pay each benefactor each cycle.");
                        this.btn_quantity.setAttribute("minimum", 10000);   //10k min payment   
                        this.btn_quantity.setAttribute("default", 10000);   //10k min payment
                        this.btn_quantity.setAttribute("display_annecoin", 1);
                        this.btn_quantity.setAttribute("displayin_id", idboxID);
                        this.btn_quantity.setAttribute("col1", "tal50");
                        this.btn_quantity.setAttribute("col2", "tal50");
                        this.btn_quantity.setAttribute("annieshack", "1");
                    }
                    this.missing+=1;
                }
            }

            else {
                if (this.btn_quantity!=null) ANNE.A.removeSelf(this.btn_quantity);
                this.sp_quantity = this.rel_quantity.to_s;
                if (this.sp_qt==MEM.distro_qt_percent.nid) {
                    this.sp_qv_percent_val = parseFloat(this.sp_quantity);
                }
                else this.sp_qv_specific_val = parseInt(this.sp_quantity);
            }
        }

        if (this.rel_cycle_frequency==null) { 
            if (this.nObj.ghost==false && this.bFROZE==true) return;

            if (this.btn_cycle_frequency==null) {
                var bREQUIRED=true;
                var msg = "block cycle (frequency)";
                this.btn_cycle_frequency = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_cycle_frequency, msg, bREQUIRED);
                var helpermsg = "This is the <b>block cycle frequency</b> this fund will streampay out according to.";
                helpermsg = helpermsg + "  This is specified by providing a number to match block number endings with %mod test."
                helpermsg = helpermsg + "  The minimum cycle is 2 weeks which is a value of 10080 blocks.  Monthly would be approximately 21600."; 
                this.btn_cycle_frequency.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
                this.btn_cycle_frequency.setAttribute("prompt", msg);
                this.btn_cycle_frequency.setAttribute("insts_only", 1);
                this.btn_cycle_frequency.setAttribute("minimum", 10080);
                this.btn_cycle_frequency.setAttribute("maximum", 10368000); //we'll let you wait 40 yrs per cycle, if you want. (lolz)
                this.btn_cycle_frequency.setAttribute("displayin_id", idboxID);
                this.btn_cycle_frequency.setAttribute("col1", "tal50");
                this.btn_cycle_frequency.setAttribute("col2", "tal50");
            }

            this.missing+=1;
        }
        else {
            if (this.btn_cycle_frequency!=null) ANNE.A.removeSelf(this.btn_cycle_frequency);
            this.sp_frequency = this.rel_cycle_frequency.to_s;
        }


        //atleast one is required.
        if (this.rel_benefactors.length==0) { 
            if (this.nObj.ghost==false && this.bFROZE==true) return; 
            if (this.btn_benefactors==null) {
                var bREQUIRED=true;
                var msg = "ANNE ID of benefactor";
                this.btn_benefactors = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_benefactors, msg, bREQUIRED);
                this.btn_benefactors.setAttribute("prompt", "The <b>ANNE IDENTITY</b> this fund will streampay to.");
                this.btn_benefactors.setAttribute("insts_only", 1);
                this.btn_benefactors.setAttribute("displayin_id", idboxID);
                this.btn_benefactors.setAttribute("col1", "tal50");
                this.btn_benefactors.setAttribute("col2", "tal50");
            }
            this.missing+=1;
        }

        //add another benefactor.
        //this will be open until the neuron is "real" and "frozen"
        //this one tho gets added to the right area to keep it out of view of our purdy stuff.
        else {
            if (this.nObj.ghost==true || (this.nObj.ghost==false && this.bFROZE==false)) {
                var msg = "add another benefactor";
                if (this.btn_benefactors==null) {
                    this.btn_benefactors = this.dossier_inst.makeCollabBtn(this.dossier_inst.el_idsbox, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_benefactors, msg, false);
                    this.btn_benefactors.setAttribute("prompt", "The <b>ANNE IDENTITY</b> this fund will streampay to.");
                    this.btn_benefactors.setAttribute("insts_only", 1);
                    this.btn_benefactors.style['margin-bottom']="10px";
                    this.btn_benefactors.setAttribute("displayin_id", idboxID);
                    this.btn_benefactors.setAttribute("col1", "tal50");
                    this.btn_benefactors.setAttribute("col2", "tal50");
                }
            } 
            else {
                if (this.btn_benefactors!=null) ANNE.A.removeSelf(this.btn_benefactors);
            }
        }


        this.sp_benefactors = [];
         for (var b=0; b < this.rel_benefactors.length; b++) {
            if (this.sp_benefactors.indexOf( this.rel_benefactors[b].to_s)==-1) {
                this.sp_benefactors.push( this.rel_benefactors[b].to_s);
            }
        }
        

        //streampay source (identity neuron, or the streampay neuron itself)
        if (this.rel_src==null) { 
            if (this.nObj.ghost==false && this.bFROZE==true){
                console.log("ok");
            }
            else if (this.btn_src==null && this.rel_freeze==null) {
                var bREQUIRED=false;
                var msg = "funds source";
                this.btn_src = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_src, msg, bREQUIRED);
                var helpermsg = "Streampay neurons default to having a fund src of their self.  The value need not be set if that is the desired source.  The other option is to set the IDENTITY making the neuron as the source of funds.";
                this.btn_src.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
                this.btn_src.setAttribute("prompt", msg);
                this.btn_src.setAttribute("displayin_id", idboxID);
                this.btn_src.setAttribute("col1", "tal50");
                this.btn_src.setAttribute("col2", "tal50");
            }
        }
        else {
            if (this.btn_src!=null || this.rel_freeze==null) ANNE.A.removeSelf(this.btn_src);
            if (this.rel_src!=null) this.setSOURCE(this.rel_src.to_s);
        }


        //keep min balance..
        //only relevant for SRC_OWNER
        if (this.SOURCE_OF_FUNDS == SRC_OWNER) {
            if (this.rel_keep_min_balance==null && this.rel_freeze==null) {
                if (this.nObj.ghost==false && this.bFROZE==true){
                    console.log("ok");
                }
                else if (this.btn_keep_min_balance==null) {
                    var bREQUIRED=false;
                    var msg = "keep min balance";
                    this.btn_keep_min_balance = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_keep_min_balance, msg, bREQUIRED);
                    var helpermsg = "Keep a min balance present which is withheld from the streampay calculations.";
                    this.btn_keep_min_balance.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
                    this.btn_keep_min_balance.setAttribute("prompt", msg);
                    this.btn_keep_min_balance.setAttribute("minimum", 10000);
                    this.btn_keep_min_balance.setAttribute("displayin_id", idboxID);
                    this.btn_keep_min_balance.setAttribute("col1", "tal50");
                    this.btn_keep_min_balance.setAttribute("col2", "tal50");
                    this.btn_keep_min_balance.setAttribute("annieshack", "1");
                }
            }
            else {
                if (this.btn_keep_min_balance!=null || this.rel_freeze==null) {
                    ANNE.A.removeSelf(this.btn_keep_min_balance);
                }
                if (this.rel_keep_min_balance!=null) this.sp_keep_min_balance = this.rel_keep_min_balance.to_s;
            }
        }

        //max payments
        if (this.rel_max_payments==null && this.rel_freeze==null) {
            if (this.nObj.ghost==false && this.bFROZE==true){
                console.log("ok");
            }
            else if (this.btn_max_payments==null) {
                var bREQUIRED=false;
                var msg = "max payments";
                this.btn_max_payments = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_max_payments, msg, bREQUIRED);
                var helpermsg = "Set a max payments to cap off a SP.  If a SRC-FUND, the remaining funds are returned to fund owner.";
                this.btn_max_payments.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
                this.btn_max_payments.setAttribute("prompt", msg);
                this.btn_max_payments.setAttribute("minimum", 1);
                this.btn_max_payments.setAttribute("displayin_id", idboxID);
                this.btn_max_payments.setAttribute("col1", "tal50");
                this.btn_max_payments.setAttribute("col2", "tal50");
            }
        }
        else {
            if (this.btn_max_payments!=null || this.rel_freeze==null) {
                ANNE.A.removeSelf(this.btn_max_payments);
            }
            if (this.rel_max_payments!=null) this.sp_max_payments = parseInt(this.rel_max_payments.to_s);
        }


        if (this.rel_min_streampay_payment==null && this.rel_freeze==null) {
            if (this.nObj.ghost==false && this.bFROZE==true){
                console.log("ok");
            }
            else if (this.btn_min_streampay_payment==null) {
                var bREQUIRED=false;
                var msg = "min payment";
                this.btn_min_streampay_payment = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_min_payment, msg, bREQUIRED);
                var helpermsg = "Set a min payment (relevant for % distros).  If min can't be met the SP is closed.";
                this.btn_min_streampay_payment.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
                this.btn_min_streampay_payment.setAttribute("prompt", msg);
                this.btn_min_streampay_payment.setAttribute("minimum", 10000);
                this.btn_min_streampay_payment.setAttribute("display_annecoin", "1");
                this.btn_min_streampay_payment.setAttribute("displayin_id", idboxID);
                this.btn_min_streampay_payment.setAttribute("col1", "tal50");
                this.btn_min_streampay_payment.setAttribute("col2", "tal50");
                this.btn_min_streampay_payment.setAttribute("annieshack", "1");
            }
        }
        else {
            if (this.btn_min_streampay_payment!=null || this.rel_freeze==null) {
                ANNE.A.removeSelf(this.btn_min_streampay_payment);
            }
            if (this.rel_min_streampay_payment!=null) {
                this._min_payment = Math.max(SP_MIN_PAYMENT, parseInt(this.rel_min_streampay_payment.to_s));
            }
        }


        //minimum start block.
        if (this.rel_min_start_block==null && this.rel_freeze==null) { 
            if (this.nObj.ghost==false && this.bFROZE==true){
                console.log("ok");
            }
            else if (this.btn_min_start_block==null) {
                var bREQUIRED=false;
                var msg = "min start block";
                this.btn_min_start_block = this.dossier_inst.makeCollabBtn(this.el_params, ANNE.TXB.TXTYPE_CHILD_RELON, this.rel_param_min_start_block, msg, bREQUIRED);
                var current_block = ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK;

                var helpermsg = "This is the minimum <b>block</b> this fun can payout on.  It is essentially a time delay.  Current block: <b>"+current_block+"</b>";
                this.btn_min_start_block.setAttribute("helperMsg", helpermsg);  //a bigger helper msg.
                this.btn_min_start_block.setAttribute("prompt", msg);
                this.btn_min_start_block.setAttribute("insts_only", 1);
                this.btn_min_start_block.setAttribute("minimum", 1);
                this.btn_min_start_block.setAttribute("maximum", 10368000); //we'll let you wait 40 yrs, if you really want.
                this.btn_min_start_block.setAttribute("displayin_id", idboxID);
                this.btn_min_start_block.setAttribute("col1", "tal50");
                this.btn_min_start_block.setAttribute("col2", "tal50");
            }
        }
        else {
            if (this.btn_min_start_block!=null || this.rel_freeze==null) {
                ANNE.A.removeSelf(this.btn_min_start_block);
            }
            if (this.rel_min_start_block!=null) this.sp_min_start_block = this.rel_min_start_block.to_s;
        }


        if (this.missing==0 ) {
            if (this.nObj.ghost==true) {
                ANNE.A.show(this.dossier_inst.el_upgrade_ghost_relons);
                var fundmsg = "fund and activate (freeze)";
                if (this.SOURCE_OF_FUNDS == SRC_OWNER) {
                    fundmsg = "activate (freeze)";
                }
                this.el_funding_msg.innerHTML="*** Once you upgrade from Ghost to real neuron you can "+fundmsg+" this streampay. ***";
                this.el_funding_msg.classList = "callout";
            }

            //not a ghost, but may have ghost relons still
            else {

                //if froze, nothing can be done.
                if (this.bFROZE==false && this.nObj.hasGhostRelons()==true) {
                    ANNE.A.show(this.dossier_inst.el_upgrade_ghost_relons);
                }
            }

            this.bVALID=true;
        }

        else {
            this.el_funding_msg.innerHTML="Required values are still missing.";
            ANNE.A.hide(this.dossier_inst.el_upgrade_ghost_relons);
        }
    }

         
    /**
     * 
     * @param {*} $arr 
     * @param {*} $balance 
     * @param {*} $height 
     * @param {*} $CALCNEW_HEIGHT
     * @returns 
     */
    project_payment = function($arr, $balance, $current_height, $CALCNEW_HEIGHT=false) {
        var next_payment_annies = 0;
        var next_payment_height = 0;

        //owner src and keep_min_balance set, leave that out of the calcs.
        if (this.SOURCE_OF_FUNDS == SRC_OWNER && this.sp_keep_min_balance>0) {
            $balance = $balance - this.sp_keep_min_balance;
        }

        if($balance <=0) {
            return {last_height:$current_height, balance:0, stop:true};
        }

        
        if (this.sp_qt==MEM.distro_qt_percent.nid) {
            var fees = this.PAYMENT_FEE*this.sp_benefactors.length;
            var balance_to_work_with = $balance-fees;
            next_payment_annies = Math.floor(this.sp_qv_percent_val * balance_to_work_with);
        }        
        else if (this.sp_qt==MEM.distro_qt_specific.nid) {
            next_payment_annies = this.sp_qv_specific_val;
        }
        
        //not enough to cover min-payment (the final payment mark this and payout the owner)  
        if (next_payment_annies<this._min_payment) {
            return {last_height:$current_height, balance:0, stop:true};
        }
        
        if ($CALCNEW_HEIGHT==true) {
            if (this.sp_min_start_block>0) {
                if (this.sp_min_start_block > $current_height) {
                    next_payment_height = this.sp_min_start_block;
                }
                else {
                    next_payment_height = $current_height+this.sp_frequency;
                }
            }
            else {
                var freeze_height = 0;
                if (this.rel_freeze!=null) {
                    freeze_height = parseInt(this.rel_freeze.time);
                    if ($current_height==freeze_height) {
                        next_payment_height = freeze_height+1;
                    }
                    else {
                        if ($current_height>ANNE.HISTORY._GREATEST_LAST_KNOWN_BLOCK) {
                            next_payment_height = $current_height+this.sp_frequency;
                        }
                        else next_payment_height = $current_height+1+this.sp_frequency;
                    }
                }
                else {
                    next_payment_height = $current_height+this.sp_frequency;
                }
            }
        }
        else {
            next_payment_height = $current_height;
        }
   
        var payments_needed = this.sp_benefactors.length;
        var annies_needed = (this.PAYMENT_FEE*payments_needed) + (payments_needed * next_payment_annies);

        if (annies_needed <= $balance) {
            for (var b=0; b < this.sp_benefactors.length; b++) {
                var bwd = {projected:true, annies:next_payment_annies, txid:"", from_nid:this.nObj.text, to_s:this.sp_benefactors[b], height:next_payment_height};
                $arr.push(bwd);
            }
            return {last_height:next_payment_height, balance:($balance-annies_needed)};
        }

        //if funds left, dump them back to the owner
        else {
            if ($balance>0) {
                var ownedByNOBJ = MEMG.getNeuronByNid(this.nObj.owned_by);
                var bwd = {projected:true, annies:$balance, txid:"", from_nid:this.nObj.text, to_s:ownedByNOBJ.text, height:next_payment_height};
            }
        }


        return {last_height:$current_height, balance:0};
    }

}



/**
 * Streampay another account on a block cycle schedule for a specific or percent amount.
 */
 class dossier_streampay extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        console.log("%c dossier_streampay", TALK.bgredbig);
        super($pgui, $secondary, $third, $misc);
        this._freeze_annies = 0;
        this.btn_fund_and_freeze = null;
        this.btn_freeze_only = null;
        this.btn_paystream_projections = null;
        this.el_empty_notice = null;
        this._tableObj = null;  
        this.triggers  = new arraymap();
        this.el_brain = null;
    }


    /**
     * 
     * @param {*} $pguicopy 
     */
    initASYNC = async($pguicopy)=>{
        ANNE.A.removeSelf(this.el_bebox_img);
        await this.getData(false, this.nObj, []);
        await this.doHeading(false, []);
        this.spf = new anne_streampay_fund(this.nObj, this);
        await this.spf.initASYNC();
 
        ANNE.A.addRemoveClass("page_"+this.ID, "anne-page-wide", "anne-page-dossier-solo");

        ANNE.A.addRemoveClass(this.el_content, "doss-body-box-full", "doss-body-box");
        
        //anne-page-dossier-solo-body
        //anne-page-body-wide anne-page-maxH
        var el2 = ANNE.A.addRemoveClass("apb_"+this.ID, "anne-page-body-wide", "anne-page-dossier-solo-body");
        el2.classList.add("anne-page-maxH");

        ANNE.A.removeSelf("garden_"+this.nObj.temp_nid);
        
        var elhas = await this.doAllHas(this.el_idsbox, "section-title-center", [], [], "simple-col tal", "tal");
        ANNE.A.removeSelf(elhas);
        
        ANNE.A.smartScroll("scrollable_"+this.ID, 72);

        var bREDOBALANCE=false;

        if (this.spf.SOURCE_OF_FUNDS == SRC_OWNER) this.validateAndHandle(true);
        else this.validateAndHandle(true);

        ANNE.TALK.printRelons(this.nObj.ins);
    }


    /**
     * 
     */
    activeFreezeOnly = function() {
        this.btn_freeze_only = ANNE.A.showParent("freeze_selfOwned_freezeonly_btn_"+this.ID, true);
        this.btn_freeze_only.addEventListener("click", async(e)=>{
            ANNE.A.removeParent(this.btn_freeze_only);  //don't want any downstream gui stuff to turn this back on in this view.
            this.freezeStreampay(e);
            if (this.btn_paystream_projections==null) {
                var newcol  = document.createElement("div");
                newcol.classList = "simple-col fba"; 
                var fzAnnies = document.getElementById("freeze_annies_"+this.ID);
                ANNE.A.appendAfter(fzAnnies, newcol);
                this.btn_paystream_projections = ANNE.A.ezButton(newcol, "btn_paystream_projections", "project ♼ streampay ♼", "dynamic anne-tiny-btn btn-blue-sq btn-maxH hide", 
                        async($e)=>{
                            console.log("project the paystream!");
                            ANNE.A.hide(this.btn_paystream_projections);
                            redoLedger(this._freeze_annies);
                        }
                );
            }
        });
    }


    /**
     * activate the freeze button.
     * The streampay is valid and it has funds and it is not yet froze.
     */
    activateFundAndFreeze=function() {
        this.btn_fund_and_freeze = ANNE.A.showParent("freeze_selfOwned_btn_"+this.ID, true);
        this.btn_fund_and_freeze.addEventListener("click", async(e)=>{
            ANNE.A.show("freeze_annies_"+this.ID);
            ANNE.A.removeParent(this.btn_fund_and_freeze);  //don't want any downstream gui stuff to turn this back on in this view.
            var freeze_anne_input = ANNE.A.show("freeze_anne_input_"+this.ID);
            freeze_anne_input.addEventListener("input", e=>this.freeze_anne_entered(e));
            freeze_anne_input.setAttribute("uid_pre", this.ID);
            var btn_final_freeze = ANNE.A.hide("final_freeze_"+this.ID);
            btn_final_freeze.addEventListener("click", e=>this.freezeStreampay(e));
            if (this.btn_paystream_projections==null) {
                var newcol  = document.createElement("div");
                newcol.classList = "simple-col fba"; 
                var fzAnnies = document.getElementById("freeze_annies_"+this.ID);
                ANNE.A.appendAfter(fzAnnies, newcol);
                this.btn_paystream_projections = ANNE.A.ezButton(newcol, "btn_paystream_projections", "project ♼ streampay ♼", "dynamic anne-tiny-btn btn-blue-sq btn-maxH hide", 
                        async($e)=>{
                            console.log("project the paystream!");
                            ANNE.A.hide(this.btn_paystream_projections);
                            this.redoLedger(this._freeze_annies);
                        }
                );
            }
        });
    }



    /**
     * 
     * @param {*} $e 
     */
    freeze_anne_entered = async($e)=>{
        var el_freeze_anne_input = $e.target;
        if (el_freeze_anne_input==null) return;
        var el_display = el_freeze_anne_input.getAttribute("el-display");
        if (el_display!=null) el_display = document.getElementById(el_display);

        var amt = 0;
        
        if ($e.data==null) {
            console.log("likely backspace");
        }
        else if ($e.data=="k" || $e.data=="K") {
            var newval = Number.parseFloat(ANNE.A.getValue(el_freeze_anne_input)) * 1000;
            el_freeze_anne_input.value = newval;
        }
        else if ($e.data=="m" || $e.data=="M") {
            var newval = Number.parseFloat(ANNE.A.getValue(el_freeze_anne_input)) * 1000000;
            el_freeze_anne_input.value = newval;
        }
        else if ($e.data=="b" || $e.data=="B") {
            var newval = Number.parseFloat(ANNE.A.getValue(el_freeze_anne_input)) * 1000000000;
            el_freeze_anne_input.value = newval;
        }
        else if ("0123456789.,".indexOf($e.data)==-1) {
            var newval = "";
            for (var a=0; a < amt.length; a++) {
                if ((a!=(amt.length-1)) && "kKmMbB".indexOf(amt[a])!=-1) continue;
                else if ("0123456789.,".indexOf(amt[a])!=-1) continue;
                newval = newval+amt[a];
            }
            el_freeze_anne_input.value = newval;
        }
        
        this._freeze_annies = parseInt(el_freeze_anne_input.value)*100;
        var el_freeze_annies_final= document.getElementById("final_freeze_"+this.ID);

        if (this._freeze_annies>=0) {
            if (this.spf.sp_qt_var==QT_SPECIFIC && this._freeze_annies < parseInt(this.spf.sp_quantity+this.PAYMENT_FEE)) {
                ANNE.A.hide(el_freeze_annies_final);
                ANNE.A.ezAnniesToAnneDisplay("freeze_annies_display_"+this.ID, 0, true);
                ANNE.A.hide(this.btn_paystream_projections);  
                return;
            }

            ANNE.A.show(el_freeze_annies_final);
            ANNE.A.ezAnniesToAnneDisplay("freeze_annies_display_"+this.ID, this._freeze_annies, true);
            ANNE.A.show(this.btn_paystream_projections); 
        }
        else {
            ANNE.A.hide(el_freeze_annies_final);
            ANNE.A.ezAnniesToAnneDisplay("freeze_annies_display_"+this.ID, 0, true); 
            ANNE.A.hide(this.btn_paystream_projections);  
        }
    }
    

    /**
     * @param {*} $e 
     * @returns 
     */
    freezeStreampay=async($e)=>{
        ANNE.A.hideParent("freeze_selfOwned_btn_"+this.ID, true);
        var ghost_rel = await ANNE.GHOSTDATA.makeGhostRelon(TYPE_SYS_MSG, this.nObj, MEM.CMD_FREEZE, TO_TYPE_ANNE, this.nObj.nid, parseInt(this._freeze_annies));
        ghost_rel.freeze = 1;
        await SENDQ.addRelonToSendQ(ghost_rel, true, TXB.TXTYPE_CHILD_RELON);   
        ANNE.playSound("success");
        return await SENDQ.___sendQueue();
    }


    /**
     * Fund this streampay
     * @param {*} $e 
     */
    fundThisStreampay = async($e)=>{
        var paramsObj = new page_params(null, null, null);
        paramsObj.misc = {default_fund_to_nid:this.nObj.nid, annies:this._faucet_recommended,callback:ANNE.PAGES.openPage, callbackParams:["dossier", this.nObj.nid]};
        await PAGES.openPage("send_funds", paramsObj);
    }

     
    /**
     * Validate the streampay is good
     */
    validateAndHandle = async($bREDOBALANCE=true)=>{
        this.spf.recheck(); //redraw values and calc validness.
        
        if (this.spf.bVALID==true) {

            if ($bREDOBALANCE==true) {
                if (this.spf.SOURCE_OF_FUNDS == SRC_OWNER) {

                    //get the balance on the main USER acct.
                    //ANNE.A.empty("doss_balance_"+this.ID); 
                    var ownerNOBJ = MEMG.getNeuronByNid(this.nObj.owned_by);
                    var elb = await this.getBalance(false, "", ownerNOBJ);
                    if (document.getElementById("spbalance_display")!=null) {
                        var sp = document.getElementById("spbalance_display");
                        sp.innerHTML = ownerNOBJ.bestNameHTML();
                    }
                    else {
                        var sp = document.createElement("span");
                        sp.id="spbalance_display";
                        sp.classList = "text-sharpgreen-pad";
                        sp.innerHTML = ownerNOBJ.bestNameHTML();
                        elb.append(sp);
                    }
                   
                }

                else {
                    //get it on the STREAMPAY FUND NEURON
                    if (this.nObj.ghost==false) {
                        ANNE.A.empty("doss_balance_"+this.ID); 
                        await this.getBalance();  
                    }
                }
            }
            
            this.showFundLedger(0);

            if (this.spf._mode=="maker" && this.nObj.ghost==false) {  
                
                //for primary freeze/fund, we need the neuron MAKE cmd to be confirmed and real.
                //the neuron isn't otherwise able to be froze (as it doesn't yet have a legit acct)
                if (this.spf.bFROZE==false && this.btn_fund_and_freeze==null && this.btn_freeze_only==null) {
                    
                    //if this is this.spf.sp_src==MEM.streampay_src_owner.nid..
                    //we should just do a FREEZE button, not fund and freeze.
                    
                    if (this.spf.SOURCE_OF_FUNDS == SRC_OWNER) {
                        if (this.spf.rel_freeze==null) this.activeFreezeOnly();
                    }
                    else {
                        if (this.spf.rel_freeze==null) this.activateFundAndFreeze();
                        
                    }
                    ANNE.A.show(this.el_actions);
                }

                
                //allow for more funding.
                else if (this.bCOMPLETE == true && this.spf.bFROZE==true && this.spf.SOURCE_OF_FUNDS == SRC_FUND) {
                    var fund_col = ANNE.A.ezElPrepend(this.el_actions, "div", "simple-col fba");
                    fund_col.style="text-align:left";
                    this.btn_fund = ANNE.A.ezButton(fund_col, "", "fund streampay more", "anne-tiny-btn btn-purple-sq btn-maxH", e=>this.fundThisStreampay(e));
                    ANNE.A.show(this.el_actions);
                }
                
                //helper.
                if (this.spf.bFROZE==true) {
                    var clone_col = ANNE.A.ezElPrepend(this.el_actions, "div", "simple-col fba");
                    clone_col.style="text-align:left";
                    ANNE.A.ezButton(clone_col, "", "clone this", "anne-tiny-btn btn-blue-sq btn-maxH", e=>this.cloneThisSP(e));
                    ANNE.A.show(this.el_actions);
                }
            }

            //benefactor view
            else {
            }
        }

        //not yet valid.
        else {
            console.log("not yet valid.");
        } 
    }
     
     
    //called when a button click has led to adding new data to this neuron.
    dataAdded = async($new_relon)=> {
        this.validateAndHandle();
    }


    /**
     * 
     * @returns 
     */
    cloneThisSP = async()=> {
        if (this.spf.rel_qt==null) return;
        if (this.spf.rel_quantity==null) return;
        if (this.spf.rel_cycle_frequency==null) return;
        if (this.spf.rel_benefactors==null) return;
    
        var newGhostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.streampay,this.spf.nObj.text+" (clone)");

        await GHOSTDATA.makeGhostRelon(this.spf.rel_qt.type, newGhostNOBJ, this.spf.rel_qt.reln, this.spf.rel_qt.to_type, this.spf.rel_qt.to_s);
        await GHOSTDATA.makeGhostRelon(this.spf.rel_quantity.type, newGhostNOBJ, this.spf.rel_quantity.reln, this.spf.rel_quantity.to_type, this.spf.rel_quantity.to_s);
        await GHOSTDATA.makeGhostRelon(this.spf.rel_cycle_frequency.type, newGhostNOBJ, this.spf.rel_cycle_frequency.reln, this.spf.rel_cycle_frequency.to_type, this.spf.rel_cycle_frequency.to_s);
        
        for(var b=0; b < this.spf.rel_benefactors.length; b++) {
            var rel_ben = this.spf.rel_benefactors[b];
            await GHOSTDATA.makeGhostRelon(rel_ben.type, newGhostNOBJ, rel_ben.reln, rel_ben.to_type, rel_ben.to_s);
        }
    
        if (this.spf.rel_min_start_block!=null && parseInt(this.spf.rel_min_start_block.to_s) > ANNE.HISTORY.getGLKB()) {
            await GHOSTDATA.makeGhostRelon(this.spf.rel_min_start_block.type, newGhostNOBJ, this.spf.rel_min_start_block.reln, this.spf.rel_min_start_block.to_type, this.spf.rel_min_start_block.to_s);
        } 
        if (this.spf.rel_src!=null) {
            await GHOSTDATA.makeGhostRelon(this.spf.rel_src.type, newGhostNOBJ, this.spf.rel_src.reln, this.spf.rel_src.to_type, this.spf.rel_src.to_s);
        }
        if (this.spf.rel_keep_min_balance!=null) {
            await GHOSTDATA.makeGhostRelon(this.spf.rel_keep_min_balance.type, newGhostNOBJ, this.spf.rel_keep_min_balance.reln, this.spf.rel_src.to_type, this.spf.rel_keep_min_balance.to_s);
        }
        if (this.spf.rel_max_payments!=null) {
            await GHOSTDATA.makeGhostRelon(this.spf.rel_max_payments.type, newGhostNOBJ, this.spf.rel_max_payments.reln, this.spf.rel_max_payments.to_type, this.spf.rel_max_payments.to_s);
        }
        if (this.spf.rel_min_streampay_payment!=null) {
            await GHOSTDATA.makeGhostRelon(this.spf.rel_min_streampay_payment.type, newGhostNOBJ, this.rel_min_streampay_payment.reln, this.rel_min_streampay_payment.to_type, this.rel_min_streampay_payment.to_s);
        }

        PAGES.launchNeuron(newGhostNOBJ.nid);
    }


    /**
     * redo the display ledger
     */
    redoLedger = function($extraAnnies) {
        console.log("redo ledger with extra annies");
        if (this.el_empty_notice!=null) {
            ANNE.A.removeSelf(this.el_empty_notice);
            this.el_empty_notice=null;
        }

        if (this._tableObj!=null) {
            this._tableObj.wipeTableEls();
            this._tableObj = null;
        }
        
        //this._tableObj.el_heading_row.parentNode.removeChild(this._tableObj.el_heading_row);
        //this._tableObj.el_tbl_body.parentNode.removeChild(this._tableObj.el_tbl_body);
        //this._tableObj.el_paginator.parentNode.removeChild(this._tableObj.el_paginator);

        this.showFundLedger($extraAnnies);
    }
    


    /**
     * Colorize the block col value blue if it is future.
     * @param {*} $col 
     * @param {*} $record 
     * @param {*} $propVal 
     */
    colorizeProjected = function($col, $record, $propVal) {
        if ($record.projected==true) {
            $col.classList.add("future-data");
        }
        else $col.classList.add("past-data");
        $col.innerHTML = $propVal;
    }


    /**
     * 
     * @param {*} $el 
     * @param {*} $triggers 
     */
    doTriggerSection=function($el, $triggers){    
        this.triggers.sortArrDesc("sys_ref_txid");

        for (var r=0; r < $triggers.length; r++) {
            var rel = $triggers[r];             
            var row = ANNE.A.ezEl($el, "div", "simple-row");            
            var col1 = ANNE.A.ezEl(row, "div", "simple-col "+"tal50");            
            var col2 = ANNE.A.ezEl(row, "div", "simple-col "+"tal50"); 
    
            //$el, $relon, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="", $txtoverride=""
            var lbl = "next trigger";
            if (r>0) lbl = "prev trigger";
            else if (parseInt(rel.sys_ref_txid)<ANNE.HISTORY.getGLKB()) {
                lbl = "prev (last/final) trigger";
                this.spf.bCOMPLETE = true;
                this.el_actions.innerHTML = "This streampay is now complete/closed.";
                this.el_actions.classList.add("status-closed");
                ANNE.A.addRemoveClass("apb_"+this.ID, "complete-border", "freeze-border");
                ANNE.A.show(this.el_actions);

            }
            EXT_BTNS.makeRelonViewLink_SMART(col1, rel, false, 8, true, "", lbl);           
            ANNE.A.ezSpan(col2, "", "", "height <b>"+rel.sys_ref_txid+"</b>");       
        }            
    }
     

    /**
     * Payments come in and go out and are shown in the table.
     */
    showFundLedger = function($extra_annies=0) {
        if (this._tableObj!=null) {
           this._tableObj.wipeTableEls();
        }

        this.nObj.printInsAndOuts();
        var payouts_data = [];
        var fundings = 0;
        var total_in_funds = 0;
        var total_out_funds = 0;
        var last_height = ANNE.HISTORY.getGLKB();
        var not_pending = 0;
        var pending=0;
        var pending_annies=0;
        var highest_observed_h = 0;

        for (var s=0; s < this.nObj.ins.length; s++) {
            var annies_in_rel = this.nObj.ins[s];
            var fromNOBJ = MEMG.getNeuronByNid(annies_in_rel.from_nid);
            var toNOBJ = MEMG.getNeuronByNid(annies_in_rel.to_s);
            var bPENDING = false;
            
            //payments inbound come in annies
            //as long as the neuron is still active.
            if (annies_in_rel.r==MEM.annies.temp_nid) {
                if (annies_in_rel.time==-1) {
                    bPENDING=true;
                    pending+=1;
                    //pending_annies+=parseInt(annies_in_rel.annies);
                }
                else not_pending+=1;
                var bwd = {pending:bPENDING, projected:false, annies:parseInt(annies_in_rel.annies), txid:annies_in_rel.txid, from_nid:fromNOBJ.text, to_s:toNOBJ.text, height:annies_in_rel.time};
               
                if (parseInt(annies_in_rel.time) > highest_observed_h) highest_observed_h = parseInt(annies_in_rel.time);
            } 

            //the payment came from the owned by on a freeze (tho the childRelon pat was used)
            else if (annies_in_rel.r==MEM.CMD_FREEZE.temp_nid) {
                var annies = annies_in_rel.annies;
                if (annies==undefined) annies = 0;

                if (annies_in_rel.time==-1) {
                    pending=true;
                    pending_annies+=parseInt(annies);
                }
                else not_pending+=1;
                fromNOBJ = MEMG.getNeuronByNid(this.nObj.owned_by);
                var bwd = {pending:bPENDING, projected:false, annies:parseInt(annies), txid:annies_in_rel.txid, from_nid:fromNOBJ.text, to_s:toNOBJ.text, height:annies_in_rel.time};
            
                if (parseInt(annies_in_rel.time) > highest_observed_h) highest_observed_h = parseInt(annies_in_rel.time);
            }
            
            //no trigger relons for streampays ?
            //what is this for?
            else if (annies_in_rel.r==MEM.streampay.temp_nid && annies_in_rel.type==TYPE_BRAIN120) {
                this.triggers.addUnique(annies_in_rel, annies_in_rel.txid)
                continue;
            }
            else continue;

            payouts_data.push(bwd);
            fundings+=1;
            total_in_funds+=parseInt(annies_in_rel.annies);
        } 
        
        var others = [];
        if (this.spf.rel_freeze!=null) others.push(this.spf.rel_freeze);
        
        
        if (others.length>0) {
            this.doTheseRelons(this.el_idsbox, others, "", "section-title-center", "tal50", "tal50");
        }

        //in funds are going to be.. uh.. complicated if using IDENTITY NEURON
        var NOBJ = this.nObj;
        if (this.spf.sp_src==MEM.streampay_src_owner.nid) {
            NOBJ = USER._userNObj;
        }

        //hypothetical in.
        if ($extra_annies>0) {
            last_height=last_height+1;  
            var bwd = {projected:false, annies:$extra_annies, txid:"", from_nid:USER._userNObj.text, to_s:this.nObj.text, height:last_height};
            payouts_data.push(bwd);
            fundings+=1;
            total_in_funds+=$extra_annies;
            last_height+=this.spf.sp_frequency; //tx will confirm (hypothetical) so run the projection after
        }

        var annies_out_rels = [];
        
        if (this.spf.sp_src==MEM.streampay_src_owner.nid) {
            if (this.spf.rel_freeze==null) {
            }
            else {
                var ownerNOBJ = MEMG.getNeuronByNid(this.nObj.owned_by);
                annies_out_rels = MEMG.getInternalPaymentsOutWithSYSREFID(ownerNOBJ.outs, this.spf.rel_freeze.txid);
            }
        }
        else {
            annies_out_rels = MEMG.getInternalPayments(this.nObj.outs);
        }
        
        if (annies_out_rels!=undefined && annies_out_rels!=null && annies_out_rels.length>0) {
            annies_out_rels.sort(ANNE.UTILS.sortByTimeASC);
        }
        
        var distros = 0;
        var payback = 0;
        var payment_heights = [];

        if (annies_out_rels.length>0) {
            for (var s=0; s < annies_out_rels.length; s++) {
                var annies_out_rel = annies_out_rels[s];
                console.log("pre sort audit "+annies_out_rel.time);
                var fromNOBJ = MEMG.getNeuronByNid(annies_out_rel.from_nid);
                var toNOBJ = MEMG.getNeuronByTempNid(annies_out_rel.t);
                var bwd = {projected:false, annies:parseInt(annies_out_rel.annies), txid:annies_out_rel.txid, from_nid:fromNOBJ.text, to_s:toNOBJ.text, height:annies_out_rel.time};
                payouts_data.push(bwd);
                if (payment_heights.indexOf(annies_out_rel.time)==-1) {
                    payment_heights.push(annies_out_rel.time);
                }

                //what about funding relon.. (for src-fund types?)  will it come here?
                if (toNOBJ.nid==USER._userNObj.nid && this.spf.sp_benefactors.indexOf(toNOBJ.nid)==-1) {
                    payback = parseInt(annies_out_rel.annies);
                }
                else {
                    distros+=1;
                    total_out_funds+=parseInt(annies_out_rel.annies);
                }

                if (parseInt(annies_out_rel.time) > highest_observed_h) highest_observed_h = parseInt(annies_out_rel.time);
            }
        }

        //need to fix first message after funding (until payment clears)
        //check for pending funding.. (pending=true).. if so, add that value to the balance.

        if (distros==0 && fundings==0 && $extra_annies==0 && NOBJ.balanceObj && parseInt(NOBJ.balanceObj.annies)==0) {
            if (pending>0) {
                this.el_empty_notice = ANNE.A.ezEl(this.el_content, "div", "simple-row text-danger-no-bg-lbl", "Funding/Freeze is pending and projections will display once it is confirmed.");
            }
            else this.el_empty_notice = ANNE.A.ezEl(this.el_content, "div", "simple-row text-danger-no-bg-lbl", "There are no streampayment ledger entries in or out made yet for this fund.");
            return;
        }

        console.log(NOBJ.balanceObj);

        //let's auto do the projections here -- since we have existing funds.
        var balance_annies = 0;
        if (NOBJ.ghost==false && NOBJ.balanceObj) {
            balance_annies = parseInt(NOBJ.balanceObj.annies)+parseInt($extra_annies)+pending_annies;
        }

        //can't project yet.
        if (balance_annies==0 && $extra_annies==0 && NOBJ.ghost==true) {
            return;
        }
        
        //update last_height with the b120 trigger to project the next payments more accurately.
        var next_trigger_height =  0;

        //real triggers..  (last_height is greatest last known height we have on-chain)
        if (this.triggers.arr.length>0) {
            var gtrelh = 0;
            var glkb = ANNE.HISTORY.getGLKB();
            var lowest_height_after_GLKH = 0;
            for (var hh = 0; hh < this.triggers.arr.length; hh++) {
                var trel = this.triggers.arr[hh];
                var trel_h = parseInt(trel.sys_ref_txid);
                if (trel_h > gtrelh) gtrelh = trel_h;
                if (trel_h > glkb) {
                    if (lowest_height_after_GLKH==0) lowest_height_after_GLKH = trel_h;
                    else {
                        if (trel_h < lowest_height_after_GLKH) lowest_height_after_GLKH = trel_h;
                    }
                }
            }

            //we have multiple future triggers in our app, only the lowest future one is NEXT.
            if (lowest_height_after_GLKH>0) {
                last_height = lowest_height_after_GLKH;
            }
            else last_height = gtrelh;

            //must only set the lowest future next trigger to the next trigger height.
            next_trigger_height = last_height;
            
            //another override?
            if(this.spf.sp_min_start_block>0 && this.spf.sp_min_start_block > next_trigger_height) {
                next_trigger_height = this.spf.sp_min_start_block;
                last_height = this.spf.sp_min_start_block;
            }
            if (this.el_brain!=null) ANNE.A.removeSelf(this.el_brain);

            //$el, $trigger, $headingClass="section-title"
            this.el_brain = this.doTriggerSection(this.el_idsbox, this.triggers.arr);
        }

        var CALCNEW_HEIGHT = true;
        var bNOMOREPAYOUTS = false;
        var total_cycles_so_far = this.triggers.arr.length;
        
        if (this.spf.sp_max_payments>0 && total_cycles_so_far>=this.spf.sp_max_payments) {
            bNOMOREPAYOUTS = true;
        }
        
        if (bNOMOREPAYOUTS==false && balance_annies>0 && this.spf.sp_benefactors.length>0) {
            var loops = 0;
            
            if (this.spf.sp_min_start_block>0 && this.spf.sp_min_start_block > last_height) {
                last_height = this.spf.sp_min_start_block;
            }

            while (balance_annies>0) {
                
                if (next_trigger_height==last_height && loops==0) CALCNEW_HEIGHT=false;
        
                var obj = this.spf.project_payment(payouts_data, balance_annies, last_height, CALCNEW_HEIGHT);    
                if (obj.annies==0) {
                    break;
                }
                if (obj.stop!=undefined) {
                    break;
                }
                
                balance_annies = obj.balance; //obj.annies
                
                last_height = obj.last_height;
                loops+=1;
                total_cycles_so_far+=1;

                if (this.spf.sp_max_payments>0 && total_cycles_so_far>=(this.spf.sp_max_payments+1)) {
                    bNOMOREPAYOUTS = true;
                    break;
                }
            }
        }

        
        if (this.spf.SOURCE_OF_FUNDS==SRC_OWNER) {
            total_in_funds = balance_annies;
        }
                                                           
        this.spf.doRecap(fundings, total_in_funds, distros, total_out_funds, payouts_data, $extra_annies, payback, this.triggers.arr.length);

        var tbl_cols = [
            {   neuron_link:false,
                relon_link:false,
                title:"block",
                prop:"height",
                class1:"annid-block-sm",
                classH:"annid-block-H-sm",
                s_prop:"height",
                s_type:"numeric",
                actions_cb:this.colorizeProjected
            },
            {   neuron_link:false,
                relon_link:true,
                title:"txid",
                prop:"txid",
                class1:"annid-txid-sm",
                classH:"annid-txid-H-sm",
            },
            {   neuron_link:false,
                relon_link:false,
                title:"from",
                prop:"from_nid",
                class1:"annid-nid-sm",
                classH:"annid-nid-H-sm",
            },
            {   neuron_link:false,
                relon_link:false,
                title:"receiver",
                prop:"to_s",
                class1:"annid-nid-sm",
                classH:"annid-nid-H-sm",
            },
            {   
                neuron_link:false,
                relon_link:false,
                title:"payout",
                prop:"annies",
                class1:"annid-annecoin-sm",
                classH:"annid-annecoin-H-sm",
                formatter:"ezAnneDisplayApprox"
            }];


        console.log(payouts_data);
        //var testel = document.createElement("div");
        //this.el_content.append(testel);

        var bb = this.el_content.getBoundingClientRect();
        var estimatedTableBodyTop = 86+bb.top;
        
        this._tableObj = new neuron_table(null);
        this._tableObj.YBUF = 72;

        //var estimatedTableBodyTop = 0;
        this._tableObj.setManualCols(tbl_cols, payouts_data);
        var bDOBORDER=false;
        var bDOPAGINATOR=true;
        var ROW_MAX_H=33; //w/ the annies display these rows are bigger.
        this._tableObj.buildDOMTable(this.el_content, estimatedTableBodyTop, null, bDOBORDER, bDOPAGINATOR, ROW_MAX_H);
    }
}