

/**
 * verbish
 */
 class dossier_verbish extends neuron_dossier {
    constructor ($pgui, $secondary=null, $third=null, $misc=null) {
        super($pgui, $secondary, $third, $misc);
        console.log("%c dossier_verbish", TALK.bgredbig);
    }
    initASYNC = async($pguicopy)=>{
        await this.getData(false, this.nObj);
        await this.doHeading(false, []);
        
        if (this.nObj.ntype!=NTYPE_CLASS) {
            console.log("%c dossier_verbish should be for CLASS NEURONS ONLY", TALK.bgredbig);
            return;
        }

        //we should linkify the sentence if this is a class def..
        var talkOBJ = await this.nObj.processActionNeuron(this.all_relons, true, [], this.el_content);
        console.log(talkOBJ);
        if (talkOBJ.poa!=null) ANNE.A.ezEl(this.el_content, "div", "part-of-anne", talkOBJ.poa.text+", "+talkOBJ.tense_lbl);
        ANNE.A.ezEl(this.el_content, "div", "verbish-def-heading", talkOBJ.output);

        for (var r=0; r < this.nObj._roles.length; r++) {
            var role_meaning = this.nObj._roles[r];
            var row = ANNE.A.ezEl(this.el_content, "div", "simple-row");
            var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            EXT_BTNS.makeNeuronLink(col1, role_meaning.reln);
            var elrn = ANNE.A.ezSpan(col2, "", "relneuron");
            EXT_BTNS.makeRelonViewLink_SMART(elrn, role_meaning, false, 8, true);
            EXT_BTNS.makeNeuronLink(elrn, role_meaning.to_s, "dib");
        }

        this.doAltBES(this.el_bes_content);
        //this.doAKA(this.el_bes_content);
        //this.doFKA(this.el_bes_content);

        //TODO, print out meaning here like a dictionary would in infinitive form.
        //jump,  to motate upwardly
        
        //display the existing _meaning_roles  (here they should be dupes of the _roles array)
        if (ANNE.UTILS.isset(this.nObj._meaning_roles)==true) {
            for (var r=0; r < this.nObj._meaning_roles.length; r++){
                ANNE.A.ezRoleDisplay(this.el_content, this.nObj._meaning_roles[r], this.ID);
            }
        }
        
        if (this.nObj.v1!=null) {
            this.doManualNidNoRel(this.el_bes_content, "V1", this.nObj.v1.nid);
        }

        if (this.nObj.v2!=undefined) {
            this.doManualNidNoRel(this.el_bes_content, "V2", this.nObj.v2.nid);
        }

        if (this.nObj.v3!=undefined) {
            this.doManualNidNoRel(this.el_bes_content, "V3", this.nObj.v3.nid);
        }

        if (this.nObj.v4!=undefined) {
            this.doManualNidNoRel(this.el_bes_content, "V4", this.nObj.v4.nid);
        }

        if (this.nObj.v5!=undefined) {
            this.doManualNidNoRel(this.el_bes_content, "V5", this.nObj.v5.nid);
        }


        //show the roles this verb assigns.
        var assignsDiv = ANNE.A.ezEl(this.el_bes_content, "div", "section-title-center", "Assigns Semantic Roles");
        for (var r=0; r < this.nObj._param_roles.length; r++) {
            var role_param = this.nObj._param_roles[r];
            var row = ANNE.A.ezEl(assignsDiv, "div", "simple-row");
            var col1 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            var col2 = ANNE.A.ezEl(row, "div", "simple-col tal50");
            EXT_BTNS.makeNeuronLink(col1, role_param.reln);
            EXT_BTNS.makeRelonViewLink_SMART(col2, role_param, false, 8, true);
            EXT_BTNS.makeNeuronLink(col2, role_param.to_s);
        }

        //do similar?
        //do opposite?
        
        this.doAssociate();
        this.doBRAINSection(this.el_content);  
      
        this.addAwarvu();

        await this.doImgs(this.el_thumbs); //images after the body

        await this.doAnumSection(this.el_content);
        
        this.doAdminRelons(this.el_content);

        ANNE.A.smartScroll("scrollable_"+this.ID, 72);
    }
}