class govenor {
    constructor($nObj) {
        this.target_nObj=$nObj;
        this.dr_restrict_reln_tnids=[];  //delegated params restricts.        
        this.target_ntype = $nObj.ntype;
        this.action=govenor.COLLAB_REQ_NO_COLLAB_RIGHTS;
        this.bBADGARDEN = false;
        this._applied_for_identity_nid = 0;

        //set with respect to the identity in question
        this.bANDY = false;             //can approve collab request
        this.bANDY_SUPER = false;       //can set new admins and approve any type of collab request.
        this.hanai_admin=false;         //can appprove hanai of instances of this neuron.
        
        //tallied for *all* andy admins on this neuron (not just the identity in question)
        this.andy_admins = [];      //an array of objects with .user_nid and .andy_right
        this.hanai_admins = [];     //an array of NIDS

        this._target_reln_temp_nid=-1;
    }

    static COLLAB_REQ_AUTOREJECT = 0;
    static COLLAB_NOCOLLABIDENTITY = 1
    static COLLAB_REQ_NO_COLLAB_RIGHTS = 2;
    static COLLAB_REQ_OK = 4;                //collab request is ok, let it through
    static DELEGATE_NOW = 5;                 //delegation is approved
    static SELF_OWNED = 6; 
    static THIS_IS_YOU = 7;  
    static actionText = [   "No collab", 
                            "No collab on identities", 
                            "No collab rights", 
                            "[xx]", 
                            "You have collab rights", 
                            "You have delegation rights", 
                            "This is your neuron", 
                            "This is your identity"];

    static auditGT() {
        for (var n=0; n < MEM._aNeurons.length; n++) { 
            if (MEM._aNeurons[n]._gt!=null) { 
                var gtNOBJ = MEMG.getNeuronByNid(MEM._aNeurons[n]._gt.t);
                if (ANNE.SETTINGS.debug()==true) console.log(MEM._aNeurons[n].text, "** "+gtNOBJ.text);
            } 
        }
    }

    /**
     * No collab on sys msg, awareness, brain (firing), episodic or experience relons  
     * 
     * @param {int} - relon type of relon we are attempting to collab on
     * 
     * @author {Mr.Scatman}
     */
     static isCollabDimension ($type) {
        if ($type==TYPE_SYS) return true;     //sys dimension
        if ($type==TYPE_BE) return true;      //be dimension
        if ($type==TYPE_PARAM) return true;   //param dimension
        if ($type==TYPE_HAS) return true;     //has dimension
        if ($type==TYPE_ROLE) return true;    //points to a role inside of a clump
        if ($type==TYPE_CLUMP) return true;   //points to various clump types
        return false;
    }
        

    addHanaiAdmin=function($identity) {
        if (this.hanai_admins.indexOf($identity)==-1) {
            this.hanai_admins.push($identity);
        }
    }

    isHanaiAdmin=function($identity) {
        if (this.hanai_admins.indexOf($identity)!==-1) return true;
        return false;
    }
    


    /**
     * Apply the known garden rules to assess for collab and delegation.
     * 
     * The default garden allows for COLLAB requests and presumes  
     * communual requests are ok.

     * Default garden will still honor the PARAM RESTRICTIONS.
     * Default garden will DEFAULT to requiring request reln's to meet PARAM requirements.
     * This enables loose rules on who can attempt to collab but still 
     * narrows the desired relns.
     *
     * Default garden does NOT honor let or deny.  (since there is no gardne)
     * LET or DENY only work w/ specified garden type
     * Default garden DOES NOT allow for delegation.  
     * SET THE GARDEN TO TELL ANNE TO PAY ATTENTION TO DELEGATION and LET/DENY lists.
     *
     * @param {string} - nid long string of the identity we want to analzye this for.$identity_nid
     * @author {Mr.Scatman}
     * 
     */
    applygardenRulesForIdentity=async($identity_nid)=> {
        if (this._applied_for_identity_nid==$identity_nid) return;

        //reset identity specific vars
        this.dr_restrict_reln_tnids=[];
        this.bANDY = false;             
        this.hanai_admin=false;
        this.action = govenor.COLLAB_REQ_NO_COLLAB_RIGHTS;
        
        this._applied_for_identity_nid = $identity_nid;
        if (this.target_nObj.nid==$identity_nid) {
            this.action = govenor.THIS_IS_YOU;
            this.target_nObj.collab_ACTION = this.action;
            return;
        }


//check for them..
//if we've pulled or just created this.. 
//no need to tax the annode API.
//we have to have the 0/1 outs.
//await ANNE.CHASE.lookupMinNid(this.target_nObj.nid);
        
        //EXIT, no collab on identities.
        if (MEM.isIdentity(this.target_nObj)==true) {
            this.action = govenor.COLLAB_NOCOLLABIDENTITY;
            this.target_nObj.collab_ACTION = this.action;
            return;
        }

        
        //this is owned by you.  Fire away.
        if (this.target_nObj.owned_by==$identity_nid) {
            this.action = govenor.SELF_OWNED;
            this.target_nObj.collab_ACTION = this.action;

            //still want to set hanai rights flags to know if
            //the hanai will be auto approved (and properly display that)
            await this.analyzeDelegationRights($identity_nid);
            return;
        }
        

        await this.analyzeDelegationRights($identity_nid);

        //*************AUDITS **************//
        if (this.target_nObj.ntype==NTYPE_CLASS) {
            if (this.target_nObj._gt==null) {
                if (this.target_nObj.bes.length) {
                    var parentNOBJ = MEMG.getNeuronByTempNid(this.target_nObj.bes[0]);
                    if (parentNOBJ._gt!=undefined && parentNOBJ._gt!=null) {
                        //console.log("%cfix this, _gt should have been set on "+this.target_nObj.text, TALK.bgredbig);
                        this.target_nObj.setGtRelon(parentNOBJ._gt);
                    }
                }
            }
        }
        if (this.target_nObj._gti==null) {
            if (this.target_nObj.bes.length) {
                var parentNOBJ = MEMG.getNeuronByTempNid(this.target_nObj.bes[0]);
                if (parentNOBJ._gti!=undefined && parentNOBJ._gti!=null) {
                    //console.log("%cfix this, _gti should have been set on inst "+this.target_nObj.text, TALK.bgredbig);
                    this.target_nObj.setGtiRelon(parentNOBJ._gti);
                }
            }
        }
        //*************AUDITS **************//

        var GT = null;
        if (this.target_ntype==NTYPE_CLASS) GT = this.target_nObj._gt;
        else if (this.target_ntype==NTYPE_INST) GT = this.target_nObj._gti;
        else {
            if (ANNE.SETTINGS.debug()==true) console.log("no ntype on this neuron. Cannot collab/delegate");
            this.action = govenor.COLLAB_REQ_AUTOREJECT;
            this.target_nObj.collab_ACTION = this.action;
            return;
        }


        if (GT==null) {
            //only way to get collab req reject in no-garden type is for the class
            //to have a param restriction and this request doesn't meet it.
            if (ANNE.SETTINGS.debug()==true) console.log("** no garden type ** for ('"+this.target_nObj.text+"') applying defaults.  Collab ok.  Will check params restricts.");
            this.action = govenor.COLLAB_REQ_OK;

            if (this.bANDY==true) this.action = govenor.DELEGATE_NOW;

            this.target_nObj.collab_ACTION = this.action;
            return;
        }


        //Communal garden - Honors owner set delegation to allow collab approvals.  
        //Deny entry will OVERRIDE delegated rights
        //Defaults to BLACKLIST mode for denys (ignores those on the LET list).
        //Anyone can make collab relon requests.
        //Anyone can make keyless children (that they own)
        //gui - Neurons owned by the owner or anyone not in the deny list will be displayed.
        else if (GT.t==MEM.gt_communal.temp_nid) {

            //user has been denied.
            if (this.target_nObj._wv_deny!=null && this.target_nObj._wv_deny.length>0  && this.target_nObj._wv_deny.indexOf($identity_nid)!=-1) {
                this.action = govenor.COLLAB_REQ_AUTOREJECT;
                this.bANDY = false;
                if (ANNE.SETTINGS.debug()==true) console.log("INVALID: garden type communual, user in deny list.");
                this.target_nObj.collab_ACTION = govenor.COLLAB_REQ_AUTOREJECT;
                return;
            }

            else {
                //console.log("garden type communual, user not in deny list.");
                this.action = govenor.COLLAB_REQ_OK;
            }
        }

        
        //Owner collab - Honors owner set delegation to allow collab approvals.
        //Defaults to WHITELIST mode for LETS.
        //Only those listed in LETS can make collab relon request and keyless children (that they own).
        //gui - Only those neurons owned by the owner, or the LETS, will be displayed.
        else if (GT.t==MEM.gt_owner_collab.temp_nid) {

            //no lets, no one gets in.  sorry charley.
            if (this.target_nObj._wv_let==null || this.target_nObj._wv_let.length==0) {
                this.action = govenor.COLLAB_REQ_NO_COLLAB_RIGHTS;
                this.target_nObj.collab_ACTION = govenor.COLLAB_REQ_NO_COLLAB_RIGHTS;
                 if (ANNE.SETTINGS.debug()==true) console.log("INVALID: garden type owner collab, user not in let list.");
            }

            //user is not in let list.  Deny.
            else if (this.target_nObj._wv_let!=null && this.target_nObj._wv_let.length>0 
                && this._wv_let.indexOf(this.target_nObj.identity_nid)==-1) {
                this.action = govenor.COLLAB_REQ_NO_COLLAB_RIGHTS;
                this.target_nObj.collab_ACTION = govenor.COLLAB_REQ_NO_COLLAB_RIGHTS;
                 if (ANNE.SETTINGS.debug()==true)console.log("INVALID: garden type owner collab, user not in let list.");
                return;
            }

            //user is in the let list.. so they have access to collab on this.
            else this.action = govenor.COLLAB_REQ_OK;
        }

        //Owner Only - No delegation, no LET, no DENY, noone can make collab relons,
        //and no one can make keyless children.
        //TO DO, enforce this on keyless children
        //gui - In guis only neurons created by the owner will be queried and displayed.
        else if (GT.t==MEM.gt_owner_only.temp_nid) {
            this.bANDY = false;        //to override any permitted params.
            this.action = govenor.COLLAB_REQ_AUTOREJECT;
            this.target_nObj.collab_ACTION = govenor.COLLAB_REQ_AUTOREJECT;    
        }
        else {
             if (ANNE.SETTINGS.debug()==true)console.log("unhandled garden type");
            this.bBADGARDEN = true;
            this.bANDY=false;
        }
        
        if (this.bANDY==true) {
            this.action = govenor.DELEGATE_NOW;
        }

        
        this.target_nObj.collab_ACTION = this.action;
        return;
    }


    /**
     * analyze delegation for this user considering this neuron class
     * and the DR rights set for it.
     * 
     * Garden type is not considered here.
     */
     analyzeDelegationRights=async($identity_nid)=> {

        //TO DO: check that we have chased 0/1 for both parent and child.
        //if not, chase it.parent_temp_nid

        if (this.target_nObj.delegation==null) this.target_nObj.delegation=[];

        var beline_dg_rights = MEMG.getBELINEDelegation(this.target_nObj);
        //TALK.printRelons(beline_dg_rights);
        
        var target_nid = this.target_nObj.nid;

        //now we have all delegation relons ready to analyze.
        for (var d=0; d < beline_dg_rights.length; d++) {
            var rObj = beline_dg_rights[d];
            var from_nid = rObj.from_nid;

            //we handle permitted dr relns (specific to user + neuron) in a clump syntax.
            //we snag these here tho we won't use them until analyzing a specific
            //relon for collab/delegation.
            if (rObj.type==TYPE_CLUMP) {
                var clumpNOBJ = MEMG.getNeuronByTempNid(rObj.t);
                if (clumpNOBJ==null) continue;
                if (clumpNOBJ.bPROCESSEDCLUMP==undefined) {
                    await clumpNOBJ.processActionNeuron();
                }
                if (clumpNOBJ.validateEquals('role_affected_thing', $identity_nid)==false) continue;
                if (clumpNOBJ.validateEquals('role_thing', rObj.from_nid)==false) continue;
                
                //only our permitted reln needs to use the full clump syntax.
                //the rest are single semantic relon shorthand clumps.  (a->b->c).
                //we use a clump when we need more than a basic subj/predicate/obj syntax.
                if (clumpNOBJ.validateEquals('role_action', MEM.dr_permitted_reln.nid)==false) continue;
                
                //for the permission clump the role_theme_thing will be the relns
                //that are approved for delegation
                var paramNOBJS = clumpNOBJ.extractRoles(MEM.role_theme_thing);

                //dr_restrict_reln_tnids
                for (var p=0; p < paramNOBJS.length; p++) {
                    var param = paramNOBJS[p];
                    if (this.dr_restrict_reln_tnids.indexOf(param.temp_nid)==-1) {
                        this.dr_restrict_reln_tnids.push(param.temp_nid);
                    }
                }
                continue;
            }
                     
            //for non super, the target neuron class must have the same owner
            //as the rights issuer.
            if (rObj.r==MEM.dr_andy_defn.temp_nid) {
                if (from_nid!=target_nid) continue;
                else if (rObj.to_s==$identity_nid) {
                    this.bANDY=true;
                }
                this.andy_admins.push( {andy_right:rObj.r, user_nid:rObj.to_s});
            }
            else if (rObj.r==MEM.dr_andy_super_all.temp_nid) {
                var fromNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (fromNOBJ.owned_by!=this.target_nObj.owned_by) continue;
                else if (rObj.to_s==$identity_nid) {
                    this.bANDY=true;
                    this.bANDY_SUPER=true;
                }
                this.andy_admins.push( {andy_right:rObj.r, user_nid:rObj.to_s});
            }

            //new super super (all rights to the neuron in one go)
            else if (rObj.r==MEM.dr_super_super.temp_nid) {
                var fromNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                this.addHanaiAdmin(rObj.to_s);

                this.andy_admins.push( {andy_right:rObj.r, user_nid:rObj.to_s});
                if (fromNOBJ.owned_by!=this.target_nObj.owned_by) {

                    //if this is a merge, and the neuron is an instance..
                    if (this._target_reln_temp_nid==MEM.CMD_MERGE_NEURON.temp_nid && this.target_nObj.ntype==NTYPE_INST) {
                        //var targetBE = MEMG.getNeuronByTempNid(this.target_nObj.bes[0]);

                        //the super has access to this.
                        if (fromNOBJ.owned_by!=this.target_nObj.owned_by && rObj.to_s==$identity_nid) {
                            this.bANDY=true;
                            this.bANDY_SUPER=true;
                            this.hanai_admin=true;
                        }
                    }
                    else {
                        if (fromNOBJ.owned_by!=this.target_nObj.owned_by && rObj.to_s==$identity_nid) {
                            this.bANDY=true;
                            this.bANDY_SUPER=true;
                            this.hanai_admin=true;
                        }
                    }
                    continue;
                }
                else if (rObj.to_s==$identity_nid) {
                    this.bANDY=true;
                    this.bANDY_SUPER=true;
                    this.hanai_admin=true;
                }
            }

            else if (this.target_ntype==NTYPE_CLASS) {
                //ANDY super class rights DO cascade in the protocol rules.
                //they cascade only to same-owned neurons as the class that granted
                //the rights.
                if (rObj.r==MEM.dr_andy_super_class.temp_nid) {
                    var fromNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                    if (fromNOBJ.owned_by!=this.target_nObj.owned_by) continue;
                    else if (rObj.to_s==$identity_nid) this.bANDY=true;
                    this.andy_admins.push( {andy_right:rObj.r, user_nid:rObj.to_s});
                }
                //for hanai approvals.
                else if (rObj.r==MEM.dr_andy_hanai_in.temp_nid) {
                    this.addHanaiAdmin(rObj.to_s);
                    if (rObj.to_s==$identity_nid) this.hanai_admin=true;
                }
            }
            
            else if (this.target_ntype==NTYPE_INST) {
                if (rObj.r==MEM.dr_andy_super_insts.temp_nid) {
                    var fromNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                    
                    if (fromNOBJ.owned_by!=this.target_nObj.owned_by) continue;
                    else if (rObj.to_s==$identity_nid) {
                        this.bANDY=true;
                    }
                    this.andy_admins.push( {andy_right:rObj.r, user_nid:rObj.to_s});
                }

                //for hanai approvals. (makes no sense for NTYPE_INST)
                else if (rObj.r==MEM.dr_andy_hanai_in.temp_nid) {
                    this.addHanaiAdmin(rObj.to_s);
                    if (rObj.to_s==$identity_nid) this.hanai_admin=true;
                }
            }
        }

        
    }


    /**
     * Quick check for a valid collab response reln
     */
    static isCollabRespReln = function($tnid_action_taken) {
        if (MEM.collabRespRelns.indexOf($tnid_action_taken)==-1) return false;
        return true;
    }


    /**
     * Is this a valid Collab response?
     * 
     * An admin has taken action.  Is the action valid to broadcast to the chain?
     * 
     */
    isValidCollabResponse=async($admin_nid, $tnid_action_taken, $target_reln_temp_nid)=> {
        if (this._applied_for_identity_nid==null) {
            if (ANNE.SETTINGS.debug()==true)    alert("MUST APPLY GARDEN RULES FOR THIS USER, FIRST");
            await this.applygardenRulesForIdentity($admin_nid);
        }

        if (this._applied_for_identity_nid!=$admin_nid) {
            alert("garden set up for a different user.  This should not happen");
            return false;
        }

        //is the action a known collab response action?
        if (govenor.isCollabRespReln($tnid_action_taken)==false) {
            alert("not a valid collab action");
            return false;
        };

        //does this admin have access to delegate on this?
        if (this.action < govenor.DELEGATE_NOW) {
            if (ANNE.SETTINGS.debug()==true)console.log($admin_nid+" has no delegation rights to nid:'"+this.target_nObj.nid+"' "+this.target_nObj.text);
            return false;
        }

        //NOTE: move this to the top of this function once we vet the stuffs above it are working anyhow.
        if (this.action==govenor.SELF_OWNED || $admin_nid==this.target_nObj.owned_by) {
            if (ANNE.SETTINGS.debug()==true) console.log('ur the owner of this.. u can approve collab requests');
            return true;
        }

        if (this.dr_restrict_reln_tnids.length) {  //must be an array of temp_nid values
            var targetRelnNOBJ = MEMG.getNeuronByTempNid($target_reln_temp_nid);
            if (this.dr_restrict_reln_tnids.indexOf($target_reln_temp_nid)==-1) {
                if (ANNE.SETTINGS.debug()==true) console.log($admin_nid+" has delegation rights to nid:'"+this.target_nObj.nid+"' "+this.target_nObj.text+" but NOT to param "+targetRelnNOBJ.text);
                return false;
            }
            else {
                if (ANNE.SETTINGS.debug()==true) console.log($admin_nid+" has delegation rights to nid:'"+this.target_nObj.nid+"' "+this.target_nObj.text+", param "+targetRelnNOBJ.text);
                return true;
            }
        }
        
        if (ANNE.SETTINGS.debug()==true) console.log($admin_nid+" has delegation rights to nid:'"+this.target_nObj.nid+"' "+this.target_nObj.text+", no param restrictions set in the garden");
        return true;
    }


    /**
     * Get the summation of extra garden relns (param restrictions) for neuron
     * up its be line.
     * 
     * @author {Mr.Scatman}
     */
    getEgrsSum = function() {
        var egrs = this.target_nObj.egrs_tnids;
        if (egrs==undefined || egrs==null) egrs=[];
        var gens = 0;
        var parent_temp_nid = this.target_nObj.bes[0];

        //climb the be line and snag all egrs_tnids.
        while (gens++<15) {
            var pNOBJ = MEMG.getNeuronByTempNid(parent_temp_nid);
            if (pNOBJ==null) break;
            if (pNOBJ.egrs_tnids==undefined || pNOBJ.egrs_tnids==null || pNOBJ.egrs_tnids.length==0) continue;
            for (var p=0; p < pNOBJ.egrs_tnids.length; p++) {
                if (egrs.indexOf(pNOBJ.egrs_tnids[p])==-1) egrs.push(pNOBJ.egrs_tnids[p]);
            }
            if (pNOBJ.be_lvl==0) break;
        }
        //console.log(egrs);
        return egrs;
    }


    /**
     * Is this a valid Collab request?
     * 
     * With garden rules applied for this identity, assess if the collab request
     * is valid in consideration of the RELN being used in the collab.
     * 
     * returns a helpful TXB.TXTTYPE for generating the proper ANNE TRANSACTION.
     * 
     * @author {Mr.Scatman}
     * 
     */
    isValidCollabReq=async($identity_nid, $target_reln_temp_nid)=> {
        this._target_reln_temp_nid = $target_reln_temp_nid;
        
        if (this._applied_for_identity_nid==null || this._applied_for_identity_nid==0) {
            await this.applygardenRulesForIdentity($identity_nid);
        }
        if (this._applied_for_identity_nid!=$identity_nid) {
            alert("garden set up for a different user.  This should not happen");
            return 0;
        }

        if (this.action < govenor.COLLAB_REQ_OK) return 0;
        if (this.target_nObj.nid==USER._userNObj.nid) return TXB.TXTYPE_SELF_RELON;

        //move this to the top of this function once we vet the stuffs above it are working anyhow.
        if (this.action==govenor.SELF_OWNED || this.target_nObj.owned_by==$identity_nid) {
            return TXB.TXTYPE_CHILD_RELON;
        }
        if (this.action>=govenor.COLLAB_REQ_OK) {
            //we consider THIS neuron and its parent extra garden relns.
            //we do not inherit these from entire parental line.. that is a big 
            //burden on the ANNODE to validate.. There are ways to build hybrid solutions
            //to handle such graph-like queries at the protocol layer but I opt
            //to NOT go that road.. Garden rules are inherited ONE GENERATION...
            //if a class is sub-classed and that class is sub-classed then the garden
            //rules must be specified again.. (as they may be different anyhow)
            //and another admin may want to set different params.
            var egrs = this.getEgrsSum();

            //are restrictions set to delegating only certain params?
            if (egrs.length) {
                //we have egrs but this isn't one of them.
                if (egrs.indexOf($target_reln_temp_nid)==-1) return 0;
            }
        }

        //check if auto delegation is set for this. 
        //will inform the user ...
        if (this.action==govenor.DELEGATE_NOW) {

            //are there restrictions to what param are delegated?
            if (this.dr_restrict_reln_tnids.length) {
                
                //sorry, not this one.
                if (this.dr_restrict_reln_tnids.indexOf($target_reln_temp_nid)==-1) return TXB.TXTYPE_COLLAB_REQ;

                //good param! delegation possible!
                else return TXB.TXTYPE_COLLAB_REQ_EXP_DEL;
            }

            //delgation allowed, no restrictions on granted delegation rights to this.
            else return TXB.TXTYPE_COLLAB_REQ_EXP_DEL;
        }

        return TXB.TXTYPE_COLLAB_REQ;
    }


    /**
     * 
     */
    printRights=function() {
        for (var h =0; h < this.hanai_admins.length; h++) {
            var nObj = MEMG.getNeuronByNid(this.hanai_admins[h]);
            console.log("%c HANAI RIGHTS:%c"+nObj.bestNameHTML(), ANNE.TALK.bgpink, ANNE.TALK.bgyellow);
        }
        for (var a =0; a < this.andy_admins.length; a++) {
            var nObj = MEMG.getNeuronByNid(this.andy_admins[a].user_nid);
            var rightsNOBJ = MEMG.getNeuronByTempNid(this.andy_admins[a].andy_right);

            console.log("%c ANDY RIGHTS:%c"+rightsNOBJ.text+" %c"+nObj.bestNameHTML(), ANNE.TALK.bgblue, ANNE.TALK.bggreen, ANNE.TALK.bgyellow);
        }

        this.bANDY = false;             //can approve collab request
        this.bANDY_SUPER = false;       //can set new admins and approve any type of collab request.
        this.hanai_admin=false;         //can appprove hanai of instances of this neuron.
        
        console.log("bANDY:"+this.bANDY+" bANDY_SUPER:"+this.bANDY_SUPER+" hanai_admin:"+this.hanai_admin);
    }
}