var HANAI = {};
HANAI.initHanaiView=async()=>{
    var hanais = await CHASE.queryForHanai(USER._userNObj.nid, 0);
    console.log(hanais);
    var el_hb = ANNE.A.__getEl("hanai_box");
    el_hb.innerHTML = "hanais count:"+hanais.length;
}


/**
 * 
 * @param {*} $nObj 
 * @returns 
 */
HANAI.adminTestForMultiHanai=async($nObj)=>{
    var non_anne_tnids = [];
    var missing = [];
    var pending = [];
    var hanai_rels = [];

    var others = ANNE.MEM_UDF.pendingHanaisFor($nObj.owned_by);

    //these are relons.. 
    var other_collab_hanais = ANNE.MEM_UDF.pendingHanaiCollabsFor($nObj.owned_by);

    //this will chase all connected neurons that are not ANNE owned.
    await HANAI.getNonANNE_nObjs(non_anne_tnids, [$nObj]);
    for (var n=0; n < non_anne_tnids.length; n++) {
        var nObj = MEMG.getNeuronByTempNid(non_anne_tnids[n]);
        if (ANNE.isANNE(nObj.owned_by)==true) {
            var pending_hanai_relon = ANNE.HANAI.getPendingHanai(nObj);
            if (pending_hanai_relon==null) missing.push(nObj.text);
            else {
                if (nObj.nid!=$nObj.nid) pending.push("<span style='color:pink; font-weight:bold'>"+nObj.text+"</span>");
                hanai_rels.push(pending_hanai_relon);
            }
        }
    }

    var valid_hanai = false;
    var msg = "";
    var bFORCE_OTHERS  = false;
    if (missing.length>0) {
        valid_hanai = false;
        msg = "You should not approve a hanai for a neuron that connects to non-ANNE neurons that are not also up for hanai.";
        msg = msg+"  This neuron connects to non-ANNE neurons of "+missing.join(", ")+" and cannot be hanai'd.";
    }
    else {
        valid_hanai = true;
        if (pending.length==0) {
            var beNOBJ = MEMG.getNeuronByTempNid($nObj.bes[0]);
            var det = "the ";
            var be_text = "(unknown parent... WHAAAAAT????)";
            if (beNOBJ!=null) {
                be_text = beNOBJ.text;
                var det = TALK.getDet(beNOBJ.text);
                if (det.length>0) det = det+" ";
            }
          
            msg = "This is a basic single hanai request of "+det+"<b>"+be_text+"</b>&nbsp;<span style='color:pink; font-weight:bold'>"+pending+"</span>";
            if (others.length>1) {
                msg = msg + "  There are other hanai requests from this same user that can all be approved at the same time by using the HANAI APPROVE ALL method.";
            }
        }
        else {
            msg = "This hanai requires that <b>"+pending.length+"</b> additional referenced neurons are hanai'd.";
            msg = msg+"<br>The <b>"+(pending.length)+"</b> additional neurons of "+pending.join(", ")+" are also up for Hanai and approving this request will approve them as well.";
            msg = msg+"<br>As an ANDY Admin please ensure **ALL** data is accurate prior to accepting this neuron into the ANNE worldview.";
            if (others.length>1>0) bFORCE_OTHERS=true;
        }
    }
    
    return {msg:msg, others_ch:other_collab_hanais, valid:valid_hanai, missing:missing, pending:pending, hanai_rels:hanai_rels, non_anne:non_anne_tnids, others:others, force_others:bFORCE_OTHERS};
}


/**
 * 
 * @param {*} $nObj 
 */
HANAI.getApproveHanaiCollabImpact=async($nObj)=>{

}

HANAI.getApproveHanaiImpact=async($nObj)=> {

}



/**
 */
HANAI.getHanaiImpact=async($nObj, $bHANAICOLLAB=false)=> {
    var non_anne_tnids = [];
    var bCONNECTED_ONLY=false;
    if (ANNE.isANNE($nObj.owned_by)==true) bCONNECTED_ONLY=true;
    
    var collab_rels = [];

    await HANAI.getNonANNE_nObjs(non_anne_tnids, [$nObj], [], collab_rels);
    var addendum = "";
    var count = 0;
    var bMSGONLY = false;
    if (non_anne_tnids.length) {
        var names_mine = [];
        var names_other = [];
        for (var n=0; n < non_anne_tnids.length; n++) {
            var nObj = MEMG.getNeuronByTempNid(non_anne_tnids[n]);
            if (ANNE.isANNE(nObj.owned_by)==true) {
                non_anne_tnids.splice(n, 1);
                n=n-1;
                continue;
            }

            //not anne, not me.
            else if (ANNE.isANNE(nObj.owned_by)==false && nObj.owned_by!=USER._userNObj.nid) {
                names_other.push("<span style='color:red'>"+nObj.text+"</span>");
            }
            //me
            else if (nObj.owned_by==USER._userNObj.nid) {
                count+=1;
                if (nObj.nid==$nObj.nid) continue;
                names_mine.push("<span style='color:pink; font-weight:bold'>"+nObj.text+"</span>");
            }
        }
        var neurons = ANNE.TALK.pluralizeNounIf2(count, "neuron", "neurons");
        if (names_other.length) {
            addendum = "This neuron <span style='color:red; font-weight:bold'>"+$nObj.text+"</span> connects to neurons neither you nor ANNE own ("+names_other.join(", ")+").  ANNE will not Hanai this neuron.";
            bMSGONLY=true;
        }
        else if (count>1) {
            addendum = "This neuron connects to other neurons you own ("+names_mine.join(", ")+").  ";
            if (bCONNECTED_ONLY==true) addendum = "If you continue you are sending requests to HANAI "+count+" "+neurons+".";
            else addendum = "If you continue to Hanai this neuron you will also be sending a request to HANAI those neurons too!";
        }
    }
    
    var hc = "";
    var hc_rels = "";
    if ($bHANAICOLLAB==true) {
        var content = "Are you sure you want to <b>H&amacr;nai</b> <span style='font-weight:bold; size:1.2rem'>"+count+"</span> "+neurons+" to <b>ANNE</b> so you can collab on the connecting relons?  You will give up ownership rights in exchange for being the sponsor.  You will also be the relon sponsor of the collab relons.  If accepted, the "+neurons+" will become part of <b>ANNE's worldview</b>."
        content=content+"  This will bring wider exposure to the "+neurons+".  As neuron sponsor you will receive <u>all microTX fees</u> generated from neuron references.  You can still make changes through <em>collab</em> requests.";
    }
    else {
        var content = "Are you sure you want to <b>H&amacr;nai</b> <span style='font-weight:bold; size:1.2rem'>"+count+"</span> "+neurons+" to <b>ANNE</b>"+hc+"?  You will give up ownership rights in exchange for being the sponsor.  If accepted, the "+neurons+" will become part of <b>ANNE's worldview</b>."
        content=content+"  This will bring wider exposure to the "+neurons+".  As sponsor you will receive <u>all microTX fees</u> generated from neuron references.  You can still make changes through <em>collab</em> requests.";    
    }
    return {nat:non_anne_tnids, collab_rels:collab_rels, content:content, addendum:addendum, bMSGONLY:bMSGONLY};
}


/**
 * Get pending hanai.
 * We can look for a manual hanai out relon...
 * However, we could also have a collab+hanai relon that doesn't look like a hanai (in 1schema form)
 * It's TX TYPE (not relon TYPE) will tell us it is up for hanai.
 * 
 * NOTE: this doesn't find the collab/hanai type.  ARRRRRG.  :(
 * 
 * @param {*} $nObj 
 * @returns 
 */
HANAI.getPendingHanai=function($nObj){
    var relons = MEMG.getRelonsFromWithTo($nObj.outs, TYPE_SYS_MSG, MEM.hanai_out.temp_nid, MEM.ANNE_ACCTID);
    if (relons==null || relons.length==0) {
        var cRelonTest = ANNE.MEM_UDF.getAndyCollabRel($nObj);
        if (cRelonTest==null) {
            var test = MEMG.getRelonsFromWithTo($nObj.outs, TYPE_SYS, MEM.PENDING_HANAI.temp_nid, "1");
            if (test.length) cRelonTest = test[0];
        }
        if (cRelonTest!=null && cRelonTest.length) {
            //verify the status of the hanai.
            //if we have a sys_ref_txid, it is either approved/declined and not pending.
            if (cRelonTest.sys_ref_txid!=undefined && cRelonTest.sys_ref_txid!=null && cRelonTest.sys_ref_txid.length) return null;
            $nObj.bPENDING_HANAI=true;
            if (Array.isArray(cRelonTest)==true && cRelonTest.length) cRelonTest = cRelonTest[0];
            return cRelonTest;
        }
        return null;
    }

    //verify the status of the hanai.
    //if we have a sys_ref_txid, it is either approved/declined and not pending.
    for (var r=0; r < relons.length; r++) {
        if (relons[r].temp==true) continue;
        if (relons[r].sys_ref_txid!=undefined && relons[r].sys_ref_txid!=null && relons[r].sys_ref_txid.length) continue;
        var nOBJ = MEMG.getNeuronByTempNid(relons[r].f);
        nOBJ.bPENDING_HANAI=true;
        return relons[r];
    }
    return null;
}


/**
 * Pass in list of nObjs extracted from the circuit (a top neuron of some kind)
 * We will populate $tnids, collab_rels and collab_literals
 */
HANAI.getNonANNE_nObjs = async($tnids, $nObjs, $skips=[], $collab_rels=[], $collab_literals=[], $lvl=1)=> {
    var chaser_nids = [];
    var iterateNOBJS = [];
    if (ANNE.SETTINGS.debug()==true) console.log("(getNonANNE_nObjs) **lvl**:"+$lvl+" assessing "+$nObjs.length);

    //probably should move this to a common area..
    //also probably focus on classes we want, not those we don't.
    var no  = [MEM.PDN_PUBLIC_ACCESS.temp_nid, MEM.PDN_VIP.temp_nid, 
            MEM.PDN_BEARER_TOKEN.temp_nid, MEM.specific_d_vote_by_list.temp_nid, MEM.bounty.temp_nid,
            MEM.ASDF.temp_nid, MEM.PDN.temp_nid, MEM.identity.temp_nid];
    
    for (var n=0; n < $nObjs.length; n++) {
        var nObj = $nObjs[n];
        
        //no hanai stuff on these.
        if (no.indexOf(nObj.bes[0])!=-1) continue;
        if (MEM.isIdentity(nObj)==true) continue;

        if ($tnids.indexOf(nObj.temp_nid)==-1 && nObj.owned_by==USER._userNObj.nid) {
            $tnids.push(nObj.temp_nid);
        }
        
        if (nObj.owned_by!=USER._userNObj.nid && ANNE.isANNE(nObj.owned_by)==false) continue;
        //console.log("getNonANNE_nObjs from %c"+nObj.text, TALK.bggreen);

        for (var r=0; r < nObj.outs.length; r++) {
            var rel = nObj.outs[r];

            if (rel.ghost==false) continue;

            //this rel is a literal
            if (rel.to_type!=TO_TYPE_ANNE) {

                //if this is owned by anne and it points to a literal,
                //this is just a basic collab relon.
                if (ANNE.isANNE(nObj.from_nid)==true && $collab_literals.indexOf(rel.txid)==-1) {
                    $collab_literals.push(rel.txid);
                }
                continue;
            }

            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            if (toNOBJ==null) continue;

            //we are not interest to relons to ANNE neurons here.
            if (toNOBJ.owned_by==ANNE_ACCTID) continue;
            else {
                if ($tnids.indexOf(toNOBJ.temp_nid)!=-1) continue;
                if ($skips.indexOf(toNOBJ.nid)!=-1) continue;

                //we are interested in ANNE->ghost here
                if (rel.ghost==true) $collab_rels.push(rel);

                if (toNOBJ.owned_by!=USER._userNObj.nid) {
                    if (chaser_nids.indexOf(toNOBJ.temp_nid)==-1) {
                        continue;
                        //chaser_nids.push(toNOBJ.nid);
                        //iterateNOBJS.push(toNOBJ);
                    }
                }
                else iterateNOBJS.push(toNOBJ);
            }   
        }
    }

    //we have some data to chase/investigate.

    //get all relons for non-anne owned neurons.  We must analyze those too!
    //It may be owned by ANNE if we haven't yet pulled data for this neuron.
    //We need not worry about OUR neurons as we will have already pulled those goodies.
    if (chaser_nids.length) {
        await ANNE.CHASE.lookupNidsGetAllOuts(chaser_nids);
        $skips = $skips.concat(chaser_nids);
    }
    if (iterateNOBJS.length) {
        return await HANAI.getNonANNE_nObjs($tnids, iterateNOBJS, $skips, $collab_rels, $collab_literals, $lvl+1);
    }
}