/**
 * used by extended classes to select existing values.
 * Can search the annode if not found.
 * If still not found, can link to a create new (with relon passed thru)
 */
 class ss_selector extends anne_selectors {
    constructor ($pgui) {
        super($pgui);
        this.validClassTempNids = [];
        if (this.el_save_gneuron_and_relon!=null) {
            this.el_save_gneuron_and_relon.addEventListener("click", e=>this.makeNewGhost(e));  
        }
        this.new_text = "";
    }

    /**
     * Init the smart search gui
     */
    initSmartSearch = async($getTnids, $msg, $newCallback)=>{
        if (this.ntypes.indexOf(NTYPE_INST)!=-1) {
            this.bDOINSTS=true;
            if (this.ntypes.length==1) this.bINSTSONLY=true;
        }
        if (this.classNOBJ==null) {
            console.log("%c error (ss_selector) must have classNOBJ here", TALK.bgred);
            return;
        }
        this.validClassTempNids = await $getTnids();

        //this.classNOBJ.getAllDownlineChildren(this.validClassTempNids, 0, this.bDOINSTS, this.bDONIDSLIST, this.bDOALLBES, this.bINSTSONLY);   
        this._SS = new smart_search("ss_div_"+this.ID, this.ID, this.classNOBJ.temp_nid, this.bSMARTSEARCH, $msg, this.bTESTFORNEWOK);
        this._SS.init_dd_vals(this.validClassTempNids);
        this._SS.onValid = this.validSelection;     //a valid neuron selection the SS has been made
        this._SS.onInValid = this.invalidSelection; //no valid selection in the SS made
        this._SS.newCallback = $newCallback;
        this._SS.setMakeText = "make new "+this.classNOBJ.text;
        
        //yikes
        if (this._SS.el_ss!=null) {
            this._SS.el_ss.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        }
    }

    
    /**
     */
    invalidSelection = async($text, $bINANNE=false)=> {
        if($text.length==0) {
            this.new_text = "";
            this.el_msg.innerHTML="";
            return;
        }
        ANNE.A.hide(this.el_disambig);
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        var badmsg = "<span class='unknown-result'>"+$text+"</span> is an unknown <b>"+this.classNOBJ.text+"</b>";
        if ($bINANNE==true) badmsg + " in ANNE";
        ANNE.A.setHTML(this.el_msg, badmsg);  
        this.new_text = $text;
    }


    //for existing, select existing thing, don't make a ghost.
    validSelection = async($nObj)=> {
        if ($nObj!=undefined && $nObj!=null) {
            this.new_text = $nObj.text;
            this.el_msg.innerHTML = "select action &nbsp;<span class='text-success-lbl'>"+$nObj.text+"</span>";
            this.enter="select";
            $nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID);
            ANNE.A.show(this.el_disambig);
            this.existing_nid = $nObj.nid;
            ANNE.A.show(this.el_make_ghost_relon_btn);
            ANNE.A.hide(this.el_save_gneuron_and_relon);
        }
    }

    returnKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="ghost") {
                alert("test");
                //$this.makeNewGhost($e);
            }
            else if ($this.enter=="select") $this.makeGhostRelon($e);
        }
    }


    /**
     * 
     * @param {*} $e 
     */
    makeGhostRelon = async($e)=> {
        var to_s = this.to_s;
        if (to_s==null) to_s = this.el_input.value;
        var final_reln = this.reln_nid;
        if (this.reln_dynamic!=null) final_reln = this.reln_dynamic;

        var rObj = await GHOSTDATA.makeGhostRelon(this.misc.type, this.fNObj, final_reln, this.to_type, to_s); 

        if (this.success_callback!=null && typeof this.success_callback==="function") {
            this.success_callback(gui_extras, to_s, rObj);
        }
    }
}


class ss_thing_selector extends ss_selector {
    constructor ($pgui) {
        console.log("%c ss_thing_selector", TALK.bgredbig);
        super($pgui);
        console.log($pgui);
        console.log($pgui.pObj);
        console.log($pgui.pObj.misc);
        
        this.ntypes = [];
        
        //selector for thing defaults to instances.
        if ($pgui.pObj.misc && $pgui.pObj.misc.types) this.ntypes = $pgui.pObj.misc.types
        else this.ntypes.push(NTYPE_INST);
    }
}



/**.
 */
class ss_class_person_selector extends ss_selector {
    constructor ($pgui) {
        console.log("%c ss_class_person_selector", TALK.bgredbig);
        super($pgui);
        this.bNODUPEHACK = false; //silly hack fix to not call the event twice.. debug later.
        
        this.ntypes = [];
        this.ntypes.push(NTYPE_INST);
        
        this.paramRelon = $pgui.pObj.misc.paramRelon;//paramRelon


        this.classRELNOBJ = ANNE.MEMG.getNeuronByTempNid(this.paramRelon.r); //ie, "position"
        console.log("class to be the dynamic reln: "+this.classRELNOBJ.nid);
        if (this.classRELNOBJ==null) return;
        
        this.validClassTempNids = [];
        this.classRELNOBJ.getAllDownlineChildren(this.validClassTempNids, 0, false, true, true, false) 
    }


    invalidReln = async()=> {
        console.log("invalid reln");
        ANNE.A.hide(this.el_ss_div);
    }
    
    validReln = async()=> {
        console.log("valid reln");
        this.class_reln_nid = this._SS2.getVal();
        if (this.class_reln_nid!=null) {
            ANNE.A.show(this.el_ss_div);
        }
    }
    
    newRelnNeuron = async()=> {
        console.log("new reln neuron")
        //loadDefaultRelon(Consts.TYPE_BE, pvs.position, ECS.BE_CHILDREN_RELN, ECS.ec_is);
		//loadDefaultRelon(Consts.TYPE_BE, pvs.position, ECS.BE_PARENT, ECS.ec_nonliving); 

        var newValue = this._SS2.getValue();
        
        var parentNOBJ  = MEMG.getNeuronByTempNid(this.classRELNOBJ.functional_childparent_parent);     //non-living
        var childRELN = MEMG.getNeuronByTempNid(this.classRELNOBJ.functional_childparent_reln);         //ec-is
            
        this._newGhost = await GHOSTDATA.makeGhostNeuron(parentNOBJ, newValue, NTYPE_INST, 0);

        //the alt-be (ie, TYPE_BE from new neuorn-> is -> position)
        await GHOSTDATA.makeGhostRelon(TYPE_BE, this._newGhost, childRELN.nid, TO_TYPE_ANNE, this.classRELNOBJ.nid); 

        this.class_reln_nid =  this._newGhost.nid;
        
        if (this.class_reln_nid!=null) {
            ANNE.A.show(this.el_ss_div);
        }
    }
    

    initClassPerAsync=async()=>{
        
        //this.classNOBJ.getAllDownlineChildren(this.validClassTempNids, 0, this.bDOINSTS, this.bDONIDSLIST, this.bDOALLBES, this.bINSTSONLY);   
        this._SS2 = new smart_search("ss_div_class_"+this.ID, this.ID, this.classRELNOBJ.temp_nid, true, "blah", true);
        this._SS2.init_dd_vals(this.validClassTempNids);
        this._SS2.onValid = this.validReln;     //a valid neuron selection the SS has been made
        this._SS2.onInValid = this.invalidReln;
        this._SS2.newCallback = this.newRelnNeuron;
        this._SS2.setMakeText = "make new "+this.classRELNOBJ.text;

        this.placeholder_msg = "type the person's name";
        this.el_ss_div = document.getElementById("ss_div_"+this.ID);
        if (this.misc.default_value!=undefined) {
            await this.initSmartSearch(this.customPersonsTnidsGetter, this.placeholder_msg, this.makeNewPerson);  
            this.placeholder_msg = "find or make <b>"+this.misc.default_value+"</b>";
            ANNE.A.setHTML(this.el_dynamic_msg, "Add <b>"+this.fNObj.text+"</b> "+this.rNObj.text+" <b>"+this.misc.default_value+"</b>");
            var bDISABLEINPUT = true;
            this._SS.triggerSelectOrAutoSearch(this.misc.default_value, bDISABLEINPUT);
            var btxt = '<img class="dib" src="../imgs/ghost_white_ico.png" width="12px" title="make ghost">';
            btxt = btxt+' make new <b>'+this.rNObj.text+'</b> for <b>'+this.fNObj.text+'</b>';
            this._SS.setMakeText=btxt;
        }
        else {
            await  this.initSmartSearch(this.customPersonsTnidsGetter, this.placeholder_msg, this.makeNewPerson);  
            ANNE.A.setHTML(this.el_dynamic_msg, "select a person for <b>"+this.fNObj.text+"</b> <b>"+this.rNObj.text+"</b>");
        }

        ANNE.A.hide(this.el_ss_div);
    }
        

    /**
     * Select an existing value and make a relon with it.
     */
    select_existing_value_handler = async($e)=> {
        $e.stopPropagation();
        $e.preventDefault();
        
        if (this.bNODUPEHACK==true) return; //yah, whatever dude
        
        this.el_make_ghost_relon_btn.removeEventListener("click", this.select_existing_value_handler);
        
        this.bNODUPEHACK=true;
        
        var to_s = this._SS.getVal();

        if(this.class_reln_nid==null) {
            console.log("must have a "+this.classRELNOBJ.text+" reln chosen");
            return;
        }
        

        //this should have just been a gui_extras to begin with..  doh.
        var gui_extras = this.geRetObj();

        if (this.encryption_method!=null) {
            gui_extras.encryption_method  = this.encryption_method;
            if (this.encryption_method==TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY) {
                var annode_uri_relon = MEMG.getRelonFromWith(this.fNObj.outs, TYPE_HAS, MEM.ANNODE_URI.nid);
                if (annode_uri_relon!=null) gui_extras.annode_uri = annode_uri_relon.to_s;
                
                /*** TO DO */
                var annode_uri = gui_extras.annode_uri;
                //make sure we are handshaked with the right annode.
                //each shared key is specific to the annode we handshake with.

                var shared_secretObj = await USER.getSharedSecret();
                if (shared_secretObj.status=="success") {
                    var final_reln = this.class_reln_nid; //from misc.reln_nid
                    if (this.reln_dynamic!=null) final_reln = this.reln_dynamic;
                    var rObj = MEM.makeTempRelon(this.fNObj, this.misc.type, final_reln, this.to_type, to_s, true);
                    var bUDPATERELONWITHENCRYPTION = false;
                    if (this.fNObj.ghost==true) bUDPATERELONWITHENCRYPTION = false;
                    else bUDPATERELONWITHENCRYPTION = true;
                    var encryptionDone = await USER.encryptRelonToWithSS(shared_secretObj.seed, rObj, bUDPATERELONWITHENCRYPTION);
                    if (encryptionDone==false) {
                        this.el_msg.innerHTML="<span class='text-danger-lbl'>**!! ENCRYPTION PROBLEM !!**</span>";
                        ANNE.A.show(this.el_msg);
                        return;
                    } 
                    await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
                    if (this.success_callback!=null && typeof this.success_callback==="function") {
                        this.success_callback(gui_extras, to_s, rObj);
                    }
                }
                else {
                    this.el_msg.innerHTML="<span class='text-danger-lbl'>SHARED KEY PROBLEM W/ THE ANNODE YOU ARE USING</span>";
                    ANNE.A.show(this.el_msg);
                    return;
                }
                return;
            }
        }

        //this should be doing something like  corp instance -> some position reln -> to a person nid.
        var rObj = await GHOSTDATA.makeGhostRelon(this.misc.type, this.fNObj, this.class_reln_nid, this.to_type, to_s);
        this.bDUPESTOPPER=true;
        if (this.success_callback!=null && typeof this.success_callback==="function") {
            this.success_callback(gui_extras, to_s, rObj);
        }
    }


    /**
     * Returns an array of valid persons to select
     * The EXT will not necessarily (or efficiently) hold all person neurons in local mem
     * That's ok, the user can search the ANNODE for the person they are looking for.
     * @returns {array}
     */
    customPersonsTnidsGetter = async()=> {
        var tnids = [];
        for (var i=0; i < MEM.person.ins.length; i++) {
            var rel = MEM.person.ins[i];
            if (rel.type==TYPE_SYS) continue;
            if (rel.to_type!=TO_TYPE_ANNE) continue;
            var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (fromNOBJ==null) continue;
            if (fromNOBJ.ntype!=NTYPE_INST) continue;
            tnids.push(rel.f);
        }
        console.log(tnids);
        return tnids;
    }


    //wire this through to our make person (not just selecting anymore)
    //it will have the needed goodies to make the proper new ghost relon
    //AND return out
    makeNewPerson=async()=>{
        console.log("(ss_person_selector) makeNewPerson");
        var gui_extras = this.geRetObj();
        var ghostObj = await GHOSTDATA.newGhostWithRelon(MEM.person, this.new_text, this.fNObj, this.misc.type, this.misc.reln_nid);
        if (this.success_callback!=null) {
            this.success_callback(gui_extras, ghostObj.nObj.nid, ghostObj.rel);
            return;
        }
        PAGES.launchNeuron(ghostObj.nObj.nid);
        return;
    }
}



/**
 * Select a person
 * If it doesn't exist in local MEM a search ANNE will pop up.
 * If it doesn't exist in the ANNODE a make new will pop up (if possible).
 * That will rewire the page to the appropriate maker page.
 */
 class ss_person_selector extends ss_selector {
    constructor ($pgui) {
        console.log("%c ss_person_selector", TALK.bgredbig);
        console.log($pgui);
        console.log($pgui.pObj);
        console.log($pgui.pObj.misc);
        super($pgui);
        
        this.ntypes = [];
        this.ntypes.push(NTYPE_INST);
        
    }
    initPerAsync=async()=>{
        this.placeholder_msg = "type the person's name";
        this.el_ss_div = document.getElementById("ss_div_"+this.ID);
        
        if (this.misc.default_value!=undefined) {
            await this.initSmartSearch(this.customPersonsTnidsGetter, this.placeholder_msg, this.makeNewPerson);  
            this.placeholder_msg = "find or make <b>"+this.misc.default_value+"</b>";
            ANNE.A.setHTML(this.el_dynamic_msg, "Add <b>"+this.fNObj.text+"</b> "+this.rNObj.text+" <b>"+this.misc.default_value+"</b>");
            var bDISABLEINPUT = true;
            this._SS.triggerSelectOrAutoSearch(this.misc.default_value, bDISABLEINPUT);
            var btxt = '<img class="dib" src="../imgs/ghost_white_ico.png" width="12px" title="make ghost">';
            btxt = btxt+' make new <b>'+this.rNObj.text+'</b> for <b>'+this.fNObj.text+'</b>';
            this._SS.setMakeText=btxt;
        }
        else {
            await  this.initSmartSearch(this.customPersonsTnidsGetter, this.placeholder_msg, this.makeNewPerson);  
            ANNE.A.setHTML(this.el_dynamic_msg, "select a person for <b>"+this.fNObj.text+"</b> <b>"+this.rNObj.text+"</b>");
        }
    }
        

    /**
     * Select an existing value and make a relon with it.
     */
    select_existing_value_handler = async($e)=> {
        if (this.bDUPESTOPPER==true) return;
        
        $e.stopPropagation();
        $e.preventDefault();
        var to_s = this._SS.getVal();

        //this should have just been a gui_extras to begin with..  doh.
        var gui_extras = this.geRetObj();

        if (this.encryption_method!=null) {
            gui_extras.encryption_method  = this.encryption_method;
            if (this.encryption_method==TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY) {
                var annode_uri_relon = MEMG.getRelonFromWith(this.fNObj.outs, TYPE_HAS, MEM.ANNODE_URI.nid);
                if (annode_uri_relon!=null) gui_extras.annode_uri = annode_uri_relon.to_s;
                
                /*** TO DO */
                var annode_uri = gui_extras.annode_uri;
                //make sure we are handshaked with the right annode.
                //each shared key is specific to the annode we handshake with.

                var shared_secretObj = await USER.getSharedSecret();
                if (shared_secretObj.status=="success") {
                    var final_reln = this.reln_nid; //from misc.reln_nid
                    if (this.reln_dynamic!=null) final_reln = this.reln_dynamic;
                    var rObj = MEM.makeTempRelon(this.fNObj, this.misc.type, final_reln, this.to_type, to_s, true);
                    var bUDPATERELONWITHENCRYPTION = false;
                    if (this.fNObj.ghost==true) bUDPATERELONWITHENCRYPTION = false;
                    else bUDPATERELONWITHENCRYPTION = true;
                    var encryptionDone = await USER.encryptRelonToWithSS(shared_secretObj.seed, rObj, bUDPATERELONWITHENCRYPTION);
                    if (encryptionDone==false) {
                        this.el_msg.innerHTML="<span class='text-danger-lbl'>**!! ENCRYPTION PROBLEM !!**</span>";
                        ANNE.A.show(this.el_msg);
                        return;
                    } 
                    await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
                    if (this.success_callback!=null && typeof this.success_callback==="function") {
                        this.success_callback(gui_extras, to_s, rObj);
                    }
                }
                else {
                    this.el_msg.innerHTML="<span class='text-danger-lbl'>SHARED KEY PROBLEM W/ THE ANNODE YOU ARE USING</span>";
                    ANNE.A.show(this.el_msg);
                    return;
                }
                return;
            }
        }
        var final_reln = this.reln_nid; 
        if (this.reln_dynamic!=null) final_reln = this.reln_dynamic;
        var rObj = await GHOSTDATA.makeGhostRelon(this.misc.type, this.fNObj, final_reln, this.to_type, to_s);
        if (this.success_callback!=null && typeof this.success_callback==="function") {
            this.success_callback(gui_extras, to_s, rObj);
        }
    }


    /**
     * Returns an array of valid persons to select
     * The EXT will not necessarily (or efficiently) hold all person neurons in local mem
     * That's ok, the user can search the ANNODE for the person they are looking for.
     * @returns {array}
     */
    customPersonsTnidsGetter = async()=> {
        var tnids = [];
        for (var i=0; i < MEM.person.ins.length; i++) {
            var rel = MEM.person.ins[i];
            if (rel.type==TYPE_SYS) continue;
            if (rel.to_type!=TO_TYPE_ANNE) continue;
            var fromNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (fromNOBJ==null) continue;
            if (fromNOBJ.ntype!=NTYPE_INST) continue;
            tnids.push(rel.f);
        }
        console.log(tnids);
        return tnids;
    }


    //wire this through to our make person (not just selecting anymore)
    //it will have the needed goodies to make the proper new ghost relon
    //AND return out
    makeNewPerson=async()=>{
        console.log("(ss_person_selector) makeNewPerson");
        var gui_extras = this.geRetObj();
        var ghostObj = await GHOSTDATA.newGhostWithRelon(MEM.person, this.new_text, this.fNObj, this.misc.type, this.misc.reln_nid);
        if (this.success_callback!=null) {
            this.success_callback(gui_extras, ghostObj.nObj.nid, ghostObj.rel);
            return;
        }
        PAGES.launchNeuron(ghostObj.nObj.nid);
        return;
    }
}


/**
 * User wants to select OR MAKE A NEW location and we have no parent context
 * on where this location may be located in.
 */
class ss_location_naked_selector extends ss_selector{
    constructor ($pgui) {
        super($pgui);
        console.log("%c ss_location_naked_selector", TALK.bgredbig);
        
        this.altBeNOBJ = MEMG.getNeuronByNid(this.misc.reln_nid);
        this.ntypes = [];
        this.ntypes.push(NTYPE_INST);
        this.defaultLocObj=null;
        this.polity_nid=null;
        this.altBeNID = "";
        this.constituent_of_nObj = null;
        
        //move buttons into search
        var el_loc_btns = ANNE.A.__getEl("loc_btns_"+this.ID);
        var el_naked_ss_holder = ANNE.A.__getEl("ss_naked_holder_"+this.ID);
        el_naked_ss_holder.appendChild(el_loc_btns);//move node
    }

    initLocAsync=async()=>{
        this.placeholder_msg = "Find the existing parent location";
        var msg =  "Select or create the <b>"+this.altBeNOBJ.text+"</b> for <span class='text-success-lbl'>"+this.fNObj.text+"</span>";
        this.bPARSE_LOCATION_TEXT=true;
        await this.initSmartNakedLocationSearch(this.placeholder_msg, null);
        ANNE.A.setHTML(this.el_dynamic_msg, msg);
    }
    

    /**
     * Init the smart naked search gui  (we have no context of parent location)
     * The parent location MUST BE KNOWN to create any location/site/geo etc.
     */
     initSmartNakedLocationSearch = async($msg, $newCallback)=>{
        if (this.ntypes.indexOf(NTYPE_INST)!=-1) {
            this.bDOINSTS=true;
            if (this.ntypes.length==1) this.bINSTSONLY=true;
        }
        if (this.classNOBJ==null) {
            console.log("%c error (ss_selector) must have classNOBJ here", TALK.bgred);
            return;
        }

        ANNE.A.show("ss_loc_naked_context");
        ANNE.A.hide("ss_div_naked_"+this.ID); //ss div in naked mode is for the parent location!
        ANNE.A.removeSelf("ss_div_"+this.ID);
        this.el_loc_type = document.getElementById("loc_type_"+this.ID);
        this.el_loc_type.addEventListener("change", this.typeSelected);

        //name of location
        this.el_the_location = document.getElementById("dynamic_input_"+this.ID);
        this.el_the_location.addEventListener("input",  e=>this.inputNakedLocEventHandler(e));
        this.el_the_location.addEventListener("keyup", e=>this.returnNakedLocKeyPress(e, this));
        this.enter="none";

        this.el_chk_new_btn = document.getElementById("check_new_btn_"+this.ID);
        this.el_chk_new_btn.addEventListener("click", e=>this.testNakedNew(e));
        
        if (this.el_save_gneuron_and_relon!=null) {
            this.el_save_gneuron_and_relon.addEventListener("click", e=>this.makeNewLocationAndRelon(e));  
        }

        this._SS = new smart_search("ss_div_naked_"+this.ID, this.ID, MEM.location.temp_nid, this.bSMARTSEARCH, $msg, false);
        this._SS.init_dd_vals(MEM.location.children);
        this._SS.onValid = this.validParentSelection;     //a valid neuron selection the SS has been made
        this._SS.onInValid = this.invalidParentSelection; //no valid selection in the SS made
        this._SS.newCallback = $newCallback;
        //this._SS.setMakeText = "make new "+this.classNOBJ.text;
        this._SS.searchCallback=this.testNakedNew;
        
        this.ss_div = ANNE.A.hide("ss_div_naked_"+this.ID);
    }

    
    //for name typing
    inputNakedLocEventHandler=async($e)=> {
        ANNE.A.empty(this.el_disambig, true);
        ANNE.A.hide(this.el_save_gneuron_and_relon);
        ANNE.A.hide(this.el_checkbtn);
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        await this.validateNewNakedLoc();
    }  
    

    /**
     */
    returnNakedLocKeyPress = async($e, $this)=> {
        $e.preventDefault();
        if ($e.keyCode === 13) {
            if ($this.enter=="none") return;
            else if ($this.enter=="lookup") {
                $this.testNakedNew($e);
            }
            else if ($this.enter=="submit") $this.makeNew($e);
        }
    }

    //smart search valid selection
    validParentSelection = async($nObj)=> {
        console.log("validParentSelection");
        this.constituent_of_nObj = $nObj;
        this.constituent_of_nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID, true);
        ANNE.A.show(this.el_disambig);
        this.validateNewNakedLoc();
    }
    
    invalidParentSelection = async($val, $bool, $newResults=-1)=> {
        this.constituent_of_nObj = null;
        var  msg = "";
        if ($newResults==0) {
            msg = $val+ " "+" not found";
        }
        await this.validateNewNakedLoc(msg);
    }


    validateNewNakedLoc = async($msg="")=> {
        //set type first.
        ANNE.A.empty(this.el_disambig);
        if (this.altBeNID=="") {
            ANNE.A.hide(this.el_disambig);
            ANNE.A.hide(this.el_checkbtn);
            ANNE.A.hide(this.el_save_gneuron_and_relon);
            //ANNE.A.hide(this.el_the_location);
            ANNE.A.hide(this.ss_div);
            ANNE.A.setHTML(this.el_msg, "select type of location");
            return;
        }

        //next do typing the new name.
        var txt = ANNE.A.getValue(this.el_the_location);
        if (txt.length>0) {
            ANNE.A.setHTML("loc_name_selected_"+this.ID, txt);
            ANNE.A.applyRQD(this.el_the_location, true);

            //consituent of (parent location) is valid
            if (this.constituent_of_nObj!=undefined && this.constituent_of_nObj!=null) {
                this.constituent_of_nObj.disambigHTMLStr(this.el_disambig, false, true);
                ANNE.A.show(this.el_disambig);
                var loc = txt+", "+this.constituent_of_nObj.text;
                ANNE.A.setHTML(this.el_msg, "<span class='text-success-lbl'>"+loc+"</span>");     
                ANNE.A.setHTML(this.el_checkbtn, "search ANNE for <span class='color:#fefe17'>"+loc+"</span>", true);
                this.enter = "lookup"; 
                ANNE.A.show(this.ss_div);
            }
            else {
                ANNE.A.applyRQD(this.el_the_location, false);
                this.constituent_of_nObj = null;
                if ($msg.length==0) $msg = "<span class='text-danger-lbl-invert'>Select a parent location.</span>";
                ANNE.A.setHTML(this.el_msg, $msg, true); 
                ANNE.A.hide(this.el_disambig);
                ANNE.A.hide(this.el_save_gneuron_and_relon);
                ANNE.A.hide(this.el_checkbtn);
                this.enter = "none"; 
                ANNE.A.show(this.ss_div);
            }
        }
        else {
            ANNE.A.hide(this.el_checkbtn);
            ANNE.A.hide(this.el_disambig);
            ANNE.A.hide(this.el_save_gneuron_and_relon);
            ANNE.A.hide(this.ss_div);
            ANNE.A.show(this.el_the_location);
            this.enter= "none";
            ANNE.A.setHTML(this.el_msg, "<span class='text-danger-lbl-invert'>Enter "+this.altBeNOBJ.text+" name</span>"); 
        }
    }


    /**
     */
    testNakedNew = async($e)=> {
        ANNE.A.hide(this.el_checkbtn);
        var name = ANNE.A.getValue(this.el_the_location);
        if (name=="") return;
        if (this.altBeNID=="") return;
        
        this.new_text = name;

        //this is a search to try and find the parent location.
        if (this.constituent_of_nObj==null) {
            this._SS.smartListSearch(null, true); //use default smart search here to feedback results into the SS widget.
            return;
        }
        
        //we need partial matches that are close..
        //to atleast show the user for their selection.
        var lsp = await CHASE.getGlobalLocation(name, this.constituent_of_nObj, this.altBeNID);
        console.log(lsp);
        if (lsp==null) return await this.validNewNakedLocation();

        var matches = lsp.getMatches();
        if (matches.length>0) {
            for (var m=0; m < matches.length; m++) {
                var match = matches[m];
                var nObj = match.nObj;

                //take the first (it was sorted as the highest)
                //RELATIVE is ok here.
                if (nObj.owned_by==USER._userNObj.nid || ANNE.isANNE(nObj.owned_by)==true) return await this.existingLocation(match, lsp.str);
            }
        }

        return await this.validNewNakedLocation();
    }

    /**
     * The matching algo has found an existing location for the search.
     * 
     * @param {loc_search_match} $match 
     * @param {String} $str 
     */
    existingLocation = async($match, $str)=> {
        var nObj = $match.nObj;
        var coNOBJ = this.constituent_of_nObj;
        var msg_class="text-success-lbl";
        var msg_title="This is a direct match";
        var bALLOWNEW=false;
        if ($match.co!=LSM_DIRECT) {
            coNOBJ = MEMG.getNeuronByTempNid($match.co_tnid);
            msg_class="text-danger-lbl";
            msg_title="This is a match but in a nearby location.";
            bALLOWNEW=true;
            this.new_text = $str;   //if they choose to go with a new location.
        }

        ANNE.A.applyRQD(this.el_input, false);
        ANNE.A.setHTML(this.el_msg, "<span class='"+msg_class+"'>"+nObj.text+", "+coNOBJ.text+"</span>"); 
        this.el_msg.title=msg_title;
        ANNE.A.hide(this.el_save_gneuron_and_relon);
        var btn = ANNE.A.show(this.el_make_ghost_relon_btn);
        ANNE.A.setHTML(btn, "select existing "+nObj.text+", "+coNOBJ.text);
        this.to_s = nObj.nid; //key to set this!!!
    
        await this.validNewNakedLocation(false);//still allow for new if the user insists..
    }


    validNewNakedLocation = async($bACTIVATE_ENTER_KEY=true)=> {
        ANNE.A.applyRQD(this.el_input, true);
        var loc = this.el_input.value+", "+this.constituent_of_nObj.text;
        ANNE.A.setHTML(this.el_save_gneuron_and_relon, "make new <em>"+this.altBeNOBJ.text+"</em> "+loc, true);
        if ($bACTIVATE_ENTER_KEY==true) this.enter="submit";
    }

    
    typeSelected=async($e)=>{
        this.altBeNID = ANNE.A.getValue(this.el_loc_type);
        if (this.altBeNID!="") {
            this.altBeNOBJ = MEMG.getNeuronByNid(this.altBeNID);
            if ( this.altBeNOBJ!=null) {
                this.el_the_location.setAttribute("placeholder",  this.altBeNOBJ.text + " name");
                this.el_the_location.focus();

                //not relevant in the naked search!
               // await this.reloadParentLocations();   
            }
        }
        else {
            this.el_the_location.setAttribute("placeholder", "location name");
        }
        await this.validateNewNakedLoc();
    }


    reloadParentLocations=async()=>{
        this.validClassTempNids = await this.customTnidsGetter();
        var bSORTALPHA = true;
        this._SS.redoDD(this.validClassTempNids, bSORTALPHA);
        ANNE.A.show("ss_div_"+this.ID); //ss div in naked mode is for the parent location!
        ANNE.A.show('loc_naked_parent');
    }


    /**
     */
     customTnidsGetter = async()=> {
        var tnids = [];
        for (var i=0; i < MEM.location.ins.length; i++) {
            var rel = MEM.location.ins[i];
            var fromLocNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (MEMG.isAltBeOf(fromLocNOBJ.outs, this.altBeNOBJ.temp_nid)==true) {
                //if yes, get what it is a constiutent of.
                //this is a valid item in our DD
                var co = fromLocNOBJ["be_"+MEM.constituent_of.temp_nid];
                if (co!=undefined && tnids.indexOf(co)==-1) tnids.push(co);
            }
        }
        return tnids;
    }


    /**
     * 
     */
    makeNewLocationAndRelon=async()=>{
        console.log("(makeNewLocationAndRelon)");
        var gui_extras = this.geRetObj();

        //make ghost location with relon from fNobj and appropriate pieces.
        var ghostObj = await GHOSTDATA.newGhostWithRelon(MEM.location, this.new_text, this.fNObj, this.misc.type, this.misc.reln_nid);
        
        var relons_to_ghost = [];
        
        var crel = MEM.makeTempRelon(ghostObj.nObj, TYPE_BE, MEM.constituent_of.nid, TO_TYPE_ANNE, this.constituent_of_nObj.nid, true);
        relons_to_ghost.push(crel);

        //we need the proper reln for this alt_be..
        //that will be stored in the BE_CHILDREN_RELN
        //should be polity, ec_is.. etc.. Whatever this type of location requires
        //for its alt-be heirarchy to work.
        //country, city etc have a TYPE_BE polity reln pointing to the polity (which is the altBe here)
        //something like geo site uses a TYPE_BE IS reln to point to the altBe of geo site.
        var be_children_tnid = this.altBeNOBJ['be_'+MEM.BE_CHILDREN.temp_nid];
        var alt_be_nid = "";
        
        //should be for non polity sites.
        if (be_children_tnid==undefined) {
            alt_be_nid = MEM.ec_is.nid;
            var alt_be_rel = MEM.makeTempRelon(ghostObj.nObj, TYPE_BE, alt_be_nid, TO_TYPE_ANNE, this.altBeNOBJ.nid, true);
            relons_to_ghost.push(alt_be_rel);
        }
        else {
            var altBeChildNOBJ = MEMG.getNeuronByTempNid(be_children_tnid);
            alt_be_nid = altBeChildNOBJ.nid;
            var alt_be_rel = MEM.makeTempRelon(ghostObj.nObj, TYPE_BE, alt_be_nid, TO_TYPE_ANNE, this.altBeNOBJ.nid, true);
            relons_to_ghost.push(alt_be_rel);
        }

        if (relons_to_ghost.length) {
            await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        }

        if (this.success_callback!=null) {
            this.success_callback(gui_extras, ghostObj.nObj.nid, ghostObj.rel);
            return;
        }

        //don't launch the new location, go back to the FROM NEURON here.

        return;
    }    
}


/**
 * Select a location of some alt be (passed in to the selector caller)
 * If it doesn't exist in local MEM a search ANNE will pop up.
 * If it doesn't exist in the ANNODE a make new will pop up (if possible).
 * That will rewire the page to the appropriate maker page.
 */
class ss_location_selector extends ss_selector {
    constructor ($pgui) {
        super($pgui);
        console.log("%c ss_location_selector", TALK.bgredbig);
        
        //hmmm.
        this.altBeNOBJ = MEMG.getNeuronByNid(this.misc.reln_nid);
        
        this.ntypes = [];
        this.ntypes.push(NTYPE_INST);
        
        this.defaultLocObj=null;
        this.polity_nid=null;

        this.required_loc_from_nid = null;
    }

    initLocAsync=async()=>{
        if (this.misc.default_value!=undefined) {

            this.defaultLocObj = new anne_location(this.misc.default_value);
            await defaultLocObj.processFull();

            if (this.defaultLocObj.nObj==null) {
                ANNE.A.setHTML(this.el_dynamic_msg, "Our location parser cannot handle this type of location here.  Sorry. (todo, send issue report)");
                return;
            }

            var loc_temp_nid = this.defaultLocObj.nObj.temp_nid;

            //only get the locations that are constituents of the parent of the lowest location part in the sequence.
            //ie,  dallas, Texas, USA.
            //we don't need any others!
            await this.initSmartLocationSearch(function(){ return loc_temp_nid;}, this.placeholder_msg, this.makeNewLocation);
    
            this.placeholder_msg = "find or make <b>"+this.misc.default_value+"</b>";
            ANNE.A.setHTML(this.el_dynamic_msg, "Add <b>"+this.fNObj.text+"</b> "+this.rNObj.text+" <b>"+this.misc.default_value+"</b>");
            
            var btxt = '<img class="dib" src="../imgs/ghost_white_ico.png" width="12px" title="make ghost">';
            btxt = btxt+' make new <b>'+this.rNObj.text+'</b> for <b>'+this.fNObj.text+'</b>';
            this._SS.setMakeText=btxt;
           
            
            //we need to parse the default location..
            if (this.defaultLocObj.nObj!=null) {
                var bDISABLEINPUT = true;
                var newLoc = this.defaultLocObj.nObj.text;
                await this._SS.triggerSelectOrAutoSearch(newLoc, bDISABLEINPUT);
                var icostring = this.defaultLocObj.printFullIcoString(3);
                ANNE.A.empty(this.el_valid_msg);
                ANNE.A.ezEl(this.el_valid_msg, "div", "dib", icostring);
                
                if (this.defaultLocObj.new==true) {
                    this._SS.hideMakeBtn();
                    var el_polity = ANNE.A.ezEl(this.el_valid_msg.parentNode, "div", "simple-col");
                    
                    //we need polity!
                    var el_dd = ANNE.A.ezDD(el_polity, MEM.polity.children, async($e)=>{
                        this.polity_nid = el_dd.value;
                        console.log(this.polity_nid);
                        if (this.polity_nid!=null && this.polity_nid!="") {
                            this._SS.showMakeBtn();
                        }
                        else this._SS.hideMakeBtn();
                    }, "what is the polity of '"+newLoc+"'?", true, "", false, false);
                }
            }   
        }

        //no default value..
        else {
            this.required_loc_from_nid = this.fNObj.nid;
            console.log("new creation must create with in existing location");
            this.placeholder_msg = "select or create a new "+this.altBeNOBJ.text+" that is within "+this.fNObj.text;
            var msg = "Select or create a new <b>"+this.altBeNOBJ.text+"</b> that is within <b>"+this.fNObj.text+"</b>";
            await this.initSmartLocationSearch(this.customLocationsTnidsGetter, this.placeholder_msg, this.makeNewLocation);
            ANNE.A.setHTML(this.el_dynamic_msg, msg);
        }
    }
    

    /**
     * Init the smart search gui
     */
    initSmartLocationSearch = async($getTnids, $msg, $newCallback)=>{
        if (this.ntypes.indexOf(NTYPE_INST)!=-1) {
            this.bDOINSTS=true;
            if (this.ntypes.length==1) this.bINSTSONLY=true;
        }
        if (this.classNOBJ==null) {
            console.log("%c error (ss_selector) must have classNOBJ here", TALK.bgred);
            return;
        }
        this.validClassTempNids = await $getTnids();
        this._SS = new smart_search("ss_div_"+this.ID, this.ID, this.classNOBJ.temp_nid, this.bSMARTSEARCH, $msg, this.bTESTFORNEWOK);
        this._SS.init_dd_vals(this.validClassTempNids);
        this._SS.onValid = this.validLocationSelection;     //a valid neuron selection the SS has been made
        this._SS.onInValid = this.invalidLocationSelection; //no valid selection in the SS made
        this._SS.newCallback = $newCallback;
        this._SS.setMakeText = "make new "+this.classNOBJ.text;    
    
        ANNE.A.removeParentParent("ss_div_naked_"+this.ID); 
       
        //yikes
        //if (this._SS.el_ss!=null) {
            //this._SS.el_ss.addEventListener("keyup", e=>this.returnKeyPress(e, this));
        //}
    }


    /**
     */
    invalidLocationSelection = async($text, $bINANNE=false)=> {
        if($text.length==0) {
            this.new_text = "";
            this.el_msg.innerHTML="";
            return;
        }
        ANNE.A.hide(this.el_disambig);
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        var badmsg = "<span class='unknown-result'>"+$text+"</span> is an unknown <b>"+this.classNOBJ.text+"</b>";
        if ($bINANNE==true) badmsg + " in ANNE";
        ANNE.A.setHTML(this.el_msg, badmsg);  
        this.new_text = $text;
    }


    //for existing, select existing thing, don't make a ghost.
    validLocationSelection = async($nObj)=> {
        if ($nObj!=undefined && $nObj!=null) {
            this.new_text = $nObj.text;
            this.el_msg.innerHTML = "select action &nbsp;<span class='text-success-lbl'>"+$nObj.text+"</span>";
            this.enter="select";
            $nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID);
            ANNE.A.show(this.el_disambig);
            this.existing_nid = $nObj.nid;
            ANNE.A.show(this.el_make_ghost_relon_btn);
            ANNE.A.hide(this.el_save_gneuron_and_relon);
        }
    }
    

    customLocationsTnidsGetter = async()=> {
        var tnids = [];
        if (this.altBeNOBJ.bes.indexOf(MEM.__ANNE_SYS_CLASS.temp_nid)!=-1) {
            for (var i=0; i < MEM.location.ins.length; i++) {
                var rel = MEM.location.ins[i];
                tnids.push(rel.f);
            }
            console.log(tnids);
            return tnids;
        }
        for (var i=0; i < MEM.location.ins.length; i++) {
            var rel = MEM.location.ins[i];
            var fromLocNOBJ = MEMG.getNeuronByTempNid(rel.f);
            if (fromLocNOBJ.isAltBe(this.altBeNOBJ.temp_nid)==true) {
                tnids.push(rel.f);
            }
        }
        console.log(tnids);
        return tnids;
    }


    //wire this through to our make location (not just selecting anymore)
    //it will have the needed goodies to make the proper new ghost relon
    //AND return out
    makeNewLocation=async()=>{
        console.log("(makeNewLocation) makeNewLocation");
        var gui_extras = this.geRetObj();
        if (this.defaultLocObj!=null) {
            var relons_to_ghost = this.defaultLocObj.getAllOutsForGhosting();  
            if (this.polity_nid!=null) {
                var polrel = MEM.makeTempRelon(this.defaultLocObj.nObj, TYPE_BE, MEM.polity.nid, TO_TYPE_ANNE, this.polity_nid, true);
                relons_to_ghost.push(polrel);
            }
            var passthru_rel = MEM.makeTempRelon(this.fNObj, this.misc.type, this.misc.reln_nid, TO_TYPE_ANNE, this.defaultLocObj.nObj.nid, true);
            relons_to_ghost.push(passthru_rel);
            ANNE.TALK.printRelons(relons_to_ghost); //should see be, name and constituent relon!
            await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
            if (this.success_callback!=null) {
                this.success_callback(gui_extras, this.defaultLocObj.nObj.nid, passthru_rel);
                return;
            }
            
            PAGES.launchNeuron(ghostObj.nObj.nid);
        }


        //for non default mode when creating a new simple location.
        //param button for SITE or GEO SITE (is an example)
        //the alt be will be passed in.
        else {
            var ghostObj = await GHOSTDATA.newGhostWithRelon(MEM.location, this.new_text, this.fNObj, this.misc.type, this.misc.reln_nid);
        
            //we need the proper reln for this alt_be..
            //that will be stored in the BE_CHILDREN_RELN
            //should be polity, ec_is.. etc.. Whatever this type of location requires
            //for its alt-be heirarchy to work.
            //country, city etc have a TYPE_BE polity reln pointing to the polity (which is the altBe here)
            //something like geo site uses a TYPE_BE IS reln to point to the altBe of geo site.
            var be_children_tnid = this.altBeNOBJ['be_'+MEM.BE_CHILDREN.temp_nid];
            var alt_be_nid = "";
            var relons_to_ghost = [];
            
            //should be for non polity sites.
            if (be_children_tnid==undefined) {
                alt_be_nid = MEM.ec_is.nid;
                var alt_be_rel = MEM.makeTempRelon(ghostObj.nObj, TYPE_BE, alt_be_nid, TO_TYPE_ANNE, this.altBeNOBJ.nid, true);
                relons_to_ghost.push(alt_be_rel);
            }
            else {
                var altBeChildNOBJ = MEMG.getNeuronByTempNid(be_children_tnid);
                alt_be_nid = altBeChildNOBJ.nid;
                var alt_be_rel = MEM.makeTempRelon(ghostObj.nObj, TYPE_BE, alt_be_nid, TO_TYPE_ANNE, this.altBeNOBJ.nid, true);
                relons_to_ghost.push(alt_be_rel);
            }
            if (relons_to_ghost.length) {
                await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
            }

            if (this.success_callback!=null) {
                this.success_callback(gui_extras, ghostObj.nObj.nid, ghostObj.rel);
                return;
            }
            
            PAGES.launchNeuron(ghostObj.nObj.nid);
        }
        

        return;
    }
}



/***
 * hasfull - 
 * ANY selection of ANNE NEURON that doesn't have a custom selector class.
 * We have custom selector classes for location, person, date, and a few other
 * classes that we pay special attention to.
 * 
 * We will rewire this class to special handlers if we have them and they come through
 * here.
 */
 class ss_selector_hasfull extends ss_selector {
    constructor($pgui) { 
        super($pgui); 
        console.log("%c ss_selector_hasfull", TALK.bgredbig);
        this.to_type = TO_TYPE_ANNE;
        if (this.encrypted==true) this.to_type = TO_TYPE_ENCR_ANNE;
        else this.to_type = TO_TYPE_ANNE;
        
        //pickers of neurons that show media to allow for picking.
        this._img_picker = null;    
        this._audio_picker = null;      //todo  
        this._video_picker = null;      //todo
        this._fileneuron_picker = null; //todo

        this.bSMARTSEARCH = false;
        this.paramToNObj = null;    //the class we are restricting the select DD to.
        this.ss_tnid = null;
        this.validClassTempNids = [];
        this.bNEWVALUESOK = true;

        if (this.misc.bNEWVALUESOK!=undefined) this.bNEWVALUESOK=this.misc.bNEWVALUESOK;
        
        //This needs to be set!
        if (this.misc.classRestrictNid==undefined) this.misc.classRestricNid=null;

        //TO DO: what we actually want here is a NEURON SEARCH of all neurons..
        //by text..
        if (this.misc.classRestrictNid==MEM.e_anne_id.nid) {
            this.bNEWVALUESOK = false;
            this.paramToNObj = MEMG.getNeuronByNid(this.misc.classRestrictNid);
            this.bSMARTSEARCH = false;

            //all neurons, really? Lolz.. we need a search like lukat here.
            this.ss_tnid = MEM.___SELF___.temp_nid; 
            var msg = "Select an existing neuron ID you have in local memory to encrypt.";
            
            this.validClassTempNids = MEMG.getALLNIDSINLOCALMEM(this.bINSTSONLY);
            this._SS = new smart_search("ss_div_"+this.ID, this.ID, this.ss_tnid, this.bSMARTSEARCH, msg);
            this._SS.init_dd_vals(this.validClassTempNids);
            
            this.bSHOWDISAMBIGNID=true; //always show nid here.
            this._SS.onValid = this.validSelection;
            this._SS.onInValid = this.invalidSelection; 
        }
       
        //we must have a classRestricNid to use this.
        else if (this.misc.classRestrictNid!=null) {
            
            this.paramToNObj = MEMG.getNeuronByNid(this.misc.classRestrictNid);
            console.log(this.paramToNObj.bestNameHTML());
            
            this.bSMARTSEARCH = this.paramToNObj.isSmartSearch();
            this.ss_tnid = this.paramToNObj.temp_nid;  

            var msg = "";
            if (this.paramToNObj.prompt!=undefined) msg = this.paramToNObj.prompt;
            else msg = "Select "+this.paramToNObj.text;
            if (this.bNEWVALUESOK==true) msg = msg +" or make a new one.";
            
            //TODO, these should be from class vars loaded in from .misc obj.
            var bDOINSTS = true;
            var bDONIDSLIST = true;
            var bDOALLBES = true;   //emulated be tree stuff
            
            if (this.rNObj.temp_nid==MEM.inst.temp_nid) bDOINSTS = false;  

            //override for bNEWVALUESOK if the relon reln NOBJ is set to take
            //no new children.
            if (this.rNObj.no_new_children!=undefined && this.rNObj.no_new_children==true) {
                this.bNEWVALUESOK = false;
                this.bSEARCHFORNEWOK = false;
                console.log("%c override NEW VALUES NOT OK, SEARCH FOR NEW NOT OK", TALK.bgred);
            }
            else {
                console.log("%c new values ok:"+this.bNEWVALUESOK, TALK.bggreen);
            }

            var bUSE_makeANNE_SIF = false;

            //we passed in the valid tnids
            if (this.misc.manual_tnids_arr!=undefined) {
                this.validClassTempNids = this.misc.manual_tnids_arr.concat();
            }

            //huge data sets here.., let's use the makeANNE_SIF
            //things, anne_ids, locations, images.. (we could look to the smart search val here. have to lookup what that is. lolz)
            else if (this.misc.classRestrictNid==MEM.ec_thing.nid || this.misc.classRestrictNid==MEM.anne_id.nid 
                || this.misc.classRestrictNid==MEM.location.nid 
                || this.misc.classRetrictNid==MEM.neuronImg.nid
                || this.misc.classRestrictNid==MEM.person.nid 
                || this.misc.classRestrictNid==MEM.company.nid) {
                bUSE_makeANNE_SIF=true;
            }

            //inst only forced override
            else if (this.param_relon!=null && this.param_relon.insts_only!=undefined && this.param_relon.insts_only==true) {
                if (this.misc.child_cdx!=undefined) {
                    this.paramToNObj.getAllDownlineChildren_cdx(this.misc.child_cdx, this.validClassTempNids, 0, true, bDONIDSLIST, bDOALLBES, this.bINSTSONLY);   
                }
                else this.paramToNObj.getAllDownlineChildren(this.validClassTempNids, 0, true, bDONIDSLIST, bDOALLBES, this.bINSTSONLY);   
            }

            //standard.
            else {
                if (this.misc.child_cdx!=undefined) {
                    this.paramToNObj.getAllDownlineChildren_cdx(this.misc.child_cdx, this.validClassTempNids, 0, bDOINSTS, bDONIDSLIST, bDOALLBES, this.bINSTSONLY);   
                }
                else {
                    this.paramToNObj.getAllDownlineChildren(this.validClassTempNids, 0, bDOINSTS, bDONIDSLIST, bDOALLBES, this.bINSTSONLY);   
                }
            }

            //sort by name.
            //console.log(this.validClassTempNids);
            ANNE.UTILS.sortTnidsByAlpha(this.validClassTempNids);

            if (this.misc.img_picker!=undefined && this.misc.img_picker==true) {
                this._img_picker = new img_picker("ss_div_"+this.ID, this.ID, this.validClassTempNids, msg);
                this._img_picker.onValid = this.validImgSelection;
                this._img_picker.onInValid = this.invalidSelection; 
                if (this.validClassTempNids.length) ANNE.A.setHTML(this.el_dynamic_msg, msg);
                else ANNE.A.setHTML(this.el_dynamic_msg, "no valid images to pick");
                this.el_valid_msg.style['text-align']="right";
                this.el_valid_msg.classList.add("f2");
                ANNE.A.setHTML(this.el_make_ghost_relon_btn, "select this img");
            }
            else if (this.misc.img_picker_by_url!=undefined && this.misc.img_picker_by_url==true) {
                console.log("to do");
            }
            else {
                var msg = this.prompt;
                if (msg=="") {
                    var name = this.fNObj.bestNameHTML();
                    msg = "Enter in the&nbsp;<span class='text-success-lbl'>"+this.rNObj.text+"</span>&nbsp;for&nbsp;<em><b>"+name+"</b></em>";    
                }
                ANNE.A.empty(this.el_dynamic_msg);
                ANNE.A.ezSpan(this.el_dynamic_msg, "", "", msg);

                //if thing or generalizd ANNE_ID, use this type of gui widget
                if (bUSE_makeANNE_SIF==true) {
                    var el_sif_input = document.createElement("input");
                    el_sif_input.id = "sif_input_"+this.ID;
                    el_sif_input.setAttribute("size", 40);
                    this.ss_div = ANNE.A.__getEl("ss_div_"+this.ID);
                    this.ss_div.appendChild(el_sif_input);
                    ANNE.A.makeANNE_SIF("sif_input_"+this.ID, this.searchLocalOnlyCallback, this.searchAnnodeCallback, this.selected_cb);
                }


                //if a specific class that is of reasonable size, use this gui widget
                else {
                    this._SS = new smart_search("ss_div_"+this.ID, this.ID, this.ss_tnid, this.bSMARTSEARCH, msg, this.bSEARCHFORNEWOK);
                    this._SS.init_dd_vals(this.validClassTempNids);
                    this._SS.onValid = this.validSelection;
                    this._SS.onInValid = this.invalidSelection;  
                    if (this.paramToNObj!=null) this._SS.applyWvToBeLine = true;
                    ANNE.A.setHTML(this.el_dynamic_msg, msg);
                    if (this.misc.default_value!=undefined) {
                        this._SS.setDefaultValue = this.misc.default_value;
                    }
                }
            }
        }
        else {
            alert("DEPRECATE NON toPARAMNID MODE");
            return;
        }
        this.el_disambig =  document.getElementById('disambig_'+this.ID);
        ANNE.A.hide(this.el_disambig);

        if (this.misc.ghostBtnText!=undefined) {
            this.el_make_ghost_relon_btn.innerHTML = this.misc.ghostBtnText;
        }
    }


    /**
     * Seach ANNE for a string.
     * @param {*} $e 
     */
    searchAnnodeCallback = async($e)=>{
        var val = $e.target.value;
        if (val.length>1) {
            return await CHASE.anne_naked_neuron_search(val);
        }
        return [];
    }

    /**
     * Seach local app for an ajax-like type typing.
     * This is only necessary when the options are not yet populated in the widget.
     * @param {*} $e 
     */
    searchLocalOnlyCallback = async($val)=>{
        if ($val.length>0) {
            return await CHASE.anne_naked_neuron_search($val, true)
        }
        return [];
    }


    invalidSelection = function() {
        ANNE.A.hide(this.el_make_ghost_relon_btn);
        ANNE.A.hide(this.el_disambig);
        ANNE.A.empty("valid_msg_"+this.ID);
        this.to_s = null;
    }

    /**
     * 
     * @param {*} $nObj 
     * @param {*} $btnToClone 
     * @returns 
     */
    validImgSelection = async($nObj, $btnToClone)=> {
        if ($nObj==undefined || $nObj==null) {
            ANNE.A.hide(this.el_make_ghost_relon_btn);
            ANNE.A.hide(this.el_disambig);
            this.to_s = null;
            return;
        }
        this.to_s = $nObj.nid;
        ANNE.A.show(this.el_disambig);
        ANNE.A.empty(this.el_valid_msg);
        //var rel_fp = MEMG.getRelonFromWithRToType($nObj.outs, TYPE_HAS, MEM.fileFingerPrint.temp_nid, TO_TYPE_FILEHASH);
        var url = MEM.__GET_URL_FROM_TNID($nObj.temp_nid);
        ANNE.A.ezSpan(this.el_valid_msg,"",url);
        //ANNE.A.ezSpan(tw,"","filehash","<b>file hash</b> "+rel_fp.to_s);
        //var imgbtn = ANNE.A.cloneAndAppend($btnToClone,this.el_valid_msg,true,true);
        ANNE.A.show(this.el_make_ghost_relon_btn); 
    }


    /**
     * 
     * @param {*} $temp_nid 
     */
     selected_cb = async($temp_nid)=>{
         if ($temp_nid==-1) {
            this.invalidSelection();
            return;
        }
        var nObj = MEMG.getNeuronByTempNid($temp_nid);
       
        if (nObj==undefined || nObj==null) {
            ANNE.A.hide(this.el_make_ghost_relon_btn);
            ANNE.A.hide(this.el_disambig);
            this.to_s = null;
            return;
        }
        if (this.misc.no_dupes!=undefined && this.misc_no_dupes==1){
            alert("TODO: test for dupes, no dupes set.");
        }
        this.to_s = nObj.nid;
        nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID);
        ANNE.A.show(this.el_disambig);
        this.el_valid_msg.innerHTML = "selected <span class='text-success-lbl'>"+nObj.text+"</span>";
        ANNE.A.show(this.el_make_ghost_relon_btn); 
    }

    
    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    validSelection = async($nObj)=> {
        if ($nObj==undefined || $nObj==null) {
            ANNE.A.hide(this.el_make_ghost_relon_btn);
            ANNE.A.hide(this.el_disambig);
            this.to_s = null;
            return;
        }
        if (this.misc.no_dupes!=undefined && this.misc_no_dupes==1){
            alert("TODO: test for dupes, no dupes set.");
        }
        this.to_s = $nObj.nid;
        var disambig_text_only = false;
        if (this.misc.disambig_text_only!=undefined) disambig_text_only=true;
                        
        $nObj.disambigHTMLStr(this.el_disambig, this.bSHOWDISAMBIGNID, false, "", "", disambig_text_only);
        ANNE.A.show(this.el_disambig);
        this.el_valid_msg.innerHTML = "selected <span class='text-success-lbl'>"+$nObj.text+"</span>";
        ANNE.A.show(this.el_make_ghost_relon_btn); 
    }
}



class ss_action_selector extends ss_selector {
    constructor ($pgui) {
        console.log("%c ss_action_selector", TALK.bgredbig);
        var ntypes = [NTYPE_CLASS];
        var bDONIDSLIST = true;
        var bDOALLBES = false;
        var bTESTFORNEWOK = false;
        var bSMARTSEARCH = false;
        var msg = "type the PRESENT TENSE action";
        super($pgui, ntypes, bDONIDSLIST, bDOALLBES, bTESTFORNEWOK, bSMARTSEARCH, msg);
    }
}

