
const PATHTYPE_ANNE = 1;
const PATHTYPE_UDF = 2;

const RENDERTYPE_BASE = 1;
const RENDERTYPE_STANDARD = 2; 
const RENDERTYPE_FLOATER = 3;
const RENDERTYPE_TAB = 4;
const RENDERTYPE_MODAL = 5; 
const RENDERTYPE_INJECT = 6;

class page_template {

    //too many params to pass.. will do it this way.
    constructor ($obj) {

        //not defined in any relons/neurons.. set by the class itself.
        this._pguis = [];
        this.bISOPEN = false; 
        this.callback_open = null;  
        this.callback_close = null;
        
        this.invisibleTab = false;

        //these will be set run-time when a page is called.
        //they are only relevant for "refreshes" of the page where we need the
        //original calling params.
        this.pObj = null; 

        this.nid = "";  //the neuron aid of this page. :)

        //a ptr to an instance of the javascript anne_service class
        //services are loaded on bootup and they will create their respective pages.
        //when they do, they will set this _svc pointer so the GUI page has access
        //to the service object in its init.
        this._svc = null;


        //if this is a tabber, these are the pages you want to render in the tabber when you open
        //it run-time.
        this.tab_pages = [];
        this.tab_title_overrides = [];

        this.action = "hide";
        this.active = true;
        this.activate_close_div = false; //specifically place ur own close button
        this.never_inject_close = false; //never inject the auto button.
        this.content = "";
        this.display = "";
        this.ico = null;
        this.makelink = false;      //if set, when we "makeLinks" this will be a link.

        //allow multiple copies of this open at once
        //typically with floater=true
        this.multiples = false;         
        this.divid = "";           

        this.injection_div = "";
        this.scrollclass = "";
        
        //if a spacevar is provided.
        this.spacevar = "";
        this.linkid = "";

        //if you load the .js code in a FILE, you DO NOT WANT TO DESTROY THE SPACEVAR
        //if it is a multiple=true
        //since you will not have it around anymore!
        //also, you do not want to destroy the spacevar if you PRE-LOADED your
        //js object in an include/import/script tag in the main app.
        this.destroy_spacevar=false; 
        this.cheapEvents = [];
        this.encrypted = false;

        //"anne" = the content file is located in js/gui folder
        //"udf" = the content file is located in the app root _udf/ folder
        this.path_type = PATHTYPE_UDF;                
     
        //standard (normal)
        //tab      (a tab put in a tabset and tabcontent)
        //floater  (draggable around the screen)
        //base     the home/landing page of the app which started AND REMAINS in the DOM at all times
        this.render_type = RENDERTYPE_STANDARD;
        

        this.path = "";
        this.get_gui_id_callback=null;  //sneaky
        this.autoCloseHangers = false;  

        this.bTOGGLEOK = true;
        this.instantiate = false;
        this.thisINST = null;

        //will be set by the page if the page requires a specific to nid restriction.
        //see selector_tense
        this.classRestrictNid = null;  
        this.searchFornewOK = true;
        
        //populate obj with passed in params.
        var props = Object.keys($obj);
        for (var p = 0; p < props.length; p++) {
            this[props[p]]=$obj[props[p]];
        }

        if (this.activate_close_div==true) {
            this.never_inject_close = true;
        }

        //fixes/checks
        if (this.path_type==PATHTYPE_ANNE) {
            this.path = ANNE.___root+'/js/gui/pages/';
        }
        else {
            this.path = ANNE.___root_local_app+'/js/gui/pages/';
        }

        //auto set the link id to the divid + "_link"
        if (this.divid!="" && this.linkid=="") this.linkid = this.divid+"_link";
    }
        

    /**
    * These are like instances of page_template instances, but not.  They
    * are their own insts and they reference the page template inst.
    */
    add_page_gui = function ($pObj) {
        var pgui = new page_gui(this, $pObj);
        if (this.multiples==false && this.instantiate==false) {
            this._pguis.push(pgui);
            return {pgui:pgui, new:true};
        }

        //for multiples we accept the passed in guid (and test it)
        //or we use the generating function and make one.
        //this is crucial to a uniqueid which is crucial to allowing
        //multiple templates used throughout the site (at the same time)
        //with DOM ids that become unique but still referenceable in dynamic code.
        var testguid = "";
        if (pgui.guid!="") testguid = pgui._guid;
        else {
            if ($pObj!=null && $pObj.randSeed!=undefined) {
                testguid = this._gen_gui(pgui.pObj.p1+$pObj.randSeed);
            }
            else testguid = this._gen_gui(pgui.pObj.p1, pgui.pObj.p2);
        }
        
        //pass through any injection div in the parameters to
        //the pgui .injection_div.  This takes precedence over the default
        //page template injection div.
        if (pgui.pObj.injection_div!=undefined) {
            pgui.injection_div=pgui.pObj.injection_div;
        }

        var existingpgui = this._getPgui(testguid);
        if (existingpgui==null) {
            pgui.guid = testguid;
            pgui.pObj.guid = testguid;
            this._pguis.push(pgui);
            return {pgui:pgui, new:true};
        }

        else {

            //this flag is set in the page and tells the ANNE.PAGES that upon dupes
            //we will auto kill the old one and make a new one.
            //If not set, we try to pull up that tab/page wherever it is.
            if (existingpgui.page.autoCloseHangers!=undefined && existingpgui.page.autoCloseHangers==true) {
                existingpgui.close();
                pgui.guid = testguid;
                pgui.pObj.guid = testguid;
                this._pguis.push(pgui);
                return {pgui:pgui, new:true};
            }
            return {pgui:pgui, new:false};
        }
    }


    /**
     * This is typically a hashing function provided by the page.  It
     * ensures the multiples are unique.  (generating a unique guid)
     * This can then be referenced elsewhere.
     */
    _gen_gui = function ($p1=null, $p2=null) {
        if ($p1!=null && this.get_gui_id_callback!=null) {
            return this.get_gui_id_callback($p1);
        }
        else if ($p2!=null && this.get_gui_id_callback!=null) {
            return this.get_gui_id_callback($p1);
        }
        return ANNE.UTILS.randHex(8);
    }


    add_tab_page=function($tab3) {
        if ($tab3.render_type!=RENDERTYPE_TAB) {
            console.warn("fix your renderttype to tab in your code!!");
            $tab3.render_type=RENDERTYPE_TAB;
        }
        this.tab_pages.push($tab3);
    }


    _is_unique = function ($guid) {
        for (var g=0; g < this._pguis.length; g++) {
            if (this._pguis[g]._guid==$guid) return false;
        }
        return true;
    }

    
    _getPgui = function ($guid) {
        for (var g=0; g < this._pguis.length; g++) {
            if (this._pguis[g]._guid==$guid) return this._pguis[g];
        }
        return null;
    }

    /**
     * close the pgui -- and set the template to bOPEN=false if there are
     * no more pguis open using it.
     */
    get_pgui_and_remove_from_tracker = function ($guid="") {
        if (this._pguis.length==1) {
            this.bISOPEN = false;
            this._pguis[0].bISOPEN = false;
            var pgui = this._pguis[0];
            this._pguis = [];
            return pgui;
        }
        else {

            //splice out the pgui that is open..
            //leave the pTemplate bISOPEN=true since we still have one of them open.
            for (var g=0; g < this._pguis.length; g++) {
                if (this._pguis[g]._guid==$guid) {
                    var pgui = this._pguis[g];
                    pgui.bISOPEN=false;
                    this._pguis.splice(g,1);
                    return pgui;
                }
            }
        }
        return null;
    }


    show_all_open_pguis = function() {
        if (this.divid=="") return;
        if (this.multiples==false) ANNE.A.fadeIn(this.divid);
        else {
            if (this.guid=="") return;
            for (var g=0; g < this._pguis.length; g++) {
                var pgui = this._pguis[g];
                if (pgui.bISOPEN==true) {
                    ANNE.A.fadeIn(this.divid+"_"+this.guid);
                }
            }
        }
    }
}