

const REVPT_UNASSIGNED = 999;
const REVPT_NETWORK_BASE = 1;
const REVPT_NEURON = 2;                     //an assigned NEURON
const REVPT_NEURON_MATCH = 3;               //a non NETWORK BASE that is in both/all newtorks.
const REVPT_PATICLE_MATCH_PATH = 6;               //a non NETWORK BASE that is in both/all newtorks.
const REVPT_PARTICLE_ONLY = 15; 

class rev_network{
    constructor($nObj, $color, $i) {
        this.nObj = $nObj;
        this.tnid = $nObj.temp_nid;
        this.nid = $nObj.nid;
        this.color = $color;
        this.i = $i;
        this.mesh = null;                   //will be the newtork/attractor for this thing.
        this.tnids = [$nObj.temp_nid];      //track what tnids are tied to this network.
        this.max_lvl = 0;
        
        //actual e vs max allowed for this network.
        this.e_particles = 0;
        this.MAX_E = 10000;
        this.buzzes=0;
    }

    addToNetwork($nObj) {
        if (this.tnids.indexOf($nObj.temp_nid)==-1) {
            this.tnids.push($nObj.temp_nid);
        }
    }
}

//every unique neuron in the REVELATIAN is a rev_point.
//rev points can be assigned to multiple f_origs (attractors)
//their weight to that attractor determines their behavior.
class rev_point {
    constructor($index) {
        this.pt = null;                     //the actual position vector3
        this.i=$index;                      //the index in the pts array
        this.type = REVPT_UNASSIGNED;       //the type of pt
        this.mass=1;                        //mass of this pt
        this.lvl_offsets = [];               //lvl offset is the lvl in the network.  index of the network is used. 
        this.tnid=-1;                       //tnid of this pt, if assigned
        this.tc=0;                          //too close marker to its attractor
        this.cssobj=null;                   //cssgui object for display

        this.queried_outs = false;          //flag to indicate we queried this thing's outs in ANNE
        this.process_outs_net_i = [];       //index set for network to indicate we have processed the outs.
        this.out_rels = null;               //the valid out rels we are interested in

        this.queried_ins = false;           //flag to indicate we queried this thing's ins in ANNE
        this.processed_ins = false;         //flat to indicate we have processed the ins.
        this.in_rels = null;                //the valid in rels we are interested in 
        
        //for neuron pts NOT particles.
        this.f_origs = null;                //the different temp_nids this neuron is connected FROM (it was the TO in the reln)
        
        //for particles only.
        this.next_attr = null;              //used for particles traversing.
   
        this.buzzticks = 0;

        this.n_i = -1;
    }


	/**
	 */
	getLowestLvl = function() {
		var lowest = 99;
		for (var v=0; v < this.lvl_offsets.length; v++) {
			if (this.lvl_offsets[v]<lowest) lowest = this.lvl_offsets[v];
		}
		return lowest;
	}
	
	
    /**
     * For button clicks when blasting out more particles to a specific
     * network.. we start them at home base.
     * @returns 
     */
    getRandNextPt=function($REV) {
        if (this.out_rels.arr.length==0) return null;
        var rand_rel_r = Math.floor(Math.random()*this.out_rels.arr.length);
        var tnid = this.out_rels.arr[rand_rel_r].rel.t;
        return $REV.pts.get2(tnid);
    }


	//we don't want a tnid already on our current path..
	//we don't want a tnid of the origin pt ( index 0 of avoidTnids)
	//we don't want a tnid we've tried and don't like and added ot avoidTnids (for any other reason)
	//if we can't get a rand path fitting these requirements, give up, send the pt home.
	//hope for better results next time it goes around.
    getRandToTnid=function($PT, $tries=0) {
        if (this.out_rels.arr.length==0) return null;
        if ($tries>3) return null;
        var rand_rel_r = Math.floor(Math.random()*this.out_rels.arr.length);
        var tnid = this.out_rels.arr[rand_rel_r].rel.t;
		if ($PT.avoidTnids==undefined) {
			console.log("what particle is this???");
			console.log($PT);
			$PT.avoidTnids=[$PT.p_origin.tnid];
			return null;
		}
        if ($PT.avoidTnids.indexOf(tnid)!=-1 
            || ($PT.pt_path!=undefined && $PT.pt_path.indexOf(tnid)!=-1)) {
            //this.out_rels.arr[rand_rel_r].avoid=true;
            //this.out_rels.arr.remove("rid", this.out_rels.arr[rand_rel_r].rel.rid);
			$tries+=1;
            return this.getRandToTnid($PT, $tries);
        }
        return tnid;
    }


    /**
     * particle takes a random fork in the road. 
     * This is for the non-neuron particles ($PT) that documented the neuron connections.
     * We're setting the next step of the path the $PT will take.
     */
    setRandNextATTR=function($REV, $PT) {
        //these pathways have proven to be false and we don't want to travel them again.
        var tnid = this.getRandToTnid($PT);
        if (tnid==null) {

            $PT.next_attr = $PT.p_origin;  //send home, we can't get a valid pt.
            if ($PT.pt_path!=undefined) {
                $PT.pt_path =[$PT.p_origin];
            }
            return;
        }

        $PT.next_attr = $REV.pts.get2(tnid);

        if ($PT.pt_path!=undefined) {
            $PT.pt_path.push($PT.next_attr);
            if ($PT.next_attr.type>REVPT_PATICLE_MATCH_PATH) {
                console.warn("TROUBLE");
                $PT.next_attr = null;
            }
        }
    }


    /**
     * 
     * @param {*} $rel 
     * @returns 
     */
    addOutRel = function($rel) {
        if (this.out_rels==null) this.out_rels = new arraymap();
        this.out_rels.setMapKey("rid");
        if ($rel.f!=this.tnid) {
            console.log("this should not be added here.");
            return;
        }
        this.out_rels.addU({rid:$rel.rid, rel:$rel});
    }
    
    addInRel = function($REV, $network, $rel, $lvl=1) {
        if (this.in_rels==null) this.in_rels = new arraymap();
        this.in_rels.setMapKey("txid");
        this.in_rels.addU($rel);

        if (this.f_origs==null) {
            this.f_origs= new arraymap();
            this.f_origs.setMapKey("f");
        }

        var fpt = $REV.pts.get2($rel.f); //the tnid array.

        //an arraymap of tnid and hits.
        var forig = this.f_origs.get($rel.f);
        if (forig!=null) {
            forig.hits+=1;
        }
        else {
            forig = {f:$rel.f, pt:fpt, hits:1}
            this.f_origs.addU(forig);
        }

        if ($REV.e_particles > $REV.MAX_E) {
            return;
        }

        if ($network.e_particles > $network.MAX_E) {
            return;
        }
        
        var cnt = 0;
        if ($lvl==1) cnt=200;
        else if ($lvl==2) cnt=9;
        else if ($lvl==3) cnt=3;
        else cnt = 0;

        //place them at fpt, send them to this pt.
        if (cnt>0) $REV.addParticlesOnly($network, cnt, fpt, this);
    }
}


/**
 * 
 */
class rev_tuner {
    constructor($maxdepth=7) {
        this.MAX_DEPTH = $maxdepth;
        this.search = new Object();
        this.match = new Object();
        this.match_weights = new Object();
        this.search["queryForOutsAndInsFroms"] = new Object();
        this.search["queryForOutsFroms_not"] = new Object();
        this.match[NTYPE_CLASS] = new Object();
        this.match[NTYPE_INST] = new Object();
        this.match_weights[NTYPE_CLASS] = new Object();
        this.match_weights[NTYPE_INST] = new Object();

        for (var depth=0; depth < 7; depth++) {
            this.match[NTYPE_CLASS]["d"+depth] = [];
            this.match[NTYPE_INST]["d"+depth] = [];
            this.match_weights[NTYPE_CLASS]["d"+depth] = [];
            this.match_weights[NTYPE_INST]["d"+depth] = [];

			this.search["queryForOutsAndInsFroms"]["d"+depth] = [];
            this.search["queryForOutsFroms_not"]["d"+depth] = [];
        }
    }  

    doDefaults=function() {

        //turn off matches for classes greater than depth 1.
        this.setMatch(NTYPE_CLASS, "off", "gt", 1, -1);

        //turn off search (queries of ANNE) for outs/ins query greater than depth 3
        //this is done for instances.  (and we will have ALOT of them as depths increase)
        //this.setSearch("queryForOutsAndInsFroms", "off", "gt", 3, -1);

        //turn off search (queries of ANNE) for outs query greater than depth 2
        //this is done for "classes"
        //this.setSearch("queryForOutsFroms_not", "off", "gt", 2, -1);

        //we're not chasing location stuff.
        //this.setSearch("queryForOutsAndInsFroms", "off", "gt", 1, ANNE.MEM.location);
        //this.setSearch("queryForOutsFroms_not", "off", "gt", 1, ANNE.MEM.location);
    }


    setMatch = function($ntype, $RTONOFF="off", $op="gt", $d, $isNOBJTest) {
        if ($op=="gt") {
            for (var d=$d+1; d < this.MAX_DEPTH; d++) {
                this.match[$ntype]["d"+d][$RTONOFF]=$isNOBJTest;
            }
        }
        else if ($op=="lt") {
            for (var d=$d-1; d >=0; d--) {
                this.match[$ntype]["d"+d][$RTONOFF]=$isNOBJTest;
            }
        }
    }

    setSearch = function($funct, $RTONOFF="off", $op="gt", $d, $isNOBJTest) {
        if ($op=="gt") {
            for (var d=$d+1; d < this.MAX_DEPTH; d++) {
                this.search[$funct]["d"+d][$RTONOFF]=$isNOBJTest;
            }
        }
        else if ($op=="lt") {
            for (var d=$d-1; d >=0; d--) {
                this.search[$funct]["d"+d][$RTONOFF]=$isNOBJTest;
            }
        }
    }

    
    //deault is matchable.
    //if we match a rule, it is exclusionary.
    matchableIsOff = function($ntype, $depth, $nObjMatch) {
        var matchdepth = this.match[$ntype]["d"+$depth];
        if (matchdepth==undefined) return false;
        if (matchdepth && matchdepth["off"]!=undefined) {
            //if -1, it is off for all classes
            if (matchdepth["off"]==-1) {
                //console.log("matches for $ntype:"+$ntype+" at depth:"+$depth+" for "+$nObjMatch.text+" are turned OFF");
                return true;
            }

            //if not -1 (and not undefined) then the match filter is a neuron.
            //test to see if the match is in the be-line of the filter.
            //if so, return TRUE, it is off.
            else if ($nObjMatch.is(matchdepth["off"])==true) {
                var nOBJ = MEMG.getNeuronByTempNid($tnid);
                //console.log("matches for $ntype:"+$ntype+" at depth:"+$depth+" for "+nOBJ.text+" are turned OFF");
                return true;
            }
			else {
				 console.log("matches for $ntype:"+$ntype+" at depth:"+$depth+" for "+nOBJ.text+" are turned OK");
			}
        }
        return false;
    }
    searchIsOff = function($func, $depth, $nObjSearch) {
        var searchdepth = this.search[$func]["d"+$depth];
        if (searchdepth==undefined) return false;
        if (searchdepth && searchdepth["off"]!=undefined) {
            //if -1, it is off for all classes
            if (searchdepth["off"]==-1) {
                return true;
            }
            //if not -1 (and not undefined) then the match filter is a neuron.
            //test to see if the match is in the be-line of the filter.
            //if so, return TRUE, it is off.
            else if ($nObjSearch.is(searchdepth["off"])==true) {
                var nOBJ = MEMG.getNeuronByTempNid($tnid);
                console.log("matches for $ntype:"+$ntype+" func:"+$func+" at depth:"+$depth+" for "+nOBJ.text+" are turned OFF");
                return true;
            }
			else {
				console.log("searches for $ntype:"+$ntype+" func:"+$func+" at depth:"+$depth+" for "+nOBJ.text+" are turned OK");
			}
        }
        return false;
    }
}



/**
 * 
 */
class revelatian {
    constructor($ANX, $scene, $camera, $rendererCSS, $helperObj, $bEMULATE_DATA=false) {
        this.ticks=0;
        this.last_task_start_ticks = 0;
        this.last_task_start_neurons = 0;
        this._task_debug_history = [];

        this.ANX = $ANX;
        this.scene = $scene;
        this.camera = $camera;
        this.rendererCSS = $rendererCSS;

        this.helperObj = $helperObj;
        
        this.pts = null;    //will be an arraymap.

        this.default_attractor = null;

        this.networks = new arraymap();
        this.networks.setMapKey("nid");
		this.n1 = null;
		this.n2 = null;

        this.bEMULATE_DATA = $bEMULATE_DATA;

        this.default_showable_lvl1 = [MEM.person.nid, MEM.location.nid, MEM.company.nid, 
                            MEM.gregorian_date.nid, MEM.group.nid, 
                            MEM.group_event.nid, MEM.EC_CLASS.nid];

        this.parent_i = -1;

        this.wcolor = new THREE.Color(0xD3D3D3);
        //var color = new THREE.Color(0xff0000);
        this.wcolor.a = 0.5; 

        this.ycolor = new THREE.Color(0xfefe17);
        this.bcolor = new THREE.Color(0x09fff);
        this.tcolor = new THREE.Color(0x00ffff);
        this.gcolor = new THREE.Color(0x00ff00);
        this.g2color = new THREE.Color(0x97ff97);

        this.ncolors = [this.ycolor, this.bcolor];
        
        this.highlightFinalColor = new THREE.Color(0xfefe17);

        //manager of our 3d css elements.
        //when we reset stuff we have them here to clear them out.
        this.last_lbl_pts = [];

        this.ZOOM_UP = 3.3875;

        this.MAX_CSS_3JS_LBLS = 80;     //experiment with this. (not enforced yet)
        this.AUTO_SHOW_CSS_MIN = 30;    //

        this.max_lvl = 0; 

        this.debug_sphere = null;
        this.total_neurons = 0;
        this.total_relons = 0;

        this._LAST_P_INDEX_USED = 0;

        this.matcher = new Object();
        this.matcher_path_strs = [];

        //for better experience.. break it up.
        this.__tasks = [];
        this.__bTask_in_process=false;
        this.__metatotalTasks = 0;
        this.skipped_searches = 0;
        this.queries = 0;

        this.e_particles = 0;
        this.unassigned_cnt = 0;
        this.MAX_E = 20100;
        this.reclaims=0;
        this.m_particles = 0;   //total particles assigned to a matching path.

        this.MAX_DEFAULT_LBL_LEFT_SHOW = 2;
        
        const listener = new THREE.AudioListener();
        this.sound_ambient = new THREE.Audio( listener );

        this.rev_tuner = new rev_tuner();
        this.rev_tuner.doDefaults();
        

        //for me when jamming to coding music.. have to turn of this
        this.localSOUNDTEST = true;

        //to neurons (and rels) we skipped due to be lvl being too low
        //and class likely being irrelvant for us.
        this.audit_skips = [];

        this.init();
    }

    genEfficiencyAudit = function() {
        console.log("%c ****** efficiency audit ********* ", ANNE.TALK.bgpurple);
        if (this.n0!=null && this.n1!=null) {
			console.log("%c n0 depth %c "+this.n0.max_lvl+"%c n1 depth %c "+this.n1.max_lvl, ANNE.TALK.bgyellow, ANNE.TALK.bggreen, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
		}
		console.log("%c audit skips %c "+this.audit_skips, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
        console.log("%c skipped searches %c "+this.skipped_searches, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
        console.log("%c queries %c "+this.queries, ANNE.TALK.bgyellow, ANNE.TALK.bggreen);
    }


    /**
     * 
     * @returns 
     */
    init = function() {

        const audioLoader = new THREE.AudioLoader();
        audioLoader.load('../mp3/deepspace.mp3', function( buffer ) {
            ANNE.ANX._REVELATIAN.sound_ambient.setBuffer( buffer );
            ANNE.ANX._REVELATIAN.sound_ambient.setLoop( true );
            ANNE.ANX._REVELATIAN.sound_ambient.setVolume(.5);
            if (ANNE.ANX._REVELATIAN.localSOUNDTEST==true) ANNE.ANX._REVELATIAN.sound_ambient.play();
            else ANNE.ANX._REVELATIAN.sound_ambient.pause();
        });
        
        ANNE.A.hide("id_annefolio_subfilters");
        ANNE.A.emptySelf("id_annefolio_subfilters");
        ANNE.A.hide("injected_div");
        ANNE.A.hide("left_holder2");
        ANNE.A.hide("afnd");

        var revbtns = document.getElementById("left_header_body");
        ANNE.A.show(revbtns);
        revbtns.innerHTML = "<span style='padding-top:20px; padding:8px; font-weight:700; font-sie:12px; color:#fefe17'><span style='color:#00FF00'>Pick a neuron</span> from the search and click on it.  Then pick another.  Enjoy the show.</span>";

        revbtns.addEventListener("click", async(e)=>{
            var target = e.target;
            var tnid = target.getAttribute("rev_tnid");
            if (tnid==undefined) return;
            
            var network_i = target.getAttribute("network_i");
            if (network_i==undefined) return;

            var pt_i = target.getAttribute("pt_i");
            if (pt_i==undefined) return;

            //console.log("tnid:"+tnid+" i:"+network_i+" pt.i:"+pt_i);
            var nOBJ = MEMG.getNeuronByTempNid(tnid);
            console.log(nOBJ.nid);
            var pt = this.pts.arr[pt_i];

            var el = this.doCSSLbl(network_i, pt, nOBJ, pt.pt, "neuron-floater-rv");
            if (el!=null) {
                if (el.classList.contains("highlight")==false) {
                    el.classList.add("highlight");
                }
                else {
                    el.classList.remove("highlight");
                } 
            }
            el.innerHTML = nOBJ.text;

            var safetyfirsteverybody = 0;
            var path = [];
            while (nOBJ.bes.length>0) {
                if (path.length==0) {
                    path.push("<b>"+nOBJ.bestName()+"</b>");
                }
                else path.push(nOBJ.bestName());
                nOBJ = MEMG.getNeuronByTempNid(nOBJ.bes[0]);
                if (safetyfirsteverybody++ > 20) break;
            }

            //get the last one.
            path.push(nOBJ.text);

            var bePath = "<span class='rev-be-path-text'>"+path.reverse().join(" > ")+"</span><BR>";
            
            var html = ANNE.ANX._REVELATIAN.verbalizeRelons(pt, true, true);
            ANNE.ANX.showPopup(bePath+html);
        });

        
        var btn_one_more_lvl = document.getElementById("btn_on_more_lvl");
        btn_one_more_lvl.addEventListener("click", e=>{
            for (var n=0; n < this.networks.arr.length; n++) {
                this.newTask({task:"__task__procesNextGen", lvl_to_do:this.networks.arr[n].max_lvl, t:0, network:this.networks.arr[n], funct:ANNE.ANX._REVELATIAN.__task__procesNextGen});
            }
        });

        //can do a slider config if we want.. this is fine tho.
        var btn_5k_more = document.getElementById("btn_5k_more");
        btn_5k_more.addEventListener("click", (e)=>{
            this.addPts(5000);
        });

        var btn_5k_less = document.getElementById("btn_5k_less");
        btn_5k_less.addEventListener("click", (e)=>{
            var network = this.networks.arr[0];
            var actual = Math.min(5000, network.MAX_E);
            this.minusPts(actual, REVPT_UNASSIGNED);
        });
        
        //can do a slider config if we want.. this is fine tho.
        var btn_5k_more0 = document.getElementById("btn_5k_more0");
        btn_5k_more0.addEventListener("click", (e)=>{
            var network = this.networks.arr[0];
            network.MAX_E+=5000;
            this.MAX_E+=5000;
            if (this.unassigned_cnt<=5000) this.addPts(5000);
            ANNE.ANX._REVELATIAN.addParticlesOnlyRand(network, 5000, network.pt);
            ANNE.A.play("boomhit");
        });

        var btn_5k_less0 = document.getElementById("btn_5k_less0");
        btn_5k_less0.addEventListener("click", (e)=>{
            var network = this.networks.arr[0];
            var actual = Math.min(5000, network.MAX_E);
            network.MAX_E-=actual;
            this.MAX_E-=actual;
            this.minusPts(actual, REVPT_PARTICLE_ONLY, network.tnid);
            ANNE.A.play("poof");
        });

        var btn_5k_more1 = document.getElementById("btn_5k_more1");
        btn_5k_more1.addEventListener("click", (e)=>{
            var network = this.networks.arr[1];
            network.MAX_E+=5000;
            this.MAX_E+=5000;
            if (this.unassigned_cnt<=5000) this.addPts(5000);
            ANNE.ANX._REVELATIAN.addParticlesOnlyRand(network, 5000, network.pt);
            ANNE.A.play("boomhit");
        });

        var btn_5k_less1 = document.getElementById("btn_5k_less1");
        btn_5k_less1.addEventListener("click", (e)=>{
            var network = this.networks.arr[1];
            var actual = Math.min(5000, network.MAX_E);
            network.MAX_E-=actual;
            this.MAX_E-=actual;
            this.minusPts(actual, REVPT_PARTICLE_ONLY, network.tnid);
            ANNE.A.play("poof");
        });
        
        this.clock = new THREE.Clock();

        var sz = .1;
        var rcs = 12;
                                            //pts, row, columns, width, height
        var ptsObj = ANNE.u3js.makeSheetsPts(36000, rcs, rcs, 200, 200);
        var pts2 = ANNE.UTILS.fisherYatesShuffle(ptsObj.pts);

        this.pts = new arraymap();
        for (var p=0; p < pts2.length; p++) {
            pts2[p].i=p; //reindex. since we sorted them.
            this.pts.quickAdd(pts2[p]);
        }

        this.unassigned_cnt = this.pts.arr.length;
        ANNE.A.setHTML("rev_u", ANNE.UTILS.commas(this.unassigned_cnt));

        //2ndary lookup by tnid.
        this.pts.setSecondaryIndex("tnid");
        this.default_attractor = new THREE.Vector3(0, 0, 0);
        
        const geometry = new THREE.IcosahedronGeometry(sz, 0 );
        const vmat = new THREE.MeshBasicMaterial( { vertexColors: THREE.VertexColors } );
        this.mesh = new THREE.InstancedMesh( geometry, vmat, this.pts.arr.length );
        this.mesh.ATYPE = ANNEFOLIO_VIEWER;

        const matrix = new THREE.Matrix4();

        for(var p=0; p < this.pts.arr.length; p++) {
            matrix.setPosition(this.pts.arr[p].pt.x, this.pts.arr[p].pt.y, this.pts.arr[p].pt.z);
            this.mesh.setMatrixAt( p, matrix );
            this.mesh.setColorAt( p, this.wcolor );
        }

        if (this.helperObj!=null) {
            this.mesh.position.copy(this.helperObj.objSpawnPosition);
        }

        this.scene.add(this.mesh);
        this.debug_sphere = u3js.makeDebugSphere(this.mesh, new THREE.Vector3(0,0,0), 20, 0x00ffff, 0.1); 
        this.mesh.lookAt(this.camera.position);

        var THIS = this;
        gsap.to(this.camera, {
            zoom:1,
            ease:"none",
            duration: 6,
            onUpdate() {
                THIS.camera.updateProjectionMatrix();
            }
        });

        this.timerID = setTimeout(() => {
			setInterval(ANNE.ANX._REVELATIAN.handleNextTask, 500);
		}, 3000);
        
        return;
    }


    /**
     * 
     * @param {*} $PT 
     * @param {*} $bINS 
     * @param {*} $bOUTS 
     * @returns 
     */
    verbalizeRelons=function($PT, $bINS, $bOUTS) {
        var html = [];
        if ($bINS==true && $PT.in_rels) {
            for (var r=0; r < $PT.in_rels.arr.length; r++) {
                var rel = $PT.in_rels.arr[r];
                var txt = this.simpleRelonPrint(rel, "ins");
                html.push(txt);
            }
        }
        if ($bOUTS==true && $PT.out_rels) {
            for (var r=0; r < $PT.out_rels.arr.length; r++) {
                var rel = $PT.out_rels.arr[r].rel;
                var txt = this.simpleRelonPrint(rel, "outs");
                html.push(txt);
            }
        }
        return html.join("<BR>");
    }


    /**
     * 
     * @param {*} $rObj 
     * @returns 
     */
	simpleRelonPrint = function ($rObj, $dir="in") {
		var parts = [];
		if ($rObj==null) {
			return "this is a malformed relon";
		}
        if ($dir=="outs") parts.push("➜");
        else parts.push("⬅");

        var fromclass = "white";
        if ($rObj.from_nid==this.networks.arr[0].nid) fromclass="yellow";
        else if (this.networks.arr.length>1 && $rObj.from_nid==this.networks.arr[1].nid) fromclass="blue";

        var toclass = "white";
        if ($rObj.to_s==this.networks.arr[0].nid) toclass="yellow";
        else if (this.networks.arr.length>1 && $rObj.to_s==this.networks.arr[1].nid) fromclass="blue";

		parts.push("<span class='rev-relpart-"+fromclass+"'>"+MEMG.getNeuronByTempNid($rObj.f).bestNameHTML()+"</span>");
		parts.push("<span class='rev-relpart-type'>"+ANNE.TALK.getTypeName($rObj.type, false)+"</span>");
		parts.push("<span class='rev-relpart-green'>"+MEMG.getNeuronByTempNid($rObj.r).bestNameHTML()+"</span>");
		parts.push("<span class='rev-relpart-"+toclass+"'>"+MEMG.getNeuronByTempNid($rObj.t).bestNameHTML()+"</span>");
		return parts.join("");
	}


    /**
     * @param {*} $nObj 
     */
    _action_addNetwork=async($nObj)=>{
        var _network = this.networks.get($nObj.nid);
        if (_network!=null) {
            console.log("we've already added this attractor as a network for this visual.");
            return;
        }

        if (this.networks.arr.length==0) {
            ANNE.A.empty("left_header_body");
        }

        //add a new network (these are tops awe are trying to compare)
        _network = new rev_network($nObj, this.ncolors[this.networks.arr.length], this.networks.arr.length);
        this.networks.addU(_network);

		//much easier.
		if (this.networks.arr.length==1) this.n1=_network;
		else if (this.networks.arr.length==2) this.n2=_network;
    
        //this new network top nObj may already be mapped to a pt in another netowrk.
        var pt = this.pts.get2($nObj.temp_nid); //the tnid array.
        
        //we already have a pt for this nObj.  Use it.
        if (pt!=undefined) {
            pt.type = REVPT_NETWORK_BASE;   //upgrade this to a foundational network.
            pt.lvl_offsets[_network.i] = 0;  //(leave lvl offset)
            if (pt.cssobj!=null && pt.cssobj.element!=null) pt.cssobj.element.classList.remove("neuron-floater-rv");
            if (pt.cssobj!=null && pt.cssobj.element!=null) pt.cssobj.element.classList.add("neuron-network-floater-rv");
        }
        else {  //otherwise, assign it.
            pt = await this.wireNewPt(_network, $nObj, null, REVPT_NETWORK_BASE, 0);
        }

        //create an attractor mesh.
        const attractorMat = new THREE.MeshBasicMaterial({ color: _network.color, wireframe:true, transparent:true, opacity:.4 });
        
        var mass = 3+Math.log($nObj.outs.length);
        
        const sphereGeometry = new THREE.SphereGeometry(mass, 8, 8);
        pt.mesh = new THREE.Mesh(sphereGeometry, attractorMat);
        pt.mesh.nObj = $nObj;

        const x = Math.random() * 100 - 50;
        const y = Math.random() * 100 - 50;
        const z = Math.random() * 100 - 50;
        pt.mesh.position.set(x, y, z);
        pt.pt.x = x;
        pt.pt.y = y;
        pt.pt.z = z;
        this.mesh.add(pt.mesh);

        pt.mesh._color = _network.color;
        pt.mass = mass;
        pt.type = REVPT_NETWORK_BASE;

        //make sure our network mesh and primary network pt are in our trackers.
        _network.mesh = pt.mesh;
        _network.pt = pt;

        this.doCSSLbl(_network.i, pt, $nObj, _network.mesh.position, "neuron-network-floater-rv"); 

        ANNE.A.play("boomhit");

        return await this.__task__processTopNeuron(_network);
    }
    

    /**
     * 
     * @param {*} $network 
     * @returns 
     */
    __task__processTopNeuron=async($network, $task=null)=> {
        if(this.__bTask_in_process==true) {
            console.log("TASK IN PROCESS -------->  PEND TASK");
            this.newTask({task:"__task__processTopNeuron", network:$network, funct:ANNE.ANX._REVELATIAN.__task__processTopNeuron});
            return;
        }
        this.__bTask_in_process = true;


        if ($network.i==1) {
            //if (this.localSOUNDTEST==true) ANNE.A.play("tense_background");
            ANNE.A.show("btn_5k_more1");
            ANNE.A.show("btn_5k_less1");
        }
        else if ($network.i==0) {
            ANNE.A.show("btn_5k_more0");
            ANNE.A.show("btn_5k_less0");
        }
        
        if ($task==null || $task.t==0) {
            ANNE.A.play("spaceintro");
        }

        console.log("processToPneuron "+$network.nObj.text);;
        var q_nids = [];
        var nObj = $network.nObj;
        var p_origin = $network.pt;

        this.queries+=1;
        await ANNE.API.queryForOutsAndIns(nObj.nid, false);
        ANNE.A.setHTML("queries", ANNE.UTILS.commas(this.queries));

        var rels = [];
        for (var r=0; r < nObj.outs.length; r++) {
            var rel = nObj.outs[r];
            if (rel.to_type!=TO_TYPE_ANNE) continue;
            if (rel.type==TYPE_PARAM) continue;
            if (rel.type==TYPE_SYS) continue;
            if (rel.type==TYPE_SYS_MSG) continue;
            if (rel.type==TYPE_BRAIN) continue;
            if (rel.type==TYPE_BRAIN120) continue;
            
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);

            //skip anne sys classes.
            if (toNOBJ.ntype==NTYPE_CLASS && toNOBJ.is(ANNE.MEM.__ANNE_SYS_CLASS)==true) {
                this.audit_skips.push(toNOBJ.text);
                continue;
            }

            rels.push(rel);
            
            if (toNOBJ.text=="" && q_nids.indexOf(toNOBJ.nid)==-1) {
                q_nids.push(toNOBJ.nid);
            }
        }

        //query all the nids in the circuit.
        if (q_nids.length>0) {
            this.queries+=1;
            await ANNE.API.getNames(q_nids);
            ANNE.A.setHTML("queries", ANNE.UTILS.commas(this.queries));
        }

        var top_tests = 0;
        
        //do the pt after we pull the text.
        for (var r=0; r < rels.length; r++) {
            var rel = rels[r];
            var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
            
            //at top level we cannot connect to ourself.
            if (rel.t==$network.tnid) continue;

            if (toNOBJ==null) continue;//impossible here.

            top_tests+=1;
            
            //always add this rel to the out rels tracker.
            //we could track by rid (a bit shorter) instead.
            //consider later.  Easy to alter.
            $network.pt.addOutRel(rel);

            //from neuron, to neuron to add to network.
            $network.addToNetwork(toNOBJ);

            //addInR3l is called in wireN3wPt.
            //this will ensure the hits is upp'd in the f_origs
            var pt = this.pts.get2(toNOBJ.temp_nid); //the tnid array.
            if (pt==null) {
                pt = await this.wireNewPt($network, toNOBJ, rel, REVPT_NEURON, p_origin.lvl_offsets[$network.i]+1);
                if (toNOBJ.outs.length > 10 || toNOBJ.ins.length > 10) {
                    this.doCSSLbl($network.i, pt, toNOBJ, pt.pt); 
                }
                else {
                    this.doCSSLbl_left_only($network.i, pt, toNOBJ, pt.pt); 
                }
            }
            
            else {
                if(pt.type!=REVPT_NEURON && pt.type!=REVPT_NETWORK_BASE) {
                    console.log("WHAT IS THIS????");
                }
                pt.addInRel(this, $network, rel, p_origin.lvl_offsets[$network.i]+1);
            }
        }

        p_origin.queried_outs = true; 
        p_origin.process_outs_net_i.push($network.i);

        if (p_origin.lvl_offsets[$network.i]+1 > this.max_lvl) {
            this.max_lvl = p_origin.lvl_offsets[$network.i]+1;
        }
        ANNE.A.setHTML("rev_lvls", this.max_lvl);
        //console.log("PROCESSTOPNEURON: max_lvl:"+$network.max_lvl+"TOP TEST FOR THIS NETWORK : "+top_tests); //s.b. 1 here.
        
        if (this.max_lvl>1) {
            this.newTask({task:"__task__procesNextGen", t:0, lvl_to_do:1, network:$network, funct:ANNE.ANX._REVELATIAN.__task__procesNextGen});
        }

        this.__bTask_in_process = false;
        ANNE.A.show("btn_on_more_lvl");

        return;
    }


    /**
     * 
     * @param {*} $nObj 
     * @param {*} $in_rel 
     * @param {*} $type 
     * @returns 
     */
    wireNewPt=async($network, $nObj, $in_rel, $type, $lvl_offset=0)=> {
        if ($type==REVPT_UNASSIGNED) {
            alert("This is stupid.");
            return null;
        }
        
        var ptP2 = null;
        for (var i=this._LAST_P_INDEX_USED; i < this.pts.arr.length; i++) {
            if (this.pts.arr[i].type!=REVPT_UNASSIGNED) continue;
            ptP2 = this.pts.arr[i];
            ptP2.lvl_offsets[$network.i] = $lvl_offset;
            break;
        }
        if (ptP2==null) {
            await this.addPts(5000);
            return this.wireNewP($network, $nObj, $in_rel, $type, $lvl_offset);
        }

        if (ptP2.type!=REVPT_UNASSIGNED) {
            alert("YUGE PROBLEM");
            return null;
        }


        this._LAST_P_INDEX_USED = ptP2.i;
        this.unassigned_cnt-=1;
        ANNE.A.setHTML("rev_u", ANNE.UTILS.commas(this.unassigned_cnt));

        //assign the pt.
        ptP2.tnid = $nObj.temp_nid;
        
        this.pts.addIndex2(ptP2, ptP2.tnid);
        
        ptP2.status = PT_STATUS_ACTIVE;
        ptP2.type=$type;

        
        //the in rel.. is the in TO THIS (spawning the TO)
        if ($in_rel!=null) {
            this.total_relons+=1;
            ANNE.A.setHTML("rev_total_relons", ANNE.UTILS.commas(this.total_relons));
            ptP2.addInRel(this, $network, $in_rel, $lvl_offset);
        }

        if ($lvl_offset > $network.max_lvl) {
            $network.max_lvl = $lvl_offset;
        }

        if ($type==REVPT_NEURON || $type==REVPT_NETWORK_BASE) {
            this.total_neurons+=1;
            ANNE.A.setHTML("rev_total_neurons", ANNE.UTILS.commas(this.total_neurons));
            this.mesh.setColorAt( ptP2.i, $network.color);
        }

        return ptP2;
    }


    /**
     * How to optimize these lookups further?
     * How to not hit the gui w/ delays/pauses? hmmm.
     * 
     * @param {*} $network 
     */
    __task__procesNextGen = async($network, $task=null, $bOVERRIDE=true)=>{
        if ($bOVERRIDE==false && this.__bTask_in_process==true) {
            console.log("TASK IN PROCESS -------->  PEND TASK");
            this.newTask($task);
        }
        console.log("%c __task__procesNextGen %ct="+$task.t, ANNE.TALK.bgblack, ANNE.TALK.bggreen);
            
        this.__bTask_in_process=true;
        var startTime = performance.now();
        var t = 0;
        if ($task!=null && $task.t!=undefined) t = $task.t;

        var qforoutsandins_nids = [];
        var qforouts_nids = [];
        var MAX_SHARD=40;
        var this_SHARD = 0;
        var this_tnids = [];
        var lvl_to_do = $task.lvl_to_do;
        var tt = 0;


        //isolate a shard to handle (to process)
        for (tt=t; tt < $network.tnids.length; tt++) {
            var PT = this.pts.get2($network.tnids[tt]); //the tnid array.
            if (PT.process_outs_net_i.indexOf($network.i)!=-1) continue;
            if (PT.lvl_offsets[$network.i] != lvl_to_do) continue;
            var rels = [];
            var q_nids = [];
            var tnobj = MEMG.getNeuronByTempNid($network.tnids[tt]);
            this_tnids.push(tnobj.temp_nid);

            //skip anne sys classes.
            if (tnobj.ntype==NTYPE_CLASS && tnobj.is(ANNE.MEM.__ANNE_SYS_CLASS)==true) {
                this.audit_skips.push(tnobj.text);
                continue;
            }
            
            //we don't want these early classes.
            if (tnobj.ntype==NTYPE_CLASS && tnobj.be_lvl!=-1 && tnobj.be_lvl<=2) {
                this.audit_skips.push(tnobj.text);
                continue;
            }

            //if (tnobj.ntype==NTYPE_CLASS && tnobj.is(ANNE.MEM.__ANNE_SYS_CLASS)==true) {
                //console.log("skipping "+tnobj.text);
                //continue;
            //}

            if (PT.queried_outs==false) {

                //for instances, get the outs and ins
                if (tnobj.ntype==NTYPE_INST) {
                    if (PT.queried_ins==false && qforoutsandins_nids.indexOf(tnobj.nid)==-1) {
                        
                        //search optimizer.
                        if (this.rev_tuner.searchIsOff("queryForOutsAndInsFroms", lvl_to_do, tnobj)==true) {
                            this.skipped_searches+=1;
                            continue;
                        }

                        qforoutsandins_nids.push(tnobj.nid);
                        this_SHARD+=1;
                        PT.queried_ins=true;
                    }
                }
                //for classes, just get the outs.
                else {

                    //search optimizer.
                    if (this.rev_tuner.searchIsOff("queryForOutsFroms_not", lvl_to_do, tnobj)==true) {
                        this.skipped_searches+=1;
                        continue;
                    }

                    if (qforouts_nids.indexOf(tnobj.nid)==-1) {
                        qforouts_nids.push(tnobj.nid);
                        this_SHARD+=1;
                    }
                }
                PT.queried_outs=true;
            }
            else {
                this.skipped_searches+=1;
            }
            if (this_SHARD>MAX_SHARD) break;
        }
        
        if (qforoutsandins_nids.length) {
            await ANNE.API.queryForOutsAndInsFroms(qforoutsandins_nids, false, [0,1,2,3,5,6,8,9,10]);
            this.queries+=1;
        }
        if (qforouts_nids.length) {
            await ANNE.API.queryForOutsFroms_not(qforouts_nids, false, [4,7], true, false);
            this.queries+=1;
        }

        ANNE.A.setHTML("skipped_searches", ANNE.UTILS.commas(this.skipped_searches));
        ANNE.A.setHTML("queries", ANNE.UTILS.commas(this.queries));

        //this_tnids is however many we could get before hitting the shard limit of query.
        var handled=0;
        for (var tt3=0; tt3 < this_tnids.length; tt3++) {
            var PT = this.pts.get2(this_tnids[tt3]);                    //the PT (unique to tnid)
            var rels = [];
            var q_nids = [];
            var tnobj = MEMG.getNeuronByTempNid(this_tnids[tt3]);
  
            handled+=1;
            for (var r=0; r < tnobj.outs.length; r++) {
                var rel = tnobj.outs[r];
                if (rel.f!=this_tnids[tt3]) {
                    console.log("shit should not be possible here.");
                }
                
                if (rel.to_type!=TO_TYPE_ANNE) continue;

                if (rel.type==TYPE_PARAM) continue;
                if (rel.type==TYPE_SYS) continue;
                if (rel.type==TYPE_SYS_MSG) continue;
                if (rel.type==TYPE_BRAIN) continue;
                if (rel.type==TYPE_BRAIN120) continue;

                //we don't want to chase neurons we already have in another network.
                //it will cause massive "match" bloat because of course you will share all
                //the common set of neurons from that point on.
                if (this.isInAnotherNetwork(rel.f, $network.i)==true) {
                    continue;
                }
          
                rels.push(rel);
                var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                if (toNOBJ.text=="" && q_nids.indexOf(toNOBJ.nid)==-1) {
                    q_nids.push(toNOBJ.nid);
                }
            }

            //query all the nids in the circuit.
            if (q_nids.length>0) {
                var existingTask = this.getTask("getNames");
                if (existingTask!=null) {
                    existingTask.q_nids = existingTask.q_nids.concat(q_nids);
                }
                else this.newTask({task:"getNames", funct:ANNE.ANX._REVELATIAN.getNames, network:$network, q_nids:q_nids});
            }

            //do the pt after we pull the text.
            for (var r=0; r < rels.length; r++) {
                var rel = rels[r];
                var toNOBJ = MEMG.getNeuronByTempNid(rel.t);
                if (toNOBJ==null) continue;//impossible here.
                
                var PT = this.pts.get2(rel.f);
                PT.addOutRel(rel);
                
                $network.addToNetwork(toNOBJ);

                //addInR3k is called in wireN3wPt.
                //this will ensure the hits is upp'd in the f_origs
                var pt_new = this.pts.get2(toNOBJ.temp_nid); //the tnid array.
                if (pt_new==null) {
                    pt_new = await this.wireNewPt($network, toNOBJ, rel, REVPT_NEURON, PT.lvl_offsets[$network.i]+1);
                    
                    //only put in left menu.  If clicked, we can get a lbl on screen.
                    //if when this goes GREEN we will make lbl auto.
                    if (toNOBJ.outs.length > this.AUTO_SHOW_CSS_MIN || toNOBJ.ins.length>this.AUTO_SHOW_CSS_MIN) {
                        this.doCSSLbl($network.i, pt_new, toNOBJ, pt_new.pt);
                    }
                    else if (PT.lvl_offsets[$network.i]<=this.MAX_DEFAULT_LBL_LEFT_SHOW) {
                        this.doCSSLbl_left_only($network.i, pt_new, toNOBJ, pt_new.pt); 
                    }
                }
                else {
                    pt_new.addInRel(this, $network, rel, PT.lvl_offsets[$network.i]+1);
                }
                
                if (pt_new.lvl_offsets[$network.i] > this.max_lvl) {
                    this.max_lvl = pt_new.lvl_offsets[$network.i];
                }
            }
            
            PT.process_outs_net_i.push($network.i);
        }
        
        ANNE.A.setHTML("rev_lvls", this.max_lvl);    
        var endTime = performance.now();
        var elapsedTime = endTime - startTime;
        
        //we didn't take much time to do this.
        //lets do another cycle of it.
        if (tt < $network.tnids.length) {

            if (elapsedTime<333) {
                console.log("go again!");
                var quicktask = {task:"__task__procesNextGen", t:tt, lvl_to_do:lvl_to_do, network:$network, funct:ANNE.ANX._REVELATIAN.__task__procesNextGen};
                return this.__task__procesNextGen($network, quicktask, true); //recurise this function.
            }
              
            //we still have more to go.  We finished this cycle of SHARD elements.
            else if (tt < $network.tnids.length) {
                console.log("more to process...");
                this.__bTask_in_process = false;
                this.newTask({task:"__task__procesNextGen", t:tt, lvl_to_do:lvl_to_do, network:$network, funct:ANNE.ANX._REVELATIAN.__task__procesNextGen});
                this.__bTask_in_process = false;
                return;
            }
        }

        //keep chasing network #2 --- to our max lvl of the network #1.
        //we should now have a +1 max_lvl from when we started this.
        else if (this.max_lvl>$network.max_lvl) {
            console.log("process next gen, auto!");
            this.newTask({task:"__task__procesNextGen", t:0, lvl_to_do:$network.max_lvl, network:$network, funct:ANNE.ANX._REVELATIAN.__task__procesNextGen});
        }

        ANNE.A.play("boomhit");
        this.updateTaskGui();

        ANNE.ANX._REVELATIAN.genEfficiencyAudit();
        this.__bTask_in_process = false;
        return;
    }



    /**
     * @param {*} $network 
     * @param {*} $task 
     */
    getNames = async($network, $task)=>{
        if (this.__bTask_in_process==true) {
            console.log("TASK IN PROCESS -------->  PEND TASK");
            this.newTask($task);
        }
        this.__bTask_in_process=true;
        await ANNE.API.getNames($task.q_nids);
        for (var n=0; n < $task.q_nids.length; n++) {
            var nObj = MEMG.getNeuronByNid($task.q_nids[n]);
            const elementsWithAttribute = document.querySelectorAll('[rev_tnid="'+nObj.temp_nid+'"]');
            elementsWithAttribute.forEach(element => {
                element.innerHTML = nObj.text;
            });
        }
        this.__bTask_in_process=false;
    }


    /**
     * test removing points.
     */
    removeUnassignedPts = function() {
        if (this.unassigned_cnt>0) {
            this.updatePtCount(this.pts.arr.length-this.unassigned_cnt);
        }
    }
    addPts = async($pts=5000)=>{
        this.updatePtCount(this.pts.arr.length+$pts);
    }
    minusPts = async($pts=5000, $type=REVPT_UNASSIGNED, $origin_tnid=-1)=>{
        this.updatePtCount(this.pts.arr.length-$pts, $type, $origin_tnid);
    }


    /**
     * 
     * @param {int} $newPointscount 
     * @param {int} $type 
     * @param {int} $origin_tnid 
     */
    updatePtCount=function($newPointCount, $type=REVPT_UNASSIGNED, $origin_tnid=-1) {
        const currentPtCount = this.pts.arr.length;
        var deletes = [];
        if ($newPointCount > currentPtCount) {
            for (let i = currentPtCount; i < $newPointCount; i++) {
                var pt = new rev_point(this.pts.arr.length);
                pt.pt=new THREE.Vector3(0, 0, 0);
                pt.type = REVPT_UNASSIGNED;
                this.pts.arr.push(pt);
                this.unassigned_cnt+=1;
            }
        } 

        //on removes, we remove a specific type
        else if ($newPointCount < currentPtCount) {
            var ptsToRemove = currentPtCount-$newPointCount;
            for (var p=this.pts.arr.length-1; p>0; p--) {
                if (this.pts.arr[p].type!=$type) {
                    continue;
                }

                if ($origin_tnid!=-1) {
                    if (this.pts.arr[p].p_origin.tnid!=$origin_tnid) continue;
                }

                this.pts.removeNoKey(p);
                deletes.push(p);
                ptsToRemove-=1;
                this.unassigned_cnt-=1;
                if (ptsToRemove<=0) break;
            }
        }

        ANNE.A.setHTML("rev_u", ANNE.UTILS.commas(this.unassigned_cnt));
        const matrix = new THREE.Matrix4();
        for (let p = 0; p < this.pts.arr.length; p++) {
            matrix.setPosition(this.pts.arr[p].pt.x, this.pts.arr[p].pt.y, this.pts.arr[p].pt.z);
            this.mesh.setMatrixAt(p, matrix);
            const t = this.pts.arr[p].type;
            if (t==REVPT_UNASSIGNED) {
                this.mesh.setColorAt(p, this.wcolor);
            }
            //else if (t==REVPT_PATICLE_MATCH_PATH || t==REVPT_NEURON_MATCH) {
                //this.mesh.setColorAt(p, this.g2color);
            //}
        }
        if (deletes.length) {
            deletes.forEach(index => {
                this.mesh.instanceMatrix.array[index * 16 + 15] = 0; 
            });
        }
        this.mesh.instanceCount = this.pts.arr.length;
        this.mesh.instanceMatrix.needsUpdate = true; 
    }


    /**
     * 
     * @returns 
     */
    handleNextTask = function() {
        if (ANNE.ANX._REVELATIAN.__bTask_in_process==true) {
            if (this.ticks - this.last_task_start_ticks > 1000) {
                console.alert("the show must go on");
                ANNE.A.play("run");
                this.last_task_start_ticks = 0;
                this.last_task_start_neurons = 0;
                ANNE.ANX._REVELATIAN.__bTask_in_process = false;
            }
            return;
        }
        if (ANNE.ANX._REVELATIAN.__tasks.length==0) {
            ANNE.A.setHTML("last_task_name", "");
            return;
        }

        this.last_task_start_ticks = this.ticks;
        this.last_task_start_neurons = this.total_neurons;

        //console.log("handle next tasks ticks:"+ANNE.ANX._REVELATIAN.ticks);
        var nextTask = ANNE.ANX._REVELATIAN.__tasks.shift();

        if (nextTask!=null) {
            if (nextTask.task=="setRandNextATTR") {
                for(var p=0; p <  nextTask.pts.length; p++) {
                    ANNE.A.setHTML("last_task_name", "setRandNextATTR");
                    nextTask.scope.setRandNextATTR(ANNE.ANX._REVELATIAN, nextTask.pts[p]);
                }
            }
            else {
                nextTask.funct(nextTask.network, nextTask);
                if (typeof nextTask.funct !=="function") {
                    //console.warn("HOW THE F DID THIS GET THROUGH>>>> FOR PETE'S SAKE");
                    return;
                }
                ANNE.A.setHTML("last_task_name", nextTask.task);
            }
        }
    }


    /**
     * 
     * @param {*} $task 
     * @returns 
     */
    getTask = function($task) {
        for (var t=0; t < this.__tasks.length; t++) {
            if (this.__tasks[t].task==$task) return this.__tasks[t];
        }
        return null;
    }


    /** 
     */
    addORSetRandNextATTRTask = function($task){
        this.__metatotalTasks+=1;
        var existing = this.getTask($task.task);
        if (existing!=null && existing.pts.length < 1000) {
            //console.log("added to task pts.");
            existing.pts.push($task.pts[0]);
        }
        else this.__tasks.push($task);
        
        this.updateTaskGui();
    }

    /**
     * 
     * @param {*} $task 
     */
    newTask = function($task) {
        if ($task.funct==undefined || $task.funct==null) {
            console.warn("malformed task", $task);
            return;
        }

        $task.th_index = this._task_debug_history.length;
        this._task_debug_history.push($task.task);

        this.__metatotalTasks+=1;
        this.__tasks.push($task);
        this.updateTaskGui();
    }

    updateTaskGui() {
        ANNE.A.setHTML("tasks_remaining", (ANNE.ANX._REVELATIAN.__metatotalTasks-ANNE.ANX._REVELATIAN.__tasks.length)+"/"+ANNE.ANX._REVELATIAN.__metatotalTasks);
    }
    

    //massive emergency.. shouldn't be needed with our REV and network throttles.
    reclaimPts = function($cnt) {
        var reclaimed = 0;
        this._LAST_P_INDEX_USED = 0;
        this.reclaims+=1;
        for (var c=0; c < Math.min(this.e_particles, $cnt); c++) {
            var ptP = null;
            for (var i=this._LAST_P_INDEX_USED; i < this.pts.arr.length; i++) {
                ptP = this.pts.arr[i];
                if (ptP.type==REVPT_PARTICLE_ONLY) {
                    ptP.type=REVPT_UNASSIGNED;
                    reclaimed+=1;
                    this.e_particles-=1;
                    ptP.tc=0;                         
                    ptP.cssobj=null;                   
                    ptP.queried_outs = false;         
                    ptP.process_outs_net_i = [];       
                    ptP.out_rels = null;              
                    ptP.queried_ins = false;           
                    ptP.processed_ins = false;        
                    ptP.in_rels = null;               
                    ptP.f_origs = null;               
                    ptP.next_attr = null;              
                    delete PT1.pt_path;
                    delete PT1.m_index;
                    if (reclaimed >=$cnt) return;
                }
            }
        }
        return;
    }
    
    
    addParticlesOnlyRand=function($network, $cnt, $fromPt) {
        for (var c=0; c < $cnt; c++) {
            var ptP = null;
            for (var i=this._LAST_P_INDEX_USED; i < this.pts.arr.length; i++) {
                ptP = this.pts.arr[i];
                if (ptP.type!=REVPT_UNASSIGNED) {
                    continue;
                }
                break;
            }

            if (ptP==null) {
                console.warn("this should not be possible as we create pts just before this step if we need them.");
                return null;
            }

            this.unassigned_cnt-=1;
            ANNE.A.setHTML("rev_u", ANNE.UTILS.commas(this.unassigned_cnt));
            this._LAST_P_INDEX_USED = ptP.i;

            //assign the pt.
            ptP.lvl_offsets[$network.i] = $fromPt.lvl_offsets[$network.i];
            ptP.status = PT_STATUS_ACTIVE;
            ptP.type=REVPT_PARTICLE_ONLY;
            ptP.n_i = $network.i;
            this.mesh.setColorAt(ptP.i, $network.color);

            this.e_particles+=1;
            $network.e_particles+=1;
            //ANNE.A.setHTML("rev_e", ANNE.UTILS.commas(this.e_particles));
            ANNE.A.setHTML("rev_n"+$network.i, ANNE.UTILS.commas($network.e_particles));

            //set the next attractor to the to pt.
            //this particle will flow from the pt.
            ptP.pt = $fromPt.pt.clone();
            ptP.pt.z+= Math.random()*3;
            ptP.pt.x+= Math.random()*3;
            ptP.pt.y+= Math.random()*3;

            //origin should be the network home.
            ptP.p_origin = $network.pt;  

			ptP.avoidTnids=[ptP.p_origin.tnid];

            ptP.next_attr = $network.pt.getRandNextPt(ANNE.ANX._REVELATIAN);
            ptP.tnid=-1;
        }
        
        this.mesh.instanceColor.needsUpdate = true;
    }

    /**
     * We want some particles added, colorized to this network.
     * @param {rev_network} $network
     * @param {int} $cnt 
     * @param {THREE.Vector3} $fromPt 
     * @param {THREE.Vector3} $toPt 
     * @returns 
     */
    addParticlesOnly=function($network, $cnt, $fromPt, $toPt) {
        //console.log("adding partcles only "+$cnt);
        
        for (var c=0; c < $cnt; c++) {
            var ptP = null;
            for (var i=this._LAST_P_INDEX_USED; i < this.pts.arr.length; i++) {
                ptP = this.pts.arr[i];
                if (ptP.type!=REVPT_UNASSIGNED) {
                    continue;
                }
                break;
            }

            if (ptP==null) {
                alert("WE ARE OUT OF PTS!!! ALLOCATE MORE!!!!");
                return null;
            }

           
            //we need to reclaim some E particles.
            if (ptP.type!=REVPT_UNASSIGNED) {
                this.reclaimPts(1000);
                this.addParticlesOnly($network, $cnt, $frompt, $toPt);
                return null;
            }
    
            this.unassigned_cnt-=1;
            ANNE.A.setHTML("rev_u", ANNE.UTILS.commas(this.unassigned_cnt));

            this._LAST_P_INDEX_USED = ptP.i;

            //assign the pt.
            ptP.lvl_offsets[$network.i] = $fromPt.lvl_offsets[$network.i];
            ptP.status = PT_STATUS_ACTIVE;
            ptP.type=REVPT_PARTICLE_ONLY;
            ptP.n_i = $network.i;
            ptP.avoidTnids=[$network.pt.tnid];

            this.mesh.setColorAt(ptP.i, $network.color);

            this.e_particles+=1;
            $network.e_particles+=1;
            //ANNE.A.setHTML("rev_e", ANNE.UTILS.commas(this.e_particles));
            ANNE.A.setHTML("rev_n"+$network.i, ANNE.UTILS.commas($network.e_particles));

            //set the next attractor to the to pt.
            //this particle will flow from the pt.
            ptP.pt = $fromPt.pt.clone();
            ptP.pt.z+= Math.random()*3;
            ptP.pt.x+= Math.random()*3;
            ptP.pt.y+= Math.random()*3;
            
            //origin should be the network home.
            ptP.p_origin = $network.pt;  

            ptP.next_attr = $toPt;
            ptP.audit="test pt.i="+ptP.i;
            ptP.tnid=-1;
        }
        
        this.mesh.instanceColor.needsUpdate = true;
    }



    /**
     * 
     */
    cleanup = function() {
        this.resetLbls();
        this.scene.remove(this.mesh);
        this.pts = [];
        ANNE.A.hide("revelatian_footer");
        ANNE.A.hide("revelatian_footer");
        ANNE.A.emptySelf("left_header_body");

        //fix the right holder.
        var elrholder = ANNE.A.__getEl("right_holder");
        elrholder.style["width"]="280px";
        elrholder.style["background"]="transparent";
        ANNE.A.empty(elrholder);
        ANNE.A.hide(elrholder);

        //remove networks
        for (var f=0; f < this.networks.arr.length; f++) {
            this.mesh.remove(this.networks.arr[f].mesh);
        }

        clearInterval(this.timerID);
    }


    /**
     * remove css 3d objs from scene and elements from the dom
     */
    resetLbls = function() {
        for (var i=0; i  < this.last_lbl_pts.length; i++) {
            if ( this.last_lbl_pts[i].cssobj==null) {
                continue;
            }
            this.scene.remove(this.last_lbl_pts[i].cssobj);
            ANNE.A.hide(this.last_lbl_pts[i].cssobj.element);
            var parent =this.last_lbl_pts[i].cssobj.element.parentElement;
            if (parent==undefined || parent==null) continue;
            parent.removeChild(this.last_lbl_pts[i].cssobj.element);
            this.last_lbl_pts[i].cssobj = null;
        }

        //audit
        for (var p=0; p < this.pts.arr.length; p++) {
            if (this.pts.arr[p].cssobj!=null) {
                console.log("WHO IS THIS?????");
            }
        }

        this.last_lbl_pts = [];
    }
    

    /**
     * 
     * @param {*} $network_index 
     * @param {*} $pt 
     * @param {*} $nObj 
     * @param {*} $position 
     * @param {*} $class 
     * @returns 
     */
    doCSSLbl = function($network_index, $pt, $nObj, $position, $class="neuron-floater-rv") {
        if ($position==undefined) return null;

        if ($pt.cssobj==null) {
            const elLbl = document.createElement("div");
            if ($pt.lvl_offsets[$network_index]>0) elLbl.innerHTML = $nObj.bestNameHTML()+" <span font-size='2px'>(lvl:"+$pt.lvl_offsets[$network_index]+")</span>";
            else elLbl.innerHTML = $nObj.bestNameHTML();
            elLbl.setAttribute("rev_tnid", $nObj.temp_nid);
            elLbl.classList = $class+$network_index;
            elLbl.classList.add("smart_"+$nObj.temp_nid);
            
            $pt.cssobj = new ANNE.CSS3DObject( elLbl );
            $pt.cssobj.position.set( $position.x, $position.y, $position.z );
            this.mesh.add($pt.cssobj);
            $pt.cssobj.lookAt(this.camera.position);
            this.last_lbl_pts.push($pt);
        }

        //left hand overlay for ez clicks
        if ($pt.eloverlay==undefined) {
            const eloverlay = document.createElement("div");
            eloverlay.classList="revelatian-neuron-item"+$network_index;
            if ($pt.lvl_offsets[$network_index]>0) eloverlay.innerHTML=$nObj.bestNameHTML()+" (lvl:"+$pt.lvl_offsets[$network_index]+")";
            else eloverlay.innerHTML=$nObj.bestNameHTML();
    
            eloverlay.setAttribute("rev_tnid", $nObj.temp_nid);
            eloverlay.setAttribute("network_i", $network_index);
            eloverlay.setAttribute("pt_i", $pt.i);
            eloverlay.classList.add("smart_"+$nObj.temp_nid);
    
            var el_rnd = document.getElementById("left_header_body");
            el_rnd.appendChild(eloverlay);
            ANNE.A.show("left_header_body");
            $pt.eloverlay = eloverlay;
        }

        return $pt.cssobj.element;
    }


        /**
     * 
     * @param {*} $network_index 
     * @param {*} $pt 
     * @param {*} $nObj 
     * @param {*} $position 
     * @param {*} $class 
     * @returns 
     */
    doCSSLbl_left_only = function($network_index, $pt, $nObj, $position, $class="neuron-floater-rv") {
        if($network_index==undefined) {
            console.log("deerrrrp");
        }
        if ($pt.cssobj!=null) {
            console.log("skip cssLbl");
            return;
        }

        if ($position==undefined) return null;

        //left hand overlay for ez clicks
        if ($pt.eloverlay==undefined) {
            const eloverlay = document.createElement("div");
            eloverlay.classList="revelatian-neuron-item"+$network_index;
            if ($pt.lvl_offsets[$network_index]>0) eloverlay.innerHTML=$nObj.bestNameHTML()+" (lvl:"+$pt.lvl_offsets[$network_index]+")";
            else eloverlay.innerHTML=$nObj.bestNameHTML();
    
            eloverlay.setAttribute("rev_tnid", $nObj.temp_nid);
            eloverlay.setAttribute("network_i", $network_index);
            eloverlay.setAttribute("pt_i", $pt.i);
            eloverlay.classList.add("smart_"+$nObj.temp_nid);

            var el_rnd = document.getElementById("left_header_body");
            el_rnd.appendChild(eloverlay);
            ANNE.A.show("left_header_body");
            $pt.eloverlay = eloverlay;
        }

        return $pt.eloverlay;
    }


    /**
     * Need to prioritize matches..
     * @param {*} $matchPt 
     */
    addMATCH=function($ePT1) {
        if ($ePT1==undefined || $ePT1==null) {
            console.log("track this.");
        }
        
        if ($ePT1.type==REVPT_NETWORK_BASE || $ePT1.tnid!=-1) {
            console.warn("this is the particle for the BASE NETWORK ITSELF.  DON'T MUCK WITH IT.");
            return false;
        }
        
        var match_pt = $ePT1.next_attr;
        if (match_pt==null) {
            console.warn("we have to have a match pt here");
            return false;
        }


        //if ($ePT1.n_i==1) {
        //    console.log("WHERE ARE OUR BLUES?????");
        //}

        var nObj = MEMG.getNeuronByTempNid(match_pt.tnid);

        if (this.rev_tuner.matchableIsOff(nObj.ntype, match_pt.lvl_offsets[$ePT1.n_i], nObj)==true) {
            return false;
        }
        
        this.m_particles+=1;
        ANNE.A.setHTML("rev_m", ANNE.UTILS.commas(this.m_particles));

        //PT1 particle was teh REVPT_PARTICLE that was on a winning path.
        $ePT1.type=REVPT_PATICLE_MATCH_PATH;                     //set revpt to match path (different handler)
        $ePT1.m_index=1;                                         //set m_index to 1 (m_index 0 is origin path)
        
        //send particle back to home, and it will start the SAME JOURNEY again,
        //now green, and on this path forever. 
        $ePT1.pt = $ePT1.p_origin.pt.clone(); 

        this.mesh.setColorAt($ePT1.i, this.g2color);             //set the color of the partcicle to green.

        //this is the particle representing the NEURON.
        this.mesh.setColorAt( match_pt.i, this.g2color);  //set the neuron's particle to green.  
        match_pt.type=REVPT_NEURON_MATCH;                 //set the neuorn's new type to NEURON MATCH.
        
        //add css object and left holder element for this, if it isn't already showing.
        if (match_pt.cssobj==undefined || match_pt.cssobj==null || match_pt.element==undefined || match_pt.element==null) {
            var toNOBJ = MEMG.getNeuronByTempNid(match_pt.tnid);
            this.doCSSLbl(0, match_pt, toNOBJ, match_pt.pt);
        }


        //for upgraded pts that find a match path, we keep the pt_path static 
        //and simply iterate through with the m_index thereafter.
        //In theory, all particles should eventually find winning pathways they settle on.
        var pt_path = $ePT1.pt_path;

        //this is the winning path that got us from network start to a neuron shared in the other network.
        if (pt_path==undefined || pt_path==null) {
            console.log("uh oh");
            return false;
        }
        var pathtrack = [];
        for (var p=0; p < pt_path.length; p++) {
			if (pt_path[p]==undefined) {
				console.log("WHATTTTT??");
				continue;
			}
            pathtrack.push(pt_path[p].tnid);
        }
        var pathid = "."+pathtrack.join(".")+".";
        
        //we already have this path included in another path.
        for (var m=0; m < this.matcher_path_strs.length; m++) {
            if (this.matcher_path_strs[m].length>pathid) continue;
            if (pathid.indexOf(this.matcher_path_strs[m])!=-1) {
                //we have a matching subpath within this match already.
                //we do not need this match.
                //remove the relon?
                return false;
            }
        }
        

        //we will now use the pt_path now for this particle.
        //the next_attr is no longer needed.
        $ePT1.next_attr = null;

        if (this.matcher[match_pt.tnid]==undefined) {
            var paths = new arraymap();
            paths.setMapKey("pathid");
            paths.addU({pathid:pathid, hits:1, n_cnt:pathtrack.length, n_i:$ePT1.n_i});
            var match = {tnid:match_pt.tnid, myl:1, paths:paths, nets:[$ePT1.n_i]};
            this.matcher[match_pt.tnid] = match;

            //MATCHING NIDS DING
            ANNE.A.play("beep");    //we'll do a better sound for this.

            var el_holder = document.getElementById("right_holder");
            ANNE.A.showParent(el_holder);

            //turning green all matches.
            //The particles will be joining us on these paths.
            //All of them.
            ANNE.A.play("tap");
            if (match_pt.cssobj.element!=null) {
                if (match_pt.cssobj.element.classList.contains("match")==false) {
                    match_pt.cssobj.element.classList.add("match");
                }
            }
            if (match_pt.eloverlay!=null) {
                if (match_pt.eloverlay.classList.contains("match")==false) {
                    match_pt.eloverlay.classList.add("match");
                }
            }
        }

        //another particle has found this path....
        else {
            var match = this.matcher[match_pt.tnid];
            match.myl+=1;

            if (match.nets.indexOf($ePT1.n_i)==-1) {
                match.nets.push($ePT1.n_i);
                var pathObj = {pathid:pathid, hits:1, n_cnt:pathtrack.length, n_i:$ePT1.n_i};
				var paths = match.paths;
                paths.addU(pathObj);
                this.finishMatchDisplayAsync(match_pt, nObj, match);  //don't await it.
                ANNE.A.play("lock");
            }

            var paths = match.paths;
            var pathObj = paths.get(pathid);
            if (pathObj==null) {
                pathObj = {pathid:pathid, hits:1, n_cnt:pathtrack.length, n_i:$ePT1.n_i};
                paths.addU(pathObj);
                this.updateMatchNewpath(nObj, pathObj, match_pt);
            }
            else {
                pathObj.hits+=1;
                this.updateMatchPathRefresh(pathObj);
            }
            //ANNE.A.play("ding");
           
        }
    
        //console.log(this.matcher);
        this.mesh.instanceColor.needsUpdate = true;
        return true;
    }


    /**
     * 
     * @param {*} $match 
     * @param {*} $pathObj 
     */
    updateMatchPathRefresh=async($pathObj)=>{
        var el_path = document.getElementById($pathObj.pathid);
        if (el_path==null) return;
        
        var el_hits = el_path.querySelector(".rev-path-hits");
        
		if (el_hits==null) return;
		el_hits.innerHTML=$pathObj.hits;
    }


    /**
     * Build out new paths.. or denote particles on this path.
     * @param {*} $nObj 
     * @param {*} $match 
     */
    updateMatchNewpath=async($nObj, $pathObj, $matchPt)=>{
        var el_pathways = document.getElementById("pathways_"+$nObj.temp_nid);
		if (el_pathways==null) {
			return;
		}
		if ($pathObj==null) {
			return;
		}
		
        this.addPathGUI(el_pathways, $pathObj);
    }


    /**
     * 
     * @param {*} $el_pathways 
     * @param {*} $pathObj 
     */
    addPathGUI = function($el_pathways, $pathObj) {
        var tnids = $pathObj.pathid.split(".");
        var pathnames=[];

        var matchText="";
        var pathclass="";

		//the pathid has leading "." and trailing "." so we can quickly
		//look for substrings without faux matches of extended numbers..
		//ie   17.1234  would match  32317.123456 if we didn't do this.
		// 323[17.1234]56
        for (var t=1; t < tnids.length-1; t++) {
            var ptNOBJ = MEMG.getNeuronByTempNid(tnids[t]);
            if (t==1) {
                if (parseInt(tnids[1])==this.networks.arr[0].tnid) {
                    pathclass="revpath-yellow";
                }
                else pathclass="revpath-blue";
				pathnames.push("<em>"+ANNE.UTILS.poorMansAbbreviate(ptNOBJ.bestName())+"</em>");
            }
            else if ((tnids.length-2)==t) {
                matchText=ptNOBJ.bestName();
            }
            else pathnames.push("<span style='color:whitesmoke!important'>"+ptNOBJ.bestName()+"</span>");
        }

        var row = document.createElement("div");
        row.classList.add("rev-path-entry");
        row.setAttribute("id", $pathObj.pathid);

        $el_pathways.appendChild(row);

        var pathname = pathnames.join(" ➜ ");
        var el = document.createElement("span");
        el.classList.add(pathclass);
        el.innerHTML = pathname;
        row.append(el);

        var elMatch  = document.createElement("span");
        elMatch.classList.add("revpath-green");
        elMatch.innerHTML = " ➜ "+matchText;
        row.append(elMatch);

        //particles on this path in the gui.
        var elmyl = document.createElement("span");
        elmyl.classList.add("rev-path-hits");
        elmyl.innerHTML=$pathObj.hits;
        row.appendChild(elmyl);
    }


    /**
     * For processing meme display of path.
     * @param {*} $tnids 
     * @param {*} $memelegs 
     */
    blowOutPath=async($tnids, $memelegs=[])=> {
        
        for (var t=0; t < $tnids.length; t++) {
            var tnid = $tnids[t];
            var nObj = ANNE.MEMG.getNeuronByTempNid(tnid);

            var afile = await ANNE.IMAGES.getAnyValidImgAFILE(nObj, 99);
            //if (afile!=null) {
                //console.log("we have an afile");
            //}
            var memeleg = {t:t, nid:nObj.nid, text:nObj.shortName(), reln_text:"", afile:afile};

            $memelegs.push(memeleg);
            if (t < $tnids.length-1) {
                var next_tnid = $tnids[t+1];
                var pt = this.pts.get2(tnid);
                var reln_text = [];
                for (var p=0; p < pt.out_rels.arr.length; p++) {
                    var rel = pt.out_rels.arr[p].rel;
                    if (rel.f==tnid) {
                        if (rel.t==next_tnid) {
                            var relnNOBJ = MEMG.getNeuronByTempNid(rel.r);
                            var rtext = relnNOBJ.shortName();
                            if (relnNOBJ.nid==ANNE.MEM.class.nid) rtext = "subclass of";
                            else if (relnNOBJ.nid==ANNE.MEM.inst.nid) rtext = "instance of";
                            
                            reln_text.push("<span class='tight-reln-tags'>"+ANNE.TALK.getTypeName(rel.type, true, "rev-tag-type")+rtext+"</span>");
                            if (reln_text.lenth==2) {
                                reln_text = reln_text+"<BR><BR>";   //try to jump the arrow line?
                            }
                            ANNE.TALK.printRelon(rel);
                        }
                        else continue;
                    }
                    else continue;
                }
                memeleg.reln_text = reln_text.join("<BR>");
            }
        }
    }


    /**
     * @param {*} $PT1
     * @param {*} $nObj 
     * @param {*} $match 
     */
    finishMatchDisplayAsync=async($PT1, $nObj, $match)=>{
        var elObj = await ANNE.A.neuronRevelatianMatchDisplay($nObj, $match, $PT1.lvl_offsets);
        if (elObj==null) return;

		var el_acf = elObj.el;
        var el_holder = document.getElementById("right_holder");
        el_holder.append(el_acf);

        var el_pathways = elObj.el_pathways;
        var paths = $match.paths;

        for(var p=0; p < paths.arr.length; p++) {
            //console.log(paths.arr[p]);
            var pathObj = paths.arr[p];
            this.addPathGUI(el_pathways, pathObj);
        }

        //on click -- we will display the memification page.
        el_acf.addEventListener("click", async($e)=>{
            if (ANNE.ANX._REVELATIAN!=null) {
                
				var tnid = $e.target.getAttribute("tnid");
                if (tnid==null) {
                    tnid = ANNE.A.ez_getNearestParentWithProp($e.target, "tnid");
                }
                if (tnid!=null) {
                    tnid = parseInt(tnid);
                    var matchObj = this.matcher[tnid];
                    console.log(matchObj);

                    var n0_n_cnt = new arraymap();
                    n0_n_cnt.setMapKey("n_cnt");
                    var n1_n_cnt = new arraymap();
                    n1_n_cnt.setMapKey("n_cnt");

                    for (var p=0; p < matchObj.paths.arr.length; p++) {
                        var path = matchObj.paths.arr[p];
                        var ncnttracker = null;

                        if (path.n_i==0) ncnttracker = n0_n_cnt;
                        else ncnttracker = n1_n_cnt;

                        var pmergebyncnt = ncnttracker.get(path.n_cnt);
                        if (pmergebyncnt==undefined) {
                            ncnttracker.addU({n_cnt:path.n_cnt, paths:[path]});
                        }
                        else {
                            pmergebyncnt.paths.push(path);
                        }
                    }

                    //now we have paths parsed out ready to join wisely w our template.
                    var n0cnt = 0;
                    var n0path = 0;
                    var n1cnt = 0;
                    var n1path = 0;

                    //for now, testing, take the first combo we have.
                    //potentially allow the user to decide which paths..
                    //presending a speedbump of options.. with each path "side" in a dd.
                    //their choice pieces together the path the meme will show.
                    if (n0_n_cnt.arr.length>0 && n1_n_cnt.arr.length>0) {
                        n0cnt = n0_n_cnt.arr[0].n_cnt;
                        n0path = n0_n_cnt.arr[0].paths[0];

                        n1cnt = n1_n_cnt.arr[0].n_cnt;
                        n1path = n1_n_cnt.arr[0].paths[0];
                    }

                    else {
                        console.warn("this is a partial path, no MEME can be made.");
                        return;
                    }

                    var memelegs0 = [];
                    var memelegs1 = [];

                    var tnids0 = n0path.pathid.split(".");
                    tnids0.pop();
                    tnids0.shift();
                    await ANNE.ANX._REVELATIAN.blowOutPath(tnids0, memelegs0);

                    var tnids1 = n1path.pathid.split(".");
                    tnids1.pop();
                    tnids1.shift();
                    await ANNE.ANX._REVELATIAN.blowOutPath(tnids1, memelegs1);
                    

                    //build1con1con
                    var funcname = "build";
                    funcname = funcname+(n0cnt-1)+"con"+(n1cnt-1)+"con";
                    
                    if (typeof ANNE.A[funcname] !=="function" ) {
                        console.warn("this meme pattern function '"+this._REVELATIAN[funcname]+"' is not handled yet");
                        alert("template "+funcname+" is unhandled");
                        return;
                    }

                    //call the right function.
                    var grid = ANNE.A[funcname](null, memelegs0, memelegs1);

					//we have the populated grid we want.  We can show it in a popup now.
                    var memObj = ANNE.A.memeframer("900px", ANNE.ANX.makeMemeFromEL);
                    memObj.body.appendChild(grid.parent_el);
                    ANNE.ANX.showPopup(memObj.el);
                }
            }
        });


        //turn off any lbls we auto added.
        //de-clutter.
        for (var i=this.last_lbl_pts.length-1; i >=0; i--) {
            if (this.last_lbl_pts[i].type!=REVPT_NEURON_MATCH 
                && this.last_lbl_pts[i].type!=REVPT_NETWORK_BASE) {

                this.scene.remove(this.last_lbl_pts[i].cssobj);
                ANNE.A.hide(this.last_lbl_pts[i].cssobj.element);
                var parent =this.last_lbl_pts[i].cssobj.element.parentElement;
                if (parent==undefined || parent==null) continue;
                parent.removeChild(this.last_lbl_pts[i].cssobj.element);
                this.last_lbl_pts[i].cssobj = null;
                this.last_lbl_pts.splice(i,1);
            }
        }

    }


    isInAnotherNetwork=function($tnid, $skipIndex=-1) {
        for (var n=0; n < this.networks.arr.length; n++) {
            if ($skipIndex!=-1 && this.networks.arr[n].i==$skipIndex) {
                continue;
            }
            if (this.networks.arr[n].tnids.indexOf($tnid)!=-1) return true;
        }
        return false;
    }


    isInAllNetworks=function($tnid, $skipIndex=-1) {
        for (var n=0; n < this.networks.arr.length; n++) {
            if ($skipIndex!=-1 && this.networks.arr[n].i==$skipIndex) {
                continue;
            }
            if (this.networks.arr[n].tnids.indexOf($tnid)==-1) return false;
        }
        return true;
    }

    /**
     * 
     */
    animate = function() {
        this.ticks+=1;
        this.debug_sphere.rotation.y+=.01;

        var dummy = new THREE.Object3D();

        var speed = 2;

        const attractionForce = 1.9;
        const attractionForceActive = 0.3;

        const repelForce = -0.37*speed;;
        const repelForceActive = -0.05*speed;

        const TOO_CLOSE_NONACTIVE = 2;
        const TOO_CLOSE_ACTIVE = 30;
     
        const OK_NOW_NONACTIVE = 150;
        const OK_NOW_ACTIVE = 120;

        //console.log(this.ticks);
        //if (this.ticks % 100==0) {
           // if (this.n1) {
				//if(this.n1.buzzes>777) ANNE.A.play("chimes");
				//this.n1.buzzes=0;
			//}
				
			//if (this.n2) {
				//if(this.n2.buzzes>777) ANNE.A.play("chimes");
				//this.n2.buzzes=0;
			//}
        //}
        
        for (var i = 0; i < this.pts.arr.length; i++) {
            
            //this pt stays put.
            
            //TODO: slightly rotate around orb in middle...
            if (this.pts.arr[i].type==REVPT_NETWORK_BASE) {
                //continue;
            }

            //if this is assigned to a neuron in the network,
            //we want to pull (attract) this towards the neuron that got it into the network.
            else if (this.pts.arr[i].status==PT_STATUS_ACTIVE) {
                
                //match path should enjoy travelling the match path.
                //other particles will eventually join this too when they find it.
                if (this.pts.arr[i].type==REVPT_PATICLE_MATCH_PATH) {
                    var PT1 = this.pts.arr[i];
                    if (PT1.pt_path==undefined || PT1.pt_path==null || PT1.pt_path.length==0) {
                        console.log("dead particle!");
                        continue;
                    }
                    var PT2 = PT1.pt_path[PT1.m_index];
                    if (PT2==null) {
                        console.log("fix this smokey!");
                        continue;
                    }
                    const direction = new THREE.Vector3().subVectors(PT2.pt, PT1.pt);
                    const distance = Math.abs(direction.length());
                    if (distance < 2) {
                        if (PT1.m_index == PT1.pt_path.length-1) {
                            //send him home to start the positive joureny again.
                            if (Math.random()>.2) {
                                PT1.m_index=1;  //set m_index back to first attr in path.
                                PT1.pt = PT1.p_origin.pt.clone();  
                            }
                        }
                        //send him to the next leg of the journey.
                        else {
                            PT1.m_index+=1;
                        }
                    }
                    else{
                        PT1.pt.add(direction.normalize().multiplyScalar(attractionForceActive*2));
                    }

                    dummy.position.copy(this.pts.arr[i].pt);
                    dummy.updateMatrix();
                    this.mesh.setMatrixAt(i, dummy.matrix );
                    continue;
                    
                }

                //for particles only....
                else if (this.pts.arr[i].type==REVPT_PARTICLE_ONLY) {
                    var PT1 = this.pts.arr[i];
                    var PT2 = PT1.next_attr;
                    if (PT2==null) {
						PT1.pt = PT1.p_origin.pt.clone();  
	                    PT1.p_origin.setRandNextATTR(this, PT1);
                        continue;
                    }
                    const direction = new THREE.Vector3().subVectors(PT2.pt, PT1.pt);
                    const distance = Math.abs(direction.length());
                    if (distance < 2) {
                        if (Math.random()>.9) { //controls spread of flowing particles.
                            //PT1.pt.next_attr=null;
                            
                            if (PT1.tc==0 && PT1.next_attr.out_rels!=null && PT1.next_attr.out_rels.arr.length) {               
                                //no need to travel further.
                                //we want to isolate on the common points.

                                //no matches until we have fully run the gamut from the pt_path.
                                if (PT1.pt_path!=undefined 
                                        && PT1.pt_path!=null 
                                        && PT1.pt_path.length>0 
                                        && this.networks.arr.length>1 
                                        && this.isInAllNetworks(PT1.next_attr.tnid)==true) {

                                    //sets back to 0 pt, sets m_index to 1, and does gui changes.
                                    //this particle will be on this path, forever.        
                                    var bGOOD = this.addMATCH(PT1);
                                    
                                    //try again on another path.
                                    if (bGOOD==false) {
                                        var poppt = PT1.pt_path.pop(); //take off the last path item.
                                        if (PT1.avoidTnids.indexOf(poppt.tnid)==-1) {
                                            PT1.avoidTnids.push(poppt.tnid);
                                        }

                                        if (PT1.pt_path.length>0) {
                                            
                                            //try another path.  we popped off the last pt_path
											//send the pt to the prev last (now last) and then set a new
											//rand pt (it will avoid the tnids list we added to)
                                            PT1.pt = PT1.pt_path[PT1.pt_path.length-1].pt.clone();  

                                            //set RandNextATTR with avoiding poppt.
                                            PT1.pt_path[PT1.pt_path.length-1].setRandNextATTR(this, PT1);
                                        }   
                                        else {
                                            PT1.pt = PT1.p_origin.pt.clone();  
                                            PT1.p_origin.setRandNextATTR(this, PT1);
                                        }
                                    }
                                }
                                else {
                                    PT1.next_attr.setRandNextATTR(this, PT1);
                                    //this.addORSetRandNextATTRTask({task:"setRandNextATTR", scope:PT1.next_attr, funct:null, pts:[PT1]});
                                }
                                PT1.tc = 1;
                            }

                            //only if we reached the end of the line do we 
                            //teleport the particle back to the top network and let it restart
                            //the journey.
                            else {
                                    
                                //if this is the first full-run dead-end,
                                //and we have a pt_path
                                //learn.
                                if (PT1.buzzticks==0 && PT1.pt_path!=undefined && PT1.pt_path.length) {
                                    if (this.networks.arr.length>1 && this.isInAllNetworks(PT1.next_attr.tnid)==true) {
                                        var bGOOD = this.addMATCH(PT1);
                                        
                                        //try again on another path.
                                        if (bGOOD==false) {
                                            var poppt = PT1.pt_path.pop(); //take off the last path item.
                                            if (PT1.avoidTnids.indexOf(poppt.tnid)==-1) {
                                                PT1.avoidTnids.push(poppt.tnid);
                                            }

                                            if (PT1.pt_path.length>0) {
                                                
                                                //try another path.
                                                PT1.pt = PT1.pt_path[PT1.pt_path.length-1].pt.clone();  

                                                //set RandNextATTR with avoiding poppt.
                                                //what we are saying here is.. yes, that was a matching path,
                                                //HOWEVER, we don't want that match..
                                                //send this particle back out to find a better one and
                                                //avoid taking the same path this this one.
                                                PT1.pt_path[PT1.pt_path.length-1].setRandNextATTR(this, PT1);
                                            }   
                                            else {
                                                PT1.buzzticks+=1;
                                                //this.networks.arr[PT1.n_i].buzzes+=1;
                                                PT1.pt.z+= Math.random()*3;
                                                PT1.pt.x+= Math.random()*3;
                                                PT1.pt.y+= Math.random()*3;
												PT1.pt = PT1.p_origin.pt.clone();  
	                                            PT1.p_origin.setRandNextATTR(this, PT1);
                                            }
                                        }

                                        
                                    }
                                }

                                //looking for a pathway forward...
                                if (PT1.buzzticks>12) {
                                    PT1.buzzticks = 0;
									this.networks.arr[PT1.n_i].buzzes-=1;
									
                                    //first dead-end we get a pt_path.
                                    //origin is the first pt in the path, but we will only travel
                                    //FROM there.
                                    PT1.pt_path = [PT1.p_origin];   
                                    
                                    //send him to home network, to start a discovery journey.
                                    PT1.pt = PT1.p_origin.pt.clone();  
                                    PT1.p_origin.setRandNextATTR(this, PT1);
                                    //this.addORSetRandNextATTRTask({task:"setRandNextATTR", scope:PT1.p_origin, funct:null, pts:[PT1]});
                                } 

                                //buzzy buzzy.
                                else {
                                    PT1.buzzticks+=1;
                                    //this.networks.arr[PT1.n_i].buzzes+=1;
                                    PT1.pt.z+= Math.random()*3;
                                    PT1.pt.x+= Math.random()*3;
                                    PT1.pt.y+= Math.random()*3;
                                }
                            }
                        }
                    } 

                    else {
                        //pt.audit="travelling "+pt.i;
                        PT1.pt.add(direction.normalize().multiplyScalar(attractionForceActive));
                        if (distance>2.2) PT1.tc=0;//we made it out.
                    }
                    dummy.position.copy(this.pts.arr[i].pt);
                    dummy.updateMatrix();
                    this.mesh.setMatrixAt(i, dummy.matrix );
                    continue;
                }

                //
                var PT1 = this.pts.arr[i];
                if (PT1.f_origs==null) {
                    continue; //not init yet before animate?
                }
                
                for (var f = 0; f < PT1.f_origs.arr.length; f++) {
                    var PT1f = PT1.f_origs.arr[f].pt;
                    const direction = new THREE.Vector3().subVectors(PT1f.pt, PT1.pt);
                    const distance = direction.length(); 
                    if (PT1.tc==1) {
                        //turn off tc.
                        if (distance > OK_NOW_ACTIVE && Math.random()>.96) {   //gotta get it hooked again.
                            this.pts.arr[i].tc=0;
                        }
                        //keep repelling
                        else {
                            PT1.pt.add(direction.normalize().multiplyScalar(repelForceActive * 2 * (Math.random() - 0.2)));
                        }
                    }
                    //his is too close!!
                    else if (distance<TOO_CLOSE_ACTIVE) {
                        this.pts.arr[i].pt.add(direction.normalize().multiplyScalar(repelForce));
                        this.pts.arr[i].tc=1;
                    }
                    //otherwise draw it in.
                    else {
                        this.pts.arr[i].pt.add(direction.normalize().multiplyScalar(attractionForceActive/20));
                    }
                }
            }


            //not active??
            //white unassigned particles.
            else {

                const direction = new THREE.Vector3().subVectors(this.default_attractor,  this.pts.arr[i].pt);
                const distance = Math.abs(direction.length());

                //if too close, repel it.
                if (this.pts.arr[i].tc==1) {

                    //turn off tc.
                    if (distance > OK_NOW_NONACTIVE && Math.random()>.96) {   //gotta get it hooked again.
                        this.pts.arr[i].tc=0;
                    }

                    //keep repelling
                    else {
                        this.pts.arr[i].pt.add(direction.normalize().multiplyScalar(repelForce*Math.random()));
                    }
                }
                
                else if (distance<TOO_CLOSE_NONACTIVE) {
                    this.pts.arr[i].pt.add(direction.normalize().multiplyScalar(repelForce));
                    this.pts.arr[i].tc=1;
                }

                //otherwise draw it in.
                else this.pts.arr[i].pt.add(direction.normalize().multiplyScalar(attractionForce/2));

            }

             
            dummy.position.copy(this.pts.arr[i].pt);
            dummy.updateMatrix();
            this.mesh.setMatrixAt(i, dummy.matrix );

            if(this.pts.arr[i].cssobj!=null) {
                this.pts.arr[i].cssobj.position.copy(this.pts.arr[i].pt);
                this.pts.arr[i].cssobj.position.y-=4;
                this.pts.arr[i].cssobj.lookAt(this.camera.position);
            }
        }

        this.mesh.instanceMatrix.needsUpdate = true;

        const delta = this.clock.getDelta();
        this.mesh.rotation.y += delta/50 * 0.5;
    }


}


