class search_settings {
    constructor () {
        this.bISOPEN = false;
        this._blurEls = [];
        this._observable_bs = [];
        this._bRESTRICT_CLASS = false;
        this._restrictClassNids = [];
        this._thresh = .3;
        this._bEXACT = false;
    }
    

    /** 
     * Filter by class nids.
     * 
     * If class filter are on, return the filter. 
     * 
     * @author {Mr.Scatman}
     */
    getClassNids = function() {
        if (SS._bRESTRICT_CLASS==false) return [];
        return SS._restrictClassNids;
    }
    
    getClassTnids = function() {
        if (SS._bRESTRICT_CLASS==false) return [];
        return MEMG.nidsToTnidsList(SS._restrictClassNids);
    }

    /** 
     * Filter by class nids.
     * 
     * If worldview settings are on, return the filter 
     * THIS FILTER IS USER DEFINED.  
     * THEY CAN OVERRIDE WHAT A SITE LETS THRU.
     * 
     * @author {Mr.Scatman}
     */
    getWorldViewNidList = function() {
        if (USER._bWORLDVIEWBIPASS==false) return MEM.getWorldViewNidList();
        else return [];
    }
    
    /** 
     * Filter by class nids.
     * 
     * The $beClassNids and $lets are APP DEFINED.  They are helpful filters
     * to limit the scope of what this particular search is trying to find.
     * 
     * $bAPPLYWVTOBELINE - apply the wv restriction to the BES list, not the result neuron
     * This is relevant with something like identity.  We don't care who owns the neuron (the identity does)..
     * We do want to know that it has a proper identity parent of a neuron that is in the ANNE worldview.
     * 
     * $inbeline - nid of be line this must be in (instead of passing actual bes) 
     * 
     * @author {Mr.Scatman}
     */

    /**
     * 
     */
    getDefaultSearchObj = function ($searchVal, $beClassNids=[], $lets=[], $bAPPLYWVTOBELINE=false, $inbeline=0, $bEXACT=false) {
        var wvs_live = SS.getWorldViewNidList();
        if(wvs_live==undefined) wvs_live = [];
        var bes = SS.getClassNids();
        var bes_tnids = SS.getClassTnids();
        if ($beClassNids.length) {
            if (bes.length) {
                for (var b=0; b < $beClassNids.length; b++) {
                    var be = $beClassNids[b];
                    if (bes.indexOf(be)==-1) {
                        bes.push(be);
                        var beNOBJ = MEMG.getNeuronByNid(be);
                        bes_tnids.push(beNOBJ.temp_nid);
                    }
                }
            }
            else {
                bes = $beClassNids;  
                for (var b=0; b < $beClassNids.length; b++) {
                    var be = $beClassNids[b];
                    var beNOBJ = MEMG.getNeuronByNid(be);
                    bes_tnids.push(beNOBJ.temp_nid);
                }
            }
        }
        if ($lets.length) {
            for (var w=0; w < $lets.length; w++) {
                var wv = $lets[w];
                if (wvs_live.indexOf(wv)==-1)wvs_live.push(wv);
            }
        }
        return { 
                text:$searchVal, 
                wvs:wvs_live, 
                bes:bes,
                bes_tnids:bes_tnids,
                exact:$bEXACT,
                applywvtobeline:$bAPPLYWVTOBELINE,
                inbeline:$inbeline,
                chaseIt:true
        };
    }
}

var SS = new search_settings();