/** 
 * tools to store neuron and relons as ghosts..
 * and tools to upgrade them to ANNE as real neurons/relons.
 *
 * When updating them we need to handle each neuron class specifically if it
 * has a special handler to create it in ANNE.
 */

var GHOSTDATA = {};
GHOSTDATA.ico = '<img class="dib" src="../imgs/ghost64_ico.png" height=30px title="Ghost data." />';
GHOSTDATA._lastProcessedUser = "";
GHOSTDATA.ignore_pats = [];
GHOSTDATA.temp_only_deletes = [];

GHOSTDATA.init=function() {
    console.log("%cinit GHOSTDATA", TALK.bgblackblue);
}

GHOSTDATA.pendingSelf=function() {
    if (ANNE.USER._userNObj==null) return false;
    for (var r=0; r < ANNE.USER._userNObj.outs.length; r++) {
        if ( ANNE.USER._userNObj.outs[r].ghost==true) return true;
    }
    return false;
}


/**
 * 
 */
GHOSTDATA.blastTest=function($tx_cnt = 10000, $amt_annies = 200) {
    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) return
    for(var t=0; t < $tx_cnt; t++) {

        ANNE.TXB.makePaymentAPICmd(ANNE.TXB.TXTYPE_SEND_FUNDS, 100, ANNE.USER._userNObj.nid,ANNE.MEM.ANNE_DEV_FUND_ACCTID, $amt_annies+t, false, "", true);
    
    }
    ANNE.SENDQ.___sendQueue(); 
}



/**
 * UNTESTED.
 * nuke temp onlys made to support the ghost we just broadcast and/or nuked.
 * @returns 
 */
GHOSTDATA.deleteTempOnlys=async()=> {
    if (GHOSTDATA.temp_only_deletes.length==0) return;
    await DB_local.___delete(GHOSTDATA.temp_only_deletes, "ghost_relons");
    var annihilated_txids = [];
    for (var t=0; t < GHOSTDATA.temp_only_deletes.length; t++) {
        if (MEM._aRelons_hashtbl[GHOSTDATA.temp_only_deletes[t]]!=undefined) {
            var rid = MEM._aRelons_hashtbl[GHOSTDATA.temp_only_deletes[t]];
            var rel = MEM._aRelons[rid];
            rel.dead = true;
            rel.from_nid=-1;
            rel.reln=-1;
            rel.to_s=-1;
            rel.type=-1;
            rel.to_type=-1;
            delete MEM._aRelons_hashtbl[GHOSTDATA.temp_only_deletes[t]]; 

            MEMP.annihilateRelon_RAM(rel, annihilated_txids); 
        }       
    }
    GHOSTDATA.temp_only_deletes = [];
}



GHOSTDATA.hasGhosts = function() {
    for (var r=0; r < MEM._aRelons.length; r++) {
        if (MEM._aRelons[r].ghost==true) return true;
    }
    return false;
}


/**
 * When we delete relons we can't delete them from the _aRelons array
 * or it would throw all RIDs and indexes off.
 * We mark them as dead for the session.
 * We only  need to check that if we loop the _aRelons... as
 * the hash is deleted and it won't be found by txid.
 */
GHOSTDATA.getGhosts = function() {
    var rels = [];
    for (var g=0; g < MEM._aRelons.length; g++) {
        if (MEM._aRelons[g].ghost==true) {
            if (MEM._aRelons[g].dead!=undefined && MEM._aRelons[g].dead==true) continue;
            rels.push(MEM._aRelons[g]);
        }
    }
    return rels;
}


GHOSTDATA.sendAllGhosts=async($callback=null)=>{
    var ghost_to_anneOBJ = new ghost_to_anne(USER._userNObj);
    var bSKIPGLOBALS = false;
    var bAUTOHANAI = true;
    if (ANNE.SETTINGS!=null) bAUTOHANAI = ANNE.SETTINGS.bAUTOHANAI;

    await ghost_to_anneOBJ.update(USER._userNObj, 0, true, bSKIPGLOBALS, bAUTOHANAI);
    console.log(ghost_to_anneOBJ);
    await ANNE.SENDQ.___sendQueue($callback);
}


/**
 * // -- > we're not doing this anymore.. we're using "position" instead of occupation.
 * 
 * we are NOT trying to categorize or create a tree here.
 * we use this to create new occupations and other generalized terms.
 * we do not fret with classification --- that can be done with dynamic lateral relons
 * such as a BE relon to say this is an "occupation"
 */
GHOSTDATA.makeNewOccupation = async($name)=> {
    var NewLivingThing = await GHOSTDATA.makeGhostNeuron(MEM.ec_living, $name, NTYPE_CLASS);
    return await GHOSTDATA.new_ghost_be(NewLivingThing, ANNE.MEM.ec_is.nid, TO_TYPE_ANNE, ANNE.MEM.position.nid);
}


/**
 * quick ghost a new neuron
 */
GHOSTDATA.makeGhostNeuron=async($classNOBJ, $text, $ntype=NTYPE_INST, $annies=0)=>{
    if ($classNOBJ==null || $text=="") {
        console.log("WE HAVE A MAJOR PROBLEM! ALL NEURONS MUST HAVE A CLASSNOBJ AND TEXT!!");
        return null;
    }
    var newGhostNOBJ = await ANNE.MEM.makeGhostNObj(ANNE.USER._userNObj.nid, $ntype, $text, $classNOBJ, true, true);
    
    newGhostNOBJ.bNEW=true;
    if ($annies!=0 && newGhostNOBJ.outs.length) {
        for (var r=0; r < newGhostNOBJ.outs.length; r++) {
            if (newGhostNOBJ.outs[r].type==TYPE_BE && (newGhostNOBJ.outs[r].r==ANNE.MEM.inst.temp_nid || newGhostNOBJ.outs[r].r==MEM.class.temp_nid)) {
                newGhostNOBJ.outs[0].annies=$annies;    //this will be the TYPE_BE
            }
        } 
    }

    var done = await ANNE.GHOSTDATA.localGhostTheRelons(newGhostNOBJ.outs, true);

    //last/first/middle or initial relons will be created auto via adoption into ANNE worldview via hanai
    /*
    if ($classNOBJ.nid==MEM.person.nid) {
        var suffix = ["jr", "jr.", "sr", "sr.", "iii", "ii", "iv", "i", "v", "vi", "vii", "viii", "ix"];
        var parts = $text.split(" ");
        if (parts.length > 2) {
            var firstName = parts[0];
            var lastName = parts[ parts.length-1];
            var lowerlast = lastName.toLowerCase();
            if (parts.length>3 && suffix.indexOf(lowerlast)!=-1) {
                return newGhostNOBJ;
            }
            var alias = firstName + " "+ lastName;
    
            //this helps us when matching.
            await GHOSTDATA.new_ghost_be(newGhostNOBJ, MEM.aka.nid, TO_TYPE_STRING, alias);
        }
    }
    */
    
    ANNE.playSound("flip");
    newGhostNOBJ.ghost=true;
    return newGhostNOBJ;
}



/**
 * quick ghost a new relon
 */
GHOSTDATA.makeGhostRelon = async($type, $fromNOBJ=null, $reln="", $to_type="", $to_s="", $annies=0)=>{
    if (($fromNOBJ instanceof anne_neuron) == false) return null;
    if (($reln instanceof anne_neuron) == true) {
        console.warn("pass nid not neuron for reln in makeGhostRelon! (we fixed it run-time)");
        $reln = $reln.nid;
    }
    if ($reln=="" || $to_type=="" || $to_s=="") return null;
    
    if ($type==TYPE_HAS) return await GHOSTDATA.new_ghost_has($fromNOBJ, $reln, $to_type, $to_s);
    else if ($type==TYPE_PARAM) return await GHOSTDATA.new_ghost_param($fromNOBJ, $reln, $to_type, $to_s);
    else if ($type==TYPE_SYS) return await GHOSTDATA.new_ghost_sys($fromNOBJ, $reln, $to_type, $to_s, $annies);
    else if ($type==TYPE_BE) return await GHOSTDATA.new_ghost_be($fromNOBJ, $reln, $to_type, $to_s);
    else if ($type==TYPE_BRAIN) return await GHOSTDATA.new_ghost_brain($fromNOBJ, $reln, $to_type, $to_s)
    else if ($type==TYPE_ROLE) return await GHOSTDATA.new_ghost_role($fromNOBJ, $reln, $to_type, $to_s)
    else if ($type==TYPE_SYS_MSG) return await GHOSTDATA.new_ghost_sys_msg($fromNOBJ, $reln, $to_type, $to_s, $annies)
    else if ($type==TYPE_AWARENESS) return await GHOSTDATA.new_ghost_awareness($fromNOBJ, $reln, $to_type, $to_s, $annies)
    return null;
}

/**
 * Make a new ghost neuron with a relon that points to it.
 * 
 * @param {anne_neuron} - the class of neuron to create
 * @param {string} - the text (name) of the relon to create
 * @param {anne_neuron} - the from neuron to make the relon
 * @param {int} - the TYPE of relon
 * @param {string} - nid long string of the reln of the relon
 * 
 * @author {Mr.Scatman}
 */
GHOSTDATA.newGhostWithRelon=async($classNOBJ, $text, $fromNOBJ=null, $type="", $reln="")=>{
    var ghostObj = {nObj:null, rel:null};
    if (($classNOBJ instanceof anne_neuron) == false) return ghostObj;

    ghostObj.nObj = await GHOSTDATA.makeGhostNeuron($classNOBJ, $text);

    if (($fromNOBJ instanceof anne_neuron) == false) return ghostObj;
    if ($type=="" || $reln=="") return ghostObj;
    
    ghostObj.rel = await GHOSTDATA.makeGhostRelon($type, $fromNOBJ, $reln, TO_TYPE_ANNE, ghostObj.nObj.nid);
    return ghostObj;
}



/**
* @author {Mr.Scatman}
*/
GHOSTDATA.new_ghost_has=async($fromNOBJ, $reln, $to_type, $to_s)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }
    
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_HAS, $reln, $to_type, $to_s, true);
    if (rObj==undefined || rObj==null) {
        console.log("problem with has relon creation!!");
        return null;
    }
    rObj.relon_sponsor = ANNE.USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}


/**
* @author {Mr.Scatman}
*/
GHOSTDATA.new_ghost_param=async($fromNOBJ, $reln, $to_type, $to_s)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }

    //if a PARAM has a non TO_TYPE_ANNE to_type this is incorrectly formed.
    //We can presume that the TO should be of that type ---- so let's audit that much.
    //We will force to the TO_TYPE to be TO_TYPE_ANNE as the PARAM itself informs us
    //of the TO_TYPE the param will be making via the TO_S's terminating type definition.
    //ie, if the to_s is the "url" neuron then we know the PARAM relon will create a HAS relon with a TO_TYPE_URL TO_TYPE.
    if ($to_type!=TO_TYPE_ANNE){
        console.log("(new_ghost_param) to_type override to TO_TYPE_ANNE!")
        var toNOBJ_audit = MEMG.getNeuronByNid($to_s);
        var TTOBJ = MEMG.getSysToTypeObjByType($to_type);
        if (toNOBJ_audit.is(TTOBJ)==false) {
            console.log("TYPE MISMATCH WITH TO_TYPE AND TO_S!")
        }
    }

    //all params are TO_TYPE_ANNE!
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_PARAM, $reln, TO_TYPE_ANNE, $to_s, true);
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}


/**
* @author {Mr.Scatman}
*/
GHOSTDATA.new_ghost_sys = async($fromNOBJ, $reln, $to_type, $to_s, $annies=0)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }
    if ($reln==undefined || $reln==null) return null;
    if ($to_type==undefined || $to_type==null) return null;
    if ($to_s==undefined || $to_s==null || $to_s=="") return null;
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_SYS, $reln, $to_type, $to_s, true);
    if (rObj==null) return null;
    
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    if ($annies!=0) rObj.annies = $annies;
    MEMZ.ez_setNARRPtrsForNew(rObj);
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}


/**
 * @author {Mr.Scatman}
 */
GHOSTDATA.new_ghost_be = async($fromNOBJ, $reln, $to_type, $to_s)=> {

    //can't create ghost data if the app doesn't have a user obj.  (loggin!)
    if (USER==null) {
        alert("sign in to app");
        return;
    }
    
    //we change the text w/ it in the send q.  If they undo.. we need this value.
    //only relevant in TYPE BE name relons.
    if ($reln==MEM.name.nid) {
        $fromNOBJ.rollbackText = $fromNOBJ.text; 
        $fromNOBJ.text = $to_s;
    }
    //every new new_ghost_be is now a ghost.
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_BE, $reln, $to_type, $to_s, true);
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    MEMZ.ez_setNARRPtrsForNew(rObj);
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}


   
/**
* @author {Mr.Scatman}
*/
GHOSTDATA.new_ghost_role=async($fromNOBJ, $reln, $to_type, $to_s, $bMAKE_GHOST=true, $bSETROLE=true)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_ROLE, $reln, $to_type, $to_s, true);
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    
    if ($bMAKE_GHOST==true) {
        var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    }

    //a solid favor, thanks fren.
    if ($bSETROLE==true) {
        var relnNOBJ = MEMG.getNeuronByNid($reln);
        $fromNOBJ.addRole(relnNOBJ.text.toLowerCase(), rObj);
    }

    return rObj;
}


/**
* @author {Mr.Scatman}
*/
GHOSTDATA.new_ghost_brain=async($fromNOBJ, $reln, $to_type, $to_s)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_BRAIN, $reln, $to_type, $to_s, true);
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}

GHOSTDATA.new_ghost_awareness=async($fromNOBJ, $reln, $to_type, $to_s)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }

    //if fromNOBJ is not an identity this is not a valid relon.
    if ($fromNOBJ.is(MEM.identity)==false) {
        console.log("only IDENTITIES can submit awareness relons.");
        return null;
    }

    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_AWARENESS, $reln, $to_type, $to_s, true);
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}

/**
 * For most uses we do not want to ghost a sys msg.. we send it straight-away.
 * There are cases where we do want to ghost it.
 * @author {Mr.Scatman}
 */
GHOSTDATA.new_ghost_sys_msg=async($fromNOBJ, $reln, $to_type, $to_s, $annies=0)=> {
    if ($fromNOBJ==null) {
        console.log("we need a neuron (temp or real) here");
        return null;
    }
    var rObj = MEM.makeTempRelon($fromNOBJ, TYPE_SYS_MSG, $reln, $to_type, $to_s, true);
    rObj.relon_sponsor = USER._userNObj.nid;
    USER._userNObj.addUsAsRelonSponsor(rObj);
    if ($annies!=0) rObj.annies = $annies;
    var done = await ANNE.GHOSTDATA.localGhostTheRelons([rObj]);
    return rObj;
}


/**
 * Delete ghost neurons (and all out/in relons)
 * Delete all other ghost relons (from known to known)
 */
GHOSTDATA.deleteAllGhosts = async()=>{
    console.log("delete all ghost data");
    var nids_deleted = [];
    for (var n=0; n < MEM._aNeurons.length; n++) {
        if (MEM._aNeurons[n].ghost==false) continue;
        var nObj = MEM._aNeurons[n];
        if (nObj.ghost==false || nObj.nid[0]!="z") continue;
        nids_deleted.push(nObj.nid);
    }

    //do them all once.
    await GHOSTDATA._annihilateGhostNids(nids_deleted);

    var solo_ghost_txids = [];
    for (var r=0; r < MEM._aRelons.length; r++) {
        if (MEM._aRelons[r].ghost==false) continue;
        solo_ghost_txids.push(MEM._aRelons[r].txid);
    }
    if (solo_ghost_txids.length) {
        console.log("solo ghosts to delete:"+solo_ghost_txids.length);
        await GHOSTDATA.deleteGhostTxidsFull(solo_ghost_txids);
    }
    return nids_deleted;
}


/**
 * A rudimentary list of potential ghost dupes to help the user with the ghost gui.
 * 
 * discount names that have jr/sr added to them.  They are not dupe candidates (unless both have it)
 * @param {*} $nObj 
 * @returns 
 */
GHOSTDATA.potentialDupes=function($nObj) {
    var dupes = [];
    var ends = ["jr", "sr", "I.", "II.", "III.", "IV.", "V.", "VI."];
    var lowertxt = $nObj.text.toLowerCase();
    for (var n=0; n < MEM._aNeurons.length; n++) {
        var nObj = MEM._aNeurons[n];
        if (nObj.ghost==false) continue;
        if (nObj.nid==$nObj.nid) continue;
        if (nObj.bes.length==0) continue;
        if ($nObj.bes.length==0) continue;
        if (nObj.bes[0]!=$nObj.bes[0]) continue;
        
        var i = lowertxt.indexOf(nObj.text.toLowerCase());
        var bDUPE=false;
        
        if (i==0) {
            bDUPE=true;
            var remain = lowertxt.substring(nObj.text.length+1).trim().toLowerCase();
            for (var e=0; e < ends.length; e++) {
                if (remain.indexOf(ends[e])!=-1) {
                    bDUPE=false;
                    continue;
                }    
            }
            if (bDUPE==true) {
                dupes.push(nObj);
            }
            continue;
        } 
        
        var ii = nObj.text.toLowerCase().indexOf(lowertxt);
        if (ii==0) {
            bDUPE=true;
            var remain = nObj.text.substring(lowertxt.length+1).trim().toLowerCase();
            for (var e=0; e < ends.length; e++) {
                if (remain.indexOf(ends[e])!=-1) {
                    bDUPE=false;
                    continue;
                }    
            }
            if (bDUPE==true) {
                dupes.push(nObj);
            }
            continue;
        } 
    }
    return dupes;
}


/**
 * Used when merging a ghost neuron into a ghost neuron to check for dupe info.
 * We don't want to keep the merged relon around if we already have that info.
 * @param {*} $rels 
 * @param {*} $rel 
 * @param {*} $ignoreSlot 
 * @returns 
 */
GHOSTDATA.ghostHasGhostRel = function($rels, $rel, $ignoreSlot="from_nid") {
    for (var r=0; r < $rels.length; r++) {
        var thisrel = $rels[r];
        if ($ignoreSlot=="from_nid") {
            if (thisrel.type!=$rel.type) continue;
            if (thisrel.reln!=$rel.reln) continue;
            if (thisrel.to_type!=$rel.to_type) continue;
            if (thisrel.to_s!=$rel.to_s) continue;
            return true;
        }
        else {
            if (thisrel.from_nid!=$rel.from_nid) continue;
            if (thisrel.type!=$rel.type) continue;
            if (thisrel.reln!=$rel.reln) continue;
            if (thisrel.to_type!=$rel.to_type) continue;
            return true;
        }
    }
    return false;
}


/**
 * 
 * @param {*} $nObj 
 * @param {*} $alias 
 * @returns 
 */
GHOSTDATA.addAlias=async($nObj, $alias) =>{
    var ghostRelon = await GHOSTDATA.new_ghost_be($nObj, MEM.aka, TO_TYPE_STRING, $alias);
    $nObj.addAka(ghostRelon);
    return;
}



/**
 * 
 * @param {*} $survivor_nid 
 * @param {*} $absorbed_nid 
 * @returns 
 */
GHOSTDATA.mergeGhosts=async($survivor_nid, $absorbed_nid)=> {
    var sNOBJ = MEMG.getNeuronByNid($survivor_nid);
    if (sNOBJ==null) return;
    if (sNOBJ.ghost==false) return;

    var aNOBJ = MEMG.getNeuronByNid($absorbed_nid);
    if (aNOBJ==null) return;
    if (aNOBJ.ghost==false) return;

    var relsToDelete = [];
    var old_name = aNOBJ.text;
    for (var g=0; g < aNOBJ.outs.length; g++) {
        var ghost_rel = aNOBJ.outs[g];

        if (GHOSTDATA.ghostHasGhostRel(sNOBJ.outs, ghost_rel, "from_nid")==false) {
            ghost_rel.from_nid = $survivor_nid;
            ghost_rel.f = sNOBJ.temp_nid;
            await GHOSTDATA.updateDBSingleGhostRelon(ghost_rel);
        }
        else relsToDelete.push(ghost_rel);
    }

    var keep_name = sNOBJ.text;
    for (var g=0; g < aNOBJ.ins.length; g++) {
        var ghost_rel = aNOBJ.ins[g];
        if (GHOSTDATA.ghostHasGhostRel(sNOBJ.ins, ghost_rel, "to_s")==false) {
            ghost_rel.to_s = $survivor_nid;
            ghost_rel.t = sNOBJ.temp_nid;
            await GHOSTDATA.updateDBSingleGhostRelon(ghost_rel);
        }
        else relsToDelete.push(ghost_rel);
    }

    if (old_name!=keep_name) {
        await GHOSTDATA.addAlias(sNOBJ, old_name);
    }
    
    //delete these in ghost meme
    if (relsToDelete.length) {
        await GHOSTDATA.deleteGhostTxidsFull(relsToDelete);
    }

    if (ANNE.PAGES!=null) {
        ANNE.PAGES.removeHistory([aNOBJ.nid]);
    }

    await GHOSTDATA._annihilateGhostNeuron(aNOBJ);

    if (ANNE.ACE!=null) {
        ANNE.ACE.neuronDeleted(aNOBJ.nid);
    }
}


    
/**
 * Quickly clone a neuron.
 * @param {*} $nid 
 */
GHOSTDATA.quickClone = async($nid)=> {
    var nObj = MEMG.getNeuronByNid($nid);
    var parent = nObj.getParent();
    var cloneNOBJ = await GHOSTDATA.makeGhostNeuron(parent, nObj.text+" (clone)", nObj.ntype);
    for (var r=0; r < nObj.outs.length; r++) {
        if (nObj.outs[r].type==TYPE_BE && nObj.outs[r].r==ANNE.MEM.name.temp_nid) continue;
        if (nObj.outs[r].type==TYPE_BE && 
            (nObj.outs[r].r==ANNE.MEM.class.temp_nid || nObj.outs[r].r==ANNE.MEM.inst.temp_nid)) continue;
        var rel = nObj.outs[r];
        await GHOSTDATA.makeGhostRelon(rel.type, cloneNOBJ, rel.reln, rel.to_type, rel.to_s);
    }
    if (this.PAGES!=null) {
        this.PAGES.launchNeuron(cloneNOBJ.nid, "dossier");
    }
}


//appointed by, preceeded by, succeeded by
GHOSTDATA.createAffectedThingAction=async($action, $actionL2)=>{
    var newActionPresentTense = await GHOSTDATA.makeGhostNeuron(ANNE.MEM.ec_action, $action, NTYPE_CLASS);
    var language = ANNE.MEMG.getOrMakeIfNew("7777662227658988771");
    var ENG = ANNE.MEMG.getOrMakeIfNew("777722641707973679");
    var ec_action_to_affected_thing = ANNE.MEM.getOrMakeIfNew("9257684190024618868");
    var vb_form = ANNE.MEMG.getOrMakeIfNew("5489825729469988645");
    var V1 = ANNE.MEMG.getOrMakeIfNew("2355561758022526353");
    var V2 = ANNE.MEMG.getOrMakeIfNew("2961294413712646030");

    await GHOSTDATA.makeGhostRelon(TYPE_BE, newActionPresentTense, language.nid, TO_ANNE_TYPE, ENG.nid);
    await GHOSTDATA.makeGhostRelon(TYPE_BE, newActionPresentTense, ANNE.MEM.ec_is.nid, TO_ANNE_TYPE, ec_action_to_affected_thing.nid);
    await GHOSTDATA.makeGhostRelon(TYPE_BE, newActionPresentTense, vb_form.nid, TO_ANNE_TYPE, V1.nid);

    var newActionPastTense = await GHOSTDATA.makeGhostNeuron(newActionPresentTense.nid, $actionL2, NTYPE_CLASS);
    await GHOSTDATA.makeGhostRelon(TYPE_BE, newActionPastTense, vb_form.nid, TO_ANNE_TYPE, V2.nid);
    await GHOSTDATA.makeGhostRelon(TYPE_HAS, newActionPastTense, vb_form.nid, TO_ANNE_TYPE, V2.nid);
    await GHOSTDATA.makeGhostRelon(TYPE_HAS, newActionPresentTense, V2.nid, TO_ANNE_TYPE, newActionPastTense.nid);

    return newActionPastTense;
}


/**
 * 
 * @param {*} $nids 
 * @returns 
 */
GHOSTDATA._annihilateGhostNids=async($nids)=> {
    if ($nids==null) return;
    console.log("(GHOSTDATA._annihilateGhostNids) cnt: "+$nids.length);
    var ghost_txids = [];
    var real_txids = [];

    await MEM.removeTextIndexByNids($nids);
    
    for (var n =0; n  <$nids.length; n++) {
        var nObj = MEMG.getNeuronByNid($nids[n]);
        if (ANNE.PAGES!=null) {
            ANNE.PAGES.removeHistory([nObj.nid]);
        }
        var annilated = MEMP.annihilate_RAM(nObj, null, false);  
    
        for (var a=0; a < annilated.length; a++) {
            var txid = annilated[a];
            if (txid[0]=="z") ghost_txids.push(txid);
            else real_txids.push(txid);
        }
    }

    if (real_txids.length) {
        alert("you have real relons connected to your ghost.. this is baaaaaaaad");
        console.log(real_txids);
        ANNE.TALK.printRelons(real_txids);
    }
    if (ghost_txids.length) {
        await GHOSTDATA.deleteGhostTxids(ghost_txids);  
    }
}


/**
 * 
 * @param {*} $nObj 
 * @returns 
 */
GHOSTDATA._annihilateGhostNeuron=async($nObj)=> {
    if ($nObj==null) return;
    if (ANNE.SETTINGS.debug()==true) console.log("(GHOSTDATA._annihilateGhostNeuron) "+$nObj.text)
    
    //console.log("%c ANNIHILATE GHOST NEURON %c"+$nObj.text, TALK.bgblackblue, TALK.bgblackgreen);
    if ($nObj.ghost==false || $nObj.nid[0]!="z") return;

    if (ANNE.PAGES!=null) {
        ANNE.PAGES.removeHistory([$nObj.nid]);
    }

    var annilated = MEMP.annihilate_RAM($nObj);   //this will kill the text index too
    var ghost_txids = [];
    var real_txids = [];
    for (var a=0; a < annilated.length; a++) {
        var txid = annilated[a];
        if (txid[0]=="z") ghost_txids.push(txid);
        else real_txids.push(txid);
    }
    if (real_txids.length) {
        alert("you have real relons connected to your ghost.. this is baaaaaaaad");
        console.log(real_txids);
        ANNE.TALK.printRelons(real_txids);
    }
    if (ghost_txids.length) {
        await GHOSTDATA.deleteGhostTxids(ghost_txids);  
    }

}



/**
 * 
 * @param {*} $tnids 
 * @param {*} $nObj 
 * @returns 
 */
GHOSTDATA.deleteByTnidsMap=async($tnids, $nObj)=> {
    if ($tnids==null) return;
    var keys = Object.keys($tnids);
    var txids = [];
    var handled_nids = [];
    for (var k=0; k < keys.length; k++) {
        var key = keys[k];

        //$tnids map is keys of tnids in an assoc array with nOBJS as the object
        var nObj = $tnids[key]; 
        if (nObj.ghost==false && key[0]!="z") {
            //alert("this is not a ghost neuron!");
            continue;
        }
        await GHOSTDATA._annihilateGhostNeuron(nObj);
        handled_nids.push(nObj.nid);
    }
    if ($nObj!=null && handled_nids.indexOf($nObj.nid)==-1) {
        await GHOSTDATA._annihilateGhostNeuron($nObj);
    }
    return;
}


/**
 * 
 * @param {*} $txids 
 * @returns 
 */
GHOSTDATA.deleteGhostTxidsFull=async($txids)=>{
    for (var t=0; t < $txids.length; t++) {
        await GHOSTDATA.deleteSingleGhostRelon($txids[t]);
    }
    return;
}


/**
 * 
 * @param {*} $txid 
 * @returns 
 */
GHOSTDATA.deleteSingleGhostRelon=async($txid)=> {
    var annihilated_txids = [];
    var relon = MEMG.lookupByTXID($txid);
    
    //ensure it is gone from ghost memeory.
    if (relon==null) {
        await GHOSTDATA.deleteGhostTxids([$txid]);            
        return;
    }

    MEMP.annihilateRelon_RAM(relon, annihilated_txids);  

    if (annihilated_txids.length) {
        await GHOSTDATA.deleteGhostTxids(annihilated_txids);        
    }
}


/**
 * 
 * @param {*} $txids 
 */
GHOSTDATA.deleteGhostTxids=async($txids)=>{
    await DB_local.___delete($txids, "ghost_relons");
     
    //delete the hash tbl entry pointing the old ghost txid to the relon
    //we don't want this to find the relon.
    //this should have been done in __hashRelonUpdate_AFTER_SEND -> __deleteRelonHash
    //but let's make sure.
    for (var t=0; t < $txids.length; t++) {
        if (MEM._aRelons_hashtbl[$txids[t]]!=undefined) {
            var rid = MEM._aRelons_hashtbl[$txids[t]];
            var rel = MEM._aRelons[rid];
            rel.dead = true;
            rel.from_nid=-1;
            rel.reln=-1;
            rel.to_s=-1;
            rel.type=-1;
            rel.to_type=-1;
            delete MEM._aRelons_hashtbl[$txids[t]]; 
        }
    }
}


/**
 */
GHOSTDATA.updateRelonTo=async($rel, $newval)=>{
    if ($rel.to_type==TO_TYPE_ANNE) {
        var oldtoNOBJ = MEMG.getNeuronByTempNid($rel.t);
        for (var i=0; i  < oldtoNOBJ.ins.length; i++) {
            if (oldtoNOBJ.ins[i].txid==$rel.txid) {
                oldtoNOBJ.ins.splice(i, 1);
                break;
            }
        }
        $rel.to_s=$newval;
        var newtoNOBJ = MEMG.getNeuronByNid($rel.to_s);
        $rel.t = newtoNOBJ.temp_nid;
        newtoNOBJ.ins.push($rel);
    }

    else {
        ANNE.MEM.editTextIndex($rel.to_s, $newval, $rel.from_nid);
        $rel.to_s=$newval;
    }

    //update ghost mem.
    return await GHOSTDATA.updateDBSingleGhostRelon($rel);
}



/**
 * We can edit anything we like other than the temp txid.
 * This cannot be edited as it is the key.
 */
GHOSTDATA.updateDBSingleGhostRelon=async($rel)=> {
    console.log("(updateDBSingleGhostRelon)", $rel);
    return await DB_local.___update($rel, "ghost_relons");
}

GHOSTDATA.cloneToGhostThenPrune=async($relon)=>{
    var fromNOBJ = MEMG.getNeuronByTempNid($relon.f);
    await GHOSTDATA.makeGhostRelon($relon.type, fromNOBJ, $relon.reln, $relon.to_type, $relon.to_s);
    
    //should check rights for this... hmm.
    //await ANNE.makeArborPruneByTXID($relon.txid);

    //lets update our own mem
    ANNE.MEMP.processNeuronsFromRelons([$relon], false, true, "relons", "GHOSTDATA.cloneToGhostThenPrune");
}


/**
 * We want to check these again against our ANNODE
 * for updates.
 * @param {*} $ghostrelons 
 */
GHOSTDATA.recheckAll=async($ghostrelons)=>{
    var ghostNeurons = new arraymap();
    
    for (var g=0; g < $ghostrelons.length; g++) {
        var nObj = MEMG.getNeuronByTempNid($ghostrelons[g].f);
        if (nObj.ghost==true) {
            ghostNeurons.addUnique(nObj, nObj.nid);
        }
    }

    console.log(ghostNeurons);


    //this sucks to write.. will do it later.  Meh.
    for (var g=0; g < ghostNeurons.arr.length; g++) {
        var ghostNOBJ = ghostNeurons.arr[g];
        
        if (ghostNOBJ.bes[0]==MEM.date_gregorian.temp_nid) {
            var result = await CHASE.getGlobal(MEM.date_gregorian, $nObj.text);
            console.log(result);
        }
        else if (ghostNOBJ.bes[0]==MEM.person.temp_nid) {
            console.log("person");
        }  
    }
}



/**
 * Take temp relons and turn them into ghosts.
 * Update localStorage db memory with new relons.
 * 
 * ALL GHOSTS SHOULD BE RUN THROUGH HERE!!!!
 */
GHOSTDATA.localGhostTheRelons = async ($relons)=> {
    if (ANNE.DB_local==undefined || ANNE.DB_local==null) {
        console.log("%ccan't ghost relons w/o a local DB_local set up in app_db", TALK.bgred);
        return;
    }
    var newGhosts = [];
    var allGoodGhosts = [];
    
    if ($relons==undefined || $relons==null || $relons.length==0) return;
    for (var r=0; r < $relons.length; r++) {
        var relon = $relons[r];
        if (relon==undefined || relon==null) {
            console.log("clean up your relons array!");
            $relons.splice(r, 1);
            r=r-1;
            continue;
        }
        
        if (relon.ghost==true) {
            allGoodGhosts.push(relon);
            continue;         //this is already a ghost.
        }

        relon.ghost=true;
        relon.ghost_owner = USER._userNObj.nid;
        relon.ghost_order = MEM._nextGhostOrder++;
        relon.mine = true;    //all ghosts are mine=true;
        relon.temp = false;   //ghosts are NOT temp anymore (they are ghosts)

        //the neuron is also ghost if it was a temp and we ghosted any of its relons.
        //it could be a REAL NEURON and we are only ghosting a relon.. so it is not a ghost
        //if it is not a temp.
        var fromNOBJ = MEMG.getOrMakeIfNew(relon.from_nid);

        if(fromNOBJ.temp==true) {
            fromNOBJ.ghost=true;
            fromNOBJ.owned_by=USER._userNObj.nid;
        }
        else relon.owned_by = fromNOBJ.owned_by; //someone else owns the neuron.

        newGhosts.push(relon);
        allGoodGhosts.push(relon);
        MEM_UDF._ghost_rels.push(relon);    //keep around for user switch and easy remove
    }
    

    //insert relon into ghosted db.
    if (newGhosts.length) {
        var done = await ANNE.DB_local.___insert(newGhosts, "ghost_relons");
    }
    
    //process the relons into their respective neuron and relon arrays
    //just if they are coming into the app normally.
    var bRETURNALL = false;
    var bDOINGLOCALSAVE = false;
    if (relon.reln==ANNE.MEM.CMD_FREEZE.nid) {
        relon.freeze = 1;
    }
    await MEMP.processNeuronsFromRelons(newGhosts, bRETURNALL, bDOINGLOCALSAVE, "relons", "GHOSTDATA.localGhostTheRelons")

    return allGoodGhosts;
}


/**
 * These are temp supporters of ghosts until they become real.
 * THEY DO NOT GET BROADCAST!!!!
 * @param {*} $relons 
 * @returns 
 */
GHOSTDATA.tempOnlyTheRelons = async ($relons)=> {
    if (ANNE.DB_local==undefined || ANNE.DB_local==null) {
        console.log("%ccan't ghost relons w/o a local DB_local set up in app_db", TALK.bgred);
        return;
    }
    var newTempOnlys = [];
    var allGoodTempOnlys = [];
    
    if ($relons==undefined || $relons==null || $relons.length==0) return;
    for (var r=0; r < $relons.length; r++) {
        var relon = $relons[r];
        if (relon==undefined || relon==null) {
            console.log("clean up your relons array!");
            $relons.splice(r, 1);
            r=r-1;
            continue;
        }
        
        if (relon.TEMP_ONLY==true) {
            allGoodTempOnlys.push(relon);
            continue;         //this is already a ghost.
        }

        relon.TEMP_ONLY=true;
        relon.ghost_owner = USER._userNObj.nid;
        relon.ghost_order = MEM._nextGhostOrder++;
        relon.mine = true;    //all ghosts are mine=true;
        relon.temp = false;   //TEMP ONLY ghosts are NOT temp anymore (they are TEMP ONLY ghosts)

        newTempOnlys.push(relon);
        allGoodTempOnlys.push(relon);
    }
    
    //insert relon into ghosted db.
    if (newTempOnlys.length) {
        var done = await ANNE.DB_local.___insert(newTempOnlys, "ghost_relons");
    }
    
    //process the relons into their respective neuron and relon arrays
    //just if they are coming into the app normally.
    var bRETURNALL = false;
    var bDOINGLOCALSAVE = false;
    await MEMP.processNeuronsFromRelons(newTempOnlys, bRETURNALL, bDOINGLOCALSAVE, "relons", "GHOSTDATA.tempOnlyTheRelons")
    return allGoodTempOnlys;
}


/**
 * Process any local ghosts.
 * This must be done AFTER the user chooses their login.
 * With multi-logins in the EXT the ghosts for that particular user change
 * even though they are stored in the same local indexedDB.
 * 
 * @author {Mr.Scatman} 
 */
 GHOSTDATA.processGhosts = async()=> {
    var ghosts = await DB_local.__getGhostsOnly();
    if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("(processing ghosts):"+ghosts.length, TALK.bgbluebig);
    if (ghosts.length) {
        var bGHOSTS=true;
        var _ghosts = [];
        for (var g=0; g < ghosts.length; g++) {
            if (ghosts[g].ghost_owner!=USER._userNObj.nid) continue;
            if (ghosts[g].txid[0]!=="z") {
                ANNE.TALK.printRelon(ghosts[g]);
                alert("non-ghost relon in ghost table!");
                await DB_local.___delete([ghosts[g].txid], "ghost_relons");
                continue;
            }

            if (ghosts[g].to_s=="") {
                await DB_local.___delete([ghosts[g].txid], "ghost_relons");
                continue;
            }
            
            _ghosts.push(ghosts[g]);
            
            //ANNE.TALK.printRelon(ghosts[g]);
            
            MEM_UDF._ghost_rels.push(ghosts[g]);
        }
        
        ghosts = _ghosts;  
        if (ANNE.SETTINGS.bCONSOLE_DEBUG==true) console.log("%c"+_ghosts.length+" ghosts apply to user "+USER._userNObj.nid, TALK.ghosts);

        ANNE.MEMP.sanitizeSRFR_Ghosts(ghosts, bGHOSTS);
        var rRETURNALL=false;
        var bDOLOCALSAVE=false;

        //local ghosts have a .ghost_owner on them set to the main identity
        //that has power to push them (local user)
        //they also have a .ghost_order to indicate importance of order in submission.
        //This is relevant when trying to submit relons for neurons before they are made!
        //This is mostly relevant for non-global type neurons/relons that users are creating
        //on their own for their own purposes.  Classes handled at L1 ANNE like
        //location/date/company/integer etc are done via direct API calls to the node
        //with a custom SYS relon that is then blown out in the ANNODE.
        if (ghosts.length==0) return;
        
        var ghosts = await ANNE.MEMP.processNeuronsFromRelons(ghosts, rRETURNALL, bDOLOCALSAVE, "relons", "GHOSTDATA.processGhosts");
        for (var g=0; g < ghosts.length; g++) {
            if (ghosts[g].ghost==false) {
                alert("FIX THIS JERKY");
                ghosts[g].ghost = true;
            }
            var fromNOBJ = MEMG.getNeuronByTempNid(ghosts[g].f);
            if (fromNOBJ.ghost==true) {
                if (USER._userNObj.owns.indexOf(fromNOBJ.temp_nid)==-1) {
                    fromNOBJ.addOwnedBy(USER._userNObj.nid);
                }
            }
        
            //ANNE.TALK.printRelon(ghosts[g]);
        }
    }

    //we need to remove ghosts from RAM that this new user is not author of!
    if (GHOSTDATA._lastProcessedUser!="" && GHOSTDATA._lastProcessedUser!=USER._userNObj.nid) {
        var removed_from_ram_only = [];
        for (var r=0; r < ANNE.MEM._aRelons.length; r++) {
            var rObj = ANNE.MEM._aRelons[r];
            
            //delete this solo relon from RAM.
            if (rObj.ghost==true && rObj.ghost_owner!=USER._userNObj.nid) {
                MEMP.annihilateRelon_RAM(rObj, removed_from_ram_only);    
            }
        }
        
        for (var n=0; n < ANNE.MEM._aNeurons.length; n++) {
            var nObj = ANNE.MEM._aNeurons[n];
            if (nObj.ghost==false) continue;
            if (nObj.owned_by==USER._userNObj.nid) continue;

            //remove local nObj and all outs/ins.
            MEMP.annihilate_RAM(nObj, removed_from_ram_only);   //this will kill the text index too
        }

        //console.log("removed from ram only", removed_from_ram_only);
    }

    GHOSTDATA._lastProcessedUser = USER._userNObj.nid;
}

/**
 * A known ANNE-owned neuron for a neuron we made a ghost for has been found.
 * Update our ghost to the known ANNE neuron.
 * 
 * Note - this does not transfer ghost out relons from the ghost (we are replacing).
 * If there are outs for new info on the ghost that gets updated, those outs are gone.
 * We could try to map those over auto  (ie, if u supplied a data pt on ur ghost that the 
 * updated ANNE neuron doesn't yet have)... but I don't have the bandwidth to chase that optimization
 * right now.
 */
GHOSTDATA.manualUpdateGhostToKnown = async($ghostNOBJ, $known_nid)=> {
    var ins = $ghostNOBJ.ins;
    var ghost_rels = [];
    for (var i=0; i < ins.length; i++) {
        ins[i].to_s = $known_nid;   //rewire to new known nid.
        ghost_rels.push(ins[i]);
    }
    $ghostNOBJ.ins = [];    //don't want to annhilate the relons we just updated.
    if (ghost_rels.length) {
        await GHOSTDATA.reprocessGhostRelonsForManualUpdates(ghost_rels);
    }
    await GHOSTDATA._annihilateGhostNeuron($ghostNOBJ);
    return;
}


/**
 * 
 * @param {*} $znids 
 */
GHOSTDATA.deleteZNIDS=async($znids)=>{
    for (var z=0; z < $znids.length; z++) {
        var ghostNOBJ = MEMG.getNeuronByNid($znids[z]);
        await GHOSTDATA._annihilateGhostNeuron(ghostNOBJ);
    }
}


/**
 * Add a quick relon from relon link btn syntax to ghost and/or send.
 * @param {*} $element 
 */
GHOSTDATA.makeRelonFromRelonLinkBtn = async($element, $bADDTOQ=true)=> {
    var from_nid = $element.getAttribute("new_relon_from");
    if (from_nid==null) return;
    var fromNOBJ = MEMG.getNeuronByNid(from_nid);

    var type = $element.getAttribute("new_relon_type");
    if (type==null) return;
    
    var reln = $element.getAttribute("new_relon_reln");
    if (reln==null) return;
    
    var to_type = $element.getAttribute("new_relon_to_type");
    if (to_type==null) return;
    
    var to_s = $element.getAttribute("new_relon_to_s");
    if (to_s==null) return;

    var annies = $element.getAttribute("new_relon_annies");
    if (annies==null) annies = "";
    
    var TXTYPE = $element.getAttribute("TXTYPE");
    if (TXTYPE==null) return;
    
    var ghostRel = await GHOSTDATA.makeGhostRelon(type, fromNOBJ, reln, to_type, to_s, annies);
    
    if ($bADDTOQ==false) return;

    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRel, false, TXTYPE);
    if (tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="makeRelonFromRelonLinkBtn sent.")=>{

    });
}


/**
 * fixes arrays in RAM
 */
GHOSTDATA.reprocessGhostRelonsForManualUpdates = async($reprocess_only_ghost_relons)=> {
    console.log("(reprocessGhostRelonsForManualUpdates) "+$reprocess_only_ghost_relons.length+" relons here");
    console.log($reprocess_only_ghost_relons);
    
    await ANNE.MEMP.processNeuronsFromRelons($reprocess_only_ghost_relons, true, false, "relons", "GHOSTDATA.reprocessGhostRelonsForManualUpdates");
    
    //audit
    for (var x=0; x < $reprocess_only_ghost_relons.length; x++) {
        var testRel = $reprocess_only_ghost_relons[x];
        var bPASSED = false;
        if (testRel.to_type==TO_TYPE_ANNE) {
            var TONOBJ = MEMG.getNeuronByTempNid(testRel.t);
            for (var i=0; i < TONOBJ.ins.length; i++) {
                if (TONOBJ.ins[i].txid==testRel.txid) {
                    console.log("audit passed!");
                    bPASSED=true;
                    break;
                }
            }

            if (bPASSED==false) {
                console.log("audit DID NOT PASS ", testRel);
            }
        }
    }
}


/**
 * Right now I manually invoke this using the console.
 * We can build a GUI to do this, time-permitting.
 * 
 * The lnts/admin flow of this works in the present gui once the requst is submit.
 * @param {*} $nid1 
 * @param {*} $nid2 
 * @returns 
 */
GHOSTDATA.mergeNeuronRequest=async($nid1, $nid2)=>{    
    var nObj1 = MEMG.getNeuronByNid($nid1);
    var ghostRelMerge = await GHOSTDATA.new_ghost_sys(nObj1, MEM.CMD_MERGE_NEURON.nid, TO_TYPE_ANNE, $nid2);
    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRelMerge, false, TXB.TXTYPE_COLLAB_REQ);
    if (tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="merge request sent.")=>{
        console.log("merge request for "+$nid1+" and "+$nid2+" has been sent ");
    });
}



/**
 * 
 * @param {*} $nid 
 * @returns 
 */
GHOSTDATA.redlistNidTest=async($nid)=>{    
    var ghostRelMerge = await GHOSTDATA.new_ghost_sys(ANNE.USER._userNObj, ANNE.MEM.REDLIST.nid, TO_TYPE_ANNE, $nid);
    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRelMerge, false, ANNE.TXB.TXTYPE_SELF_RELON);
    if (tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="redlist added.")=>{
        console.log($nid+" has been redlisted.");
    });
}


/**
 * 
 * @param {*} $ipv4 
 * @returns 
 */
GHOSTDATA.redlistIPV4Test=async($ipv4)=>{    
    var ghostRelMerge = await GHOSTDATA.new_ghost_sys(ANNE.USER._userNObj, ANNE.MEM.REDLIST.nid, TO_TYPE_IPV4, $ipv4);
    var tempCmdObj = await ANNE.SENDQ.addRelonToSendQ(ghostRelMerge, false, ANNE.TXB.TXTYPE_SELF_RELON);
    if (tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="redlist ipv4 added.")=>{
        console.log($ipv4+" has been redlisted.");
    });
}


/**
 * Short-hand syntax for replace TO A value of a relon.
 * ONLY POSSIBLE BY ANNE to save a prune.
 * NID_REPLACE_TO-> reln:the new to -> TO_TYPE_TXID-> the txid of the RELON which we want to replace the to_a of.
 */
GHOSTDATA.testReplaceTo=async($txid, $new_to)=>{
    var replace_to = "777383945773360537";
    var replaceToNOBJ = ANNE.MEMG.getOrMakeIfNew(replace_to);

    var relon = ANNE.MEMG.lookupByTXID($txid);
    if (relon==null) {
        console.warn("must have a relon in memory to attempt a testReplaceTo for that relon");
        return;
    }

    var newTO_test = ANNE.MEMG.getNeuronByNid($new_to);
    if (newTO_test==null) {
        await ANNE.API.getNeuronByNid($new_to);
        newTO_test = ANNE.MEMG.getNeuronByNid($new_to);
        if (newTO_test==null) {
            console.warn("the new to_a we are pushing into the relon must exist.");
            return;
        }
    }

    //must be a sys msg for this to work..
    var ghostRelReplaceTo = await GHOSTDATA.new_ghost_sys_msg(replaceToNOBJ, newTO_test.nid, TO_TYPE_TXID, $txid);
    var tempCmdObj = await ANNE.SENDQ.addRelonToSendQ(ghostRelReplaceTo, false, ANNE.TXB.TXTYPE_CHILD_RELON);
    if (tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="a drastic replace to_a cmd!!!")=>{
        console.log("a drastic replace to_a cmd, result: "+ $msg);
    });
}


/**
 * call this with new verion like "6.8.8".
 * A sys message will be broadcast out to the annodes.
 * @param {*} $newV 
 * @param {*} $required 
 * @returns 
 */
GHOSTDATA.versionAnnouncement=async($newV, $required=false)=>{
    var parts = $newV.split(".");
    if (parts.length!=3) {
        console.warn("must be 3 parts to version");
        return;
    }
    for (var p=0; p < parts.length; p++) {
        var part = parts[p];
        if (isNaN(part)==true) {
            console.warn("version must be integers seperated by dots");
            return;
        }
    }
    var optional = "";
    if ($required==false) optional = " optional.";
    var msg = "v"+$newV+" published."+optional;
    return await GHOSTDATA.makeSysAnnouncement(msg);
}


/**
 * 
 * @param {*} $msg 
 * @returns 
 */
GHOSTDATA.makeSysAnnouncement=async($msg)=>{    
    var ghostRelMerge = await GHOSTDATA.new_ghost_sys(ANNE.USER._userNObj, ANNE.MEM.ANNE_SYS_ANNOUNCEMENT.nid, TO_TYPE_BLOB, $msg);
    var tempCmdObj = await ANNE.SENDQ.addRelonToSendQ(ghostRelMerge, false, ANNE.TXB.TXTYPE_SELF_RELON);
    if (tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="sys announcement broadcast.")=>{
        console.log("sys announcement broadcast: "+ $msg);
    });
}


/**
 * 
 * @param {*} $nid 
 * @returns 
 */
GHOSTDATA.makeNecrosis=async($nid)=>{
    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) {
        console.warn("only for anne admin here");
        return;
    }
    var neuronToNuke = ANNE.MEMG.getNeuronByNid($nid);
    if (neuronToNuke==null) return;
    GHOSTDATA.new_ghost_sys(ANNE.USER._userNObj, MEM.necrosis.nid, TO_TYPE_ANNE, neuronToNuke.nid)
}



/**
 * only will work on the node from an ANNE acct.
 * @param {*} $msg 
 */
GHOSTDATA.makeBrickPoint=async($msg, $block, $version)=>{    
    var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(MEM.ANNE_BRICK_POINT, "brick "+$block, NTYPE_INST);

    var rel_msg = await GHOSTDATA.makeGhostRelon(TYPE_HAS, ghostNOBJ, MEM.ANNE_BRICK_PT_MSG.nid, TO_TYPE_BLOB, $msg);
    
    var rel_minv = await GHOSTDATA.makeGhostRelon(TYPE_HAS, ghostNOBJ, MEM.ANNE_BRICK_PT_MIN_V.nid, TO_TYPE_STRING, $version);
    
    var rel_activation_block = await GHOSTDATA.makeGhostRelon(TYPE_HAS, ghostNOBJ, MEM.ANNE_BRICK_PT_ACTIVATION_BLOCK.nid, TO_TYPE_NUMBER, $block);

    //WHERE THE F IS THIS SOMETIMES???????????????????????????
    var rel_announce = await GHOSTDATA.makeGhostRelon(TYPE_SYS, USER._userNObj, MEM.ANNE_BRICK_POINT.nid, TO_TYPE_ANNE, ghostNOBJ.nid);

    var ghostobj = new ghost_to_anne();
    ghostobj.addToLast(rel_announce.txid);

    await ghostobj.updateAll(false, null);
    
    //await ANNE.SENDQ.___sendQueue(($msg="brick point test.")=>{
       // console.log("brick point test: "+ $msg);
    //});
}


/**
 * 
 * @param {*} $user_nid 
 */
GHOSTDATA.grantSuperAdminForAppStuff = async($user_nid, $bSUPER_SUPER=false)=>{
    var appStuff = [
        ANNE.MEM.person,
        ANNE.MEM.company,
        ANNE.MEM.location,
        ANNE.MEM.group,
        ANNE.MEM.group_event,
        ANNE.MEM.ec_action,
        ANNE.MEM.ec_living,
        ANNE.MEM.ec_thing,
        ANNE.MEM.religion
    ];
    for (var a=0; a < appStuff.length; a++) {
        var nObj = appStuff[a];
        if ($bSUPER_SUPER==true) {
            var rights_relon = await GHOSTDATA.new_ghost_sys(nObj, ANNE.MEM.dr_super_super.nid, TO_TYPE_ANNE, $user_nid, 0);
            await ANNE.SENDQ.addRelonToSendQ(rights_relon, false, ANNE.TXB.TXTYPE_ADD_ADMIN);
        }
        else {
            var hanai_in_rights = await GHOSTDATA.new_ghost_sys(nObj, ANNE.MEM.dr_andy_hanai_in.nid, TO_TYPE_ANNE, $user_nid, 0);
            await ANNE.SENDQ.addRelonToSendQ(hanai_in_rights, false, ANNE.TXB.TXTYPE_ADD_ADMIN);
            var super_class_rights = await GHOSTDATA.new_ghost_sys(nObj, ANNE.MEM.dr_andy_super_all.nid, TO_TYPE_ANNE, $user_nid, 0);
            await ANNE.SENDQ.addRelonToSendQ(super_class_rights, false, ANNE.TXB.TXTYPE_ADD_ADMIN);
        }
    }
}




/**
 * ONLY ANNE can send these.  Well, u can try, but I wouldn't advise it.  Lolz.
 * @returns 
 */
GHOSTDATA.activateBounties = async($activate="activate")=> {
    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) {
        console.log("Only ANNE can send the go-live cmd");
        return;
    }
    if (ANNE.SENDQ.aQ.length>0) {
        console.log("can't send activation if any other TXs are in the queue");
        return;
    }

    var reln = MEM.ACTIVATE.nid;
    if ($activate=="deactivate") {
        reln = MEM.DEACTIVATE.nid;
    }

    //TYPE_SYS, anne->  -> -> to_type_number ->    (this will activate live mode, one time)
    var ghostRelActivate = await GHOSTDATA.new_ghost_sys(USER._userNObj, reln, TO_TYPE_NUMBER, 5);
    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRelActivate, false, TXB.TXTYPE_SELF_RELON);
    if(tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="send activation processed")=>{
        console.log("upon mining --- the app is now in live mode");
    });
}


/**
 * ONLY ANNE can send these.  Well, u can try, but I wouldn't advise it.  Lolz.
 * @returns 
 */
GHOSTDATA.activatePDNS = async($activate="activate")=> {
    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) {
        console.log("Only ANNE can send the go-live cmd");
        return;
    }
    if (ANNE.SENDQ.aQ.length>0) {
        console.log("can't send activation if any other TXs are in the queue");
        return;
    }

    var reln = MEM.ACTIVATE.nid;
    if ($activate=="deactivate") {
        reln = MEM.DEACTIVATE.nid;
    }

    //TYPE_SYS, anne->  -> -> to_type_number ->    (this will activate live mode, one time)
    var ghostRelActivate = await GHOSTDATA.new_ghost_sys(USER._userNObj, reln, TO_TYPE_NUMBER, 8);
    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRelActivate, false, TXB.TXTYPE_SELF_RELON);
    if(tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="send activation processed")=>{
        console.log("upon mining --- the app is now in live mode");
    });
}


/**
 * ONLY ANNE can send these.  Well, u can try, but I wouldn't advise it.  Lolz.
 * @returns 
 */
GHOSTDATA.activateASDF = async($activate="activate")=> {
    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) {
        console.log("Only ANNE can send the go-live cmd");
        return;
    }
    if (ANNE.SENDQ.aQ.length>0) {
        console.log("can't send activation if any other TXs are in the queue");
        return;
    }

    var reln = MEM.ACTIVATE.nid;
    if ($activate=="deactivate") {
        reln = MEM.DEACTIVATE.nid;
    }

    //TYPE_SYS, anne->  -> -> to_type_number ->    (this will activate live mode, one time)
    var ghostRelActivate = await GHOSTDATA.new_ghost_sys(USER._userNObj, reln, TO_TYPE_NUMBER, 7);
    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRelActivate, false, TXB.TXTYPE_SELF_RELON);
    if(tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="send activation processed")=>{
        console.log("upon mining --- the app is now in live mode");
    });
}


/**
 * ONLY ANNE can send these.  Well, u can try, but I wouldn't advise it.  Lolz.
 * @returns 
 */
GHOSTDATA.activateANNDLES = async($activate="activate")=> {
    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) {
        console.log("Only ANNE can send the go-live cmd");
        return;
    }
    if (ANNE.SENDQ.aQ.length>0) {
        console.log("can't send activation if any other TXs are in the queue");
        return;
    }

    var reln = MEM.ACTIVATE.nid;
    if ($activate=="deactivate") {
        reln = MEM.DEACTIVATE.nid;
    }

    //TYPE_SYS, anne->  -> -> to_type_number ->    (this will activate live mode, one time)
    var ghostRelActivate = await GHOSTDATA.new_ghost_sys(USER._userNObj, reln, TO_TYPE_NUMBER, 19);
    var tempCmdObj = await SENDQ.addRelonToSendQ(ghostRelActivate, false, TXB.TXTYPE_SELF_RELON);
    if(tempCmdObj==null) return;
    await ANNE.SENDQ.___sendQueue(($msg="send activation processed")=>{
        console.log("upon mining --- the app is now in live mode");
    });
}


GHOSTDATA.defendBadData=function($type,$nid) {
    if ($type==TYPE_HAS && ANNE.MEM.BE_ofs.indexOf($nid)==true) {
        return true;
    }
    else if ($type==TYPE_BE && ANNE.MEM.HAS_no_ofs.indexOf($nid)==true) {
        return true;
    }
    return false;
}


/**
 * 
 * @param {connector} $CONNECTOR - subclass of connector for wikispooks, dbpedia or other. 
 */
GHOSTDATA.ANNEDataFromExternalGeneralized = async($CONNECTOR, $rezPartNOBJ, $callback_done=null, $consolePrint=null)=> {
    var _postMortem = [];
    
    if ($CONNECTOR.status=="no_results") {
        if ($callback_done!=null && typeof $callback_done=="function") {
            $consolePrint("done");
            $callback_done($CONNECTOR.resolvedNOBJ, $CONNECTOR);
        }
        return null;
    }
    
    if ($CONNECTOR.wiki_type_nObj==null && $CONNECTOR.resolvedNOBJ==null) {
        console.log("no wiki_type_nObj and no resolvedNOBJ for connector "+$CONNECTOR.aec.src);
        if ($callback_done!=null) {
            return $callback_done(null, $CONNECTOR);
        }
        else return null;
    }

    var fromNOBJ0 = null;

    const copr = $consolePrint;

    /****************************************************** */
    //MAKER
    /****************************************************** */
    var makeRelonIfNew=async($fromNOBJ, $type, $reln, $to_type, $to_s)=> {    
        if ($fromNOBJ!=null  && $type!=null && $reln!=null && $to_type!=null && $to_s!=null) {
            var testpat = ANNE.testPatIsOk($fromNOBJ, $type, $reln);
            if (testpat.ok==false) {
                testpat.rel=null;
                return testpat; 
            }

            var x_relon = MEMG.getRelonFromWithTo($fromNOBJ.outs, $type, $reln, $to_s);
            if (x_relon!=null) {
                //if (copr!=null) copr("found existing relon, skip");
                testpat.rel=x_relon;
                testpat.dupe=true;
                return testpat;
            }

            //sometimes we have an upgrade. hmm.
            //like kinfolk parent exists, but we now have kinfolk_father
            //or kinfolk_mother.  catch those ghosts.. delete ghost, replace with new.
            //for real, later we can remove the lessor quality one
            var x_relonP = MEMG.getRelonFromWithTo_orParentLine1($fromNOBJ.outs, $type, $reln, $to_s);
            if (x_relonP!=null) {
                testpat.rel=x_relonP;
                testpat.dupe=true;
                x_relonP.reln = $reln;
                
                //alter the single relon to the more refined/value.  
                await this.updateDBSingleGhostRelon(x_relonP);

                return testpat;
            }
            

            x_relon = await GHOSTDATA.makeGhostRelon($type, $fromNOBJ, $reln, TO_TYPE_ANNE, $to_s);
            if (x_relon==null) {
                if (copr!=null) copr("missing data, relon not made");
                alert("relon didn't get made!");
                return {ok:false, rel:null, msg:"relon didn't get made by GHOSTDATE"};
            }
            testpat.rel=x_relon;
            testpat.dupe=false;
            $CONNECTOR._new_external_data+=1;
            return testpat;
        }

        copr("missing data, relon not made");
        return {ok:false, rel:null, msg:"missing data, relon not made"};
    }
    
    

    //with new supporting info we may already have this thing..
    //the name could have been off/different than we've seen.
    //this would require supporting info (like bday)
    if ($CONNECTOR.external_ready_search!="") {
        $CONNECTOR.external_ready_search = $CONNECTOR.external_ready_search.replace("-28", "(");
        $CONNECTOR.external_ready_search = $CONNECTOR.external_ready_search.replace("-29", ")");    
    }
    
    var bMAKEREZPARTRELON = false;

    //if we wiki spooked a new neuron, get runtime neurons from the class
    if ($CONNECTOR.resolvedNOBJ==null) {
        //name should be set via the $CONNECTOR.  If not, use .fixed_search_text
        $CONNECTOR.name = $CONNECTOR.name.replace("_", " ");    //should have been done in wiki file
         if ($CONNECTOR.name.indexOf("/")!=-1) {
            $CONNECTOR.name = $CONNECTOR.name.replace("/", " "); //main name should not have slashes.. convert.
        }
        if ($CONNECTOR.name.indexOf("(")!=-1) {
            var fixedObj = ANNE.UTILS.stripParens($CONNECTOR.name);
            $CONNECTOR.name = fixedObj.str.trim();    
        }

        //this crates the neuron and stores the ghost relon in ghost memory to suppor the new relon.
        fromNOBJ0 = await GHOSTDATA.makeGhostNeuron($CONNECTOR.wiki_type_nObj, $CONNECTOR.name, NTYPE_INST);
        await GHOSTDATA.makeGhostRelon(TYPE_SYS, fromNOBJ0, $rezPartNOBJ.nid, TO_TYPE_STRING, $CONNECTOR.external_ready_search);
        $CONNECTOR._new_external_data+=1;
    }

    else {
        fromNOBJ0 = $CONNECTOR.resolvedNOBJ;
        var x_relon = MEMG.getRelonFromWithTo(fromNOBJ0.outs, TYPE_SYS, $rezPartNOBJ.nid, $CONNECTOR.external_ready_search);
        if (x_relon==null) {
            bMAKEREZPARTRELON = true;
            $CONNECTOR._new_external_data+=1;
        }
    }

    //catastrophic error.
    if (fromNOBJ0==null) {
        ANNE.consoleError("(GHOSTDATA.ANNEDataFromExternalGeneralized) no nObj here????");
        copr("catastrophic missing fromNOBJ0.  Exit.");
        if ($callback_done!=null) {
            $callback_done(fromNOBJ0, $CONNECTOR);
        }
        return;
    }
    
    var grelons=0;

    //extras tossed in along the way for the main neuron.
    if ($CONNECTOR.extras!=undefined && $CONNECTOR.extras.length>0) {
        for (var e=0; e < $CONNECTOR.extras.length; e++) {
            var erel =  $CONNECTOR.extras[e];
            var relnNOBJ = ANNE.MEMG.getNeuronByNid(erel.reln);
            console.log("audit extra "+relnNOBJ.text);
            var x_relon = MEMG.getRelonFromWithTo(fromNOBJ0.outs, erel.type, erel.reln, erel.to_s);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(erel.type, fromNOBJ0, erel.reln, erel.to_type, erel.to_s);
                $CONNECTOR._new_external_data+=1;
            }
        }
    }


    for (var d=0; d < $CONNECTOR._props.length; d++) {
        var prop = $CONNECTOR._props[d];
        if (ANNE.UTILS.isset(prop.json_objs)==false) continue;
        if (prop.reln==null || prop.reln=="") continue;
       
        var relnNOBJ0 = MEMG.getNeuronByNid(prop.reln);
        if (relnNOBJ0==null) continue;

        //the base relon... before subj/obj flips and duals.
        var from_nid0 = fromNOBJ0.nid;
        
        var reln0 = relnNOBJ0.nid;
        var type0 = prop.type;
        var to_type0 =  prop.to_type;
       
        //override a has religion with a BE TRIBAL
        //if religion is judaism..
        //this comes through on wikispooks as anyone affiliated with
        //jewishness per their definition
        if (to_s0==MEM.judaism.nid) {
            
            //for now, to be safe, convert religion to ethnicity for wikispooks.
            //would be best to catch this in the wikispooks handler.
            //They tag things as  "religion=jewish" if a person is merely born jewish..
            //This would more accurately be called ethnicity/heritage
            if (relnNOBJ0.nid==MEM.religion.nid) {
                relnNOBJ0 = MEM.ethnicity;
                to_s0=MEM.jewish.nid;
                type0 = TYPE_BE;
            }
        }
        
        //loop the json_objs for this property.
        for (var p=0; p < prop.json_objs.length; p++) {
            
            //this is now the wdata object.  We need an addExtras available
            //for specific data -- NOT just the prop itself (which applies to all using the prop)
            var jsonobj = prop.json_objs[p];
             
            var to_s0 = jsonobj.to_s;
            if (to_s0==undefined || to_s0==null || to_s0=="") {
                continue;
            }
            
            if (jsonobj.bDEAD!=undefined && jsonobj.bDEAD==true) {
                continue;
            }
            
            var from_nid1 = null;
            var fromNOBJ1 = null;
            var type1 = null;
            var reln1 = null;
            var to_s1 = null;
            var to_type1 = to_type0; //always the same here on duals as we must have TO_TYPE_ANNE

            //if we are making a dual...
            if (prop.make_be_dual!=undefined) {
                //the dual obj 
                from_nid1=to_s0;
                fromNOBJ1 = MEMG.getNeuronByNid(from_nid1);
                type1=prop.dual_type;
                if (type1==undefined) type1=type0;
                reln1=prop.make_be_dual.nid;
                if (jsonobj.OVERRIDE_MAKE_BE_DUAL!=undefined) {
                    reln1 = jsonobj.OVERRIDE_RELN.nid;
                }
                to_s1 = from_nid0;
            }

            var toNOBJ = fromNOBJ1;

            //no relon_to_subj flip, just a normal relon and potential dual.
            if (jsonobj.relon_to_subj==undefined) {
                toNOBJ = fromNOBJ0;

                var makeObj = await makeRelonIfNew(fromNOBJ0, type0, reln0, to_type0, to_s0);
                if (makeObj.ok==false) {
                    if (jsonobj.processedBy!=undefined) console.log("%c"+jsonobj.processedBy, ANNE.TALK.bgpurple);
                    _postMortem.push({j:jsonobj, p:prop, m:makeObj});
                    console.log(jsonobj);
                    console.log(prop);
                    continue;
                }
                else if (jsonobj.processedBy!=undefined) {
                    makeObj.rel.dataImporter = jsonobj.processedBy;
                }

                if (prop.make_be_dual!=undefined && prop.make_be_dual!=null) {
                    var makeObj = await makeRelonIfNew(fromNOBJ1, type1, reln1, to_type1, to_s1);
                    if (makeObj.ok==false) {
                        if (jsonobj.processedBy!=undefined) console.log("%c"+jsonobj.processedBy, ANNE.TALK.bgpurple);
                        console.log(jsonobj);
                        console.log(prop);
                        _postMortem.push({j:jsonobj, p:prop, m:makeObj});
                        continue;
                    }
                    else if (jsonobj.processedBy!=undefined) {
                        makeObj.rel.dataImporter = jsonobj.processedBy;
                    }
                }
            }
           
            //subj and obj are flipped.
            else {
                var makeObj = await makeRelonIfNew(fromNOBJ1, type0, reln0, to_type0, to_s1);
                if (makeObj.ok==false) {
                    if (jsonobj.processedBy!=undefined) console.log("%c"+jsonobj.processedBy, ANNE.TALK.bgpurple);
                    _postMortem.push({j:jsonobj, p:prop, m:makeObj});
                    console.log(jsonobj);
                    console.log(prop);
                    continue;
                }
                else if (jsonobj.processedBy!=undefined) {
                    makeObj.rel.dataImporter = jsonobj.processedBy;
                }

                if (prop.make_be_dual!=undefined && prop.make_be_dual!=null) {
                    var makeObj = await makeRelonIfNew(fromNOBJ0, type1, reln1, to_type1, to_s0);
                    if (jsonobj.processedBy!=undefined) console.log("%c"+jsonobj.processedBy, ANNE.TALK.bgpurple);
                    if (makeObj.ok==false) {
                        _postMortem.push({j:jsonobj, p:prop, m:makeObj});
                        console.log(jsonobj);
                        console.log(prop);
                        continue;
                    }
                    else if (jsonobj.processedBy!=undefined) {
                        makeObj.rel.dataImporter = jsonobj.processedBy;
                    }
                }
            }

            //the TONOBJ is NOT the main FROM..
            if (jsonobj.last_slash_uri!=undefined) {
                var thisTONOBJ = MEMG.getNeuronByNid(jsonobj.to_s);
                if (thisTONOBJ!=null) {
                    var uripart_relon = MEMG.getRelonFromWithTo(thisTONOBJ.outs, TYPE_SYS, $rezPartNOBJ.nid, jsonobj.last_slash_uri);
                    if (uripart_relon==null) {
                        //console.log("audit making rez part for nObj "+thisTONOBJ.text);
                        await GHOSTDATA.makeGhostRelon(TYPE_SYS, thisTONOBJ, $rezPartNOBJ.nid, TO_TYPE_STRING, jsonobj.last_slash_uri);
                        grelons+=1;
                        $CONNECTOR._new_external_data+=1;
                    }
                }
            }


            //specific wdata extras extract that were not yet added/handled.
            //in some cases we will just add them straightaway.
            //in other cases we will wait to check here if we have it or not.
            if (jsonobj.extras!=undefined && jsonobj.extras.length) {
                for (var e=0; e < jsonobj.extras.length; e++) {
                    var erel =  jsonobj.extras[e];
                    var propRESOLVEDNOBJ = ANNE.MEMG.getNeuronByNid(jsonobj.to_s);
                    if (propRESOLVEDNOBJ==null) continue;
                    var x_relon = MEMG.getRelonFromWithTo(propRESOLVEDNOBJ.outs, erel.type, erel.reln, erel.to_s);
                    if (x_relon==null) {
                        await GHOSTDATA.makeGhostRelon(erel.type, propRESOLVEDNOBJ, erel.reln, erel.to_type, erel.to_s);
                        $CONNECTOR._new_external_data+=1;
                    }
                }
            }
            
            //we will store this as a general TEXT assoc.
            //it aims to be conceptual, once resolved later?
            if (jsonobj.context!=undefined && jsonobj.context!=null && jsonobj.context.length>0 && jsonobj.context!="undefined") {
                if (Array.isArray(jsonobj.context)==true) {
                    for (var c=0; c < jsonobj.context.length; c++) {
                        //await GHOSTDATA.makeGhostRelon(TYPE_BRAIN, fromNOBJ0, MEM.anbl_assoc.nid, TO_TYPE_STRING, jsonobj.context[c]);
                        grelons+=1;
                        $CONNECTOR._new_external_data+=1;
                        copr("TYPE_BRAIN context relon <b>"+fromNOBJ0.text+"</b>-><b>"+jsonobj.context[c]+"</b>");
                    }
                }
                else {
                    //await GHOSTDATA.makeGhostRelon(TYPE_BRAIN, fromNOBJ0, MEM.anbl_assoc.nid, TO_TYPE_STRING, jsonobj.context);
                    copr("TYPE_BRAIN context relon <b>"+fromNOBJ0.text+"</b>-><b>"+jsonobj.context+"</b>");
                    grelons+=1;
                    $CONNECTOR._new_external_data+=1;
                }
            }
        }   //END OF PROP LOOP.
    
    
    }

    if (_postMortem.length) {
        console.log("%cPOST MORTEM", ANNE.TALK.title);
        console.log(_postMortem);
    }

    //only make the REZPART if we had results.
    if (bMAKEREZPARTRELON==true && grelons>0) {
        await GHOSTDATA.makeGhostRelon(TYPE_SYS, fromNOBJ0, $rezPartNOBJ.nid, TO_TYPE_STRING, $CONNECTOR.external_ready_search);
        //copr("new rez part for "+fromNOBJ0.text+" of "+$CONNECTOR.external_ready_search);
        $CONNECTOR._new_external_data+=1;
    }


    if ($callback_done!=null) {
        copr("done");
        $callback_done(fromNOBJ0, $CONNECTOR);
    }

    return null;
}




class ghost_to_anne {
    constructor($nObj) {
        this.nObj = $nObj;
        this.beNOBJ = null;

        this.handled_neurons = new arraymap();
        this.handled_neurons.setMapKey("temp_nid");

        this.relons_to_process = [];    //pending relons..??
        this.txids_cmds=[];
        this.ghost_nids = [];
        this.ghost_nObjs = [];
        this.last_txids = [];

        //neurons by nid
        this.temps_to_still_process = new arraymap();
        this.temps_to_still_process.setMapKey("nid");

        this.make_sure_we_processed = new arraymap();
        this.make_sure_we_processed.setMapKey("txid");
    }
    
    addToLast = function($txid) {
        this.last_txids.push($txid);
    }

    /**
     * 
     * @param {boolean} $bAUTOHANAI 
     * @param {function} $simple_callback 
     */
    updateAll = async($bAUTOHANAI=false, $simple_callback=null)=>{
        var ghost_tnids = [];
        var real_tnids_with_ghosts = [];
        var nids_to_chase = [];
        GHOSTDATA.temp_only_deletes = [];
        
        for (var n=0; n < MEM._aNeurons.length; n++) {
            if (MEM._aNeurons[n].ghost==false) continue;//not a ghost
            ghost_tnids.push(MEM._aNeurons[n].temp_nid);
        }

        //get all ghost relons that are from non-ghost neurons
        //we're going ot want to do HANAI COLLABS with these.
        //These ghosts are from ANNE-OWNED neurons
        var selfGhosts=0;

        for (var r=0; r < MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].ghost==true) {

                //not in either array yet..
                if (real_tnids_with_ghosts.indexOf( MEM._aRelons[r].f)==-1 
                        && ghost_tnids.indexOf(MEM._aRelons[r].f)==-1) {

                    var fromNOBJ = MEMG.getNeuronByTempNid( MEM._aRelons[r].f);
                    if (fromNOBJ.nid==USER._userNObj.nid){
                        selfGhosts+=1;
                    }
                    
                    if (MEM._aRelons[r].to_type==TO_TYPE_ANNE) {
                        var toNOBJ = MEMG.getNeuronByTempNid( MEM._aRelons[r].t);

                        //nuke this relon.  It is ded.
                        if (toNOBJ==null) {

                            //nuke
                            continue;
                        }

                        if (toNOBJ.ghost==false) {
                            if (toNOBJ.sponsored_by=="" || 
                                (toNOBJ.sponsored_by==ANNE.USER._userNObj.nid && nids_to_chase.indexOf(toNOBJ.nid)==-1)) {
                                nids_to_chase.push(fromNOBJ.nid);
                            }
                        }
                    }
                    
                    //ony collab allowed from ANNE OWNED NEURONS.
                    //self owned can be altered already.
                    //other owned is a different type of collab not supported in this app (but supported in ANNE)
                    if (ANNE.isANNE(fromNOBJ.owned_by)==false) continue;

                    real_tnids_with_ghosts.push(MEM._aRelons[r].f);
                }
            }
        }

        //we must have updated spoonsored_by info on these neurons.
        //if we don't, we will potentially error on incorrect hanai requests.
        await ANNE.API.queryForGhostPrep(nids_to_chase);

        //process every one of these ghost neurons for ghost relons.
        console.log(ghost_tnids);
        for (var t=0; t < ghost_tnids.length; t++) {
            var nOBJ = MEMG.getNeuronByTempNid(ghost_tnids[t]);
            if (this.handled_neurons.contains(nOBJ.temp_nid)==true) {
                continue;
            }
            await this.update(nOBJ, 0, true, $bAUTOHANAI, false)
        }

        //process every one of these REAL neurons for ghost relons.
        console.log(real_tnids_with_ghosts);
        for (var t=0; t < real_tnids_with_ghosts.length; t++) {
            var nOBJ = MEMG.getNeuronByTempNid(real_tnids_with_ghosts[t]);
            if (this.handled_neurons.contains(nOBJ.temp_nid)==true) {
                continue;
            }
            await this.update(nOBJ, 0, true, $bAUTOHANAI, false)
        }

        if ($bAUTOHANAI==true && (ghost_tnids.length || real_tnids_with_ghosts.length)) {
            if (ANNE.isANNE(USER._userNObj.nid)==false) {
                await this.doAutoHanai();
            }
        }

        if (selfGhosts>0) {
            await this.update(USER._userNObj, 0, true, $bAUTOHANAI);//don't skip globals here
        }
        
        //note, if we had a CMD_POPULATE_WITH_VARS_ONLY_NO_SEND via pendingDynamicGhostVarUpdateONLY with relon.txid
        //but later upgrade it to collab+hanai, we can delete the updateVars cmd because we do not need to wait on 
        //that ghost relon for later. (it was used in a collab+hanai)  We can search for this whenever a collab+hanai is added.

        if (this.last_txids.length) {
            var cmds_fix = [];
            for (var s=0; s < ANNE.SENDQ.aQ.length; s++) {
                var cmd = ANNE.SENDQ.aQ[s];
                if (cmd.relon==null) continue;
                if (this.last_txids.indexOf(cmd.relon.txid)!=-1) {
                    cmds_fix.push(cmd);
                    ANNE.SENDQ.aQ.splice(s,1);
                    s=s-1;
                    continue;
                }
            }
            if (cmds_fix.length) {
                ANNE.SENDQ.aQ = ANNE.SENDQ.aQ.concat(cmds_fix);
            }
        }


        if (ANNE.SENDQ.aQ.length > 0) { //
            await ANNE.SENDQ.___sendQueue(async($msg="ghosts processed")=>{
                 if ($simple_callback!=null) {
                    $simple_callback();
                    return;
                 }

                 //DO WE REALLY WANT TO PRESUME THIS is what the user wants?
                 else {
                    
                 }
             });     
         }
         else {
            if ($simple_callback!=null) {
                $simple_callback();
                return;
            }
        }

        return;
    }



    /**
     * This is quite tricky.
     * Some neurons use special API global functions for ANNE as they are intended to create
     * global classes.  Of those, some can be created straight-away, others will need to be 
     * approved prior to accepting.  ANNE doesn't want something like PULLMYFINGER TOWN, Idaho put in 
     * as a town name in Idaho (in ANNE's worldview).  You are welcome to add that (or anything) to your worldview...
     * This will not be forced upon anyone.. no one has to care or even see it.
     * 
     * That's not ANNE's business -- but ANNE cannot let falsehoods in to the ANNE worldview.
     *
     * @param {anne_neuron} $nObj - the neuron we are processing
     * @param {int} $lvl - level deep we are in chasing ghosts
     * @param {boolean} $bSKIPGLOBALBES - skip globals for this thing?
     * @param {boolean} $bAUTOHANAI 
     * @param {boolean} $bRESETARRAYS 
     * @returns 
     */
    update=async($nObj, $lvl=0, $bSKIPGLOBALBES=true, $bAUTOHANAI=true, $bRESETARRAYS=true)=> {
        console.log("%c GHOSTDATA.update %c"+$nObj.text+"%c"+" depth: "+$lvl, ANNE.TALK.bgblue, ANNE.TALK.bggreen, ANNE.TALK.bgred);
            
        if($lvl>7) {
            console.log("testing ghost chase depth from this spider web approach.");
        }
        //console.log("%c GHOST DATA UPDATE lvl:"+$lvl, TALK.bgblackblue);
        
        if ($lvl==0 && $bRESETARRAYS==true) {
            this.handled_neurons = new arraymap();
            this.handled_neurons.setMapKey("temp_nid");
            GHOSTDATA.temp_only_deletes = [];
        }

        //local array of temp neurons we run into while processing THIS ghost..
        //we have to make sure these are processed so we have a real nid to point to
        //in the relon that references it.  It is a chicken and egg situation!
        
        
        //we already handled this neuron
        if (this.handled_neurons.contains($nObj.temp_nid)==true) return;

        //we do not process ghosts for any neuron that does not have its primary BE set.
        if ($nObj.bes.length==0 && $nObj.nid!=MEM.___SELF___.nid) return;

        this.beNOBJ = $nObj.getParent();

        //*************************************************************
        //** base neuron is known, only base relons (to possible ghost neurons too)
        //*************************************************************
        if ($nObj.ghost==false && $lvl==0) {
            await this.process_ins($lvl, $nObj);
            await this.process_outs($lvl, $nObj, $bSKIPGLOBALBES);
            this.handled_neurons.addU($nObj);
            await this.processExtras($lvl, $bSKIPGLOBALBES, $bAUTOHANAI, $bRESETARRAYS);
            return;
        }

        //audit nid.
        else {
            if ($nObj.nid[0]!="z") {
                console.log("this is NOT a ghost nid!");
                console.log("Ghost flag should be off!");
            }
            else {
                if (this.ghost_nids.indexOf($nObj.nid)==-1) {
                    this.ghost_nids.push($nObj.nid);
                    this.ghost_nObjs.push($nObj);
                }
            }
        }

        //*************************************************************
        //** PROCESSING TEMP PERSON INTO REAL PERSON
        //*************************************************************
        if (this.beNOBJ.temp_nid==MEM.person.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            console.log("ghost person nid ref: %c"+ge.ref_var+"%c"+$nObj.text, ANNE.TALK.title, ANNE.TALK.bggreen);
            ge.znid=$nObj.nid;
            await CHASE.makeGlobal(MEM.person, $nObj.text, false, ge); 
            await this.process_ins($lvl, $nObj);
            var bSKIPGLOBALS = true;
            await this.process_outs($lvl, $nObj, bSKIPGLOBALS);
            this.handled_neurons.addU($nObj);
        }


        //*************************************************************
        //** PROCESSING TEMP ANDLE INTO REAL ANDLE
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.anndle.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;

            var beRel = MEMG.getBeRelon($nObj.outs, MEM.inst.temp_nid);
            if (beRel!=null && beRel.annies!=undefined && beRel.annies>0) {
                ge.znid=$nObj.nid;
                var cmdOBJ  = await CHASE.makeGlobal(MEM.anndle, $nObj.text, false, ge);
                cmdOBJ.annies+= parseInt(anndleObj.anndle_annies_price);
            }
            else {
                var anndleObj = await ANNE.API.getAnndlePricing($nObj.text);
                ge.znid=$nObj.nid;
                var cmdOBJ  = await CHASE.makeGlobal(MEM.anndle, $nObj.text, false, ge);
                cmdOBJ.annies+= parseInt(anndleObj.anndle_annies_price);
            }
            await this.process_ins($lvl, $nObj);
            var bSKIPGLOBALS = true;
            await this.process_outs($lvl, $nObj, bSKIPGLOBALS);
            this.handled_neurons.addU($nObj);  
        }


        //*************************************************************
        //** PROCESSING TEMP SUBANNDLE INTO REAL SUBANNDLE
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.subanndle.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid; 
            var parentNOBJ = null;
            for (var r=0; r < $nObj.outs.length; r++) {
                var relz = $nObj.outs[r];
                if (relz.r==MEM.subanndle_of.temp_nid) {
                    parentNOBJ = MEMG.getNeuronByNid(relz.to_s);
                    break;
                }
            }

            if (parentNOBJ==null) return;   //we can't continue without the parentNOBJ for a subanndle.

            var msg = "<span class='q-part rel-reln'>make subanndle</span><span class='q-part rel-to'>"+$nObj.text+"</span>";
            var rObj = MEM.makeTempRelon(parentNOBJ, TYPE_SYS_MSG, MEM.CMD_MAKE_SUBANNDLE, TO_TYPE_STRING, $nObj.text, true);
            rObj.msg = msg;
            rObj.gui_extras=ge;
            var tempCmdObj = await SENDQ.addRelonToSendQ(rObj, false, TXB.TXTYPE_MAKE_SUBANNDLE);
                    
            //strip out any subanndle/subanndle of relons (after successful creation)
            //don't know how many things the user created as ghosts before they submit..
            //but we don't want to submit there.. they get made on the annode.
            for (var r=0; r < $nObj.outs.length; r++) {
                var relz = $nObj.outs[r];
                if (relz.r==MEM.subanndle_of.temp_nid) {     
                    if (tempCmdObj.delete_temp_ghosts==undefined) tempCmdObj.delete_temp_ghosts = [relz.txid];
                    else {
                        if(tempCmdObj.delete_temp_ghosts.indexOf(relz.txid)==-1) tempCmdObj.delete_temp_ghosts.push(relz.txid);
                    }
                }
                else if (relz.r==MEM.subanndle.temp_nid) {
                    if (tempCmdObj.delete_temp_ghosts==undefined) tempCmdObj.delete_temp_ghosts = [relz.txid];
                    else {
                        if(tempCmdObj.delete_temp_ghosts.indexOf(relz.txid)==-1) tempCmdObj.delete_temp_ghosts.push(relz.txid);
                    }
                }
            }
            await this.process_ins($lvl, $nObj, false, [MEM.subanndle.temp_nid, MEM.subanndle_of.temp_nid]);
            var bSKIPGLOBALS = true;
            await this.process_outs($lvl, $nObj, bSKIPGLOBALS, [MEM.subanndle.temp_nid, MEM.subanndle_of.temp_nid]);
        
            this.handled_neurons.addU($nObj);
        }


        //*************************************************************
        //** PROCESSING TEMP company INTO REAL company
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.company.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            ge.znid=$nObj.nid;
            await CHASE.makeGlobal(MEM.company, $nObj.text, false, ge); 
            await this.process_ins($lvl, $nObj);
            await this.process_outs($lvl, $nObj, true);
            
            this.handled_neurons.addU($nObj);
        }


        //*************************************************************
        //** PROCESSING TEMP ANORG INTO REAL ANORG
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.anorg.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            this.addToMap($nObj);
            ge.znid=$nObj.nid;
            await CHASE.makeGlobal(MEM.anorg, $nObj.text, false, ge); 
            await this.process_ins($lvl, $nObj);
            await this.process_outs($lvl, $nObj, true);

            this.handled_neurons.addU($nObj);
        }


        //*************************************************************
        //** PROCESSING TEMP BOUNTY INTO REAL BOUNT
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.bounty.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            ge.znid=$nObj.nid;
            await CHASE.makeGlobal(MEM.bounty, $nObj.text, false, ge); 
            await this.process_outs($lvl, $nObj, false);
            this.handled_neurons.addU($nObj);
        }

        else if (this.beNOBJ.temp_nid==MEM.integer.temp_nid) {
            var testInt = parseInt($nObj.text);
            if (testInt>0) {
                var ge = new gui_extras(this.pgui);  
                ge.ref_var="new_"+$nObj.nid;
                ge.znid=$nObj.nid;
                await CHASE.makeGlobal(MEM.integer, $nObj.text, false, ge); 
                await this.process_outs($lvl, $nObj, false);
                this.handled_neurons.addU($nObj);
            }
            else {
                console.warn("we have a bad integer neuron. "+$nObj.text);
                return;
            }
        }


        //*************************************************************
        //** PROCESSING TEMP DISTRO NEURON
        //** note: we should not be doing with if the SRC neuron is a tempNOBJ!
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.specific_d_vote_by_list.temp_nid) {
            var rel_src = MEMG.getHasRelon($nObj.outs, MEM.distro_src.temp_nid);
            if (rel_src==null) {
                console.log("no upgrade of distro if src is a ghost");
                return;
            }
            else {
                var srcNOBJ = MEMG.getNeuronByTempNid(rel_src.t);
                if (srcNOBJ==null || srcNOBJ.ghost==true) {
                    console.log("no upgrade of distro if src is a ghost");
                    return;
                }
            }

            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            ge.znid=$nObj.nid;

            await CHASE.makeKeylessNeuron(this.beNOBJ, MEM.inst, null, false, ge);
            var skips = [MEM.inst.temp_nid]; //we don't want parent (already in keysless request)
            await this.process_outs($lvl, $nObj, false, skips);

            //we want the 1 relon from the src (ie, bounty neuron)
            await this.process_ins($lvl, $nObj, false, skips); 

            this.handled_neurons.addU($nObj);
        }


        //*************************************************************
        //** PROCESSING TEMP neuronImg INTO REAL neuronImg
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.neuronImg.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            var anneImgObj = null;
            if ($nObj.audit==undefined || $nObj.audit=="bad") {
                anneImgObj = await ANNE.IMAGES.loadAndAuditFromNObj($nObj); 
                if (anneImgObj.audit<=0) {
                    $nObj.audit="bad";
                    return;
                }
                else $nObj.audit="good";
            }
            else if ($nObj.audit=="good") {
                anneImgObj = new anne_file();
                anneImgObj.setFromNeuron($nObj);
            }

            if ($nObj.audit!="good") {
                console.log("bad audit for img, can't continue");
                return;
            }

            ge.znid=$nObj.nid;

            var finger = anneImgObj.stored_finger;
            if (finger==undefined || finger==null) finger = anneImgObj.live_finger;
            if (finger==null) {
                alert("WE MUST HAVE A FINGER BROADCAST AN IMG HERE!!!");
                return;
            }
            
            await CHASE.makeGlobal(MEM.neuronImg, finger, false, ge); 
            
            await this.process_ins($lvl, $nObj);


            //ghosts won't have name relons yet. (we dodn't emulate them in the mem handler by default)
            //we skip TYPE_BEs like this typically because it will already have a name as 
            //part of the global request process.
            var name_relon = $nObj.getNameRelon(MEM.name);
            if (name_relon==null) await this._makeNameRelon($nObj);
            else await this._processNameRelon($nObj, name_relon)

            //we want to skip fileFingerPrint because that is apart of the makeGlobal
            //we do not need that nrelon.. In fact, we can remove it! (todo)
            await this.process_outs($lvl, $nObj, true, [MEM.fileFingerPrint.temp_nid]);

            this.handled_neurons.addU($nObj);
        }


        //*************************************************************
        //** PROCESSING TEMP DATES INTO REAL DATES
        //dates use the make global and require only 1 relon to create.
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.date_gregorian.temp_nid) {
            //this is NOT a date, it should be trated like a yr.
            //the relon should altered to YR too.  (aarrrrrg)
            if ($nObj.text<=4) {
                alert("warning, date of "+$nObj.text+" should not be a date neuron");
            }

            //check if this date has since been added in ANNE.
            //if so, replace all our ghost relons to it.
            var result = await CHASE.getGlobal(MEM.date_gregorian, $nObj.text);
            if (result && result.result && (result.status!="good" || result.message!="available")) {
                
                //good news!  We now have this thing (which was formerly a ghost.)
                var known_nid = result.result.nid;
                if (known_nid!=undefined && known_nid!=null) {
                    console.log("known_nid for date found:"+known_nid);
                    await ANNE.GHOSTDATA.manualUpdateGhostToKnown($nObj, known_nid);
                    var updatedKnownNOBJ = MEMG.getNeuronByNid(known_nid);

                    //we still want the relons we have from our stuff that points into this 
                    //thing.
                    await this.process_ins($lvl, updatedKnownNOBJ);
                    this.handled_neurons.addU(updatedKnownNOBJ);
                }

            }
            else {
                var ge = new gui_extras(this.pgui);  
                ge.ref_var="new_"+$nObj.nid;
                ge.znid=$nObj.nid;
                await CHASE.makeGlobal(MEM.date_gregorian, $nObj.text, false, ge); 

                //if the $nObj is a person and the from of the in is a different ghost person,
                //don't pull them in yet to submit.
                await this.process_ins($lvl, $nObj);
                this.handled_neurons.addU($nObj);
            }
        }



        //*************************************************************
        //** PROCESSING TEMP LOCATION INTO REAL LOCATION
        // SKIP NAME relon ?
        //*************************************************************
        else if (this.beNOBJ.temp_nid==MEM.location.temp_nid) {
            var constituentNOBJ = null;
            var rel = MEMG.getRelonByTempR($nObj.outs, MEM.constituent_of.temp_nid);
            if (rel!=null) {
                constituentNOBJ = MEMG.getNeuronByTempNid(rel.t);
            }
            else {
                //we have no way to process this if we don't have a constituent_of
                if ($nObj.ghost==false) {
                    await CHASE.queryForOuts_not($nObj, true, [TYPE_AWARENESS]);
                    var rel = MEMG.getRelonByTempR($nObj.outs, MEM.constituent_of.temp_nid);
                    if (rel==null) {
                        return; //this cannot be processed.
                    }
                    constituentNOBJ = MEMG.getNeuronByTempNid(rel.t);
                    if (constituentNOBJ==null) {
                        console.log("cant proccess location with missing constituent of.");
                        return; //this cannot be processed.
                    }
                }
                else {
                    console.log("cant proccess location with missing constituent of.");
                    //ANNE.GHOSTDATA.deleteZNIDS([$nObj.nid]);
                    return;
                }
            }
            
            //test this with a multi-location ghost.. like: newmarket, Ontario, Canada (from Jim Carrey)
            if (constituentNOBJ.ghost==true) {
                var c2 = null;
                var rel = MEMG.getRelonByTempR(constituentNOBJ.outs, MEM.constituent_of.temp_nid);
                if (rel!=null) c2 = MEMG.getNeuronByTempNid(rel.t);

                if (c2==null) {
                    return; //we have to have a NON-GHOST real neuron as top location.
                }
                if (c2.ghost==true) {
                    return;   //this is too many for now!
                }
                var ge = new gui_extras(this.pgui);  
                ge.ref_var="new_"+constituentNOBJ.nid;
                ge.znid=$nObj.nid;
                var cmdObj = await CHASE.makeGlobalLocation(constituentNOBJ.text, c2, false, ge);
                
                //if success (or perma fail msg) we need to delete this peksy ghost relon.
                cmdObj.aux_ghost_txid = rel.txid;

                var g2 = new gui_extras(this.pgui);  
                g2.ref_var="new_"+$nObj.nid;
                await CHASE.makePendingGlobalLocation($nObj.text, constituentNOBJ, false, g2);
                await this.process_ins($lvl, constituentNOBJ);
                await this.process_outs($lvl, constituentNOBJ, true);
                this.handled_neurons.addU(constituentNOBJ);
                this.temps_to_still_process.addU({nid:$nObj.nid, depth:$lvl});    //gotta come back to ours.
                
            }
            else {
                var ge = new gui_extras(this.pgui);  
                ge.ref_var="new_"+$nObj.nid;
                ge.znid=$nObj.nid;
                await CHASE.makeGlobalLocation($nObj.text, constituentNOBJ, false, ge);
                await this.process_ins($lvl, $nObj);
                await this.process_outs($lvl, $nObj, true);
                this.handled_neurons.addU($nObj);
            }
        }


        //*************************************************************
        //** PROCESSING PDN
        //************************************************************* 
        else if (this.beNOBJ.temp_nid==ANNE.MEM.PDN_PUBLIC_ACCESS.temp_nid
                || this.beNOBJ.temp_nid==ANNE.MEM.PDN_VIP.temp_nid
                || this.beNOBJ.temp_nid==ANNE.MEM.PDN_BEARER_TOKEN.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            var beNOBJ = ANNE.MEMG.getNeuronByTempNid($nObj.bes[0]);
            await ANNE.CHASE.makePDNNeuron(beNOBJ, ANNE.MEM.inst, null, false, ge);

            //process outs include the TYPE_BE name
            await this.process_outs($lvl, $nObj, false);
            this.handled_neurons.addU($nObj);
        }

        //service terms
        else if (this.beNOBJ.temp_nid==ANNE.MEM.service_term.temp_nid) {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            ge.znid=$nObj.nid;
            var primaryRelnNOBJ = ANNE.MEM.inst;
            if ($nObj.ntype==NTYPE_CLASS) primaryRelnNOBJ = ANNE.MEM.class;
            var ghostrel = await ANNE.CHASE.makeKeylessNeuron(this.beNOBJ, primaryRelnNOBJ, null, false, ge); 
            ghostrel.debug_name = $nObj.text;
            var skips = [ANNE.MEM.inst.temp_nid, ANNE.MEM.class.temp_nid];
            await this.process_ins($lvl, $nObj);
            await this.process_outs($lvl, $nObj, false, skips); 
            this.handled_neurons.addU($nObj);
        }
        

        //generic keyless.
        //can be a generic class or inst.
        else {
            var ge = new gui_extras(this.pgui);  
            ge.ref_var="new_"+$nObj.nid;
            var beNOBJ = ANNE.MEMG.getNeuronByTempNid($nObj.bes[0]);
            ge.znid=$nObj.nid;
            var primaryRelnNOBJ = ANNE.MEM.inst;
            if ($nObj.ntype==NTYPE_CLASS) primaryRelnNOBJ = ANNE.MEM.class;
            var ghostrel = await ANNE.CHASE.makeKeylessNeuron(beNOBJ, primaryRelnNOBJ, null, false, ge); 
            ghostrel.debug_name = $nObj.text;
            var skips = [ANNE.MEM.inst.temp_nid, ANNE.MEM.class.temp_nid]; //we don't want parent (already in keysless request)
            await this.process_ins($lvl, $nObj);
            await this.process_outs($lvl, $nObj, false, skips);
            this.handled_neurons.addU($nObj); 
        }

        //hmmm.. with nested service term.. 
        //and with it needing dates or any other supporting infos..
        //these need to be first of queue, or atleast, before they are referenced!

        //************* TOP CALLER EXIT ****************************/
        //only do this for the top caller....
        //which was a GHOST (in order to get here)....
        if ($lvl==0) {
            await this.processExtras($lvl, $bSKIPGLOBALBES, $bAUTOHANAI, $bRESETARRAYS);
        }
 
        return;
    }


    /**
     * 
     * @param {*} $bAUTOHANAI 
     */
    processExtras = async($lvl, $bSKIPGLOBALBES, $bAUTOHANAI, $bRESETARRAYS)=> {
        for (var f=0; f < this.temps_to_still_process.arr.length; f++) {
            var ghostNOBJ = ANNE.MEMG.getNeuronByNid(this.temps_to_still_process.arr[f].nid);
            console.log("%ctemps_to_process f#"+f+"%c process %c"+ghostNOBJ.text+"%c"+ghostNOBJ.nid, TALK.bgyellow, TALK.bgpurple, TALK.bggreen, TALK.bgreed);
            var newlvlx = $lvl+=1;
            await this.update(ghostNOBJ, newlvlx, $bSKIPGLOBALBES, $bAUTOHANAI, $bRESETARRAYS);
        }

        for (var r=0; r < this.make_sure_we_processed.arr.length; r++) {
            var rel = this.make_sure_we_processed.arr[r];
            var txid = rel.txid;
            if (this.txids_cmds.indexOf(txid)==-1) {
                console.warn("MISSING PROCESSING OF THIS RELON!!!");
                ANNE.TALK.printRelon(rel);
            }
        }
        
        //note, have to ensure date/integer to not get caught up in
        //this mix.  They "will be" anne-owned once they are created (no hanai needed)
        //hanai, should, accept *ALL* relons that are outbound from the neuron in question.
        //NOTE: we may need to alter the ANNODE's TX order processing to ensure hanai is handled
        //**AFTER** neuron creation.  In the EXT test use case we were not creating+hanai'ing at the same time.
        if ($bAUTOHANAI==true && ANNE.isANNE(ANNE.USER._userNObj.nid)==false) {
            await this.doAutoHanai();
        }

        //audit ths damn thing from dupe hanais.
        if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false) ANNE.SENDQ.auditFoDupeHanai();   
    }


    /**
     */
    doAutoHanai = async()=>{

        //no need.
        if (ANNE.isANNE(USER._userNObj.nid)==true) return;

        var non_anne_tnids = [];    //will populate
        var collab_rels = [];       //will populate
        var collab_literals = [];   //will populate  (relon to a NON-NEURON)

        await HANAI.getNonANNE_nObjs(non_anne_tnids, this.handled_neurons.arr, [], collab_rels, collab_literals);
        
        //a new neuron (ghost->soon to be real or already real) for anne to hanai
        //hanai can only hanai real neurons, but we can put the cmd in the queue to be updated
        //with the REAL neuron (of the ghost soon to be real)
        for (var h=0; h < non_anne_tnids.length; h++) {
            var nObj = MEMG.getNeuronByTempNid( non_anne_tnids[h]);
            console.log("for non-ANNE neuron %c"+nObj.text, ANNE.TALK.bggreen);
            var bDIDCOLLABHANAI = false;
            
            //these will already become ANNE worldview (no need to hanai)
            if (nObj.bes[0]==MEM.date_gregorian.temp_nid || nObj.bes[0]==MEM.integer.temp_nid) {
                continue;
            }

            //prev que runs (that get cancelled) may have lingering hanai requests.
            //or -- we may have one pending.
            //In either event, we don't want another hanai request.
            var sys_rel = MEMG.getSysRelon(nObj.outs, MEM.hanai_out.temp_nid);
            if (sys_rel!=null) continue;
            
            //no dupe hanais here.
            if (ANNE.SENDQ.aduditForTXTYPE(nObj.nid, ANNE.TXB.TXTYPE_HANAI_OUT_REQ)==true) {
                console.log("we already have a hanai for this keyless neuron in this queue.");
                bDIDCOLLABHANAI = true;
                continue;
            }

            //no dupe hanais here.  This relon is the in the form of a collab relon from anne neuron->reln->to a collab req
            if (ANNE.SENDQ.aduditForTXTYPE(nObj.nid, ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ, "pending_to_s")==true) {
                console.log("we already have a hanai for this keyless neuron in this queue.");
                bDIDCOLLABHANAI = true;
                continue;
            }

            if (ANNE.SENDQ.aduditForTXTYPE(nObj.nid, ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ, "to_s")==true) {
                console.log("we already have a hanai for this keyless neuron in this queue.");
                bDIDCOLLABHANAI = true;
                continue;
            }

          
            //console.log("for neuron %c"+nObj.text, ANNE.TALK.bgyellow);

            //collab_rels here is all potential collab hanai rels we may be able
            //to do a collab hanai on (two birds).
            for (var c=0; c < collab_rels.length; c++) {
                var crel = collab_rels[c];
                if (crel.to_type==TO_TYPE_ANNE && crel.t==nObj.temp_nid) {  //toNOBJ is the nObj.
                    var cfromNOBJ = MEMG.getNeuronByTempNid(crel.f);
                    if (ANNE.isANNE(cfromNOBJ.owned_by)==true) {
                        
                        var collaHanaiToNOBJ = MEMG.getNeuronByTempNid(crel.t);

                        //we can do one collab hanai.  The rest will have to wait (or be done with collab PENDING hanai (not implemented)
                        bDIDCOLLABHANAI=true;   //don't do this again below.

                        //pending hanai+collab that is a ghost to which will update then request to be hanai'd.
                        // hanai collab TXs are in the form of their COLLAB RELON.
                        //if the to is a ghost we need a pending hanai collab relon.
                        if (collaHanaiToNOBJ.ghost==true) {

                            //can't hanai a ghost without first creating the ghost as a real neuron.
                            //make sure we have that create cmd in the queue already if we are going ot do a collab/hanai
                            if (ANNE.SENDQ.aduditForMAKER(nObj.nid)==false) {
                                console.log("no keyless neuron request in the queue for this ghost "+nObj.text+", thus no hanai possible");
                                continue;
                            }
                            
                            var hanaicollab = {txid:crel.txid, type:crel.type, from_nid:crel.from_nid, pending_from:null, reln:crel.reln, to_type:crel.to_type, to_s:null, pending_to_s:"new_"+collaHanaiToNOBJ.nid, pending_to_debug:collaHanaiToNOBJ.text, pending_from_debug:""};
                            await SENDQ.pendingDynamicVarRelon(hanaicollab, false, false, true, TXB.TXTYPE_HANAI_COLLAB_REQ, null, false);
                        
                            //if we had any cmds of this in the queue, they are no longer needed.
                            SENDQ.deleteByTXTYPE(TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND, crel.txid, "upgraded txid to be hanaicollab (pending from)");
                        }

                        //real toNObj already that we own, this is a hanai collab TX as-is.
                        //it takes the form of a collab and the TO is hanai'd.
                        else {
                            await SENDQ.addRelonToSendQ(crel, false, TXB.TXTYPE_HANAI_COLLAB_REQ);

                            //if we had any cmds of this in the queue, they are no longer needed.
                            SENDQ.deleteByTXTYPE(TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND, crel.txid, "upgraded txid to hanaicollab");
                        }
                        
                        //only one collab_hanai per neuron is possible.
                        //any other relons from ANNE-OWNED neurons pointing to a ghost (which will be updated and hanai'd)
                        //will have to be done in a later queue run.
                        break;
                    }
                }
            }
            

            //even with AUTO hanai, we can still just do the hanai..
            //and it will kick in auto via the annode.
            if (bDIDCOLLABHANAI==false) {   //NID_HANAI_OUT

                //hanais are in the form of NEURONTOHANAI->hanai out-> WORLDVIEW TO HANAI TO.
                if (nObj.ghost==true) {

                    //can't hanai a ghost without first creating the ghost as a real neuron.
                    //make sure we have that create cmd in the queue already if we are going ot do a collab/hanai
                    if (ANNE.SENDQ.aduditForMAKER(nObj.nid)==false) {
                        console.log("no keyless neuron request in the queue for this ghost "+nObj.text+", thus no hanai possible");
                        continue;
                    }

                    var relon = MEM.makeTempRelon(nObj, TYPE_SYS_MSG, MEM.hanai_out.nid, TO_TYPE_ANNE, MEM.ANNE_ACCTID, true);
                    if (relon==null) {
                        alert("really?? lolz");
                        continue;
                    }
                    
                    var outrelon = {txid:relon.txid, type:TYPE_SYS_MSG, from_nid:null, pending_from_debug:"", pending_from:"new_"+nObj.nid, reln:MEM.hanai_out.nid, to_type:relon.to_type, to_s:MEM.ANNE_ACCTID}
                    outrelon.pending_from_debug = nObj.text;

                    //future relon from a (now ghost) soon to be real neuron that we 
                    //hanai out to the ANNE worldview.
                    await SENDQ.pendingDynamicVarRelon(outrelon, true, false, false, ANNE.TXB.TXTYPE_HANAI_OUT_REQ, null, false);
                }

                else {
                    var hanaiasisrelon = MEM.makeTempRelon(nObj, TYPE_SYS_MSG, MEM.hanai_out.nid, TO_TYPE_ANNE, MEM.ANNE_ACCTID, true);
                    await SENDQ.addRelonToSendQ(hanaiasisrelon, false, ANNE.TXB.TXTYPE_HANAI_OUT_REQ);
                }
            }
        }
    }
    

    /**
     */
    _makeNameRelon = async($nObj, $bPROCESS=true)=> {
        var name_relon = $nObj.makeNameTempRelon(MEM.name, $nObj.text);
        if ($bPROCESS==true) await this._processNameRelon(name_relon);
    }
    _processNameRelon=async($nObj, $name_relon)=> {
        var outrelon = {txid:$name_relon.txid, type:$name_relon.type, pending_from_debug:"", from_nid:null, pending_from:"new_"+$nObj.nid, reln:$name_relon.reln, to_type:$name_relon.to_type, to_s:$name_relon.to_s};
        outrelon.pending_from_debug = $nObj.text;
        await SENDQ.pendingDynamicVarRelon(outrelon, true, false, false, TXB.TXTYPE_CHILD_RELON, null, false);
        this.relons_to_process.push(outrelon);
    }


    /**
     * Standard ins processor for any given temp neuron
     */
    process_ins=async($lvl, $toNOBJ, $bSKIPGLOBALBES=true, $skipTnids=[])=> {
        
        var bISANNE = false;
        if (ANNE.isANNE(MEM.USER._userNObj.nid)==true) {
            bISANNE=true;    
        }
        
        if ($toNOBJ.nid!=ANNE.USER._userNObj.nid && ANNE.isANNE($toNOBJ.owned_by)==false && $toNOBJ.owned_by!=MEM.USER._userNObj.nid) return;

        for (var i=0; i < $toNOBJ.ins.length; i++) {
            var relon = $toNOBJ.ins[i];    
            if (relon.ghost==false) continue;
            if (relon.TEMP_ONLY!=undefined && relon.TEMP_ONLY==true) {
                if (GHOSTDATA.temp_only_deletes.indexOf(relon.txid)==-1) {
                    GHOSTDATA.temp_only_deletes.push(relon.txid);
                }
                continue;
            }

            if ($skipTnids.length && $skipTnids.indexOf(relon.r)!=-1) continue;

            //freeze is self to self relon (next condition would catch it too)
            if (relon.r==ANNE.MEM.CMD_FREEZE.temp_nid) continue;  

            //this can be handled in the from.
            if (relon.type==TO_TYPE_ANNE && relon.f==relon.t) continue;

            //for globals we will be making a global SYS_MSG TX to 
            //create this on the annode. A ssuch, we don't need any of these
            //types of relons for skipglobals
            if ($bSKIPGLOBALBES==true) {
                if (relon.type==TYPE_BE) {
                    if (relon.r==ANNE.MEM.name.temp_nid) continue;
                    else if (relon.r==ANNE.MEM.class.temp_nid) continue;
                    else if (relon.r==ANNE.MEM.inst.temp_nid) continue;
                    else if (relon.r==ANNE.MEM.constituent_of.temp_nid) continue;
                }
            }

            //already covered this.
            if (this.txids_cmds.indexOf(relon.txid)!=-1) {
                continue;
            }
            
            var from_nOBJ = ANNE.MEMG.getNeuronByTempNid(relon.f);
            if (ANNE.isANNE(from_nOBJ.owned_by)==false && from_nOBJ.owned_by!=ANNE.MEM.USER._userNObj.nid) continue;

            //basic type.  HOWEVER,
            //if we are in collab mode we need collab types!
            var TXTTYPE = ANNE.TXB.TXTYPE_CHILD_RELON;
            
            var AUDIT_TXTTYPE = ANNE.TXB.calcTXTTYPE(relon);    

            if (from_nOBJ.nid==ANNE.USER._userNObj.nid) {
                if (relon.type==TYPE_AWARENESS) {
                    TXTTYPE = ANNE.TXB.TXTYPE_SELF_RELON;
                }
                else if (relon.reln==ANNE.MEM.distro_vote.nid) {
                    TXTTYPE = ANNE.TXB.TXTYPE_ANORG_VOTECALL;
                }
                else TXTTYPE = ANNE.TXB.TXTYPE_SELF_RELON;
            }

            else if (relon.type==TYPE_SYS && ANNE.MEM.delegation_reln_tnids.indexOf(relon.reln)!=-1){
                TXTTYPE = ANNE.TXB.TXTYPE_ADD_ADMIN;
            }

            //this must be a collab request.
            //from is real but is not owned by the user.
            //if the from is NOT owned by ANNE we're going to skip it
            //L1 can handle user-to-user collabs but this app i don't want to.
            else if (from_nOBJ.ghost==false && from_nOBJ.owned_by!=ANNE.USER._userNObj.nid) {
                if (ANNE.isANNE(from_nOBJ.owned_by)==false) continue;
                if (ANNE.isANNE(ANNE.USER._userNObj.nid)==true) {
                    console.log("keep TX type");
                }
                else TXTTYPE = await from_nOBJ.validateCollabReq(USER._userNObj, relon.r);
            }


            
            if (TXTTYPE!=0 && AUDIT_TXTTYPE!=TXTTYPE && TXTTYPE!=TXB.TXTYPE_COLLAB_REQ_EXP_DEL) {
                ANNE.TALK.printRelon(relon);
                alert("audit failed! AUDIT "+AUDIT_TXTTYPE+" not equal to set TXTYPE of "+TXTTYPE);
            }

            
            //temp from to a temp to
            //we will process this relon as the OUT of the from..
            if (from_nOBJ.ghost==true) {
                
                
                //we already have processed this FROM so we are safe to reference it.
                if (this.handled_neurons.contains(from_nOBJ.temp_nid)==true) {
                    var outrelon = {txid:relon.txid, type:relon.type, from_nid:null, pending_from_debug:"", pending_from:"new_"+from_nOBJ.nid, reln:relon.reln, to_type:relon.to_type, to_s:null, pending_to_s:"new_"+$toNOBJ.nid, pending_to_debug:$toNOBJ.text};
                    outrelon.pending_from_debug = from_nOBJ.text;
                    await SENDQ.pendingDynamicVarRelon(outrelon, true, false, true, TXTTYPE, null, false);
                    this.relons_to_process.push(outrelon);
                    this.txids_cmds.push(relon.txid);
                    continue;
                }

                //we need to process this next (including the relon we skipped)              
                else {
                    this.temps_to_still_process.addU({nid:from_nOBJ.nid, depth:$lvl});
                    console.log("pending relon in to %c"+$toNOBJ.text+"%c can't be made until %c"+from_nOBJ.text+" %cis made",ANNE.TALK.bggreen, ANNE.TALK.bgblack, ANNE.TALK.bggreen, ANNE.TALK.bgblack);
                    this.make_sure_we_processed.addU(relon);
                    continue;
                }
            }

            //known from into this ghost to.
            //we're safe to make this dynamicVarRelon cmd now..
            else {
                if ($toNOBJ.ghost==true) {
                    
                    //if the from is an ANNE owned neuron and we are pointing to a 
                    //non-ANNE neuron, this is an upgrade from ghost to real for that neuron..
                    //It is connected to by an ANNE neuron with a ghost relon that will be 
                    //a collab relon once we upgrade to the TONOBJ.

                    //The collab will be denied since the neuron is owned by the user.
                    //That img must first be HANAI'd to ANNE and then it can be connected to
                    //from the user profile.
                    //example:  adding an img to an ANNE neuron then upgrading the ghost neuron
                    //NOTE: dates and ints are AUTO made in ANNE's worldview so we can make the neuron new AND link to it in one go.
                    if (ANNE.isANNE(ANNE.USER._userNObj.nid)==false 
                        && ANNE.isANNE(from_nOBJ.owned_by)==true 
                        && $toNOBJ.bes[0]!=ANNE.MEM.date_gregorian.temp_nid 
                        && $toNOBJ.bes[0]!=ANNE.MEM.integer.temp_nid) {

                        relon.pending_to_s="new_"+$toNOBJ.nid;
                        
                        if ($toNOBJ.nid[0]!="z") {
                            console.log( "must be a znid");
                            continue;
                        }

                        relon.pending_to_debug = $toNOBJ.text;

                        //TTYPE is not relevant here.  There is no send.  Ghost upgrade for this relon
                        //will determine if this is a collab relon.
                        await ANNE.SENDQ.pendingDynamicGhostVarUpdateONLY(relon, TXTTYPE);
                        continue;
                    }

                    var inrelon = {txid:relon.txid, type:relon.type, from_nid:from_nOBJ.nid, reln:relon.reln, to_type:relon.to_type, to_s:null, pending_to_s:"new_"+$toNOBJ.nid, pending_to_debug:$toNOBJ.text};
                    this.txids_cmds.push(relon.txid);

                    await ANNE.SENDQ.pendingDynamicVarRelon(inrelon, false, false, true, TXTTYPE, null, false);
                    this.relons_to_process.push(inrelon);
                }

                
                //if the fromNOBJ is ANNE and the toNOBJ is not ANNE,
                //this needs either a collab hanai or must be pended till later.
                else {

                    if (ANNE.isANNE(from_nOBJ.owned_by)==true) {
                        if (bISANNE==true) {
                            await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                        }
                        
                        //anne neuron to -> our neuron 
                        //hanai collab or skip.
                        else if ($toNOBJ.owned_by==ANNE.MEM.USER._userNObj.nid) {
                            console.log("we need a collab that is PENDING hanai here.");
                            //alternatively, they can send it on another go around, once the TO
                            //neuron is in ANNE.
                            continue;
                        }

                        //anne neuron to -> anne neuron
                        else {
                            //no pending needed, just send it.
                            await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                        }
                    }
        
                        
                    //from is owned by us
                    else if (from_nOBJ.owned_by==ANNE.USER._userNObj.nid) {
                        
                        //our neuron to -> our neuron 
                        if ($toNOBJ.owned_by==ANNE.MEM.USER._userNObj.nid) {
                            await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                        }

                        //our neuron to -> anne neuron
                        else {
                            await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                        }
                    }

                    //from is not ours and not anne's.  Skip.
                    else continue;
                }
            }
        }
    }


    /**
     * Standard outs processor for any given temp neuron
     */
    process_outs=async($lvl, $nObj, $bSKIPGLOBALBES=true, $skipTnids=[])=> {
        if ($nObj.nid!=ANNE.USER._userNObj.nid && ANNE.isANNE($nObj.owned_by)==false && $nObj.owned_by!=ANNE.MEM.USER._userNObj.nid) return;
            
        for (var o=0; o<$nObj.outs.length; o++) {
            var relon = $nObj.outs[o]; //birthday, deathday, birthplace, deathplace etc.
            if (relon.ghost==false) continue;

            if (relon.TEMP_ONLY!=undefined && relon.TEMP_ONLY==true) {
                if (GHOSTDATA.temp_only_deletes.indexOf(relon.txid)==-1) {
                    GHOSTDATA.temp_only_deletes.push(relon.txid);
                }
                continue;
            }
       
            //already covered this.
            if (this.txids_cmds.indexOf(relon.txid)!=-1) {
                continue;
            }
            
            if ($skipTnids.length && $skipTnids.indexOf(relon.r)!=-1) continue;

            if ($bSKIPGLOBALBES==true) {
                if (relon.type==TYPE_BE) {
                    if (relon.r==ANNE.MEM.name.temp_nid) continue;
                    else if (relon.r==ANNE.MEM.class.temp_nid) continue;
                    else if (relon.r==ANNE.MEM.inst.temp_nid) continue;
                    else if (relon.r==ANNE.MEM.constituent_of.temp_nid) {
                        var locNOBJ = MEMG.getNeuronByNid(relon.to_s);
                        if (locNOBJ==null) continue;
                        if (locNOBJ.is(MEM.location)==true) continue;
                    }
                }
            }

            //basic type.  HOWEVER,
            //if we are in collab mode we need collab types!
           // var TXTTYPE = TXB.TXTYPE_CHILD_RELON;
            var TXTTYPE = ANNE.TXB.calcTXTTYPE(relon);   

            if (ANNE.SETTINGS.debug()==true) ANNE.TALK.printRelon(relon);
            
            if (relon.to_type==TO_TYPE_ANNE) {
                var toNOBJ = ANNE.MEMG.getNeuronByTempNid(relon.t);

                if (toNOBJ==null) {
                    console.log("this should not hppen.")
                    continue;
                }
                
                var bANNDLE = false;
                
                //if this isn't a selfrelon (the from nid)
                //we can't muck about with other people's stuff in this app. too complicated.
                //later apps can try to build non-ANNE worldviews and muck about with that.
                if ($nObj.bes[0]==ANNE.MEM.anndle.temp_nid && $nObj.sponsored_by==ANNE.USER._userNObj.nid) {
                    console.log("anndle the sole exception to this rule");
                    bANNDLE=true;
                }
                else if ($nObj.nid!=ANNE.USER._userNObj.nid
                    && ANNE.isANNE(toNOBJ.owned_by)==false 
                    && toNOBJ.owned_by!=ANNE.MEM.USER._userNObj.nid
                    && $nObj.owned_by!=ANNE.USER._userNObj.nid
                    && ANNE.MEM.delegation_reln_tnids.indexOf(relon.r)==-1) continue;
        
                //ghost to 
                if (toNOBJ.ghost==true) {

                    //$nObj here can only be the fromNOBJ
                    if ($nObj.ghost==true) {
                        
                        //this has already been created as a neuron (prior in the sendQ)
                        if (this.handled_neurons.contains(toNOBJ.temp_nid)==true) {
                            var outrelon = {txid:relon.txid, type:relon.type, pending_from_debug:"", from_nid:null, pending_from:"new_"+$nObj.nid, reln:relon.reln, to_type:relon.to_type, to_s:null, pending_to_s:"new_"+toNOBJ.nid, pending_to_debug:$nObj.text};
                            outrelon.pending_from_debug = $nObj.text;
                    
                            this.txids_cmds.push(relon.txid);

                            await ANNE.SENDQ.pendingDynamicVarRelon(outrelon, true, false, true, TXTTYPE, null, false);
                            this.relons_to_process.push(outrelon);
                            continue;
                        }

                        //we need to process this next (including the relon we skipped)
                        else {
                            this.temps_to_still_process.addU({nid:toNOBJ.nid, lvl:$lvl});
                            console.log("pending relon from known neuron %c"+$nObj.text+"%c can't be made until %c"+toNOBJ.text+" %cis made",ANNE.TALK.bggreen, ANNE.TALK.bgblack, ANNE.TALK.bggreen, ANNE.TALK.bgblack);
                            this.make_sure_we_processed.addU(relon);
                            continue;
                        }
                    }

                    //known from, to a ghost toNOBJ
                    else {

                        //this is already a real neuron.
                        //we have already queued up the processing of this NEW NEURON.
                        //we are safe to add in new pending relons here.
                        if (this.handled_neurons.contains(toNOBJ.temp_nid)==true) {
                            var outrelon = {txid:relon.txid, type:relon.type, from_nid:relon.from_nid, reln:relon.reln, to_type:relon.to_type, to_s:null, pending_to_s:"new_"+toNOBJ.nid, pending_to_debug:toNOBJ.text};
                            this.txids_cmds.push(relon.txid);

                            await ANNE.SENDQ.pendingDynamicVarRelon(outrelon, false, false, true, TXTTYPE, null, false);
                            this.relons_to_process.push(outrelon);
                            continue;
                        }

                        //we need to process this next (including the relon we skipped)
                        else {
                            this.temps_to_still_process.addU({nid:toNOBJ.nid, lvl:$lvl});
                            console.log("pending relon from known neuron %c"+$nObj.text+"%c can't be made until %c"+toNOBJ.text+" %cis made",ANNE.TALK.bggreen, ANNE.TALK.bgblack, ANNE.TALK.bgreen, ANNE.TALK.bgblack);
                            this.make_sure_we_processed.addU(relon);
                            continue;
                        }
                    }
                }

                //a known "to" already... (not a ghost)
                else {

                    //known to, ghost from.
                    if ($nObj.ghost==true) {
                        var outrelon = {txid:relon.txid, type:relon.type, pending_from_debug:"", from_nid:null, pending_from:"new_"+$nObj.nid, reln:relon.reln, to_type:relon.to_type, to_s:relon.to_s}
                        outrelon.pending_from_debug = $nObj.text;
                    
                        this.txids_cmds.push(relon.txid);
                        await ANNE.SENDQ.pendingDynamicVarRelon(outrelon, true, false, false, TXTTYPE, null, false);
                        this.relons_to_process.push(outrelon);
                        continue;
                    }

                    //known to and know from (just a ghost relon)
                    //NOTE, if from is ANNE OWNED and TO IS NON-ANNE OWNED
                    //this has to be a COLLAB or COLLAB HANAI!
                    else {      

                        //bounty claim.
                        if ($nObj.temp_nid==ANNE.USER._userNObj.temp_nid && toNOBJ.bes[0]==ANNE.MEM.bounty.temp_nid && 
                            relon.r==ANNE.MEM.bounty_claim.temp_nid && relon.type==TYPE_SYS_MSG) {
                                //if annode_uri was set in this bounty we broadcast it immediately
                                //and do not handle it here.
                                console.log(relon);
                                this.txids_cmds.push(relon.txid);
                                await ANNE.SENDQ.addRelonToSendQ(relon, false, ANNE.TXB.TXTYPE_BOUNTY_CLAIM);
                                continue;
                        }

                        //ASDF accept risk.
                        else if ($nObj.temp_nid==ANNE.USER._userNObj.temp_nid && toNOBJ.bes[0]==ANNE.MEM.ASDF.temp_nid && 
                            relon.r==ANNE.MEM.ASDF_ACCEPT_RISK.temp_nid && relon.type==TYPE_SYS_MSG) {
                                console.log(relon);
                                this.txids_cmds.push(relon.txid);
                                await ANNE.SENDQ.addRelonToSendQ(relon, false, ANNE.TXB.TXTYPE_ASDF_ACCEPT_RISK);
                                continue;
                        }

                        //ASDF add risk.
                        else if ($nObj.temp_nid==ANNE.USER._userNObj.temp_nid && toNOBJ.bes[0]==ANNE.MEM.ASDF.temp_nid && 
                            relon.r==ANNE.MEM.ASDF_ADD_RISK.temp_nid && relon.type==TYPE_SYS_MSG) {
                                console.log(relon);
                                this.txids_cmds.push(relon.txid);
                                await ANNE.SENDQ.addRelonToSendQ(relon, false, ANNE.TXB.TXTYPE_ASDF_ADD_RISK);
                                continue;
    
                        }

                        //add admin rights to a neuron class.
                        else if (this.isRightsSetter(relon)==true) {
                            console.log(relon);
                            this.txids_cmds.push(relon.txid);
                            await ANNE.SENDQ.addRelonToSendQ(relon, false, ANNE.TXB.TXTYPE_ADD_ADMIN);
                            continue;
                        }

                        //skip any relons that are connecting to a pending hanai.
                        //we don't collab until hanai is approved by ANND andy admin
                        //we can potentially do a hanai+collab in ONE TX if this reln is FROM an ANNE NEURON
                        //pointing to a NON-ANNE neuron (to be hanai + the collab relon pointing to it)
                        if (ANNE.isANNE($nObj.owned_by)==true && ANNE.isANNE(toNOBJ.owned_by)==false) { 

                            //feelz
                            if (relon.type==TYPE_AWARENESS && relon.from_nid==USER._userNObj.nid) {
                                this.txids_cmds.push(relon.txid);
                                await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                                continue;
                            }
                            
                            //this user cannot submit a relon pointing to another user's neuron from an ANNE neuron.
                            //that is not collabable.  The owner of the TO can submit a hanai/collab.
                            if (bANNDLE==false && toNOBJ.owned_by!=USER._userNObj.nid
                               && ANNE.MEM.delegation_reln_tnids.indexOf(relon.r)==-1) continue;

                            else if (bANNDLE==true) {
                                await ANNE.SENDQ.addRelonToSendQ(relon, false, ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ);
                                this.txids_cmds.push(relon.txid);
                                continue;
                            }
                        
                            //check if already pending (in local mem, don't chase it)
                            if (relon.type!=TYPE_AWARENESS) {

                                //pending hanai.. collab_ghost.. wait to send it until 
                                //hanai is good.. (to avoid wasting collab sends after a hanai reject)
                                var pending_hanai = ANNE.HANAI.getPendingHanai(toNOBJ);
                                if (pending_hanai!=null) {
                                    continue;
                                }
                                    
                                //we still can't SEND a simple collab here.
                                //this has to be hanai-collab'd...
                                //OR, two step, hanai to neuron, then collab request.
                                //we will do a hanai-collab.
                                else {
                                    await ANNE.SENDQ.addRelonToSendQ(relon, false, ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ);
                                    ANNE.SENDQ.deleteByTXTYPE(ANNE.TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND, relon.txid, "upgraded txid to hanaicollab");
                                    this.txids_cmds.push(relon.txid);
                                    continue;
                                }
                            }
                        }

                        //standard relon request that points to a known neuron.
                        this.txids_cmds.push(relon.txid);
                        await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                        continue;
                    }
                }
            }

            //not to a neuron.. just take it as-is if it isn't be_name, be_class/inst
            else {
                if (relon.type==TYPE_BE) {
                    if ($bSKIPGLOBALBES==true && relon.r==ANNE.MEM.name.temp_nid) continue;
                }
                if ($nObj.ghost==true) {
                    var ge = null;

                    if (relon.r==ANNE.MEM.PDN_SECRET.temp_nid) {
                        console.log("test encoding of encrypted data");
                        ge = new Object();
                        ge.encryption_method=ANNE.TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
                    }

                    //if this is a bounty, we want to pay in the bounty annies with the annies
                    //relon. (else we will reject this relon in the ANNODE)
                    else if (relon.r==ANNE.MEM.annies.temp_nid) {
                        if ($nObj.bes.indexOf(ANNE.MEM.bounty.temp_nid)!=-1) {
                            ge = new Object();
                            ge.payment = parseInt(relon.to_s);
                        }
                    }

                    var outrelon = {txid:relon.txid, type:relon.type, pending_from_debug:"", from_nid:null, pending_from:"new_"+$nObj.nid, reln:relon.reln, to_type:relon.to_type, to_s:relon.to_s}
                    outrelon.pending_from_debug = $nObj.text;
                    
                    this.txids_cmds.push(relon.txid);
                    var cmdObj = await SENDQ.pendingDynamicVarRelon(outrelon, true, false, false, TXTTYPE, ge, false);
                    
                    if (relon.annies!=undefined) cmdObj.annies += cmdObj.annies;

                    //make sure this is in here. (dupe effort from sendQ)
                    if (relon.r==ANNE.MEM.PDN_SECRET.temp_nid && relon.type!=TYPE_PARAM) {
                        cmdObj.add_special(ANNE.TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY);
                    }

                    this.relons_to_process.push(outrelon);
                    continue;
                }

                //just a normal upgrade of a simple relon
                else {
                    this.txids_cmds.push(relon.txid);
                    if (relon.type==TYPE_HAS && relon.reln==ANNE.MEM.annies.nid && relon.to_type==TO_TYPE_NUMBER) {
                        if (parseInt(relon.to_s)>0) {    
                            var gui_extras = new Object();
                            gui_extras.payment = parseInt(relon.to_s);
                            relon.gui_extras = gui_extras;
                        }
                        await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                    }
                    else await ANNE.SENDQ.addRelonToSendQ(relon, false, TXTTYPE);
                }
            }
        }
    }

    
    /**
     * 
     * @param {*} $relon 
     * @returns 
     */
    isRightsSetter = function($relon) {
        if (ANNE.MEM.delegation_reln_tnids.indexOf($relon.r)==-1) return false;
        if ($relon.type!=TYPE_SYS) return false;
        var fNOBJ = MEMG.getNeuronByTempNid($relon.f);
        if (fNOBJ.ntype!=NTYPE_CLASS) return false;
        return true;
    }
}