class mem_processor extends anne_singleton {
    constructor(){ 
        super(false);
        this._memProcessRuns=0;
        this._DOINGPROCESSING_BASE_LVL = false;
    }
    init = function($MEM) {
        this._DOINGPROCESSING_BASE_LVL = false;
    }

    /**
     * When we get word of a merge via the neuron that has been merged..
     * We one-time clean up our mess.
     * Nuke the relons before we process the new relons that use the same
     * txids but now map to a different from!
     * WE DO NOT WANT TO FIND THESE IN OUR PROCESSING LOOP SO WE MUST NUKE THEM FIRST!!!
     * 
     * On the execution of the merge the ANNODE moved over (altered froms) of the relons it could use.
     * Any left behind it nuked from relons... so we should not get this neuron once we process
     * the merge info.
     * @param {*} $merge_nids_to_cleanup 
     */
    mergePrep = async($merge_nids_to_cleanup)=> {
        var ars = [];
        var ghost_txids = [];
        var real_txids = [];
        for (var n=0; n < $merge_nids_to_cleanup.length; n++) {
            var mnid = $merge_nids_to_cleanup[n];
            var mergedNOBJ = MEMG.getNeuronByNid(mnid);
            if (mergedNOBJ!=null) MEMP.annihilate_MERGE_RAM(mergedNOBJ, ars);
        }
        for (var r=0; r < ars.length; r++) {
            if (ars[r].ghost==true) ghost_txids.push(ars[r].txid);
            else real_txids.push(ars[r].txids);
        }
        if (ghost_txids.length) await GHOSTDATA.deleteGhostTxids(ghost_txids);
        if (real_txids.length) await ANNE.DB.___delete(real_txids, "relons");
    }


    annihilate_MERGE_RAM = function ($nObj, $annihilated_relons=null) {
        var beNOBJ = MEMG.getNeuronByTempNid($nObj.temp_nid);
        if (beNOBJ!=null) {
            MEMP.deadBeatDad(beNOBJ);
        }
        var annihilated_relons = $annihilated_relons;
        if (annihilated_relons==null) annihilated_relons = [];
        MEMP.annihilateOutRelons_RAM($nObj, annihilated_relons);
        MEMP.annihilateInRelons_RAM($nObj, annihilated_relons);
        MEMP.annihilateRelnRelons_RAM($nObj, annihilated_relons);
        $nObj.bANNIHILATED = true;
        MEMP._resetNeuron_RAM($nObj);
        //this is an array of dead relon objects with the .txid.
        //we can use it to remove data from DB mem as that only uses the .txid index.
        return annihilated_relons;
    }

    processNeuronsFromRelons = async ($aRelons, $bRETURNALL=false, $bDOLOCALSAVE=true, $tbl="relons", $debug="")=> {
        var bNESTED=false;
        if (this._DOINGPROCESSING_BASE_LVL==true && $bDOLOCALSAVE==true) {
            bNESTED = true;
        }
        
        this._DOINGPROCESSING_BASE_LVL = true;

        if ($bDOLOCALSAVE==false) console.log("%c MEMP.processNeuronsFromRelons %c"+$aRelons.length+"%c just processing into RAM %c"+$debug, ANNE.TALK.bglightbluebold, ANNE.TALK.bgred, ANNE.TALK.msgNote, ANNE.TALK.fromMsg);
        else console.log("%c MEMP.processNeuronsFromRelons %c relons:"+$aRelons.length +"%c+"+$debug, ANNE.TALK.bglightbluebold, ANNE.TALK.bgred, ANNE.TALK.fromMsg);

        if ($aRelons==undefined || $aRelons==null) {
            this._DOINGPROCESSING_BASE_LVL=false;
           // console.log("%c [DONE] MEMP.processNeuronsFromRelons %c", ANNE.TALK.bglightbluebold, ANNE.TALK.bgred)
            return [];
        }
        if ($aRelons.length==0) {
            this._DOINGPROCESSING_BASE_LVL=false;
            //console.log("%c [DONE] MEMP.processNeuronsFromRelons %c", ANNE.TALK.bglightbluebold, ANNE.TALK.bgred)
            return [];
        }
        
        MEMP._memProcessRuns+=1;

        //this is relatively light (vetted as fast);
        var merge_nids_to_cleanup = await MEMP.__brainPreops($aRelons, $bDOLOCALSAVE);
        
        if (merge_nids_to_cleanup.length>0) {
            console.log("cleaning up local mem for merged neuron");
            await this.mergePrep(merge_nids_to_cleanup);
        }

        var _memPoolBootups = [];
        
        //a radical new approach..
        var am = new arraymap();
        
        if ($bDOLOCALSAVE==true) {
            am.setMapKey("txid");
            
            for (let r = 0; r < $aRelons.length; r++) {
                let rObj = $aRelons[r];
                rObj.idb_insert=true;
                
                //note: dont save this relon, EVER
                if (rObj.reln==ANNE.MEM.INTRA_BLOCK_PENDING.nid && rObj.to_s=="pending annex chg") {
                    var rtxid = rObj.txid;
                    var rsysreftxid = rObj.sys_ref_txid;
                    console.log("rtxid:"+rtxid+" vs "+rsysreftxid);
                }

                if (merge_nids_to_cleanup.length && merge_nids_to_cleanup.indexOf(rObj.from_nid)!=-1) continue;
                if (rObj.emulated!=undefined && rObj.emulated==true) continue;
                if (rObj.active==false) continue;
                let time = parseInt(rObj.time); //unconf shoudl be -1 now (NOT 0);
    
                //just a helpful marker to know where we are at on the chain (without looking)
                if (rObj.time!=undefined && time > HISTORY._GREATEST_LAST_KNOWN_BLOCK) {
                    if (rObj.temp==undefined || rObj.temp==false) HISTORY.updateGLKB_fromRelons(time);
                }
                am.addU( rObj);
            }

            //avoiding the insert problem when we haven't yet pulled mem for this
            //from IDB.

            //neuorn_necrosis_list is a summary of all necrosis cmds we've hit this 
            //session in our mem manager.  We can skip all references to these nids, safely.
            await ANNE.IDB.checkForNewTxids_ONLY(am, MEM.neuron_necrosis_list);
        }

        //we already looped/clenaed the doing local save.
        // just loading this part into RAM.
        // bDOLOCALSAVE==true but am.arr_other --> these are the 
        // relons we already had in IDB and moved over to the arr_other arr.
        // They are update candidates if we had net-new info on them.
        // This was already determinced in the checkForNewTxids_ONLY function.
        else if ($bDOLOCALSAVE==false) {

            //we **only** want to process our arr_other relons if we are in bDOLOCALSAVE==true here.
            //|| (am!=null && am.arr_other.length)
            //if(am!=null && am.arr_other.length>0) {
                //$aRelons = am.arr_other;
            //}

            for (let r = 0; r < $aRelons.length; r++) {
                let rObj = $aRelons[r];
                if (merge_nids_to_cleanup.length && merge_nids_to_cleanup.indexOf(rObj.from_nid)!=-1) continue;
                if (rObj.emulated!=undefined && rObj.emulated==true) continue;
                if (rObj.active==false) continue;
                
                //just a helpful marker to know where we are at on the chain (without looking)
                if ((rObj.temp==undefined || rObj.temp==false) && rObj.time!=undefined) {
                    let time = parseInt(rObj.time);
                    if (time > HISTORY._GREATEST_LAST_KNOWN_BLOCK) HISTORY.updateGLKB_fromRelons(time);
                }

                if (rObj.dupe!=undefined && rObj.dupe==true) continue;
                
                var duperel = MEMG.lookupRelonByTXID(rObj.txid);
                if (duperel!=null) {
                    rObj.dupe=true;
                    continue;
                }

                if (rObj.time==-1 && rObj.ghost==false) {
                    //ugly.. bad data, really.  likely on a busted send/return cycle.
                    if (rObj.txid[0]=="z") {
                        rObj.ghost=true;
                        continue;
                    }
                    if (bNESTED==false && ANNE.MEM_UDF.bGETDEDSATBOOTUP==true) {
                        _memPoolBootups.push(rObj.txid);
                    }
                }
            }
        }

        //get all the aRelons back.
        //if(am!=null && $bDOLOCALSAVE==true && am.arr.length>0) {
            //$aRelons = am.arr.concat(am.arr_other);
        //}
        //$aRELONS IS NOW BACK TO ALL.
        //2nd pass.
        var _uniqueFromNidsThisRun = [];
        
        //console.time("memp.pnfr stage 4");

        for (let r = 0; r < $aRelons.length; r++) {
            var rObj = $aRelons[r];
            if (rObj.emulated!=undefined && rObj.emulated==true) continue;
            if (rObj.active==false) continue;

            if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ=MEMG.getOrMakeIfNew(rObj.from_nid);
                
            if (rObj.dupe==true) {

                //update in-mem pubKey for this neuron.  (??? why this one?)
                if (rObj.pubKey!=undefined) {
                    rObj.from_nidTNOBJ.pubKey=rObj.pubKey;
                }

                //make sure it is in our text index.
                ANNE.MEM.addToTextIndex(rObj.from_nidTNOBJ.text, rObj.from_nidTNOBJ.nid);
                    
                //extract key props out of dupe
                rObj.from_nidTNOBJ.extractOtherPropsFromRelon(rObj);
                continue;  
            }

            else if (rObj.pubKey!=undefined) {
                //if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ=MEMG.getNeuronByNid(rObj.from_nid);
                rObj.from_nidTNOBJ.pubKey=rObj.pubKey;
            }

            //extract from/reln and make neurons
            //WE WILL DELETE from_txt_temp and reln_txt_temp after testing.
            //it makes it easier to read CHROME DEBUGGER relons to know what they are.
            MEM.makeAndPushIfUniqueNid(rObj, 'from_nid', 'f', 'from_txt_temp');                            //this sets the .f
            if (_uniqueFromNidsThisRun.indexOf(rObj.from_nidTNOBJ.temp_nid)==-1) {
                _uniqueFromNidsThisRun.push(rObj.from_nidTNOBJ.temp_nid);
            }

            //make sure it is in our text index.
            ANNE.MEM.addToTextIndex(rObj.from_nidTNOBJ.text, rObj.from_nidTNOBJ.nid);
            
            if (rObj.from_nidTNOBJ.ghost==true) {
                rObj.ghost=true;
                rObj.from_nidTNOBJ.owned_by=rObj.ghost_owner;
            }

            //this could be a future COLLAB so we can't mark the fNOBJ as a ghost.
            else if (rObj.ghost_owner!=undefined) {
                rObj.ghost=true;
            }
            
            MEM.makeAndPushIfUniqueNid(rObj, 'reln', 'r', 'reln_txt_temp');
            if (rObj.from_nidTNOBJ==null || rObj.relnTNOBJ==null) {
                ANNE.TALK.printRelon(rObj);
                console.alert("we should never get here");
                continue;
            }

            //more robust handling in MEM_UDF __handleSingleRelonPostOps.
            if (rObj.type==TYPE_BE && rObj.r==MEM.name.temp_nid) {  
                rObj.from_nidTNOBJ.text = rObj.to_s;
                rObj.from_nidTNOBJ.setLatestNameRelon(rObj);
            }

            //extract to and make a neuron
            if (rObj.to_type==TO_TYPE_ANNE 
                    && rObj.r!=MEM.arbor_prune.temp_nid
                    && rObj.r!=MEM.inhibit_relon.temp_nid 
                    && rObj.r!=MEM.necrosis.temp_nid) {
                MEM.makeAndPushIfUniqueNid(rObj, 'to_s', 't');
            }

            else if (rObj.to_type!=TO_TYPE_ANNE &&  rObj.to_type!=TO_TYPE_SEED) {
                if ((MEM._emulatables.length && MEM._emulatables.indexOf(rObj.to_type)!=-1)) {
                    rObj.to_sTNOBJ = MEM.makeAndPushIfUniqueEMULATED(rObj.to_s, rObj.to_type, rObj);
                    if (rObj.to_sTNOBJ.ghost==true) rObj.ghost=true; 
                }
            }

            //build a text index (experimental)
            if (rObj.to_type==TO_TYPE_STRING) {
                if (rObj.type!=TYPE_SYS_MSG) {
                    ANNE.MEM.addToTextIndex(rObj.to_s, rObj.from_nid);
                }
            }



            /************************* SPECIAL INDEXES ******************************/
            //the new owned_by prop from ANNODE is on all BEs and SYS relons.
            /************************************************************************/
            if (rObj.type!=TYPE_SYS_MSG) {

                //ANNODE .owned_by index
                if (rObj.owned_by!=undefined && (rObj.type==TYPE_BE || rObj.type==TYPE_SYS)) {
                    rObj.from_nidTNOBJ.addOwnedBy(rObj.owned_by);
                }

                /********************/
                //ANNODE .sponsored_by index, (for self only, build on-demand for other user queries)
                if ((rObj.sponsored_by!=undefined && rObj.sponsored_by!="" && (rObj.from_nidTNOBJ.sponsored_by==null || rObj.from_nidTNOBJ.sponsored_by==""))) {
                    rObj.from_nidTNOBJ.addSponsoredBy(rObj.sponsored_by);
                }

                /********************/
                //ANNODE .parent index
                //NOTE: this is the same as bes[0]
                if ((rObj.parent!=undefined && rObj.parent!="") && (rObj.from_nidTNOBJ.bes.length==0 || rObj.from_nidTNOBJ.parent=="")) {
                    let parentNObj = MEMG.getOrMakeIfNew(rObj.parent);  //this may be the only reference to this neuron we have...
                    rObj.from_nidTNOBJ.setBeTempNid(parentNObj);
                }
            }

            if (rObj.origin!=undefined) rObj.from_nidTNOBJ.origin = rObj.origin;

            if (rObj.ntype!=undefined && (rObj.from_nidTNOBJ.ntype!==1 && rObj.from_nidTNOBJ.ntype!=0)) {
                rObj.from_nidTNOBJ.ntype=rObj.ntype;
            }

            //quick set of polarity, system wide can use this on loads.
            if (rObj.r==MEM.polarity.temp_nid && rObj.type==TYPE_BE && rObj.to_sTNOBJ!=null && rObj.from_nidTNOBJ.polarity==undefined) {
                rObj.from_nidTNOBJ.polarity = rObj.to_sTNOBJ.polarity;
            }

            /********************/
            rObj.from_nidTNOBJ.extractOtherPropsFromRelon(rObj);

            //first load of memory only..
            //if a profile is pulled up and pieces validated,
            //we store the ico_display prop in and do a DB.update w/ the be name relon.
            //we reload that into here so we can have it again and then when we see that user
            //on the site they will have their logos (ie, sponsored by) even if we haven't
            //went to their profile this session.
            if ($bDOLOCALSAVE==false && rObj.type==TYPE_BE && (rObj.r==MEM.class.temp_nid || rObj.r==MEM.inst.temp_nid)) {
                if (rObj.ico_display!=undefined) rObj.from_nidTNOBJ.ico_display = rObj.ico_display;
            }

            //if this is OUR remembez relon, set the rememberz property in the nObj.
            //this will help the gui with the brain icon.
            if ((ANNE.USER!=null && ANNE.USER._userNObj.nid && rObj.from_nidTNOBJ.from_nid==ANNE.USER._userNObj.nid) && 
                rObj.r==MEM.rememberz.temp_nid && rObj.temp==false) {
                rObj.to_sTNOBJ.rememberz=rObj;
            }

            MEMP.__handleSingleRelonPostOps (rObj, rObj.from_nidTNOBJ);
        }

        //console.timeEnd("memp.pnfr stage 4");

        //We've now set up all our pointers and quick indexes.
        //Build arrays for DB manipulation (add/delete).
        //This function will do the updates.
        //console.time("processRelonsIntoLocalMem");
        //console.time("memp.pnfr stage 5");

        var aNewRelons = [];

        //if local save, we only want to return the aNewRelons
        if ($bDOLOCALSAVE==true) {
            await MEMP.processRelonsIntoLocalMem($aRelons, true);
            if (am!=null) aNewRelons = am.arr;
        }
        else aNewRelons = await MEMP.processRelonsIntoLocalMem($aRelons, $bDOLOCALSAVE);	
        
        //console.timeEnd("memp.pnfr stage 5");

        //a quick loop of NEW relons looking for any arbor or necrosis.
        //we go to those, snag the values, and splice them out of their targets
        //the ar and necro arrays stay in place with the TXIDS of what we removed.
        //console.time("memp.pnfr stage 6");
        MEMP.__brainPostops($aRelons);
        //console.timeEnd("memp.pnfr stage 6");

        //DO POST OPS FOR ALL UNIQUE NIDs.
        // console.time("nidsPostOps");
        //console.time("memp.pnfr stage 7");
        MEMP.nidsPostOps(_uniqueFromNidsThisRun, MEMP._memProcessRuns);
        //console.timeEnd("memp.pnfr stage 7");

        //nuke these nids and any connected relons
        //we updated our new relons (old from to new from)
        //whatever is still left n the absorbed needs to be nuked.

        if (MEM._localRunDelete.length) {
            //console.time("_localRunDelete");
            if (ANNE.DB!=null) await DB.___delete(MEM._localRunDelete, "relons");
            
            //now do the mem wipe of txid... (keep the entry to not upset the array indexes in this session)
            for (let d=0; d<MEM._localRunDelete.length; d++) {
                MEMP.__removeByTXID_master(MEM._localRunDelete[d]);
            }
            MEM._localRunDelete=[];
            //console.timeEnd("_localRunDelete");
        }

        if (ANNE.GUI_STUFF!=null) ANNE.GUI_STUFF.updateMemStats();

        //update the localstore with the aNewRelons!
        //Note: we already updated the ones that were existing relons with net new info.
        if ($bDOLOCALSAVE==true) {
            if(aNewRelons.length && ANNE.DB!=null) {
                if (ANNE.SETTINGS.debug()==true) {
                    console.log("attemping to add "+aNewRelons.length+" new relons to store");
                }
                await DB.___insert(aNewRelons, $tbl);
            }
            //console.timeEnd("memp.pnfr stage 8");
        }

        //this comes from local annode useage and stopping an annode (losing the txs in the mempool)
        //when the annnode boots up it will nuke those stranded TXIDS (and neurons) and replace them 
        //if another mempool broadcasts to them OR a block contains them.
        //In either case, we're safe to assume they are dead now, until they come back.
        //This list is a list of potential deads.
        //We need to lookup each one of these against the active mempool..
        //So ---- get mempool txids.
        if (bNESTED==false && _memPoolBootups.length > 0 && ANNE.MEM_UDF.bGETDEDSATBOOTUP==true) {
            //console.time("_memPoolBootups");
            ANNE.MEM_UDF.bGETDEDSATBOOTUP = false;
            //console.warn("we have potential relons to nuke from this app that were mempool but no longer on the node. INVESTIGATE.");
            var allDedTxids = [];
            //consider a max here... just get what we can done (a few hundred or so..)
            //We don't want to needlessly chase all TXs from a huge blast out ..  ie, 5k TXs
            //that are all unconfirmed .. no need to panic and chase em.
            //wish i could store a last shutdown variable in the annode.. hmmm.
            allDedTxids = await ANNE.CHASE.getAllDEDTXIDS(_memPoolBootups);
            if (allDedTxids.length>0 || ANNE.MEM._localRunDelete.length>0) {
                //nuke em.
                //note -- we should loop these for "MAKER" pattern TXs and nuke the neurons too.
                //note2 -- a really frenly gesture would be to recreate the ghost neurons AND values.
                ANNE.MEM._localRunDelete = ANNE.MEM._localRunDelete.concat(allDedTxids);

                if (MEM._localRunDelete.length) {
                    console.log("%cDELETING TXS that are dead %c", TALK.bgred, TALK.bgyellow);
                    if (ANNE.DB!=null) await DB.___delete(MEM._localRunDelete, "relons");
                    
                    //now do the mem wipe of txid... (keep the entry to not upset the array indexes in this session)
                    for (let d=0; d<MEM._localRunDelete.length; d++) {
                        MEMP.__removeByTXID_master(MEM._localRunDelete[d]);
                    }
                    MEM._localRunDelete = []; //reset for next run.

                    if (MEM._thisRunNECROSIS.length>0) {
                        await ANNE.MEM.removeTextIndexByNids(MEM._thisRunNECROSIS);
                        await ANNE.MEMP.necrosisNeuronsRAM(MEM._thisRunNECROSIS);
                    }
            
                    MEM._thisRunNECROSIS = [];//reset for next run.
                }
            }
            //console.timeEnd("_memPoolBootups");
            //the other should be GOOD and have their time updated if there is a new time. (mined in a block)
        }

        //on any run to store relons
        //we clean up deletes (from idb)
        //and we clean up ram for anything we deleted
        else if (bNESTED==false) {
            if (MEM._localRunDelete.length) {
                console.log("%cDELETING TXS that are dead %c", TALK.bgred, TALK.bgyellow);
                if (ANNE.DB!=null) await DB.___delete(MEM._localRunDelete, "relons");
                for (let d=0; d<MEM._localRunDelete.length; d++) {
                    MEMP.__removeByTXID_master(MEM._localRunDelete[d]);
                }
                MEM._localRunDelete = []; //reset for next run.
            }
            if (MEM._thisRunNECROSIS.length>0) {
                await ANNE.MEM.removeTextIndexByNids(MEM._thisRunNECROSIS);
                await ANNE.MEMP.necrosisNeuronsRAM(MEM._thisRunNECROSIS);
                MEM._thisRunNECROSIS = [];//reset for next run.
            }
        }

            
        if ($bRETURNALL==true) {
            if (am!=null && am.arr_other.length) return $aRelons.concat(am.arr_other);
            this._DOINGPROCESSING_BASE_LVL=false;
            //console.log("%c [DONE] MEMP.processNeuronsFromRelons %c", ANNE.TALK.bglightbluebold, ANNE.TALK.bgred)
            return $aRelons;
        }

        this._DOINGPROCESSING_BASE_LVL=false;
        //console.log("%c [DONE] MEMP.processNeuronsFromRelons %c", ANNE.TALK.bglightbluebold, ANNE.TALK.bgred)
        return aNewRelons;  //return aNewRelons just to return the new ones.
    }
    


    /** 
     * 
     * NOTE: not doing be lvl setting / enforcement as we no longer have the entire mem
     * in RAM.  We cannot count on what we have until we chase the BE LINE UP, then we can build
     * the be lvls.
     * 
     * Run from the mem processor for each unique neuron in the processing run.
     * This essentially means any neurons that were in the "from" slot of a relon
     * have their nids post op function run after the processing is done.
     * 
     * @param {array} - list of temp_nids we want to post-process
     * @param {int} - a frenly int of what mem processing run we are on.
     * 
     */
    nidsPostOps($uniqueTNids, $memProcessRuns=0) {
        //console.log("(nidsPostOps) unique from nids in run %c"+$memProcessRuns+": "+$uniqueTNids.length, TALK.bggreen);
        ANNE.MEM._cascadePropsDownChildrenClasses_cnt=0;
        var did_it = [];
        
        //start at every level 1 (with parent of level 0) 
        //be level and cascade its props down.
        //This will do it most efficiently.
        for (var n=0; n <$uniqueTNids.length; n++) {
            var nObj = MEMG.getNeuronByTempNid($uniqueTNids[n]);

            if (nObj.bes.length==0) continue;

            if (nObj.bes[0]==MEM.anndle.temp_nid) {
                if (ANNE.ANNDLE) ANNE.ANNDLE.addQuick(nObj);
            }
 
            //on preload, we only need to chase be_lvl=1.
            //after that, we must do all.
            if (nObj.be_lvl!=2 && $memProcessRuns<=1) continue;
            
            //level 2 inherits from level 1 (beNOBJ).. and so on.
            var beNOBJ = MEMG.getNeuronByTempNid(nObj.bes[0]);
            //console.log("beNOBJ:"+beNOBJ.text+" for neuron:"+nObj.text);
            nObj.__functInherit(beNOBJ, "memp.nidsPostOps");
        }
    }


    /**                                                
     */
     __handleSingleRelonPostOps = function ($rObj, $nObj) {
        if ($nObj==null || $rObj==null) {
            console.log("__handleSingleRelonPostOps cannot have rObj or nObj null", $rObj, $nObj);
            return;
        }

        //classes that don't have a parent class.  (top level classes)
        //or, a class that was created but at the time didn't know of its parent class.
        //both cases will produce a TYPE_SYS reln:class to:class TX.
        else if ($rObj.type == TYPE_SYS) {

        }

        else if ($rObj.type == TYPE_BE) {
            if ($rObj.r == MEM.name.temp_nid) {
                if ($rObj.to_type==TO_TYPE_STRING) {
                    $nObj.text = $rObj.to_s.trim(); //update the text with the name relon.  Always.
                }
            }

            //neuron->class->class, a top.
            else if ($rObj.r==MEM.class.temp_nid) {
                                    
                if ($rObj.t==MEM.__ANNE_SYS_CLASS.temp_nid) {
                    if (MEM._SYS_PROPS_TNIDS.indexOf($rObj.f)==-1) {
                        MEM._SYS_PROPS_TNIDS.push($rObj.f);
                    }
                }

                else if ($rObj.t == MEM.class.temp_nid) {
                    if ($nObj.ntype == NTYPE_UNKNOWN) {
                        if ($nObj.be=="" && $nObj.bes.length==0) {
                            $nObj.setBeTempNid(MEM.class.temp_nid);
                        }
                    }
                }
            }
            else if ($rObj.r==MEM.inst.temp_nid) {
                if ($rObj.t==MEM.__ANNE_SYS_CLASS.temp_nid) {
                    if (MEM._SYS_PROPS_TNIDS.indexOf($rObj.f)==-1) {
                        MEM._SYS_PROPS_TNIDS.push($rObj.f);
                    }
                }
                if ($nObj.ntype=="") {
                    $nObj.ntype=NTYPE_INST;
                    $nObj.bTERMINATING_TYPE=true; 
                }
            }

            //manual override for a class to be a terminating type.
            else if ($rObj.r==MEM.TERMINATING_TYPE.temp_nid) {
                if ($rObj.t && $rObj.to_type==TO_TYPE_ANNE) {
                    ANNE.MEM.mapSysCode($nObj, $rObj.t);
                    $nObj.bTERMINATING_TYPE = true;
                }
            }
        }

        else if ($rObj.type == TYPE_HAS) {
                        
            //these need to be set before post ops which 
            //depend on them.. so we can capture them here and then
            //know they are set when we run the loop again.
            //set pk (primary_prop)
            //this is for neurons that have a special identifier like another key to make 
            //them unique.  NOTE: this is documentation of a be_class' primary prop so it is 
            //not a TYPE_BE relon to specify what the be prop is.
            if ($rObj.r==MEM.primary_key.temp_nid) {
                if ($nObj['pk']==undefined) $nObj['pk']=$rObj.t;
                else {
                    if ($nObj['pk']!=$rObj.t) {
                        console.warn("we already have a pk! This is different! Serious trouble!");
                    }
                }
            }
             
            else if ($rObj.r==MEM.primary_key2.temp_nid) {  //SET fk property
                if ($nObj['pk2']==undefined) $nObj['pk2']=[$rObj.t];
                else {
                    if ($nObj['pk2'].indexOf($rObj.t)==-1) {
                        $nObj['pk2'].push($rObj.t);
                    }
                }
            }
        }
    }


    /** 
     * This is not necessary with ANNODE now, but we will still do it.
     */
    __brainPreops = async($aRelons, $bDOLOCALSAVE=false)=> {
        var bad_audit = 0;
        var bad_data_rels = [];
        var merge_nids_to_cleanup = [];

        for (var r=0; r <$aRelons.length; r++) {
            var rObj = $aRelons[r];


            //we will remove these after we are done with them.                        
            rObj.from_nidTNOBJ = null;
            rObj.relnTNOBJ = null;
            rObj.to_sTNOBJ = null;

            //we get the cmd one-time, we do not store it.
            //we use it run-time to fix our RAM.
            if (rObj.type==TYPE_SYS && rObj.reln==MEM.MERGED_WITH.nid) {
                merge_nids_to_cleanup.push(rObj.from_nid);  
                rObj.active=false;  
                continue;
            }

            //this is for personal ghosts
            if (rObj.ghost==true) {
                //rObj.temp=true;
                if (rObj.ghost_order!=undefined) {
                    if (parseInt(rObj.ghost_order) > MEM._nextGhostOrder) {
                        MEM._nextGhostOrder = parseInt(rObj.ghost_order)+1;
                    }
                }
            }
            if (rObj.emulated!=undefined && rObj.emulated==true) {
                rObj.active=false;
                continue;
            }
            if(rObj.type==undefined) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="type is undefined";
                continue;
            } 
            if (rObj.to_type==undefined) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="to_type is undefined";
                continue;
                
            }
            if (rObj.reln==undefined) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="reln is undefined";
                continue;
            }
            if (rObj.from_nid==undefined) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="from_nid is undefined";
                continue;
            }
            if (rObj.to_s==undefined) {    //not our relon
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="to s is undefined";
                continue;
            }
            rObj.active = true;		
            if (rObj.to_s==null || rObj.to_type==null || rObj.reln==null  || rObj.from_nid==null || rObj.type==null) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="something is null";
                continue;
            }
            if (rObj.to_s === "") {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="to_s is not set";
                continue;
            }
            if (rObj.to_type === "") {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="to_type not set";
                continue;
            }
            if (rObj.reln === "") {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="reln is not set";
                continue;
            }
            if (rObj.from_nid === "") {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="from_nid is not set";
                continue;
            }
            if (rObj.type === "") {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="type is not set";
                continue;
            }

            rObj.type = parseInt(rObj.type);
            if (rObj.type <0 || rObj.type >255) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="type is out of bounds";
                continue;
            }
            rObj.to_type = parseInt(rObj.to_type);
            if (rObj.to_type <0 || rObj.to_type >255) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="to type is out of bounds";
                continue;
            }

            //strings of longs can be any length up until
            if (rObj.from_nid.length > 20) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="length of reln is too long!";
                continue;
            }

            if (rObj.reln.length > 20) {
                rObj.active=false;
                rObj.bad_data=true;
                bad_audit+=1;
                bad_data_rels.push(rObj);
                rObj.bad_reason="length of reln is too long!";
                continue;
            }
           
            if (rObj.to_type==TO_TYPE_ANNE) {
                if (rObj.to_s.length>20) {
                    rObj.active=false;
                    rObj.bad_data=true;
                    bad_audit+=1;
                    bad_data_rels.push(rObj);
                    rObj.bad_reason="length of toS for a TO_TYPE_ANNE is too long!";
                    continue;
                }
            }
            
            //if this was not stored right on chain (as a number) then convert it here.
            else if (rObj.to_type==TO_TYPE_NUMBER) rObj.to_s = parseFloat(rObj.to_s);
            else {
                rObj.to_s = rObj.to_s+"";
                //if (rObj.to_s!=" ") rObj.to_s = rObj.to_s.trim();
            }

            if (rObj.ghost==undefined) rObj.ghost = false;
            var nid = rObj.from_nid;
            
            //add to the master arbor prune and necrosis lists of ANNE.
            //we will also add to this list with any REDLIST items (once we implement that!)  :)
            if (nid==MEM.ANNE_ADMIN_ACCTID) {
                if (rObj.type==TYPE_SYS) {
                    //when ANNE arbors, its gone.
                    if (rObj.reln==MEM.arbor_prune.nid) {       //use full .reln and .nid here.  The .r is not yet set
                        if (MEM.tx_ap_inh_list.indexOf(rObj.to_s)==-1) {
                            MEM.tx_ap_inh_list.push(rObj.to_s);   
                        }
                        if (rObj.ghost==false) {
                            rObj.active=false;
                            rObj.idb_delete=true;
                            if (MEM._localRunDelete.indexOf(rObj.txid)==-1) {
                                MEM._localRunDelete.push(rObj.txid);
                            }
                        }
                    }

                    //when ANNE inhibits, it is an arbor
                    else if (rObj.reln==MEM.inhibit_relon.nid) { //use full .reln and .nid here.  The .r is not yet set
                        MEM.tx_ap_inh_list.push(rObj.to_s);   
                        if (rObj.ghost==false) {
                            rObj.active=false;
                            rObj.idb_delete=true;
                            if (MEM._localRunDelete.indexOf(rObj.txid)==-1) {
                                MEM._localRunDelete.push(rObj.txid);
                            }
                        }
                    }
                }
            } 

            //we onlyl want to process the real necrosis..
            //the SELF-TYPE_SYS->necrosis->SELF relon burned by protocol.
            else {
                
                //TO DO downstream: 
                //we will want to delete anything from db mem as well "from" or "to" the rObj.to_s
                //using _localRunDelete
                if (rObj.from_nid==rObj.to_s && rObj.type==TYPE_SYS && rObj.reln==MEM.necrosis.nid) { //use full .reln and .nid here.  The .r is not yet set   
                    //only interested in the final protocol-created necrosis here.
                    rObj.active=false;
                    rObj.idb_delete=true;
                    if (MEM.neuron_necrosis_list.indexOf(rObj.to_s)===-1) {
                        MEM.neuron_necrosis_list.push(rObj.to_s);
                    }
                    else continue; //done this already.

                    if (MEM._localRunDelete.indexOf(rObj.txid)==-1) {
                        MEM._localRunDelete.push(rObj.txid);
                    }
                    if (MEM._thisRunNECROSIS.indexOf(rObj.to_s)==-1) {
                        MEM._thisRunNECROSIS.push(rObj.to_s);
                    }
                }
            }
        }
        

        if (bad_audit>0) {
            console.warn("BAD DATA AUDIT", bad_audit);
            console.log(bad_data_rels);
            var bGHOST = false;
            if ($bDOLOCALSAVE==false) {   //load only from mem, fix our mem!
                var bdtxids = [];
                for (var d=0; d < bad_data_rels.length; d++) {
                    bdtxids.push(bad_data_rels[d].txid);
                    if (bad_data_rels[d].ghost==true || bad_data_rels[d].txid[0]=="z") bGHOST=true;
                }
                if (bGHOST==false) await ANNE.DB.___delete(bdtxids);
                else await await ANNE.DB_local.___delete(bdtxids);
            }
        }
        return merge_nids_to_cleanup;
    }


    /**
     * Build add/delete arrays and update net-new info into local DB mem.
     * 
     * This will also manipulate the local RAM neurons/relons.
     * @param {array} - the array of Relons from this processing run.
     * @param {boolean} - a flag to indicate if we are saving this run into the local DB
     * @author {Mr.Scatman}
     */
    processRelonsIntoLocalMem = async ($aRelons, $bDOLOCALSAVE=true)=> {
        var aNewRelons = [];

        for (var r=0; r <$aRelons.length; r++) {
            var rObj = $aRelons[r];
            if (rObj.bad_data==true) continue;  //we do nothing with bad data.

            if ($bDOLOCALSAVE==true) {
                //ths matches a neuron that underwent necrosis
                if (MEM.neuron_necrosis_list.indexOf(rObj.from_nid)!=-1) {
                    rObj.bad_data=true;
                    rObj.active=false;
                    continue;
                }

                //this has already been arbor pruned or inhibited.
                if (MEM.tx_ap_inh_list.indexOf(rObj.txid)!=-1) {
                    rObj.bad_data=true;
                    rObj.active=false;
                    continue;
                }
            }   

            //DUPES CAN PROVIDE NET-NEW INFO SO THERE COULD BE AN UPDATE.
            if (rObj.active==false || rObj.dupe==true) {  
                if (rObj.emulated!=undefined && rObj.emulated==true) continue;
                if (rObj.ghost==true) continue; //ghost never get touched here.
                
                //we already  marked this as a dupe in our pre-process.
                //snag the real relon and look for updatables.
                //this check is necessary when we jam existing txids from their creation (into mem)
                //as temp objects before we pull them from the blockchain.   In these cases we have
                //a real TXID but it is a .temp relon.
                var inMemRObj = null; 
                if (rObj.dupe!=undefined && rObj.dupe==true && (rObj.idb_update==undefined || rObj.idb_update==true)) {
                    
                    //if we have a dupe flag but no dupe_robj_in_mem.. uh... that should not be possible.
                    if (rObj.dupe_robj_in_mem!=undefined) {
                        //snag a ptr to the dupe in memory.
                        inMemRObj = rObj.dupe_robj_in_mem;
                        delete rObj.dupe_robj_in_mem;   //delete the ptr out of the "new" rObj
    
                        //we are just re-loading to the to_s into the working-memory..
                        if (rObj.to_type==TO_TYPE_BLOB && rObj.to_s!="" && inMemRObj.to_s=="BLOB") {
                            inMemRObj.to_s = rObj.to_s; // just update to_s and get out!  no store
                            continue;
                        }    
                    }
                    else continue;
                }

                //our temp neuron (or an existing one w/ more info) 
                if (rObj.idb_update!=undefined && rObj.idb_update==true) {
                    delete rObj.idb_update; //we don't need this anymore.
                    if ($bDOLOCALSAVE==true) {
                        if (inMemRObj!=null) {
                            //console.log("%c updating relon in RAM "+rObj.txid, TALK.bgpink);
                            await DB.___update(inMemRObj, 'relons');
                            $aRelons[r]=inMemRObj;    
                            rObj = $aRelons[r];         //flip the ptrs back.  We're done with inMemRObj special handling
                        }
                    }
                    else {     
                        console.warn("*** WE SHOULD NOT HAVE GOTTEN HERE!!!! ***");
                        continue;
                    }
                }
                continue;
            }   

            //DUPES HAVE NOW BEEN HANDLED.
            if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);

            //the relon finally makes it in to memory we will keep (in the browser).
            if (rObj.time==undefined) rObj.time=-1;

            //this is necessary for temp relons we created that were given a temp TXID 
            //(not a real one) now we have the real one so this is where finally swap it out.
            var temp_tx_id = "";
            if ($bDOLOCALSAVE==true && rObj.from_nidTNOBJ.nid!="7777089034065106708" && rObj.type!=TYPE_INTERNAL_PAY) {
                temp_tx_id = MEMP.killTempRelon(rObj.from_nidTNOBJ, rObj);
            }

            //this relon and its txid are new.
            //hash it in our relons hash table.
            //if this was a preload it is already hashed in its creation function.
            if (temp_tx_id=="") {
                if (rObj.temp==undefined) rObj.temp=false;
                if ((rObj.preloaded==undefined || rObj.preloaded==false) 
                   && (rObj.dupe==undefined || rObj.dupe==false) && rObj.active==true) MEMP.__hashRelon(rObj);
            }


            //update RAM outs and ins for the neuron this relon references
            rObj.from_nidTNOBJ.addUniqueOut(rObj);
            MEMP.addUniqueIns(rObj);          
            
            //we push the new relon to the aNewRelons array to tell our caller to do a DB.update
            //we want this even with the killTempRelon match that updated MEM._aRelon memory
            //and has deleted the old temp xxx txid from DB memory.  It needs to add the new
            //relon object back into DB memory.  (it is already in MEM._aRelon memory and didn't
            //need to be added there again).
            if (rObj.idb_insert==true) {
                aNewRelons.push(rObj);  
            }

            delete rObj.idb_insert;
            delete rObj.idb_update;
            
            //smart update for gui, everywhere.
            //put smart_+"temp_nid" on anything we want the name to update once we get more info.
            if ($bDOLOCALSAVE==true && rObj.r==MEM.name.temp_nid && rObj.type==TYPE_BE) {
                var els = document.querySelectorAll(".smart_"+rObj.f);
                for (var e = 0; e < els.length; e++) {
                    var el = els[e];
                    el.innerHTML=rObj.to_s;
                }
            }
        }

        return aNewRelons;      //MUST RETURN NEW RELONS WE WILL BE ADDING TO THE DB
    }


    /**
     */
    addUniqueIns = function ($rObj) {
        if ($rObj.active==false) return;
        if ($rObj.to_type != TO_TYPE_ANNE) return;
        
        if ($rObj.t==undefined) {
            
            if ($rObj.to_type==TO_TYPE_ANNE && $rObj.to_s!=undefined && $rObj.to_s!="" && $rObj.r!=MEM.necrosis.temp_nid) {
                console.warn("we must have a rObj.t at this point!", $rObj);
                ANNE.TALK.printRelon($rObj);
                if ($rObj.to_sNOBJ==null) $rObj.to_sNOBJ = ANNE.MEMG.getOrMakeIfNew($rObj.to_s);
                $rObj.t=toNOBJ.temp_nid;
            }
                
            else return;
        }
        
        if ($rObj.to_sNOBJ==null) $rObj.to_sNOBJ = MEMG.getNeuronByTempNid($rObj.t);
        if ($rObj.to_sNOBJ==null) {
            console.warn("can't add an in without the to_s resolving to a known neuron!");
            $rObj.active = false;
            return;
        }
        $rObj.to_sNOBJ.addUniqueIns($rObj);
    }


    /** 
     * Do inhibits, arbor prunes, necrosis and some other final indexings.
     * 
     * APPLY inhibits and arbor prunes and necrosis
     * REMINDER:  INHIBITS are local throttles that do not remove relons from the ANNODE.
     * Any user can inhibit any relon they like.  It will be honored in their worldview 
     * via data being removed from their local memory arrays and local DB.
     *
     * ARBOR PRUNES with the right authority alter a neuron for EVERYONE.
     * The self, or owner, or ANNE master account can can ARBOR PRUNE relons.
     * In those cases they are removed and cease to exist in the ANNODE and in all
     * downstream use cases.
     */
    __brainPostops = function($aRelons) {

        //code props (in js) can be set with TYPE_BE or TYPE_SYS relons
        var setCodeProps=function($rObj) {
            if ($rObj.relnTNOBJ==null) $rObj.relnTNOBJ = MEMG.getNeuronByTempNid($rObj.r);
            if ($rObj.relnTNOBJ==null) return;//unfortunately, we may not yet have this reln NOBJ in mem.
            var PNAME = $rObj.relnTNOBJ.PARAM_NAME;
            var REL_PNAME = $rObj.relnTNOBJ.REL_PARAM_NAME;
            if (PNAME!=undefined && PNAME!=null && PNAME.length>1 && PNAME!="text" && PNAME!="name") {
                if ($rObj.from_nidTNOBJ==null) $rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid($rObj.f);
                if ($rObj.from_nidTNOBJ!=null) {
                    var to_val = $rObj.to_s;
                    if ($rObj.TO_TYPE_NUMBER) to_val = parseInt(to_val);
                    else if ($rObj.TO_TYPE_BOOLEAN) to_val = Boolean(to_val);
                    //we could have a prop on the relon to let us know
                    //to store the relon, not the to_s, but that's for later.
                    //no need for it for now.  We want the RELON in the quick
                    //_gt and _gti prop of neurons.
                    if (PNAME=="_gt" || PNAME=="_gti") $rObj.from_nidTNOBJ[PNAME]=$rObj;
                    else $rObj.from_nidTNOBJ[PNAME]=$rObj.to_s;
                }
            }

            //if a reln param val exists, it is true.  It is just a flag.
            //ie, .required, ._multiples_ok.  
            //Non presence of the flag inidcates false.  (not required, multiples NOT ok)
            if (REL_PNAME!=undefined && REL_PNAME!=null && REL_PNAME.length>0) {
                if ($rObj.to_type==TO_TYPE_TXID) {
                    var rel = MEMG.lookupByTXID($rObj.to_s);
                    if (rel!=null) rel[REL_PNAME]=true;
                }
            }
        }

        for (var r=0; r < $aRelons.length; r++) {
            var rObj = $aRelons[r];
            if (rObj.dupe==true) {
                delete rObj.from_nidTNOBJ;
                delete rObj.relnTNOBJ;
                delete rObj.to_sTNOBJ;
                continue;
            }

            var INHBIIT = false;
            var ARBOR = false;
            var NECROSIS = false;

            if (rObj.r==MEM.relon_dimension.temp_nid && rObj.type==TYPE_SYS) {
                if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                rObj.from_nidTNOBJ.target_type = parseInt(rObj.to_s);
            }

            if (rObj.r==MEM.inhibit_relon.temp_nid) {
                if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (rObj.from_nidTNOBJ.inhibit_txs==undefined) rObj.from_nidTNOBJ.inhibit_txs=[];
                else if (rObj.from_nidTNOBJ.inhibit_txs.indexOf(rObj.to_s)!=-1) {
                    delete rObj.from_nidTNOBJ;
                    delete rObj.relnTNOBJ;
                    delete rObj.to_sTNOBJ;
                    continue;    //already done
                }
                rObj.from_nidTNOBJ.inhibit_txs.push(rObj.to_s);
                INHBIIT = true;
                rObj.active = true; 
            }
            else if (rObj.r==MEM.arbor_prune.temp_nid) {
                if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (rObj.from_nidTNOBJ.ap==undefined) rObj.from_nidTNOBJ.ap=[];
                else if (rObj.from_nidTNOBJ.ap.indexOf(rObj.to_s)!=-1) {
                    delete rObj.from_nidTNOBJ;
                    delete rObj.relnTNOBJ;
                    delete rObj.to_sTNOBJ;
                    continue;    //alreayd done
                }
                rObj.from_nidTNOBJ.ap.push(rObj.to_s);
                ARBOR = true;
                rObj.active = true; 
            } 

            //for now, let's only apply necrosis on the PROTOTCOL-CREATED SELF-FROM NEURON.
            //that way we need not muck about it before we need it.
            else if (rObj.r==MEM.necrosis.temp_nid) {
                rObj.active = false; 
            }


            if (INHBIIT || ARBOR) {
                var targetRelon = MEMG.lookupRelonByTXID(rObj.to_s);
                if (targetRelon!=null) {

                    //if this relon is from the neuron owner OR ANNE OR US(self)
                    //we can remove it from the arrays.
                    var targetFromNOBJ = MEMG.getNeuronByTempNid(targetRelon.f);

                    if (targetRelon.from_nid==rObj.from_nid 
                        || rObj.from_nidTNOBJ.temp_nid==ANNE.MEM.__ANNE__.temp_nid
                        || (ANNE.USER._userNObj!=null && ANNE.USER._userNObj.nid!=0 
                                && rObj.from_nidTNOBJ.temp_nid==ANNE.USER._userNObj.temp_nid)) {

                        //turn the target relon off.
                        targetRelon.active=false;

                        //remove it from the outs of the from NOBJ
                        rObj.from_nidTNOBJ.removeByTXID('outs', targetRelon.txid);
                        
                        //if the target Relon was an ANNE TX,
                        //also remove the in of the to.
                        if (targetRelon.to_type==TO_TYPE_ANNE) {
                            var toNOBJ = MEMG.getNeuronByTempNid(rObj.t);
                            if (toNOBJ!=null) toNOBJ.removeByTXID('ins', targetRelon.txid);
                        }
                        
                        //add the txid to the tracker array.  We will block any
                        //new attempts to get this .txid back into RAM.
                        MEM.tx_ap_inh_list.push(targetRelon.txid);

                        //this will need to remove the sponsored_by index
                        //on ALL TYPE_BE and TYPE_SYS relons and also update
                        //DB mem for relons already in DB mem.
                        if (targetRelon.r==MEM.sponsored_by) {
                            if (targetFromNOBJ.sponsored_by!=undefined 
                                && targetFromNOBJ.sponsored_by==targetRelon.to_s) {
                                    targetFromNOBJ.sponsored_by="";
                                console.warn("TO DO FIX TYPE BE/SYS from targetFromNOBJ"); 
                            }
                        }

                        else if (targetRelon.r==MEM.inst.temp_nid || targetRelon.r==MEM.class.temp_nid) {
                            
                            //removal of parent as this parent will remove bes array entries
                            //for this neuron.
                            targetFromNOBJ.childDisavowsParent(targetRelon.t);
                            console.warn("TO DO FIX TYPE BE/SYS from targetFromNOBJ "+targetFromNOBJ.text);
                            ANNE.TALK.printRelon(targetRelon);
                        }

                        else if (targetRelon.r==MEM.name.temp_nid) {
                            if (rObj.from_nidTNOBJ.text==targetRelon.to_s) {
                                rObj.from_nidTNOBJ.text="";
                                rObj.from_nidTNOBJ.text=MEM.setTextWithFirstValidAssigner(rObj.from_nidTNOBJ);
                            }
                        }

                        targetRelon.idb_delete=true;

                        //ADD the target relon to the localRunDelete array.
                        //we batch delete these at the end of this run.
                        //Also, finally destroy it out of the master relons array.
                        if (targetRelon.ghost==false) {
                            MEM._localRunDelete.push(targetRelon.txid); 
                        }  
                    }
                }
            }

            //no other active=false relons get processed any further.
            else if (rObj.active==false) {
                delete rObj.from_nidTNOBJ;
                delete rObj.relnTNOBJ;
                delete rObj.to_sTNOBJ;
                continue;
            } 

            //FINAL PREP WORK
            //super mojo here..
            //some PARAM NAMES are BEs and handled hardcoded.
            //we don't want dynamic props there to interfere.
            //these, however, are dynamic and can be UDF on-chain..
            //to tune the code with available nobj and relon props.
            //IF TYPE_SYS and the RELNOBJ has a PARAM_NAME set (pval)
            //set the fromNOBJ[pval] = rObj.to_s
            //IF TYPE_SYS and the RELNOBJ has a RELON_PARAM_NAME set (pval)
            //set the rObj[pval] = rObj.to_s
            else if (rObj.type==TYPE_SYS) {
                setCodeProps(rObj);  
            }

            //give me a be array (first gen).
            else if (rObj.type==TYPE_BE) {   
                if (rObj.to_type==TO_TYPE_ANNE) {
                    
                    setCodeProps(rObj)

                    if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                    if (rObj.from_nidTNOBJ==null) {
                        console.warn("NEVER SHOULD HAPPEN BUT WITH NEW MEM OPTIMIZERS --- INVESTIGATE");
                        rObj.from_nidTNOBJ = MEMG.getNeuronByNid(rObj.from_nid);
                    }

                    rObj.from_nidTNOBJ.addUniqueBe(rObj);

                    //set identity flag..
                    //this is a strong differentiator in ANNE.
                    //identities are users.. all other neurons are not.
                    rObj.from_nidTNOBJ.bISIDENTITY = MEM.tempBeIsA(rObj.from_nidTNOBJ.temp_nid, MEM.identity.temp_nid, NTYPE_INST);
                }

                //we store both aka and birthname as an aka.
                //this allows us more info than just an aka but the functionality.
                else if (rObj.r==MEM.aka.temp_nid || rObj.r==MEM.birthname.temp_nid) {
                    if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                    rObj.from_nidTNOBJ.addAka(rObj);
                }

                //we didnt cover the TO_TYPE_ANNE cases
                //we waited so we could check for PARAM.
                //Dupe param names WILL NOT WORK and I'm not going 
                //to worry about it.
                else {
                    if (rObj.relnTNOBJ==null) rObj.relnTNOBJ = MEMG.getNeuronByTempNid(rObj.r); //iso_..
                    if (rObj.relnTNOBJ==null || rObj.relnTNOBJ.PARAM_NAME==undefined) {
                        delete rObj.from_nidTNOBJ;
                        delete rObj.relnTNOBJ;
                        delete rObj.to_sTNOBJ;
                        continue;
                    }
                    if (rObj.relnTNOBJ.PARAM_NAME!="text" && rObj.relnTNOBJ.PARAM_NAME!="name") {
                        if(rObj.relnTNOBJ.PARAM_NAME=="_company_type") {
                            console.log("test company type getting set from BE use of company type BE");
                        }
                        //this value is an attribute but no necessarily the PK or PK2.
                        if (rObj.from_nidTNOBJ==null) {
                            //console.log("why?");
                            rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                        }
                        rObj.from_nidTNOBJ[rObj.relnTNOBJ.PARAM_NAME]=rObj.to_s;

                        //if this reln is the pk or pk2 of the parent of the from
                        if (rObj.from_nidTNOBJ.bes.length==0) {
                            delete rObj.from_nidTNOBJ;
                            delete rObj.relnTNOBJ;
                            delete rObj.to_sTNOBJ;
                            continue;
                        }

                        //this won't get creative "BES".. (BE_CHILDREN defined by relon other than parent)
                        //we can get it in a buildAndInjectMod module load if needed in a specific app.
                        //in MEM we do LANG and COUNTRY as examples of how to build dynamic MODULES.
                        var beNOBJ = MEMG.getNeuronByTempNid(rObj.from_nidTNOBJ.bes[0]);
                        if (beNOBJ==null || beNOBJ.pk==undefined) {
                            delete rObj.from_nidTNOBJ;
                            delete rObj.relnTNOBJ;
                            delete rObj.to_sTNOBJ;
                            continue;
                        }
                        //we could put pk_val = or pk2_val = on this nObj.
                        if (rObj.relnTNOBJ.temp_nid==beNOBJ.pk) {
                            rObj.from_nidTNOBJ["pk_val"] = rObj.to_s;
                            rObj.from_nidTNOBJ["pk_name"] = rObj.relnTNOBJ.PARAM_NAME;
                        }                            
                    }
                }
            }

            //TYPE HAS....
            else if (rObj.type==TYPE_HAS) {
                if (rObj.from_nidTNOBJ==null) rObj.from_nidTNOBJ = MEMG.getNeuronByTempNid(rObj.f);
                if (rObj.from_nidTNOBJ==null) {
                    console.log("%c YUGE PROBLEM fix this", TALK.bgpink);
                    delete rObj.from_nidTNOBJ;
                    delete rObj.relnTNOBJ;
                    delete rObj.to_sTNOBJ;
                    continue;
                }

                if (rObj.from_nidTNOBJ.type==NTYPE_INST) {
                    if(rObj.to_type==TO_TYPE_STRING) {
                        if (rObj.relnTNOBJ==null) rObj.relnTNOBJ = MEMG.getNeuronByTempNid(rObj.r);
                        if (rObj.relnTNOBJ.text.length) {
                            rObj.from_nidTNOBJ[rObj.relnTNOBJ.text.replace(" ","_")]=rObj.to_s;
                        }
                    }
                    else if (rObj.to_type==TO_TYPE_ANNE) {
                        if (rObj.relnTNOBJ==null) rObj.relnTNOBJ = MEMG.getNeuronByTempNid(rObj.r);
                        if (rObj.relnTNOBJ.text.length) {
                            if (rObj.to_sTNOBJ==null) rObj.to_sTNOBJ = MEMG.getNeuronByTempNid(rObj.t);
                            if (rObj.to_sTNOBJ!=null) {
                                rObj.from_nidTNOBJ[relnNOBJ.text.replace(" ","_")]=rObj.to_sTNOBJ.text;
                            }
                        }
                    }
                }
            }

            delete rObj.from_nidTNOBJ;
            delete rObj.relnTNOBJ;
            delete rObj.to_sTNOBJ;
        }

        //MEM._MOD_FUNC_CALLER(ANNE.MEM_UDF, '_udf_handleBrainPostOp');
    }




    //***************** SUPORTING PROCESSING FUNCTIOINS *****************//


    /** 
     * @author {Mr.Scatman} 
     */
     __deleteRelonHash=function($oldtxid, $txid) {
        if ($oldtxid!=$txid) {
            var key = $oldtxid;
            if (key.length == 0) return;

            //safe to delete the old index from the hash table,
            //NEVER DELETE IT FROM THE RELONS TBL
            if (MEM._aRelons_hashtbl[key]!=undefined) {
                var rel = MEM._aRelons[ MEM._aRelons_hashtbl[key] ];
                rel.dead = true;
                delete MEM._aRelons_hashtbl[key]; 
            }
        }
    }



    /** 
     * @author {Mr.Scatman} 
     */
     __hashNeuron = function($nObj){
        if ($nObj==null || $nObj.nid==undefined) { return; }
        
        var index = $nObj.nid;// Math.abs(hash);
        if (MEM._aNeurons_hashtbl[index]!=undefined) {
             //already have this  neuron hash.
             return;
        }
                
        //hash tables provides index to temp_nid.
        else {
            var temp_nid = MEM._aNeurons.length;
            MEM._aNeurons_hashtbl[index]=temp_nid;
            $nObj.temp_nid = temp_nid;
            MEM._aNeurons.push($nObj);
        }
    }


    /**
     * @author {Mr.Scatman}
     */    
     __hashRelon = function($rObj){
        if ($rObj==null) {
            console.log("%c ((YOU HAVE NO ROBJ TO HASH", 'background: white; color: red');
            console.log($rObj);
            return null;
        }
        var key = $rObj.txid;
        if (key==undefined) {
            console.log("%c ((YOU HAVE NO txid on that robj", 'background: white; color: red');
            return null;
        }

        if (key.length == 0) return;

        var hti = MEM._aRelons_hashtbl[key];
        if (hti!=undefined) {
            if (MEM._aRelons[hti].txid==$rObj.txid) {
                //console.warn("fix this -- the relon should have been flagged as already found", $rObj);
                return; //same relon.
            }
            console.log("%c ((has collision:"+$rObj.txid+" vs "+MEM._aRelons[hti].txid+"", 'background: white; color: red');
        }

        //hash tables provides index to rid.
        //don't want the large objects in the hash object.
        else {
            var rid = MEM._aRelons.length;
            MEM._aRelons_hashtbl[key]=rid;
            $rObj.rid = rid;
            MEM._aRelons.push($rObj);
            return;
        }
    }


    /**
     * @author {Mr.Scatman}
     */
     __hashRelonDelete=function($txid) {
        var rid = MEM._aRelons_hashtbl[$txid];
        if (rid==undefined) return null;
        else delete MEM._aRelons_hashtbl[rid];
        return;
    }


    /**
     * Update a temp txid to a real one.
     * @author {Mr.Scatman}
     */
    __hashRelonUpdate=function($rObj_existing, $rObj_new) {
        var rid = -1;
        var oldtxid = -1;
        if ($rObj_new==undefined || $rObj_new==null) return;

        if ($rObj_existing!=null && $rObj_existing!=undefined) {
            rid = $rObj_existing.rid;           
            oldtxid = $rObj_existing.txid;
        }

        //there is no existing, just do a new
        else {
            MEMP.__hashRelon($rObj_new);
            return;
        }

        //we don't have an existing 
        if (rid==undefined || rid==-1) {  
            if ($rObj_new==null) {
                console.log("%c ((YOU HAVE NO new ROBJ TO HASH", 'background: white; color: red');
                return;
            }
            else if ($rObj_new.txid==undefined) {
                console.log("%c ((YOU HAVE NO txid on this robj", 'background: white; color: red');
                console.log($rObj_new);
                return;
            }
            
            MEMP.__hashRelon($rObj_new);    //just hash the new and get out.          
            return;
        }

        //the rid is indexes in to the master relons array already, 
        //we need to set a new hashtbl entry (for the new real txid) to THIS rid.
        else {
            var hash = 0;
            var key = $rObj_new.txid;
            if (key.length == 0) return hash;
            MEM._aRelons_hashtbl[key] = rid;
            $rObj_existing.txid = key;
            MEMP.__deleteRelonHash(oldtxid, key);
        }

        return;
    }


    /**
     * Update the new relon in mem.
     * 
     * We created a temp relon in local memory before we sent a TX.
     * Here we want to take the temp txid and update it with the real TXID.
     * We don't require waiting for processing the new relon to do this. 
     * @param {object} - The existing relon we used to send via the API.
     * @param {string} - The new transaction ID of the actual broadcast relon.
     * 
     * @author {Mr.Scatman} 
     */
    __hashRelonUpdate_AFTER_SEND=function($rObj_existing, $txid="") {
        var rid = -1;
        var oldtxid = -1;
        if ($txid==undefined || $txid==null || $txid=="") {
            console.log("%c ((__hashRelonUpdate_AFTER_SEND) YOU HAVE NO new txid", 'background: white; color: red');
            return;
        }

        if ($rObj_existing!=null && $rObj_existing!=undefined) {
            
            //relon already handled.
            if ($rObj_existing.old_txid!=undefined && $rObj_existing.old_txid.length) return;

            rid = $rObj_existing.rid;           
            oldtxid = $rObj_existing.txid;
            if (oldtxid==undefined) return;
            if (oldtxid[0]!="z") return;    //txid MUST be a z txid here
        }

        //there is no existing, 
        //this relon was never in the hash table.
        //just update it with the new TXID and hash it now.
        else {
            console.log("%c ((__hashRelonUpdate_AFTER_SEND) no existing relon passed in", 'background: white; color: red');
            return;
        }

        $rObj_existing.temp=false;
        $rObj_existing.emulated=false;
        $rObj_existing.ghost=false;
        
        //we don't have an existing
        //just do it new here.
        if (rid==undefined || rid==-1) { 
            $rObj_existing.txid=$txid;
            //console.log("hashing anew");
            MEMP.__hashRelon($rObj_existing);    //just hash the new and get out.     
        }

        //the rid is indexes in to the master relons array already, 
        //we need to set a new hashtbl entry (for the new real txid) to THIS rid.
        else {
            var key = $txid;
            MEM._aRelons_hashtbl[key] = rid;
            $rObj_existing.txid = $txid; 
            $rObj_existing.old_txid = oldtxid.substring(0); //force copy;
            MEMP.__deleteRelonHash(oldtxid, $txid);    
        }
        return;
    }


    /** 
     * Kill a temp relon.
     * 
     * NOTE: REVISIT THIS WITH OUR TEMP RELON LENGTH -- TO CONFIRM WE STILL 
     * GET 65 length TXIDS FOR ALL NON-REAL CASES.
     *  
     * @author {Mr.Scatman}
     */
     killTempRelon=function($nObj, $rObj) {
        if ($nObj==null || $nObj.outs==undefined || $nObj.outs.length==0) return "";
        var temp_tx_id = "";
        if ($rObj==null) return null;

        for (var r=0; r < $nObj.outs.length; r++) {
            var rObj = $nObj.outs[r];
            if ((rObj.temp==undefined || rObj.temp==false) && rObj.emulated==false) continue;

            //this relon matches another relon
            if (rObj.from_nid==$rObj.from_nid
                && rObj.type==$rObj.type 
                && rObj.reln==$rObj.reln 
                && rObj.to_type==$rObj.to_type
                && rObj.to_s==$rObj.to_s) {
                //console.warn("(killTempRelon) FOUND A .temp DUPE");

                //if the other relon is a temp, switch it to a real.
                //REMOVE the temp relon from the nObj.outs array.  The new one will already
                //have been pushed in to there.
                if (rObj.txid.length!=64 && (rObj.temp==true || rObj.emulated==true)) {
                    temp_tx_id = rObj.txid;
                    MEMP.__hashRelonUpdate(rObj, $rObj);
                    if ($rObj.time!=undefined) rObj.time=$rObj.time;
                    else if ($rObj.firstseen!=undefined) rObj.firstseen=$rObj.time;
                    if (rObj.temp==true) rObj.temp=false;
                    if (rObj.emulated==true) rObj.emulated=false;
                    $nObj.outs.splice(r, 1);    //REMOVE THIS OUT.
                    return temp_tx_id;
                }
            }
        }
        return "";
    }




    /**
     * We run this ONCE to catch flags we want to set after login that we      
     * couldn't set because we weren't logged in yet.   
     * @author {Mr.Scatman}
     *    
     * NOTE: we really need to login before we load the memory...uug                    
     */
     __postLoginCleanup = async ()=> {
        if (ANNE.USER._userNObj.owns==null) ANNE.USER._userNObj.owns=[];
        var us = ANNE.USER._userNObj.nid;
        var owns = null;
        var my_sponsored = null;

        if (ANNE.USER._userNObj.owns==undefined || ANNE.USER._userNObj.owns==null) {
            ANNE.USER._userNObj.owns = [];
        }
        owns = ANNE.USER._userNObj.owns;

        if (ANNE.USER._userNObj.my_sponsored==undefined || ANNE.USER._userNObj.my_sponsored==null) {
            ANNE.USER._userNObj.my_sponsored = [];
        }
        my_sponsored = ANNE.USER._userNObj.my_sponsored 

        for (var n=0; n < MEM._aNeurons.length; n++) {
            var nObj = MEM._aNeurons[n];
            if (nObj.owned_by==us) {
                if (owns.indexOf(nObj.temp_nid)==-1) owns.push(nObj.temp_nid);
                nObj.mine = true;
            }
            else if (nObj.sponsored_by==us) {
                if (my_sponsored.indexOf(nObj.temp_nid)==-1) my_sponsored.push(nObj.temp_nid);
            }
        }

        //another post process loop. (lol)
        for (var r=0; r<MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].relon_sponsor!=undefined && MEM._aRelons[r].relon_sponsor==us) {
                ANNE.USER._userNObj.addUsAsRelonSponsor(MEM._aRelons[r]);
            }

            //we have some kind of any rights to either this class or inst.
            //lets tally it in our andy_nids so we can more easily query for andy admin 
            if (MEM._aRelons[r].t==USER._userNObj.temp_nid) {
                if (MEM.delegation_reln_tnids.indexOf(MEM._aRelons[r].r)!=-1) {
                    USER._userNObj.addAndy(MEM._aRelons[r].from_nid);
                }
            }
        }

        //make sure we got our adopted in there (we skipped them in pre-load before we were logged in)
        //we only process our adopted array
        //same with remembers/forgetz (or any cheat props on the nObj)
        var outs = ANNE.USER._userNObj.outs;
        for (var r=0; r < outs.length; r++) {
            var rObj = outs[r];
            if (rObj.r==MEM.trusted_adopt.temp_nid) ANNE.USER._userNObj.addTrustedAdopt(rObj.t);
            if ((rObj.r==MEM.rememberz.temp_nid) && rObj.temp==false) {
                var toNOBJ = MEMG.getNeuronByTempNid(rObj.t);
                toNOBJ.rememberz = rObj;
            }
        }

        //clean up the user's view for relons they've inhibited that are of their own.
        if (ANNE.USER._userNObj.inhibit_txs!=undefined) {
            var inh = ANNE.USER._userNObj.inhibit_txs;
            for (var i=0; i < inh.length; i++) {
                var txid = inh[i];
                var rObj = MEMG.lookupRelonByTXID(txid);
                if (rObj==null) continue;
                var fromNObj = MEMG.getNeuronByTempNid(rObj.f);
                
                //if we own the neuron that has the inhibited relon, we can deactivate it.
                if (fromNObj.mine==true) rObj.active = false; 
            }
        }

        if (ANNE.USER._userNObj.ap!=undefined) {
            var ap = ANNE.USER._userNObj.ap;
            for (var i=0; i < ap.length; i++) {
                var txid = ap[i];
                var rObj = MEMG.lookupRelonByTXID(txid);
                if (rObj==null) continue;


                var fromNObj = MEMG.getNeuronByTempNid(rObj.f);
                
                //we should have this deleted from memory.
                if (fromNObj.mine==true) {
                    rObj.active = false;     
                    await ANNE.DB.___delete([rObj]);
                }
            }
        }

    }
    

    /** 
     * Nuke a relon's data of the master relons array. 
     *
     * NEVER NEVER NEVER DELETE ITEMS FROM _aRelons.  It will shift all
     *  our INDEXES.  BIG BIG BIG NO NO. 
     * @author {Mr.Scatman} 
     */
    __removeByTXID_master = function ($txid) {
        var rel = ANNE.MEMG.lookupByTXID($txid);
        if (rel!=null) {
            rel.active=false;
            rel.from_nid="";
            rel.to_s="";
            rel.reln="";
            rel.outs = [];
            rel.ins = [];
            rel.txid="";
            return true;
        }
        for (var r=0; r < MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].txid==$txid) {
                MEM._aRelons[r].active=false;
                MEM._aRelons[r].from_nid="";
                MEM._aRelons[r].to_s="";
                MEM._aRelons[r].reln="";
                MEM._aRelons[r].outs = [];
                MEM._aRelons[r].ins = [];
                MEM._aRelons[r].txid="";
                return true;
            }
        }
        return false;    
    }


    /** 
     * @author {Mr.Scatman} 
     */
    removeActiveWorldView = function ($worldviewNid) {
        var WV = parseInt($worldviewNid);
        var match = MEM._activeWorldViewNids.indexOf(WV);
        if (match!==-1) MEM._activeWorldViewNids.splice(match, 1);
    }



    /**
     * we've taken it out of outs/ins but it is still in the _aRelons.
     * We do not want to delete from that array as it will totally muck
     * up our indexes.. just set the obj vals to null.
     */
    _resetRelon=function($relon){
        $relon.from_nid=null;
        $relon.to_s=null;
        $relon.reln=null;
        $relon.to_type=null;
        $relon.type=null;
    }


    /**  
     * @author {Mr.Scatman} 
     */
    _resetNeuron_RAM=function($nObj) {
        if ($nObj.outs && $nObj.outs.length && $nObj.bANNIHILATED==undefined) {
            console.warn("(resetNeuron) must annihilate outs first");
        }
        if ($nObj.ins && $nObj.ins.length) {
            console.warn("(resetNeuron) must annihilate ins first");
        }

        //remove this neuron from its owner's own array
        var owned_by = $nObj.owned_by;
        if (owned_by) {
            var ownerNObj = MEMG.getNeuronByNid(owned_by);
            if (ANNE.UTILS!=null) ANNE.UTILS.removeFromNidArray(ownerNObj.owns, $nObj.temp_nid);
            else alert("TO DO");
        }

        //remove this neuron from any children arrays.
        var bes = $nObj.bes;
        for (var b=0; b < bes.length; b++) {
            var beNObj = MEMG.getNeuronByTempNid(bes[b]);
            if (ANNE.UTILS!=null) ANNE.UTILS.removeFromNidArray(beNObj.children, $nObj.temp_nid);
            else alert("TO DO");
        }

        //DO NOT DELETE THIS ... it will be irrelevant on the next
        //load of the memory manager.
        //$nObj.temp_nid = -1;
        $nObj.dead=true;
        $nObj.text = "**dead**";
        $nObj.ntype = NTYPE_UNKNOWN;
        //delete MEM._aNeurons_hashtbl[$nObj.nid];
        //$nObj.nid = "";
        
        $nObj.ins = [];
        $nObj.outs = [];	
        $nObj.be = "";
        $nObj.bes = [];
        $nObj.ap = [];
        $nObj.necro = [];
        $nObj.owns = [];
        $nObj.emulated=false;	
        $nObj.owned_by = "";
        $nObj.mine = false;
        $nObj.children = [];
        $nObj.bTERMINATING_TYPE=false;
        $nObj.temp=false;
        $nObj._gt=null;
        $nObj._gti=null;
        $nObj.short="";
        $nObj.parent="";
        $nObj.aka=[];
    }   


    /**
     * Complete nuke a neuron from existence.
     * 
     * This will delete all ins, outs and references to this from the MEM. (RAM)
     * Use the annihilated_relons array to nuke it out of DB mem.
     * 
     * @author {Mr.Scatman}  
     */
    annihilate_RAM = function ($nObj, $annihilated_relons=null, $bREMOVEINDEX=true) {
        
        if ($bREMOVEINDEX==true) MEM.removeTextIndex($nObj.text, $nObj.nid);   //this will kill the text index

        var beNOBJ = MEMG.getNeuronByTempNid($nObj.temp_nid);
        if ($nObj.freeze==1 && $nObj.ghost==false 
            && (USER._userNObj.nid!=MEM.ANNE_ADMIN_ACCTID || 
                USER._userNObj.nid!=MEM.ANNE_ADMIN_BACKUP_ACCTID)) return [];    //can't nuke a frozen neuron.
        
        if (beNOBJ!=null) {
            
            //remove all children of this neuron -- they are now orphans.
            MEMP.deadBeatDad(beNOBJ);
        }
        
        var annihilated_relons = $annihilated_relons;
        if (annihilated_relons==null) annihilated_relons = [];

        MEMP.annihilateOutRelons_RAM($nObj, annihilated_relons);
        MEMP.annihilateInRelons_RAM($nObj, annihilated_relons);
        MEMP.annihilateRelnRelons_RAM($nObj, annihilated_relons);

        $nObj.bANNIHILATED = true;
        MEMP._resetNeuron_RAM($nObj);

        //this is an array of dead relon objects with the .txid.
        //we can use it to remove data from DB mem as that only uses the .txid index.
        return annihilated_relons;

    }

    
    /**
     * 
     * @param {*} $rObj 
     */
    localOnlyArborPrune_RAM=function($rObj) {
        if (ANNE.SETTINGS.debug()==true) console.log("localOnlyArborPrune_RAM", $rObj);
        var annihilated_txids = [];
        MEMP.annihilateRelon_RAM($rObj, annihilated_txids);
        console.log("localOnlyArborPrune_RAM "+annihilated_txids.length+" has relons");
    }



    /**
     *  Nuke all ins
     * 
     *  This is only used on nObj arrays, safe to do as-is. 
     * @param {object} - the neuron
     * @param {array} - store the nuked relons in the array for downstream DB handling.
     * @author {Mr.Scatman}  
     *
     */   
     annihilateInRelons_RAM = function ($nObj, $annihilated_relons=[]) {
        if ($nObj.ins==undefined || $nObj.ins.length==0) return;

        //loop em all till they are gone.
        while ($nObj.ins.length) {
            var targetRelon = $nObj.ins[0];
            $nObj.removeByTXID('ins',  targetRelon.txid, $annihilated_relons);
            if (targetRelon.from_nid) {
                var fNOBJ = MEMG.getNeuronByNid(targetRelon.from_nid);
                fNOBJ.removeByTXID('outs', targetRelon.txid, $annihilated_relons);
            }  
        }
        if ($nObj.ins.length>0) {
            console.log("%c still ins leftover?  FIX THIS MRSCATMAN NOW!", TALK.bgredbig);
        }
    }

    /**
     *  Nuke all spots a neuron is used as the reln.
     * 
     * @param {object} - the neuron
     * @param {array} - store the nuked relons in the array for downstream DB handling.
     * @author {Mr.Scatman}  
     *
     */   
    annihilateRelnRelons_RAM = function ($nObj, $annihilated_relons=[]) {
        for (var r=0; r < MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].r==$nObj.temp_nid) {
                $annihilated_relons.push(MEM._aRelons[r].txid);
            }
        }
    }


    /**
     *  Nuke all outs
     * 
     *  This is only used on nObj arrays, safe to do as-is. 
     * @param {object} - the neuron
     * @param {array} - store the nuked relons in the array for downstream DB handling.
     * @author {Mr.Scatman}  
     *
     */   
    annihilateOutRelons_RAM = function ($nObj, $annihilated_relons=[]) {
        var arr = $nObj['outs'];
        if (arr==undefined || arr.length==0) return;    
        for (var r=0; r < $nObj.outs.length; r++) {
            var targetRelon = $nObj.outs[r];
            var done = $nObj.removeByTXID('outs', targetRelon.txid, $annihilated_relons);
            if (done==true) {
                if (targetRelon.to_s && targetRelon.to_type == TO_TYPE_ANNE) {
                    var tObj = MEMG.getNeuronByNid(targetRelon.to_s);
                    if (tObj==null) continue;
                    
                    //don't need to track this one, we already got it.
                    //this is just removing it from the tObj "ins" array.
                    tObj.removeByTXID('ins', targetRelon.txid, []); 
                }  

                r = r-1;
                continue;
            }
        }
    }


    /**
     *  Annihilate a Relon.
     * 
     *  Remove a relon from the master relon array.                      
     *  destroy it from any other associated arrays.  (from, to) etc.     
     * @param {object} - the neuron
     * @param {array} - store the nuked relons in the array for downstream DB handling.
     * @author {Mr.Scatman}  
     *
     */     
    annihilateRelon_RAM = function($targetRelon, $annihilated_txids=[]) {
        if ($targetRelon.pending_from!=undefined) return true;
        if ($targetRelon.pending_to_s!=undefined) return true;
        if ($targetRelon.pending_txid!=undefined) return true;

        //remove it from its from's outs
        var fNObj = MEMG.getNeuronByNid($targetRelon.from_nid);      
        if (fNObj!=null) fNObj.removeByTXID('outs', $targetRelon.txid, $annihilated_txids);

        //remove it from its to's ins
        var tNObj = MEMG.getNeuronByTempNid($targetRelon.t);      
        if (tNObj!=null) tNObj.removeByTXID('ins', $targetRelon.txid, $annihilated_txids);
        
        this._resetRelon($targetRelon);

        return true;
    }
    

    /**
     * 
     * @param {*} $nids 
     * @returns 
     */
    necrosisNeuronsRAM=async($nids)=>{
        for (var n=0; n < $nids.length; n++) {
            var nOBJ = MEMG.getNeuronByNid($nids[n]);
            if (nOBJ==null) continue;
            MEMP.annihilate_RAM(nOBJ);
        }
        return;
    }


    /**
     *  Parent has went bye bye.
     *  Loop all children and cleanup their in-RAM-MEM connecton to the parent.
     *
     * @author {Mr.Scatman}  
     *
     */
    deadBeatDad = function($parentNOBJ, $bGRANNYTAKESOVER=false) {
        for (var c=0; c<$parentNOBJ.children.length; c++) {
            var childNOBJ = ANNE.MEMG.getNeuronByTempNid($parentNOBJ.children[c]);
            if (childNOBJ==null) continue;
            childNOBJ.removeParentFromChild ($parentNOBJ.temp_nid, $bGRANNYTAKESOVER);
        }
    }


    /**
     *  We marked the sand.  Now we reprocess from where we marked.
     *     
     * @param {int} - the nid mark we had before we did a special local load.
     * @author {Mr.Scatman}  
     *
     */ 
    reprocessRelonsFrom=async($TEMP_NID_SAVE)=> {
        var aRelons = MEM._aRelons.slice($TEMP_NID_SAVE);
        return await MEMP.processNeuronsFromRelons(aRelons, false, false, "relons", "MEMP.reprocessRelonsFrom");
    }

    

    /**
     * Clean up run-time ptrs and indexes that may have gotten into the local DB.
     * 
     * relons stored in local browser db need to be cleaned up a bit before 
     * they are re-run through the local memory processor.  
     *  
     * @author {Mr.Scatman}                 
     */
     santizeSavedRelonsForReprocessing=async($aRelons)=> {
        var fixIts = [];
        for (var r=0; r < $aRelons.length; r++) {
            var rObj = $aRelons[r];
            delete rObj['f'];
            delete rObj['t'];
            delete rObj['r'];
            delete rObj['active'];
            delete rObj['temp'];
            delete rObj['outs'];
            delete rObj['ins'];
            if (rObj.ghost!=undefined && rObj.ghost==true ||
                rObj.ghost_owner!=undefined || rObj.ghost_order!=undefined) {
                delete rObj['ghost'];
                delete rObj['ghost_owner'];
                delete rObj['ghost_order'];
                fixIts.push(rObj);
            }
            if (rObj['gui_extras']!=undefined) delete rObj['gui_extras'];
        }

        if (fixIts.length) {
            console.log(fixIts);
            console.log("%c (santizeSavedRelonsForReprocessing) SELF FIX --- BUT WE SHOULD NEVER HAVE TO DO THIS!!!!", TALK.bgredbig);
            for (var f=0; f < fixIts.length; f++) { await DB.___update(fixIts[f]); }
        }
    }
    


    /**
     *  
     * @author {Mr.Scatman}                 
     */
    sanitizeSRFR_Ghosts=function($aRelons) {
        for (var r=0; r < $aRelons.length; r++) {
            var rObj = $aRelons[r];
            delete rObj['f'];
            delete rObj['t'];
            delete rObj['r'];
            delete rObj['active'];
            delete rObj['temp'];
            delete rObj['outs'];
            delete rObj['ins'];
        }
    }
}

var MEMP = new mem_processor();
//freeze this
