class search_obj {
    constructor($defaults) {
        if ($defaults.text!=undefined) this.text=$defaults.text;
        else this.text="";

        if ($defaults.original!=undefined) this.original=$defaults.original;
        else this.original="";

        if ($defaults.context!=undefined) this.context=$defaults.context;
        else this.context=[];

        if ($defaults.context!=undefined) this.context=$defaults.context;
        else this.context=[];

        if ($defaults.bes!=undefined) this.bes=$defaults.bes;
        else this.bes=[];

        if ($defaults.bes_tnids!=undefined) this.bes_tnids=$defaults.bes_tnids;
        else this.bes_tnids=[];

        if ($defaults.exact!=undefined) this.exact=$defaults.exact;
        else this.exact=true;

        if ($defaults.applywvtobeline!=undefined) this.applywvtobeline=$defaults.applywvtobeline;
        else this.applywvtobeline=true;

        if ($defaults.inbeline!=undefined) this.inbeline=$defaults.inbeline;
        else this.inbeline=true;

        if ($defaults.chaseIt!=undefined) this.chaseIt=$defaults.chaseIt;
        else this.chaseIt=true;

        this.req_extras = [];
        this.bEXTRAS_REQUIRED=false;
    }


    /**
     * Set a requirement of extra relons that match.
     * This will most often be an ALT BE relon specializing the standard/generic thing.
     * @param {*} $req_extras 
     * @param {*} $bREQUIRED 
     */
    setRequiredExtras=function($req_extras=[], $bREQUIRED=true) {
        this.req_extras=$req_extras;
        this.bEXTRAS_REQUIRED = $bREQUIRED;
    }


    /**
     * Some extra relon required to match..
     * most often an ALT lateral BE relon.
     * @param {*} $aMatches 
     * @returns 
     */
    filterExtras=function($aMatches) {
        if (this.req_extras.length>0) {
            var final_matches = [];
            for (var m=0; m < $aMatches.length; m++) {
                var match = $aMatches[m];
                var bHASALL=false;
                for (var e=0; e < this.req_extras.length; e++) {
                    var ex = this.req_extras[e];
                    var test_rel = ANNE.MEMG.getRelonFromWithTo(match.outs, ex.type, ex.reln, ex.to_s);
                    if (test_rel==null) {
                        bHASALL==false; //turn it off, exit
                        break;
                    }
                    bHASALL=true;   //set it on match of 1, meaning we looked
                }
                if (bHASALL==true) final_matches.push(match);
            }

            return final_matches;
        }
        return $aMatches;
    }


    /**
     * 
     * @param {*} $bDOPRE 
     * @param {*} $bACCEPTRAMONLY 
     * @returns 
     */
    search = async ($bDOPRE=false, $bACCEPTRAMONLY=true)=> {
        if ($bDOPRE==true) {
            var matches = await ANNE.SEARCH.searchNeuronText (this.text, this.bes_tnids, this.wvs, this.exact, this.applywvtobeline, this.inbeline); 
            if (this.chaseIt==false) {
                if (matches.length>0) {
                    if (this.bEXTRAS_REQUIRED==true) return this.filterExtras(matches);
                    else return matches;
                }
                return [];
            }
            if ($bACCEPTRAMONLY==true && matches.length>0) {
                if (this.bEXTRAS_REQUIRED==true) return this.filterExtras(matches);
                else return matches;
            }
        }
        if (this.chaseIt==true) {
            var done = await ANNE.API.queryForText (this.text, this.wv, this.bes, this.exact, this.applywvtobeline, this.inbeline);
            console.log(done);
        }

        var matches = await ANNE.SEARCH.searchNeuronText (this.text, this.bes_tnids, this.wvs, this.exact, this.applywvtobeline, this.inbeline);   
        if (this.bEXTRAS_REQUIRED==true) return this.filterExtras(matches);
        else return matches;
    }
}


class mem_search {
    constructor() {
        this.SS = null;
    }

    init=function($SS) { this.SS = $SS; }

    //ANNE.SEARCH.parseSearchForContext("tom cruise[person]")
    //ANNE.SEARCH.parseSearchForContext("red[movie]")
    //ANNE.SEARCH.parseSearchForContext("bank[action, flight]")
    parseSearchForContext = function($str) {
        var find = 0;
        var i_left = -1;
        i_left = $str.indexOf("(");
        if (i_left!==-1) find=")";
        else {
            i_left = $str.indexOf("[");
            if(i_left!=-1) find="]";
            else {
                i_left = $str.indexOf("{")
                if (i_left!=-1) find="}";
            }
        }

        if (find!="") {
            var i_right = $str.indexOf(find);
            if (i_right!=-1) {
                var extract = $str.substring(i_left+1, i_right).trim();
                if (ANNE.SETTINGS.debug()==true) console.log(extract);
                var str = $str.substring(0, i_left).trim()+$str.substring(i_right+1).trim();
                var rez= {search:str, inline_context:extract.split(",")};
                return rez;
            }
        }

        return {search:$str, inline_context:[]};
    }


    /**
     * Get the last n_items of the class and order by most recent.
     */
    getRecents=function($nids, $maxFireWeight=0.01, $max_results=200) {
        var downlineNOBJS = [];

        //recent INSTS (only)
        var bDOINSTS = true;
        var bTNIDLIST = false;
        var bDOALLBES = false;
        var bINSTSONLY = true;

        for (var n=0; n < $nids.length; n++) {
            var nOBJ = MEMG.getNeuronByNid($nids[n], $maxFireWeight);
            if (ANNE.SETTINGS.debug()==true) {
                console.log("get recents for "+nOBJ.text);
                console.log("children test:"+nOBJ.children.length);
            }

            nOBJ.getAllDownlineChildren(downlineNOBJS, 0, bDOINSTS, bTNIDLIST, bDOALLBES, bINSTSONLY);
        }
        downlineNOBJS.sort(UTILS.sortByBeTime);
        return downlineNOBJS.slice(0, Math.min(downlineNOBJS.length, $max_results));
    }



    /**
     * Search the text, case-insensitive, of all neurons in local memory. 
     * Returns neurons   
     *    
     * Rethink this for our new indexes.
     * Our .text comes in on relons but is not stored in the local DB.
     * We need to search neuron memmory for text.
     * 
     * @author {Mr.Scatman}
     */
    personSearch = function($textString, $bEXACT=true) {
        if (ANNE.SETTINGS.debug()==true) console.log($textString);
        if ($textString==undefined || $textString=="" || $textString==null) {
            console.log("fix this");
            return [];
        }
        var aMatches = [];
        var aMatchesNids = [];
        $textString=$textString+"";
        var lower = $textString.toLowerCase();

        var parts = lower.split(" ");//use cap
        var first = parts[0];
        
        for (var n=0; n < MEM._aNeurons.length; n++) {
            var nObj = MEM._aNeurons[n];
            
            if (nObj.bes[0]!=MEM.person.temp_nid) continue;
            if (nObj.owned_by!=MEM.ANNE_ACCTID && nObj.owned_by!=USER._userNObj.nid) continue;
            

            if ($bEXACT==false) {
                nObj.fire = UTILS.similarity($textString, nObj.text, 1000);
                if (nObj.fire < .8 && nObj.aka!=undefined && nObj.aka.length>0) {
                    for (var a=0; a < nObj.aka.length; a++) {
                        var fi = UTILS.similarity($textString, nObj.aka[a], 1000);
                        if (fi > nObj.fire) {
                            nObj.fire = fi;
                        }
                    }
                }

                //if we the target string is contained with this potential string, 
                //let's bump it up more.  (don't bother if already above .8)
                if (nObj.fire>=.8) {
                    aMatches.push(nObj)
                    aMatchesNids.push(nObj.temp_nid);
                }
                else if (nObj.fire>=.4) {
                    if (nObj.text.toLowerCase().indexOf(lower)!=-1) {
                        nObj.fire = Math.min(1, nObj.fire+(nObj.text.length*.05));
                    }
                    nObj.fire = nObj.fire - ((1-nObj.fire)*(1-nObj.fire)/2);
                    if (nObj.fire<=.4) continue;
                    nObj.fire = Math.round(nObj.fire*100)/100;
                    if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                    aMatchesNids.push(nObj.temp_nid);
                    aMatches.push(nObj);
                } 
            }

            
            else {
                if (nObj.text.toLowerCase() == lower) {
                    if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                    aMatchesNids.push(nObj.temp_nid);
                    aMatches.push(nObj);
                }

                //if the first name is right...
                else if (this.lower.indexOf(first)==0) {

                    //check the aka_lower array.
                    if (nObj.aka_lower && nObj.aka_lower.indexOf(lower)!=-1) {
                        if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                        aMatchesNids.push(nObj.temp_nid);
                        aMatches.push(nObj);
                    }         
                }
            }
        }

        return aMatches; 
    }



    /**
     * 
     * @param {*} $text 
     * @returns 
     */
    textSearchNaked = async($text)=> {
        return await ANNE.MEM.searchTextIndex($text);
    }


    searchNeuronTextSO = async($so)=>{
        return await this.searchNeuronText($so.text, $so.bes, $so.wv, $so.exact, $so.applywvtobeline);
    }

    /**
     * Search the text, case-insensitive, of all neurons in local memory. 
     * Returns neurons   
     *    
     * Rethink this for our new indexes.
     * Our .text comes in on relons but is not stored in the local DB.
     * We need to search neuron memmory for text.
     * 
     * @author {Mr.Scatman}
     */
    searchNeuronText = async($textString, $beTnids=[], $WVs=[], $bEXACT=false, $bAPPLYWVTOBELINEMATCH=false)=> {
        if (ANNE.SETTINGS.debug()==true) console.log($textString);
        if ($textString==undefined || $textString=="" || $textString==null) {
            return [];
        }
        
        if ($WVs.indexOf(USER._userNObj.nid)==-1) $WVs.push(USER._userNObj.nid);
        
        //test search.
        await ANNE.IDB.queryForText($textString, null, $bEXACT);

        var aMatches = [];
        var aMatchesNids = [];
        $textString=$textString+"";
        var lower = $textString.toLowerCase();

        for (var n=0; n < MEM._aNeurons.length; n++) {
            var nObj = MEM._aNeurons[n];

            //this is to restrictive and not considerate of BEMS.
            if ($beTnids.length && $beTnids.indexOf(nObj.bes[0])==-1) continue;
            
            if ($WVs.length && nObj.owned_by!="") {
                if ($bAPPLYWVTOBELINEMATCH==false && $WVs.indexOf(nObj.owned_by)==-1) continue;
                else if ($bAPPLYWVTOBELINEMATCH==true) {
                    var beNOBJ = MEMG.getNeuronByTempNid(nObj.bes[0]);
                    if (beNOBJ==null) continue;
                    if($WVs.indexOf(beNOBJ.owned_by)==-1) continue;
                }
            }


            //var test = false;
            if ($bEXACT==false) {

                //if char is set, it must match, exactly.
                if (nObj.char!=undefined) {
                    if ($textString.length==1) {
                        nObj.fire = UTILS.similarity($textString, nObj.text, 1000);
                    }
                    else continue;
                }
                else nObj.fire = UTILS.similarity($textString, nObj.text, 1000);
                
                if (nObj.fire < .8 && nObj.aka!=undefined && nObj.aka.length>0) {
                    for (var a=0; a < nObj.aka.length; a++) {
                        var fi = UTILS.similarity($textString, nObj.aka[a], 1000);
                        if (fi > nObj.fire) {
                            nObj.fire = fi;
                        }
                    }
                }

                //if we the target string is contained with this potential string, 
                //let's bump it up more.  (don't bother if already above .8)
                
                if (nObj.fire>=.8) {
                    aMatches.push(nObj)
                    aMatchesNids.push(nObj.temp_nid);
                }
                else if (nObj.fire>=.4) {
                    if (nObj.text.toLowerCase().indexOf(lower)!=-1) {
                        nObj.fire = Math.min(1, nObj.fire+(nObj.text.length*.05));
                    }
                    if(nObj.text.length>lower.length) {
                        if (nObj.text.toLowerCase().indexOf(lower)==0) {
                            if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                            aMatchesNids.push(nObj.temp_nid);
                            aMatches.push(nObj);
                        }
                    }
                    nObj.fire = nObj.fire - ((1-nObj.fire)*(1-nObj.fire)/2);
                    if (nObj.fire<=.4) continue;
                    nObj.fire = Math.round(nObj.fire*100)/100;
                    if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                    aMatchesNids.push(nObj.temp_nid);
                    aMatches.push(nObj);
                }
                else if (nObj.fire>.25 && nObj.text.length>lower.length && nObj.text.toLowerCase().indexOf(lower)==0) {
                    if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                    aMatchesNids.push(nObj.temp_nid);
                    aMatches.push(nObj);
                }
                
            }
            else if (nObj.text.toLowerCase() == lower) {
                if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                aMatchesNids.push(nObj.temp_nid);
                aMatches.push(nObj);
            }
            else if (nObj.char!=undefined && $textString.length==1 && $textString==nObj.char) {
                if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                aMatchesNids.push(nObj.temp_nid);
                aMatches.push(nObj);
            }
            else {
                //check the aka_lower array.
                if (nObj.aka_lower && nObj.aka_lower.indexOf(lower)!=-1) {
                    if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                    aMatchesNids.push(nObj.temp_nid);
                    aMatches.push(nObj);
                }         
            }
        }

        //look for exact TYPE_BE relons to non-neuron TO_TYPE_STRINGs.
        //this will get primary keys, aliases, and any other text string short hands.
        //we *SHOULD* make an effort to make a keyword neuron anytime a TYPE_BE
        //relon to a TO_TYPE_STRING is put into the ANNE worldview (on the annode)
        for (var r=0; r < MEM._aRelons.length; r++) {
            if (MEM._aRelons[r].to_type!=TO_TYPE_STRING) continue;
            if (MEM._aRelons[r].type!=TYPE_BE && MEM._aRelons[r].type!=TYPE_HAS) continue;
            if (MEM._aRelons[r].r==MEM.name.temp_nid) continue; //we already checked names
            if (MEM._aRelons[r].to_s.toLowerCase()==lower) {
                var nObj = MEMG.getNeuronByTempNid(MEM._aRelons[r].f);
                if (nObj==null) continue;

                //if this is a char it must be exact.  X != x.
                if (nObj.char!=undefined && nObj.char!=$textString) continue;
                
                if (aMatchesNids.indexOf(nObj.temp_nid)!=-1) continue;
                aMatchesNids.push(nObj.temp_nid);
                aMatches.push(nObj);
            }
        }

        return aMatches; 
    }



    /**
     * Search the text, case-insensitive, of all neurons in local memory. 
     * This is for an ajax like text entry search.  We must match the start of the word to get a partial match.
     * Returns neurons 
     * 
     * @author {Mr.Scatman} 
     */
    searchTextStart = function($textString, $typesToEnforce=[], $beNid=-1, $WVs=[]) {
        var aMatches=[];
        var beNOBJ = null;
        
        $textString = $textString.toLowerCase();

        if ($beNid>=0) beNOBJ = MEMG.getNeuronByTempNid($beNid);

        for (var n=0; n < MEM._aNeurons.length; n++) {
            var nObj = MEM._aNeurons[n];

            //if must match type, enforce first. (faster)
            if ($typesToEnforce.length && $typesToEnforce.indexOf(nObj.ntype)==-1) continue;
        
            if (nObj.text=="") continue;

            var text = nObj.text.toLowerCase();
            
            if (text.indexOf($textString)!=0) continue;  //only looking for matches to the start of a word here.
            
            //be class enforced  (note, this should be decendents, not just be)
            if (beNOBJ!=null && nObj.bes.indexOf(beNOBJ.temp_nid)==-1) continue;

            if ($WVs.length && $WVs.indexOf(nObj.owned_by)==-1) continue;
            aMatches.push(nObj);

            nObj.fire = UTILS.similarity($textString, nObj.text, 1000);
        }
        return aMatches; 
    }


    /**
     * Search the text, case-insensitive, of all neurons in local memory. 
     * Returns neurons 
     * 
     * @author {Mr.Scatman} 
     */
    searchText = function($textString, $typesToEnforce=[], $bEXACT=false, 
                                $bDOAKAS=true, $beNid=-1, $emulatedOk=false, $bDOWEIGHT=true, $WVs=[]) {
        var regex = new RegExp($textString, 'i');
        var aMatches=[];
        var beNOBJ = null;

        if ($beNid>=0) beNOBJ = MEMG.getNeuronByTempNid($beNid);

        for (var n=0; n < MEM._aNeurons.length; n++) {
            var nObj = MEM._aNeurons[n];
            
            //if must match type, enforce first. (faster)
            if ($typesToEnforce.length && $typesToEnforce.indexOf(nObj.ntype)==-1) continue;
            
            //watch this.. we may want emulated in some searches..
            if ($emulatedOk==false && nObj.emulated == true) continue;

            var text = nObj.text;
            if (nObj.text=="") continue;

            //match the text
            var test = false;
            if ($bEXACT==false) test = regex.test(text);
            else if (nObj.text == $textString) test = true; 
            
            if (test == false) {

                //quick aka check.
                if ($bDOAKAS==true && nObj.aka.indexOf(text)!=-1) {
                    if (beNOBJ!=null && nObj.bes.indexOf(beNOBJ.temp_nid)==-1) continue;
                    if ($WVs.length && $WVs.indexOf(nObj.owned_by)==-1) continue;
                    if ($bDOWEIGHT==true) nObj.fire = nObj.fire-1;
                    aMatches.push(nObj);
                    continue;
                }	

                continue;
            }

            //be class enforced  (note, this should be decendents, not just be)
            if (beNOBJ!=null && nObj.bes.indexOf(beNOBJ.temp_nid)==-1) continue;

            if ($WVs.length && $WVs.indexOf(nObj.owned_by)==-1) continue;
            aMatches.push(nObj);
            if ($bDOWEIGHT==true) {
                nObj.fire = UTILS.similarity($textString, nObj.text, 1000);
            }
        }
        return aMatches; 
    }

}

var SEARCH = new mem_search();