/* 
MEM_UDF space is for site-specific neuron pre-loads and local DB pre-processing. 
THIS FILE MUST BE LOADED AFTER the main memory handler!!!!!

REMEMBER:  functions named _udf_XXXX are referenced external to this class 
and are pointed to by in-ANNE interface functions.  They can be changed to do 
as you please or left as default.
*/
class mem_udf {
    constructor() {
        this.appName="DOSINTAPP";
        this.THIS_APP = null;
        this._collab_hlc = 0;
        this._bDOSMARTLINKUPDATES = true;
        this._bWORLDVIEWBIPASS = false;
        this._lookupPreloadedOuts = true;   //should we spend a lookup chasing the outs of a preloaded neuron?
        this._lookupPreloadedIns = true;    //should we spend a lookup chasing the ins of a preloaded neuron?
        this._ghost_rels = [];
        this._bONETIMEINIT=false;
        this.aSettingsToProcess = [];
        this.bGETDEDSATBOOTUP = false;
        this._collab_relons = [];
		this._basic_demographic_nids = [
			"7771124117310918099", "777925711019642749", "7770927790880535113", 
            "7777627441463363769", "7770855606276797271", "7770982642614293125",
            "7772878965553112082", "7775045073476665086"
    	];
        this.bANUMON=true;
    }


    /**
     * @author {Mr.Scatman} 
     */
    init = async()=> {

        //a list of valid identity classes (this app accepts) when a new user is created.
        this.valid_persona_tnids = [MEM.application_identity.temp_nid, 
                            MEM.corporation_identity.temp_nid, 
                            MEM.individual_identity.temp_nid,
                            MEM.miner_identity.temp_nid,
                            MEM.annode_identity.temp_nid,
                            MEM.oracle_identity.temp_nid];

        var ANNENOBJ = MEMG.getNeuronByNid(MEM.ANNE_ACCTID);
        
        MEM.addToAppWideActiveWorldViews(ANNENOBJ.temp_nid);    
        
        //for collab/ghosts/ and  prefs not stored on the ANNODE.
        if (typeof DB_local != "undefined") {
            ANNE.DB_local = DB_local;
            if (!('indexedDB' in window)) {
                console.log('This browser does not support IndexedDB');
                ANNE.DB_local.bSUPPORTED=false;
                ANNE.DB_local=null;
            }
            else {	
                ANNE.DB_local.bSUPPORTED=true;
                return await ANNE.DB_local.___init(MEM_UDF._finisheAppDBPreInit); 
            }
        }
        else ANNE.DB_local=null;
        ANNE.DOSINT = DOSINT;
        return;
    }

    resetUser = async()=> {}

    /**
     * Here u get whatever u store in your app-specific DB and u process it. 
     * This could be app settings for gui or any persistent data you chose  
     * to store for the user locally for whatever reason.                   
     *                                                                       
     * The aPullHistory is available for you to use to optimize any non-ANNE 
     * local app queries of non-ANNE calls to your data providers.
     * 
     * @author {Mr.Scatman} 
     */ 
    _finisheAppDBPreInit=async($aPullHistory, $cb=null)=> {
        console.log("%c (_finisheAppDBPreInit)", TALK.bgredbig);
        return;
    }


   /**
     * Optional implementation. 
     * @author {Mr.Scatman} 
     */
    udf_handleWindowResize = async()=> {
        alert("udf_handleWindowResize");
        await NF.cheapEvents({event:"RESIZE_WINDOW", data:null});
    }


    bootup_complete = async()=> {
        console.log("bootup complete");
    }

    init3js = function() {
        ANNE.DOSINT.init(this.show3js);
    }
    
    show3js =function($bPLAY=true) {
        ANNE.DOSINT.b3JSACTIVE=true;
        var cssel = ANNE.A.show("csscontainer");
        cssel.style.pointerEvents="all";
        var tjsel = ANNE.A.show("container");
        tjsel.style.pointerEvents="all";
        ANNE.A.show("left_holder");
        if ($bPLAY==true) ANNE.A.play("breezIntro");
    }

    hide3js = function() {
        ANNE.DOSINT.b3JSACTIVE=false;
        var cssel = ANNE.A.hide("csscontainer");
        cssel.style.pointerEvents="none";
        var tjsel = ANNE.A.hide("container");
        tjsel.style.pointerEvents="none";
        ANNE.A.hide("super_footers");
        ANNE.A.hide("left_holder2");
        ANNE.A.hide("right_holder");
    }


    //NOT DOING RELON AND NEURON VIEWERS IN THIS APP, FOR NOW.
    //can do a quick popup form or something later...
    //aarr blah
    makeRelonViewLink_SMART=function($el, $relon, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="", $txtoverride="") {
        return $el.innerHTML="<span>"+$relon.txid+"</span>";
    }

    makeRelonViewLink=function($el, $txid, $bEMPTY=true, $h=12, $imgOnly=false, $relonClass="", $txtoverride="") {
        return $el.innerHTML="<span>"+$txid+"</span>";
    }

    makeNeuronLink=function($el, $nid, $class="", $pre="", $bADDCOPY=false, $txtoverride="", $page="dossier", $classpre="") {
        return $el.innerHTML=$nid;
    }

    sendFeelzQueue = async($refreshCallbackTemp=null, $mustRunPreTestFunction=null, $cancelSendCB=null, $failedCB=null)=>{
        ANNE.A.hide("fzWidgetOverlayOutter_anx");
        var el_fzWidgetOverlay = document.getElementById("fzWidgetOverlay_anx");
        ANNE.A.emptySelfAfterChild(el_fzWidgetOverlay, 0);
        return await this.sendQueue($refreshCallbackTemp, $mustRunPreTestFunction, $cancelSendCB, $failedCB);
    }


    /**
     * Generalized send for any sends that don't have their own process
     * (like annex, boosties etc)
     * 
     * Remember, we are not using the PAGES mod in this app.  Moving away from that behemoth.
     * 
     * @param {*} $refreshCallbackTemp 
     * @param {*} $mustRunPreTestFunction 
     * @param {*} $cancelSendCB 
     * @param {*} $failedCB 
     */
    sendQueue = async($refreshCallbackTemp=null, $mustRunPreTestFunction=null, $cancelSendCB=null, $failedCB=null)=>{
        SENDQ.__refreshCallbackTemp = $refreshCallbackTemp;
        SENDQ.__mustRunPreTestFunction = $mustRunPreTestFunction;

        ANNE.MEM_UDF.hide3js();

        await ANNE.MEM_UDF.loadSolo("sender.html", "injected_div", "");
        
        SENDQ.___genQgui();

        //cancel/success callbacks.
        var pObj = {};
        var pgui = {pObj:pObj};
        
        if ( $cancelSendCB!=null) pObj.c_cbk=$cancelSendCB; 
        else pObj.c_cbk=function(){
            ANNE.A.emptySelf("injected_div");
            ANNE.A.hide("injected_div");
            ANNE.MEM_UDF.show3js(false);
        }

        if ($failedCB!=null) pObj.f_cb=$failedCB;
        else pObj.f_cb=function() {
            console.log("something went wrong");
            ANNE.A.emptySelf("injected_div");
            ANNE.A.hide("injected_div");
            ANNE.MEM_UDF.show3js(false);
        }

        pObj.s_cbk=function($obj=null){
            if ($obj) console.log($obj);
            console.log("called on success only.");
            ANNE.A.emptySelf("injected_div");
            ANNE.A.hide("injected_div");
            ANNE.MEM_UDF.show3js(false);
            ANNE.DOSINT.updateAwarvu($obj);
        }

        ANNE.SENDER.init(pgui);
    }


    /**
     * We optimize now with limited loads from IndexedDB into RAM.
     * We already optmize with our queries againts the ANNODE with the history tracker / block filter for searches.
     * This gets our basic user info in RAM for our basic profie view.  When we need more we will get it.
     * @returns 
     */
	getMyStuffBasic=async()=> {
		console.time("getMyStuffBasic");
        var nid = ANNE.USER._userNObj.nid;
		var aRelonsToProcess = await DB.loadAll("relons");
		var aRelons = [];
		for (var r=0; r < aRelonsToProcess.length; r++) {
			if (aRelonsToProcess[r].from_nid!=nid) continue;
            if (aRelonsToProcess[r].type==TYPE_SYS_MSG) continue;     //not interested in these right now.
            if (aRelonsToProcess[r].type==TYPE_AWARENESS) continue;   //not interested in these right now.
            aRelons.push(aRelonsToProcess[r]);
		}

		//not a save, just a load
		if (aRelons.length) {
			await MEMP.processNeuronsFromRelons(aRelons, true, false, "relons", "getMyStuffBasic");
		}
		console.timeEnd("getMyStuffBasic");
		return aRelons;
	}


    /**
     */ 
    getMyFeelzFor=function($target_id, $to_type, $bGHOSTSONLY=false) {
        var matches = [];
        for (var u=0; u < USER._userNObj.outs.length; u++) {
            var rel = USER._userNObj.outs[u];
            if (rel.type!=TYPE_AWARENESS) continue;
            if ($bGHOSTSONLY==true && rel.ghost==false) continue;
            if (rel.to_s==$target_id && rel.to_type==$to_type) matches.push(rel);
        }
        return matches;
    }
    

    /**
     */
    unlocked_pre = async($bSWAPUSERBIPASS=false, $fromwhat="")=> {
        ANNE.A.show("login_loader");
        ANNE.A.hide("main_logo");
        ANNE.A.emptySelf("injected_div", true); 

        this.init3js();

        //we can proces ghosts/TXs tbls per anneid. 
        //rememeber, logged in is not a traditional login.
        //it just means an anneid is in browser mem.
        //to actually use it the user will need the pw that unlocks the seed/key
        await ANNE.GHOSTDATA.processGhosts();

        //load our basic data so we have it in RAM.
        //we will do a bigger load of RAM if we need our data (ANNEfolio).
        await ANNE.MEM_UDF.getMyStuffBasic();

        //some cheat relon pts we stored that must be deleted in RAM.
        //they will be reset for the potential new user.
        for (var r=0; r < MEM._aRelons.length; r++) {
            delete MEM._aRelons[r].hanai_rights;
            delete MEM._aRelons[r].andy_rel;
            delete MEM._aRelons[r].isAndyRel;
        }
        for (var n=0; n < MEM._aNeurons.length; n++) {
            MEM._aNeurons[n]._govenor = null;
        }

        if (ANNE.GUI_STUFF!=null && this.aSettingsToProcess!=null) {
            await ANNE.SETTINGS.setSettings(this.aSettingsToProcess);
        }

        ANNE.A.hide("login_loader");
        ANNE.A.show("main_logo");
    }


    /**
     * 
     */
    __login_check = async()=> {
        //these are all in the login solo. (they come together)
        if (ANNE.LOGIN_SOLO!=null) {

            //load the html..
            await this.loadSolo("solo_login.html", "injected_div", "sl_123");

            //activate the right area.
            USER.__loginCheck(e=>{
                console.log("alreadyLoggedIn");
                ANNE.A.hide("loading");
                ANNE.A.hide("solo_login");
                ANNE.A.show("unlock_box");
                ANNE.UNLOCK.init();
                ANNE.DOSINT.preload();
            }, async(e)=>{
                ANNE.A.hide("loading");
                ANNE.A.hide("unlock_box");
                ANNE.A.show("solo_login");
                ANNE.LOGIN_SOLO.init();
                ANNE.DOSINT.preload();
            });				
        }
    }


    /**
     * Tack on this function the A object.
     * @param {*} $partName 
     * @param {*} $loadIntoEl 
     * @param {*} $guiID 
     * @returns 
     */
    loadSolo=async($partName, $loadIntoEl, $guiID)=> {    
        var xhr;
        if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
        else xhr = new ActiveXObject("Microsoft.XMLHTTP");
        return new Promise((resolve, reject) => {
            xhr.onreadystatechange = function () {
                if (this.readyState == 4 && this.status == 200) {
                    var resp = this.response;
                    var loadIntoel = ANNE.A.__getEl($loadIntoEl);
                    loadIntoel.innerHTML=resp;
                    var items = loadIntoel.querySelectorAll('.dynamic');
                    for (var i = 0; i < items.length; i++) {
                        var item = items[i];
                        if (item.id != null && item.id != "") {
                            item.id = item.id + "_" + $guiID;
                        }
                        var forattr = item.getAttribute("for");
                        if (forattr != null) item.setAttribute("for", forattr + "_" +$guiID);
                        var nameattr = item.getAttribute("name");
                        if (nameattr != null) item.setAttribute("name", nameattr + "_" + $guiID);
                    }
                    ANNE.A.show(loadIntoel);
                    return resolve(loadIntoel);
                }
            };
            xhr.open("GET", "./solo_parts/"+$partName + "?v=" + Math.random() * 10, true);
            xhr.responseType = "";
            xhr.send();
        });
    }


    /**
     * 
     * NOTE: NO COLLAB BROADCAST AS OF NOW FROM SOLO (ANNEX) APP
     * PUTTING THIS IN THO FOR LATER SUPPORT.
     * 
     * We broadcast a new collab and/or hanai relon.
     * Loosely add it in to our RAM array here.
     * 
     * For auto-hanai/collab this will be updated with status_txid whenever
     * the relon is mined and repulled.
     * 
     */
    addCollabFromBroadcast=function($newBroadcastRelon, $collab_type) {
        for (var c=0; c < MEM_UDF._collab_relons.length; c++) {
            if (MEM_UDF._collab_relons[c].txid==$newBroadcastRelon.txid) {
                console.warn("IS THIS EVER RELEVANT?? , SEEMS LIKE IT SHOULDN'T BE");
                return;
            }
        }
        $newBroadcastRelon.isAndyRel = true;
        $newBroadcastRelon.relon_sponsor = USER._userNObj.nid;
        $newBroadcastRelon.status_text = "p";
        $newBroadcastRelon.status_txid = null;
        if ($collab_type==CTYPE_COLLAB_ONLY) {
            if ($newBroadcastRelon.r==MEM.CMD_MERGE_NEURON.temp_nid) {
                $collab_type = CTYPE_MERGE_REQUEST;
            }
        }
        $newBroadcastRelon.collab_type = $collab_type;
        MEM_UDF._collab_relons.push($newBroadcastRelon);

        if ($newBroadcastRelon.old_txid==undefined) return;

        //remove old txid from collab_relons array.  
        //(we just added the new updated one)
        //we will later remove it from ghost db mem by txid.
        var old_txid = $newBroadcastRelon.old_txid;
        for (var c=0; c < MEM_UDF._collab_relons.length; c++) {
            var rel =  MEM_UDF._collab_relons[c];
            if (rel.txid==old_txid) {
                MEM_UDF._collab_relons.splice(c, 1);
                console.warn("DELETED OLD COLLAB RELON AND REPLACED WITH NEW.")
                return;
            }
        }
    }
    
}


var MEM_UDF = new mem_udf();