
var ANNE = {NET:null, SIGNA:null, A:null, MEM_UDF:null, UTILS:null, DB_blocks:null};
ANNE.SIGNA = {sig:null};
if (typeof sig$ != "undefined") ANNE.SIGNA.sig = sig$;
if (typeof sig$crypto != "undefined") ANNE.SIGNA.crypto = sig$crypto;
if (typeof sig$http != "undefined") ANNE.SIGNA.http = sig$http;
if (typeof sig$util != "undefined") ANNE.SIGNA.util = sig$util;
if (typeof A != "undefined") ANNE.A = A;
if (typeof UTILS != "undefined") ANNE.UTILS = UTILS;
if (typeof TALK != "undefined") ANNE.TALK = TALK;


var _mempool = null;
var _LAST_MEMPOOL_CNT = 0;
const REFRESH_RATE_MS = 30000;
const MAX_MEMPOOL =  16384;

var _tbl_cols = null;
var __tableObj = null;

document.addEventListener("DOMContentLoaded", async (event) => {
    console.log("dom loaded");
    const port = window.location.port;
    console.log(port);
    ANNE.NET = new ANNE_NET(window.origin);

    initMemmpool();
});


var getTX = function($txid) {
    for (var t=0; t < _TXS.length; t++) {
        if (_TXS[t].id==$txid) return _TXS[t];
    }
    return null;
}


var initMemmpool = async()=>{
    
    //popup -- click and it goes away.
    var el_mp_details = document.getElementById("mp_details");
    el_mp_details.addEventListener("click", e=>{
        var el_pd = ANNE.A.hide("mp_details");
        el_pd.style.pointerEvents="none";
    });

    doGUI();

    //refresh every 30 seconds.
    setInterval(doGUI, REFRESH_RATE_MS);
}


/**
 * 
 * @returns 
 */
var doGUI=async()=> {
    ANNE.A.empty("mempool");
    var mpool = await ANNE.NET.query("getMempool", {mempoolcnt:_LAST_MEMPOOL_CNT});
    var txs = mpool.unconfirmedTransactions;
    
    _mempool = [];
    
    if (txs==undefined || txs==null) txs = [];

    for(var t=0; t < txs.length; t++) {
        var tx = {};
        var obj = txs[t];
        tx.amountNQT = obj.amountNQT;
        tx.sender = obj.sender;
        if (obj.attachment!=null) {
            var att = obj.attachment;
            if (att.type!=undefined) tx.rel_type = att.type;
            if (att.from!=undefined) tx.rel_from = att.from;
            else tx.rel_from = obj.sender;
            if (att.reln!=undefined) tx.rel_reln = att.reln;
            if (att.to_type!=undefined) tx.rel_to_type = att.to_type;
            if (att.to!=undefined) tx.rel_to_s = att.to;
        }
        tx.ecBlockHeight = obj.ecBlockHeight;
        tx.ecBlockId = obj.ecBlockId;
        tx.tx_subtype = obj.subtype;
        tx.tx_type = obj.type;
        _mempool.push(tx);
    }
    
    console.log(_mempool);
    _LAST_MEMPOOL_CNT = _mempool.length;

    //mempool header bar.
    var el_mpm = document.getElementById("mempool_meta");
    ANNE.A.empty(el_mpm);
    var filled = _mempool.length;
    var remaining = Math.max(0, MAX_MEMPOOL - filled);
    var filledPer = 0;
    var remainingPer = 100;
    if (filled>0) {
        filledPer=filled*85/MAX_MEMPOOL;
    }
    else filledPer = 0;
    if (remaining>0) {
        remainingPer = remaining*85/MAX_MEMPOOL;
    }
    else remainingPer = 0;

    var el_mpbar = document.createElement("div");
    el_mpbar.classList = "mempoolbar";
    el_mpm.appendChild(el_mpbar);
    
    var el_mpname = document.createElement("div");
    el_mpname.classList = "mepool-title";
    el_mpname.innerHTML = "MEMPOOL "+filled+"/"+remaining;
    ANNE.A.setHTML("page_title", "MEMPOOL "+filled+"/"+remaining);
    el_mpname.style="width:15%";
    el_mpbar.append(el_mpname);

    //easy access for later updating with new data.
    var el_filled = document.createElement("span");
    el_filled.classList="filled-green";
    el_filled.style="width:"+filledPer+"%";
    el_mpbar.append(el_filled);

    var el_remaining = document.createElement("span");
    el_remaining.classList="filled-black";
    el_remaining.style="width:"+remainingPer+"%";
    el_mpbar.append(el_remaining);
}



/**
 * 
 * @param {*} $mp 
 */
var loadTXDetail = function($mp) {
    /** 
    var el_mode = ANNE.A.setHTML("annode_mode", $mp.annode_mode);
    if ($mp.annode_mode=="LIVE") {
        el_mode.classList = "bg-green";
    }
    else el_mode.classList = "bg-red";

    var el_is = ANNE.A.setHTML("inbound_state", $mp.inbound_state);
    if ($mp.inbound_state=="CONNECTED") {
        el_is.classList = "bg-green";
    }
    else el_is.classList = "bg-red";

    var el_os = ANNE.A.setHTML("outbound_state", $mp.outbound_state);
    if ($mp.outbound_state=="CONNECTED") {
        el_os.classList = "bg-green";
    }
    else el_os.classList = "bg-red";
    

    var el_bh = ANNE.A.setHTML("blockchainHeight", $mp.blockchainHeight);
    if ($mp.blockchainHeight==_ramvars.height) {
        el_bh.classList = "bg-green";
    }
    else el_bh.classList = "bg-red";

    var el_cbh = ANNE.A.setHTML("commonBlockHeight", $mp.commonBlockHeight);
    if ($mp.blockchainHeight==_ramvars.commonBlockHeight) {
        el_cbh.classList = "bg-green";
    }
    else el_cbh.classList = "bg-red";
    
    var el_common = ANNE.A.setHTML("commonBlockId", $mp.commonBlockId);
    if ($mp.blockchainHeight==_ramvars.commonBlockHeight) {
        el_common.classList = "bg-green";
    }
    else el_common.classList = "bg-red";

    var el_diff = ANNE.A.setHTML("blockDiff", $mp.blockDiff);
    if ($mp.blockDiff>0) {
        el_diff.classList = "bg-green";
    }
    else el_diff.classList = "bg-red";

    ANNE.A.setHTML("last_block_timestamp", $mp.last_block_timestamp);
    ANNE.A.setHTML("secs_since_lastblock", UTILS.secsElapsedToDHMS($mp.secs_since_lastblock));

    var el_blacklisted = ANNE.A.setHTML("blacklisted", $mp.blacklisted);
    if ($mp.blacklisted==false) {
        el_blacklisted.classList = "bg-green";
    }
    else el_blacklisted.classList = "bg-red";

    var el_errors = ANNE.A.setHTML("errors", $mp.errors);
    if ($mp.errors==0) {
        el_errors.classList = "bg-green";
    }
    else if ($mp.errors<3) {
        el_errors.classList = "bg-yellow";
    }
    else el_errors.classList = "bg-red";

    ANNE.A.setHTML("version", $mp.versions);
    */
}


/**
 * 
 */
var buildMEMPOOLTBL = function() {
    var el_mempool = document.getElementById("mempool");
    _tbl_cols = [
        {   neuron_link:false,
            relon_link:false,
            title:"txid",
            prop:"txid",
            class1:"txid",
            classH:"header-col txid-H",
            s_prop:"txid",
            s_type:"numeric",
            default_sort:"desc"
        },
        {   
            neuron_link:false,
            relon_link:false,
            title:"sender",
            prop:"sender",
            class1:"txid",
            classH:"header-col sender-H",
            s_prop:"sender",
            s_type:"numeric",
            default_sort:"desc"
        },
        {   neuron_link:false,
            relon_link:false,
            title:"txtype",
            prop:"type",
            class1:"txtype",
            classH:"header-col txtype-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"subtype",
            prop:"subtype",
            class1:"subtype",
            classH:"header-col subtype-H",
        }
    ];
    
    var bb = el_mempool.getBoundingClientRect();
    var estimatedTableBodyTop = bb.top;
    __tableObj = new neuron_table(null);
    __tableObj.setManualCols(_tbl_cols, _mempool);
    __tableObj.buildDOMTable(el_mempool, estimatedTableBodyTop, null, true, true, 17.5);   
}