
class wdata {
    constructor($lookupval="", $wikipart="") {
        this.lookupval = $lookupval;
        this.wikipart = $wikipart;
        this.context = null;
        this.context2 = null;
        this.fka = null;
        this.to_s = "";
        this.extras = [];
    }
    addExtra = function($type, $reln, $to_type, $to_s) {
        this.extras.push({type:$type, reln:$reln, to_type:$to_type, to_s:$to_s});
    }
}

class wdata_drange extends wdata{
    constructor($lookupval) {
        super($lookupval, "");
        this.start=null;
        this.end=null;
        this.adr = null;
        this.start_nid=null;
        this.end_nid=null;
    }
    doContext=async($context)=> {
        this.adr = new anne_date_range();
        await this.adr.parseFromString($context, true);
        if (this.adr.nid1!=null) {
            this.start_nid = this.adr.nid1;
            this.start = this.adr.d1_str;
        }
        if (this.adr.nid2!=null) {
            this.end_nid = this.nid2;
            this.end = this.adr.d2_str;
        }
    }
    doContextSplit=function($context){
        var parts = $context.split("–");
        if (parts.length==1) parts = $context.split("-");
        if (parts.length) this.start = parts[0];
        if (parts.length>1) this.end = parts[1];
        finalArr.push(obj);
    }
}


class wikipediadata2  {
    constructor($trackerMap = null, $altConsole=null) {
        this._props = [];
        this.aec = new anne_external_connector("", "wikipedia", null);
        if ($trackerMap!=null) this.aec.setTracker($trackerMap);

        //print stuff here instead.
        if ($altConsole!=null) {
            this.aec.setAltConsole($altConsole);
        }

        //will be populated by the specific search.
        this.resolvedNOBJ = null;
        this.page_name = null;              //needs to be set the last slash uri of this page.
        this.wiki_type_nObj = null;         //needs to be set to the neuron we will make in ANNE for this new search result thing  
        this.original_search_text = null;
        this.url = "";
        this.new_relons = [];
        this.wiki_type_nObj = null;
        this._ignoredValues=[];//["deep state operative", "deep state actor", "deep state functionary", "deep state politician"]
        this.json = null;
        this._processing_complete_callback = null;
        this.ambiguous_resolutions = [];
        this._busted = [];
        this.location_support = [];
        this.primary_inst_support = [];
        this._imgs = [];//we can use any one of these to display in the wiki maker.
        this.logo = "";
        this.prop_occupation = null;

        
        this.bGOT_TOP_SERVICE_TERMS = false;
        this.bGOT_TOP_MARRY_NEURONS = false;

        this.extras = [];
        this._temp_only_ghosts = [];    //relons supporting ghosts but never broadcast

        this.printToBest("initializing", _CYAN, "wikpedia data connector");

        this._pmother = null;
        this._pfather = null;

        this.buildProps();

    }


    //printing to superconsole ---
    //until we allow wikipedia searches in the hypergraph..
    //then we have to reroute to console in hypergraph.
    printf = function($args) {
        var msg = ANNE.TALK.printf(...$args);
        ANNE.superConsolePrint(msg);
    }
    
    printToBest=function(...$args) {
        var msg = ANNE.TALK.printf(...$args);
        if (this.aec!=null) {
            this.aec.addToConsole(msg);
        }
    }


    addExtra = function($type, $reln, $to_type, $to_s) {
        this.extras.push({type:$type, reln:$reln, to_type:$to_type, to_s:$to_s});
    }

    
    /**
     * 
     */
    buildProps=function() {

        var pedu = this.makeFM(this.processEducation, "education", "education", TYPE_BE, MEM.alumni_of.nid, TO_TYPE_ANNE, "per"); 
        pedu.splitByContext = true;
        
        this.makeFM(this.processDate, "birth_date", "birth date", TYPE_BE, ANNE.MEM.birthday.nid, TO_TYPE_ANNE); 
        this.makeFM(this.processBirthname, "birth_name", "birth name", TYPE_BE, ANNE.MEM.birthname.nid, TO_TYPE_STRING); 
        
        var propBirthLocation =this.makeFM(this.processLocation, "birth_place", "birth place", TYPE_BE, ANNE.MEM.birthplace.nid, TO_TYPE_ANNE); 
        propBirthLocation.onlyOne = true;
        
        this.makeFM(this.processDate, "death_date", "death date", TYPE_BE, ANNE.MEM.deathday.nid, TO_TYPE_ANNE); 
        var propDeathLocation = this.makeFM(this.processLocation, "death_place", "death place", TYPE_BE, ANNE.MEM.deathplace.nid, TO_TYPE_ANNE); 
        propDeathLocation.onlyOne = true;

        this.makeFM(this.processEducation, "alma_mater", "alumni of", TYPE_BE, ANNE.MEM.alumni_of.nid, TO_TYPE_ANNE); 
        
        this.makeFM(this.processSimpleText, "nickname", "nickname", TYPE_HAS, ANNE.MEM.IMDB_id.nid, TO_TYPE_STRING)
        
        this.makeFM(this.processEthnicHeritage, "eheritage", "eheritage", TYPE_BE, ANNE.MEM.ethnicity.nid, TO_TYPE_ANNE)
        
        this.makeFM(this.processServiceTerm, "service_term", "service_term", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term1", "service_term1", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term2", "service_term2", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term3", "service_term3", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term4", "service_term4", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term5", "service_term5", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term6", "service_term6", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term7", "service_term7", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term8", "service_term8", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term9", "service_term9", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term10", "service_term10", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term11", "service_term11", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term12", "service_term12", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term13", "service_term13", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term14", "service_term14", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term15", "service_term15", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term16", "service_term16", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term17", "service_term17", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);
        this.makeFM(this.processServiceTerm, "service_term18", "service_term18", TYPE_HAS, ANNE.MEM.service_term.nid, TO_TYPE_ANNE);

        //spouse now makes a clump for marriage date/divorce date.
        var pspouse = this.makeFM(this.processSpouse, "spouse", "spouse", TYPE_HAS, ANNE.MEM.spouse.nid, TO_TYPE_ANNE);
        pspouse.apply_to_types = ["person"];
        pspouse.make_be_dual = MEM.spouse;
        pspouse.dual_type = TYPE_HAS;

        var prelative = this.makeFM(this.processRelatives, "relatives", "relatives", TYPE_HAS, null, TO_TYPE_ANNE);
        prelative.apply_to_types = ["person"];
        prelative.splitOn="newline";
        
        this._pfather = this.makeFM(this.processFather, "father", "father", TYPE_HAS, ANNE.MEM.father.nid, TO_TYPE_ANNE);
        this._pfather.apply_to_types = ["person"];
        this._pfather.make_be_dual = MEM.kinfolk_child;
        this._pfather.dual_type = TYPE_HAS;
        
        this._pmother = this.makeFM(this.processMother, "mother", "mother", TYPE_HAS, ANNE.MEM.mother.nid, TO_TYPE_ANNE);
        this._pmother.apply_to_types = ["person"];
        this._pmother.make_be_dual = MEM.kinfolk_child;
        this._pmother.dual_type = TYPE_HAS;

        //must be processed second, as we will atack these on to pmother/pfather
        var pparents = this.makeFM(this.processParent, "parents", "parents", TYPE_HAS, ANNE.MEM.kinfolk_parent.nid, TO_TYPE_ANNE);
        pparents.apply_to_types = ["person"];
        pparents.make_be_dual = MEM.kinfolk_child;
        pparents.dual_type = TYPE_HAS;
        pparents.apply_to_types = ["person"];
        pparents.parent_pair_male_first=true;

        var prop111 = this.makeFM(this.processFoundedAsClump, "founded", "founded date", TYPE_HAS, ANNE.MEM.foundedOn.nid, TO_TYPE_ANNE); 
        prop111.prop_pair = true;
        prop111.prop_part0 = "date";
        prop111.prop_part1 = "location";
        prop111.splitter="newline";
        prop111.aug_reln = ANNE.MEM.registrationPolity.nid;
        
        this.makeFM(this.processLocation, "registration_polity", "registration polity", TYPE_BE, ANNE.MEM.registrationPolity.nid, TO_TYPE_ANNE); 

        var propc = this.makeFM(this.processLocation, "hq_location_city", "location", TYPE_HAS, ANNE.MEM.hqLocation.nid, TO_TYPE_ANNE); 
  
        var propc = this.makeFM(this.processLocation, "location", "location", TYPE_HAS, ANNE.MEM.hqLocation.nid, TO_TYPE_ANNE); 
        propc.apply_to_types = ["company"];


        var ploc = this.makeFM(this.processLocation, "location_prefix", "location_prefix", TYPE_HAS, ANNE.MEM.location.nid, TO_TYPE_ANNE);
        this.makeFM(this.processLocation, "city", "city", TYPE_HAS, ANNE.MEM.location.nid, TO_TYPE_ANNE);
        this.makeFM(this.processState, "state", "state", TYPE_HAS, ANNE.MEM.state.nid, TO_TYPE_ANNE); 
        this.makeFM(this.processCountry, "country", "location country", TYPE_HAS, ANNE.MEM.country.nid, TO_TYPE_ANNE); 
        
        this.makeFM(this.processCountry, "hq_location_country", "location country", TYPE_HAS, ANNE.MEM.country.nid, TO_TYPE_ANNE); 
        this.makeFM(this.processCompanyType, "company_type", "location country", TYPE_BE, ANNE.MEM.company_type.nid, TO_TYPE_ANNE); 
        
        //DAMN.. sometimes this is an address too.
        this.makeFM(this.processSiteOrLocation, "headquarters", "headquarters", TYPE_HAS, ANNE.MEM.hqLocation.nid, TO_TYPE_ANNE); 
        
        //is this used anymore?  I don't think so.. not in wikipedia. (maybe dbpedia?)
        this.makeFM(this.processCompanyType, "corp_type", "company type", TYPE_BE, ANNE.MEM.company_type.nid, TO_TYPE_ANNE); 

        
        var prop88 = this.makeFM(this.processISIN, "isin", "corp id", TYPE_BE, ANNE.MEM.corp_legal_id.nid, TO_TYPE_STRING)
        prop88.parse_colon_pair = true;
        prop88.prop_part0 = "id_name";
        prop88.prop_part1 = "id_value";

        //do we want to do this as a different location??? on one?
        //TODO:FIX
        var proplf = this.makeFM(this.processLocation, "location_prefix", "location prefix", TYPE_HAS, ANNE.MEM.city.nid, TO_TYPE_ANNE); 
        proplf.process_as_array=true;

        this.makeFM(this.processDate, "established", "founded date", TYPE_HAS, ANNE.MEM.foundedOn.nid, TO_TYPE_ANNE); 

        this.makeFM(null, "website", "website", TYPE_HAS, ANNE.MEM.website.nid, TO_TYPE_ANNE);
        this.makeFM(null, "homepage", "website", TYPE_HAS, ANNE.MEM.website.nid, TO_TYPE_ANNE);

        //screen shot of app/site.
        //screenshot

        this.makeFM(this.processSimpleText, "athletics_nickname", "athletics nickname", TYPE_HAS, ANNE.MEM.athletics_nickname.nid, TO_TYPE_STRING)
        
        this.prop_occupation = this.makeFM(null, "occupationX", "occupationX", TYPE_HAS, ANNE.MEM.occupation.nid, TO_TYPE_ANNE);
        this.prop_occupation.extras = [{type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:ANNE.MEM.occupation.nid}];
        this.prop_occupation.add_extras_if_doesnt_exist = true;

        //key_people --->  //Jeff Bezos\n(chairman)\n\nAndy Jassy\n(president and CEO)
        var prop9 = this.makeFM(this.processPersonWithTitle, "key_people", "key people", TYPE_HAS, ANNE.MEM.key_person.nid, TO_TYPE_ANNE); 
        prop9.prop_pair = true;
        prop9.splitter="newline";
        prop9.innersplitter=" and ";
        prop9.prop_part0="person";
        prop9.prop_part1="title";
        prop9.make_service_term = true;
        prop9.special_prop_obj = this.prop_occupation;
        prop9.prop_part1and=true; //this can have an and and have multiple titles!
 
        
        this.makeFM(this.processGeoCoordinates, "coordinates", "coordinates", TYPE_HAS, ANNE.MEM.gps_lat.nid, TO_TYPE_NUMBER);
        this.makeFM(this.processGeoCoordinates, "coor", "coor", TYPE_HAS, ANNE.MEM.gps_lat.nid, TO_TYPE_NUMBER);

        //"Burgers · chicken · french fries · soft drinks · soft serves · shakes · salads · desserts · hotcake · coffee · breakfast · wraps"
        var prop44 = this.makeFM(this.processNonLivingThing, "products", "products", TYPE_HAS, ANNE.MEM.product.nid, TO_TYPE_ANNE);
        prop44.extras = [{type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:ANNE.MEM.product.nid}];
        prop44.extras_to_match_required = true;
        prop44.splitOn=",";
        prop44.splitOn2 = "·";

        
        //is a division also a corp??? or a division is a non-corp thing?
        //observe the willy-wonka wikpedia way and ascertain this.. then store it when it makes more sense.

        //var propDivision = this.makeFM(this.processDivision, "divisions", "divisions", TYPE_HAS, ANNE.MEM.division.nid, TO_TYPE_ANNE);
        //propDivision.extras = [{type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:ANNE.MEM.division.nid}];
        //propDivision.extras_to_match_required = true;
        //propDivision.make_be_dual = MEM.division_of;
        //propDivision.dual_type = TYPE_BE;

        //converting these to proper img files.
        this.makeFM(this.processImgPart, "thumbnail", "thumbnail", TYPE_HAS, ANNE.MEM.wcImgUriPart_thumbnail.nid, TO_TYPE_ANNE);
        this.makeFM(this.processImgPart, "imageFlag", "imageFlag", TYPE_HAS, ANNE.MEM.wcImgUriPart_Flag.nid, TO_TYPE_ANNE);
        this.makeFM(this.processImgPart, "imageMap", "imageMap", TYPE_HAS, ANNE.MEM.wcImgUriPart_Map.nid, TO_TYPE_ANNE);
        this.makeFM(this.processImgPart, "imageSeal", "imageSeal", TYPE_HAS, ANNE.MEM.wcImgUriPart_Seal.nid, TO_TYPE_ANNE);
        this.makeFM(this.processImgPart, "imageSkyline", "imageSkyline", TYPE_HAS, ANNE.MEM.wcImgUriPart_Skyline.nid, TO_TYPE_ANNE);        

        //group stuff.
        this.makeFM(this.processDate, "disbanded", "dissolved on", TYPE_HAS, ANNE.MEM.dissolved_on.nid, TO_TYPE_ANNE); 

        //review this
        //this.makeFM(this.processDate, "other_name", "aka", TYPE_BE, ANNE.MEM.aka.nid, TO_TYPE_STRING); 
        
        this.makeFM(this.processLocation, "hqLocation", "hqLocation", TYPE_HAS, ANNE.MEM.hqLocation.nid, TO_TYPE_ANNE); 
        this.makeFM(this.processNonLivingThing, "ideology", "ideology", TYPE_HAS, ANNE.MEM.ideology.nid, TO_TYPE_ANNE); 
    
        //Odeo (March–October 2006)\n\nObvious Corporation (2006–2007)\n\nTwitter, Inc. (2007–2023)\n\nX Corp. (2023–present)
        var powner = this.makeFM(this.processCompany, "owner", "owner", TYPE_HAS, ANNE.MEM.ideology.nid, TO_TYPE_ANNE); 
        powner.parse_date_range_context=true;
        powner.user_anne_date_range = true;
        powner.apply_to_types = ["company", "website"];

        var pparent = this.makeFM(this.processCompany, "parent", "parent", TYPE_BE, ANNE.MEM.subsidary_of.nid, TO_TYPE_ANNE); 
        pparent.make_be_dual = MEM.subsidary;
        pparent.dual_type = TYPE_HAS;
        pparent.splitOn = "·";
        pparent.apply_to_types = ["company"];

        var ppsubsid = this.makeFM(this.processCompany, "subsid", "subsid", TYPE_HAS, ANNE.MEM.subsidary.nid, TO_TYPE_ANNE); 
        ppsubsid.make_be_dual = MEM.subsidary_of;
        ppsubsid.dual_type = TYPE_BE;
        ppsubsid.splitOn = "·";
        ppsubsid.apply_to_types = ["company"];

        //[DONE] tested and working in new model.
        var launchdate = this.makeFM(this.processDate, "launch_date", "launch_date", TYPE_HAS, ANNE.MEM.launch_date.nid, TO_TYPE_ANNE); 
        launchdate.apply_to_types = ["company", "website"];

        //[DONE] tested and working in new model.
        //no date ranges of term?  arrrg.
        var pceo = this.makeFM(this.processPerson, "ceo", "ceo", TYPE_HAS, ANNE.MEM.ceo.nid, TO_TYPE_ANNE); 
        pceo.apply_to_types = ["company", "website"];

        //[DONE] tested and working in new model.
        //no date ranges?  arrrg.
        var pchairman = this.makeFM(this.processPerson, "chairman", "chairman", TYPE_HAS, ANNE.MEM.chairman.nid, TO_TYPE_ANNE); 
        pchairman.apply_to_types = ["company", "website"];
                
        //[DONE] tested and working in new model.
        //explore building this out.
        var prop8 = this.makeFM(this.processNameClump, "former_name", "formerly known as", TYPE_BE, ANNE.MEM.fka.nid, TO_TYPE_STRING)
        prop8.parse_date_range_context=true;
        pceo.apply_to_types = ["company", "person", "website"];

        //[DONE] tested and working in new model.
        //store name if we don't have it.
        //if we have it, but this is a new alt name, store aka.
        var propname = this.makeFM(this.processSimpleText, "name", "name", TYPE_BE, ANNE.MEM.name.nid, TO_TYPE_STRING);
        propname.only_if_no_name = true;
        propname.alt_reln = ANNE.MEM.aka.nid;
        propname.alt_type = TYPE_BE;
        propname.alt_to_type = TO_TYPE_STRING;

        this.makeFM(this.processMotto, "motto", "motto", TYPE_BE, ANNE.MEM.motto.nid, TO_TYPE_BLOB);
        
        //[DONE] tested and working in new model.
        var propxx = this.makeFM(this.processFounder, "founder", "founder from company", TYPE_HAS, ANNE.MEM.founder.nid, TO_TYPE_ANNE); 
        propxx.disambig_first = true;
        propxx.apply_to_types = ["company", "website"];
        propxx.make_be_dual = MEM.founder_of;
        propxx.dual_type = TYPE_BE;
        propxx.max_char_to_skip = 90; 
        propxx.founderColons=true;

        
        var propxx2 = this.makeFM(this.processCorpFounders, "founders", "founder from company", TYPE_HAS, ANNE.MEM.founder.nid, TO_TYPE_ANNE); 
        propxx2.apply_to_types = ["company"];
        propxx2.splitOn=",";
        propxx2.pre_fix_multi_context = true;
        propxx2.make_be_dual = MEM.founder_of;
        propxx2.dual_type = TYPE_BE;


        //[DONE] tested and working in new model.
        this.makeFM(this.processImgPart, "logo", "logo", TYPE_HAS, ANNE.MEM.logo.nid, TO_TYPE_ANNE);
        this.makeFM(this.processImgPart, "image_1", "image_1", TYPE_HAS, ANNE.MEM.neuronImg.nid, TO_TYPE_ANNE);
        this.makeFM(this.processImgPart, "image_2", "image_2", TYPE_HAS, ANNE.MEM.neuronImg.nid, TO_TYPE_ANNE);
        

        //[DONE] tested and working in new model.
        var ppeth = this.makeFM(this.processEthnicity, "ethnicity", "ethnicity", TYPE_HAS, ANNE.MEM.ethnicity.nid, TO_TYPE_ANNE);
        ppeth.apply_to_types = ["name"];
        ppeth.extras = [{type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:ANNE.MEM.ethnicity.nid}];

        var ppeth = this.makeFM(this.processSimpleText, "meaning", "meaning", TYPE_HAS, ANNE.MEM.wiki_meaning.nid, TO_TYPE_BLOB);
        ppeth.apply_to_types = ["name"];

        var pndust = this.makeFM(this.processIndustry, "industry", "industry", TYPE_HAS, ANNE.MEM.industry.nid, TO_TYPE_ANNE);
        pndust.apply_to_types = ["company"];
        pndust.extras = [{type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:ANNE.MEM.industry.nid}];
        pndust.splitOn=",";

        //X Corp has a service of twitter.
        //this is a simple non-living THING tied with a TYPE_BE to "service".
        var pnservices = this.makeFM(this.processService____likeProduct, "services", "services", TYPE_HAS, ANNE.MEM.service.nid, TO_TYPE_ANNE);
        pnservices.apply_to_types = ["company"];
        pnservices.extras = [{type:TYPE_BE, reln:ANNE.MEM.ec_is.nid, to_type:TO_TYPE_ANNE, to_s:ANNE.MEM.service.nid}];
        pnservices.extras_to_match_required = true;
        
        //legit known langs.
        //[DONE] tested and working in new model.
        var pplang = this.makeFM(this.processLanguage, "language", "language", TYPE_BE, ANNE.MEM.language.nid, TO_TYPE_ANNE); 
        pplang.apply_to_types = ["name"];

        //name desc (of the name class) -- just taking the first sentence not extended blob
        //[DONE] tested and working in new model.
        var pdesc = this.makeFM(this.processBlob, "name_desc", "name_desc", TYPE_HAS, ANNE.MEM.description.nid, TO_TYPE_BLOB); 
        pdesc.apply_to_types = ["name"];
        pdesc.max=1;

        //desperado when we have nothing else.
        //but we can get the wiki link name and document this as "unique".
        //[DONE] tested and working in new model
        var pdesc2 = this.makeFM(this.processBlob, "per_desc", "per_desc", TYPE_HAS, ANNE.MEM.description.nid, TO_TYPE_BLOB); 
        pdesc2.apply_to_types = ["person"];
        pdesc2.max=1;

        var propxx2 = this.makeFM(this.processPerson, "founder", "founder from person", TYPE_HAS, ANNE.MEM.founder.nid, TO_TYPE_ANNE); 
        propxx2.splitOn =",";
        propxx2.apply_to_types = ["person"];


        //[DONE] tested and working in new model.
        var pp2 = this.makeFM(this.processPerson2, "people", "people", null, "", null); 
        pp2.apply_to_types = ["name"];
        pp2.makeTempRelons = [{type:TYPE_HAS, reln:ANNE.MEM.lastName.nid}];

        //[DONE] tested and working in new mode.
        var pp2 = this.makeFM(this.processImgsFix, "imgsfix", "imgsfix", TYPE_HAS, ANNE.MEM.neuronImg.nid, TO_TYPE_ANNE); 
        pp2.max = 1;
        pp2.apply_to_types = ["person"];    

        var pp2IF = this.makeFM(this.processImgsFix, "imgsfix", "imgsfix", TYPE_HAS, ANNE.MEM.neuronImg.nid, TO_TYPE_ANNE); 
        pp2IF.max = 5;
        pp2IF.apply_to_types = ["location"];    

        //TYPE_CLUMP signal protocol to extrapolate roles into mappedRoles.
        //in theory, we should get when to extrapolate to foundOn and where to extrapolate to foundedAt
        //if such mappings existed.
        //March 21, 2006, in San Francisco, California, U.S
        var ppFoundation = this.makeFM(this.processDate, "foundation", "foundation", TYPE_HAS, ANNE.MEM.foundedOn.nid, TO_TYPE_ANNE); 
        ppFoundation.prop_pair = true;
        ppFoundation.splitter = " in ";
        ppFoundation.prop_part0 = "date";
        ppFoundation.prop_reln0 = ANNE.MEM.foundedOn.nid;
        ppFoundation.prop_part1 = "location";
        ppFoundation.prop_reln1 = ANNE.MEM.registrationPolity.nid;
    }
    

    /**
     * 
     * @param {*} $cb_resolve_obj 
     * @param {*} $src_prop_name 
     * @param {*} $anne_prop_name 
     * @param {*} $type 
     * @param {*} $reln 
     * @param {*} $to_type 
     * @param {*} $incr 
     * @returns 
     */
    makeFM=function($cb_resolve_obj=null, $src_prop_name="propname", $anne_prop_name="annename", $type=3, $reln="", $to_type="") {
        var prop = new field_mapper($cb_resolve_obj, this.src, $src_prop_name, $anne_prop_name, $type, $reln, $to_type);
        this._props.push(prop);
        return prop;
    } 



    /**
     * @param {array} $results 
     * @param {*} $str 
     * @param {*} $propObj 
     * @param {*} $data 
     * @returns 
     */
    cleanThisMessUp=async($results, $str, $propObj, $data)=>{
        if ($str==undefined || $str==null || $str=="") return [];

        //audit new method?
        var test = wtf($str).text();
        console.log("audit %c"+$propObj.src_prop_name+"%c"+test, ANNE.TALK.bggreen, ANNE.TALK.bgyellow);

        if ($propObj.src_prop_name=="key_people") {
            console.log("key_people");
            console.log($data);
        }
        if ($propObj.src_prop_name=="founders") {
            console.log("test founders.");
            console.log($data);
        }
        
        var finalArr = [];
        
        var pushfinal =function($obj) {
            var fixedObj = ANNE.UTILS.stripParens($obj.lookupval.trim());
            if (fixedObj.context!="") {
                $obj.lookupval = fixedObj.str;
                $obj.context = fixedObj.context;
                $obj.wikipart = fixedObj.str;

                if ($obj.context.indexOf("formerly ")!=-1) {
                    $obj.fka = $obj.context.replace("formerly ", "");
                    $obj.extras.push({type:TYPE_BE, reln:ANNE.MEM.fka.nid, to_type:TO_TYPE_STRING, to_s: $obj.fka});
                    $obj.context="";
                }
            }
            finalArr.push($obj);
        }

        var $wikipart = $data.text;

        var arrmaker=function($str, $wiki, $text) {
            //use the str, if we get more than one, take it as-is.
            var arr = $str.trim().split(/\n\n|;/); //split on new lines or semi colon.
            if (arr.length==1) {
                arr = arr[0].trim().split(/\n/); //split on new lines or semi colon.
                if (arr.length>1) return arr;
            }
            if(arr.length>1) return arr;

            //if we only have one, with no right brackets.. take it
            if ($wiki==null || $wiki=="" || $wiki.indexOf("]]")==-1) return [$str];

            //we have crap wiki data running a known [[xxx]] next to another string with no page.
            //it is actually 2 things.

            var wparts = $wiki.split("]]");
            if (wparts.length==1) return [$text];
            var finalarr = [];
            for (var w=0; w < wparts.length; w++) {
                if (wparts[w].length==0 || wparts[w]=="") continue;
                if (wparts[w].indexOf("[[")==0) {
                    wparts[w] = wparts[w].substring(2);
                }
                if (wparts[w].indexOf("[[")!=-1) continue;
                if(wparts[w].indexOf("(")!=-1) continue;
                if (wparts[w].indexOf(")")!=-1) continue;
                if (wparts[w].trim().length<2) continue;
                finalarr.push(wparts[w].trim());
            }
            return finalarr;
        }


        var arr = arrmaker($str, $data.wiki, $data.text);

        if ($propObj.pre_fix_multi_context!=undefined) {        
            if (arr.length==1) {
                var matches = arr[0].split(")");
                if (matches.length>2) {
                    var finalm = [];
                    for (var m=0; m < matches.length; m++) {
                        var mt = matches[m];
                        if (mt.length==0) continue;
                        finalm.push(mt+")");
                    } 
                    if (finalm.length>1) arr = finalm;
                }
            }
        }
        
        var finalm2 = [];
        for (var a=0; a < arr.length; a++) {
            var fix  = arr[a];
            if (fix.indexOf("* ")!=-1) {
                var fpart = fix.split("* ");
                for (var ff2=0; ff2 < fpart.length; ff2++) {
                    var fpart2 = fpart[ff2].trim();
                    if (fpart2.length) finalm2.push(fpart2);
                }
            }
            else finalm2.push(fix);
        }
        if (finalm2.length>arr.length) {
            arr = finalm2;
        }
        
        for (var nn=0; nn < arr.length; nn++) {

            //clean these up here. (burger king is a mess!!!)
            if ($propObj.src_prop_name=="founder" || $propObj.src_prop_name=="key_people") {
                console.log(arr[nn]);
            }

            //March 21, 2006, in San Francisco, California, U.S.
            if ($propObj.prop_pair!=undefined && $propObj.splitter!=undefined) {
                if ($propObj.splitter=="newline") {
                    var parts = arr[nn].trim().split(/\n|;/); //split on new lines or semi colon.
                }
                else {
                    var parts = arr[nn].trim().split($propObj.splitter);
                }
                var obj = {lookupval:null, to_s:""}; //to_s will still be the part0 resolution default.

                if (parts.length==1) {
                    var cobj = ANNE.UTILS.stripParens(arr[nn]);
                    var partname0 = $propObj.prop_part0;
                    var partname1 = $propObj.prop_part1;
                    obj[partname0] = cobj.str;
                    obj[partname1] = cobj.context;                    
                }
                else {
                    for (var p=0; p < parts.length; p++) {
                        var part = parts[p];
                        part = ANNE.UTILS.endsWithStrip(part, ",");
                        var partname = $propObj['prop_part'+p];
                        var reln = $propObj['prop_reln'+p];
                        if (partname==undefined) continue;
                        var part = part.replace(/[()]/g, '');
                        //this will split the titles up -- even with one, it will be an array
                        if ($propObj.innersplitter!=undefined && p>0 && part.split($propObj.innersplitter)>1) {
                            var p_parts = part.split($propObj.innersplitter);
                            obj[partname] = p_parts;
                        }
                        else {
                            obj[partname] = part;
                        }
                        obj[partname+'_reln'] = reln;
                    }
                }
                
                finalArr.push(obj);
                continue;
            }

            //Twitter (2006–2023)
            else if ($propObj.parse_date_range_context!=undefined) {
                var cobj = ANNE.UTILS.stripParens(arr[nn]);  
                var obj = new wdata_drange(cobj.str, null);
                var context = cobj.context; 
                if ($propObj.anne_date_range==true) {
                    await obj.doContext(context);
                }
                else {
                    obj.doContextSplit(context);
                }
                finalArr.push(obj);
            }
            
            else if ($propObj.and!=undefined) {
                var parts = arr[nn].trim().split(" and ");
                if (parts.length>1) {
                    for (var p=0; p < parts.length; p++) {
                        var obj = new wdata(parts[p].trim(), parts[p].trim());
                        pushfinal(obj);
                    }
                }
            }


            else if ($propObj.splitOn!=undefined) {
                var parts = [];
                if ($propObj.splitOn=="newline") {
                    parts = arr[nn].trim().split(/\n|;/); //split on new lines or semi colon.
                }
                else parts = arr[nn].split($propObj.splitOn);
                
                if (parts.length==1 && $propObj.splitOn2!=undefined) {
                    parts = arr[nn].split($propObj.splitOn2);
                }
                
                for (var p=0; p < parts.length; p++) {
                    var cobj = ANNE.UTILS.stripParens(parts[p].trim());  
                    var obj = new wdata(cobj.str, parts[p].trim());
                    obj.context2=cobj.context;

                    if (obj.lookupval.indexOf(" & ")!=-1 && obj.lookupval.split(" ").length>=4) {
                        var strs = ANNE.UTILS.extrapAmperStr(obj.lookupval);
                        if (strs==null) pushFinal(obj);
                        else {
                            for (var s=0; s < strs.length; s++) {
                                var objX = new wdata(strs[s], null);
                                if (obj.context2!=undefined) objX.context2 = obj.context2;
                                pushfinal(objX);
                            }
                        }
                    }
                    else pushfinal(obj);
                }
                
            }

            else if ($propObj.parse_colon_pair!=undefined) {
                var obj = new wdata(arr[nn], null);
                var parts = arr[nn].split(":");
                if (parts.length!=2) continue; //skip it.
                obj[$propObj.prop_part0] = parts[0];
                obj[$propObj.prop_part1] = parts[1];  
                pushfinal(obj);
            }
                
            else if ($propObj.parse_colon!=undefined) {
                var parts = arr[nn].split(":");
                if (parts.length>1) {
                    for (var p=0; p < parts.length; p++) {
                        var obj = new wdata(parts[p].trim(), parts[p].trim());
                        pushfinal(obj);
                    }
                }
            }

            else if ($propObj.splitByContext!=undefined) {
                const regex = /([^()]+) \(([^)]+)\)/g;
                let match;
                const result = [];
                
                while ((match = regex.exec(arr[nn])) !== null) {
                    var obj = new wdata(match[1].trim(), null);
                    obj.context = match[2];
                    pushfinal(obj);
                }
            }
            else if($propObj.founderColons!=undefined) {
                var parts = arr[nn].split(":");
                if (parts.length==1) {
                    var wikipart = "";
                    if (arr.length>1) wikipart = arr[nn].trim().replaceAll(" ", "_"); 
                    else wikipart = $wikipart;
                    var obj = new wdata(arr[nn].trim(), wikipart);
                    pushfinal(obj);
                    continue;
                }

                //skip for now.
                if (arr[nn].length>$propObj.max_char_to_skip) {
                    continue;
                }
    
                //"Insta-Burger King: Keith G. Kramer and Matthew Burns Burger King: David Edgerton and James McLamore"
                //var name = this.name;
                
            }
            else {
                var wikipart = "";
                if (arr.length>1) wikipart = arr[nn].trim().replaceAll(" ", "_"); 
                else wikipart = $wikipart;
                var obj = new wdata(arr[nn].trim(), wikipart);
                pushfinal(obj);
            }
        }

        //quite a rube hack just to get one better relon (instead of parent, get father.. or mother)
        if ($propObj.parent_pair_male_first!=undefined) {
            if (finalArr.length==2) {
                var fatherObj = finalArr[0];
                if (this._pfather.prop_value_arr==undefined || this._pfather.prop_val_arr==null) {
                    this._pfather.prop_value_arr = [];
                }
                this._pfather.prop_value_arr.push(fatherObj);
                if (ANNE.UTILS.findValInObjnArr2($results, "src_prop_name", "father")==false) {
                    $results.push(this._pfather);
                }

                var motherObj = finalArr[1];
                if (this._pmother.prop_value_arr==undefined || this._pmother.prop_val_arr==null) {
                    this._pmother.prop_value_arr = [];
                }
                this._pmother.prop_value_arr.push(motherObj);
                if (ANNE.UTILS.findValInObjnArr2($results, "src_prop_name", "mother")==false) {
                    $results.push(this._pmother);
                }
                finalArr=[];    //set parents array nadda.. 
            }
        }
        return finalArr;
    }



    /**
     * 
     * @param {*} $dataObj 
     * @returns 
     */
    processResults=async($dataObj)=>{
        this.printToBest("proccessing results");
        if ($dataObj.infobox==undefined && ($dataObj.json==undefined||$dataObj.json==null)) {
            $dataObj.results = [];
            return;
        }
        
        var results = [];

        //only some pages have the IDATA with the infobox.
        var IDATA = null;
        if ($dataObj.infobox!=null) {
            IDATA = $dataObj.infobox.data;
            console.log(IDATA);
        }
        
        var jextract = $dataObj.json;

        //make the other TXs....  these are searchObj context tags that were used in the search itself.
        //some searches include parens IN the search
        if ($dataObj._targets!=null && $dataObj._targets.props.length>0 && $dataObj.searchObj && $dataObj.searchObj.context.length>0) {
            console.log("context in original search s.b. BE resolved BE data, or EC nonliving class");
            var contexts = $dataObj.searchObj.context;
            for (var t=0; t < contexts.length; t++) {
                this.printToBest("resolving context", _GREEN, context[t]);
                var aMatches = await ANNE.CHASE.nakedSearch(contexts[t].replaceAll("_", " "), false, true);
                if (aMatches.length==0) {
                    var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(ANNE.MEM.ec_nonliving, contexts[t].replaceAll("_", " "), NTYPE_CLASS);
                    this.printToBest("new context", _BLUE, context[t]);
                    this.addExtra(TYPE_BE, ANNE.MEM.be.nid, TO_TYPE_ANNE, ghostNOBJ.nid);
                }
                else if (aMatches.length>0) {
                    if (ANNE.BRAIN.ctp_light!=null) {
                        var dp = new simple_disambig_pool("disambig thing", ANNE.BRAIN.ctp_light);
                        var winnerNOBJ = dp.disambiguate(aMatches, [this.resolvedNOBJ, ANNE.MEM.role_theme_thing, ANNE.MEM.ec_nonliving]);
                        this.printToBest("resolved context with disambig pool", _GREEN, context[t]);
                        this.addExtra(TYPE_BE, ANNE.MEM.is.nid, TO_TYPE_ANNE, winnerNOBJ.nid);
                    }
                    else {
                        this.printToBest(_RED,"no disambig pool available.",_WHITE,"best guess resolution to", _GREEN, context[t]);
                        this.addExtra(TYPE_BE, ANNE.MEM.is.nid, TO_TYPE_ANNE, aMatches[0].nid);
                    }
                }
                else {
                    this.printToBest("resolved context", _GREEN, context[t]);
                    this.addExtra(TYPE_BE, ANNE.MEM.is.nid, TO_TYPE_ANNE, aMatches[0].nid);
                }
            }
        }

        var wtc = $dataObj.wiki_type_conformed;
        
        var targets = $dataObj._targets;

        //loop our properties with potential values found in the wiki pull.
        for (var p = 0; p < this._props.length; p++) {
            var propObj = this._props[p];
            var propf = propObj.src_prop_name;

            if (propObj.anne_prop_name=="alumni of" || propObj.src_prop_nam=="alma_mater") {
                console.log("test this nonsnse");
            }
            
            if (propObj.src_prop_name=="spouse") {
                console.log("test here why no break on newline?");
            }
            if(targets!=null && targets.props.length) {
                if (targets.only_one==true && targets.found==true) {
                    continue;
                }

                if (targets.props.indexOf(propf)==-1) {
                    console.log("in targets only mode!");
                    continue;
                }
                else {
                    propObj.targets=targets;
                }
            }

            //apply to type check...  (skip if we don't want this prop for this type)
            if (propObj.applyToType(wtc)==false) {
                continue;
            }

            //extracted other way besides infobox.
            //this is the other json outside of the infobox (sometimes no infobox exists)
            if (jextract!=null && jextract[propf] !=undefined) {
                var arr = jextract[propf];
                propObj.prop_value_arr = [];

                //these are pre-prepped and pre-formatted by us..
                //so they are ready to go as-is in their respective functions.
                for(var a=0; a < arr.length; a++) {
                    propObj.prop_value_arr.push(arr[a]);
                    await propObj.resolve_obj(arr[a], propObj);
                    if (propObj.max!=undefined && propObj.max==(a+1)) break;
                }

                results.push(propObj);
            }

            else if (IDATA!=null && IDATA[propf] != undefined) {
                var data = IDATA[propf].data;  //original wiki data.
                if (data==undefined) {
                    data = IDATA[propf];
                    if (Array.isArray(data)==true) {
                        console.log(data);
                        propObj.prop_value_arr = data;
                        propObj.prop_links = null;
                        propObj.prop_value = null;
                    }
                    results.push(propObj);
                }
                else if (data.bCUSTOMWIKIOBJECT!=undefined) {
                    this.printToBest("conceptualizing", _CYAN, propf, _WHITE, "with custom obj");
                    propObj.prop_value = data;
                    propObj.prop_value_arr = [data];
                    results.push(propObj);
                }
                else if (data!=undefined) {
                    console.log(propObj.anne_prop_name+" "+data.text);
                    this.printToBest("conceptualizing", _CYAN, propf, _GREEN, data.text);
                    propObj.prop_value = data.text;
                    propObj.prop_links = data.links;
                    var arr3 = await this.cleanThisMessUp(results, data.text, propObj, data);
                    if (arr3 && arr3.length>0) {
                        propObj.prop_value_arr = arr3;
                    }
                    else continue;
                    results.push(propObj);
                }
                
                else continue;
            }
        }


        for (var rez=0; rez < results.length; rez++) {
            var propObj = results[rez];
            
            console.log("rez "+rez+" prop:"+propObj.src_prop_name);
            
            //loop each item, resolve it with its function.
            for (var a=0; a <propObj.prop_value_arr.length; a++) {

                //we have had enough this one..
                if (propObj.max!=undefined && a>propObj.max) continue;
                
                var objX = propObj.prop_value_arr[a];
            
                if (propObj.resolve_obj != undefined && propObj.resolve_obj!=null && typeof propObj.resolve_obj === "function") {
                    //console.log("handling prop ",propObj.anne_prop_name, objX);
                    if (typeof objX==="string") {
                        var str = objX;
                        objX = {lookupval:str, to_s:""};
                        propObj.prop_value_arr[a]=objX;
                    }
                    else objX.to_s = "";
                    
                    if (propObj.prop_links!=undefined) {
                        objX.prop_links = propObj.prop_links;
                    }

                    if (propObj.anne_prop_name=="alumni of") {
                        console.log("test this nonsnse");
                    }
                    await propObj.resolve_obj(objX, propObj);
                }

                //this is not functioning right...
                else {
                    //console.log("no resolver.  take as is", propObj);
                    console.log(objX);
                }
            }
        }

        if (jextract!=null && jextract.title !=undefined && jextract.title!=null) {
            var strs = [this.name];

            if ( this.resolvedNOBJ!=null) {
                strs.push( this.resolvedNOBJ.text);
                if (this.resolvedNOBJ.aka && this.resolvedNOBJ.aka.length) strs = strs.concat(this.resolvedNOBJ.aka);
            }

            if (this.notsame(strs, jextract.title)==true) {
                //should only do this if not the same as the text.
                this.addExtra(TYPE_BE, ANNE.MEM.aka.nid, TO_TYPE_STRING, jextract.title);
            }
        }

        $dataObj.results = results;
        if (results.length==0) {
            this.printToBest(_CYAN, "no", _WHITE, "unqique result props extracted");
        }
        else if (results.length==1) {
            this.printToBest(_CYAN, "1", _WHITE, "unique result prop extracted");
        }
        else {
            this.printToBest(_CYAN, results.length+"", _WHITE, "unique result props extracted");
        }

        //relons supporting ghosts (gui backlinks) but never broadcast.
        //these relons will be created by L1 protocol.
        if (this._temp_only_ghosts.length>0) {
            await GHOSTDATA.tempOnlyTheRelons(this._temp_only_ghosts);
        }

        return;
    }


    notsame = function($arr, $str2) {
        if ($arr==undefined || $arr==null) return true;
        if ($str2==undefined || $str2==null) return true;

        var s2 = $str2.replaceAll("_"," ").toLowerCase().trim();
        
        for(var a=0; a<$arr.length; a++) {
            var s1 = $arr[a].replaceAll("_"," ").toLowerCase().trim();
            if (s1==s2) return false;
        }
        
        return true;
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     */
    processImgsFix = async($obj, $propObj)=>{
        console.log("TO DO: process:"+$obj);
        $obj.processedBy="wikipediadata2.processImgsFix";
       
        var anneimg = await ANNE.IMAGES.getImgMetaFromUrl($obj.img_full);
        if (anneimg==undefined || anneimg==null) {
            return;
        }

        //check that this checks local space too (ghost imgs not on ANNE)
        var result = await CHASE.getGlobal(MEM.neuronImg, anneimg.live_finger);

        //return {status:"good-but", result:nObj};
        
        if (result.status=="good" && result.message=="available") {
            var imgNOBJ = await anneimg.makeGhost(null, this.resolvedNOBJ, TYPE_HAS, MEM.neuronImg.nid, this.name);
            $obj.to_s = imgNOBJ.nid;

            //add captions to picture.
            if ($obj.caption!=undefined && $obj.caption!=null && $obj.caption.length<255) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, imgNOBJ, ANNE.MEM.description.nid, TO_TYPE_BLOB, $obj.caption);
            }
            
            //we will be wanting to move this from our html/ui/a2a_cache to the a2a_neurons once upgraded.
            //otherwise, we will not have the file data as it will be tied to the url (we didn't have a neuron)
            //at the time we originally stored it.
            //Unless we want to store a data_src relon to the external site... which could change based on
            //their willy-nilly needs to store imgs (as it often does).
            imgNOBJ.temp_href = $obj.img_full;
            if (this.successful_img_afile==null) {
                this.successful_img_afile = anneimg; //what is this for???
                this._new_external_data+=1;
                this.printf("added new img from", _BLUE, $obj.img_full);
            }
        }
        
        //dupe img
        else if (result.result!=null) {

            //tie relon from base thing to this img by setting to_s.
            $obj.to_s = result.result.nid;

            //fix missing caption
            if ($obj.caption!=undefined && $obj.caption!=null && $obj.caption.length<255) {
                var x_relon = ANNE.MEMG.getRelonFromWithR(result.result.outs, TYPE_HAS, ANNE.MEM.description.temp_nid);
                if (x_relon==null) {
                    await GHOSTDATA.makeGhostRelon(TYPE_HAS, imgNOBJ, ANNE.MEM.description.nid, TO_TYPE_BLOB, $obj.caption);
                    this._new_external_data+=1;
                }
            }
        }

        else $obj.to_s = null;
    }


    processGeoCoordinates = async($obj,  $propObj) =>{
        if ($obj==null || $obj.lookupval==undefined) return;

        var parts = $obj.lookupval.split(",");
        if (parts.length!=2) {
            $obj.to_s="";
            return;
        }

        //sign should be all we need here to store it.
        var lat = parts[0].trim(); //40.70861°N
        lat = lat.replace("°N", "");
        lat = lat.replace("°S", "");
        if (isNaN(lat)==true) {
            $obj.to_s="";
            return;
        }
        
        var lon = parts[1].trim(); //-74.00889°W'
        lon = lon.replace("°W", "");
        lon = lon.replace("°E", "");
        if (isNaN(lon)==true) {
            $obj.to_s="";
            return;
        }

        var x_lat_relon = MEMG.getRelonFromWithR(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.gps_lat.temp_nid);
        if (x_lat_relon==null) {
            this.addExtra(TYPE_HAS, ANNE.MEM.gps_lat.nid, TO_TYPE_NUMBER, lat);
        }

        var x_long_rel = MEMG.getRelonFromWithR(this.resolvedNOBJ.outs, TYPE_HAS, ANNE.MEM.gps_long.temp_nid);
        if (x_long_rel==null) {
            this.addExtra(TYPE_HAS, ANNE.MEM.gps_long.nid, TO_TYPE_NUMBER, lon);
        }
    }


    /**
    */
    processBlob = async($obj, $propObj)=> {
        if ($obj==null || $obj.lookupval==undefined) return;
        
        if ($obj.lookupval.length>=255) {
            this.printToBest("blob is", _RED, "too big", _WHITE,", skipping", _GREEN, $obj.lookupval);
        }
        var relnNOBj = ANNE.MEMG.getNeuronByNid($propObj.reln);
        var x_relon = MEMG.getRelonFromWithR(this.resolvedNOBJ.outs, TYPE_HAS, relnNOBj.temp_nid);
        if (x_relon==null) {
            $obj.to_s = $obj.lookupval;
            this.printToBest("adding blob", _GREEN, $obj.lookupval);
        } 
        else {
            this.printToBest("one blob desc per neuron,", _RED, "skipping", _GREEN, $obj.lookupval);
        }
    }


     /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processEthnicity = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processEthnicity";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_nonliving, NTYPE_CLASS, $propObj);
    }


    /**
     * Find or make the new industry neuron
     * it should have a TYPE_BE pointing to off to industry
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processIndustry = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processIndustry";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_nonliving, NTYPE_CLASS, $propObj);
    }

    
    processService____likeProduct = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processService____likeProduct";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_nonliving, NTYPE_CLASS, $propObj);
    }



    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processLanguage = async($obj, $propObj)=> {
        if ($obj==null || $obj.lookupval==undefined) return;
        
        $obj.processedBy="wikidata2.processLanguage";
        return await this.findOnly($obj, ANNE.MEM.language, NTYPE_CLASS);
    }


     /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processLivingThing = async($obj, $propObj)=> {
        if ($obj==null || $obj.lookupval==undefined) return;
         
        $obj.processedBy="wikidata2.processLivingThing";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_living, NTYPE_CLASS, $propObj);
    }



    /**
     * 
     * @param {*} $obj 
     * @param {*} $matches 
     */
    addAmbiguous=function($obj, $matches) {
        var ambig = {jsonobj:$obj, matches:$matches};
        this.ambiguous_resolutions.push(ambig);
        this.printToBest(_CYAN,"AMBIGUIOUS RESULTS", _WHITE, "pend till later resolution");
        console.log(ambig);
    }
 

    /**
     * We only get the file name here.
     * Fix it, and pump it through ImgsFix
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processImgPart=async($obj, $propObj)=>{
        $obj.img_full = "https://wikipedia.org/wiki/Special:Redirect/file/"+$obj.lookupval;
        return await this.processImgsFix($obj, $propObj);    
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processDateWithLocation=async($obj, $propObj)=>{
        $obj.processedBy="processDateWithLocation";
        var lookupval = "";
        if (typeof $obj.lookupval === "string") lookupval = $obj.lookupval;
        else {
            if ($obj.date!=undefined) lookupval = $obj.date;
        }

        if (lookupval.length>20) {
            this._busted.push($obj);
            return;
        }
        
        var ad = new anne_date(lookupval);
        if (ad==null) return; //problem with parse (skip it)

        var bMAKEGHOSTIFNOTFOUND=true;
        await ad.testDate(bMAKEGHOSTIFNOTFOUND);

        //try with date part parsing
        if (ad.nObj==null) {
            var bMONTH_YEAR = true;
            ad = new anne_date(lookupval, false, bMONTH_YEAR);
            await ad.testDate(true);
        }
        
        if (ad.nObj!=null) {
            $obj.to_s = ad.nObj.nid;
            
            //extra location information (on the later relon)
            //this is stored on the main resolvedNOBJ.
            //NOTE: we could do a clump here for WHERE and WHEN but we have mapped relns for these already.
            if ($obj.location!=undefined && $propObj.aug_reln!=undefined) {
                var anne_loc_test = new anne_location($obj.location);
                bMAKEGHOSTIFNOTFOUND=true;
                await anne_loc_test.processFull([], true, bMAKEGHOSTIFNOTFOUND);
                if (anne_loc_test.nObj!=null) {
                    var x_relon = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, TYPE_BE, $propObj.aug_reln, anne_loc_test.nObj.nid);
                    if (x_relon==null) {
                        this.addExtra(TYPE_BE, $propObj.aug_reln, TO_TYPE_ANNE, anne_loc_test.nObj.nid);
                    }
                }
            }
          
        }
        else {
            console.log("something wrong with wiki date");
            this._busted.push($obj);
        }
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processFoundedAsClump = async($obj, $propObj)=> {
        var lookupval = "";
        $obj.processedBy="wikidata2.processDate";

        var context2 = $obj.context;
        if (context2==undefined || context2.indexOf("as ") !=0) {
            if ($obj.date!=undefined && $obj.location!=undefined) {
                return await this.processDateWithLocation($obj, $propObj);
            }
            return;
        }

        var oldCorpName = context2.replace("as ", "");
        console.log(oldCorpName);

        if (typeof $obj.lookupval === "string") {
            lookupval = $obj.lookupval;
        }
        else {
            if ($obj.date!=undefined) {
                lookupval = $obj.date;
            }
        }

        //nope.
        if (lookupval.length>20) {
            this._busted.push($obj);
            return;
        }
        
        //needs to parse MONTH YEAR pattern too here!
        var ad = new anne_date(lookupval);
        if (ad==null) return; //problem with parse (skip it)

        //will make new date if we don't find it.
        await ad.testDate(true);

        //try with date part parsing
        if (ad.nObj==null) {
            var bMONTH_YEAR = true;
            ad = new anne_date(lookupval, false, bMONTH_YEAR);
            await ad.testDate(true);
        }

        var ACTOR_NOBJ = null;
        var WHEN_NOBJ = null;
        var ACTION_NOBJ = ANNE.MEM.founded;
        var WHERE_NOBJ = null;
        
        if (ad.nObj!=null) {
            WHEN_NOBJ = ad.nObj;
            
            //$obj.to_s = ad.nObj.nid;  //base resolution.

            if (WHEN_NOBJ.ghost==false) this.printToBest("resolved date",_YELLOW,WHEN_NOBJ.text);
            else this.printToBest("created new date",_BLUE,WHEN_NOBJ.text);
            
            //this is the self neuron!
            if (oldCorpName==this.name) {
                ACTOR_NOBJ = this.resolvedNOBJ;
            }
            else {
                var highest_nObj = await this.aec.estimateClass(oldCorpName, ANNE.MEM.corp_entity_thetype);
                var GMOBJ = await MEMG.getOrMakeIfNewCorp(this.aec, oldCorpName, highest_nObj);
    
                if (GMOBJ.status=="good") ACTOR_NOBJ = GMOBJ.match;
                else return;//no disambig here.. too complicated at this step (for now)
            }

            //make a new clump
            var clumplookup = new clump_lookup();
            clumplookup.addRole(ANNE.MEM.role_actor.nid, ACTOR_NOBJ.nid);
            clumplookup.addRole(ANNE.MEM.role_action.nid, ACTION_NOBJ.nid);
            clumplookup.addRole(ANNE.MEM.role_when.nid, WHEN_NOBJ.nid);
            
            var rez = await clumplookup.findClump(true);
            if (rez.status=="good") {
                $obj.to_s = rez.match.nid;
            }
            else if (rez.status=="ambiguious") {
                console.log("don't do anything here.");
                return;
            }
        }
            
        else {
            console.log("something wrong with wiki founded as clump");
            this._busted.push($obj);
        }
    }
    


    /**
     * 
     * @param {*} $obj 
     * @returns 
     */
    processDate = async($obj, $propObj)=> {
        var lookupval = "";
        $obj.processedBy="wikidata2.processDate";

        if (typeof $obj.lookupval === "string") {
            lookupval = $obj.lookupval;
        }
        else {
            if ($obj.date!=undefined) {
                lookupval = $obj.date;
            }
        }

        //nope.
        if (lookupval.length>20) {
            this._busted.push($obj);
            return;
        }
        
        var ad = new anne_date(lookupval);
        if (ad==null) return; //problem with parse (skip it)

        //will make new date if we don't find it.
        await ad.testDate(true);
        
        if (ad.nObj!=null) {
            $obj.to_s = ad.nObj.nid;  //base resolution.

            if (ad.nObj.ghost==false) this.printToBest("resolved date",_YELLOW,ad.nObj.text);
            else this.printToBest("created new date",_BLUE,ad.nObj.text);

            //extra location on the primary object, not info about the date.
            //this is essentially another data point.
            //note - we could make a clump here if we wanted...
            //ie,  ROLE_WHERE->  ROLE_WHEN->  ROLE_ACTOR->
            //however, founding won't change.. things that have starts/ends..
            //these make sense to put in clumps.. (service terms, marriages, positions)
            if ($obj.location!=undefined && $obj.location_reln!=undefined) {
                this.printToBest(_CYAN, "extra location available",_GREEN, $obj.location);
                var anne_loc_test = new anne_location($obj.location);
                var bMAKEGHOSTIFNOTFOUND=true;
                await anne_loc_test.processFull([], true, bMAKEGHOSTIFNOTFOUND);
                anne_loc_test.print();
                if (anne_loc_test.nObj!=null) {
                    if (anne_loc_test.nObj.bNEW==true) {
                        this.printToBest("resolved extra location",_YELLOW,anne_loc_test.nObj.text);
                    }
                    else {
                        this.printToBest("made new location", _BLUE, anne_loc_test.nObj.text);
                    }
                    //this is an extra relon on the thing we are processing date for.
                    this.addExtra(TYPE_BE, $obj.location_reln, TO_TYPE_ANNE,anne_loc_test.nObj.nid);
                }
            }
        }
        else {
            console.log("something wrong with wiki date");
            this._busted.push($obj);
        }
    }
    

    
    processISIN = async($obj, $propObj) =>{
        if ($obj.id_name==undefined) return;
        if ($obj.id_value==undefined) return;
        $obj.to_s = $obj.id_value;
    }
    

    processMotto = async($obj, $propObj) =>{
        if ($obj.context==undefined) {
            var obj = ANNE.UTILS.stripParens($obj.lookval);
            $obj.lookupval = obj.str;
            $obj.context = obj.context;
        }

        //lookup language..
        if ($obj.context.legth){
            
        }
        
        $obj.to_s = $obj.lookupval;
        this.printToBest("processed motto", _GREEN, $obj.lookupval);
        
        $obj.processedBy="wikidata2.processMotto";
    }
    
    
    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     */
    processSimpleText = async($obj, $propObj)=> {
        if (this.resolvedNOBJ!=null && $propObj.only_if_no_name!=undefined) {
            if (this.resolvedNOBJ.text!="") {
                if ($obj.alt_reln!=undefined) {
                    var x_relon = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, TYPE_BE, $obj.alt_reln, $obj.lookupval);
                    if (x_relon==null) {
                        this.addExtra($obj.alt_type, $obj.alt_reln, $obj.alt_to_type, $obj.lookupval);
                    }
                }
                $obj.to_s="";
                return;
            }
        }
        if (typeof $obj.lookupval === "string") {
            $obj.to_s = $obj.lookupval;
            this.printToBest("processed simple text", _GREEN, $obj.lookupval);
        }
        else {
            //$obj.id_name;
            if($obj.id_value!=undefined) {
                $obj.to_s = $obj.id_value;
                this.printToBest("processed simple text", _GREEN, $obj.to_s);
            }
        }
        $obj.processedBy="wikidata2.processSimpleText";
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     */
    processBirthname = async($obj, $propObj)=> {
        console.log($obj);
        if (this.resolvedNOBJ!=null && $obj.lookupval.toLowerCase().replaceAll("_"," ")!=this.resolvedNOBJ.text.toLowerCase()) {
            $obj.to_s=$obj.lookupval;
            this.printToBest("processed birthname", _GREEN, $obj.lookupval);
        }

        $obj.processedBy="wikidata2.processBirthname";
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processCountry = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processCountry";
        var bCOUNTRYONLY = true;
        return this.processLocation($obj, $propObj, bCOUNTRYONLY);
    }

    processState = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processState";
        var lookupval ="";
        if (typeof $obj.lookupval === "string") lookupval = $obj.lookupval;
        if (lookupval=="") return;
        var anne_loc_test = new anne_location();
        var stateNOBJ = await anne_loc_test.checkForRegionOrState(lookupval);
        if (stateNOBJ!=null) {
            $propObj.to_s = stateNOBJ.nid;
            this.printToBest("resolved context to state", _YELLOW, stateNOBJ.text);
        }
        return;
    }

    searchLinksForPage = function($links, $page){
        for (var l=0; l < $links.length; l++) {
            var link = $links[l];
            console.log(link);
            if (link.data.page==$page) return $page;
        }
        return "";
    }



    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processSiteOrLocation = async($obj, $propObj)=>{
        var lookupval ="";
        if (typeof $obj.lookupval === "string") lookupval = $obj.lookupval;
        else alert("processlocation")
        $obj.processedBy="wikidata2.processLocation";

        var parts = lookupval.split(",");
        
        //not exactly comprehensive... gotta be a more intelligent way.
        var siteClues = "monument statue building tower skyscraper bridge tunnel park mountain hill lake river stream creek";

        //WHAT IS THIS??????? LOLZ.. don't think i meant a double index of thingie here
        if (siteClues.indexOf(parts[0].toLowerCase().indexOf(lookupval.toLowerCase())!=-1)) {
            var site = parts.shift();
            console.log("site canddiate:"+site);

            var explore_text = this.searchLinksForPage($obj.prop_links, site);
            if (explore_text!="") {

                //go meta and get this site.  It is important enough if cited.
                var wke = new wikipediaExplore(explore_text, this.aec.trackerMap, this.printToBest);
                await wke.exploreFull(); 

                //need to find how to isolate on sites/buildings/geo/etc.  So--observe what this wikiexplore it.
                if (wke.explore_rez.wiki_type_conformed=="location") {
                                    
                    //we did not resolve or look it up.. did we?
                    if (wke._wiki && wke._wiki.resolvedNOBJ!=null) {
                        $obj.to_s = wke._wiki.resolvedNOBJ.nid;   
                    }
                    else if (wke.subtype=="site" || wke.subtype=="geosite") {
                        console.log("definitely a site/geosite within a location.");
                        var loc = parts.join(",");
                        if (wke.subtype=="site") this.processSite($obj, $propObj, site, loc, ANNE.MEM.site);
                        else this.processSite($obj, $propObj, site, loc, ANNE.MEM.geo_site);
                    }
                }
                else {
                    //uhhh what is this then? Lolz.
                    console.log(wke);
                    return null;
                }
            }

            else {
                if (lookupval.length>70) {
                    console.warn("SKIPPING THIS.. likely address "+lookupval);
                    return;
                }
                return await this.processLocation($obj, $propObj, false);
            }
            
            console.log("location candidate:"+parts.join(","));
        }

        //could be a likely site too here.
        else if (parts.length>3) {
            var site = parts.shift();
            console.log("site canddiate:"+site);
            console.log("location candidate:"+site.join(","));
        }
        else {
            return await this.processLocation($obj, $propObj, false);
        }
    }

    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @param {*} site 
     * @param {*} loc 
     * @param {*} ANNE 
     * @param {*} MEM 
     * @param {*} geo_site 
     */
    processSite=async($obj, $propObj, $site_str, $loc_str, $classNOBJ)=> {
        
        //potental drama if same site-name in multiple locations.
        //we would have verify the location we have for our site/geosite.
        var aMatches_pre = await ANNE.CHASE.nakedSearch($site_str, true, true, true);
        if (aMatches_pre.length>0) {
            for (var a=0; a < aMatches_pre.length; a++) {
                var locNOBJ = aMatches_pre[a];
                if (locNOBJ.is(ANNE.MEM.location)==true) {
                    $obj.to_s = locNOBJ.nid;
                    this.aec.mappedToExisting($site_str, locNOBJ, $classNOBJ);
                    return $propObj;
                }
            }
        }

        var anne_loc = new anne_location($loc_str);
        var bMAKEGHOSTIFNOTFOUND = true;
        anne_loc.setSiteStrAndClass($site_str, $classNOBJ);
        await anne_loc.processFull([], false, bMAKEGHOSTIFNOTFOUND);
        anne_loc.print();
        
        if (anne_loc.nObj!=null) {
            console.log(anne_loc.nObj);
            $obj.to_s = anne_loc.nObj.nid;
            if (anne_loc.nObj.bNEW==undefined || anne_loc.nObj.bNEW==false) {
                this.aec.mappedToExisting($site_str, anne_loc.nObj, $classNOBJ);
            }
            else {
                 this.printToBest("adding new "+$classNOBJ.text+" location", _BLUE, $site_str);
            }
            return $propObj;
        }
        else {
            this.printf(_RED, "trouble conceptualizing site/location",_GREEN, $loc_str+","+$site_str);
            return $propObj;
        }
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @param {*} $bCOUNTRYONLY 
     * @returns 
     */
    processLocation = async($obj, $propObj, $bCOUNTRYONLY=false)=> {
        var lookupval ="";
        if (typeof $obj.lookupval === "string") lookupval = $obj.lookupval;
        else alert("processlocation")
        $obj.processedBy="wikidata2.processLocation";

        var anne_loc = null;

        if ($propObj.process_as_array!=undefined) {
            alert("wikipedia has a process as array location.  fix this.");
            return;
        }

        //if no commas, just look up straighaway as-is.
        //{type: 'internal', page: 'Metropolitan Correctional Center, New York', raw: '[[Metropolitan Correctional Center, New York]]'}
        if ($obj.prop_links!=undefined && $obj.prop_links.length>0) {
            var link = $obj.prop_links[0];
            if (link.data && link.data.type=="internal" && link.data.page) {
                var obj = ANNE.UTILS.stripParens(link.data.page);

                //no commas in location string, just look it up as a single location name.
                if (obj.str.indexOf(",")==-1) {
                    var aMatches_pre = await ANNE.CHASE.nakedSearch(obj.str, true, true, true);
                    if (aMatches_pre.length>0) {
                        for (var a=0; a < aMatches_pre.length; a++) {
                            var locNOBJ = aMatches_pre[a];
                            if (locNOBJ.is(ANNE.MEM.location)==true) {
                                $obj.to_s = locNOBJ.nid;
                                this.aec.mappedToExisting(obj.str, locNOBJ, ANNE.MEM.location);
                                return $propObj;
                            }
                        }
                    }
                }
            }
        }


        var anne_loc = new anne_location(lookupval);
        var bMAKEGHOSTIFNOTFOUND = true;
        await anne_loc.processFull([],  $bCOUNTRYONLY, bMAKEGHOSTIFNOTFOUND);
        
        anne_loc.print();
        
        if (anne_loc.nObj!=null) {
            console.log(anne_loc.nObj);

            $obj.to_s = anne_loc.nObj.nid;

            //here we may be dealing with a dupe of lessor (or better) degree.
            //ie, if we already have birthplace = BRONX
            //and we get birithplace = NYC..
            //this is an inferior data point.  BRONX is contained within NYC.  Skip it.
            if (this.resolvedNOBJ!=null && $propObj.onlyOne!=undefined && $propObj.onlyOne==true) {
                var bISBEST = MEMZ.isBestLocation(this.resolvedNOBJ, $propObj.reln, $obj.to_s, anne_loc);
                if (bISBEST==false) {
                    $obj.to_s = ""; //skip this, we already have a better more refined location.
                }
            }
            if (anne_loc.nObj.bNEW==undefined || anne_loc.nObj.bNEW==false) {
                this.aec.mappedToExisting(lookupval, anne_loc.nObj, ANNE.MEM.location);
            }
            console.log("location %c "+$propObj.anne_prop_name+"%c"+anne_loc.nObj.text, TALK.bgyellow, TALK.bggreen);
            return $propObj;
        }
        else {
            console.log("location????? %c"+$obj, TALK.bgred);
            return $propObj;
        }
    }
    

    /**
     * We did a quick wiki lookup for type on some fields that can be different classes than the bulk.
     * ie, founder is usually a person, but sometimes a company or a governing body.
     * Reroute to the proper handler.
     * @param {*} $anne_type 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @param {*} $wiki_type 
     * @returns 
     */
    handleRerouteByType = async($anne_type, $obj, $propObj, $wiki_type="")=> {
        $obj.did_disambig_first = true;

        if ($anne_type=="person") {
            return await this.processPerson($obj, $propObj);
        }
        else if ($anne_type=="location") {
            return await this.processLocation($obj, $propObj);
        }
        else if ($anne_type=="company") {
            return await this.processCompany($obj, $propObj, $wiki_type);
        }
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @param {*} $companyType 
     * @returns 
     */
    processCompany = async($obj, $propObj, $companyType="")=> {
        var lookupval =$obj.lookupval;
        $obj.processedBy="wikidata2.processCompany";

        //we get a clue with $companyType from wiki (if we did a disambig pre)
        console.log($companyType);

        var highest_nObj = await this.aec.estimateClass(lookupval, ANNE.MEM.corp_entity_thetype);
        var GMOBJ = await MEMG.getOrMakeIfNewCorp(this.aec,lookupval, highest_nObj);
        var nObj = null;
        if (GMOBJ.status=="good") nObj = GMOBJ.match;
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches);
            return;
        }
        $obj.to_s = nObj.nid;
        return;
    }   


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @param {*} $companyType 
     * @returns 
     */
    processEducation = async($obj, $propObj, $companyType="")=> {
        var lookupval =$obj.lookupval;
        $obj.processedBy="wikidata2.processEducation";

        //we get a clue with $companyType from wiki (if we did a disambig pre)
        console.log($obj);
        console.log($companyType);

        var highest_nObj = await this.aec.estimateClass(lookupval, ANNE.MEM.corp_entity_thetype);
        var GMOBJ = await MEMG.getOrMakeIfNewCorp(this.aec,lookupval, highest_nObj);
        var nObj = null;
        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;
        }
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($jsonobj, GMOBJ.matches);
            return;
        }
        $obj.to_s = nObj.nid;
        return;
    }   


    processPerson2 = async($obj, $propObj)=> {
        var lookupval = $obj.name;
        $obj.processedBy="wikidata2.processPerson2";

        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;

        console.log("processPerson2:"+lookupval);
        
        //we need to do a get --- but then PAUSE to lookup type (in case it isn't a person)
        var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval, ANNE.MEM.wikipart.nid, TO_TYPE_STRING, $obj.wikipart);

        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;

            //for extra title (we will map it to TYPE_HAS occupation)
            if ($obj.person_desc!="" && $obj.person_desc.length<255) {
               var x_relon = MEMG.getRelonFromWithR(nObj.outs, TYPE_HAS, ANNE.MEM.description.temp_nid);
               if ($obj.extras==undefined) $obj.extras = [];
               $obj.extras.push({type:TYPE_HAS, reln:ANNE.MEM.description.nid, to_type:TO_TYPE_BLOB, to_s:$obj.person_desc});
               this.printToBest("adding person desc", _GREEN, $obj.person_desc);
            }

            //update...
            if ($obj.birth!="" || $obj.death!="") {
                var fireRels = [];
                var birthyrNOBJ = await MEMG.getOrMakeIfNewInteger(null, $obj.birth);
                if(birthyrNOBJ!=null){
                    $obj.addExtra(TYPE_BE, MEM.birthday.nid, TO_TYPE_ANNE, birthyrNOBJ.nid);
                }
                if ($obj.death!="") {
                    var deathyrNOBJ = await MEMG.getOrMakeIfNewInteger(null, $obj.death);
                    if(deathyrNOBJ!=null){
                        $obj.addExtra(TYPE_BE, MEM.birthday.nid, TO_TYPE_ANNE, deathyrNOBJ.nid);
                    }
                }
            }
        }
        
        //we can disambiguate on $obj.birth or  $obj.death
        else if (GMOBJ.status=="ambiguous") {
            var matches = ANNE.disambigOnRel(GMOBJ.matches, ANNE.MEM.wikipart.nid, $obj.wikipart);

            if (matches.length==1) {
                nObj = GMOBJ.match;
                this.printf(_CYAN, "AMBIG AUTO RESOLVED", _WHITE, "to", _YELLOW, nObj.text, _WHITE, "with", _GREEN, $obj.wikipart);
            }

            var autoDisambig = [];

            if ($obj.birth!="" || $obj.death!="") {
                var fireRels = [];
                var birthyrNOBJ = await MEMG.getOrMakeIfNewInteger(null, $obj.birth);
                if(birthyrNOBJ!=null){
                    fireRels.push({reln:MEM.birthday.nid, to_s:birthyrNOBJ.nid});
                }
                if ($obj.death!="") {
                    var deathyrNOBJ = await MEMG.getOrMakeIfNewInteger(null, $obj.death);
                    if(deathyrNOBJ!=null){
                        fireRels.push({reln:MEM.birthday.nid, to_s:deathyrNOBJ.nid});
                    }
                }

                //TODO, a big lift, but will be quite useful.
                //autoDisambig = ANNE.autoDisambig(GMOBJ.matches, fireRels, $obj.context);

                if (autoDisambig.length==1) {
                    nObj = GMOBJ.match;
                    this.printf(_CYAN, "AMBIG AUTO RESOLVED", _WHITE, "to", _YELLOW, nObj.text);

                    //for extra title (we will map it to TYPE_HAS occupation)
                    if ($obj.person_desc!="" && $obj.person_desc.length<255) {
                        var x_relon = MEMG.getRelonFromWithR(nObj.outs, TYPE_HAS, ANNE.MEM.description.temp_nid);
                        if ($obj.extras==undefined) $obj.extras = [];
                        $obj.extras.push({type:TYPE_HAS, reln:ANNE.MEM.description.nid, to_type:TO_TYPE_BLOB, to_s:$obj.person_desc});
                        this.printToBest("adding person desc", _GREEN, $obj.person_desc);
                    }        
                }
                else {
                    this.printf(_CYAN, "could not auto disambig.");
                }
            }

            //no help.
            if (nObj==null) this.addAmbiguous($obj, GMOBJ.matches);
        }


        //push the nifty wikipart we know to be true.
        if (nObj!=null && $obj.wikipart!=undefined && $obj.wikipart.length>0) {
            var wikirel = MEMG.getSysRelon(nObj.outs, ANNE.MEM.wikipart.temp_nid);
            if (wikirel==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_SYS, nObj, ANNE.MEM.wikipart.nid, TO_TYPE_STRING, $obj.wikipart);
            }
        }
        
        //this relon can now be mapped to the existing/new thing we are processing.
        if (nObj!=null) {
            $obj.to_s = nObj.nid;

            //if we have an alt temp relon, make it.  We do not want to broadcast this.
            //our GHOSTDATA is instructed to delete it upon submission.
            //it is helpful to "see" as L1 protocol will be creating this relon for us.
            //ie,  PERSON->[has]->LAST NAME-> (to: the last name)
            if ($propObj.makeTempRelons!=null && this.resolvedNOBJ!=null) {
                for (var t=0; t < $propObj.makeTempRelons.length; t++) {
                    var ttype = $propObj.makeTempRelons[t].type;
                    var treln = $propObj.makeTempRelons[t].reln;
                    var tto_s = this.resolvedNOBJ.nid;
                    var x_relon = MEMG.getRelonFromWithTo(nObj.outs, ttype, treln, tto_s);
                    if (x_relon==null) {
                        var temp_ghost = MEM.makeTempRelon(nObj, ttype, treln, TO_TYPE_ANNE, tto_s, true);    
                        this._temp_only_ghosts.push(temp_ghost);
                    }
                }
            }
        }
        
        return nObj;
    }


    /**
     * In this syntax, we are extracting a partial service term
     * from KEY_PERSONS in wikipedia.
     * We have the actor, theme thing and theme thing mod..
     * ie, president of paypal...
     * We do not have the start date/end date as this is intended to be wikipedias 
     * quick syntax to indicate they are active.
     * 
     * We can investigate if the parse of the actual person will yield the actual service term
     * start date.
     * 
     * [ROLE_ACTOR] person
     * [ROLE_THEME_THING] TITLE/POSITION
     * [ROLE_THEME_THING_MOD] company/thing/nation TITLE/POSITION applies to.
     * (CEO of Twitter)
     */
    serviceTermSpecial=async($companyNOBJ, $personNOBJ, $title, $specialPropObj=null)=>{
        var STR = new wiki_clump_neuron(ANNE.UTILS.randHex(3), this.aec);
        console.log("service term special for company:"+$companyNOBJ.text+" for person:"+$personNOBJ.text+" title:"+$title);
        STR.setActor($personNOBJ);          //person who is the CEO
        STR.setThemeThingMod($companyNOBJ);    //CEO of [TWITTER] (this is TWITTER)
            
        if (typeof $title === "string") {
            var matches = await this.findOrAddNew({lookupval:$title}, ANNE.MEM.ec_thing, NTYPE_CLASS, $specialPropObj, [ANNE.MEM.ec_nonliving, ANNE.MEM.ec_living]);

            //var x_relon = MEMG.getRelonFromWithTo(inner_valNOBJ.outs, TYPE_HAS, ANNE.MEM.occupation.nid, inner_valNOBJ.nid);
            //if (x_relon==null) await GHOSTDATA.makeGhostRelon(TYPE_HAS, nObj, ANNE.MEM.occupation.nid, TO_TYPE_ANNE, inner_valNOBJ.nid);
             if (matches.length) {
                var inner_valNOBJ = matches[0];
                STR.setThemeThing(inner_valNOBJ);
            }
        }
        else {
            for (var t=0; t < $title.length; t++) {
                var matches = await this.findOrAddNew({lookupval:$title[t]}, ANNE.MEM.ec_thing, NTYPE_CLASS, $specialPropObj, [ANNE.MEM.ec_nonliving, ANNE.MEM.ec_living]);
                //var x_relon = MEMG.getRelonFromWithTo(inner_valNOBJ.outs, TYPE_BE, ANNE.MEM.ec_is, ANNE.MEM.occupation.nid);
                //if (x_relon==null) await GHOSTDATA.makeGhostRelon(TYPE_BE, inner_valNOBJ, ANNE.MEM.ec_is.nid, TO_TYPE_ANNE, ANNE.MEM.occupation.nid);
                if (matches.length) {
                    var inner_valNOBJ = matches[0];
                    STR.setThemeThing(inner_valNOBJ);
                }
            }
        }

        //override the default search here -- as we want to look from the personNOBJ not this company.
        var serviceTermNOBJ = await this.findServiceTerm(STR, null, {from_nid:$personNOBJ.nid, reln:ANNE.MEM.service_term.nid, backup_in_reln:ANNE.MEM.role_actor.nid});
        if (serviceTermNOBJ==null) {
            serviceTermNOBJ = await STR.makeServiceTermNeuron();
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, $personNOBJ, ANNE.MEM.service_term.nid, TO_TYPE_ANNE, serviceTermNOBJ.nid);
            return;
        }

        else {
            this.printToBest("resolved service term neuron to existing", _YELLOW, serviceTermNOBJ.text);
            const THIS = this;
            var x_relon = MEMG.getRelonFromWithTo($personNOBJ.outs, TYPE_HAS, ANNE.MEM.service_term.nid, ANNE.MEM.occupation.nid);
            if (x_relon==null) await GHOSTDATA.makeGhostRelon(TYPE_HAS, $personNOBJ, ANNE.MEM.service_term.nid, TO_TYPE_ANNE, serviceTermNOBJ.nid);
            await STR.updateGenericMax(serviceTermNOBJ, THIS);
        }

        return;
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processSpouse = async($obj, $propObj)=> {
        this.printToBest(_CYAN, "reroute spouse", _GREEN, $obj.lookupval);
        var md = WIKIDATA.marriageDivorceExtraction($obj.context);
        
        //if we have a married/divorced we should make a marriage clump.
        //ROLE_START = married,
        //ROLE_END = divorced,
        //ROLE_ACTION = married
        //ROLE_ACTOR = resolvedNOBJ 
        //ROLE_ACTOR = this person.
        //(this produces the semantic sentance: "bob and suze married on X [and divrced on Y]");
        $obj.married = md.married;
        $obj.divorced = md.divorced;

        //get existing spouses known.  Either fire those heavy and rely upon fire to resolve,
        //or pass them to the processPerson as a hint/clue... 

        var spouseNOBJS = this.resolvedNOBJ.getSpouses();

        var personNOBJ = await this.processPerson($obj, $propObj, spouseNOBJS);
        if (personNOBJ!=null) {
            var wcn = new wiki_clump_neuron( ANNE.UTILS.randHex(3), this.aec);
            if ($obj.married!=null) await wcn.setTermStartManual($obj.married);
            if ($obj.divorced!=null) await wcn.setTermEndManual($obj.divorced);
            await wcn.setActor(this.resolvedNOBJ);
            await wcn.setActor(personNOBJ);
            if ($obj.location!=undefined && $obj.location!=null) await wcn.setLocation($obj.location);

            //now we have a proper clump, look it up to see if we already have this.
            var marriageNOBJ = await this.findMarryNeuron(wcn);
            if (marriageNOBJ==null) {
                marriageNOBJ = await wcn.makeMarryNeuron();
                this.printToBest("added new marriage neuron", _BLUE, marriageNOBJ.text);
            }

            //we may have extracted some new infos (end dates, filled in missing gaps.. etc)
            else {
                this.printToBest("resolved marry neuron to existing", _YELLOW, marriageNOBJ.text);
                const THIS = this;
                await wcn.updateGenericMax(marriageNOBJ, THIS);
            }

            //make the tie we need if we don't have it.
            //this is for the spouse neuron..
            $obj.addExtra(TYPE_HAS, ANNE.MEM.marriage.nid, TO_TYPE_ANNE, marriageNOBJ.nid);
            
            //also make the tie if this neuron doesn't have it yet.
            this.addExtra(TYPE_HAS, ANNE.MEM.marriage.nid, TO_TYPE_ANNE, marriageNOBJ.nid);
        }

    }


    addExtraIfUnique = async($type, $reln, $to_type, $to_s, $bMIRRORDUAL=false)=> {
        var x_relon = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, $type, $reln, $to_s);
        if (x_relon==null) {
            await GHOSTDATA.makeGhostRelon($type, this.resolvedNOBJ, $reln, $to_type, $to_s); 
            this._new_external_data+=1;
        }
        
        if ($bMIRRORDUAL==false) return;

        var toNOBJ = ANNE.MEMG.getNeuronByNid($to_s);
        if (toNOBJ==null) return;
        
        var x_relon = MEMG.getRelonFromWithTo(toNOBJ.outs, $type, $reln, this.resolvedNOBJ.nid);
        if (x_relon==null) {
            await GHOSTDATA.makeGhostRelon($type, toNOBJ, $reln, $to_type, this.resolvedNOBJ.nid); 
        }
    }
    
    processFather = async($obj, $propObj)=>{
        this.printToBest(_CYAN, "reroute Father", _GREEN, $obj.lookupval);
        var relativeNOBJ = await this.processPerson($obj, this.pFather);
        var x_relon = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.nid, ANNE.MEM.male.nid);
        if (x_relon==null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, ANNE.MEM.gender, TO_TYPE_ANNE, ANNE.MEM.male.nid);
        }
    }
    processMother = async($obj, $propObj)=>{
        this.printToBest(_CYAN, "reroute Mother", _GREEN, $obj.lookupval);
        var relativeNOBJ = await this.processPerson($obj, $propObj);
        var x_relon = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.nid, ANNE.MEM.female.nid);
        if (x_relon==null) {
            await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, ANNE.MEM.gender, TO_TYPE_ANNE, ANNE.MEM.female.nid);
        }
    }

    processParent = async($obj, $propObj)=>{
        this.printToBest(_CYAN, "reroute parent", _GREEN, $obj.lookupval);

        //first is father, second is mother (in most wiki cases)
        if ($obj.resolve_obj_override!=undefined && $obj.overrideProp!=undefined) {
            var overrideProp = $obj.overrideProp;
            return $obj.resolve_obj_override($obj, overrideProp);
        }

        await this.processPerson($obj, $propObj);
    }
    
    //kinfolk_cousin
    //NO RELNS MADE AUTO FROM RELATIES.
    //MUST USE extras functionality here.
    processRelatives = async($obj, $propObj)=> {
        this.printToBest(_CYAN, "reroute relative", _GREEN, $obj.lookupval);
        var relativeNOBJ = await this.processPerson($obj, $propObj);

        if (relativeNOBJ==null) return;

        var relation = $obj.context2;
        if (relation==undefined || relation==null || relation.length==0) return;
        

        //build this out as needed.. 
        if (relation=="brother") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.brother.nid, TO_TYPE_ANNE, relativeNOBJ.nid, false);

            //can't make dual unless we know gender.  Can make simple sibbling tho.
            var x_relon = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, MEM.kinfolk_sibbling.nid, this.resolvedNOBJ.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, MEM.kinfolk_sibbling.nid, TO_TYPE_ANNE, this.resolvedNOBJ.nid); 
            }
            var x_relon2 = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.nid, ANNE.MEM.male.nid);
            if (x_relon2==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, ANNE.MEM.gender, TO_TYPE_ANNE, ANNE.MEM.male.nid);
            }
        }

        else if (relation=="sister") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.sister.nid, TO_TYPE_ANNE, relativeNOBJ.nid, false);

            //can't make dual unless we know gender.  Can make simple sibbling tho.
            var x_relon = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, MEM.kinfolk_sibbling.nid, this.resolvedNOBJ.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, MEM.kinfolk_sibbling.nid, TO_TYPE_ANNE, this.resolvedNOBJ.nid); 
            }
            var x_relon2 = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.nid, ANNE.MEM.female.nid);
            if (x_relon2==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, ANNE.MEM.gender, TO_TYPE_ANNE, ANNE.MEM.female.nid);
            }
        }

        else if (relation=="father") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.father.nid, TO_TYPE_ANNE, relativeNOBJ.nid, false);

            //can't make dual unless we know gender.  Can make simple kinfolk child tho.
            var x_relon = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, MEM.kinfolk_child.nid, this.resolvedNOBJ.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, MEM.kinfolk_child.nid, TO_TYPE_ANNE, this.resolvedNOBJ.nid); 
            }
            var x_relon2 = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.nid, ANNE.MEM.male.nid);
            if (x_relon2==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, ANNE.MEM.gender, TO_TYPE_ANNE, ANNE.MEM.male.nid);
            }
        }

        else if (relation=="mother") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.mother.nid, TO_TYPE_ANNE, relativeNOBJ.nid, false);

            //can't make dual unless we know gender.  Can make simple child tho tho.
            var x_relon = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, MEM.kinfolk_child.nid, this.resolvedNOBJ.nid);
            if (x_relon==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, MEM.kinfolk_child.nid, TO_TYPE_ANNE, this.resolvedNOBJ.nid); 
            }
            var x_relon2 = MEMG.getRelonFromWithTo(relativeNOBJ.outs, TYPE_HAS, ANNE.MEM.gender.nid, ANNE.MEM.female.nid);
            if (x_relon2==null) {
                await GHOSTDATA.makeGhostRelon(TYPE_HAS, relativeNOBJ, ANNE.MEM.gender, TO_TYPE_ANNE, ANNE.MEM.female.nid);
            }
        }

        //dual safe here both ways.
        else if (relation=="cousin") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.kinfolk_cousin.nid, TO_TYPE_ANNE, relativeNOBJ.nid, true);
        }

        else if (relation=="grandmother") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.grandmother.nid, TO_TYPE_ANNE, relativeNOBJ.nid, true);
        }

        else if (relation=="grandfather") {
            await this.addExtraIfUnique(TYPE_HAS, ANNE.MEM.grandfather.nid, TO_TYPE_ANNE, relativeNOBJ.nid, true);
        }

        else {
            alert("unhandled processRelatives relation!");
        }
    }



    //"Insta-Burger King: Keith G. Kramer and Matthew Burns Burger King: David Edgerton and James McLamore"
    processFounder = async($obj, $propObj)=>{
        var lookupval ="";
        $obj.processedBy="wikidata2.processFounder";

        if ($propObj.disambig_first!=undefined && $obj.did_disambig_first==undefined) {
            var statusObj = await ANNE.WIKIDATA.exploreType(lookupval, this.aec);
            if (statusObj.status=="good") {
                var wiki_type = statusObj.type;
                if (wiki_type!="person") {
                    console.log(wiki_type);
                    alert("we have non-person founder!!");
                }
                var anne_type = statusObj.wiki_type_conformed;
                var rez = await this.handleRerouteByType(anne_type, $obj, $propObj, wiki_type);
                console.log(rez);
                return;
            }
        }

        var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;
        }
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($obj, GMOBJ.matches);
            return null;
        }
        $obj.to_s = nObj.nid;
        return nObj;
    }



    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processCorpFounders = async($obj, $propObj)=> {
        var lookupval ="";
        $obj.processedBy="wikidata2.processCorpFounders";

        if (typeof $obj.lookupval === "string") {
            lookupval = $obj.lookupval;
        }
        else {
            if ($obj.person!=undefined) lookupval = $obj.person;
        }
    
        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;

        var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;
            //for extra title (we will map it to TYPE_HAS occupation)
            if ($obj.title!=undefined) {
                if ($propObj.make_service_term!=undefined) {
                    if (nObj.ghost==false) {
                        const NID = nObj.nid;
                        await ANNE.IDB.lookupNid(null, NID);
                    }
                    await this.serviceTermSpecial(this.resolvedNOBJ, nObj, $obj.title, $propObj.special_prop_obj);
                }
            }
        }
        
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($obj, GMOBJ.matches);
            return null;
        }

        //this relon can now be mapped to the existing/new thing we are processing.
        $obj.to_s = nObj.nid;
        return nObj;
    }

    

    /**
     * Proess the person.
     * Sometimes the names differ slightly but are the same person.
     * This is permissable if we are mapping to known clues..
     * eg, we know bill had 3 wives. and we know their names...
     * if we get a new wife name here that is very similar to one we have, we are taking the one we have.
     * @param {*} $obj 
     * @param {*} $propObj 
     * @param {array} $clueNOBJS - if this is looking up spouses, and we already know spouses, we have clues
     * @returns 
     */
    processPerson = async($obj, $propObj, $clueNOBJS=[])=> {
        var lookupval ="";
        $obj.processedBy="wikidata2.processPerson";

        if (typeof $obj.lookupval === "string") {
            lookupval = $obj.lookupval;
        }
        else {
            if ($obj.person!=undefined) lookupval = $obj.person;
        }
    
        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;
        //:nObj, :sim
        var GMOBJ = null;
        var highestSim = null;
        if ($clueNOBJS.length) {
            highestSim = ANNE.UTILS.getHighestSimilarity($clueNOBJS);
        }
        if (highestSim > 0.8) {
            GMOBJ = {status:"good", match:highestSim.nObj};
        }
        else GMOBJ = await ANNE.MEMG.getOrMakeIfNewPerson(this.aec, lookupval);

        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;

            //for extra title (we will map it to TYPE_HAS occupation)
            if ($obj.title!=undefined) {
                if ($propObj.make_service_term!=undefined) {
                    if (nObj.ghost==false) {
                        const NID = nObj.nid;
                        await ANNE.IDB.lookupNid(null, NID);
                    }
                    await this.serviceTermSpecial(this.resolvedNOBJ, nObj, $obj.title, $propObj.special_prop_obj);
                }
            }
        }
        
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($obj, GMOBJ.matches);
            return null;
        }

        //this relon can now be mapped to the existing/new thing we are processing.
        $obj.to_s = nObj.nid;
        return nObj;
    }
    
    

    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processPersonWithTitle = async($obj, $propObj)=> {
        var lookupval ="";
        $obj.processedBy="wikidata2.processPersonWithTitle";

        if (typeof $obj.lookupval === "string") {
            lookupval = $obj.lookupval;
        }
        else {
            if ($obj.person!=undefined) lookupval = $obj.person;
        }
    
        //we probably want a last name, first name search..
        //so we can find people even if they don't have a supplied alias ?
        var nObj = null;
        
        var GMOBJ = await MEMG.getOrMakeIfNewPerson(this.aec, lookupval);
        if (GMOBJ.status=="good") {
            nObj = GMOBJ.match;

            //for extra title (we will map it to TYPE_HAS occupation)
            if ($obj.title!=undefined && $obj.title!=null && $obj.title.length>0) {
                if ($propObj.make_service_term!=undefined) {
                    if (nObj.ghost==false) {
                        const NID = nObj.nid;
                        await ANNE.IDB.lookupNid(null, NID);
                    }
                    var titles = null;
                    if (Array.isArray($obj.title)==false) {
                        titles = ANNE.UTILS.blowOutAmpersands([$obj.title]);
                    }
                    else titles = ANNE.UTILS.blowOutAmpersands($obj.title);
                    
                    await this.serviceTermSpecial(this.resolvedNOBJ, nObj, titles, $propObj.special_prop_obj);
                }
            }
        }
        
        else if (GMOBJ.status=="ambiguous") {
            this.addAmbiguous($obj, GMOBJ.matches);
            return;
        }

        //this relon can now be mapped to the existing/new thing we are processing.
        $obj.to_s = nObj.nid;
        return nObj;
    }
    


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processLivingThing = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processLivingThing";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_living, NTYPE_CLASS, $propObj);
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     * @returns 
     */
    processNonLivingThing = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processNonLivingThing";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_nonliving, NTYPE_CLASS, $propObj);
    }

    processDivision = async($obj, $propObj)=> {
        $obj.processedBy="wikidata2.processDivision";
        return await this.findOrAddNew($obj, ANNE.MEM.ec_nonliving, NTYPE_CLASS, $propObj);
    }


    /**
     * 
     * @param {wiki_clump_neuron} $STR 
     * @param {field_mapper} $propObj 
     */
    processServiceTerm = async($STR, $propObj) =>{
        $STR.processedBy="wikidata2.processServiceTerm";
        console.log($STR);
        console.log($propObj);

        //set our actor in the clump.
        $STR.setActor(this.resolvedNOBJ);

        //var newThemeNOBJ = 
        //let's make them living -- these will be an office.. like president etc..
        //go generic thing here -- and abandon the ec_living ec_nonliving confusion.
        //damn willy wonka.. should have classified them all as things.
        await $STR.resolveOrMakeThemeAndAT(MEM.ec_thing, [MEM.ec_thing.nid, MEM.ec_nonliving.nid, MEM.ec_living.nid]);  
        
        //findOrAddNew term.
        var serviceTermNOBJ = null;

        var bDOINGTARGET  = false;
        //if this was a new person, we don't need to search for the service term.
        if (this.bNEW==false) {
            if ($propObj.targets!=undefined && $propObj.targets.actual_nOBJ!=undefined) {
                console.log("we have a targeted query here...only looking for a specific service term!!!!");
                bDOINGTARGET = true;
                //save time.. we already found what we came for.
                if ($propObj.targets.only_one==true && $propObj.targets.found==true) {
                    return;
                }
                serviceTermNOBJ = await this.findServiceTerm($STR, $propObj.targets.actual_nOBJ);
                
            }
            else {
                serviceTermNOBJ = await this.findServiceTerm($STR);
            }
        }
        
        //make the serviceTermNOBJ new if we couldn't find it.
        if (serviceTermNOBJ==null) {

            //not our service term.. ignore it.
            if (bDOINGTARGET==true) return; 

            serviceTermNOBJ = await $STR.makeServiceTermNeuron();
            this.printToBest("added new service term neuron", _BLUE, serviceTermNOBJ.text);
        }

        //we may have extracted some new infos (end dates, filled in missing gaps.. etc)
        else {
            this.printToBest("resolved service term neuron to existing", _YELLOW, serviceTermNOBJ.text);
            const THIS = this;
            if ($propObj.targets!=undefined && $propObj.targets.only_one==true) {
                $propObj.targets.found=true;
            }
            await $STR.updateGenericMax(serviceTermNOBJ, THIS);
        }

        //set the main object to the service term
        //this will make relon from person->service term-> the actual inst of service term.
        $STR.nObj = serviceTermNOBJ;
    }

    
    /**
     * 
     * @param {wiki_clump_neuron} $WCN 
     */
    findMarryNeuron=async($WCN)=>{
        var nObjs = [];
        var extras_if_no_contradicts = [];
        var contradicts = 0;

        //default case of service term is just a simple service term
        //connected to a person.
        //in complicated cases we are nested, and the resolvedNOBJ is a corp (or something else)
        //and the service term isn't necessarily connecting from the corp (for resolution)
        var defaultReln = ANNE.MEM.marriage.nid;
        var defaultFromNid = null;
        var defaultFromNOBJ = null;
        if (this.resolvedNOBJ!=null) {
            defaultFromNid=this.resolvedNOBJ.nid;
            defaultFromNOBJ = this.resolvedNOBJ;
        }


        //if any of the actors in the marriage are ghosts.. 
        //then this neuron cannot yet be on-chain.
        var bATLEASTONEGHOST = false;
        var nids = [];
        for (var r=0; r < $WCN.ROLE_ACTORS.length; r++) {
            var actorNOBJ = $WCN.ROLE_ACTORS[r];
            if (actorNOBJ.ghost==true) {
                nids=[];
                bATLEASTONEGHOST=true;
                break;
            }
        }
        if (defaultFromNOBJ!=null) {
            if (bATLEASTONEGHOST==false && nids.length>0) {
                nObjs = await ANNE.API.getAllToNeuronRelonsGeneric2(nids, defaultReln);
                this.bGOT_TOP_MARRY_NEURONS = true;
            }
    
            //lookup ghost mem. (for real we pull from anne EVERY TIME to be sure.)
            else {
                var rels = ANNE.MEMG.getRelonsFromWith(defaultFromNOBJ.outs, null, defaultReln);
                if (rels.length) {
                    nObjs = MEMG.getToNObjsFromRelon(rels);
                }
            }
        }
        
        var testn2 = $WCN.setGenericMarryText(true);

        //possible marriages involving this
        for (var n=0; n < nObjs.length; n++) {
            extras_if_no_contradicts = [];
            
            var NOBJ = nObjs[n];
            
            await NOBJ.processAsClumpNeuron();

            //look for STR matches matches.
            if ($WCN.ROLE_ACTORS.length>0) {
                for (var a=0; a < $WCN.ROLE_ACTORS.length; a++) {
                    var actorNOBJ = $WCN.ROLE_ACTORS[a]; 
                    var test = NOBJ.hasRole("role_actor", actorNOBJ.nid);
                    if (test==-1) {
                        contradicts+=1;
                        continue;
                    }
                    else if (test==0) {
                        console.log(NOBJ.nid+" doesn't have role_actor????");
                        var audit= MEMG.getRoleRelon(NOBJ.outs, ANNE.MEM.role_actor.temp_nid);
                        if (audit!=null) {
                            if (audit.to_s==actorNOBJ.nid) {
                                alert("JENKY ASS");    
                            }
                        }
                        else if (contradicts==0) {
                            var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_actor.nid, to_type:TO_TYPE_ANNE, to_s:actorNOBJ.nid};
                            extras_if_no_contradicts.push(einc);
                        }
                    }
                }
                
            }

            if ($WCN.ROLE_START!=null) {
                var test = await NOBJ.hasTimeRoleNoContradict("role_start", $WCN.ROLE_START.nid);
                if (test==-1) {
                    contradicts+=1;
                    continue; //mismatch
                }
                //better (more detailed) non-contradicting info.
                else if(test==2) {
                    console.log("better info");
                }
                else if (test==0) { //not present
                    //extract from name (maybe there is no role_start in the clump)
                    var numbNOBJ = await ANNE.UTILS.extractNumber( NOBJ.text);
                    //if (numbNOBJ==null) continue;
                    
                    if (numbNOBJ!=null && numbNOBJ.nid!=$WCN.ROLE_START.nid) {
                        if (ANNE.UTILS.isSameYear(numbNOBJ, $WCN.ROLE_START)==false) {
                            continue;
                        }
                    }

                    //if the role we parsed is a better date (against just a year int..)
                    //update with the date 
                    if ($WCN.ROLE_START.bes.indexOf(ANNE.MEM.date_gregorian.temp_nid)!=-1) {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_start.nid, to_type:TO_TYPE_ANNE, to_s:$WCN.ROLE_START.nid};
                        extras_if_no_contradicts.push(einc);
                    }

                    //otherwise update with the yr we extracted from the title.
                    else {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_start.nid, to_type:TO_TYPE_ANNE, to_s:numbNOBJ.nid};
                        extras_if_no_contradicts.push(einc);
                    }
                }
            }

            //we have info that is contradictory. 
            //we cannot use this neuron;
            if (extras_if_no_contradicts.length && contradicts>0) {
                continue;
            }

            console.log("found matching clump by ACTOR, THEME, START.");
            $WCN.nObj = NOBJ;//map our STR to this matching term neuron.  They are one.
            return NOBJ;
        }

        return null;
    }


    /**
     * 
     * @param {wiki_clump_neuron} $STR 
     */
    findServiceTerm=async($STR, $KnownNObj=null, $overrides=null)=>{
        var nObjs = [];
        var extras_if_no_contradicts = [];
        
        //default case of service term is just a simple service term
        //connected to a person.
        //in complicated cases we are nested, and the resolvedNOBJ is a corp (or something else)
        //and the service term isn't necessarily connecting from the corp (for resolution)
        var defaultReln = ANNE.MEM.service_term.nid;
        var defaultFromNid = null;
        var defaultFromNOBJ = null;
        if (this.resolvedNOBJ!=null) {
            defaultFromNid=this.resolvedNOBJ.nid;
            defaultFromNOBJ = this.resolvedNOBJ;
        }

        if ($overrides!=null) {
            if ($overrides.reln!=null) defaultReln = $overrides.reln;  //this is the connecting relon we expect to link to this clump with.
            if ($overrides.from_nid!=null) {
                defaultFromNid = $overrides.from_nid;
                defaultFromNOBJ = ANNE.MEMG.getNeuronByNid($overrides.from_nid);
            }
        }

        //pull all known service terms for this thign, once.
        if (defaultFromNOBJ!=null && this.bGOT_TOP_SERVICE_TERMS==false) {
            nObjs = await ANNE.API.getAllToNeuronRelonsGeneric(defaultFromNid, defaultReln);
            this.bGOT_TOP_SERVICE_TERMS = true;
        }
        

        if (defaultFromNOBJ!=null) {
            //resolve the serice term if we already have it.
            if ($KnownNObj==null) {

                //if we had zero from the api we shouldn't be getting any here.
                if (nObjs.length==0) {
                    nObjs = await ANNE.MEMG.getToNObjsByReln(defaultFromNOBJ, defaultReln);
                }
            }
            else nObjs = [$KnownNObj]; //test the one we know we want to test.
        }

        if (nObjs.length==0 && $overrides!=null && $overrides.backup_in_reln!=undefined) {
            nObjs = await ANNE.API.getAllFromNeuronRelonsGeneric($overrides.backup_in_reln, defaultFromNOBJ.nid);
        }


        
        var testn2 = null;
        if ($KnownNObj!=null) {
            testn2 = $STR.setGenericText(true);
        }

        for (var n=0; n < nObjs.length; n++) {
            var contradicts = 0;
            extras_if_no_contradicts = [];
            
            var NOBJ = nObjs[n];

            //prevent false matches.
            if ($KnownNObj!=null) {
                var sim = ANNE.UTILS.similarity( NOBJ.text, testn2);
                if (sim < .85) {
                    continue;
                }
            }

            await NOBJ.processAsClumpNeuron();

            //look for STR matches matches.
            for (var a=0; a < $STR.ROLE_ACTORS.length; a++) {
                var actorNOBJ = $STR.ROLE_ACTORS[a]; 
                var test = NOBJ.hasRole("role_actor", actorNOBJ.nid);
                if (test==-1) {
                    contradicts+=1;
                    continue;
                }
                else if (test==0) {
                    console.log(NOBJ.nid+" doesn't have role_actor????");
                    var audit= MEMG.getRoleRelon(NOBJ.outs, ANNE.MEM.role_actor.temp_nid);
                    if (audit!=null) {
                        if (audit.to_s==actorNOBJ.nid) {
                            alert("JENKY ASS");    
                        }
                    }
                    else if (contradicts==0) {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_actor.nid, to_type:TO_TYPE_ANNE, to_s:actorNOBJ.nid};
                        extras_if_no_contradicts.push(einc);
                    }
                }
            }

            if ($STR.ROLE_START!=null) {
                var test = await NOBJ.hasTimeRoleNoContradict("role_start", $STR.ROLE_START.nid);
                if (test==-1) {
                    contradicts+=1;
                    continue; //mismatch
                }
                else if(test==2) {
                    console.log("better info");
                    continue;
                }
                else if (test==0) { //not present
                    //extract from name (maybe there is no role_start in the clump)
                    var numbNOBJ = await ANNE.UTILS.extractNumber( NOBJ.text);
                    //if (numbNOBJ==null) continue;
                    
                    if (numbNOBJ!=null && numbNOBJ.nid!=$STR.ROLE_START.nid) {
                        if (ANNE.UTILS.isSameYear(numbNOBJ, $STR.ROLE_START)==false) {
                            continue;
                        }
                    }

                    //if the role we parsed is a better date (against just a year int..)
                    //update with the date 
                    if ($STR.ROLE_START.bes.indexOf(ANNE.MEM.date_gregorian.temp_nid)!=-1) {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_start.nid, to_type:TO_TYPE_ANNE, to_s:$STR.ROLE_START.nid};
                        extras_if_no_contradicts.push(einc);
                    }

                    //otherwise update with the yr we extracted from the title.
                    else {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_start.nid, to_type:TO_TYPE_ANNE, to_s:numbNOBJ.nid};
                        extras_if_no_contradicts.push(einc);
                    }
                }
            }

            if ($STR.ROLE_THEME_THINGS!=null) {
                var bCONTRA = false;
                for (var tt=0; tt < $STR.ROLE_THEME_THINGS.length; tt++) {
                    var roleNOBJ = $STR.ROLE_THEME_THINGS[tt];
                    if (roleNOBJ==undefined || roleNOBJ==null) {
                        console.log("fix this smokey");
                        continue;
                    }
                    var test =NOBJ.hasRole("role_theme_thing", roleNOBJ.nid);
                    if (test==-1) {
                        contradicts+=1;
                        bCONTRA=true;
                        break;
                    }
                    else if (test==0) {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_theme_thing.nid, to_type:TO_TYPE_ANNE, to_s:roleNOBJ.nid};
                        extras_if_no_contradicts.push(einc);
                    }
                }
                if (bCONTRA==true) {
                    continue;
                }
            }

            //-1, role, but no match.
            // 0, no role
            // 1, match.
            if ($STR.ROLE_THEME_THINGS_MOD!=null && $STR.ROLE_THEME_THINGS_MOD.length>0) {
                var bCONTRA = false;
                for(var ttm=0; ttm < $STR.ROLE_THEME_THINGS_MOD.length; ttm++) {
                    var test =NOBJ.hasRole("role_theme_thing_mod", $STR.ROLE_THEME_THINGS_MOD[ttm].nid);
                    if (test==-1) {
                        contradicts+=1;
                        bCONTRA=true;
                        break;
                    }
    
                    //new data that doesn't contradict.
                    else if (test==0) {
                        var einc = {type:TYPE_ROLE, reln:ANNE.MEM.role_theme_thing_mod.nid, to_type:TO_TYPE_ANNE, to_s:$STR.ROLE_THEME_THINGS_MOD[ttm].nid};
                        extras_if_no_contradicts.push(einc);
                    }
                }
                if (bCONTRA==true) {
                    continue;
                }
            }

            //we have info that is contradictory. 
            //we cannot use this neuron;
            if (extras_if_no_contradicts.length && contradicts>0) {
                continue;
            }

            console.log("found matching clump by ACTOR, THEME, START.");
            $STR.nObj = NOBJ;//map our STR to this matching term neuron.  They are one.
            return NOBJ;
        }

        return null;
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $propObj 
     */
    processEthnicHeritage = async($obj, $propObj)=>{
        $obj.processedBy="wikidata2.processEthnicHeritage";
        
        var lookupval = $obj.lookupval;
        var classNOBJ = ANNE.MEM.ethnicity;
        var matches = await ANNE.CIRCUIT.searchToResolve(lookupval, classNOBJ);
        if (matches.length==0) {
            classNOBJ = ANNE.MEM.religion;
            matches = await ANNE.CIRCUIT.searchToResolve(lookupval, classNOBJ);
        }
        if (matches.length==0) {
            classNOBJ = ANNE.MEM.nationality;
            matches = await ANNE.CIRCUIT.searchToResolve(lookupval, classNOBJ);
        }

        if (matches.length==1) {
            $obj.to_s = matches[0].nid;
            this.printToBest("found existing",_CYAN,classNOBJ.text, _WHITE,"of", _YELLOW, matches[0].text);
            return;
        }
        else if (matches.length>1) {
            this.printToBest("ambiguous", _CYAN, classNOBJ.text, _WHITE, "for", _GREEN,lookupval);
            this.addAmbiguous($propObj, matches);
            return;
        }

        else {
            var children=MEM.ethnicity.getRelnUsageChildren(TYPE_BE);
            for (var c=0; c < children.length; c++) {
                var nOBJ = children[c];
                if (nOBJ.text.toLowerCase()==lookupval.toLowerCase()) {
                    $obj.to_s = nOBJ.nid;
                    return;
                }
            }

            //WE HAVE A NEW ETHNICITY.
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron(ANNE.MEM.ec_nonliving, lookupval, NTYPE_CLASS);
            await GHOSTDATA.makeGhostRelon(TYPE_BE, ghostNOBJ, ANNE.MEM.ec_is.nid, TO_TYPE_ANNE, ANNE.MEM.ethnicity.nid);

            $obj.to_s = ghostNOBJ.nid;
        }
        return;
    }



    /**
     * TODO: map only, NO CREATE NEW.
     * @param {*} $obj 
     */
    processCompanyType= async($obj)=> {
        $obj.processedBy="wikidata2.processCompanyType";
        
        var lookupval ="";
        if (typeof $obj.lookupval === "string") lookupval = $obj.lookupval;
        console.log($obj);
        //return await this.findOrAddNew($obj, ANNE.MEM.ec_nonliving);
    }

    
    
    /**
     * 
     * @param {*} $obj 
     * @param {*} $classNOBJ 
     * @param {*} $ntype 
     * @returns 
     */
    findOnly=async($obj, $classNOBJ, $ntype=NTYPE_CLASS)=> {
        $obj.processedBy="wikidata2.findOnly";
        var lookupval = $obj.lookupval;
        var matches = await ANNE.CIRCUIT.searchToResolve(lookupval, $classNOBJ);
        if (matches.length==1) {
            $obj.to_s = matches[0].nid;
            this.printToBest("found existing ", _CYAN, $classNOBJ.text, _WHITE, "of", _YELLOW, matches[0].text);
        }
        else if (matches.length>1) {
             this.printToBest("ambiguous ", _CYAN, $classNOBJ.text, "for", _GREEN,lookupval);
            $obj.to_s = matches[0].nid;
            return matches;
        }
        else {
            this.printToBest("must find not found ", _CYAN, $classNOBJ.text, _WHITE, "for", _GREEN, lookupval);
        }
        return matches;
    }


    /**
     * 
     * @param {*} $prop 
     * @param {*} $matchNOBJ 
     */
    makeSubObjExtras = async($propObj, $matchNOBJ)=>{
        if ($propObj && $propObj.extras!=undefined && $propObj.extras.length>0) {
            for (var e=0; e < $propObj.extras.length; e++) {
                var erel = $propObj.extras[e];
                var x_relon = MEMG.getRelonFromWithTo($matchNOBJ.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!=null) continue;
                var ghost_rel = await GHOSTDATA.makeGhostRelon(erel.type, $matchNOBJ, erel.reln, erel.to_type, erel.to_s);
                ANNE.TALK.printRelon(ghost_rel);
                this.printToBest("new info on", _YELLOW, $matchNOBJ, _WHITE, "relon to",_BLUE, erel.to_s);
            }
        }
    }


    /**
     * These were extracted in parsing..
     * like (formerly Twitter) giving us a FKA relon we know we need on this thing.
     */
    makeParsedObjExtras = async($obj, $matchNOBJ)=>{
        if ($obj && $obj.extras!=undefined && $obj.extras.length>0) {
            for (var e=0; e < $obj.extras.length; e++) {
                var erel = $obj.extras[e];
                var x_relon = MEMG.getRelonFromWithTo($matchNOBJ.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!=null) continue;
                await GHOSTDATA.makeGhostRelon(erel.type, $matchNOBJ, erel.reln, erel.to_type, erel.to_s);
                this.printToBest("new info on", _YELLOW, $matchNOBJ, _WHITE, "relon to",_BLUE, erel.to_s);
            }
        }
    }


    /**
     * 
     * @param {*} $obj 
     * @param {*} $classNOBJ 
     * @param {*} $ntype 
     * @param {*} $findOrAddNew
     * @returns 
     */
    findOrAddNew=async($obj, $classNOBJ, $ntype=NTYPE_CLASS, $propObj=null, $extraClasses=[])=> {
        $obj.processedBy="wikidata2.findOrAddNew";
        var lookupval = $obj.lookupval;

        var searchObj = this.makeSearch(lookupval, [$classNOBJ.nid]);

        if ($extraClasses.length) {
            for(var e=0; e < $extraClasses.length; e++) {
                var beNOBJ = $extraClasses[e];
                searchObj.bes.push(beNOBJ.nid);
                searchObj.bes_tnids.push(beNOBJ.temp_nid);
            }
        }
        
        if ($propObj!=null && $propObj.extras_to_match_required!=undefined && $propObj.extras_to_match_required==true) {
            searchObj.setRequiredExtras($propObj.extras, true);
        }

        var bDOPRE = true; //ok to end by finding match
        var matches = await searchObj.search(bDOPRE);
        console.log(matches);
        
        //var matches = await ANNE.CIRCUIT.searchToResolve(lookupval, $classNOBJ);
        
        if (matches.length==1) {
            $obj.to_s = matches[0].nid;
            var matchNOBJ = matches[0];
            this.printToBest("found existing ", _CYAN, $classNOBJ.text, _WHITE, "of", _YELLOW, matchNOBJ.text);
            
            await this.makeSubObjExtras($propObj, matchNOBJ);
            await this.makeParsedObjExtras($obj, matchNOBJ);
        }

        //we could use extra relon here to disambiguate.
        //extra relon in the props definition.
        else if (matches.length>1) {
            this.printToBest("ambiguous ", _CYAN, $classNOBJ.text, _WHITE, "for", _GREEN, lookupval);
            $obj.to_s = matches[0].nid;
            return matches;
        }

        //add a new one.
        else {
            var ghostNOBJ = await GHOSTDATA.makeGhostNeuron($classNOBJ, lookupval, $ntype);
            $obj.to_s = ghostNOBJ.nid;
            this._new_external_data+=1;

            //these extras are requiremetns on the THING we are creating new..
            //like an alt BE value... if we are using a generic non-living or living class value..
            //and want to tie it to its use here in this context.
            //ie, "ethnicity" or "occupation" or "service"...
            //we do not create unique neuron of these things.  We simply reference them as labels and the
            //context is derived from their use.  This minimizes neuron explosion and complicatings of 
            //taxonomy by leanning towards a flat hierarchy.
            await this.makeSubObjExtras($propObj, ghostNOBJ);
            await this.makeParsedObjExtras($obj, ghostNOBJ);

            this.printToBest("added new", _CYAN, $classNOBJ.text, _BLUE, ghostNOBJ.text);
            matches.push(ghostNOBJ);
        }
        return matches;
    }
}


/**
 * With known neuron, extract wiki infos (wisely)
 */
class wikihandler {
    constructor($name, $classNOBJ, $trackerMap, $printf, $preloadedExtras=[]) {
        this.name = $name;
        this.classNOBJ = $classNOBJ;
        this.trackerMap = $trackerMap;
        this.printf = $printf;
        this.preloaded_extras = $preloadedExtras;
        this._wiki = null;
    }

    //?
    resolve=async()=>{
        if (this.classNOBJ.nid==ANNE.MEM.person.nid) this._wiki = new wikipediaMakePerson(this.name, null, this.trackerMap, this.printf, this.preloaded_extras);
        else if (this.classNOBJ.nid==ANNE.MEM.company.nid) this._wiki = new wikipediaMakeCompany(this.name, null, this.trackerMap, this.printf, this.preloaded_extras);
        else if (this.classNOBJ.nid==ANNE.MEM.group.nid) this._wiki = new wikipediaMakeGroup(this.name, null, this.trackerMap, this.printf, this.preloaded_extras);
        else if (this.classNOBJ.nid==ANNE.MEM.group_event.nid) this._wiki = new wikipediaMakeGroupEvent(this.name, null, this.trackerMap, this.printf, this.preloaded_extras);
        else if (this.classNOBJ.nid==ANNE.MEM.location.nid) this._wiki = new wikipediaMakeLocation(this.name, null, this.trackerMap, this.printf, this.preloaded_extras);
        else if (this.classNOBJ.nid==ANNE.MEM.name.nid) this._wiki = new wikipediaMakeName(this.name, null, this.trackerMap, this.printf, this.preloaded_extras);
        else {
            alert("unhandled wikihandler class "+this.classNOBJ.text)
            return;
        }
    }
}


/**
 * quick explore to find out what type of thing we are dealing with.
 * Don't need this in apps where we only show wiki extract options for knowns.
 * We can then get the proper class using wikiHandler
 */
class wikipediaExplore {
    constructor($name, $trackermap=null, $printf=null) {
        this.name = $name;
        this.explore_rez = null;
        this._wiki = null;
        this.error = "";
        this.trackermap = $trackermap;
        this.printf = $printf;
        this.aec = new anne_external_connector("", "wikipedia", null);
        if (this.printf!=null) {
            this.aec.setAltConsole(this.printf);
        }
    }

    
    /**
     * 
     */
    exploreFull=async($preloadedExtras=[])=>{
        this.explore_rez = await ANNE.WIKIDATA.exploreType(this.name, this.aec);
        console.log(this.explore_rez);
        
        if (this.explore_rez.status=="good") {
            var wt = this.explore_rez.wiki_type_conformed;
            var _type = this.explore_rez.type;
            console.log("explore wt%c"+wt+"%ctype%c"+_type, TALK.bgblack, TALK.bgyellow, TALK.bgblack);
            if (wt=="person") {
                this._wiki = new wikipediaMakePerson(this.name, null, this.trackermap, this.printf, $preloadedExtras);
                await this._wiki.resolveAndGet([this._wiki.targetClassNOBJ.nid]);
            }
            else if (wt=="company") {
                this._wiki = new wikipediaMakeCompany(this.name, null, this.trackermap, this.printf, $preloadedExtras);
                await this._wiki.resolveAndGet([this._wiki.targetClassNOBJ.nid]);
            }
            else if (wt=="group") {
                this._wiki = new wikipediaMakeGroup(this.name, null, this.trackermap, this.printf, $preloadedExtras);
                await this._wiki.resolveAndGet([this._wiki.targetClassNOBJ.nid]);
            }
            else if (wt=="group_event") {
                this._wiki = new wikipediaMakeGroupEvent(this.name, null, this.trackermap, this.printf, $preloadedExtras);
                await this._wiki.resolveAndGet([this.targetClassNOBJ.nid]);
            }
            else if (wt=="location") {
                this._wiki = new wikipediaMakeLocation(this.name, null,  this.trackermap, this.printf, $preloadedExtras);
                await this._wiki.resolveAndGet([this._wiki.targetClassNOBJ.nid]);
            }
            else if (wt=="name") {
                this._wiki = new wikipediaMakeName(this.name, null, this.trackermap, this.printf, $preloadedExtras);
                await this._wiki.resolveAndGet([this._wiki.targetClassNOBJ.nid]);
            }
            else {
                this.error = "unhandled/unknown thing";
            }
            return;
        }

        else if (this.explore_rez.status=="disambig" && this.explore_rez.pages!=undefined && this.explore_rez.pages.length) {
            //pages... present ambiguous resolution.
            console.log(this.explore_rez.pages);
        }

        else {
            if (this.aec!=null) {
                this.aec.printf(_CYAN, "wikipedia", _RED, "NO WIKIPEDIA RESULTS FOUND for ",_GREEN, this.name);
            }
            return;
        }
    }
}


class wikipediaGeneric extends wikipediadata2 {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $intended_wiki_type="") {
        super($trackermap, $printf);
        this.origin_search_val = $name;
        this.name = $name;
        this.dismbig_fix = "";
        this.intended_wiki_type = $intended_wiki_type;
        this.wiki_type = "";
        this.targetClassNOBJ = null;
        
        this.resolvedNOBJ = $resolvedNOBJ;

        //set if resolvedNOBJ is new (ghost).  Not set if it is an existing known
        this.bNEW=false;
    }


    /**
     * 
     * @returns 
     */
    getWikiRezPart = function() {
        var rel_sys = ANNE.MEMG.getSysRelon(this.resolvedNOBJ.outs, ANNE.MEM.wikipart.temp_nid);
        if (rel_sys==null) return null;
        return rel_sys.to_s;
    }

    /**
     * 
     * @param {*} $targetsOnly 
     * @param {*} $minMustMatch 
     * @returns 
     */
    justGet=async($targets=null)=>{
        if (this.resolvedNOBJ==null) return;
        var query = this.getWikiRezPart();
        if (query=="") query = this.name;
        var dataObj = await ANNE.WIKIDATA.getExternalWikiData(query, this.intended_wiki_type, this.aec);
        if (dataObj==null) {
            this.printToBest(_CYAN, "wikipedia", _RED, "TEMPORARY INTERNET PROBLEM PULLING THE DATA");
            return null;
        }
        dataObj._targets = $targets;
        return await this.neuronFromWiki(dataObj);
    }


    /**
     * 
     * @returns 
     */
    resolveAndGet=async($bes=[], $targetsOnly=null)=> {
        if ($bes.length==0) {
            $bes = [this.targetClassNOBJ.nid];
        }

        //if we already know the neuron, just go to wiki, don't do a search.
        if (this.resolvedNOBJ!=null) {
            if (this.resolvedNOBJ.ghost==false) {
                this.printToBest("pulling ANNE data");
                await ANNE.API.getAllOuts( this.resolvedNOBJ.nid,true, [0,1,2,3,4,5,6,7,8,9,10]);
            }
            var dataObj = await ANNE.WIKIDATA.getExternalWikiData(this.name, this.intended_wiki_type, this.aec);
            dataObj._targets = $targetsOnly;
            await this.neuronFromWiki(dataObj);
            return dataObj;
        }

        var searchObj = this.makeSearch(this.name, $bes);
        searchObj.thresh = 0.9;
        var bDOPRE = true; //ok to end by finding match
        
        var aMatches = await CHASE.anne_global_search(searchObj, bDOPRE);
        if (aMatches.length>1) {

            //if we have a context and a BRAIN obj, snag the hottest per context.
            if (ANNE.BRAIN!=null && searchObj.context!=undefined && searchObj.context.length>0) {
                this.resolvedNOBJ = ANNE.BRAIN.getHottestByContextStr(searchObj.context, aMatches);
            }
            else this.resolvedNOBJ = aMatches[0];
            await ANNE.API.getAllOuts( this.resolvedNOBJ.nid,true, [0,1,2,3,4,5,6,7,8,9,10]);
        }
            
        else if (aMatches.length==1) {
            this.resolvedNOBJ = aMatches[0];
            if (this.resolvedNOBJ.ghost==false) await ANNE.API.getAllOuts( this.resolvedNOBJ.nid,true, [0,1,2,3,4,5,6,7,8,9,10]);
        }

        //make a new person straight away.
        else {
            this.resolvedNOBJ = await GHOSTDATA.makeGhostNeuron(this.targetClassNOBJ, this.name, NTYPE_INST);
            this.bNEW=true;
            this._new_external_data+=1;
        }
        
        var dataObj = await ANNE.WIKIDATA.getExternalWikiData(this.name, this.intended_wiki_type, this.aec);
        
        dataObj._targets = $targetsOnly;
        await this.neuronFromWiki(dataObj);

        return dataObj;
    }


    /**
     * 
     * @param {*} $searchVal 
     * @param {*} $beClassNids 
     * @param {*} $lets 
     * @param {*} $bAPPLYWVTOBELINE 
     * @param {*} $inbeline 
     * @param {*} $bEXACT 
     * @returns 
     */
    makeSearch=function($searchVal, $beClassNids=[], $lets=[], $bAPPLYWVTOBELINE=false, $inbeline=0, $bEXACT=true){
        var wvs_live = [ANNE.MEM.ANNE_ACCTID];

        if (wvs_live==undefined) wvs_live = [];
        if (ANNE.USER!=null && ANNE.USER._userNObj!=null && wvs_live.indexOf(ANNE.USER._userNObj.nid)==-1) {
            wvs_live.push(ANNE.USER._userNObj.nid);
        }
        var bes_tnids = [];
        if ($beClassNids.length) {
            for (var b=0; b < $beClassNids.length; b++) {
                var be = $beClassNids[b];
                var beNOBJ = MEMG.getNeuronByNid(be);
                bes_tnids.push(beNOBJ.temp_nid);
            }
        }
    
        //we are lettign in other worldviews here (in addition to our own and ANNE)
        if ($lets.length) {
            for (var w=0; w < $lets.length; w++) {
                var wv = $lets[w];
                if (wvs_live.indexOf(wv)==-1) wvs_live.push(wv);
            }
        }

        //replace underscores here.
        var contextObj = UTILS.fixHack($searchVal, " ");
        
        var obj = { 
                text:contextObj.str,
                context:contextObj.context,
                original:$searchVal,
                wvs:wvs_live, 
                bes:$beClassNids,
                bes_tnids:bes_tnids,
                exact:$bEXACT,
                applywvtobeline:$bAPPLYWVTOBELINE,
                inbeline:$inbeline,
                chaseIt:true
        };

        return new search_obj(obj);
    }


    /**
     * @param {*} $dataObj 
     * @param {*} $targetsOnly
     * @returns 
     */
    neuronFromWiki=async($dataObj)=>{
        if ($dataObj==null) {
            return;
        }
        if ($dataObj.status=="error") {
            return;
        }
        //we need more info
        //WTF IS THIS NONSENSE?? I can't remember.
        else if ($dataObj.status=="need_info" && $dataObj.result_type=="disambig" && $dataObj.pages.length) {
            //auto disambig
            for (var p=0; p < $dataObj.pages.length; p++) {
                var page = $dataObj.pages[p];
                if (this.intended_wiki_type=="person" && page.indexOf("(company)")==-1) continue;
                this.dismbig_fix = page;
            }
            return;
        }

        //we're going to pass this through to the launch neuron if the user makes this company.
        this._dataObj = $dataObj;
        console.log($dataObj);
        this.wiki_type = $dataObj.wiki_type;
        

        try {
            await this.processResults(this._dataObj);       //this will set this._dataObj.results
        }
        catch(e) {
            console.log(e);
            this.printToBest(_CYAN, "wikipedia", _RED, "ERROR DURING PROCESS RESULTS PHASE");
            return;
        }

        try {
            await this.makeNeuron();
        }
        catch(e) {
            console.log(e);
            this.printToBest(_CYAN, "wikipedia", _RED, "ERROR DURING MAKE NEURON PHASE");
            return;
        }
    }


    /**
     */
    makeNeuron = async()=>{
        var relons_to_ghost = [];
        var proper_name = this.name;
        if(this._dataObj!=null && this._dataObj.name != undefined && this._dataObj.name.length) {
            proper_name == this._dataObj.name;
        }
        if (this.bNEW==true) {
            //make an aka for the name the user typed if it is different than the proper name.
            if (proper_name!=this.name && this.name.length>0 && this.resolvedNOBJ.name.toLowerCase()!=this.name.toLowerCase()) {
                var x_relonAKA = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, TYPE_BE, ANNE.MEM.aka.nid, this.name);
                if (x_relonAKA==null) {
                    var rel_aka = ANNE.MEM.makeTempRelon(this.resolvedNOBJ, TYPE_BE, ANNE.MEM.aka.nid, TO_TYPE_STRING, this.name, true);
                    relons_to_ghost.push(rel_aka);
                    this.printToBest("setting aka to", _GREEN, this.name);
                }
            }
        }

        //these are picked up along the way AND/OR preloaded
        //as known things we want on this new (or edited/updated) neuron.
        if (this.extras!=undefined && this.extras.length>0) {
            for (var e=0; e < this.extras.length; e++) {
                var erel =  this.extras[e];
                var x_relon = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, erel.type, erel.reln, erel.to_s);
                if (x_relon!==null) continue;
                var extrarel = ANNE.MEM.makeTempRelon(this.resolvedNOBJ, erel.type, erel.reln, erel.to_type, erel.to_s, true);
                relons_to_ghost.push(extrarel);
            }
        }

        //store the wikipart
        var wikipart = this.name;
        if (this.dismbig_fix!="") wikipart = this.dismbig_fix;
        
        //we don't want these relons for neurons we created that typically are NOT going
        //to be queried against wikipedia.  SERVICE TERM is an exception.. we extracted it..
        //and to get it again (in isolation) we use the target feature.
        if (this.resolvedNOBJ!=null 
            && this.resolvedNOBJ.bes.indexOf(ANNE.MEM.service_term.temp_nid)==-1
            && this.resolvedNOBJ.bes.indexOf(ANNE.MEM.marry.temp_nid)==-1
            && (this._new_external_data>0 || this.aec._new_external_data>0)) {
            
            var wikirel = MEMG.getSysRelon(this.resolvedNOBJ.outs, ANNE.MEM.wikipart.temp_nid);
            if (wikirel==null) {
                var rel_wikipart = ANNE.MEM.makeTempRelon(this.resolvedNOBJ, TYPE_SYS, ANNE.MEM.wikipart.nid, TO_TYPE_STRING, wikipart, true);
                relons_to_ghost.push(rel_wikipart);
            }
        }

        //pageId --
        if (this.doc!=null && this.doc._pageID!=undefined) {
            console.warn("store wikipedia_pageid value here.. it is better than wikipart string");
        }

        //supporting/new data on this new ghost (we extracted from wikipedia)
        for (var d=0; d < this._dataObj.results.length; d++) {
            var propObj = this._dataObj.results[d];
            //var apn = propObj.anne_prop_name;
            //console.log("processing "+apn);
            //console.log(propObj.anne_prop_name, propObj);

            var type = propObj.type;
            var to_type = propObj.to_type;
            var relnNOBJ = null;
            
            if (propObj.reln==undefined || propObj.reln==null) {
                //no primary relon on this prop, but maybe extras we for 
                //new supporting neurons we alreayd blew out.
            }
            else relnNOBJ = MEMG.getNeuronByNid(propObj.reln)

            if (propObj.prop_value_arr==undefined || propObj.prop_value_arr==null) {
                console.log("Help!  Fix me");
                continue;
            }
            
            //the actual values in an array (which we processed a gazillion times)
            for (var p=0; p < propObj.prop_value_arr.length; p++) {
                
                //target data object.
                var dataObj = propObj.prop_value_arr[p];
                
                var to_s = dataObj.to_s;
                
                if (to_s==undefined || to_s==null || to_s=="") {
                    if (dataObj.bCUSTOMWIKIOBJECT==undefined) continue;
                    else if (dataObj.nObj==undefined || dataObj.nObj==null) continue;
                    to_s = dataObj.nObj.nid;
                    if (to_s==undefined || to_s==null) {
                        console.warn("bad data in .nObj");//must have a to_s here
                        continue;
                    }
                    console.log("custom wiki object name: "+dataObj.nObj.text);
                }

                //for primary patterns we must have a relnNOBJ
                if (relnNOBJ!=null) {
                    if (ANNE.testPatIsOk(this.resolvedNOBJ, type, relnNOBJ.nid)==false) {
                        alert("fix this donkey kong!");
                        continue;
                    }
                    //primary RELON specified in the data.  (it may be FLIPPED to first make)
                    //check for dupe information.
                    var x_relon = MEMG.getRelonFromWithTo(this.resolvedNOBJ.outs, type, relnNOBJ.nid, to_s);
                    if (x_relon==null) {
                        x_relon = ANNE.MEM.makeTempRelon(this.resolvedNOBJ, type, relnNOBJ.nid, to_type, to_s, true);
                        relons_to_ghost.push(x_relon);
                    }
                }

                if (dataObj.extras!=undefined && dataObj.extras.length>0) {
                    //supporing neuron should have been found or made already.
                    var dataNOBJ = MEMG.getNeuronByNid(dataObj.to_s);
                    if (dataNOBJ==null) continue;

                    //extras on this thing.  We will process these too.
                    for (var e=0; e < dataObj.extras.length; e++) {
                        var erel =  dataObj.extras[e];
                        if (ANNE.testPatIsOk(dataNOBJ, erel.type, erel.reln)==false) {
                            alert("fix this donkey kong!");
                            continue;
                        }
                        var x_relon2 = MEMG.getRelonFromWithTo(dataNOBJ.outs, erel.type, erel.reln, erel.to_s);
                        if (x_relon2==null) {
                            x_relon2 = ANNE.MEM.makeTempRelon(dataNOBJ, erel.type, erel.reln, erel.to_type, erel.to_s, true);
                            relons_to_ghost.push(x_relon2);
                        }
                    }
                }

                if (dataObj.make_be_dual!=undefined) {
                    var dual_reln = dataObj.make_be_dual.nid;
                    var dual_type = dataObj.dual_type;
                    var dualFromNOBJ = MEMG.getNeuronByNid(dataObj.to_s);
                    if (dualFromNOBJ && dual_reln && dual_type) {
                        var x_dual = MEMG.getRelonFromWithTo(dualFromNOBJ.outs, dual_type, dual_reln, this.resolvedNOBJ.nid);
                        if (x_dual==null) {
                            x_dual = ANNE.MEM.makeTempRelon(dualFromNOBJ, dual_type, dual_reln, to_type, this.resolvedNOBJ.nid, true);
                            relons_to_ghost.push(x_dual);
                        }
                    }
                }
            }
        }

        //optimized this way...
        if (relons_to_ghost.length) {
            await ANNE.GHOSTDATA.localGhostTheRelons(relons_to_ghost);
        }
        
        this.printToBest(_CYAN, "wikipedia", _WHITE, "done");
        
        return;
    }
}


class wikipediaMakeLocation extends wikipediaGeneric {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $preloadedExtras=[]) {
        super($name, $resolvedNOBJ, $trackermap, $printf);   
        this.intended_wiki_type = "location";
        this.targetClassNOBJ = ANNE.MEM.location;
        this.extras = $preloadedExtras;
    }
}

class wikipediaMakeName extends wikipediaGeneric {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $preloadedExtras=[]) {
        super($name, $resolvedNOBJ,  $trackermap, $printf);   
        this.intended_wiki_type = "name";    //is this what they call it at wikipedia?
        this.targetClassNOBJ = ANNE.MEM.name;
        this.extras = $preloadedExtras;
    }
}



class wikipediaMakeGroupEvent extends wikipediaGeneric {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $preloadedExtras=[]) {
        super($name, $resolvedNOBJ, $trackermap, $printf);   
        this.intended_wiki_type = "group_event";
        this.targetClassNOBJ = ANNE.MEM.group_event;
        this.extras = $preloadedExtras;
    }
}

class wikipediaMakeGroup extends wikipediaGeneric {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $preloadedExtras=[]) {
        super($name, $resolvedNOBJ, $trackermap, $printf);    
        this.intended_wiki_type = "group";
        this.targetClassNOBJ = ANNE.MEM.group;
        this.extras = $preloadedExtras;
    }
}

class wikipediaMakeCompany extends wikipediaGeneric {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $preloadedExtras=[]) {
        super($name, $resolvedNOBJ, $trackermap, $printf);    
        this.intended_wiki_type = "company";
        this.targetClassNOBJ = ANNE.MEM.company;
        this.extras = $preloadedExtras;
    }
}


class wikipediaMakePerson extends wikipediaGeneric {
    constructor($name, $resolvedNOBJ=null, $trackermap=null, $printf=null, $preloadedExtras=[]) {
        super($name, $resolvedNOBJ, $trackermap, $printf);    
        this.intended_wiki_type = "person";
        this.targetClassNOBJ = ANNE.MEM.person;
        this.extras = $preloadedExtras;
    }
}

