class broadcast_cmd {
    constructor($TXTYPE, $miner_fee, $annies = 0, $relon = null, $msg = "") {
        this.TXTYPE = $TXTYPE;
        this.fee = $miner_fee;
        this.annies = $annies;
        this.relon = $relon;
        this.msg = $msg;
        this.cmds_special = [];
        this.recipientPublicKey = null;
        this.sender = null;
        this.receiver = null;
        this.to_s_encryptiondone = false;
        this.faucet_nid = null;
        this.gui_extras = null;
        this.PENDING_DATA = false;
        
        this.skipped = false;
        this.success = false;
    }

    add_special = function ($special) {
        if (this.cmds_special.indexOf($special) == -1) this.cmds_special.push($special);
    }
}


var TXB = {};
TXB._metaQ = null;
TXB._totalAnniesThisSession = 0;

TXB.TXTYPE_NO_TRANSACTION = 0;
TXB.TXTYPE_SELF_RELON = "40.0";
TXB.TXTYPE_MAKE_GLOBAL = "40.1";
TXB.TXTYPE_COLLAB_REQ_RESP = "40.2";
TXB.TXTYPE_KEYLESS_NEURON = "40.3";
TXB.TXTYPE_ANJ_INVITE_RESP = "40.4";
TXB.TXTYPE_BOUNTY_CLAIM = "40.5";
TXB.TXTYPE_ANORG_VOTECALL = "40.6";
TXB.TXTYPE_ASDF_ACCEPT_RISK = "40.7";
TXB.TXTYPE_ASDF_ADD_RISK = "40.8";
TXB.TXTYPE_ASDF_NOMORE_RISK = "40.10";
TXB.TXTYPE_CUSTODIAL = "40.13";
TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON = "40.14";
TXB.TXTYPE_ANNDLE_SELLBACK = "40.16"
TXB.TXTYPE_ANNDLE_RENEW = "40.17";
TXB.TXTYPE_ANNEX_NEURON = "40.18";
TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER = "40.19";
TXB.TXTYPE_ANNDLE_REVOKE_OFFER = "40.20";
TXB.TXTYPE_ANNDLE_ACCEPT_OFFER = "40.21";
TXB.TXTYPE_ANNDLE_REJECT_OFFER = "40.22";
TXB.TXTYPE_PDN = "40.3.b";     //piggy backs the keyless neuron TX type in the annode.
TXB.TXTYPE_ANNVOICE = "40.na";   //?? deprecated?
TXB.TXTYPE_CHILD_RELON = "41.0";
TXB.TXTYPE_PDN_REVEAL = "41.0r"; //reveal
TXB.TXTYPE_COLLAB_REQ = "41.2";
TXB.TXTYPE_COLLAB_REQ_EXP_DEL = "41.2.exp";
TXB.TXTYPE_MAKE_GLOBAL_LOCATION = "41.3";
TXB.TXTYPE_HANAI_COLLAB_REQ = "41.6";
TXB.TXTYPE_BOOSTIES = "41.7";
TXB.TXTYPE_NODE_CMD = "41.8";
//09 REVEAL_PDN_SUBTYPE  (interally used)
//10 ANJUCATOR_INVITE_SUBTYPE   (interally used)
TXB.TXTYPE_ADD_ADMIN = "41.11";
//12 ASDF_TRIGGER_TYPE
TXB.TXTYPE_ANNDLE_EDIT = "41.13";
TXB.TXTYPE_MAKE_SUBANNDLE = "41.14";
//TXB.TXTYPE_AOTC_ACCEPT_OFFER = "41.15";   //deprecated/removed
TXB.TXTYPE_HANAI_OUT_REQ = "41.16";
//TXB.TXTYPE_OWNERSHIP_PROOF = "42.0";      //deprecated/removed
TXB.TXTYPE_SEND_FUNDS = 21;   //??
TXB.TXTYPE_USE_AON = 22;      //??

TXB.CMD_ENCRYPT_CHILDSEED_CMD = 1;
TXB.CMD_ENCRYPT_CHILD_TO_CMD = 2;
TXB.CMD_ENCRYPT_SELF_TO = 3;
TXB.CMD_SELF_RELON = 5;
TXB.CMD_OWNERSHIP_PROOF = 6;
TXB.CMD_USE_LAST_NEURON_FORTHISFROM = 7;
TXB.CMD_USE_LAST_NEURON_FORTHISTO_S = 8;
TXB.CMD_POPULATE_RELON_WITH_VARS = 9;
TXB.CMD_INCLUDE_PUBKEY = 10;
TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND = 11;

TXB.ENCRYPT_WITH_SELF_KEY = 1;
TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY = 2;

//to do: update USER.ascertainEncryptionAndDecrypt to use this function
TXB.getEncryptionTypeByReln = function ($reln_tnid) {
    if ($reln_tnid == MEM.PDN_SECRET.temp_nid) return TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
    else return TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY;
}

TXB.printType = function ($tt) {
    if ($tt == TXB.TXTYPE_SELF_RELON) return "self";
    if ($tt == TXB.TXTYPE_COLLAB_REQ_RESP) return "collab response";
    if ($tt == TXB.TXTYPE_ANJ_INVITE_RESP) return "anj invite response";
    if ($tt == TXB.TXTYPE_ANNVOICE) return "annvoice";
    if ($tt == TXB.TXTYPE_MAKE_GLOBAL) return "global";
    if ($tt == TXB.TXTYPE_KEYLESS_NEURON) return "keyless";
    if ($tt == TXB.TXTYPE_BOUNTY_CLAIM) return "bounty claim";
    if ($tt == TXB.TXTYPE_ASDF_ADD_RISK) return "add ASDF risk";
    if ($tt == TXB.TXTYPE_ASDF_NOMORE_RISK) return "no more ASDF risk";
    if ($tt == TXB.TXTYPE_ANNDLE_SELLBACK) return "Anndle sellback";
    if ($tt == TXB.TXTYPE_ANNDLE_RENEW) return "Anndle renew";
    if ($tt == TXB.TXTYPE_ANNEX_NEURON) return "Annex neuron";
    if ($tt == TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER) return "Anndle buyside offer";
    if ($tt == TXB.TXTYPE_ANNDLE_REVOKE_OFFER) return "Anndle revoke offer";
    if ($tt == TXB.TXTYPE_ANNDLE_ACCEPT_OFFER) return "Anndle accept offer";
    if ($tt == TXB.TXTYPE_ANNDLE_REJECT_OFFER) return "Anndle reject offer";

    if ($tt == TXB.TXTYPE_ASDF_ACCEPT_RISK) return "accept ASDF risk";
    if ($tt == TXB.TXTYPE_ANORG_VOTECALL) return "Anorg Vote call";
    if ($tt == TXB.TXTYPE_CUSTODIAL) return "make custodial neuron";
    if ($tt == TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON) return "announce custodial neuron";
    if ($tt == TXB.TXTYPE_PDN) return "private data neuron";

    if ($tt == TXB.TXTYPE_CHILD_RELON) return "child";
    if ($tt == TXB.TXTYPE_COLLAB_REQ) return "collab";
    if ($tt == TXB.TXTYPE_HANAI_COLLAB_REQ) return "hanai & collab";
    if ($tt == TXB.TXTYPE_HANAI_OUT_REQ) return "hanai";
    if ($tt == TXB.TXTYPE_BOOSTIES) return "boosties";
    if ($tt == TXB.TXTYPE_COLLAB_REQ_EXP_DEL) return "collab (exp delegation)";
    if ($tt == TXB.TXTYPE_MAKE_GLOBAL_LOCATION) return "global";
    if ($tt == TXB.TXTYPE_NODE_CMD) return "node cmd";
    if ($tt == TXB.TXTYPE_ADD_ADMIN) return "add admin";
    if ($tt == TXB.TXTYPE_ANNDLE_EDIT) return "ANNDLE edit";
    if ($tt == TXB.TXTYPE_MAKE_SUBANNDLE) return "Make subanndle";
    if ($tt == TXB.TXTYPE_SEND_FUNDS) return "send funds";
    if ($tt == TXB.TXTYPE_USE_AON) return "use AON faucet";
    if ($tt == TXB.TXTYPE_PDN_REVEAL) return "reveal PDN data";
    return "unknown txt type";
}

TXB.getTxICOByType = function ($tt, $relon) {
    if ($tt == TXB.TXTYPE_BOOSTIES) return ANNE.GUI_STUFF.getghostIcoSolo("boosties", "60"); //todo
    if ($tt == TXB.TXTYPE_HANAI_COLLAB_REQ) {
        return ANNE.GUI_STUFF.getghostIcoSolo("hanaicollab", "60");
    }
    if ($tt == TXB.TXTYPE_HANAI_OUT_REQ) {
        return ANNE.GUI_STUFF.getghostIcoSolo("hanai", "60");
    }

    if ($tt == TXB.TXTYPE_CHILD_RELON) {
        if ($relon.pending_from != undefined
            || $relon.pending_to_s != undefined
            || $relon.pending_relon != undefined) {
            return ANNE.GUI_STUFF.getghostIcoSolo("gutm", "60")
        }
        else return "";
    }
    if ($tt == TXB.TXTYPE_SELF_RELON) return "";
    if ($tt == TXB.TXTYPE_COLLAB_REQ_RESP) return ANNE.GUI_STUFF.getIco("ANDY", "20");
    if ($tt == TXB.TXTYPE_ANJ_INVITE_RESP) return ANNE.GUI_STUFF.getIco("ANJ", "20");
    if ($tt == TXB.TXTYPE_ANNVOICE) return "";
    if ($tt == TXB.TXTYPE_MAKE_GLOBAL || $tt == TXB.TXTYPE_COLLAB_REQ || TXB.TXTYPE_COLLAB_REQ_EXP_DEL) {
        var ghtype = "";
        if ($relon.r == MEM.MAKE_DATE.temp_nid) ghtype = "guta";
        else ghtype = "gutm";
        return ANNE.GUI_STUFF.getghostIcoSolo(ghtype, "60");
    }
    if ($tt == TXB.TXTYPE_KEYLESS_NEURON) return "";
    if ($tt == TXB.TXTYPE_ANORG_VOTECALL) return "";
    if ($tt == TXB.TXTYPE_ADD_ADMIN) {
        if ($relon.r == MEM.dr_andy_hanai_in.temp_nid) {
            return ANNE.GUI_STUFF.getIco("HANAI", "20");
        }
        else return ANNE.GUI_STUFF.getIco("ANDY", "20");
    }

    //put the anndle ico here.
    else if ($tt == TXB.TXTYPE_ANNDLE_EDIT) {
        return ANNE.GUI_STUFF.getIco("ANNDLE", "20");
    }

    else if ($tt == TXB.TXTYPE_MAKE_SUBANNDLE) {
        return EXB_BTNS.getIco("ANNDLE", "20");
    }

    //else if ($tt==TXTYPE_AOTC_ACCEPT_OFFER) return "";  //do a custom queue logo here

    if ($tt == TXB.TXTYPE_BOUNTY_CLAIM) return "";
    if ($tt == TXB.TXTYPE_ASDF_ADD_RISK) return "";
    if ($tt == TXB.TXTYPE_ASDF_NOMORE_RISK) return "";    //doors closed
    if ($tt == TXB.TXTYPE_ANNDLE_SELLBACK) return ANNE.GUI_STUFF.getIco("ANNDLE", "20");
    if ($tt == TXB.TXTYPE_ANNDLE_RENEW) return ANNE.GUI_STUFF.getIco("ANNDLE", "20");
    if ($tt == TXB.TXTYPE_ANNEX_NEURON) return "";
    if ($tt == TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER) return ANNE.GUI_STUFF.getIco("ANNDLE", "20");
    if ($tt == TXB.TXTYPE_ANNDLE_REVOKE_OFFER) return ANNE.GUI_STUFF.getIco("ANNDLE", "20");
    if ($tt == TXB.TXTYPE_ANNDLE_ACCEPT_OFFER) return ANNE.GUI_STUFF.getIco("ANNDLE", "20");
    if ($tt == TXB.TXTYPE_ANNDLE_REJECT_OFFER) return ANNE.GUI_STUFF.getIco("ANNDLE", "20");



    if ($tt == TXB.TXTYPE_ASDF_ACCEPT_RISK) return "";
    if ($tt == TXB.TXTYPE_CUSTODIAL) return ANNE.GUI_STUFF.getIco("ANNODE", "20");;
    if ($tt == TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON) return ANNE.GUI_STUFF.getIco("ANNODE", "20");
    if ($tt == TXB.TXTYPE_PDN) return "";
    if ($tt == TXB.TXTYPE_MAKE_GLOBAL_LOCATION) return ANNE.GUI_STUFF.getghostIcoSolo("gutm", "60");
    if ($tt == TXB.TXTYPE_NODE_CMD) return "";
    if ($tt == TXB.TXTYPE_SEND_FUNDS) return "";
    if ($tt == TXB.TXTYPE_USE_AON) return "";
    if ($tt == TXB.TXTYPE_PDN_REVEAL) return "";
}


TXB.calcTXTTYPE = function ($temp_rObj) {
    if ($temp_rObj == null) return null;

    //boosties are ONLY BOOSTIES type transactions.
    //these are relons but handled by their own TX type avoid conflation/hacking
    //with other TX types.
    if ($temp_rObj.r == MEM.boosties.temp_nid) {
        if ($temp_rObj.type != TYPE_SYS_MSG) return null;
        else if ($temp_rObj.to_type != TO_TYPE_NUMBER) return null;
        return TXB.TXTYPE_BOOSTIES;
    }

    var fromNOBJ = MEMG.getNeuronByTempNid($temp_rObj.f);

    //self relon pattern
    if (fromNOBJ.nid == USER._userNObj.nid) {

        //awareness is always self relon
        if ($temp_rObj.type == TYPE_AWARENESS) {
            return TXB.TXTYPE_SELF_RELON;
        }


        //not a collab type, this is a self-relon.
        //NOTE: we are not going to handle hanai_in as the INITIATOR of the hanai
        //that would be a request for the user to give it up.. 
        //we are only handling users OFFERING their neuron for hanai.

        //IDEA: 
        //WE *COULD* implement a rule that if a hanai_in initiated ...
        //it could offer extra "annies" in the offer.  Those get put into the keyless
        //neuron via the hanai_in annode processing.  Upon acceptance of hanai, 
        //(in this case acceptance would be hanai_out and giving up a neuron ownership) 
        //the annies can be paid as an extra fee/incentive to the prev owner..
        //if rejected hanai, rejector gets their fees (to reject) back so it costs them nothing
        //to say no.. but the extra amount goes back to the offerer.
        else if ($temp_rObj.r == MEM.hanai_in.temp_nid || $temp_rObj.r == MEM.hanai_in_reject.temp_nid) {
            return TXB.TXTYPE_SELF_RELON;
        }

        //collab response relon
        else if (MEM.collabRespRelns.indexOf($temp_rObj.r) !== -1) {
            return TXB.TXTYPE_COLLAB_REQ_RESP;
        }

        else if ($temp_rObj.r == MEM.anj_accepted.temp_nid || $temp_rObj.r == MEM.anj_rejected.temp_nid) {
            return TXB.TXTYPE_ANJ_INVITE_RESP;
        }

        //annvoice pattern (?) abandoned this.
        else if (MEM.annovice_tnids.indexOf($temp_rObj.r) !== -1) return TXB.TXTYPE_ANNVOICE;

        //make global pattern
        else if ($temp_rObj.type == TYPE_SYS_MSG) {

            if ($temp_rObj.r == MEM.annex.temp_nid) {
                return TXB.TXTYPE_ANNEX_NEURON;
            }
            else if ($temp_rObj.r == MEM.anndle_renew.temp_nid) {
                return TXB.TXTYPE_ANNDLE_RENEW;
            }
            else if ($temp_rObj.r == MEM.anndle_sellback.temp_nid) {
                return TXB.TXTYPE_ANNDLE_SELLBACK;
            }
            else if ($temp_rObj.r == MEM.anndle_offer.temp_nid) {
                return TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER;
            }
            else if ($temp_rObj.r == MEM.anndle_revoke_offer.temp_nid) {
                return TXB.TXTYPE_ANNDLE_REVOKE_OFFER;
            }
            else if ($temp_rObj.r == MEM.anndle_accept_offer.temp_nid) {
                return TXB.TXTYPE_ANNDLE_ACCEPT_OFFER;
            }
            else if ($temp_rObj.r == MEM.anndle_reject_offer.temp_nid) {
                return TXB.TXTYPE_ANNDLE_REJECT_OFFER;
            }


            //keyless pattern (parent TYPE_BE)
            else if ($temp_rObj.r == MEM.inst.temp_nid || $temp_rObj.r == MEM.class.temp_nid) {
                if (MEM.tempBeIsA($temp_rObj.t, MEM.PDN.temp_nid) == true) {
                    return TXB.TXTYPE_PDN;
                }
                else return TXB.TXTYPE_KEYLESS_NEURON;
            }

            //make global pattern
            else if ($temp_rObj.r == MEM.MAKE_INTEGER.temp_nid ||
                $temp_rObj.r == MEM.MAKE_DATE.temp_nid ||
                $temp_rObj.r == MEM.MAKE_SYMBOL.temp_nid ||
                $temp_rObj.r == MEM.MAKE_ACTION.temp_nid ||
                $temp_rObj.r == MEM.MAKE_COMPANY.temp_nid ||
                $temp_rObj.r == MEM.MAKE_IMG.temp_nid ||
                $temp_rObj.r == MEM.MAKE_EVENT.temp_nid ||
                $temp_rObj.r == MEM.MAKE_ANNDLE.temp_nid ||
                $temp_rObj.r == MEM.MAKE_ANORG.temp_nid) return TXB.TXTYPE_MAKE_GLOBAL;

            else if ($temp_rObj.r == MEM.distro_vote.temp_nid) {
                return TXB.TXTYPE_ANORG_VOTECALL;
            }

            else if ($temp_rObj.r == MEM.bounty_claim.temp_nid) {
                return TXB.TXTYPE_BOUNTY_CLAIM;
            }
            else if ($temp_rObj.r == MEM.ASDF_ACCEPT_RISK.temp_nid) {
                return TXB.TXTYPE_ASDF_ACCEPT_RISK;
            }
            else if ($temp_rObj.r == MEM.ASDF_ADD_RISK.temp_nid) {
                return TXB.TXTYPE_ASDF_ADD_RISK;
            }

            else if (MEM.valid_vote.indexOf($temp_rObj.r) != -1 || $temp_rObj.r == MEM.action_delegate.temp_nid) {
                return TXB.TXTYPE_SELF_RELON;
            }
        }

        return TXB.TXTYPE_SELF_RELON;
    }

    //child relon patterns
    else {

        //hanai outs MUST use the HANAI OUT REQUEST pattern.
        if (ANNE.isANNE(USER._userNObj.nid)==false && fromNOBJ.owned_by == USER._userNObj.nid && $temp_rObj.r == MEM.hanai_out.temp_nid
            && ANNE.isANNE($temp_rObj.to_s)==true) {
            return TXB.TXTYPE_HANAI_OUT_REQ;
        }

        else if ($temp_rObj.r == MEM.constituent.temp_nid && $temp_rObj.type == TYPE_SYS_MSG) {
            return TXB.TXTYPE_MAKE_GLOBAL_LOCATION;
        }

        //setting admin rights.  (if a hack attempt it will be rejected by the annode)
        else if ($temp_rObj.type == TYPE_SYS && MEM.delegation_reln_tnids.indexOf($temp_rObj.r) != -1) {
            return TXB.TXTYPE_ADD_ADMIN;
        }

        else if ($temp_rObj.type == TYPE_HAS && fromNOBJ.bes[0] == MEM.anndle.temp_nid) {
            return TXB.TXTYPE_ANNDLE_EDIT;
        }

        else if ($temp_rObj.type == TYPE_SYS_MSG && $temp_rObj.r == MEM.subanndle.temp_nid) {
            return TXB.TXTYPE_MAKE_SUBANNDLE;
        }

        /*
        else if ($temp_rObj.type==TYPE_SYS_MSG && $temp_rObj.r==MEM.AOTC_ACCEPT_OFFER.temp_nid) return TXB.TXTYPE_AOTC_ACCEPT_OFFER;
        */

        //child relon
        else if ((ANNE.isANNE(USER._userNObj.nid)==true && ANNE.isANNE(fromNOBJ.owned_by)==true) 
                    || fromNOBJ.owned_by == USER._userNObj.nid) return TXB.TXTYPE_CHILD_RELON;

        else if (MEM.nodecmds_tnids.indexOf($temp_rObj.r) != -1) return TXB.TXTYPE_NODE_CMD;

        //equality query
        else if ($temp_rObj.type == TYPE_SYS_MSG && $temp_rObj.r == MEM.PDN_EQUALITY_QUESTION.temp_nid) {
            return TXB.TXTYPE_PDN_REVEAL;
        }

        //query-all  or ops...
        else if ($temp_rObj.type == TYPE_SYS_MSG && MEM.pdnactions_tnids.indexOf($temp_rObj.r) !== -1) {
            return TXB.TXTYPE_PDN_REVEAL;
        }

        else if (ANNE.isANNE(USER._userNObj.nid)==true) alert("ERROR IN CODE");

        //delegation requests send to the collab TX type just like normal collabs do.
        //we expect delegation and can send a signal to the http api to confirm it
        //made it thru.
        else if (ANNE.isANNE(USER._userNObj.nid)==false && fromNOBJ.collab_ACTION == govenor.DELEGATE_NOW) {
            return TXB.TXTYPE_COLLAB_REQ_EXP_DEL;
        }

        //basic collab request of relon from an existing ANNE-owned neuron to a non-neuron 
        //OR to an ANNE-owned neuron.
        else return TXB.TXTYPE_COLLAB_REQ;
    }
}


TXB.getExtraFeeByType = function ($TXTYPE, $reln = "") {
    if ($TXTYPE == TXB.TXTYPE_COLLAB_REQ_RESP) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ANJ_INVITE_RESP) return 0;
    else if ($TXTYPE == TXB.TXTYPE_SELF_RELON) return ANNE.fees.relon_self;
    else if ($TXTYPE == TXB.TXTYPE_ANNVOICE) return ANNE.fees.annvoice;
    else if ($TXTYPE == TXB.TXTYPE_MAKE_GLOBAL) return ANNE.fees.make_global;
    else if ($TXTYPE == TXB.TXTYPE_MAKE_GLOBAL_LOCATION) return ANNE.fees.make_global_location;
    else if ($TXTYPE == TXB.TXTYPE_HANAI_COLLAB_REQ) return ANNE.fees.collab_hanai_req;
    else if ($TXTYPE == TXB.TXTYPE_HANAI_OUT_REQ) return ANNE.fees.hanai_req;
    else if ($TXTYPE == TXB.TXTYPE_COLLAB_REQ) return ANNE.fees.collab_req;
    else if ($TXTYPE == TXB.TXTYPE_BOOSTIES) return ANNE.fees.boosties;
    else if ($TXTYPE == TXB.TXTYPE_COLLAB_REQ_EXP_DEL) return ANNE.fees.collab_req;
    else if ($TXTYPE == TXB.TXTYPE_KEYLESS_NEURON) return ANNE.fees.make_keyless;
    else if ($TXTYPE == TXB.TXTYPE_ANORG_VOTECALL) return ANNE.fees.anorg_votecall;
    else if ($TXTYPE == TXB.TXTYPE_ADD_ADMIN) return ANNE.fees.add_admin;
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_EDIT) return ANNE.fees.relon_child;
    else if ($TXTYPE == TXB.TXTYPE_MAKE_SUBANNDLE) return ANNE.fees.make_keyless;
    //else if ($TXTYPE==TXB.TXTYPE_AOTC_ACCEPT_OFFER) return 0;
    else if ($TXTYPE == TXB.TXTYPE_BOUNTY_CLAIM) return ANNE.fees.bounty_claim;
    else if ($TXTYPE == TXB.TXTYPE_ASDF_ACCEPT_RISK) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ASDF_ADD_RISK) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ASDF_NOMORE_RISK) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_SELLBACK) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_RENEW) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ANNEX_NEURON) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER) return 400;             //will be paid to the current sponsor ur pestering.
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_REVOKE_OFFER) return 400;              //will be paid to the current sponsor ur pestering.
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_ACCEPT_OFFER) return 0;
    else if ($TXTYPE == TXB.TXTYPE_ANNDLE_REJECT_OFFER) return 0;

    else if ($TXTYPE == TXB.TXTYPE_CUSTODIAL) return ANNE.fees.make_custodial;
    else if ($TXTYPE == TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON) return 0;
    else if ($TXTYPE == TXB.TXTYPE_PDN) return ANNE.fees.make_pdn;
    else if ($TXTYPE == TXB.TXTYPE_CHILD_RELON) {
        if ($reln != "" && $reln == MEM.anjucator.nid) return ANNE.fees.relon_anjucator_invite;
        else return ANNE.fees.relon_child;
    }
    else if ($TXTYPE == TXB.TXTYPE_NODE_CMD) return ANNE.fees.node_cmd;
    else if ($TXTYPE == TXB.TXTYPE_SEND_FUNDS) return 0;
    else if ($TXTYPE == TXB.TXTYPE_USE_AON) return 0;
    else if ($TXTYPE == TXB.TXTYPE_PDN_REVEAL) return ANNE.fees.get_pdn;
}


/**
 * Initialize the meta Q
 * 
 * We wll track items as they are added into the queue
 * to provide deep handling of potential issues when using
 * Q send mode.  In ANNE Q mode will be common since large data
 * sets will be added, reviewed, then sent.
 * @author Mr.Scatman
 */
TXB.initMetaQ = function ($displayEl = 'qrb_txs_list_div', $balanceEl = 'qrb_balance_update', $cartBadgeEl = "cart_badge") {
    TXB._metaQ = {
        init_status: "ok",
        reason: "",
        recourse: null,
        status: "pre-run",
        fundingSeed: "",
        totalAnnies: 0,
        nid_trackers: [],
        el_display: $displayEl,
        el_balance: $balanceEl,
        el_cartBadge: $cartBadgeEl,
        total_txs:0
    };
}


TXB.resetMetaQ = function () {
    if (TXB._metaQ==null) return;
    
    TXB._metaQ.init_status = "ok";
    TXB._metaQ.reason = "";
    TXB._metaQ.recourse = null;
    TXB._metaQ.status = "pre-run";
    TXB._metaQ.fundingSeed = "";
    TXB._metaQ.totalAnnies = 0;
    TXB._metaQ.nid_trackers = [];
    TXB._metaQ.total_txs = 0;
}


/**
 * Make a cmd ready to be sent via api.
 *
 * @param {int}
 * @param {object}
 * @param {string}
 * @author {Mr.Scatman}  
 */
TXB.makeSelfRelonAPICmd = function ($relon, $TXTYPE = TXB.TXTYPE_SELF_RELON, $special = null, $msg = "", $bDUPEOK=false) {
    if (!$relon) {
        alert("params");
        return null;
    }

    var miner_fee = ANNE.getMinerFeeByToType($relon.to_type);
    var fire_fee = ANNE.TXB.getExtraFeeByType($TXTYPE);

    if ($TXTYPE != 0 && (miner_fee == undefined || fire_fee == undefined)) {
        alert("dude. fix this.");
    }

    //build the relon msg here for 
    if ($msg == undefined || $msg == "") {
        $msg = ANNE.TALK.simpleRelonTags($relon, $TXTYPE, false, false);
    }

    //real_cmd is the actual cmd of the relon.  This will allow us to properly handle
    //it runtime in the bundle once we prep the changamoney utxos.

    var cmdObj = new broadcast_cmd($TXTYPE, miner_fee, fire_fee, $relon, $msg);

    if ($special != null) cmdObj.add_special($special);


    if (cmdObj.TXTYPE == TXB.TXTYPE_PDN_REVEAL && $relon.r != MEM.PDN_OP_REVEAL_ALL.temp_nid) {
        cmdObj.add_special(TXB.CMD_PDN_REVEAL_Q); //force encryption on the question.
        cmdObj.relon.to_type = TO_TYPE_ENC_STRING;
    }

    //this is not a fee, it is a payment attached to a relon,
    //but we send it along with the fee.
    //The annode will seperate it out properly.
    if ($relon.gui_extras != null && $relon.gui_extras.payment != undefined) {
        cmdObj.annies = parseInt(cmdObj.annies) + parseInt($relon.gui_extras.payment);
        $relon.annies = $relon.gui_extras.payment;  //this will be stored in the relon.annies on-chain
    }

    //stored in ghost, likely, in the .annies slot.
    //add in the extra annies to the standard fire+fee annies we've already calculated.
    //relon.annies is to indicate non-standard fire/fee annies that were part of the TX.
    else if ($relon.annies != undefined && $relon.annies > 0) {
        cmdObj.annies = parseInt(cmdObj.annies) + parseInt($relon.annies);
    }

    if (TXB.addMetaQCmd(cmdObj, false, $bDUPEOK)==false) return null;
    return cmdObj;
}


/**
 * Make a child relon cmd.
 * This will handle any TTYPES that are relevant to child relons.
 *
 * @param {int}
 * @param {object}
 * @param {string}
 * @author {Mr.Scatman}  
 */
TXB.makeChildRelonAPICmd = function ($relon, $TXTYPE = TXB.TXTYPE_CHILD_RELON, $special = null, $msg = "") {
    if (!$relon) {
        alert("params");
        return null;
    }

    //build the relon msg here for 
    if ($msg == undefined || $msg == "") $msg = ANNE.TALK.simpleRelonTags($relon, $TXTYPE, false, false);

    var miner_fee = ANNE.getMinerFeeByToType($relon.to_type);
    var fire_fee = ANNE.TXB.getExtraFeeByType($TXTYPE, $relon.reln);

    if ($TXTYPE != 0 && (miner_fee == undefined || fire_fee == undefined)) {
        alert("dude. fix this.");
    }

    //real_cmd is the actual cmd of the relon.  This will allow us to properly handle
    //it runtime in the bundle once we prep the changamoney utxos.
    var cmdObj = new broadcast_cmd($TXTYPE, miner_fee, fire_fee, $relon, $msg);

    if ($special != null) cmdObj.add_special($special);

    //for payouts
    //this is not a fee, it is a payment attached to a relon,
    //but we send it along with the fee.
    //The annode will seperate it out properly.
    if ($relon.gui_extras != null && $relon.gui_extras.payment != undefined) {
        cmdObj.annies = parseInt(cmdObj.annies) + parseInt($relon.gui_extras.payment);
        $relon.annies = parseInt($relon.gui_extras.payment);  //this will be stored in the relon.annies on-chain
    }

    //stored in ghost, likely, in the .annies slot.
    //add in the extra annies to the standard fire+fee annies we've already calculated.
    //relon.annies is to indicate non-standard fire/fee annies that were part of the TX.
    else if ($relon.annies != undefined && $relon.annies > 0) {
        cmdObj.annies = parseInt(cmdObj.annies) + parseInt($relon.annies);
    }

    if (TXB.addMetaQCmd(cmdObj, false)==false) return null;
    return cmdObj;
}


/**
 * Make a simple payment cmd ready to be sent via api.
 * 
 * Note: We have no ANNE apps that use this payment because this comes
 * with NO CONTEXT so it is just a sends b some annies.  (meh)
 * 
 * @param {int} - indicates what type of TX this is (with respect to the node API)
 * @param {int} - the fee
 * @param {string} - who is getting paid
 * @param {ing} - the amount they will receive
 * @param {boolean} - put this in the front of the queue?
 * @param {string} - optional message (debug only)
 * @author {Mr.Scatman}  
 */
TXB.makePaymentAPICmd = function ($TXTYPE, $fee, $sender, $receiver, $annies, $bPUTINFRONT = false, $msg = "", $bDUPESOK=false) {
    if (!$fee || !$receiver || !$annies) {
        alert("params");
        return null;
    }

    var cmdObj = new broadcast_cmd($TXTYPE, $fee, $annies, null, $msg);
    cmdObj.sender = $sender;
    cmdObj.receiver = $receiver;

    if (TXB.addMetaQCmd(cmdObj, $bPUTINFRONT, $bDUPESOK)==false) return null;

    return cmdObj;
}




/**
 * Review the meta Q for potential problems.
 * If found, try to provide recourse.
 * Pull balances and adjust fundings where needed
 * @author Mr.Scatman
 */
TXB.analyzeAndFixMetaQ = async () => {
    var prop_keys = Object.keys(TXB._metaQ.nid_trackers);
    var totalAnnies = 0;
    for (var k = 0; k < prop_keys.length; k++) {
        var prop_key = prop_keys[k];

        //aid, new, annies_in, annies_out, balance, must_pull_balance, pulled_balance, count
        var tracker = TXB._metaQ.nid_trackers[prop_key];
        totalAnnies += tracker.annies_out;

        //pull balance if needed
        if (tracker.must_pull_balance == true && tracker.pulled_balance == false) {
            var balanceObj = USER._userNObj.balanceObj;
            tracker.pulled_balance = true;
            if (balanceObj!=null) tracker.annies = balanceObj.annies;

            //tracker.future_balance += tracker.annies;
            tracker.future_balance -= tracker.annies_out;

            //needs funds.
            if (tracker.future_balance <= 0) {
                console.log("(analyzeAndFixMetaQ) needs funds");
                var deficit = tracker.future_balance * -1;

                //adjust the annies on the funding relon
                if (tracker.new == true) {
                    if (typeof ANNE.MEM_UDF._udf_recourse_needsFundsIdentity === 'function') {
                        TXB._metaQ.recourse = ANNE.MEM_UDF._udf_recourse_needsFundsIdentity(tracker.annies, deficit, tracker.nid);
                    }
                    else TXB._metaQ.recourse = null;

                    TXB._metaQ.status = "recourse needed";
                    TXB._metaQ.reason = "This identity needs atleast " + deficit + " more annies to make this transaction."
                    return this;
                }
            }
        }

        TXB._metaQ.totalAnnies = totalAnnies;
    }

    //loop the aQ and set the signing seed for each relon
    //childNObj in this context means it is owned by an identity..
    TXB._metaQ.total_txs = SENDQ.aQ.length;
    
    for (var a = 0; a < SENDQ.aQ.length; a++) {
        var cmdObj = SENDQ.aQ[a];

        //snake the relon msg if we have it.
        if (cmdObj.msg == "" && cmdObj.relon != undefined && cmdObj.relon.msg != undefined) {
            cmdObj.msg = cmdObj.relon.msg;
        }

        //console.log("a: "+a, cmdObj.msg);

        if (cmdObj.cmds_special.length == 0) continue;

        /* handle special cmds. */

        //investigate this.. it doesn't do anything with the encrypted string. (lolz)
        if (cmdObj.cmds_special.indexOf(TXB.CMD_PDN_REVEAL_Q) != -1) {
            var shared_secretObj = await USER.getSharedSecret();
            console.log(shared_secretObj);
            console.log("shared secret:" + shared_secretObj.seed);
            USER.encryptRevealRequestQ(shared_secretObj.seed, cmdObj.relon.to_s);
        }

        if (cmdObj.cmds_special.indexOf(TXB.CMD_INCLUDE_PUBKEY)) {
            cmdObj.recipientPublicKey = USER.pubKey;
        }


        //ENCRYPTION CMD
        //if the from neuron is a GHOST we do not do the encryption here!!!
        if (cmdObj.PENDING_DATA == true || cmdObj.relon == null || cmdObj.relon.ghost == true) continue;

        //TXB.CMD_ENCRYPT_CHILD_TO_CMD = 2;
        if (cmdObj.cmds_special.indexOf(TXB.CMD_ENCRYPT_CHILD_TO_CMD) != -1) {
            childNObj = MEMG.getNeuronByTempNid(cmdObj.relon.f);

            //using the seed we need to go procure the child key.
            //then we use them both to encrypt a child message. 
            if (cmdObj.gui_extras.encryption_method == TXB.ENCRYPT_WITH_SELF_KEY) {
                TXB._metaQ.status = "error";
                TXB._metaQ.reason = "Mr.scatman -- redo this for keyless neurons.";
                alert("we're not doing this anymore");
            }

            else if (cmdObj.gui_extras.encryption_method == TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY) {
                console.warn("use the ANNODE SHARED KEY!!!!");
                var annode_uri = gui_extras.annode_uri;

                //make sure we are handshaked with the right annode.
                //each shared key is specific to the annode we handshake with.
                var shared_secretObj = await USER.getSharedSecret();
                console.log(shared_secretObj);
                console.log("shared secret:" + shared_secretObj.seed);

                if (shared_secretObj.status == "success") {
                    if (cmdObj.to_s_encryptiondone == undefined || cmdObj.to_s_encryptiondone == false) {
                        cmdObj.to_s_encryptiondone = await USER.encryptRelonToWithSS(shared_secretObj.seed, cmdObj.relon);
                    }
                    if (cmdObj.to_s_encryptiondone == false) {
                        cmdObj.to_s = "";
                        TXB._metaQ.status = "error";
                        TXB._metaQ.reason = "encryption problem";
                        return;
                    }
                }
            }

            else {
                TXB._metaQ.status = "error";
                TXB._metaQ.reason = "unhandled encryption method";
                return;
            }
        }

        //TXB.CMD_ENCRYPT_SELF_TO = 3;
        else if (cmdObj.cmds_special.indexOf(TXB.CMD_ENCRYPT_SELF_TO) != -1) {
            alert("to do - encrypt a self message");
            if (to_s.length >= 64) cmdObj.to_s_encryptiondone = true;
        }
    }

    TXB._metaQ.status = "ready";
    return;
}


/**
 * Add a future ANNE TX cmd to the meta Q.
 * 
 * This wil build a tracker for later audit/use/recourse.  With batches of 
 * TXs that we can send we need to be careful to avoid sending errors 
 * for lack of funds in neurons.        
 * 
 * @param {object} - The cmd object to add
 * @param {boolean} - Force the cmd to be in the front of the QUE.
 * @author Mr.Scatman
 */
TXB.addMetaQCmd = function ($cmdObj, $bPUTINFRONT = false, $bDUPEOK = false) {
    if (TXB._metaQ == null) TXB.initMetaQ();

    if ($bDUPEOK==false && $cmdObj.TXTYPE != TXB.TXTYPE_KEYLESS_NEURON && $cmdObj.relon != null
        && $cmdObj.relon.pending_from == undefined
        && $cmdObj.relon.pending_to_s == undefined) {
        var qItem = SENDQ.relonIsAlreadyInQ($cmdObj.relon, $bDUPEOK);
        if (qItem != null) {
            if (typeof ANNE.TXB._dupeEntryInQ === "function") {
                ANNE.SENDQ.dupeQEntry($cmdObj);
            }
            return false;
        }
    }

    $cmdObj.cmdguid = UTILS.randomHex(8);

    if ($bPUTINFRONT == false) SENDQ.aQ.push($cmdObj);
    else SENDQ.aQ.unshift($cmdObj);


    //no longer worried about comingin..
    //we don't send from subkeys anymore!  :)
    function addUpdateTracker($cmdObj, $nid, $annies, $fee, $bGETBALANCE = false, $bNEW = false) {
        var tracker = TXB._metaQ.nid_trackers[$nid];
        var annies_out = $annies;

        $cmdObj.totalAnnies = annies_out + $fee;

        if (tracker == undefined) {
            tracker = {
                nid: $nid,
                init_cmd: $cmdObj,
                new: $bNEW,
                annies_out: annies_out + $fee,
                balance: 0,
                must_pull_balance: $bGETBALANCE,
                count: 1,
                pulled_balance: false
            }
            TXB._metaQ.nid_trackers[$nid] = tracker;
        }

        //adjust this tracker
        else {
            tracker.annies_out += annies_out + $fee;
            tracker.count += 1;
        }
    }


    //proess in_annies and out_annies here.
    var bGETBALANCE = false;
    addUpdateTracker($cmdObj, USER._userNObj.nid, $cmdObj.annies, $cmdObj.fee, bGETBALANCE);

    //console.log(TXB._metaQ);

    //update the gui handler for display pending (batched) TXs waiting
    SENDQ.cartChange();
    return true;
}


TXB.addAnniesToCmd = function ($cmdObj, $nid, $annies) {
    var tracker = TXB._metaQ.nid_trackers[$nid];
    if (tracker == undefined) return;
    $cmdObj.totalAnnies += $annies;
    tracker.annies_out += $annies;
    $cmdObj.annies += $annies;
}


/**
 * Process the commands in the queue.
 *
 * @param {Array} - An array of the Q items we want to send.
 * @param {object} - The seed obj.
 * @author {Mr.Scatman}  
 */
TXB.sender = async ($aQ, $startIndex=0) => {

    ANNE.__DO_NOT_INTERRUPT = true;

    //set the privKey in the USER if we haven't (we should have long ago)
    if (USER.privKey == "" || USER.privKey == undefined) {
        var aO = USER.prepANNEAuthObjFromSeed(USER.seedObj.seed);
        USER.privKey = aO.sign_key;
    }

    //helper array to hold vars that are populated from the annode at run time..
    //ie, a new neuron...
    //which is needed in downstream cmdObj relons but was not available at the time
    //we added it to the sendQ.  WE do this to prevent multiple cycles of TX sends...
    //for the user experience to take action once and then we do the rest instead of
    //multiple steps.
    var _THIS_VARS = [];
    var resultsObj = { txids: [], ghost_txids: [], ghostsToDelete: [], auxGhostRelsToDelete: [], status: "", relons: [] }
    var lastCmd = null;
    var last_new_from = null;
    var last_txid = null;
    //var updated_txids_test = new Object();

    var reprocess_only_ghost_relons = [];

    //AUDIT FOR DEBUGGING
    var audit_nid = USER.getAccountIdFromSeed(USER.seedObj.seed);
    if (USER._userNObj.nid != audit_nid) {
        console.alert("big trouble little china");
        ANNE.__DO_NOT_INTERRUPT = false;
        return;
    }

    //loop through all the cmds.
    for (var a = $startIndex; a < $aQ.length; a++) {
        var cmdObj = $aQ[a];
        var bLASTINQ = false;
        if (a == $aQ.length - 1) bLASTINQ = true;

        //last cmdObj holds the nid we want.
        if (cmdObj.wtfdavidblane!=undefined) {
            console.log("here");
        }
        
        if (cmdObj.cmds_special.length && lastCmd != null) {
            if (lastCmd != undefined) {
                if (cmdObj.cmds_special.indexOf(TXB.CMD_USE_LAST_NEURON_FORTHISFROM) != -1) {
                    cmdObj.relon.from_nid = last_new_from.substring(0);
                    if (cmdObj.relon.pending_from != undefined) delete cmdObj.relon.pending_from;
                    //we could be wanting to do more than one of these.. and then we won't find 
                    //the new_from set.  We can adjust here to re-store it on THIS cmd too!
                    cmdObj.new_from = last_new_from.substring(0);
                }

                else if (cmdObj.cmds_special.indexOf(TXB.CMD_USE_LAST_NEURON_FORTHISTO_S) != -1) {
                    console.log("cmd special update to_s");
                    if (cmdObj.relon.to_type == TO_TYPE_ANNE) {
                        console.log("cmd special expecting nid value");
                        cmdObj.relon.to_s = last_new_from.substring(0);
                        if (cmdObj.relon.pending_to_s != undefined) delete cmdObj.relon.pending_to_s;
                    }
                    else if (cmdObj.relon.to_type == TO_TYPE_TXID) {
                        console.log("cmd special expecting txid value");
                        cmdObj.relon.to_s = last_txid;
                        if (cmdObj.relon.pending_to_s != undefined) delete cmdObj.relon.pending_to_s;
                    }
                }

                //this is a cmd to update ghost mem (with new info)
                else if (cmdObj.cmds_special.indexOf(TXB.CMD_POPULATE_WITH_VARS_ONLY_NO_SEND) != -1) {
                    if (cmdObj.relon.pending_to_s != undefined) {
                        //console.log("we have a pending to_s var of "+cmdObj.relon.pending_to_s);
                        var dynamicvar = _THIS_VARS[cmdObj.relon.pending_to_s];
                        if (dynamicvar == undefined) {
                            console.warn("big trouble little china, no dynamic var '" + cmdObj.relon.pending_to_s + "' found!");
                            console.log(_THIS_VARS);
                            continue;
                        }
                        else {
                            //need to remove this "in" to the old ghost neuron else it will be deleted when
                            //the ghost neuron is deleted in the cleanup.
                            var old_znid = cmdObj.relon.pending_to_s.split("_")[1];
                            if (resultsObj.ghostsToDelete.indexOf(old_znid) == -1) {
                                resultsObj.ghostsToDelete.push(old_znid);
                            }
                            var oldGhostToNOBJ = MEMG.getNeuronByNid(old_znid);
                            oldGhostToNOBJ.removeByTXID('ins', cmdObj.relon.txid, []);
                            cmdObj.relon.to_s = dynamicvar.substring(0);
                            var newRealToNOBJ = MEMG.getOrMakeIfNew(dynamicvar);
                            newRealToNOBJ.addUniqueIns(cmdObj.relon);
                        }
                    }

                    //if we crash or bust this send, this ghost relon has been updated
                    //with its newly mapped/pending data.
                    await ANNE.GHOSTDATA.updateDBSingleGhostRelon(cmdObj.relon);
                    delete cmdObj.relon.pending_to_s;
                    
                    cmdObj.relon.idb_update = true;
                    cmdObj.relon.force_update = true;
                    reprocess_only_ghost_relons.push(cmdObj.relon);
                    cmdObj.broadcast_txid = "";
                    ANNE.TALK.updateSantizedAlertCmd(TXB._metaQ.el_display, cmdObj, a, $aQ.length);
                    continue;
                }

                else if (cmdObj.cmds_special.indexOf(TXB.CMD_POPULATE_RELON_WITH_VARS) != -1) {
                    if (cmdObj.wtfdavidblane!=undefined) {
                        console.log("here");
                    }

                    //sometimes we need the sys_ref_txid as the prev txid.
                    if (cmdObj.relon.pending_sys_ref_txid != undefined) {
                        var dynamicvar = _THIS_VARS[cmdObj.relon.pending_sys_ref_txid];
                        if (dynamicvar != undefined) {
                            cmdObj.relon.sys_ref_txid = dynamicvar;
                        }
                    }

                    if (cmdObj.relon.pending_reln != undefined) {
                       // console.log("we have a pending reln var of " + cmdObj.relon.pending_reln);
                        var dynamicvar = _THIS_VARS[cmdObj.relon.pending_reln].substring(0);
                        if (dynamicvar == undefined) {
                            console.warn("big trouble little china, no dynamic var '" + cmdObj.relon.pending_reln + "' found!");
                            console.log(_THIS_VARS);
                            console.log(cmdObj);
                            alert("TROUBLE - populate with vars but no dynamic relon " + cmdObj.relon.pending_reln);
                            continue;
                        }
                        else cmdObj.relon.reln = dynamicvar.substring(0);
                    }
                    if (cmdObj.relon.pending_from != undefined) {
                        //console.log("we have a pending from var of " + cmdObj.relon.pending_from);
                        var dynamicvar = _THIS_VARS[cmdObj.relon.pending_from];
                        if (dynamicvar == undefined) {
                            console.warn("big trouble little china, no dynamic var '" + cmdObj.relon.pending_from + "' found!");
                            console.log(_THIS_VARS);
                            console.log(cmdObj);
                            alert("TROUBLE - populate with vars but no dynamic relon " + cmdObj.relon.pending_from);
                            continue;
                        }
                        else {
                            if (cmdObj.relon.from_nid != undefined && cmdObj.relon.from_nid != "") {
                                cmdObj.relon.znid_was = cmdObj.relon.pending_from.split("_")[1];
                                if (resultsObj.ghostsToDelete.indexOf(cmdObj.relon.znid_was) == -1) {
                                    resultsObj.ghostsToDelete.push(cmdObj.relon.znid_was);
                                }
                            }
                            cmdObj.relon.from_nid = dynamicvar;
                            //console.log("setting from_nid to " + dynamicvar);
                            //console.log(cmdObj.relon);
                        }
                    }
                    if (cmdObj.relon.pending_to_s != undefined) {
                        console.log("we have a pending to_s var of " + cmdObj.relon.pending_to_s);
                        var dynamicvar = _THIS_VARS[cmdObj.relon.pending_to_s];
                        if (dynamicvar == undefined || dynamicvar == null) {
                            console.log(_THIS_VARS);
                            console.log(cmdObj);
                            console.warn("big trouble little china, no dynamic var '" + cmdObj.relon.pending_to_s + "' found!");
                            alert("TROUBLE");
                            continue;
                        }
                        else {
                            if (cmdObj.relon.to_s != null && cmdObj.relon.to_s.length > 10) {
                                //sb the same. we populated this ahead in a manual cheat.
                                console.log("snatch audit " + cmdObj.relon.to_s + " vs " + dynamicvar);
                            }
                            cmdObj.relon.to_s = dynamicvar.substring(0);
                        }
                    }
                }
            }
            else console.log("special cmds must come after REAL cmds");
        }

        //first things first.. if we have no AAUTH object, let's get that set properly
        //we have the seed here in local browser memory so we can use it to get the AAUTH.
        //this will allow the user to do PDNs and other features with the annode they 
        //are using.
        if (USER._userLS.aauth == null || USER._userLS.aauth == undefined) {
            if (ANNE.API._AAUTH) USER._userLS.aauth = ANNE.API._AAUTH;
            else {
                //consider extracting the seed out of localStorage via the session pw everytime we want it..
                //and storing the privKey in mem instead (in either case, only the extension can get to this info)
                var ok = await USER.refreshAAUTH(USER.seedObj.seed, USER._userLS);
            }
        }

        var relon_audit = cmdObj.relon;
        if (relon_audit != null) {
            if (relon_audit.pending_from != undefined) {
                if (relon_audit.from_nid == null || relon_audit.from_nid == undefined) {
                    console.warn("THIS SHOULD HAVE BEEN HANDLED");
                    resultsObj.status = "fail";
                    resultsObj.reason = "relon from_nid did not update with a previous from nid or var value.  Cannot continue.";
                    ANNE.__DO_NOT_INTERRUPT = false;
                    return resultsObj;
                }
            }
            if (relon_audit.pending_reln != undefined) {
                if (relon_audit.reln == null || relon_audit.reln == undefined) {
                    console.warn("THIS SHOULD HAVE BEEN HANDLED");
                    resultsObj.status = "fail";
                    resultsObj.reason = "relon reln did not update with a previous nid or var value.  Cannot continue.";
                    ANNE.__DO_NOT_INTERRUPT = false;
                    return resultsObj;
                }
            }
            if (relon_audit.pending_to_s != undefined) {
                if (relon_audit.to_s == null || relon_audit.to_s == undefined) {
                    console.warn("THIS SHOULD HAVE BEEN HANDLED");
                    resultsObj.status = "fail";
                    resultsObj.reason = "relon to_s did not update with previous from nid or var value.  Cannot continue.";
                    ANNE.__DO_NOT_INTERRUPT = false;
                    return resultsObj;
                }
            }
        }

        var ge = null;
        ge = cmdObj.gui_extras;

        //We thought we had a ghost neuron we wanted to make.
        //We maybe had extra ghosts relon after we made that ghost neuron that we were going to send.
        //Maybe some of those ghost relons are no longer needed if we already have those on the real good-but nid.
        var eliminateDupesFromGoodBut = function ($old_ghost_nid, $real_existing_results) {
            for (var aaa = a + 1; aaa < $aQ.length; aaa++) {
                var cmdObj = $aQ[aaa];
                if (cmdObj.relon == undefined || cmdObj.relon == null) continue;
                if (cmdObj.relon.from_nid != $old_ghost_nid) continue;

                //loop existing relons we retunred from the good-but
                //if we already have any of these in our ghost (with the ghost from nid)
                //we can safely skip that cmd.
                var cmrel = cmdObj.relon;
                for (var rer = 0; rer < $real_existing_results.length; rer++) {
                    var rer_rel = $real_existing_results[rer];
                    if (rer_rel.type != cmrel.type) continue;
                    if (rer_rel.reln != cmrel.reln) continue;
                    if (rer_rel.to_type != cmrel.to_type) continue;
                    if (rer_rel.to_s != cmrel.to_s) continue;
                    $aQ.splice(aaa, 1);
                    aaa = aaa - 1;
                    break;
                }
            }
        }

        //set the vars for future cmds to snag the new ghost nids so good nids are broadcast for the ghost relons.
        //this is key in the working queue to be able to process ghost relons that require real neurons
        //that don't yet exist at the time of sending the queue (must create ghost neuron first, then update, then send ghost relons).
        var setVARS = function ($ge) {
            if ($ge != undefined) {
                //ref_var is a from neuron variable
                if ($ge.ref_var != undefined && cmdObj.new_from != undefined) {
                    _THIS_VARS[$ge.ref_var] = cmdObj.new_from.substring(0);
                    var newNOBJ = MEMG.getOrMakeIfNew(cmdObj.new_from);
                    newNOBJ.znid_was = $ge.ref_var.split("_")[1];
                    console.log("%c_THIS_VARS znid %c" + $ge.ref_var + "%cupdated to %c" + cmdObj.new_from, ANNE.TALK.bgyellow, ANNE.TALK.bggreen, ANNE.TALK.bgblack, ANNE.TALK.bggreen);
                }
                //ref_txid is set it will take the last TXID.
                if ($ge.ref_txid != undefined && last_txid.length) {
                    console.log("_THIS_VARS updated: last_txid: " + last_txid);
                    _THIS_VARS[$ge.ref_txid] = last_txid.substring(0);
                }
            }
        }

        if (cmdObj.TXTYPE == 0) {
            console.warn("investigate!!", cmdObj);
            continue;
        }

        /************************************************************************/
        var innerRezObj = await TXB.handleSignAndBroadcast(cmdObj);
        /************************************************************************/

        if (innerRezObj == null) {
            console.warn("investigate!!", cmdObj);
            cmdObj.success = false;
            continue;
        }

        if ((innerRezObj.broadcasted == undefined) && innerRezObj.status != undefined && innerRezObj.status != "good") {
            cmdObj.success = false;

            cmdObj.relon.rorigin = RORIGIN_GHOST; //put this back.

            console.log("%csomething went wrong", TALK.bgbigred);
            console.log(cmdObj)
            console.log(innerRezObj);
            
            var bBIPASSERROR = false;
            
            if (cmdObj.result==undefined) cmdObj.result = innerRezObj;
            if (cmdObj.retries==undefined) cmdObj.retries=0;

            //this neuron already exists.
            //we don't need to create it.
            //accept the existing nid and set the ghost relons to accept the existing nid
            //as-if it were an newly added nid.
            if (innerRezObj.reason == "good-but" && innerRezObj.result != null) {
                console.log("bipass good but error");
                bBIPASSERROR = true;
                console.log(cmdObj);

                var existingNOBJ = MEMG.getOrMakeIfNew(innerRezObj.result.from_nid);
                cmdObj.new_from = existingNOBJ.nid;
                if (ge != undefined && ge != null) {

                    //for any other rels we needed to make.
                    //note: we probably need to look for dupes now (lol)
                    setVARS(ge);

                    if (innerRezObj.results != undefined && innerRezObj.results.length) {
                        resultsObj.relons = resultsObj.relons.concat(innerRezObj.results);
                    }

                    //old nid, search for relons in the sendQ from the old ghost nid.
                    //if we find them we may already have those relons.
                    eliminateDupesFromGoodBut(innerRezObj.result.from_nid, innerRezObj.results);
                }

                cmdObj.skipped_reason = innerRezObj.reason;
                cmdObj.skipped = true;
                last_new_from = existingNOBJ.nid;
                lastCmd = cmdObj;
                if (TXB._metaQ.el_display) {
                    ANNE.TALK.updateSantizedAlertCmd(TXB._metaQ.el_display, cmdObj, a, $aQ.length, TXB._metaQ.el_cartBadge);
                }

                ANNE.bugHunterRejectedBroadcast(cmdObj, innerRezObj);
            
                continue;

            }

            //just skip it.
            else if (innerRezObj.errorCode=="777.777.777") {
                cmdObj.skipped_reason = innerRezObj.message;
                cmdObj.skipped = true;

                ANNE.bugHunterRejectedBroadcast(cmdObj, innerRezObj);
                continue;
            }

            //dupe relon at API level, ok, just skip
            else if (innerRezObj.errorCode=="777.A.1") {
                cmdObj.skipped_reason = innerRezObj.message;
                cmdObj.skipped = true;
                resultsObj.auxGhostRelsToDelete.push(cmdObj.relon.txid);   //we will be nuking this ghost
                continue;
            }
                    
            //dupe.  delete this ghost.
            else if (innerRezObj.reason!=undefined && innerRezObj.reason.indexOf("There can only be one")!=-1) {
                cmdObj.skipped_reason = innerRezObj.reason;
                cmdObj.skipped = true;
                //innerRezObj.errorCode = "1c3";
                resultsObj.auxGhostRelsToDelete.push(cmdObj.relon.txid);   //we will be nuking this ghost
                continue;
            }

            //annode isn't ready or went in a non-sendable status.
            //lame, but try not to blow up our run over this.
            else if (innerRezObj.errorRecourse!=undefined && cmdObj.retries<10) {
                if(innerRezObj.errorRecourse=="retry") {
                    cmdObj.retries+=1;
                    await ANNE.UTILS.sleep(1000 * cmdObj.retries);   //delay 1 secsond.
                    a--;
                    continue;
                }
            }

            //just skip the hanai.
            else if (cmdObj.TXTYPE == TXB.TXTYPE_HANAI_OUT_REQ || cmdObj.TXTYPE == TXB.TXTYPE_HANAI_COLLAB_REQ) {
                bBIPASSERROR = true;
                console.log("%c skipping hanai", ANNE.TALK.bgbigred);

                //extract what info we can (and nuke the ghost relon)
                if (cmdObj.result != undefined && cmdObj.result.message != undefined) {
                    if (cmdObj.result.message == "adopter and owner are already the same!") {
                        var fromNOBJ = MEMG.getNeuronByNid(cmdObj.relon.from_nid);

                        //need to update IDB relon.. hmm.
                        await IDB.updateAllOwnedBySponsoredBy(fromNOBJ.nid, cmdObj.relon.to_s, USER._userNObj.nid);

                        fromNOBJ.addOwnedBy(cmdObj.relon.to_s);
                        fromNOBJ.addSponsoredBy(USER._userNObj.nid);

                        await GHOSTDATA.deleteSingleGhostRelon(cmdObj.relon.txid);
                        if (cmdObj.aux_ghost_txid!=undefined) {
                            resultsObj.auxGhostRelsToDelete.push(cmdObj.aux_ghost_txid);
                        }
                    }

                    else if (cmdObj.result.message == "this asset is already pending a hanai out.") {
                        await GHOSTDATA.deleteSingleGhostRelon(cmdObj.relon.txid);
                        if (cmdObj.aux_ghost_txid!=undefined) {
                            resultsObj.auxGhostRelsToDelete.push(cmdObj.aux_ghost_txid);
                        }
                    }
                    else if (cmdObj.result.message == "You have been explicitly blocked fom collaborations on this.") {
                        await GHOSTDATA.deleteSingleGhostRelon(cmdObj.relon.txid);
                        if (cmdObj.aux_ghost_txid!=undefined) {
                            resultsObj.auxGhostRelsToDelete.push(cmdObj.aux_ghost_txid);
                        }
                    }
                }
            }

            else if (cmdObj.TXTYPE == TXB.TXTYPE_CHILD_RELON) {
                bBIPASSERROR = true;
                console.log("%c skipping child relon", ANNE.TALK.bgbigred);
            }

            else if (cmdObj.TXTYPE == TXB.TXTYPE_COLLAB_REQ) {
                bBIPASSERROR = true;
                console.log("%c skipping collab request", ANNE.TALK.bgbigred);
            }

            else if (cmdObj.TXTYPE == TXB.TXTYPE_COLLAB_REQ_EXP_DEL) {
                bBIPASSERROR = true;
                console.log("%c skipping collab request w/ expected delegation", ANNE.TALK.bgbigred);
            }

            else if (cmdObj.TXTYPE == TXB.TXTYPE_SELF_RELON && cmdObj.relon != null && cmdObj.relon.type == TYPE_AWARENESS) {
                bBIPASSERROR = true;
                console.log("%c skipping self relon", ANNE.TALK.bgbigred);
            }

            cmdObj.result = innerRezObj;
            cmdObj.broadcast_txid = "";

            //ON BIPASSERROR FALSE we will now try to recover as much goodies
            //from what was good before this went bad by still calling the ___masterTXSuccessProcessor

            //we will also leave a "retry" button in case the error was bogus and we think we can fix it.
            if (bBIPASSERROR == false) {
                console.log(innerRezObj.status);
                innerRezObj.status = "error";
                console.log(innerRezObj);

                if (reprocess_only_ghost_relons.length) {
                    await GHOSTDATA.reprocessGhostRelonsForManualUpdates(reprocess_only_ghost_relons);
                }

                if (innerRezObj.reason != undefined) resultsObj.reason = innerRezObj.reason;
                if (innerRezObj.message != undefined) {
                    resultsObj.message = innerRezObj.message;
                    resultsObj.reason = innerRezObj.message;
                }
                if (innerRezObj.errorCode != undefined) resultsObj.errorCode = innerRezObj.errorCode;
                resultsObj.status = "error";
                ANNE.__DO_NOT_INTERRUPT = false;
                
                ANNE.bugHunterRejectedBroadcast(cmdObj, innerRezObj);
                return resultsObj;
            }

            cmdObj.skipped_reason = innerRezObj.reason;
            cmdObj.skipped = true;

            if (TXB._metaQ.el_display) {
                ANNE.TALK.updateSantizedAlertCmd(TXB._metaQ.el_display, cmdObj, a, $aQ.length, TXB._metaQ.el_cartBadge);
            }

            
            ANNE.bugHunterRejectedBroadcast(cmdObj, innerRezObj);
            continue;
        }

        cmdObj.success = true;

        //custidal magics.
        if (cmdObj.TXTYPE == TXB.TXTYPE_CUSTODIAL) {
            if (innerRezObj.new_pub_key != undefined && innerRezObj.new_nid != undefined) {
                //cmdObj.new_from = innerRezObj.new_nid;
                //last_new_from = innerRezObj.new_nid.substring(0);
                var custodialNOBJ = MEMG.getOrMakeIfNew(innerRezObj.new_nid);
                custodialNOBJ.origin = ORIGIN_CUSTODIAL;
                custodialNOBJ.pubKey = innerRezObj.new_pub_key;
                var cmdObj2 = $aQ[a + 1];
                if (cmdObj2 != null) {
                    var fullHash = innerRezObj.fullHash;
                    if (cmdObj2.TXTYPE == TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON) {
                        cmdObj2.recipientPublicKey = custodialNOBJ.pubKey;
                        cmdObj2.recipient = custodialNOBJ.nid;
                        cmdObj2.referencedTransactionFullHash = fullHash;
                        cmdObj2.relon.sys_ref_txid = innerRezObj.transaction;
                        cmdObj2.relon.to_s = innerRezObj.transaction;
                        cmdObj.new_from = innerRezObj.new_nid;  //yes, cmdObj not cmdObj2
                        last_new_from = innerRezObj.new_nid;
                        //the pending TO_S HANDLING WILL PICK IT UP ON THE NEXT LOOP
                        //AND UPDATE THE 
                    }
                    else {
                        console.log("%cCUSTODIAL TROUBLES!", TALKE.bgbigred);
                        resultsObj.errorCode = "CUSTODIALNEURONPROBLEM";
                        resultsObj.status = "error";
                        resultsObj.reason = "Custodial TX didn't process correctly";
                        ANNE.__DO_NOT_INTERRUPT = false;
                        return resultsObj;
                    }
                }
                //we need to set the next relon's pubkey  We are going to send it funds
                //and broadcast its new public key.
            }
        }

        //we must have this!  This registers the pubKey on other annodes.
        else if (cmdObj.TXTYPE == TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON) {
            if (ANNE.UTILS.isset(innerRezObj.extra_outs) == true) {
                ANNE.TALK.printRelons(innerRezObj.extra_outs);
                await ANNE.MEMP.processNeuronsFromRelons(innerRezObj.extra_outs, false, true, "relons", "TXB.[TXTYPE_ANNOUNCE_CUSTODIAL_NEURON]");
            }
            else console.log("BIG TROUBLE!");
        }

        resultsObj.txids.push(innerRezObj.transaction);

        last_txid = innerRezObj.transaction.substring(0);

        //these were neurons that supported ghosts but get auto made on the annode and are
        //not actually needed.  We delete them after the ghost using these is made into a real neuron.
        if (cmdObj.delete_temp_ghosts != undefined) {
            resultsObj.auxGhostRelsToDelete = resultsObj.auxGhostRelsToDelete.concat(cmdObj.delete_temp_ghosts)
        }

        if (cmdObj.relon != undefined && cmdObj.relon != null) {

            //could just look for ghost=true
            if (cmdObj.relon.txid != undefined && cmdObj.relon.txid.length && cmdObj.relon.txid[0] == "z") {
                resultsObj.ghost_txids.push(cmdObj.relon.txid);
            }

            //we should never see this here.
            //we CANNOT send relons from a ghost neuron.  It is impossible.
            if (cmdObj.relon.from_nid != undefined && cmdObj.relon.from_nid[0] == "z") {
                alert("TEST DO NOT WANT TO SEE THIS");
                cmdObj.relon.znid_was = cmdObj.relon.from_nid.substring(0);
                if (resultsObj.ghostsToDelete.indexOf(cmdObj.relon.znid_was) == -1) {
                    resultsObj.ghostsToDelete.push(cmdObj.relon.znid_was);
                }
            }

            //any rorgin from broadcasts must be BROADCAST or COLLAB_BROADCAST
            //COLLAB BROADCAST will sometimes (if no delegate approval)
            //result in a collab relon that is not yet in the hypergraph.
            //it can get into the hypergraph upon admin approval.
            if (cmdObj.relon.rorigin == undefined) cmdObj.relon.rorigin = RORIGIN_BROADCAST;
            else if (cmdObj.relon.rorigin != RORIGIN_COLLAB_BROADCAST) {
                cmdObj.relon.rorigin = RORIGIN_BROADCAST;
            }

            //ALL TRANSACTIONS SHOULD BE COMING BACK WITH A Z starting ghost relon
            //and a a populated real .txid.  We need to update the relon hash in memory.
            //we do this so we don't have to redo all our .out/.in indexes where we have referenced
            //this ghost relon object in arrays.  new hash entry (of txid) still pts to the same rid
            //s.b. same as ghost=true
            if (cmdObj.relon.txid != undefined && cmdObj.relon.txid[0] == "z") {
                ANNE.MEMP.__hashRelonUpdate_AFTER_SEND(cmdObj.relon, innerRezObj.transaction);
                console.assert(cmdObj.relon.txid[0] != "z", "ERROR IN HASHRELON UPDATE");

                //will print these after for testing. DELETE AFTER TESTING..
                //this just helps find out why ghost relons of hanai are still showing up
                //with their unique ghost .txids as a dupe relon.
                //updated_txids_test[cmdObj.relon.old_txid]=cmdObj.relon.txid;
            }

            //when is this relevant?  When is information brodacast to the annode in a TX without a relon?
            else if (cmdObj.relon.txid == undefined || cmdObj.relon.txid == "") {
                console.warn(cmdObj, cmdObj.relon);
                cmdObj.relon.txid = innerRezObj.transaction;
            }
        }

        //push the relon to our reults array if it was a real relon.
        if (cmdObj.relon != undefined && cmdObj.relon != null) {
            if (cmdObj.relon.txid != undefined && cmdObj.relon.txid.length > 10 && cmdObj.relon.txid[0] != "z") {
                resultsObj.relons.push(cmdObj.relon);

                //an admin collab'd (created the collab) so it should be auto-approved
                //as if the owner made it.  DONT PUT THIS IN COLLAB
                if (cmdObj.TXTYPE == ANNE.TXB.TXTYPE_COLLAB_REQ_EXP_DEL) {
                    //status_text:"p"
                    //status_txid
                    //ANNE.MEM_UDF.addCollabFromBroadcast(cmdObj.relon, CTYPE_COLLAB_ONLY);
                    //console.warn("collab ex[ delegation cmd", cmdObj, cmdObj.relon);
                }

                else if (cmdObj.TXTYPE && cmdObj.TXTYPE == ANNE.TXB.TXTYPE_COLLAB_REQ) {
                    ANNE.MEM_UDF.addCollabFromBroadcast(cmdObj.relon, CTYPE_COLLAB_ONLY);
                    console.warn("collab only cmd", cmdObj, cmdObj.relon);
                }

                else if (cmdObj.TXTYPE && cmdObj.TXTYPE == ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ) {
                    ANNE.MEM_UDF.addCollabFromBroadcast(cmdObj.relon, CTYPE_COLLAB_HANAI);
                    console.warn("collab hanai cmd", cmdObj, cmdObj.relon);
                }

                else if (cmdObj.TXTYPE && cmdObj.TXTYPE == ANNE.TXB.TXTYPE_HANAI_OUT_REQ) {
                    ANNE.MEM_UDF.addCollabFromBroadcast(cmdObj.relon, CTYPE_HANAI_ONLY);
                    console.warn("solo hanai out cmd", cmdObj, cmdObj.relon);
                }

                //both collab req and collab_hanai_req use collab_req_resp for admin response.
                else if (cmdObj.TXTYPE && cmdObj.TXTYPE == ANNE.TXB.TXTYPE_COLLAB_REQ_RESP) {
                    if (cmdObj.relon.reln == ANNE.MEM.andy_collab_accepted.nid) {
                        cmdObj.relon.status_text = "a";
                        cmdObj.relon.status_txid = innerRezObj.transaction;
                    }
                    else if (cmdObj.relon.reln == ANNE.MEM.andy_collab_rejected.nid) {
                        cmdObj.relon.status_text = "r";
                        cmdObj.relon.status_txid = innerRezObj.transaction;
                    }
                    else if (cmdObj.relon.reln == ANNE.MEM.hanai_and_collab_accept.nid) {
                        cmdObj.relon.status_text = "a";
                        cmdObj.relon.status_txid = innerRezObj.transaction;
                    }
                    else if (cmdObj.relon.reln == ANNE.MEM.hanai_and_collab_reject.nid) {
                        cmdObj.relon.status_text = "r";
                        cmdObj.relon.status_txid = innerRezObj.transaction;
                    }
                }
                else if (cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANJ_INVITE_RESP) {
                    if (cmdObj.relon.reln == ANNE.MEM.anj_accepted.nid) {
                        cmdObj.relon.status_text = "a";
                        cmdObj.relon.status_txid = innerRezObj.transaction;
                    }
                    else if (cmdObj.relon.reln == ANNE.MEM.anj_rejected.nid) {
                        cmdObj.relon.status_text = "r";
                        cmdObj.relon.status_txid = innerRezObj.transaction;
                    }
                }
            }
        }

        //snag the node-made relon here.
        //When we create origin_node relons we pass them back here in the .result object.
        var passthru = null;
        var extra_outs = null;

        if (innerRezObj.extra_outs != undefined && (innerRezObj.result == undefined || innerRezObj.result == null)) {
            innerRezObj.result = innerRezObj.extra_outs[0];
        }


        //set annex _annex.has_ending if this was an annex and/or boosties action.
        //this will inform the gui.. (gui updates when the annex is pulled but we won't pull it again unless we need to)
        if (cmdObj.type == ANNE.TXB.TXTYPE_ANNEX_NEURON || cmdObj.type == ANNE.TXB.TXTYPE_BOOSTIES) {
            var fromNOBJ = MEMG.getNeuronByNid(cmdObj.relon.to_s);
            if (fromNOBJ._aplex != undefined) {
                fromNOBJ._aplex.has_pending = true;
                fromNOBJ._aplex.pending_sponsored_by = USER._userNObj.nid;
            }
        }

        //TODO:  have to vet all returns from ANNODE now that we are using "broadcastTranasction"
        //and depending on that for return data when we are doing broadcastingTXs and not just queries.
        if (innerRezObj.result != undefined || innerRezObj.results != undefined) {


            //critical vars set here for future reference in CMDOBJS that are in
            //the queue but were not made with their nids since they didn't know what they were.
            if (innerRezObj.result != undefined && innerRezObj.result.from_nid != undefined && innerRezObj.result.to_s != undefined) {
                resultsObj.relons.push(innerRezObj.result);
                console.log("results:", innerRezObj.result);
                passthru = innerRezObj.result;
                cmdObj.new_from = innerRezObj.result.from_nid;
                last_new_from = cmdObj.new_from.substring(0);

                //hijack done in annode too.
                if (cmdObj.relon != null) cmdObj.relon.sys_ref_txid = last_new_from;
            }

            else if (innerRezObj.results != undefined && innerRezObj.results.length > 0 && innerRezoObj.results[0].from_nid != undefined) {
                resultsObj.relons.push(innerRezObj.results[0]);
                console.log(innerRezObj.results[0]);
                cmdObj.new_from = innerRezObj.results[0].from_nid;
                last_new_from = cmdObj.new_from.substring(0);

                //hijack done in annode too.
                if (cmdObj.relon != null) cmdObj.relon.sys_ref_txid = last_new_from;
            }

            //an encrypted msg from the annode
            if (innerRezObj.result.ss_encrypted_answer != undefined) {
                console.warn("we have an encrypted message back fromm the annode using the shared key");
                //this wll be using the cmdObj.relon  from_nid and reln.
                console.warn("innerRezObj.result.ss_encrypted_answer " + innerRezObj.result.ss_encrypted_answer);
                var encrypted = innerRezObj.result.ss_encrypted_answer;
                var ssObj = await ANNE.USER.getSharedSecret();
                if (ssObj != null) {

                    //annode used the reveal relon reln and from with the shared secret to gen the ephem key here.
                    cmdObj.gui_extras.decrypted = await ANNE.USER.decryptToSWithSS(ssObj.seed, cmdObj.relon, encrypted);
                    cmdObj.relon.decrypted = cmdObj.gui_extras.decrypted;

                    //we need to confirm this relon gets stored in memory
                    resultsObj.relons.push(cmdObj.relon);
                }
            }
        }


        //this was from an older use..  look through the annode to see if we still 
        //pass the extra_outs or if we use the .results now
        if (innerRezObj.extra_outs != undefined) {
            extra_outs = innerRezObj.extra_outs;
            console.log("%c :: we have " + extra_outs.length + " extra relons returned", TALK.bggreen);
        }


        //we may have a var even on a relon that returns no .result (passthru) relon.
        if (ge != undefined && ge != null) setVARS(ge);


        //set the broadcast_txid in the cmd Obj.
        cmdObj.broadcast_txid = innerRezObj.transaction;

        //these were old ways we passed info back from brodacasts.
        //have to look to see if we still do this..
        //not a big deal if we don't -- it is just ugly (for now)
        //Too many different ways with .results, .result, .extra_outs
        if (extra_outs && extra_outs.length) {
            if (resultsObj.relons != undefined) {
                for (var rr = 0; rr < extra_outs.length; rr++) {
                    var new_extra_out = extra_outs[rr];
                    var bFOUND = false;
                    for (var rrr = 0; rrr < resultsObj.relons.length; rrr++) {
                        var rrr_rel = resultsObj.relons[rrr];
                        if (rrr_rel.txid == new_extra_out.txid) {
                            bFOUND = true;
                            break;
                        }
                    }
                    if (bFOUND == false) resultsObj.relons.push(new_extra_out);
                }
                console.log("%c :: extra relons added to resultsObj.relons now length:" + resultsObj.relons.length, TALK.bggreen);
            }
        }



        //console.warn("*** SUPER MOJO GUI CLEANUP ***");
        if (ge != null) {
            if (innerRezObj.result && innerRezObj.result.encrypted != undefined && innerRezObj.result.nonce != undefined) {
                var nonce = innerRezObj.result.nonce;
                var aO = ANNE.USER.prepANNEAuthObjFromSeed($seedObj.seed);
                var decrypted = await ANNE.USER.decryptMsgEncryptedFromANNODE(nonce, innerRezObj.result.encrypted, ANNE.API._AAUTH.pubKey, aO.priv_key);
                ge.decrypted = decrypted;
            }

            ge.passthru = passthru;
            ge.extra_outs = extra_outs;
            ge.bLASTINQ = bLASTINQ;

            //remove from guis.
            var status_text = ge.status_text;
            var collab_txid = ge.collab_txid;
            var guid = ge.guid;

            //this was a response to a collab request..
            //update this user's gui.
            if (status_text != undefined && collab_txid != undefined && guid != undefined) {
                relon_table.updateCollabRow(guid, collab_txid, status_text);
            }

            //REVIEW THIS.. it is a bit willy wonka at this point
            //this is a very old artifact of stuff long ago.
            //still used in pdn creation.. (when active)
            if (ge.callback_funct != undefined && ge.callback_funct != null 
                && typeof ge.callback_funct === "function") {

                //relon is original TX broadcast,
                //ge has a .passthrough (_passthrough) on it for annode created relon returned.
                //this will have goodies on it to process.
                await ge.callback_funct(cmdObj.relon, ge, _THIS_VARS);
            }
        }



        //decriment the total annies.. we manage this as best as 
        //we can internally so we minimize hits on the API.
        //Also, balances w/ the getBalance from the node 
        //are not reflected until TXs are mined.
        if (cmdObj.totalAnnies && ANNE.UTILS.isset(USER._userNObj.balanceObj) == true) {
            ANNE.USER._userNObj.balanceObj.annies -= cmdObj.totalAnnies;
            if (TXB._metaQ.el_balance) {
                ANNE.A.empty(TXB._metaQ.el_balance);
                ANNE.GUI_STUFF.doAnniesToAnneSpanFull(TXB._metaQ.el_balance, "balance", ANNE.USER._userNObj.balanceObj.annies);
            }
        }

        if (ANNE.GUI_STUFF) ANNE.playSound("annies_spent");

        if (TXB._metaQ.el_display) {
            ANNE.TALK.updateSantizedAlertCmd(TXB._metaQ.el_display, cmdObj, a, $aQ.length, TXB._metaQ.el_cartBadge);
        }

        lastCmd = cmdObj;


        //some TXs will be exact dupes as others (they are cmds/instructions).
        //as such, if they are broadcast with in the same sec they can get the same timestamp
        //and with equal other parts they will create the same exact txid..
        //This is a problem which is complicated further by that txid being used as a "seed" to generate
        //the emulated keyless neuronID.
        if (lastCmd.delay != undefined) {
            //console.log("forcing delay");
            await ANNE.UTILS.sleep(parseInt(lastCmd.delay));
        }
    }

    TXB.resetMetaQ();   //prep for next run.

    //for ANNE owned from neurons that point to ghost neurons that just got updated.
    //we need to update some rare ghost relons that pointed to things we just updated to real NIDs
    //but we left behind the ghost relon and didn't update here and broadcast (for good reason).. 
    //Our local mem relon (and in ghost tbl relon) now pts to the wrong old to_s! (it was updated to a real nid!)
    //and needs to be reprocessed and properly re-wired up!
    if (reprocess_only_ghost_relons.length) {
        await ANNE.GHOSTDATA.reprocessGhostRelonsForManualUpdates(reprocess_only_ghost_relons);
        var alreadydones = [];
        for (var g=0; g < reprocess_only_ghost_relons.length; g++) {
            alreadydones.push(reprocess_only_ghost_relons[g].txid);
        }
        resultsObj.alreadydones = alreadydones;
    }
    else resultsObj.alreadydones = [];

    
    //testing only
    //key = old_txid, value = new txid.
    //console.log("testing", updated_txids_test);

    resultsObj.status = "success";
    ANNE.__DO_NOT_INTERRUPT = false;
    return resultsObj;
}


/**
*/
TXB.exitQueue = function(){
    TXB.resetMetaQ(); 
}



/**
 * Handle a specific command and route it to the right API function.
 * All prep has been done and this is ready for API interaction.
 *
 * @param {string} - Seed.  This is used to sign locally.
 * @param {object} - The ready-to-go cmd 
 * @author {Mr.Scatman}  
 */
TXB.handleSignAndBroadcast = async ($cmdObj) => {

    if ($cmdObj.signing_seed == false) {
        console.log("must have the signing seed");
        return null;
    }

    //tested, working.
    if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_SELF_RELON) {

        //Check that encryption was done if this is a self to.
        if ($cmdObj.to_s_encryptiondone == false) {

            //We may be wanting to encrypt a TO_S that is a ghost neuron and will be 
            //updated, thus we don't have the proper value yet.
            if ($cmdObj.cmds_special.indexOf(ANNE.TXB.CMD_ENCRYPT_SELF_TO) != -1) {
                var good = await ANNE.TXB.RUNTIME_ENCRYPT_UPGRADED_GHOST($cmdObj);
                if (good == false) return null;
            }
        }
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        var resp = await ANNE.API.sendSelfRelon($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
        return resp;
    }

    //tested, working.
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_KEYLESS_NEURON) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeKeylessNeuron($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANORG_VOTECALL) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.anorgVoteCall($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ADD_ADMIN) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeAnneAdmin($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    //simple relon to alter an andle.
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_EDIT) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeAnndleEdit($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    //simple relon to alter an andle.
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_MAKE_SUBANNDLE) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeSubAnndle($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    //else if ($cmdObj.TXTYPE==TXB.TXTYPE_AOTC_ACCEPT_OFFER) {
    //  $cmdObj.relon.rorigin=RORIGIN_BROADCAST;
    // return await ANNE.API.acceptAOTCOffer($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    // }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_BOUNTY_CLAIM) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.bountyClaim($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ASDF_ADD_RISK) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.asdfAddRisk($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ASDF_NOMORE_RISK) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.asdfNomoreRisk($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNEX_NEURON) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.annexNeuron($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_SELLBACK) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.anndleSellback($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_RENEW) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.anndleRenew($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_BUYSIDE_OFFER) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeAnndleOffer($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_REJECT_OFFER) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.rejectAnndleOffer($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }


    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_ACCEPT_OFFER) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.acceptAnndleOffer($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNDLE_REVOKE_OFFER) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.revokeAnndleOffer($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ASDF_ACCEPT_RISK) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.asdfAcceptRisk($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_CUSTODIAL) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeCustodialNeuron($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNOUNCE_CUSTODIAL_NEURON) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.announceCustodial($cmdObj.relon, $cmdObj.recipientPublicKey, $cmdObj.referencedTransactionFullHash, $cmdObj.recipient, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_PDN) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makePDN($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_MAKE_GLOBAL) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeNewGlobal($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_MAKE_GLOBAL_LOCATION) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeGlobalLocation($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_COLLAB_REQ) {
        console.log("(calling API.makeCollabReq)");
        $cmdObj.relon.rorigin = RORIGIN_COLLAB_BROADCAST;
        return await ANNE.API.makeCollabReq($cmdObj.relon, $cmdObj.annies, $cmdObj.fee, false);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_COLLAB_REQ_EXP_DEL) {
        console.log("(calling API.makeCollabReq)");
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeCollabReq($cmdObj.relon, $cmdObj.annies, $cmdObj.fee, true);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_HANAI_COLLAB_REQ) {
        console.log("(calling API.makeHanaiCollabReq)");
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeHanaiCollabReq($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_HANAI_OUT_REQ) {
        console.log("(calling API.makeHanaiOutReq)");
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeHanaiOutReq($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_BOOSTIES) {
        if (ANNE.SETTINGS.debug()==true) console.log("(calling API.addBoosties)");
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.addBoosties($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_COLLAB_REQ_RESP) {
        console.log("(calling API.makeCollabResp)");
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeCollabResp($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANJ_INVITE_RESP) {
        console.log("(calling API.makeAnjInviteResp)");
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.makeAnjInviteResp($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    //note:  we are going to have to encrypt the $cmdObj.to_s for op questions (>, <= etc)
    //using the shared key (for the specific annode).. TO PROTECT THE INTEGRITY OF THE PDN.
    //info can be leaked by observing questions and new questions that follow.
    //Data/info can be leaked for those watching "questions".
    //For reveal all, we don't need to encrypt the to_s of the question.
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_PDN_REVEAL) {
        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        return await ANNE.API.viewPDN($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
    }

    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_CHILD_RELON) {
        if ($cmdObj.to_s_encryptiondone == false) {
            //if we have encryption to do.. we will need to do this run time for 
            //ghost neurons that have a zNid (temporary nid).
            //The REAL NID is used in the ephemeral key generation.
            if ($cmdObj.cmds_special.indexOf(ANNE.TXB.CMD_ENCRYPT_CHILD_TO_CMD) != -1) {
                var good = await ANNE.TXB.RUNTIME_ENCRYPT_UPGRADED_GHOST($cmdObj);
                if (good == false) return null;
            }
        }

        $cmdObj.relon.rorigin = RORIGIN_BROADCAST;
        var resp = await ANNE.API.sendChildRelon($cmdObj.relon, $cmdObj.annies, $cmdObj.fee);
        return resp;
    }


    //recipientPublicKey
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_SEND_FUNDS) {
        return await ANNE.API.sendAnne($cmdObj.receiver, $cmdObj.recipientPublicKey, $cmdObj.annies, $cmdObj.fee);
    }


    //still haven't done this one yet.
    else if ($cmdObj.TXTYPE == ANNE.TXB.TXTYPE_ANNVOICE) {
        //return await ANNE.API.sendSelfRelon($cmdObj.relon,   $cmdObj.annies, $cmdObj.fee);
    }

    alert("unhandled cmdObj.TXTYPE " + $cmdObj.TXTYPE);

    return null;
}


/**
 * In ANNE relons we can either encrypt IDENTITY INFO  (self relon pattern)
 * or CHILD RELON INFO
 * 
 * CHILD RELON encrypting is done either with the IDENTITY KEY (generating an ephemeral key)
 * or it is done with the SHARED_ANNODE_SECRET (generating an ephermal key).
 */
TXB.RUNTIME_ENCRYPT_UPGRADED_GHOST = async ($cmdObj) => {

    //TXB.CMD_ENCRYPT_CHILD_TO_CMD = 2;
    if ($cmdObj.cmds_special.indexOf(ANNE.TXB.CMD_ENCRYPT_CHILD_TO_CMD) != -1) {
        childNObj = MEMG.getNeuronByTempNid($cmdObj.relon.f);

        //TO DO: test this in the EXT
        if ($cmdObj.gui_extras.encryption_method == ANNE.TXB.ENCRYPT_WITH_SELF_KEY) {
            //TXB._metaQ.status = "error";
            //TXB._metaQ.reason = "Mr.scatman -- redo this for keyless neurons.";
            alert("fix this");
            return false;
        }

        //THIS IS THE PRIMARY METHOD USED IN THE EXT for encrypting information
        //between the ANNODE.
        else if ($cmdObj.gui_extras.encryption_method == ANNE.TXB.ENCRYPT_WITH_ANNODE_SHARED_KEY) {
            console.warn("use the ANNODE SHARED KEY!!!!");
            var annode_uri = gui_extras.annode_uri;

            //make sure we are handshaked with the right annode.
            //each shared key is specific to the annode we handshake with.
            var shared_secretObj = await ANNE.USER.getSharedSecret();
            console.log(shared_secretObj);
            console.log("shared secret:" + shared_secretObj.seed);

            if (shared_secretObj.status == "success") {
                if ($cmdObj.to_s_encryptiondone == undefined || $cmdObj.to_s_encryptiondone == false) {
                    $cmdObj.to_s_encryptiondone = await ANNE.USER.encryptRelonToWithSS(shared_secretObj.seed, $cmdObj.relon);
                    return true;
                }
                if ($cmdObj.to_s_encryptiondone == false) {
                    $cmdObj.to_s = "";
                    TXB._metaQ.status = "error";
                    TXB._metaQ.reason = "unhandled encryption method";
                    return false;
                }
            }
        }

        else {
            TXB._metaQ.status = "error";
            TXB._metaQ.reason = "unhandled encryption method";
            return false;
        }
    }

    //TXB.CMD_ENCRYPT_SELF_TO = 3;
    else if ($cmdObj.cmds_special.indexOf(ANNE.TXB.CMD_ENCRYPT_SELF_TO) != -1) {
        TXB._metaQ.status = "error";
        TXB._metaQ.reason = "implement this";
        alert("to do - encrypt a self message");
        return false;

        //if (to_s.length>=64) $cmdObj.to_s_encryptiondone=true;
    }

    return true;
}
