var ACCOUNTS = {};
ACCOUNTS.init = function() {}

/**
 * User accounts ANNE manages for ease of use.
 */
class anne_accounts {
    constructor($pgui) {
        this.pgui = $pgui;
        this.tbl_cols = [{
            neuron_link:false,
            title:"ticker",
            prop:"ticker",
            class1:"acct-ticker"
        },
        {
            neuron_link:false,
            title:"uniqueID",
            prop:"uniqueID",
            class1:"acct-uniqueID",
        }, 
        {
            neuron_link:false,
            title:"nickname",
            prop:"nickname",
            class1:"acct-nickname",
        },       
        {
            title:"balance",
            prop:"balance",
            class1:"acct-balance",
            actions_cb:this.balance_by_ticker
        }
        ];
    }


    /**
     */
    init=async()=>{
        this._accts = await ANNE.USER.getAccounts();
        console.log("<_____________________________________________________________>");
        console.log(this._accts);
        console.log("[_____________________________________________________________]");
        var accts2 = [];
        for (var a=0; a<this._accts.length;a++) {
            var act = this._accts[a];
            if (act.ticker=="ANNE" && ANNE.UTILS.isset(act.nickname)==false) {
                var NOBJ = MEMG.getNeuronByTempNid(act.uniqueID);
                act.nickname = NOBJ.bestName();
            }
            if (act.annies==undefined || act.annies==0 || isNaN(act.annies)==true) {
                act.annies=0;
            }
            accts2.push({ticker:act.ticker, nickname:act.nickname, uniqueID:act.uniqueID, balance:act.annies, obj:act, actions:1});
        }

        //$pgui, $bDOHEADING=true, $heading_prop="title", $dcf=".smart-scroll-framer", $YBUF=52
        var tableObj = new neuron_table(this.pgui, true, "title", ".smart-scroll-framer");
        tableObj.bCOLORSQARES=true;
        tableObj.setManualCols(this.tbl_cols, accts2, true);
        var el_acct = ANNE.A.__getEl("anneid_acct_div");
        el_acct.classList.add("overflowy-auto");
        ANNE.A.empty(el_acct);
        ANNE.A.show(el_acct);
        tableObj.heading_col_class = "acct-heading";
        tableObj.buildDOMTable(el_acct);
        this.accountFooter(el_acct);
    }


    /**
     * 
     * @param {*} id 
     * @param {*} e
     * @author radanne 
     */
    updateAllBalances=async(id,e)=>{
        let tbl =  document.querySelector('#anneid_acct_div .anne-table-body'); 
        let ids = tbl.querySelectorAll('.acct-uniqueID');
        let annecoin = tbl.querySelectorAll('.annecoin-balance-value');
        let history = await ANNE.USER._getHistory();
        let thisAnnodeHistory = history[ANNE._annodesLS.last_uri];
        let accs = thisAnnodeHistory.users;
        for(var a=0; a < annecoin.length; a++) {   
            let nid = ids[a].innerHTML;
            let json = await ANNE.API.getBalance(nid);
            if (json.message=="entirely unknown nid") {
                annecoin[a].innerHTML = "UNKNOWN ACCT";
                accs[nid].last_known_annies = 0;
            }
            else if (json.status=="bad") {
                annecoin[a].innerHTML = "dead or ghost acct";
                accs[nid].last_known_annies = 0;
            }
            else {
                annecoin[a].innerHTML = UTILS.formatNumber((json.annies/ANNE.ANNE_TO_ANNIES), true);
                accs[nid].last_known_annies = json.annies;
            }
        }
        
        thisAnnodeHistory.users = accs;
        history[ANNE._annodesLS.last_uri] = thisAnnodeHistory;
        localStorage.setItem('ANNE_history', JSON.stringify(history));
        let totspan = document.querySelector('.accs-foot-total')
        let total = await this.getLocalTotal()
        totspan.innerHTML = 'TOTAL: ' + total; 
        this.setLastBlock();
        ANNE.playSound("success");
    }


    /**
     * 
     * @param {*} el
     * @author radanne 
     * @returns 
     */
    getLocalTotal=async(el)=>{
        let history = await ANNE.USER._getHistory();
        let thisAnnodeHistory = history[ANNE._annodesLS.last_uri];
        let accs = thisAnnodeHistory.users;
        let total = 0;
        var keys = Object.keys(accs);

        for(var k = 0; k  < keys.length; k++) {
            var acct = accs[ keys[k] ];
            console.log(acct);
            var val = acct.last_known_annies;
            if (val==undefined) {
                val = acct.annies;
                acct.last_known_annies=0;
                if (val==undefined) {
                    val = 0;
                }
            }
           
            total = total + parseInt(acct.last_known_annies);
        }
        total = (total / ANNE.ANNE_TO_ANNIES);
        if(el && total) {
            el.innerHTML = total;
        }
        return UTILS.formatNumber(total);
    }


    /**
     * @author radanne
     */
    setLastBlock=async()=>{  
        let blockstatus = ANNE.API.getBlockchainStatus();
        blockstatus.then(async function(resolve){
            let blockspan = document.getElementById('accs-lastblock');
            blockspan.innerHTML = "LAST BLOCK: " + (parseInt(resolve.numberOfBlocks) - 1);
        })

    }


    /**
     * 
     * @param {*} el_acct
     * @author radanne 
     * @returns 
     */
    accountFooter=async(el_acct)=>{       
        this.setLastBlock();
        let total = await this.getLocalTotal()
        let [h, c, cl] = ann.declareVars(6);
        h.v3="GET BALANCES", h.v5='TOTAL: ' + total; 
        c.v1='btop-silver p-5', c.v3='anne-btn2 btn-green minw-250'; c.v4='w-a ml-50', c.v5='f13rem accs-foot-total', c.v6='annecoin-small-ico'
        cl.v3=this.updateAllBalances;
        let [html, css, clb] = ann.jsons2arrays([h, c, cl]);
        let name = ["accountFooter", el_acct];
        return ann.Subroutine(name,
            ['accsum_y', 'div_x', 'button', '$2_div_x', 'span', '$4_span'],
            [...html],[...css],[...clb]
        );
    }


    /**
     * 
     * @param {*} $col 
     * @param {*} $record 
     * @param {*} $propVal 
     */
    balance_by_ticker=function($col, $record, $propVal) {
        if ($record.ticker=="ANNE") {
            ANNE.A.ezAnneDisplayApprox($col, $propVal, false, "ext-danger-no-bg-lbl");
        }
    }


    /**
     * 
     * @param {*} $col 
     * @param {*} $record 
     * @param {*} $propVal 
     */
     actions_builder=function($col, $record, $propVal){
        console.log($record);
        //let the user set their pk (or wif)
        //have to get further in the BCH testing of AOTC to know what to do here.
        if ($record.ticker=="BCH") {
            return;
        }
        else if ($record.ticker=="ANNE") {
            ANNE.A.ezButton($col, "", "chk bal", "btn-green-sq btn-stpd-xsm", async($e)=>{
                console.log("chk anne bal");
                var baljson = await ANNE.API.getBalance($record.uniqueID);
                console.log('baljson :', baljson);
            });
        }
    }
}