class lukat {
    constructor($pgui) {
        this.pgui=$pgui;
        this.bINITRESULTS = false;
        this.RESULTS_MAX = 200;
        this.t_int = 1000000;
    }
    
    init=function($histMisc=null) {
        this.el_input = document.getElementById("anne_lukat_search");
        this.el_input.focus();
        this.el_lukat_results = document.getElementById("lukat_results");
        this.el_lukatit_btn = document.getElementById("btn_lukait");
        this.el_lukatit_btn.addEventListener("click", e=>this.lukatIt(e));
        this.el_input.addEventListener("keyup", e=>this.keypress(e, this));
        this.el_input.addEventListener("input", e=>this.analyzeText(e, this));
        this.el_lukat_quick_searches = document.getElementById("lukat_quick_searches");
        var nodes = this.el_lukat_quick_searches.querySelectorAll(".lnas");
        for (var n=0; n < nodes.length; n++) {
            if (nodes[n].id=="lukat_pdns") {
                if (ANNE.USER.aauth.PDNS_active==false) {
                    nodes[n].classList.add("hide");
                    continue;
                }
            }
            else if (nodes.id=="lukat_bounties") {
                if (ANNE.USER.aauth.BOUNTY_active==false) {
                    nodes[n].classList.add("hide");
                    continue;
                }
            }
            else if (nodes[n].id=="lukat_asdfs") {
                if (ANNE.USER.aauth.ASDF_active==false) {
                    nodes[n].classList.add("hide");
                    continue;
                }
            }

            nodes[n].addEventListener("click", e=>this.quickSearch(e));
        }

        this.el_settings = document.getElementById("lukat_settings");
        this.el_settings.addEventListener("click", function($e) {
            alert("to do");
        });

        this.el_nid_or_txid = document.getElementById("section_nid_or_txid");
        this.search_nidtxid="txid";
        this.btn_nid = document.getElementById("btn_nid");
        this.btn_nid.addEventListener("click", e=>{
            ANNE.A.addRemoveClass(this.btn_txid, "toggled-off", "toggled-on");
            ANNE.A.addRemoveClass(this.btn_nid, "toggled-on", "toggled-off");
            this.search_nidtxid="nid";

        });
        this.btn_txid = document.getElementById("btn_txid");
        this.btn_txid.addEventListener("click", e=>{
            ANNE.A.addRemoveClass(this.btn_txid, "toggled-on", "toggled-off");
            ANNE.A.addRemoveClass(this.btn_nid, "toggled-off", "toggled-on");
            this.search_nidtxid="txid";
        });
        ANNE.A.hide(this.el_nid_or_txid);

        this._merge_nids = [];


        //history button.
        const dropdownIcon = document.getElementById('lukat_history_ico');
        const dropdownList = document.getElementById('lukat_history_list');
        ANNE.A.empty(dropdownList);
        
        var test = ANNE.MEM_UDF._recentsLukatSearches.arr.concat();
        if (test.length>1) test = ANNE.UTILS.sortByProp(test, "t");
        for (var t=0; t < test.length; t++) {
            var opt = document.createElement("option");
            opt.setAttribute("value", test[t].text);
            opt.innerHTML=test[t].text;
            dropdownList.appendChild(opt);
        }
        dropdownIcon.addEventListener('click', function() {
            var now = ANNE.A.toggle(dropdownList);
            if (now=="hide") {
                dropdownList.style["z-index"] = 0;
                dropdownList.style["pointer-events"] = 'none';
            }
            else {
                dropdownList.style["z-index"] = 9999999;
                dropdownList.style["pointer-events"] = 'all';
            }
        });
        const THIS = this;
        dropdownList.addEventListener('click', async($e)=> {
            console.log($e.target);
            var text = $e.target.innerText;
            if (text==undefined) return;
            ANNE.A.toggle(dropdownList);
            THIS.nakedSearch(text, false);
        });

        //process this historyMisc object if we have it.
        if ($histMisc!=null) {
            if($histMisc.text_search!=undefined) {
                console.log("default search present:"+$histMisc.text_search);
                this.el_input.value = $histMisc.text_search;
                this.lukatIt(null, $histMisc.chaseIt);
            }
            else if ($histMisc.recents!=undefined) {
                var classNid = $histMisc.recents.trim();
                var classNOBJ = MEMG.getNeuronByNid(classNid);
                this.recentsByClass(classNOBJ, $histMisc.chaseIt);
            }
            else if ($histMisc.matches!=undefined) {
                var tit = $histMisc.title;
                if (tit==undefined) tit = null;
                this.loadManual($histMisc.matches, tit);
            }
        }
    }


    /**
     * 
     * @returns 
     */
    mergeClicked = async($nid)=> {
        var nid1 = this._merge_nids[0];
        var nObj1 = MEMG.getNeuronByNid(nid1);
        var nid2 = this._merge_nids[1];
        var nObj2 = MEMG.getNeuronByNid(nid2);
        var user = USER._userNObj.nid;
        if (nObj1.owned_by==user && user!=ANNE.MEM.ANNE_ACCTID) {
            if (nObj2.owned_by!=ANNE.MEM.ANNE_ACCT) {
                console.log("Atleast one neuron must be owned by ANNE to utilize the merge feature.");
                return;
            }
            else {
                nid1 = nObj2.nid;
                nid2 = nObj1.nid;
                
                nObj1 = MEMG.getNeuronByNid(nid1);
                nObj2 = MEMG.getNeuronByNid(nid2);
            }
        }
        else if (nObj1.owned_by==ANNE.MEM.ANNE_ACCTID) {
            if (nObj2.owned_by!=ANNE.MEM.ANNE_ACCTID && nObj1.owned_by!=USER._userNObj.nid) {
                console.log("the non anne owned neuron must be owned by the submitting user");
                return;
            }
            else {
                nid1 = nObj2.nid;
                nid2 = nObj1.nid;
                
                nObj1 = MEMG.getNeuronByNid(nid1);
                nObj2 = MEMG.getNeuronByNid(nid2);
            }
        }
        else {
            console.log("no a valid merge request.");
            return;
        }

        if (nObj1.is(MEM.identity)==true) {
            console.log("can't merge identities w/ any other neurons");
            return;
        }
        
        if (nObj2.is(MEM.identity)==true) {
            console.log("can't merge identities w/ any other neurons");
            return;
        }

        var mergeReconObj = await ANNE.API.getMergeReconByNids(nid1, nid2);
        console.log(mergeReconObj);
        if (mergeReconObj.status!="good") {
            var btn_merge_req = document.getElementById("btn_merge");
            btn_merge_req.innerHTML="false alarm. "+mergeReconObj.reason;
            return;
        }

        var merge_html = "Would you like to request a merge of these two neurons <span class='merge-neuron-nid'>"+nid1+"</span> and <span class='merge-neuron-nid'>"+nid2+"</span>?";
        
        if (nObj1.owned_by==USER._userNObj.nid) {
            merge_html=merge_html+="<BR>Since your neuron is not in ANNE's worldview, it will be absorbed by ANNE's neuron.";
            merge_html=merge_html+="<BR><span class='small-text'>(Any feelz and net-new information will be moved over into the ANNE neuron.)</span>";   
        }
        else if (ANNE.isANNE(nObj1.owned_by)==true) {
            merge_html=merge_html+="<BR>These neurons are both owned by ANNE and ANNE will determine which one will absorb the other.";
            merge_html=merge_html+="<BR>If the absorbed is sponsored they will be auto-payed out the current next annex price.";    
        }

        mergeReconObj = mergeReconObj.result;
        
        var survivorObj = mergeReconObj[mergeReconObj.survivor];
        var addendum = "surviving nid:<span class='merge-neuron-nid'>"+survivorObj.nid+"</span> aged <span class='blocks-num'>"+survivorObj.age+"</span> blocks";
        if (survivorObj.annies_required>0) {
            addendum+="<BR>The absorbed neuron will be annexed by the anne admin for "+mergeReconObj.annies_required;
        }
        else addendum+="<BR>There is no annex required for this merge.";
        
        ANNE.MEM_UDF.doConfirmModalWithHTML(merge_html, addendum,
            async()=>{
                console.log("confirm merge");
                
                //if this is an admin, it will auto approve and requires annies.
                GHOSTDATA.mergeNeuronRequest(nid1, nid2);
            }, 
            function(){
                console.log("decline merge");
                return;
            }, 
            "send merge request?", 
            "MERGE", 
            false);    
    }


    /**
     * 
     * @param {*} $nObj 
     * @returns 
     */
    testForExistingMerge=function($nObj) {
        var rel_merge_cmd = ANNE.MEM_UDF.getSysRelonWithNoSysRefTxid($nObj.outs, $nObj.nid, MEM.CMD_MERGE_NEURON.temp_nid);
        if (rel_merge_cmd==null) {
            for (var i=0; i < $nObj.ins.length; i++) {
                if ($nObj.ins[i].type!=TYPE_SYS) continue;
                if ($nObj.ins[i].r==MEM.CMD_MERGE_NEURON.temp_nid 
                    && ($nObj.ins[i].sys_ref_txid==undefined || $nObj.ins[i].sys_ref_txid==null || $nObj.ins[i].sys_ref_txid=="")){
                    rel_merge_cmd = $nObj.ins[i];
                    break;
                }
            }
        }
        return rel_merge_cmd;
    }


    /**
     * 
     * @param {*} $el_chk 
     * @param {*} $nid 
     * @returns 
     */
    addToMerge=function($el_chk, $nid) {
        if (this._merge_nids.indexOf($nid)!=-1) return;

        //check for participation in an existing merge..
        //if it exists, replace the check with some info. 
        var nObj = MEMG.getNeuronByNid($nid);
        
        if (this._merge_nids.length==1) {
            if (ANNE.isANNE(nObj.owned_by)==false) {
                var mNOBJ = ANNE.MEMG.getNeuronByNid(this._merge_nids[0]);
                if (ANNE.isANNE(mNOBJ.owned_by)==false) {
                    alert("atleast one selection must be owned by ANNE");
                    return;
                }
            }
        }

        var existing_merge_request = this.testForExistingMerge(nObj);
        if (existing_merge_request!=null && ANNE.UTILS.isset(existing_merge_request.sys_ref_txid)==false) {
            nObj.pending_merge = existing_merge_request;
            ANNE.A.empty($el_chk);
            ANNE.MEM_UDF.makeRelonViewLink_SMART($el_chk, existing_merge_request, true, 12, false, "", "&nbsp;merge request already pending");
            return;
        }

        this._merge_nids.push($nid);
        if (this._merge_nids.length==2) {
            ANNE.A.show("btn_lukat_merge");
            ANNE.A.show("btn_merge");
        }
        else {
            ANNE.A.hide("btn_lukat_merge");
            ANNE.A.hide("btn_merge");
            if (this._merge_nids.length==1) {
                //owned_by
                var mNOBJ = ANNE.MEMG.getNeuronByNid(this._merge_nids[0]);
                if (ANNE.isANNE(mNOBJ.owned_by)==false) {
                    //turn off checks that are not owned by ANNE.
                    //we need the 2nd one to be owned by ANNE since this one wasn't.
                }
            }
        }
    }


    /**
     * 
     * @param {*} $nid 
     * @returns 
     */
    removeMerge=function($nid) {
        var m = this._merge_nids.indexOf($nid);
        if (m!=-1) {
            this._merge_nids.splice(m, 1);
            if (this._merge_nids.length<2) {
                ANNE.A.hide("btn_lukat_merge");
            }
            return;
        }
    }


    /**
     */
    analyzeText = async($e)=>{
        var searchval = this.el_input.value.trim();
        if (searchval.length>18 && searchval.length<21 && isNaN(searchval)==false) {
            ANNE.A.show(this.el_nid_or_txid);
        }
        else ANNE.A.hide(this.el_nid_or_txid);
    }


    loadManual = async($aMatches, $title="test load manual")=>{
        var pObj = new page_params(null, null, null);
        pObj.p2 = $aMatches;
        pObj.p4 = LINKS_NEURON_DOSSIER
        pObj.p5 = $title;
        pObj.injection_div = "lukat_rez_div";

        var misc = new Object();
        pObj.misc = misc;
        pObj.searchString = $title;
        misc.data = $aMatches;
        misc.linkType = LINKS_NEURON_DOSSIER;
        misc.searchString = "";
        misc.bSORT = false;
        misc._lukat = this;
        misc.bWEIGHTAGAIN = false;
        ANNE.A.empty("lukat_rez_div");
        await this.pgui.loadPart("lukat_results", pObj);
        ANNE.A.hide("loading");
    }


    /**
     */
    quickSearch = async($e)=>{
        if ($e!=null) {
            $e.stopImmediatePropagation();
            $e.preventDefault();
        }
        var btn = $e.target;
        var classn = btn.getAttribute("anne-class");
        if (classn=="whatshot") {
            var aData = await ANNE.API.getLatestXAnnexes(10);
            if (aData.length==0) {
                alert("todo: display no results within the last 720 blocks");
            }
            var aMatches = [];
            for (var a=0; a < aData.length; a++) {
                aMatches.push(aData[a].nObj);
            }
            this.el_lukatit_btn.setAttribute("disable", false);
            var pObj = new page_params(null, null, null);
            pObj.p2 = aMatches;
            pObj.p4 = LINKS_NEURON_DOSSIER
            pObj.p5 = "hot ANNEXes";
            pObj.injection_div = "lukat_rez_div";
    
            var misc = new Object();
            pObj.misc = misc;
            misc.data = aMatches;
            misc.linkType = LINKS_NEURON_DOSSIER;
            misc.searchString = "";
            misc.bSORT = false;
            misc._lukat = this;
            misc.bWEIGHTAGAIN = false;
            ANNE.A.empty("lukat_rez_div");
            await this.pgui.loadPart("lukat_results", pObj);
            ANNE.A.hide("loading");
            return;
        }
        
        var classNOBJ = MEMG.getNeuronByNid(classn);  
        
        if (ANNE.SETTINGS.debug()==true) console.log(classNOBJ);
        
        return await this.recentsByClass(classNOBJ);
    }


    /**
     * Recents will pull not-key'd neurons so that the results of
     * clicking the recents button will have a focus on what can be annexed.
     */
    recentsByClass=async($classNOBJ, $bCHASEIT=true)=>{
        var nids=[];
        if ($classNOBJ.nid == MEM.PDN.nid) nids = [ANNE.MEM.PDN_PUBLIC_ACCESS.nid, ANNE.MEM.PDN_VIP.nid, ANNE.MEM.PDN_BEARER_TOKEN.nid];
        else nids = [$classNOBJ.nid];

        var aMatches1 = [];
        var aMatches = await ANNE.CHASE.search_recents_by_class(nids, $bCHASEIT, 0.001, this.RESULTS_MAX);

        if (ANNE.BRAIN!=null) {
            aMatches1 = ANNE.BRAIN.getByClass($classNOBJ, 20);
        }
        if (aMatches.length && aMatches.length) {
            aMatches = ANNE.UTILS.concatUnique(aMatches, aMatches1, "nid");
            aMatches = ANNE.BRAIN.applyPoolWeights(aMatches);
        }

        this.el_lukatit_btn.setAttribute("disable", false);
        var pObj = new page_params(null, null, null, "recents::"+$classNOBJ.text);
        pObj.p2 = aMatches;
        pObj.p4 = LINKS_NEURON_DOSSIER
        pObj.p5 = "recents::"+$classNOBJ.text;
        pObj.recentsSearch = true; //recents
        pObj.injection_div = "lukat_rez_div";

        var misc = new Object();
        pObj.misc = misc;
        misc.data = aMatches;
        misc.linkType = LINKS_NEURON_DOSSIER;
        misc.searchString = "recent "+$classNOBJ.text;
        misc.bSORT = false;
        misc._lukat = this;
        misc.bWEIGHTAGAIN=false;
        PAGES.updateLastHistoryMisc({recents:$classNOBJ.nid, chaseIt:false});
        ANNE.A.empty("lukat_rez_div");
        await this.pgui.loadPart("lukat_results", pObj);
        ANNE.A.hide("loading");
    }


    /**
     */
     keypress = async($e, $this)=> {
        if ($e.keyCode === 13) this.lukatIt($e, true);
    }


    /**
     */
    lukatIt=function($e=null, $bCHASEIT=true){
        if ($e!=null) {
            $e.stopImmediatePropagation();
            $e.preventDefault();
        }
        this.el_lukatit_btn.setAttribute("disable", true);
        var searchval = this.el_input.value;

        this.nakedSearch(searchval, $bCHASEIT);

        if (this.bINITRESULTS==false) {
            //ANNE.A.animateProp("annesearch", "padding-top", 0, ".2s ease");
            //ANNE.A.animateProp("lukat_quick_searches", "padding-top", 0, ".2s ease");
            //ANNE.A.animateProps("lukat_title", {"font-size":"1.1rem","padding-top":0}, ".2s", "", "ease");
            this.bINITRESULTS=true;
        }
        //ANNE.BRAIN.manuallyStartASOA(searchval);
    }


    /**
     * 
     * @param {*} $searchStr 
     * @returns 
     */
    nakedSearch = async($searchStr="")=> {
        if ($searchStr=="") return;

        //we don't need to track results or too much here.
        //this is just to help the user easily get back to prior searches this session.
        if (ANNE.MEM_UDF!=null) {
            this.t_int = this.t_int-1;
            ANNE.MEM_UDF._recentsLukatSearches.addU({text:$searchStr, t:this.t_int});
        }

        await this.defaultTextSearch($searchStr);
        this.el_lukatit_btn.setAttribute("disable", false);
        return;
    }


    /**       
     * 
     * @author {Mr.Scatman} 
     */
     defaultTextSearch = async($searchStr)=>  {
        ANNE.A.show("loading");
         
        $searchStr = $searchStr.trim();
        var searchObj = ANNE.UTILS.prepNakeSearch($searchStr);
        var aMatches = [];

        //(nid) or (txid) will trigger this (or the button click that pops up)
        if ((searchObj.context=="" || searchObj.context=="txid" || searchObj.context=="nid") 
            && searchObj.str.length>=17 
            && searchObj.str.length<21 && isNaN(searchObj.str)==false) {

            if (this.search_nidtxid=="nid" || searchObj.context=="nid") {
                aMatches = await ANNE.CHASE.anne_nid_search(searchObj.str, true);
            }
            else {
                var rel = await ANNE.CHASE.lookupTxid(searchObj.str);
                rel = MEM_UDF.getAnyRel(searchObj.str);
                //lookup mempool for standard txid?
                if (rel!=null) {
                    ANNE.A.hide("loading");
                    return await PAGES.launchRelon(rel.txid);
                }
            }
        }

        //this is an AQL search with a lead word as a cmd.
        var parts = searchObj.str.split(" ");
        if (parts.length==1) parts = searchObj.str.split("_");

        //Category:21st-century American judges
        if (parts.length>1 && parts[0].toLowerCase().indexOf("category:")==0) {
            //reroute to wikipage category processing.
            var rez = null;
            var dataMap = null;
            var targetClassNOBJ = null;
            var extras = null;

            var lastBigWikiPages = ANNE.MEM_UDF.getBigWikiPages(searchObj.str);
            if (lastBigWikiPages!=null) {
                rez = lastBigWikiPages.pages;
                dataMap = lastBigWikiPages.dataMap;
                targetClassNOBJ = lastBigWikiPages.targetClassNOBJ;
                extras = lastBigWikiPages.extras;
            }
            
            if(rez==null) {
                ANNE.A.hide("loading");
                ANNE.A.startSound("processing");
                ANNE.showSuperBlocker();
                ANNE.superConsolePrintPF(_CYAN,"querying wikipedia for category", _GREEN, searchObj.str.substring(8));
                rez = await WIKIDATA.getPagesOfCategory(searchObj.str);
                console.log(rez);
            }
            if (rez.length>0) {
                
                //mark this as the last search so when the user clicks back, it triggers
                //the bigWiki match.
                PAGES.updateLastHistoryMisc({text_search:searchObj.str, chaseIt:false});

                ANNE.superConsolePrintPF(_CYAN, "acquired", _BLUE, rez.length+"", _WHITE, "entries");
                var pObj = new page_params(null, null, null, searchObj.str);
                var misc = new Object();
                misc.data = rez;
                misc.linkType = LINKS_NEURON_DOSSIER;
                misc.searchString = searchObj.str;
                misc.bSORT = false;
                misc._lukat = this;

                //these are only set if we have an exact previous bigWiki search
                //and we are restoring what we had.
                misc.rez = rez;
                misc.dataMap = dataMap;
                misc.targetClassNOBJ = targetClassNOBJ;
                misc.extras = extras;

                pObj.misc = misc;
                pObj.p2 = rez;
                pObj.p4 = LINKS_NEURON_DOSSIER;
                pObj.p5 = searchObj.str;
                pObj.recentsSearch = false; 
                pObj.injection_div = "lukat_rez_div";
                ANNE.A.empty("lukat_rez_div");
                ANNE.A.hide("loading");
                ANNE.hideSuperBlocker();
                ANNE.A.stopSound("processing");
                ANNE.A.playSound("beep");
                ANNE.superConsolePrintPF(_CYAN, "close the window to review the data");
                await this.pgui.loadPart("wiki_results", pObj);
                return;
            }
            ANNE.A.stopSound("processing");
            ANNE.hideSuperBlocker();
        }

        else if (parts.length>1 && ANNE.AQL.conveyorMap.get(parts[0].toLowerCase())!==null) {
            //reroute to AQL!
            ANNE.TALK.printf_console(_YELLOW, " rerouting to AQL with search ", _GREEN, searchObj.str);
            var aql = new anne_query_lang(searchObj.str);
            aMatches = await aql.parseAQL(searchObj.str, false);
            if (aMatches==undefined || aMatches==null) aMatches = [];
        }


        if (aMatches.length==0) {
            //search by text.  (this doesn't provide firing weights anymore???)
            if (searchObj.str<=3) searchObj.bEXACT=true;

            var aMatches_pre = await CHASE.nakedSearch(searchObj.str, false, true, searchObj.bEXACT);

            var lower = searchObj.str.toLowerCase();

            for(var m=0; m < aMatches_pre.length; m++) {
                var nObj = aMatches_pre[m];
                if (nObj.owned_by!=ANNE.MEM.ANNE_ACCTID && nObj.owned_by!=ANNE.USER._userNObj.owned_by) {
                    console.log("SKIPPING NON-ANNE non-USER owned neuron");
                    continue;
                }
                
                if (nObj.text.toLowerCase()==lower) nObj.fire=10;
                else if (nObj.aka_lower && nObj.aka_lower.indexOf(lower)!=-1) nObj.fire=5;
                else nObj.fire=.1;
                //console.log(nObj.text+" fire after first pass search:"+nObj.fire);
                
                aMatches.push(nObj);
            }
        }

        //do a naked search for text
        //p1 = searchstr, p2 = matches, p4 = primary click callback (what function to display)
        //p3 will change depending on the desired use of the search..
        var pObj = new page_params(null, null, null, $searchStr);//, null, null, ANNE.openANNET);
        var misc = new Object();
        pObj.misc = misc;
        misc.data = aMatches;
        misc._lukat = this;
        misc.linkType = LINKS_NEURON_DOSSIER;
        misc.searchString = $searchStr;
        misc.bSORT = false;
        misc.bWEIGHTAGAIN=true;
        misc.context = searchObj.context;
         
        aMatches.sort(this.customSort);

        pObj.p2 = aMatches;
        pObj.p4 = LINKS_NEURON_DOSSIER;
        pObj.p5 = $searchStr;
        pObj.recentsSearch = false; //recents
        pObj.injection_div = "lukat_rez_div";

        PAGES.updateLastHistoryMisc({text_search:$searchStr, chaseIt:true});

        ANNE.A.empty("lukat_rez_div");
        await this.pgui.loadPart("lukat_results", pObj);
        ANNE.A.hide("loading");
    }


    customSort=function($a,$b) {
        if ($a==undefined || $a==null || $b==undefined || $b==null || $a.fire==undefined || $b.fire==undefined) return 0;
        
        if ($a.fire > $b.fire) return -1;
        if ($a.fire < $b.fire) return 1;

        if ($a.ins.length > $b.ins.length) return -1;
        if ($a.ins.length < $b.ins.length) return 1;
        
        return 0;
    }
}



class lukat_results {
    
    /**
     * Init the search results.
     * 
     * pObj.p1 = searchstr, 
     * pObj.p2 = matches, 
     * pObj.p3 will change depending on the desired use of the search.
     * pObj.p4 neuronLinkType for rendering the right click link
     * There are cases where you may want to launch the node in a graph.. etc..
     * 
     * @author {Mr.Scatman}   
     */  
    constructor ($pgui) {
        this.pgui = $pgui;
        this.pObj = $pgui.pObj;
        
        this.ID = $pgui.pObj.guid;
        this._observedBeNids = [];   
        this.content = null;     
        this.paginator = null;

        this.misc = this.pObj.misc;
        this.data = this.misc.data;
        this.linkType = this.misc.linkType;
        this.searchString = this.misc.searchString;
        this.searchString = this.searchString.replace(/\s\s+/g, ' '); //strip out duplicate spaces tabs and new lines.
        
        //if (this.searchString==undefined || this.searchString==null || this.searchString=="") { 
        //}

        this.bSORT = this.misc.bSORT;
        
        //todo
        this.wvBIPASS = this.misc.wvBIPASS;
        this.wvCLASS_FILTERS = this.misc.wvCLASS_FILTERS;

        this.bWEIGHTAGAIN = false;
        if (this.misc.bWEIGHTAGAIN!=undefined) this.bWEIGHTAGAIN=this.misc.bWEIGHTAGAIN;

        if (ANNE.SETTINGS.debug()==true) {
            console.log(this.ID);
            console.log(this.pObj);    
        }

        var ABODY = document.getElementById("ABODY_"+this.ID);
        if (ABODY) {
            ABODY.setAttribute("guid",this.ID);
        }
        else {
            console.warn("why no ABODY?");
            return;//page has been closed prematurely.
        }
        var rez = this.data.length;

        ANNE.A.setHTML('lukat_results_cnt', this.data.length);

        var el_results_for = document.getElementById("lukat_results_lbl");
        if (el_results_for!=null) {
            if (rez==1) el_results_for.innerHTML="result for";
            else el_results_for.innerHTML="results in ANNE for";
        }
        else {
            console.log("how is it possible this is missing here???");
        }
        
        ANNE.A.setHTML('lukat_search_text', this.searchString);

        var srWVF = ABODY.querySelector('.sr-wv-filters');
        var wvf = "<span style='display:inline-flex; max-height:20px;'>&nbsp;wv filter:</span>";
        if (ANNE.USER._bWORLDVIEWBIPASS==true) wvf = wvf+"<span class='filter-lbl text-danger-lbl'>off</span>";
        else wvf=wvf+"<span style='display:inline-block' class='text-warning-lbl'>on</span>";
        srWVF.innerHTML = wvf;

        var srCLASSF= ABODY.querySelector('.sr-class-filters');
        if (ANNE.SEARCH.SS._bRESTRICT_CLASS==true) var cf = "<span style='display:inline-block'>&nbsp;|&nbsp;class filter:</span><span class='filter-lbl text-warning-lbl'>on</span>";
        else var cf = "<span style='display:inline-block'>class filter:</span><span class='filter-lbl text-danger-lbl'>off</span>";
        srCLASSF.innerHTML = cf;
       
        this.el_framer = document.getElementById("lukat_framer");
        this.el_framer.getBoundingClientRect();
        var bcr = this.el_framer.getBoundingClientRect();
        //console.log(bcr);
        this.max_bottom = bcr.bottom;
        console.log("this.max_bottom:"+this.max_bottom);
        this.el_rez = document.getElementById("lukat_results_rows_"+this.ID);
        //var rezBcr = this.el_rez.getBoundingClientRect();
        var bh = (this.max_bottom - 240);
        this.el_rez.style['max-height']=bh+"px";
        this.el_rez.style['height']=bh+"px";
        
        this.el_results = 'lukat_results_rows_'+this.ID;

        //toggle the merge checks.
        var el_btn_toggle_merge = document.getElementById("btn_toggle_merge_chks");
        el_btn_toggle_merge.addEventListener("click", e=>{
            var chks = document.querySelectorAll(".chk-lukat-merge");
            for (var c=0; c < chks.length; c++) { ANNE.A.show(chks[c]); }
        });

        var btn_merge_req = document.getElementById("btn_merge");
        btn_merge_req.addEventListener("click", e=>{
            this.misc._lukat.mergeClicked();
        })

        var paginator_el = document.getElementById("lukat_paginator");
        var shard = Math.floor(bh/106);
        

        //set disambig strs to display in the search (and help disambi)
        for (var d=0; d < this.data.length; d++) {
            this.data[d].setDisambigArrStr(3)
        }

        //apply the brain context pool weights to our matches.
        //weight for disambig as well, if misc.context exists  (search with parens)
        //ie,  William Fox (producer)
        if (ANNE.BRAIN!=null &&  this.pObj.recentsSearch==false) {
            this.data = ANNE.BRAIN.applyPoolWeights(this.data, this.misc.context);
        }
        

        //weight this. (again) -- for future orderings.
        if (this.bWEIGHTAGAIN==true) {
            for (var m=0; m < Math.min(3, this.data.length); m++) {
                if (m>2) break;
                if (m==0) ANNE.MEM_UDF.fireNeuron(this.data[m], 2.3);
                else if (m==1) ANNE.MEM_UDF.fireNeuron(this.data[m], 1.3);
                else if (m==2) ANNE.MEM_UDF.fireNeuron(this.data[m], 0.3);
            }
        }
        
        if (rez==0) {
            const el_wiki = document.createElement("div");
            el_wiki.classList.add("row");
            el_wiki.classList.add("lukat-no-rez-options");

            var elmsg = document.createElement("div");
            elmsg.classList.add("quickbtn");
            el_wiki.appendChild(elmsg);

            const el_btn = document.createElement("div");
            var wikiico = ANNE.GUI_STUFF.getIco("wikipedia", 38);
            el_btn.innerHTML=wikiico;
            elmsg.appendChild(el_btn);
            
            elmsg.addEventListener("click", ($e)=> { 
                ANNE.A.hide(el_wiki);
                this.doWikipediaQuick($e);
            });
            
            var msg = document.createElement("span");
            msg.classList.add("lukat-quickbtn-msg");
            msg.innerHTML = "quick search wikipedia for <span class='text-success-lbl'>"+this.searchString+"</span>";
            elmsg.appendChild(msg);

            var elrez = ANNE.A.__getEl("lukat_results_rows_"+this.ID);
            elrez.appendChild(el_wiki);

            //or try annet. getIco=function($type, $w=30, $class="img-ico", $style="") 
            
            const el_annet = document.createElement("div");
            el_annet.classList.add("row");
            el_annet.classList.add("lukat-no-rez-options");
            var elmsg2 = document.createElement("div");
            elmsg2.classList.add("quickbtn");
            el_annet.appendChild(elmsg2);
            var annetico = ANNE.GUI_STUFF.getIco("ANNET", 38); 
            var ico=document.createElement("span");
            ico.innerHTML =annetico;
            elmsg2.appendChild(ico);
            elmsg2.addEventListener("click", async(e)=>{
                console.log("do annet.");
                ANNE.MEM_UDF.show3js(null, this.searchString);
            });
            var msg2 = document.createElement("span");
            msg2.classList.add("lukat-quickbtn-msg");
            msg2.innerHTML = "Use annet to search external sources for <span class='text-success-lbl'>"+this.searchString+"</span>";
            elmsg2.appendChild(msg2);
            elrez.appendChild(el_annet);
        }

        else {
            this.PAGINATOR = new paginator(paginator_el, this.pgui, this.ID, this.data, this.renderResultsCallback, shard);
            this.PAGINATOR.render(null);
        }
    }


    /**
     * do wikipedia search.
     * If disambig, disply list of links.. 
     * On click, we search again.
     * @param {*} $e 
     * @returns 
     */
    doWikipediaQuick=async($e)=>{
        console.log("do wikipeida.");

        //first we have to search for what type of thing this is.
        ANNE.showSuperBlocker();
        var wke = new wikipediaExplore(this.searchString, null, ANNE.printToConsole);
        
        await wke.exploreFull();  //this will invoke the origina cb (2nd param of constructor)
        ANNE.hideSuperBlocker();

        const THIS = this;

        //go to the new thing we just made from wikipedia data.
        if (wke._wiki && wke._wiki.resolvedNOBJ!=null) {
            PAGES.launchNeuron(wke._wiki.resolvedNOBJ.nid, "dossier", null, {btn_wikipedia:false});
            return;
        }

        else if (wke.explore_rez!=null && wke.explore_rez.status=="disambig") {
            var elrez2 = document.createElement("div");
            elrez2.classList.add("row");
            
            var elp = document.createElement("div");
            elp.innerHTML = "<h2>which one?</h2>";
            elp.classList="row";
            elrez2.appendChild(elp);

            for (var p=0; p < wke.explore_rez.pages.length; p++) {
                var page = wke.explore_rez.pages[p];
                if (page.indexOf("[[")!=-1) {
                    continue;   
                }
                console.log(page);
                var elp = document.createElement("div");
                elp.innerHTML = page;
                elp.classList="disambig-page";
                elp.classList.add("row");
                elp.setAttribute("disambigval", page);
                elrez2.appendChild(elp);
                elp.addEventListener("click", ($e)=>{
                    var disambigval = $e.target.getAttribute("disambigval");
                    ANNE.A.setHTML("anne_lukat_search", disambigval);
                    THIS.searchString = disambigval;
                    THIS.doWikipediaQuick($e);
                });
            }
            
            var elrez = ANNE.A.__getEl("lukat_results_rows_"+this.ID);
            elrez.appendChild(elrez2);
            ANNE.superConsoleAddEl(elrez);
            ANNE.hideSuperBlocker();
        }

        else if (wke!=null && wke.error!="") {
            var elrez2 = document.createElement("div");
            elrez2.classList.add("row");
            elrez2.innerHTML = "We could not ascertain what this is.";
            var elrez = ANNE.A.__getEl("lukat_results_rows_"+this.ID);
            elrez.appendChild(elrez2);
            ANNE.superConsoleAddEl(elrez);
            ANNE.hideSuperBlocker();
        }

        ANNE.hideSuperBlocker();
    }
    
    
    
    /**
     * Display the results set
     * @author {Mr.Scatman}   
     */               
    renderResultsCallback = async($pgui, $data)=> {
        var disp = ANNE.A.empty(this.el_results);
        var goodResults = 0;

        if ($data.length>0) {
            var aRez2 = [];
            if ($data.length>1) {
                ANNE.A.show("lukat_merge_toggle");
            }
            for (var a=0; a < $data.length; a++) {
                var nObj = $data[a];
                //if (nObj.bes.length==0 && nObj) continue;
                aRez2.push(nObj);
                if (nObj.fire>.8) goodResults+=1;
            }
            if (aRez2.length) this.displayResultCards(disp, aRez2);
        }
        return;
    }


    /**
     * 
     * @author {Mr.Scatman}   
     */  
    displayResultCards = async($disp, $matches)=> {

        var min_lookup=[];
        for (var m=0; m < $matches.length; m++) {
            var nObj = $matches[m];
            if (nObj==null) continue;
            if (nObj.bes==undefined) {
                continue;
            }
            if (nObj.bes.length==0) {
                console.log("WE MUST HAVE A BE NID --- try to get it here (but should have before)");
                if (nObj.ghost==false) min_lookup.push(nObj.nid);
            }
        }

        //opitmize lookup for the result set.
        if (min_lookup.length) await ANNE.API.lookupNids(min_lookup, [0,1], true, true);

        for (var m=0; m < $matches.length; m++) {
            var nObj = $matches[m];
            if (nObj==null) continue;

            //console.log("match "+m, nObj);
            var beNOBJ = MEMG.getNeuronByTempNid(nObj.bes[0]);
            var card = document.createElement("div");
            card.classList = "search-rez-card";
            $disp.append(card);
            
            //ANNE.A.animateProp(card, "opacity", 1, "1s ease");

            var srcimg = document.createElement("div");
            srcimg.classList = "lukat-search-result-img";
            card.append(srcimg);

            //this will load the image if we have it.
            if (beNOBJ!=null) {
                var border_class = ANNE.A.getImgBorder(nObj);
                var afile = await IMAGES.getBasicB64Thumb(beNOBJ, nObj, srcimg, border_class, 84, 0, 84);
                if (afile && afile.imgel!=null) {
                    var imgnid = afile.imgel.getAttribute("nid");
                    if (imgnid) {
                        afile.imgel.classList.add("img-clickable");
                        EXT_BTNS.makeAnyElNeuronLaunch(afile.imgel, imgnid);
                    }
                }
            }

            var srcMiddle = document.createElement("div");
            srcMiddle.classList = "src-info";
            card.append(srcMiddle);

            var srctitle = document.createElement("div");
            srctitle.classList = "src-title";
            srcMiddle.append(srctitle);

                var srcname = document.createElement("span");
                srcname.classList = "src-name debold";

                EXT_BTNS.makeNeuronLink(srcname, nObj.nid);
                srctitle.append(srcname);
                if (nObj.disambig!=undefined && nObj.disambig.length>0) {
                    ANNE.A.appendStringList(srcname, nObj.disambig);
                }

                var srcaddress = document.createElement("span");
                srcaddress.classList = "lukat-address raw-address";
                srcaddress.innerHTML = nObj.nid;
                srctitle.append(srcaddress);

                if (beNOBJ!=null) {
                    var classname = document.createElement("span");
                    classname.classList = "lukat-class-name debold";
                    ANNE.EXT_BTNS.makeNeuronLink(classname, beNOBJ.nid);
                    srctitle.append(classname);
                }
                else {  //switch the class for display of nid only
                    var classname = document.createElement("span");
                    classname.classList = "lukat-nid debold";
                    ANNE.EXT_BTNS.makeNeuronLink(classname, null);
                    srctitle.append(classname);
                }

                //blob good here.
                //neuron_view.processSysBlob(srcMiddle, nObj);

                ANNE.MEMZ.ezNeuronOwner(srcMiddle, nObj, LINKS_NEURON_INJECT_CB, this.ID);
                ANNE.MEMZ.ezNeuronBes(srcMiddle, nObj, LINKS_NEURON_ANNET, true, "lukat-functonal-be");
                ANNE.MEMZ.ezNeuronSponsor(srcMiddle, nObj, LINKS_NEURON_INJECT_CB, this.ID);
            
            var srcRight = document.createElement("div");
            srcRight.classList = "src-search-right";
            card.append(srcRight);

            //********************* ICOS ************************/
            var srcavailableactions = document.createElement("div");
            srcavailableactions.classList = "src-available-actions";
            srcRight.append(srcavailableactions);
            
            //$matches

            const _lukat = this.misc._lukat;

            if ($matches.length) {
                var ezchk = ANNE.A.ezCheckMark(srcavailableactions, ANNE.UTILS.randHex(3), nObj.nid, "add to merge", false, false, "chk-lukat-merge", function($e) {
                    var el_chk2 = $e.target;
                    var el_parent = ANNE.A.getFirstParentOf(el_chk2, "chk-parent", true);
                    var search_nid = el_chk2.getAttribute("nid");
                    //search_nid is same as value of check.
                    if (el_chk2.checked==true) {
                        console.log("show merge checks..");
                        _lukat.addToMerge(el_parent, search_nid);
                    }
                    else _lukat.removeMerge(search_nid);
                });
                ezchk.setAttribute("nid", nObj.nid);
                ezchk.setAttribute("owned_by", nObj.owned_by);

                ANNE.A.hide(ezchk.parentNode);
            }

            var icos = [LINKS_NEURON_ANNET, LINKS_NEURON_DOSSIER, LINKS_NEURON_TBL_VIEW];
            if (nObj.ntype==NTYPE_CLASS) {
                //icos.push(LINKS_NEURON_TREE);
                //icos.push(LINKS_NEURON_DS);
            }
            ANNE.EXT_BTNS.doStandardIcoLinks(srcavailableactions, nObj, icos) ;
        }
    }


    /**
     * Inject a new row in the search results.
     * 
     * This is a static handler for ANY results injection.
     * We will find the right one via the GUID.
     * 
     * We use this instead of a new tab for neuron links that are clicked on
     * in the result set.
     * 
     * Note: we should pipe this through the paginator.
     * 
     * @author {Mr.Scatman}   
     */  
    static injectHandler = function($temp_nid, $ID) {
        var pgui = NF.getPguiByGUID($ID);
        if (pgui==null) {
            alert("no pgui");
            return;
        }
        var thisINST = pgui.thisINST;
        if (thisINST==null) {
            alert("no INST on pgui");
            return;
        }
        var nObj = MEMG.getNeuronByTempNid($temp_nid);
        var dynamicID = 'lukat_results_rows_'+$ID;
        var disp = ANNE.A.__getEl(dynamicID);
        thisINST.displayResultCards(disp, [nObj], true);
    }
    

    /**
     * 
     * @author {Mr.Scatman}   
     */  
    getAKARow = function ($nObj, $bRETURNSTRING=false) {
        var akas = "";
        if ($nObj.aka==undefined) return "";
        for (var a=0; a < $nObj.aka.length; a++) { 
            akas = akas + '<span class="text-success-lbl" style="margin-right:4px">'+$nObj.aka[a]+'</span>';
        }
        if ($bRETURNSTRING==true) return akas;
        var akaRow = document.createElement('div');
        akaRow.innerHTML = "<span>also known as:"+akas+"</span>";
        return akaRow;
    }
}



/**
 * A category in wikipedia (or another wiki) has been queried 
 * and data has been pulled.
 * 
 * put the data in a table, allow for deletes...
 * a button for manual process..
 * 
 * and then have a button to auto process each item..
 * w/or without auto submit of QUE in between..
 * ie, a crawler type page.
 */
class wiki_results {
    
    /**
     * Init the search results.
     * 
     * pObj.p1 = searchstr, 
     * pObj.p2 = matches, 
     * pObj.p3 will change depending on the desired use of the search.
     * pObj.p4 neuronLinkType for rendering the right click link
     * There are cases where you may want to launch the node in a graph.. etc..
     * 
     * @author {Mr.Scatman}   
     */  
    constructor ($pgui) {
        this.pgui = $pgui;
        this.pObj = $pgui.pObj;
        this.ID = $pgui.pObj.guid;
        this._observedBeNids = [];   
        this.content = null;     
        this.paginator = null;
        this.misc = this.pObj.misc;
        this.extras = [];
        
        var el_lh = document.getElementById("lukat_height");
        if (el_lh!=null) {
            el_lh.classList.add("wiki-max-height");
        }
        //can do a setting for this later.
        this._BROADCAST_IMMEDIATELY = false;

        this.linkType = this.misc.linkType;
        this.searchString = this.misc.searchString;
        this.searchString = this.searchString.replace(/\s\s+/g, ' '); //strip out duplicate spaces tabs and new lines.

        var ABODY = document.getElementById("ABODY_"+this.ID);
        if (ABODY)  ABODY.setAttribute("guid",this.ID);
        else return;

        var rez = this.misc.data.length;
        ANNE.A.setHTML('lukat_results_cnt', rez);

        var el_results_for = document.getElementById("lukat_results_lbl");
        if (el_results_for!=null) {
            if (rez==1) el_results_for.innerHTML="result for";
            else el_results_for.innerHTML="pages extracted from wikipedia for";
        }
  
        //this is still within the confines of lukat
        ANNE.A.setHTML('lukat_search_text', this.searchString);
       
        const THIS = this;
        
        var btn_process_all = ANNE.A.__getEl("btn_process_all");
        btn_process_all.addEventListener("click", e=>{
            THIS.setPauseResumeEvents();
            THIS.processALL();
        });

        //hijack the modal functionality on the main stage.
        //if this doesn't work, then we will do the super prompt, all the same.
        var btn_process_add_relon = ANNE.A.__getEl("btn_process_add_relon");
        btn_process_add_relon.addEventListener("click", async(e)=>{
            var el_inject_me = document.createElement("div");
            el_inject_me.innerHTML = "jomomma";
            el_inject_me.style['background-color']="#eeeeee";
            el_inject_me.setAttribute("id", "injectmenewrel");

            ANNE.MEM_UDF.popupEl(el_inject_me, null, null, "add relon pattern");
            ANNE.A.hide(ANNE.MEM_UDF.el_modal_confirm);
            
            //newRelPat is the this.s_cbk.
            var pObj = new page_params(this.newRelPat, null, null, null);
            pObj.injection_div = "injectmenewrel";
            pObj.misc = {bDOING_TEMPLATE_PART:true};
            pObj.misc.title = "Make a relon for the all pages in the category will receive";
            await PAGES.openPart("relon_naked_entry", pObj);
        });


        this.el_rez = document.getElementById("wiki_results_rows_"+this.ID);
        this.el_rez.style['max-height']="56vh";
        this.el_rez.style['height']="56vh";
        ANNE.A.empty(this.el_rez);

        //we will extract this from the first exploratory parse of the cateogry page list.
        this.targetClassNOBJ = null;
        if (this.misc.targetClassNOBJ!=undefined) {
            this.targetClassNOBJ=this.misc.targetClassNOBJ;
        }

        //extra relons that must go on each thing we process from the wiki.
        if (this.misc.extras!=undefined && this.misc.extras.length) {
            this.extras = this.misc.extras;
            for (var ex=0; ex < this.extras.length; ex++) {
                this.addExtraInGui(this.extras[ex]);
            }
        }

        this.trackerMap = new tracker_map();

        this.dataMap = null;
        if (this.misc.dataMap==undefined || this.misc.dataMap==null || this.misc.dataMap.arr.length==0) {
            this.dataMap = new arraymap();
            this.dataMap.setMapKey("pageid");
            this.displayWikiResults(this.misc.data);
        }

        else {
            this.dataMap = this.misc.dataMap;
            this.redisplayWikiResults(this.dataMap.arr);
        }
    
        this.bPAUSED = false;
        
        if (ANNE.MEM_UDF!=null) {
            ANNE.MEM_UDF.setBigWikiPages(this);
        }

        //fix scroll height here by looking at bounding box of ABODY?
        var bcr = ABODY.getBoundingClientRect();
        console.log(bcr);
        //this.el_rez.style['max-height']="60vh";
        //this.el_rez.style['height']="60vh";
    }


    /**
     * 
     * @param {*} $type 
     * @param {*} $relnNOBJ 
     * @param {*} $to_type 
     * @param {*} $to_s 
     */
    newRelPat = async($type, $relnNOBJ, $to_type, $to_s)=> {
        ANNE.A.playSound("ding");
        console.log("extras");
        ANNE.MEM_UDF.popupElCancel(null);
        console.log("type:"+$type);
        console.log("reln:"+$relnNOBJ.text);
        console.log("to_type:"+$to_type);
        if ($to_type==TO_TYPE_ANNE) {
            var toNOBJ = ANNE.MEMG.getNeuronByNid($to_s);
            console.log("to:"+toNOBJ.text);
        }
        else {
            console.log("to:"+$to_s);
        }
        this.addExtra($type, $relnNOBJ.nid, $to_type, $to_s);
    }


    /**
     * Add an extra pattern to each thing we will be processing
     * @param {*} $type 
     * @param {*} $reln 
     * @param {*} $to_type 
     * @param {*} $to_s 
     */
    addExtra = function($type, $reln, $to_type, $to_s) {
        var obj = {type:parseInt($type), reln:$reln, to_type:parseInt($to_type), to_s:$to_s};
        this.extras.push(obj);

        if (ANNE.MEM_UDF!=null) {
            var storedBigWiki = ANNE.MEM_UDF.getBigWikiPages(this); 
            if (storedBigWiki!=null) {
                storedBigWiki.extras = this.extras;
            }
        }

        obj.rand_id = UTILS.randHex(8);
        this.addExtraInGui(obj);
    }


    /**
     * 
     * @param {*} $extra 
     */
    addExtraInGui = function($extra) {
        var wiki_extra = ANNE.A.show("wiki_extras");
        var elExtra = document.createElement("div");
        elExtra.setAttribute("rand_id", $extra.rand_id);
        elExtra.classList = "wiki-extra";
        elExtra.style.display="inline-block";
        wiki_extra.appendChild(elExtra);
        var relnNOBJ = ANNE.MEMG.getNeuronByNid($extra.reln);
        var toValue = "";
        if ($extra.to_type==TO_TYPE_ANNE) {
            var toNOBJ = ANNE.MEMG.getNeuronByNid($extra.to_s);
            toValue = toNOBJ.text;
        }
        else toValue = $extra.to_s;

        //cancel the relon
        var elCancel = document.createElement("div");
        elCancel.innerHTML = "[x]";
        elCancel.style.color="red";
        elCancel.classList = "hoverable";
        elCancel.setAttribute("rand_id", $extra.rand_id);
        const THIS = this;
        elCancel.addEventListener("click", ($e)=>{
            var rand_id = $e.target.getAttribute("rand_id");
            var elExtra = document.createElement(rand_id);
            ANNE.A.removeParent(elExtra); 

            //clean up the extras
            ANNE.UTILS.removeObjInObjArr(THIS.extras, "rand_id", rand_id);
            if (ANNE.MEM_UDF!=null) {
                var storedBigWiki = ANNE.MEM_UDF.getBigWikiPages(this); 
                if (storedBigWiki!=null) {
                    storedBigWiki.extras = THIS.extras;
                }
            }
        })

        wiki_extra.appendChild(elCancel);

        elExtra.innerHTML = ANNE.TALK.printf(_GREEN, "*", _WHITE, "->", _YELLOW, relnNOBJ.text, _WHITE, "->", _YELLOW, toValue);
    }


    /**
     * 
     * @param {*} $e 
     */
    paused = async($e)=>{
        this.bPAUSED=true;
        ANNE.A.show("btn_process_resume");
        ANNE.A.hide("btn_process_pause");
    }
    
    /**
     * 
     */
    resume = async()=>{
        this.bPAUSED=false;
        ANNE.A.hide("btn_process_resume");
        ANNE.A.show("btn_process_pause");
        this.processALL();
    }


    /**
     * 
     */
    setPauseResumeEvents = function() {
        var el_resume = document.getElementById("btn_process_resume");
        el_resume.addEventListener("click", this.resume);
        var el_pause = document.getElementById("btn_process_pause");
        ANNE.A.show(el_pause);
        el_pause.addEventListener("click", this.paused);
    }

    /**
     * 
     */
    processALL = async()=> {
        for (var d=0; d < this.dataMap.arr.length; d++) {
            console.log("(wr.processALL) doing data map d:"+d);
            if (this.bPAUSED==true) {
                break;
            }

            var page = this.dataMap.arr[d];
            if (page.status!="not_processed") {
                continue;
            }
            if (page.nid!=null) continue;

            if (page.type!="page") continue;

            await this.processSingle(page);

            //pause 2 seconds to allow for gui interaction by we, the viewer.
            //(ie, hit pause button)
            await ANNE.UTILS.sleep(2000);

            if (this.bPAUSED==true) {
                break;
            }
        }
    }



    /**
     * 
     * @param {*} $page 
     */
    processSingle = async($page)=>{
        if ($page==undefined || $page==null) return;
        ANNE.showSuperBlocker();
        ANNE.superConsolePrintPF(_CYAN,"querying wikipedia for", _GREEN, $page.page);
        var el_status = document.getElementById("p"+$page.pageid);
        if (el_status==null) return;
        
        ANNE.A.addRemoveClass(el_status, "wiki-not-processed", "wiki-in-process");
        ANNE.A.startSound("processing");
        
        var dataObj = null;

        //hit wikipedia -- for the correct type.
        //if we do not yet know the type, explore it.
        if (this.targetClassNOBJ==null) {

            //this does an exploreFull and resolveAndGet -- for the first item.

            var explore = null;
            try {
                explore = await ANNE.exploreWiki($page.title, this.trackerMap, this.extras);
                console.log(explore);
            }
            catch(e) {
                console.log(e);
            }

            //set the targetClassNOBJ so we don't have to again.
            if (explore && explore._wiki && explore._wiki.resolvedNOBJ!=null) {
                $page.nid = explore._wiki.resolvedNOBJ.nid;
                this.targetClassNOBJ = explore._wiki.resolvedNOBJ.getParent();

                //store the big wiki to allow the user to navigate the results..
                //but get back to this view without loss.
                //This is a SPA so we don't have tabs... so this is a way to do that
                //with relatively little effort.
                if (ANNE.MEM_UDF!=null) {
                    var storedBigWiki = ANNE.MEM_UDF.getBigWikiPages(this); 
                    if (storedBigWiki!=null) {
                        storedBigWiki.targetClassNOBJ = this.targetClassNOBJ;
                    }
                }
            }

            else if (explore && explore._wiki!=null) {
                dataObj = explore._wiki._dataObj;
            }
        }

        //hit wikipedia -- for the correct type.
        else {   
            try {
                var wh = new wikihandler($page.title, this.targetClassNOBJ, this.trackerMap, ANNE.superConsolePrint);
                await wh.resolve();//makes the right specified wikihandler per type
                await wh._wiki.resolveAndGet([wh._wiki.targetClassNOBJ.nid]);
                if (wh._wiki.resolvedNOBJ!=null) {
                    $page.nid = wh._wiki.resolvedNOBJ.nid;
                }
                dataObj = wh._wiki._dataObj;
            }
            catch(e) {
                console.log(e);
                ANNE.A.stopSound("processing");
                ANNE.hideSuperBlocker();
                $page.status = "error";
                var el_aa = document.getElementById("s"+$page.pageid);
                ANNE.A.empty(el_aa);
                ANNE.A.addRemoveClass(el_status, "wiki-processed-error", "wiki-in-process");
                el_status.innerHTML = "error";
                ANNE.autoHideConsole();
                return;
            }
        }

        //how to check for no resolution?
        //we need to see how to pull by pageid.
        console.log(dataObj);

        ANNE.A.stopSound("processing");
        ANNE.hideSuperBlocker();

        //set status.
        $page.status = "processed";

        //empty the available actions.
        var el_aa = document.getElementById("s"+$page.pageid);
        ANNE.A.empty(el_aa);

        //update class in gui
        ANNE.A.addRemoveClass(el_status, "wiki-processed", "wiki-in-process");
        el_status.innerHTML = "done";


        if ($page.nid!=undefined && $page.nid!=null) {
            var el_type = document.getElementById("t"+$page.pageid);
            el_type.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;";
            EXT_BTNS.makeNeuronLink_colorSquares(el_type, $page.nid, "", "", false, "", "dossier", "sq-");
        }

        ANNE.autoHideConsole();
        
        //lastly, return.
        //for manual review.
        return;
    }


    /**
     * 
     * @param {*} $arr 
     */
    redisplayWikiResults = async($arr)=> {
        for (var m=0; m < $arr.length; m++) {
            var pageObj = $arr[m];
            if (pageObj==null) continue;

            if (pageObj.status=="skipped") {
                continue;
            }

            var card = document.createElement("div");
            card.classList = "wiki-rez-card";
            card.setAttribute("wikicard", true);
            this.el_rez.appendChild(card);
            
            var srcMiddle = document.createElement("div");
            srcMiddle.classList = "src-info";
            card.append(srcMiddle);

                var srctitle = document.createElement("div");
                srctitle.classList = "src-title";
                srcMiddle.append(srctitle);

                    var srcname = document.createElement("span");
                    srcname.classList = "wiki-name";
                    srcname.innerHTML = pageObj.title;
                    srctitle.append(srcname);
            

                    //will change to wiki-processed-failure OR display the nid link
                    var srcstatus = document.createElement("span");
                    srcstatus.classList = "wiki-not-processed"; 

                    if (pageObj.status=="not_processed") {
                        srcstatus.classList = "wiki-not-processed"; 
                    }
                    else if (pageObj.status=="processed") {
                        srcstatus.classList = "wiki-processed";
                    }

                    srcstatus.innerHTML = pageObj.status;
                    srcstatus.setAttribute("id", "p"+pageObj.pageid);
                    srctitle.append(srcstatus);

                    
                    var srctype = document.createElement("div");
                    srctype.classList = "wiki-type";
                    srctype.setAttribute("id", "t"+pageObj.pageid);
                    if (pageObj.nid!=undefined && pageObj.nid!=null) {
                        srcstatus.innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;";
                        EXT_BTNS.makeNeuronLink_colorSquares(srcstatus, pageObj.nid, "", "", false, "", "dossier", "sq-");
                    }
                    else srctype.innerHTML = pageObj.type;
                    srctitle.append(srctype);
            
            var srcRight = document.createElement("div");
            srcRight.classList = "src-search-right";
            card.append(srcRight);

            const srcavailableactions = document.createElement("div");
            srcavailableactions.setAttribute("id", "s"+pageObj.pageid);
            srcavailableactions.classList = "src-available-actions";
            srcRight.append(srcavailableactions);
        
            if (pageObj.status=="not_processed") {
                const btn_do_this = document.createElement("div");
                const btn_skip_this = document.createElement("div");
                btn_do_this.innerHTML="do this one";
                btn_do_this.classList = "anne-tiny-btn";
                btn_do_this.classList.add("btn-bggreen");
                srcavailableactions.appendChild(btn_do_this);
                btn_do_this.addEventListener("click", async(e)=>{
                    console.log("do this one only right now");
                    var pageid = e.target.getAttribute("pageid").substring(1);
                    var page = this.dataMap.get(pageid);
                    this.processSingle(page);
                    ANNE.A.emptyParent(btn_do_this);
                    ANNE.A.emptyParent(btn_skip_this);
                });
                btn_do_this.setAttribute("pageid", "p"+pageObj.pageid);

                btn_skip_this.classList = "anne-tiny-btn";
                btn_skip_this.classList.add("btn-bgyellow");
                btn_skip_this.innerHTML="skip this one";
                srcavailableactions.appendChild(btn_skip_this);
                btn_skip_this.addEventListener("click", async(e)=>{
                    console.log("skip this one.");
                    var pageid = e.target.getAttribute("pageid").substring(1);
                    var page = this.dataMap.get(pageid);
                    this.removeThisOne(page, e.target);
                });
                btn_skip_this.setAttribute("pageid", "p"+pageObj.pageid);
            }
        }
    }


    /**
     * 
     * @author {Mr.Scatman}   
     */  
    displayWikiResults = async($pages)=> {
        for (var m=0; m < $pages.length; m++) {
            var page = $pages[m];
            if (page==null) continue;
            
            //add to our map.
            this.dataMap.addU(page);
            page.status="not_processed";
            page.nid = null;

            var card = document.createElement("div");
            card.classList = "wiki-rez-card";
            card.setAttribute("wikicard", true);
            this.el_rez.appendChild(card);
            
            var srcMiddle = document.createElement("div");
            srcMiddle.classList = "src-info";
            card.append(srcMiddle);

                var srctitle = document.createElement("div");
                srctitle.classList = "src-title";
                srcMiddle.append(srctitle);

                    var srcname = document.createElement("span");
                    srcname.classList = "wiki-name";
                    srcname.innerHTML = page.title;
                    srctitle.append(srcname);
            
                    //will change to wiki-processed-failure OR display the nid link
                    var srcstatus = document.createElement("span");
                    srcstatus.classList = "wiki-not-processed"; 
                    srcstatus.innerHTML = "not processed";
                    srcstatus.setAttribute("id", "p"+page.pageid);

                    //set this to the unique string.
                    srctitle.append(srcstatus);

                    var srctype = document.createElement("div");
                    srctype.classList = "wiki-type";
                    srctype.innerHTML = page.type;
                    srctype.setAttribute("id", "t"+page.pageid);
                    srctitle.append(srctype);
            
            var srcRight = document.createElement("div");
            srcRight.classList = "src-search-right";
            card.append(srcRight);

            var srcavailableactions = document.createElement("div");
            srcavailableactions.classList = "src-available-actions";
            srcRight.append(srcavailableactions);

            const btn_skip_this = document.createElement("div");
            const btn_do_this = document.createElement("div");
            btn_do_this.innerHTML="do this one";
            btn_do_this.classList = "anne-tiny-btn";
            btn_do_this.classList.add("btn-bggreen");
            srcavailableactions.appendChild(btn_do_this);
            btn_do_this.addEventListener("click", async(e)=>{
                console.log("do this one only right now");
                var pageid = e.target.getAttribute("pageid").substring(1);
                var page = this.dataMap.get(pageid);
                ANNE.A.emptyParent(btn_do_this);
                ANNE.A.emptyParent(btn_skip_this);
                this.processSingle(page);
            });
            btn_do_this.setAttribute("pageid", "p"+page.pageid);

            btn_skip_this.classList = "anne-tiny-btn";
            btn_skip_this.classList.add("btn-bgyellow");
            btn_skip_this.innerHTML="skip this one";
            srcavailableactions.appendChild(btn_skip_this);
            btn_skip_this.addEventListener("click", async(e)=>{
                console.log("skip this one.");
                 var pageid = e.target.getAttribute("pageid").substring(1);
                 var page = this.dataMap.get(pageid);
                 ANNE.A.hide(btn_skip_this);
                 this.removeThisOne(page, e.target);
            });
            btn_skip_this.setAttribute("pageid", "p"+page.pageid);
        }
    }



    /**
     * 
     * @param {*} $pageObj 
     * @param {*} $el 
     */
    removeThisOne=function($pageObj, $el) {
        var card = ANNE.A.ez_getNearestParentWithProp($el, "wikicard", 4);
        if (card!=null) {
            this.el_rez.removeChild(card);
            $pageObj.status="skipped";
        }

        //get nearest search-rez-card
        //remove it.
        //decrement count on page.
    }
    
}
